# Copyright (c) Microsoft Corporation. All rights reserved.
#

!include $(MMLITE_SDK)/VERSION.mk
!include $(MMLITE_SDK)/conf/make/first.mk

#   Tools that are passed environment variables (eg, %REQUIRED_INCS%
#   for the compiler) must be forcibly launched via the build
#   platform's command shell -- at least in the case of Win9x, which
#   is what the PROCESSOR_ARCHITECTURE test is checking for.
!if "$(PROCESSOR_ARCHITECTURE)"!=""
_CMD=
!else
_CMD=$(COMSPEC) /c $(_DUMMY)
!endif

#   Make sure we don't pick up anything bogus on the user's path
PATH=$(MMLITE_SDK)\tools\bin;$(PATH)

CREATE_DIRS = $(LIBRARY_DIR) $(SYSTEM_DIR) $(OBJECT_DIR) $(DEPENDENCY_DIR) \
	$(GEN_INC_DIR)

!if "$(SRC_DIR)"!=""
__INC_SRC_DIR=$(CC_INC)$(SRC_DIR)
!endif

CC_INCS= $(CC_INCS) $(__INC_SRC_DIR) $(CC_INC)$(SRC_DIR)\md\$(TARGETCPU) $(CC_INC)$(SRC_DIR)\$(TARGETCPU) $(CC_INC)$(MMLITE_SDK)\include $(CC_INC)$(MMLITE_SDK)\include\$(TARGETCPU) $(CC_INC)$(GEN_INC_DIR)

# Define common gcc flags here so as to avoid replication
COMMON_GCC_FLAGS=-Wall -Winline -freg-struct-return
COMMON_GPLUS_FLAGS=-fno-rtti -fvtable-thunks 

!include $(MMLITE_SDK)/conf/make/$(TARGETCONFIG).mk

!if DEFINED(_CLR)
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)_CLR=1
!endif

!if DEFINED(_MINIMIZE)
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)_MINIMIZE=1
!endif

!if "$(TARGETTYPE)"=="debug"
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)_DEBUG=1
RC_FLAGS=$(RC_FLAGS) $(RC_DEF)_DEBUG=1
!endif

!if DEFINED(_UNICODE)
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)_UNICODE=1
RC_FLAGS=$(RC_FLAGS) $(RC_DEF)_UNICODE=1
!endif

# Collect all the compiler flags together
CC_FLAGS=$(CC_FLAGS) $(CC_INCS) $(CC_DEF)MMLITE=1

!include $(MMLITE_SDK)/conf/make/rules.mk
!include $(MMLITE_SDK)/conf/make/targets.mk

# Get dependencies from dependency tree if they have been generated
# Generate as "nmake depend"
#
!if exist ($(DEPENDENCY_FILE))
!include "$(DEPENDENCY_FILE)"
!endif
