# Copyright (c) Microsoft Corporation. All rights reserved.
#

ADS=1
!ifndef LM_LICENSE_FILE
LM_LICENSE_FILE = %MMLITE_SDK%\tools\arm_ads\licenses\license.dat
!endif
#
#   Compiler settings
#

COMMON_FLAGS = $(_CFLAGS) -li -apcs /noswst -W -c -j. $(CC_DEF)arm=1 $(CC_INCS)

CC_FLAGS = $(CC_FLAGS) $(COMMON_FLAGS) -ansic

!ifndef CC_DIR
CC_DIR=$(MMLITE_SDK)\tools\arm_ads\bin
!endif

ADS_FLAGS = -Oinline -Oautoinline -Ono_known_library $(CC_DEF)ADS=1
CC_FLAGS=$(CC_FLAGS) -cpu StrongARM1 $(ADS_FLAGS)
CPLUS=$(CC_DIR)\armcpp
CPLUS_FLAGS = -D__cplusplus=1 $(COMMON_FLAGS) $(ADS_FLAGS)
# -fz and -zz0 are now default in the ADS 1.1 compiler

CC=$(CC_DIR)\armcc
CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

CPRE= $(CC) -E

# Versioning
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)MMLITE_VERSION=$(BASERTL_VERSION)


#
#   BUGBUG: this will produce assembly listing files named $*.obj
#
!if "$(_COD)"=="1"
CC_FLAGS=$(CC_FLAGS) -S -fs
!endif


# BUGBUG
CC_FLAGS=$(CC_FLAGS) -DNO_DLL_LINKAGE=1
# BUGBUG

!if "$(TARGETTYPE)"=="debug"
CC_FLAGS=$(CC_FLAGS) -g+ -gtp
!endif

CCECHO=echo

#
#   Assembler settings
#
AS_DIR=$(CC_DIR)
AS=$(AS_DIR)\armasm
AS_OUT=-o $(_DUMMY)
AS_DEF=-pd

AS_FLAGS=$(AS_FLAGS) -li -g

AS_FLAGS=$(AS_FLAGS) -cpu StrongARM1 -apcs /noswst $(AS_DEF) "ADS SETA 1"

#
#   Linker settings
#
LINK=$(CC_DIR)\armlink
LINK_FLAGS=$(LINK_FLAGS) $(_LFLAGS) -map -list $*.map -remove
LINK_OUT=-output $(_DUMMY)
!ifdef COMPONENT_ENTRY
LINK_ENTRY=-entry $(COMPONENT_ENTRY)
!endif

!ifndef EXE_ENTRY
EXE_ENTRY=-scatter $(MMLITE_SDK)\include\$(TARGETCPU)\mmlite.scatter -entry mainCRTStartup1 $(LIBRARY_DIR)\_exemain.$(O)
!endif
COB_ENTRY=-scatter $(MMLITE_SDK)\include\$(TARGETCPU)\mmlite.scatter -entry _CobMainCRT $(LIBRARY_DIR)\_cobmain.$(O) $(LIBRARY_DIR)\_cobstart.$(O)

#PMDLL=$(MMLITE_SDK)\tools\bin\pmdll
#MAYBEDELETE=echo
PMDLL=$(MMLITE_SDK)\tools\bin\elfver -q -V $(BASERTL_VERSION)
MAYBEDELETE=@move

LINK_FLAGS = $(LINK_FLAGS) -symbols -callgraph	

!if "$(TARGETTYPE)"=="debug"
LINK_FLAGS=$(LINK_FLAGS) # -debug is turned on by default
!else
#LINK_FLAGS=$(LINK_FLAGS) -nodebug
!endif

LINK_EXE_FLAGS=$(LINK_FLAGS)

#
#   Librarian settings
#
LIBRARIAN=$(CC_DIR)\armar
LIB_FLAGS=-c -r $(LIB_FLAGS)
LIB_OUT=

#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR);$(PATH)

{$(SYSTEM_DIR)\}.exe{$(SYSTEM_DIR)\}.bin:
        fromelf -output $*.bin -bin -nodebug $*.exe
