# Copyright (c) Microsoft Corporation. All rights reserved.
#

#
#   Compiler settings
#

COMMON_FLAGS = $(_CFLAGS) -li -apcs /noswst -W -c -j. $(CC_DEF)arm=1 $(CC_INCS)

CC_FLAGS = $(CC_FLAGS) $(COMMON_FLAGS) -ansic

CC_DIR=$(MMLITE_SDK)\tools\arm250\bin
CC_FLAGS=$(CC_FLAGS) -fz -zz0 -zas2 -processor StrongARM1

CC=$(CC_DIR)\armcc
CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

CPRE= $(CC) -E

# Versioning
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)MMLITE_VERSION=$(BASERTL_VERSION)

#
#   BUGBUG: this will produce assembly listing files named $*.obj
#
!if "$(_COD)"=="1"
CC_FLAGS=$(CC_FLAGS) -S -fs
!endif


# BUGBUG
CC_FLAGS=$(CC_FLAGS) -DNO_DLL_LINKAGE=1
# BUGBUG

!if "$(TARGETTYPE)"=="debug"
CC_FLAGS=$(CC_FLAGS) -g+ -gtp
!endif

CCECHO=echo

#
#   Assembler settings
#
AS_DIR=$(CC_DIR)
AS=$(AS_DIR)\armasm
AS_OUT=-o $(_DUMMY)
AS_DEF=-pd

AS_FLAGS=$(AS_FLAGS) -li -g

AS_FLAGS=$(AS_FLAGS) -processor StrongARM1 -Apcs 3/noswst

#
#   Linker settings
#
LINK=$(CC_DIR)\armlink
LINK_FLAGS=$(LINK_FLAGS) $(_LFLAGS) -map -list $*.map -remove
LINK_OUT=-output $(_DUMMY)
!ifdef COMPONENT_ENTRY
# SDT 2.50 doesn't support symbol name for -entry qualifier
#LINK_ENTRY=-e $(COMPONENT_ENTRY)
!endif

REGLINK=-info totals  -Xref -ro-base 0x10000 -aif -reloc
!ifndef EXE_ENTRY
EXE_ENTRY=$(REGLINK) $(LIBRARY_DIR)\_exemain.$(O)
!endif
COB_ENTRY=$(REGLINK) $(LIBRARY_DIR)\_cobmain.$(O) $(LIBRARY_DIR)\_cobstart.$(O)


LINK_FLAGS = $(LINK_FLAGS) -noscanlib -symbols $*.sym


!if "$(TARGETTYPE)"=="debug"
LINK_FLAGS=$(LINK_FLAGS) # -debug is turned on by default
!else
LINK_FLAGS=$(LINK_FLAGS) -nodebug
!endif

LINK_EXE_FLAGS=$(LINK_FLAGS)

# Versioning..
PMDLL=$(MMLITE_SDK)\tools\bin\aifver -q -V $(BASERTL_VERSION)
MAYBEDELETE=@move

#
#   Librarian settings
#
LIBRARIAN=$(CC_DIR)\armlib
LIB_OUT=-o $(_DUMMY)
LIB_FLAGS=-c $(LIB_FLAGS)

#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR);$(PATH)

{$(SYSTEM_DIR)\}.exe{$(SYSTEM_DIR)\}.bin:
        $(SEDIT) -skip 128 $*.exe $*.bin
