# Copyright (c) Microsoft Corporation. All rights reserved.
#

#
#   Compiler settings
#

COMMON_FLAGS = $(_CFLAGS) $(CC_DEF)arm=1 $(CC_DEF)MMLITE_VERSION=$(BASERTL_VERSION) $(CC_INCS)
!ifndef CC_DIR
CC_DIR=$(MMLITE_SDK)\tools\evc\bin
!endif

CC_FLAGS=$(CC_FLAGS) 
CPLUS=$(CC_DIR)\clarm
CPLUS_FLAGS =  $(CC_FLAGS)

CC=$(CC_DIR)\clarm
CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-Fo

CPRE= $(CC) -E

CC_FLAGS=-nologo $(CC_FLAGS) $(COMMON_FLAGS)

#   -Gy enables function-level linking (intended to be used with
#   linker option -opt:ref).
#   -GF enables string pooling, which should reduce size.
#   The rest of the MS i386 compiler options are fairly standard....
CC_FLAGS=$(CC_FLAGS) -c -X -GX- -GR- -Gy -GF -Zi -W3  $(_CFLAGS)
CPLUS_FLAGS=$(CC_FLAGS)

CCECHO=echo

#
#   Assembler settings
#
AS_DIR=$(CC_DIR)
AS=$(AS_DIR)\armasm
AS_OUT=-o $(_DUMMY)

#
#   Linker settings
#
LINK=$(CC_DIR)\link
LINK_FLAGS=$(LINK_FLAGS) -nodefaultlib -machine:$(TARGETCPU) $(_LFLAGS) $(LINK_XXX_FLAGS)
LINK_FLAGS=$(LINK_FLAGS) -nologo /FIXED:NO /SUBSYSTEM:WINDOWSCE /VERSION:$(BASERTL_VERSION)
LINK_DEF=-def:
LINK_OUT=-out:
LINK_IMPLIB=-implib:

!ifndef EXE_ENTRY
EXE_ENTRY=-entry:mainCRTStartup1
!endif
COB_ENTRY=-entry:_CobMainCRT

!if "$(TARGETTYPE)"=="debug"
LINK_FLAGS=$(LINK_FLAGS) # -debug is turned on by default
!else
#LINK_FLAGS=$(LINK_FLAGS) -nodebug
!endif

LINK_EXE_FLAGS=$(LINK_FLAGS)

#
#   Librarian settings
#
LIBRARIAN=$(CC_DIR)\lib
LIB_FLAGS=-machine:$(TARGETCPU) -nologo
LIB_DEF=-def:
LIB_OUT=$(LINK_OUT)

#
#   TARGETTYPE-specific settings for these tools
#


!if "$(TARGETTYPE)"=="release"

# VC6 compilerbug.
# -Ox==/Ogityb1 /Gs  but the "g" one screws up INT64 type promotion.
#CC_FLAGS=$(CC_FLAGS) -Ox -MD
CC_FLAGS=$(CC_FLAGS) -Osiyb1 

!else

CC_FLAGS=$(CC_FLAGS) -Od -MDd

!endif  # TARGETTYPE

#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR);$(PATH)

{$(SYSTEM_DIR)\}.exe{$(SYSTEM_DIR)\}.bin:
        evc2bin -arm $*.exe $*.bin
