# Copyright (c) Microsoft Corporation. All rights reserved.
#
# Makefile settings for gcc 4.0.2 ARM

#
#   Environment settings
#
!if !DEFINED(TOOLS_DIR)
TOOLS_DIR=$(MMLITE_SDK)\tools\arm_gnu4\bin
!endif
PATH=$(TOOLS_DIR);$(PATH)
INCLUDE=
LIB=

#
#   Compiler settings
#
CC=$(TOOLS_DIR)\arm-elf-gcc
CPLUS=$(TOOLS_DIR)\arm-elf-g++

CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

CPRE=$(CC) -E -x c

# Versioning
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)MMLITE_VERSION=$(BASERTL_VERSION)


#
#   BUGBUG: this will produce assembly listing files named $*.obj
# except it spits the assembly on stdout so dont.
#
!if "$(_COD)"=="1"
CC_FLAGS=$(CC_FLAGS) -Wa,-ahlms
!endif

!if "$(TARGETTYPE)"=="debug"
# Enable optimizations anyway (-Os) rather than -O0 or else images will be huge
CC_FLAGS=$(CC_FLAGS) -O0 -g -gdwarf-2 -Wshadow
!else
#CC_FLAGS=-O
# -Os turns on -fstrict-aliasing, which gets tcp_input() confused,
# and possibly other places as well.
CC_FLAGS=$(CC_FLAGS) -Os -fomit-frame-pointer -fno-strict-aliasing
!endif

# Default to an ARM V3 vanilla processor
!if !DEFINED(ARM_GCC_TYPE)
#ARM_GCC_TYPE=-march=armv3 -mcpu=arm7
ARM_GCC_TYPE=-march=armv4
!endif

CC_FLAGS=$(CC_FLAGS) $(COMMON_GCC_FLAGS) $(ARM_GCC_TYPE) -mlittle-endian -fverbose-asm -fno-builtin -fno-common -fno-exceptions $(CC_DEF)arm=1 -msoft-float -c $(_CFLAGS)

# Put this in once running gcc3
# -fshort-wchar

CCECHO=echo

CPLUS_FLAGS = $(CC_FLAGS) $(COMMON_GPLUS_FLAGS)

#
#   Assembler settings
#
AS=$(TOOLS_DIR)\arm-elf-as 
!ifndef AS_FLAGS
AS_FLAGS=-marmv3 -EL -mno-fpu
!endif
AS_OUT=-o $(_DUMMY)


#
#   Linker settings
#
LINK=$(TOOLS_DIR)\arm-elf-ld
!ifndef LINK_RELOCATABLE
LINK_RELOCATABLE=-r -T $(TOOLS_DIR)\linkscript
!endif
LINK_FLAGS=$(LINK_FLAGS) $(LINK_RELOCATABLE) -d -O -S --warn-common --sort-common $(_LFLAGS)
LINK_OUT=-o $(_DUMMY)
LINK_START_GROUP=--start-group
LINK_END_GROUP=--end-group

LINK_EXE_FLAGS=$(LINK_FLAGS) -Map $*.map --cref -N -b elf32-littlearm

!ifndef EXE_ENTRY
EXE_ENTRY=-emainCRTStartup1 $(LIBRARY_DIR)\_exemain.$(O)
!endif
COB_ENTRY=-e_CobMainCRT $(LIBRARY_DIR)\_cobmain.$(O)

#PMDLL=$(MMLITE_SDK)\tools\bin\pmdll -d -v 116
PMDLL=$(MMLITE_SDK)\tools\bin\pmdll -V $(BASERTL_VERSION)
#MAYBEDELETE=-del
MAYBEDELETE=@echo

OBJCOPY=$(TOOLS_DIR)\arm-elf-objcopy

#
#   Librarian settings
#
LIBRARIAN=$(TOOLS_DIR)\arm-elf-ar
LIB_FLAGS=-cr $(LIB_FLAGS)
LIB_OUT=

{$(SYSTEM_DIR)\}.exe{$(SYSTEM_DIR)\}.bin:
        $(TOOLS_DIR)\arm-elf-objcopy -O binary $*.exe $*.bin
        $(TOOLS_DIR)\arm-elf-nm -n $*.exe | findstr/ic:" t " | findstr/v gcc2_compiled | $(SEDIT) -z " T " -s " " | $(SEDIT) -z " t " -s " " > $*.nm
