# Copyright (c) Microsoft Corporation. All rights reserved.
#

#
#   Compiler settings
#

COMMON_FLAGS = $(_CFLAGS) -J. $(CC_DEF)ecog=1 $(CC_INCS)

CC_FLAGS = $(COMMON_FLAGS) -ansi -Wpd

CC_DIR=$(MMLITE_SDK)\tools\cyan
CC_FLAGS=$(CC_FLAGS) 

CC=$(CC_DIR)\ecogncc -quiet
CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

CPRE= $(CC) -E

# Versioning
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)MMLITE_VERSION=$(BASERTL_VERSION)

# BUGBUG
CC_FLAGS=$(CC_FLAGS) -DNO_DLL_LINKAGE=1
# BUGBUG

!if "$(TARGETTYPE)"=="debug"
CC_FLAGS=$(CC_FLAGS) -g
!endif

CCECHO=echo

#
#   Assembler settings
#
AS_DIR=$(CC_DIR)
AS=$(AS_DIR)\ecogasm
AS_OUT=-o $(_DUMMY)

AS_FLAGS=$(AS_FLAGS) -list -c

#
#   Linker settings
#
CSTARTUP=$(CC_DIR)\cstartup.asm
LINK=$(CC_DIR)\ecoglink ecogcl -verbose
LINK_FLAGS=-pack $(CSTARTUP) $(LINK_FLAGS) $(_LFLAGS)
#this aint ready for prime time yet
#LINK_FLAGS=-pack $(CSTARTUP) -map $(CC_DIR)\ecog1.map $(LINK_FLAGS) $(_LFLAGS)
LINK_OUT=-o $(_DUMMY)

REGLINK=
!ifndef EXE_ENTRY
EXE_ENTRY=$(REGLINK) $(CSTARTUP) $(LIBRARY_DIR)\_exemain.$(O)
#this causes pain:
#EXE_ENTRY=$(REGLINK) $(CSTARTUP) $(LIBRARY_DIR)\mmcrt.lib\_exemain.$(O)
!endif
COB_ENTRY=$(REGLINK) $(CSTARTUP) $(LIBRARY_DIR)\_cobmain.$(O)


LINK_EXE_FLAGS=$(LINK_FLAGS)

# Versioning..
#PMDLL=$(MMLITE_SDK)\tools\bin\aifver -q -V $(MMLITE_VERSION)
MAYBEDELETE=@move

#
#   Librarian settings
#
# we got no librarian so..
#LIBRARIAN=$(CC_DIR)\ecogasm
LIBRARIAN=$(CC_DIR)\ecogcl -verbose
LIB_OUT=-c -lout $(_DUMMY)
#LIB_FLAGS= -quiet $(LIB_FLAGS)

MACHDEP_EXE_LIBS=$(CC_DIR)\crappolib.lib

#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR);$(PATH)
ECOG1_INCLUDE=
ECOG1_LIBRARY=$(CC_DIR)\crappolib.lib

### Override default build rules for assembly code cuz we be funny
__MACHDEP_AS_RULES=1
{$(SRC_DIR)\md\$(TARGETCPU)\}.s.$(O):
    copy $< $(OBJECT_DIR)\$(*B).c
    $(_SILENT)$(_CMD)$(CPRE) $(CC_FLAGS) $(CC_SBR) $(*B).c | $(SEDIT) -b -d "#line" | $(SEDIT) -b -z ZAPTOHERE > $(*B).$(O)

{$(SRC_DIR)\}.s.$(O):
    copy $< $(OBJECT_DIR)\$(*B).c
    $(_SILENT)$(_CMD)$(CPRE) $(CC_FLAGS) $(CC_SBR) $(*B).c | $(SEDIT) -b -d "#line" | $(SEDIT) -b -z ZAPTOHERE > $(*B).$(O)

{$(SRC_DIR)\}.s{$(OBJECT_DIR)\}.$(O):
    copy $< $(OBJECT_DIR)\$(*B).c
    $(_SILENT)$(_CMD)$(CPRE) $(CC_FLAGS) $(CC_SBR) $(OBJECT_DIR)\$(*B).c | $(SEDIT) -b -d "#line" | $(SEDIT) -b -z ZAPTOHERE > $(OBJECT_DIR)\$(*B).$O)

### Override default build rules for libraries cuz we be truly funny
__MACHDEP_LIB_RULES=1
.$(O){$(LIBRARY_DIR)}.lib:
    -$(_SILENT)rmdir /s /q $@
    @echo Creating LIBRARY $@
    -$(_SILENT)mkdir $@
    $(_SILENT)for %%i in ($**) do $(_SILENT)copy %%i $@
    $(_SILENT)for %%i in ($@\**) do $(_SILENT)$(AS) -c %%i -o x.lif && copysuf x.lif %%i lif


### Override default build rules for link cuz we be truly very funny. yeah.
__MACHDEP_LINK_RULES=1

.$(O){$(SYSTEM_DIR)}.exe:
    @echo Linking EXE $@
    $(_SILENT)$(LINK) $(LINK_EXE_FLAGS) $(LINK_OUT)$@.xpv $(EXE_ENTRY) $(LINK_START_GROUP) $** $(LINK_END_GROUP)
    $(_SILENT)copy $(SYSTEM_DIR)\$(@B).xpv $@

{$(LIBRARY_DIR)}.lib{$(SYSTEM_DIR)}.exe:
    @echo Linking EXE $@ from libraries
    $(_SILENT)$(LINK) $(LINK_EXE_FLAGS) $(LINK_OUT)$@.xpv $(EXE_ENTRY) $(LINK_START_GROUP) $** $(LINK_END_GROUP)
    $(_SILENT)copy $(SYSTEM_DIR)\$(@B).xpv $@

.$(O){$(SYSTEM_DIR)}.cob:
    @echo Linking COB $@
    $(_SILENT)$(LINK) $(LINK_EXE_FLAGS) $(LINK_OUT)$@.xpv $(COB_ENTRY) $(LINK_START_GROUP) $** $(LINK_END_GROUP)
    $(_SILENT)copy $(SYSTEM_DIR)\$(@B).xpv $@

{$(LIBRARY_DIR)}.lib{$(SYSTEM_DIR)}.cob:
    @echo Linking COB $@ from libraries
    $(_SILENT)$(LINK) $(LINK_EXE_FLAGS) $(LINK_OUT)$@.xpv $(COB_ENTRY) $(LINK_START_GROUP) $** $(LINK_END_GROUP)
    $(_SILENT)copy $(SYSTEM_DIR)\$(@B).xpv $@
