# Copyright (c) Microsoft Corporation. All rights reserved.
#

# This file allows compiling for the H8 using gcc 3.3.1

# For out-of-the box gcc to work, it was necessary to
# copy bin\h8300-hms-as.exe lib\gcc-lib\h8300-hms\3.3.1\as.exe
# This was after dumping the binutils and the gcc tars into tools\h8

!if DEFINED(GCCH8)
CC_DIR=$(GCCH8)
!else
CC_DIR=$(MMLITE_SDK)\tools\h8
!endif

CC=$(CC_DIR)\bin\h8300-hms-gcc.exe
CPRE=$(CC) -E

CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

!if "$(H8TYPE)"=="3069f"
CC_FLAGS=$(CC_FLAGS) -Dh8=1 -c -mint32 -mh -D_MINIMIZE=1 -O -DH8_3069F
!else
CC_FLAGS=$(CC_FLAGS) -Dh8=1 -c -mint32 -mh -D_MINIMIZE=1 -O -DH8_3052F
!endif
#CC_FLAGS=$(CC_FLAGS) -Dh8=1 -c -mint32 -mh -D_MINIMIZE=1 -O -DBYTE_ORDER=4321 -DBIG_ENDIAN=4321 -DLITTLE_ENDIAN=1234
#CC_FLAGS=$(CC_FLAGS) -Dh8=1 -c -mint32 -mh -D_DEBUG=1 -DDEBUG=1
#CC_FLAGS=$(CC_FLAGS) -Dh8=1 -c -mint32 -mh -malign-300
#CC_FLAGS=$(CC_FLAGS) -Dh8=1 -c -mh

CCECHO=echo

AS=$(CC_DIR)\bin\h8300-hms-as.exe
AS_FLAGS=
AS_OUT=-o $(_DUMMY)
AS_LST=-L -a=


LINK=$(CC_DIR)\bin\h8300-hms-ld.exe
LINK_FLAGS=$(LINK_FLAGS) -T$(CC_DIR)\lib\ldscript\h8300h.x $(_LFLAGS)
LINK_OUT=-o $(_DUMMY)
LINK_START_GROUP=--start-group
LINK_END_GROUP=--end-group

LINK_EXE_FLAGS=$(LINK_FLAGS)
COB_ENTRY=-u__CobMainCRT -e__CobMainCRT
EXE_ENTRY=-u_mainCRT -e_mainCRT

#
# i'm not sure but maybe don't need libgcc.a coz mmlite has its crt
# -> no no no, i need libgcc.a for long decimal arithmetic.
#
#MACHDEP_EXE_LIBS= $(CC_DIR)\lib\gcc-lib\h8300-hms\3.3.1\libgcc.a
#MACHDEP_EXE_LIBS= $(CC_DIR)\lib\gcc-lib\h8300-hms\3.3.1\h8300h\normal\int32\libgcc.a
MACHDEP_EXE_LIBS= $(CC_DIR)\lib\gcc-lib\h8300-hms\3.3.1\h8300h\int32\libgcc.a
#

#
#   Librarian settings
#
LIBRARIAN=$(CC_DIR)\bin\h8300-hms-ar.exe
LIB_FLAGS=-cr $(LIB_FLAGS)
LIB_OUT=


#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR)\bin;$(PATH)
GCC_EXEC_PREFIX=$(CC_DIR)\lib\gcc-lib\#

SHORTNAM=$(MMLITE_SDK)\tools\bin\shortnam

