#
# Copyright (c) Microsoft Corporation. All rights reserved.
#

# You need to run the batch file C:\Hew3\Tools\Renesas\H8\6_1_2\h8v6120env.bat
# to use these commands. The installation mentions this.

CC_DIR=
CC=ch38.exe
CPRE=$(CC) -PREP

CC_DEF=-DEF=
CC_UNDEF=
CC_INC=-INC=
CC_OUT=-OBJ=

#
# H8/3052F  -cpu=300HA:24
# H8S/2168F -cpu=2000A:24
#
# If -stack=large is not specified, stack pointer could be truncated
# resulting in memory corruption and mayhem.

CC_FLAGS=$(CC_FLAGS) -cpu=2000A:24 -nologo -nolist -debug -speed=register,shift -DEF=h8 -DEF=H8S_2168F -DEF=RENESAS_OPMA_2168F -stack=large
#CC_FLAGS=$(CC_FLAGS) -DEF=DEBUG=1 -DEF=_DEBUG=1

CCECHO=echo

AS=asm38.exe
AS_FLAGS=$(AS_FLAGS) -cpu=2000A:24 -nologo -nolist -debug
AS_OUT=-Obj=
AS_LST=-LIST


LINK=optlnk.exe
LINK_OUT=-o $(_DUMMY)
LINK_EXE_FLAGS=$(LINK_FLAGS)

COB_ENTRY=-u__CobMainCRT -e__CobMainCRT
EXE_ENTRY=-u_mainCRT -e_mainCRT

#
#   This lib file is generated by lbg38.exe.
#   You need to remove unnecessary CRT objs from it because MMlite has CRT funcs.
#
#   > lbg38 -head=runtime -cpu=2000A:24 -out=hew_2000A_24.lib
#
#MACHDEP_EXE_LIBS=$(HEWLIBPATH)\HEW_300HA_24.lib
!if !defined(HEWLIBPATH)
HEWLIBPATH=$(SRC_DIR)
!endif
MACHDEP_EXE_LIBS=$(HEWLIBPATH)\HEW_2000A_24.lib

#
#   Librarian settings
#
LIBRARIAN=optlnk.exe
LIB_FLAGS=-FORM=Library $(LIB_FLAGS)
LIB_OUT=-OUT=


### Override default build rules
__MACHDEP_AS_RULES=1

#
#   rules for .s assembly language files
#
#  no preprocessing on this platform...
#
{$(SRC_DIR)\md\$(TARGETCPU)\}.s.$(O):
    $(_SILENT)$(_CMD)$(AS) $(AS_OUT)$*.$(O) $(AS_FLAGS) $**

{$(SRC_DIR)\}.s.$(O):
    $(_SILENT)$(_CMD)$(AS) $(AS_OUT)$*.$(O) $(AS_FLAGS) $**


#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR)\bin;$(PATH)

SHORTNAM=$(MMLITE_SDK)\tools\bin\shortnam

