# Copyright (c) Microsoft Corporation. All rights reserved.
#

CC_DIR=$(MMLITE_SDK)\tools\m68k

CC=		$(CC_DIR)\bin\m68k-foo-rtems-gcc
AS=		$(CC_DIR)\bin\m68k-foo-rtems-as.exe
LINK=		$(CC_DIR)\bin\m68k-foo-rtems-ld.exe
NM=		$(CC_DIR)\bin\m68k-foo-rtems-nm.exe
ANSI_RANLIB=	$(CC_DIR)\bin\m68k-foo-rtems-ranlib.exe
LIBRARIAN=	$(CC_DIR)\bin\m68k-foo-rtems-ar.exe
SIZE=		$(CC_DIR)\bin\m68k-foo-rtems-size.exe
OBJDUMP=        $(CC_DIR)\bin\m68k-foo-rtems-objdump.exe

CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

CPRE=$(CC) -E -x c

CC_FLAGS=$(CC_FLAGS) -Dm68k=1 -O3 $(COMMON_GCC_FLAGS) -fverbose-asm -S -fno-builtin -m5200 -fno-common -fgnu-linker $(_CFLAGS)

CCECHO=echo

CPLUS_FLAGS = $(CC_FLAGS) $(COMMON_GPLUS_FLAGS)

AS_FLAGS=-m5200 -g
AS_OUT=-o $(_DUMMY)
AS_LST=-L -a=

LINK_FLAGS=$(LINK_FLAGS) -r -d -O -S --warn-common --sort-common $(_LFLAGS)
LINK_OUT=-o $(_DUMMY)
LINK_START_GROUP=--start-group
LINK_END_GROUP=--end-group

LINK_EXE_FLAGS=$(LINK_FLAGS) -Map $*.map --cref

#
#   Librarian settings
#
LIB_FLAGS=-cr $(LIB_FLAGS)
LIB_OUT=


#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR)\bin;$(PATH)
GCC_EXEC_PREFIX=$(CC_DIR)\lib\gcc-lib\#

### Override default build rules
__MACHDEP_CC_RULES=1

.c.$(O):
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$*.$(O) $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.$(O):
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$*.$(O) $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\md\$(TARGETCPU)\}.c.$(O):
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$*.$(O) $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.oba:
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_UNDEF)_UNICODE $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.obw:
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_DEF)_UNICODE $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.obs:
    @echo compiling $(<B).c SPECIAL options "$(_SPECIAL_CFLAGS)" $<
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(_SPECIAL_CFLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss

# Rule to compile C++
{$(SRC_DIR)\}.cpp.$(O):
    @echo $(<B).cpp
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss
