# Copyright (c) Microsoft Corporation. All rights reserved.
#

TOOLS=gnu
TOOLS_DIR=$(MMLITE_SDK)\tools\tigon
CC_DIR=$(TOOLS_DIR)
CC=$(CC_DIR)\bin\mips-sgi-irix5.3-gcc

CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-o $(_DUMMY)

CPRE=$(CC) -E -x c

!ifdef TIGON
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)TIGON_REV=2 -mtigon $(CC_DEF)TIGON=1
LINK_FLAGS=-r
!endif

CC_FLAGS=$(CC_FLAGS) -O2 $(COMMON_GCC_FLAGS) -fverbose-asm -mno-abicalls -S -fno-builtin -mcpu=r4000 -mips2 -mgas -fno-common -fPIC -fgnu-linker $(_CFLAGS)

CCECHO=echo

CPLUS_FLAGS = $(CC_FLAGS) $(COMMON_GPLUS_FLAGS)

AS=$(CC_DIR)\bin\as.exe
AS_FLAGS=-mips2 -g -G 0
AS_OUT=-o $(_DUMMY)
AS_LST=-L -a=


LINK=  $(CC_DIR)\bin\ld.exe
!ifndef LINK_RELOCATABLE
LINK_RELOCATABLE=-r -T $(CC_DIR)\example\alteon.x
!endif
LINK_FLAGS=$(LINK_FLAGS) $(LINK_RELOCATABLE) -d -O -S --warn-common --sort-common $(_LFLAGS)
LINK_OUT=-o $(_DUMMY)
LINK_START_GROUP=--start-group
LINK_END_GROUP=--end-group

LINK_EXE_FLAGS=$(LINK_FLAGS) -Map $*.map --cref

!ifndef EXE_ENTRY
EXE_ENTRY=-emainCRTStartup1 $(LIBRARY_DIR)\_exemain.$(O)
!endif
COB_ENTRY=-e_CobMainCRT $(LIBRARY_DIR)\_cobmain.$(O)

#PMDLL=$(MMLITE_SDK)\tools\bin\pmdll -d -v 116
PMDLL=$(MMLITE_SDK)\tools\bin\pmdll -V $(BASERTL_VERSION)
#MAYBEDELETE=-del
MAYBEDELETE=@echo

OBJCOPY=$(CC_DIR)\bin\mips-sgi-irix5.3-objcopy

#
#   Librarian settings
#
LIBRARIAN=$(CC_DIR)\bin\ar.exe
LIB_FLAGS=-cr $(LIB_FLAGS)
LIB_OUT=


#
#   Environment settings
#
INCLUDE=
LIB=
PATH=$(CC_DIR)\bin;$(PATH)
GCC_EXEC_PREFIX=$(CC_DIR)\lib\gcc-lib\#

### Override default build rules
__MACHDEP_CC_RULES=1

.c.$(O):
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$*.$(O) $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.$(O):
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$*.$(O) $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\md\$(TARGETCPU)\}.c.$(O):
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$*.$(O) $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.oba:
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_UNDEF)_UNICODE $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.obw:
    @echo compiling $(<B).c
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_DEF)_UNICODE $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss

{$(SRC_DIR)\}.c.obs:
    @echo compiling $(<B).c SPECIAL options "$(_SPECIAL_CFLAGS)" $<
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(_SPECIAL_CFLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss

# Rule to compile C++
{$(SRC_DIR)\}.cpp.$(O):
    @echo $(<B).cpp
    $(_SILENT)$(_CMD)$(CC) $(CC_FLAGS) $(CC_OUT)$*.ss $(CC_SBR) $<
    $(_SILENT)$(_CMD)$(AS) $(AS_FLAGS) $(AS_OUT)$@ $(AS_LST)$*.lst $*.ss


{$(SYSTEM_DIR)\}.exe{$(SYSTEM_DIR)\}.bin:
        $(CC_DIR)\bin\objcopy -O binary $*.exe $*.bin
        $(CC_DIR)\bin\mips-sgi-irix5.3-nm -n $*.exe | findstr/ic:" t " | findstr/v gcc2_compiled | findstr/v gnu_compiled | findstr/v /c:"$$" | $(SEDIT) -z " T " -s " " | $(SEDIT) -z " t " -s " " > $*.nm
