# Copyright (c) Microsoft Corporation. All rights reserved.
#

CC_DIR=$(MMLITE_SDK)\tools\ppc

CC=$(CC_DIR)\cl.exe
CPLUS=$(CC_DIR)\cl.exe

CC_DEF=-D
CC_UNDEF=-U
CC_INC=-I
CC_OUT=-Fo

CC_SBR=-FR$*.sbr

CPRE="$(CC)" -E

# Versioning
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)MMLITE_VERSION=$(BASERTL_VERSION)

CC_FLAGS=-nologo $(CC_FLAGS)
!if DEFINED(COVERAGE_BUILD)
CC_FLAGS=$(CC_FLAGS) -Gm
!endif

#   -Gy enables function-level linking (intended to be used with
#   linker option -opt:ref).
#   -GF enables string pooling, which should reduce size.
#   The rest of the MS ppc compiler options are fairly standard....
CC_FLAGS=$(CC_FLAGS) -c -X -Gy -GF -W3 -WX $(CC_DEF)ppc=1 $(_CFLAGS) -Z7
CPLUS_FLAGS=$(CC_FLAGS)

#
#   Assembler settings
#
AS=$(CC_DIR)\ml.exe /c -NT -Cx -nologo $(MASM_FLAGS)
# /EP
AS_OUT=-Fo
AS_SBR=-FR$*.sbr


#
#   Linker settings
#
LINK=$(CC_DIR)\link.exe
LINK_FLAGS=$(LINK_FLAGS) -machine:PPCBE $(_LFLAGS) $(LINK_XXX_FLAGS)
LINK_FLAGS=$(LINK_FLAGS) -nologo -release
LINK_DEF=-def:
LINK_OUT=-out:
LINK_IMPLIB=-implib:

!ifdef COMPONENT_ENTRY
LINK_ENTRY=-entry:$(COMPONENT_ENTRY)
!else
COB_ENTRY=-entry:_CobMainCRT
!ifndef EXE_ENTRY
!if DEFINED(_UNICODE)
EXE_ENTRY=-entry:wmainCRTStartup1
!else
EXE_ENTRY=-entry:mainCRTStartup1
!endif
!endif
!endif

!ifndef LINK_XXX_FLAGS
LINK_XXX_FLAGS=-map -subsystem:xbox -incremental:no -align:256 -merge:.bss=.data -merge:.rdata=.text -merge:.data=.text
!endif

!if "$(TARGETTYPE)"=="release"
LINK_REF= -opt:ref
!else
LINK_REF= -opt:noref
!endif

LINK_DLL_FLAGS=-dll $(LINK_REF) $(LINK_FLAGS)
LINK_EXE_FLAGS= $(LINK_REF) $(LINK_FLAGS)

#   We have to specify -debug and -debugtype in order for -pdb to
#   generate anything.
LINK_DBG_FLAGS=-debug -debugtype:cv,fixup -incremental:no -pdb:$*.pdb

#
#   Librarian settings
#
LIBRARIAN=$(CC_DIR)\link.exe
LIB_FLAGS=-lib -machine:PPCBE -nologo
LIB_DEF=-def:
LIB_OUT=$(LINK_OUT)


#
#   Source browser settings
#
BSCMAKE=$(CC_DIR)\bscmake
BSCMAKE_FLAGS=-nologo -n -o

#
#   Resource compiler settings
#
RC_DIR=$(CC_DIR)
!if DEFINED(MSVCDIR) && !DEFINED(VSINSTALLDIR)
# VC6 preinstallation finds it from a different place
RC_DIR=$(MSDEVDIR)\bin
!endif

RC=$(RC_DIR)\rc.exe

RC_DEF=-d
RC_UNDEF=-U
RC_INC=-i
RC_OUT=-fo
RC_NODEFAULTINC=-x

# image manipulation tools
MKMEMFS=$(MMLITE_SDK)\tools\bin\mkmemfs

!if !DEFINED(LINK_IMAGE)
LINK_EXE_FLAGS=$(LINK_EXE_FLAGS) -fixed:NO
!endif

LINK_FLAGS=$(LINK_FLAGS) -nodefaultlib

#   No entry point means no entry point: turn off default
!ifndef LINK_ENTRY
#LINK_DLL_FLAGS=$(LINK_DLL_FLAGS) -noentry
LINK_DLL_FLAGS=$(LINK_DLL_FLAGS) $(COB_ENTRY)
!endif


#
#   TARGETTYPE-specific settings for these tools
#
!if "$(TARGETTYPE)"=="release"

CC_FLAGS=$(CC_FLAGS) -Ox -MD
#CC_FLAGS=$(CC_FLAGS) -Osiyb1y -Gs -MD

_RELEASE_SYMBOLS=1
!if DEFINED(_RELEASE_SYMBOLS)
CC_FLAGS= $(CC_FLAGS) -Z7
LINK_DLL_FLAGS=$(LINK_DLL_FLAGS) $(LINK_DBG_FLAGS)
LINK_EXE_FLAGS=$(LINK_EXE_FLAGS) $(LINK_DBG_FLAGS)
!endif

!else

CC_FLAGS=$(CC_FLAGS) -Z7 -Od -MDd

!if !DEFINED(LINK_IMAGE_blah)
LINK_DLL_FLAGS=$(LINK_DLL_FLAGS) $(LINK_DBG_FLAGS)
LINK_EXE_FLAGS=$(LINK_EXE_FLAGS) $(LINK_DBG_FLAGS)
!endif

!endif  # TARGETTYPE

TLBIMP=$(MMLITE_SDK)\tools\bin\tlbimp

{$(SYSTEM_DIR)\}.exe{$(SYSTEM_DIR)\}.bin:
        evc2bin -ppc $*.exe $*.bin
