    ;; Copyright (c) Microsoft Corporation. All rights reserved.
    ;;
    ;; Workarounds for stubborn stupidity in Microsoft linkers.
    ;;
    ;; This is the only linker in the universe that refuses to
    ;; identify the boundaries of the sections of an image.
    ;; The hack used here is to define sections whose names are
    ;; lexically close to the ".bss" section, therefore the
    ;; symbols *we* define will be what the linker should do.
    ;; 
    ;; We would *love* to be compatible with the ARM tools but guess what ?
    ;; this toolset does not like $ in identifiers. So cant do
    ;; Image$$ZI$$Base and $$ZI$$Limit

#include <arm_asm.h>

    ;; Define the end of text symbol
    ;;
    ;; Use the "Grouped sections" trick of lexicographically ordering
    ;; the pieces that go into the .text section
    AREA |.text$zzzz| { |_etext| }, CODE, ARM, SELECTION=1
    nop    

    ;; Define the start of the bss symbol, aka commons
    ;;
#if 0
    ;; Use the "Grouped sections" trick of lexicographically ordering
    ;; the pieces that go into the .bss section
    AREA |.bss$.| { |__bss_start| }, NOINIT
    AREA |.data$.| { |__data_start| }, DATA
#else
    ;; Apparently nothing comes before a naked ".bss" ...grrrrr.
    ;; Specifying this file first in the list of files to link is our
    ;; next best guess. Sigh.
    AREA |.bss| { |__bss_start| }, NOINIT
    AREA |.data| { |__data_start| }, DATA
#endif

    ;; Define the end of the image symbol, aka end of the bss section
    ;;
    ;; Use the "Grouped sections" trick of lexicographically ordering
    ;; the pieces that go into the .bss section
    AREA |.bss$zzzz| { |_end| }, NOINIT


    END
