# Copyright (c) Microsoft Corporation. All rights reserved.
#
# Makefile for ARM AEB reference platform
#
SUBDIR=conf\package
!include $(MMLITE_SDK)/conf/make/first.mk

TARGETS = $(SYSTEM_DIR)\_fredAeb.exe

COMMON=$(LIBRARY_DIR)\elf_ldr.lib

!if "$(TOOLS)"=="gnu" || "$(TOOLS)"=="gnu4"
LINK_RELOCATABLE=
EXE_ENTRY=-e_start -u_start
COMMON= $(COMMON) aebfs.$(O)
!else
EXE_ENTRY=
_LFLAGS=$(_LFLAGS) -elf -ro-base 0x8000
COMMON=$(COMMON) _aebfs.$(O)
!endif

!include common.mk
!include $(MMLITE_SDK)/conf/common.mk

COMMON= $(COMMON) defcobtab.$(O) $(COMMON_BASE_LIBS) \
	$(LIBRARY_DIR)\romfs.lib $(LIBRARY_DIR)\basecrt.lib $(INTERFACES_LIB)

!if DEFINED(_CLR)
COMMON=$(COMMON) $(CLR_LIBS) $(LIBRARY_DIR)\mmcrt.lib
!endif

$(SYSTEM_DIR)\_fredAeb.exe: $(LIBRARY_DIR)\_startAeb.$(O) \
	$(LIBRARY_DIR)\_fredAeb.lib $(COMMON) runinit.$(O)
    $(_SILENT)$(LINK) $(LINK_EXE_FLAGS) $(EXE_ENTRY) $(LINK_OUT)$@ $(LINK_START_GROUP) $** $(LINK_END_GROUP)


EXES=$(SYSTEM_DIR)\tzk.cob

COBS=

DATAFILES=

FSFILES=$(EXES) $(COBS) $(DATAFILES)

# fs.flp differs across machines.  Unfortunately, both GCC
# and the ARM tools know of that name, one way or other.
# Hence the obsession with deleting it. Sigh.
_fs.$(O): fs.flp

_aebfs.$(O): _fs.$(O)
        -del *.flp
        -del _aebfs.$(O)
        ren _fs.$(O) _aebfs.$(O)

aebfs.$(O): fs.flp
        $(LINK) -r -b binary $** -o $@
        -del *.flp

fs.flp: $(FSFILES)
        -del *.flp
        $(MMLITE_SDK)\tools\bin\mkmemfs -rom -debug -ascii -align 4 boot.exe boot.exe $(FSFILES)
        ren 0.flp fs.flp
        del boot.exe

# Make sure than when we change what goes into the fs it gets rebuilt.
#
fs.flp: $(SRC_DIR)\aebarm.mk

# Hackery to get a different drivercfg.cob into each platform
# XXX causes some unnecessary linking and packaging
$(OBJECT_DIR)\drivercfg.cob: always
	copy $(SYSTEM_DIR)\dflt_cfg.cob $@

always:
