# Copyright (c) Microsoft Corporation. All rights reserved.
#

# Common definitions included into other makefiles

!include $(MMLITE_SDK)\conf\make\first.mk

!if exist (private.mk)
!include private.mk
!endif

!include $(OBJECT_DIR)\..\s-pack2.mk

COMMON_BASE_LIBS= \
	$(LIBRARY_DIR)\$(CBSCHED).lib $(LIBRARY_DIR)\base.lib \
	$(LIBRARY_DIR)\ff_heap.lib $(LIBRARY_DIR)\cobmgr.lib \
	$(LIBRARY_DIR)\dbg_heap.lib $(LIBRARY_DIR)\util.lib

RTSOAP_LIBS= \
	$(LIBRARY_DIR)\sensor.lib \
	$(LIBRARY_DIR)\planner.lib \
	$(LIBRARY_DIR)\statistics.lib \
	$(LIBRARY_DIR)\sampling.lib \
	$(LIBRARY_DIR)\sntp.lib \
	$(LIBRARY_DIR)\cimdb.lib \
	$(LIBRARY_DIR)\cimsample.lib \
	$(LIBRARY_DIR)\tzk.lib \

WS_LIBS= \
	$(LIBRARY_DIR)\wsaddr.lib \
	$(LIBRARY_DIR)\ws.lib \
	$(LIBRARY_DIR)\wsres.lib \
	$(LIBRARY_DIR)\wsman.lib \
	$(LIBRARY_DIR)\marionette.lib \
	$(LIBRARY_DIR)\tabletService.lib \
	$(LIBRARY_DIR)\wsdiscov.lib \
	$(LIBRARY_DIR)\base64.lib \

# Smaller version of SOAP that does not support HTTP
SOAP_UDP_LIBS= $(PRIVATE_SOAP_LIBS) \
	$(LIBRARY_DIR)\tokenizer.lib $(LIBRARY_DIR)\sax.lib \
	$(LIBRARY_DIR)\http.lib \
	$(LIBRARY_DIR)\soap.lib $(LIBRARY_DIR)\convert.lib \
	$(LIBRARY_DIR)\tmp_heap.lib $(LIBRARY_DIR)\calc.lib \
	$(WS_LIBS) \
	$(RTSOAP_LIBS) \
	$(LIBRARY_DIR)\typeinfo.lib

SOAP_LIBS= $(SOAP_UDP_LIBS) \
    $(LIBRARY_DIR)\dssp.lib

NET_LIBS= \
	$(LIBRARY_DIR)\protocol.lib \
	$(LIBRARY_DIR)\ip.lib $(LIBRARY_DIR)\dhcp.lib \
	$(LIBRARY_DIR)\tcp.lib $(LIBRARY_DIR)\igmp.lib \
	$(LIBRARY_DIR)\route.lib $(LIBRARY_DIR)\udp.lib \
	$(LIBRARY_DIR)\dns.lib $(LIBRARY_DIR)\sockets.lib \
	$(PRIVATE_PROTOCOL_LIBS)

# Smaller version that does not support TCP or DNS
NET_UDP_LIBS= \
	$(LIBRARY_DIR)\protocol.lib \
	$(LIBRARY_DIR)\ip.lib $(LIBRARY_DIR)\dhcp.lib \
	$(LIBRARY_DIR)\igmp.lib \
	$(LIBRARY_DIR)\route.lib $(LIBRARY_DIR)\udp.lib \
	$(LIBRARY_DIR)\sockets.lib faketcp.$(O)

!if DEFINED(_CLR)
CLR_LIBS= \
	$(LIBRARY_DIR)\clr.lib		\
	$(LIBRARY_DIR)\clrload.lib	\
	$(LIBRARY_DIR)\clrcoree.lib	\
	$(LIBRARY_DIR)\clrdiag.lib	\
	$(LIBRARY_DIR)\clrcor.lib	\
	$(LIBRARY_DIR)\clrsupp.lib	\
	$(LIBRARY_DIR)\clrhw.lib	\
	$(LIBRARY_DIR)\clrsys.lib	\
	$(LIBRARY_DIR)\clrmm.lib	\
	$(LIBRARY_DIR)\clrsyscoll.lib	\
	$(LIBRARY_DIR)\clrsysreflect.lib	\
	$(LIBRARY_DIR)\clrsysrtcomp.lib	\
	$(LIBRARY_DIR)\clrsysthread.lib
CC_FLAGS = $(CC_FLAGS) -D_CLR=1
NO_CLR_LIB = $(LIBRARY_DIR)\no_clr.lib
CLR_BUILD_DIR = clr.dir
!else
CLR_LIBS = 
NO_CLR_LIB =
CLR_BUILD_DIR =
!endif
