/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <tchar.h>
#include <loaders/cobtab.h>
#include <base/cons.h>

extern PIUNKNOWN Db161CobMain(void);

extern PIUNKNOWN HostfsCobMain(void);
extern PIUNKNOWN SerplexCobMain(void);

const struct PRECOB ThePreCobTable[] = {
    {_T("eb63usart.cob"), SerialCobMain },
    {_T("sernet.cob"), SerNetCobMain }, \
    {_T("serplex.cob"), SerplexCobMain }, \
    {_T("db161.cob"), Db161CobMain },
    WS_MAN_TCP_COBS
    {0,0}
};

/* Select root "fs" file system */
PINAMESPACE BoardInitRomFs(void);
PINAMESPACE BoardInitHostFs(void);

PINAMESPACE BoardInitFileSystem(void)
{
    /* Use RomFs with eb63big: it's a flashed standalone image */
    PINAMESPACE ns = BoardInitRomFs();
    return ns;
}

SCODE FirstApp(const _TCHAR *Args)
{
    return RunSoapServer("http", TRUE);
}
