#
# Copyright (c) Microsoft Corporation. All rights reserved.
#
# Build H8 Image
#

H8_OBJ_DIR=$(MMLITE_SDK)\build\h8_hew\release\obj\src\base\md\h8
H8_OBJS=\
        $(H8_OBJ_DIR)\resetprg.obj \
        $(H8_OBJ_DIR)\intprg.obj \
        $(H8_OBJ_DIR)\dbsct.obj \
        $(H8_OBJ_DIR)\hwsetup.obj \
        $(H8_OBJ_DIR)\_context.obj \
        $(H8_OBJ_DIR)\_pic.obj \
        $(H8_OBJ_DIR)\_timer.obj \
        $(H8_OBJ_DIR)\_fred.obj \
        $(H8_OBJ_DIR)\_umulm.obj \
        $(H8_OBJ_DIR)\_end.obj \
        $(H8_OBJ_DIR)\sci.obj \
        $(H8_OBJ_DIR)\sci2.obj \
        $(MMLITE_SDK)\build\h8_hew\release\obj\src\loaders\no_ldr.obj \
        $(MMLITE_SDK)\build\h8_hew\release\obj\src\crt\snprintf.obj \

LIBS=$(COMMON_BASE_LIBS) \
     $(LIBRARY_DIR)\basecrt.lib \
     $(LIBRARY_DIR)\iids.lib \
     $(MACHDEP_EXE_LIBS) \
     $(LIBRARY_DIR)\ax88796.lib \
     $(LIBRARY_DIR)\testservice.lib \

SUBDIR=conf\package

TARGETS=$(SYSTEM_DIR)\mmliteh8.abs \
	$(SYSTEM_DIR)\mmliteh8_0.abs

!include common.mk
!include $(MMLITE_SDK)/conf/common.mk

START_OPTION=-rom=D=R -start=PResetPRG,PIntPRG/0400,P,C,C$$DSEC,C$$BSEC,D/0C00,B,R/0FF0800,S/0FF95F0

$(SYSTEM_DIR)\mmliteh8.abs: $(H8_OBJ_DIR)\firstthread.obj everyns.$(O) $(H8_OBJS) $(LIBS) $(WS_MAN_TCP_LIBS)
	echo LIB=$(LIBS) $(WS_MAN_TCP_LIBS)>$(SYSTEM_DIR)\LIBS.TMP
	$(SEDIT) -z " " -s , < $(SYSTEM_DIR)\LIBS.TMP >$(SYSTEM_DIR)\LIBS.SUB
	optlnk $(START_OPTION) $(H8_OBJ_DIR)\firstthread.obj everyns.$(O) $(H8_OBJS) $(OBJS) -SUB=$(SYSTEM_DIR)\LIBS.SUB -list=$(SYSTEM_DIR)\mmliteh8.map -output=$(SYSTEM_DIR)\mmliteh8.abs

$(SYSTEM_DIR)\mmliteh8_0.abs: $(H8_OBJ_DIR)\firstthread_0.obj wsmanns.$(O) $(H8_OBJS) $(OBJS) $(NETOBJS) $(LIBS) $(NETLIBS) $(DRIVERLIBS)
	echo LIB=$(LIBS) $(NETLIBS) $(DRIVERLIBS) $(LIBRARY_DIR)\typeinfo.lib>$(SYSTEM_DIR)\LIBS_0.TMP
	$(SEDIT) -z " " -s , < $(SYSTEM_DIR)\LIBS_0.TMP >$(SYSTEM_DIR)\LIBS_0.SUB
	optlnk $(START_OPTION) $(H8_OBJ_DIR)\firstthread_0.obj wsmanns.$(O) $(H8_OBJS) $(OBJS) $(NETOBJS) -SUB=$(SYSTEM_DIR)\LIBS_0.SUB -list=$(SYSTEM_DIR)\mmliteh8_0.map -output=$(SYSTEM_DIR)\mmliteh8_0.abs


