# Copyright (c) Microsoft Corporation. All rights reserved.
#
# Package image together
#

SUBDIR=conf\package
FILES= $(SYSTEM_DIR)\init.tzk $(SYSTEM_DIR)\hostname.txt

TARGETS=$(SYSTEM_DIR)\ntu.exe $(SYSTEM_DIR)\ntubig.exe \
    $(SYSTEM_DIR)\ntusoap.exe $(SYSTEM_DIR)\ntubig2.exe \
    $(SYSTEM_DIR)\ntusec.exe $(SYSTEM_DIR)\ntuds.exe \
    $(SYSTEM_DIR)\debugsyn.dll $(SYSTEM_DIR)\drivercfg.cob \
    $(FILES) \

!if "$(TARGETTYPE)"!="debug"
TARGETS=$(TARGETS) $(SYSTEM_DIR)\ntuds.size $(SYSTEM_DIR)\ntubig.size
!endif

# $(SYSTEM_DIR)\ntu.bsc

COMPONENT_ENTRY=foo

!include common.mk
!include $(MMLITE_SDK)/conf/common.mk

COMMON= ntu.$(O) $(LIBRARY_DIR)\_ntu.$(O) $(LIBRARY_DIR)\_ntu.lib \
	$(LIBRARY_DIR)\base_sim.lib $(LIBRARY_DIR)\ff_heap.lib \
	$(LIBRARY_DIR)\dbg_heap.lib $(LIBRARY_DIR)\util.lib \
	$(LIBRARY_DIR)\cobmgr.lib $(LIBRARY_DIR)\pe_ldr_sim.lib \
	$(LIBRARY_DIR)\romfs.lib $(LIBRARY_DIR)\cb_sched_sim.lib \
	$(LIBRARY_DIR)\hostfssim.lib $(LIBRARY_DIR)\hostfsd.lib \
	$(LIBRARY_DIR)\serplex.lib $(LIBRARY_DIR)\basecrt.lib \
	$(LIBRARY_DIR)\simcrt.lib $(INTERFACES_LIB) $(WIN32_LIBS)

!if DEFINED(_CLR)
COMMON=$(COMMON) $(CLR_LIBS)
!endif
$(SYSTEM_DIR)\ntu.exe: $(COMMON) defcobtab.$(O) runinit.$(O)

$(SYSTEM_DIR)\ntubig.exe: ntubig.$(O) everyns.$(O) \
	$(COMMON) runinit.$(O) ntu_cfg.$(O) \
	$(LIBRARY_DIR)\drivers.lib $(LIBRARY_DIR)\drivercfg.lib \
	$(NTUBIG_LIBS) $(LIBRARY_DIR)\hostfs.lib \
	$(LIBRARY_DIR)\wsock32.lib $(CLR_LIBS)

$(SYSTEM_DIR)\ntubig2.exe: ntubig2.$(O) everyns.$(O) \
	$(COMMON) ntubig.$(O) runinit.$(O) \
	$(LIBRARY_DIR)\drivers.lib $(LIBRARY_DIR)\drivercfg.lib \
	$(NTUBIG_LIBS) $(LIBRARY_DIR)\hostfs.lib \
	$(LIBRARY_DIR)\wsock32.lib

$(SYSTEM_DIR)\ntusoap.exe: ntusoap.$(O) \
	$(COMMON) ntubig.$(O) ntu_cfg.$(O) wsmanns.$(O) \
	$(NTUBIG_LIBS) \
	$(LIBRARY_DIR)\drivers.lib $(LIBRARY_DIR)\drivercfg.lib

$(SYSTEM_DIR)\ntusec.exe: ntusec.$(O) \
	$(COMMON) ntu_cfg.$(O) wsmanns.$(O) \
	$(LIBRARY_DIR)\drivers.lib $(LIBRARY_DIR)\drivercfg.lib \
	$(LIBRARY_DIR)\sernet.lib $(SOAP_UDP_LIBS) $(NET_UDP_LIBS)

$(SYSTEM_DIR)\ntuds.exe: ntuds.$(O) \
	$(COMMON) ntu_cfg.$(O) dsns.$(O) \
	$(NTUDS_LIBS) \
	$(LIBRARY_DIR)\drivers.lib $(LIBRARY_DIR)\drivercfg.lib

$(SYSTEM_DIR)\ntu.bsc: $(SYSTEM_DIR)\ntu.exe
    cd $(SYSTEM_DIR)
!if defined(_UNICODE)
    dir /s /b ..\..\$(TARGETTYPE)-u\obj\*.sbr > bsc.tmp
!else
    dir /s /b ..\..\$(TARGETTYPE)\obj\*.sbr > bsc.tmp
!endif
   "$(BSCMAKE)" $(BSCMAKE_FLAGS) ntu.bsc @bsc.tmp
    -del bsc.tmp

$(SYSTEM_DIR)\debugsyn.dll: $(MMLITE_SDK)\tools\VC_debug_patch\debugsyn.dll
	copy $** $@

$(FILES): $(SRC_DIR)\$(@F)
	copy $** $@

$(SYSTEM_DIR)\drivercfg.cob:
	copy $(SYSTEM_DIR)\ntu_cfg.cob $@
	-copy $(SYSTEM_DIR)\ntu_cfg.pdb $(SYSTEM_DIR)\drivercfg.pdb
