# Copyright (c) Microsoft Corporation. All rights reserved.
#
# Makefile for Intel SideARM board
#
SUBDIR=conf\package
!include $(MMLITE_SDK)/conf/make/first.mk

TARGETS = $(SYSTEM_DIR)\_fredSA.exe

COMMON=$(LIBRARY_DIR)\elf_ldr.lib

!if "$(TOOLS)"=="gnu" || "$(TOOLS)"=="gnu4"
LINK_RELOCATABLE=
EXE_ENTRY=-e_start -u_start
COMMON= $(COMMON) safs.$(O)
!else
EXE_ENTRY=
_LFLAGS=$(_LFLAGS) -elf -ro-base 0x8000
COMMON=$(COMMON) _safs.$(O)
!endif

!include common.mk
!include $(MMLITE_SDK)/conf/common.mk

COMMON= $(COMMON) defcobtab.$(O) $(COMMON_BASE_LIBS) \
	$(LIBRARY_DIR)\romfs.lib $(LIBRARY_DIR)\basecrt.lib $(INTERFACES_LIB)

!if DEFINED(_CLR)
COMMON=$(COMMON) $(CLR_LIBS) $(LIBRARY_DIR)\mmcrt.lib
!endif

$(SYSTEM_DIR)\_fredSA.exe: $(LIBRARY_DIR)\_startSA.$(O) \
	$(LIBRARY_DIR)\_fredSA.lib $(COMMON) runinit.$(O)
    $(_SILENT)$(LINK) $(LINK_EXE_FLAGS) $(EXE_ENTRY) $(LINK_OUT)$@ $(LINK_START_GROUP) $** $(LINK_END_GROUP)

ALLTESTS=\
        $(SYSTEM_DIR)\algnflt.exe \
        $(SYSTEM_DIR)\alltests.exe \
        $(SYSTEM_DIR)\cmdecho.exe \
        $(SYSTEM_DIR)\constrn2.exe \
        $(SYSTEM_DIR)\constrnt.exe \
        $(SYSTEM_DIR)\echo.exe \
        $(SYSTEM_DIR)\fileio.exe \
        $(SYSTEM_DIR)\heaptest.exe \
        $(SYSTEM_DIR)\heaptstc.exe \
        $(SYSTEM_DIR)\heaptstx.exe \
        $(SYSTEM_DIR)\himom.exe \
        $(SYSTEM_DIR)\limage.exe \
        $(SYSTEM_DIR)\lsmodule.exe \
        $(SYSTEM_DIR)\machinfo.exe \
        $(SYSTEM_DIR)\memfunc.exe \
        $(SYSTEM_DIR)\nametest.exe \
        $(SYSTEM_DIR)\sleep.exe \
        $(SYSTEM_DIR)\sleeptst.exe \
        $(SYSTEM_DIR)\t1.exe \
        $(SYSTEM_DIR)\t2.exe \
        $(SYSTEM_DIR)\t3.exe \
        $(SYSTEM_DIR)\t4.exe \
        $(SYSTEM_DIR)\t5.exe \
        $(SYSTEM_DIR)\t6.exe \
        $(SYSTEM_DIR)\t7.exe \
        $(SYSTEM_DIR)\tcis.exe \
        $(SYSTEM_DIR)\tcswitch.exe \
        $(SYSTEM_DIR)\tmutex.exe \
        $(SYSTEM_DIR)\tstdiv64.exe \
        $(SYSTEM_DIR)\tstmemfn.exe \
        $(SYSTEM_DIR)\tstmul64.exe \
        $(SYSTEM_DIR)\ttcreate.exe \


EXES=   \
        $(SYSTEM_DIR)\hp_state.exe \
        $(SYSTEM_DIR)\lsmodule.exe


COBS=\
	$(SYSTEM_DIR)\drivers.cob \
	$(OBJECT_DIR)\drivercfg.cob \
	$(SYSTEM_DIR)\hicob.cob \
	$(SYSTEM_DIR)\null.cob \
	$(SYSTEM_DIR)\sa.cob \
         $(SYSTEM_DIR)\tzk.cob \

DATAFILES=


FSFILES=$(EXES) $(COBS) $(DATAFILES)

# fs.flp differs across machines.  Unfortunately, both GCC
# and the ARM tools know of that name, one way or other.
# Hence the obsession with deleting it. Sigh.
_fs.$(O): fs.flp

_safs.$(O): _fs.$(O)
        -del *.flp
        -del _safs.$(O)
        ren _fs.$(O) _safs.$(O)

safs.$(O): fs.flp
        $(LINK) -r -b binary $** -o $@
        -del *.flp

fs.flp: $(FSFILES)
        -del *.flp
        $(MMLITE_SDK)\tools\bin\mkmemfs -rom -debug -ascii -align 4 boot.exe boot.exe $(FSFILES)
        ren 0.flp fs.flp
        del boot.exe

# Make sure than when we change what goes into the fs it gets rebuilt.
#
fs.flp: $(SRC_DIR)\sidearm.mk

# Hackery to get a different drivercfg.cob into each platform
# XXX causes some unnecessary linking and packaging
$(OBJECT_DIR)\drivercfg.cob: always
	copy $(SYSTEM_DIR)\dflt_cfg.cob $@

always:
