# Copyright (c) Microsoft Corporation. All rights reserved.
#
# Package image together
#

SUBDIR=conf\package

TARGETS=$(SYSTEM_DIR)\winbig.exe
# $(SYSTEM_DIR)\winsoap.exe
# $(SYSTEM_DIR)\winsoap.bsc

!if "$(TARGETTYPE)"!="debug"
TARGETS=$(TARGETS) $(SYSTEM_DIR)\winbig.size
!endif

COMPONENT_ENTRY=foo

!include common.mk
!include $(MMLITE_SDK)/conf/common.mk

COMMON= $(LIBRARY_DIR)\xpshim.lib \
	$(LIBRARY_DIR)\shimbase.lib	\
	$(LIBRARY_DIR)\cbuffer.lib \
	$(LIBRARY_DIR)\dbg_heap.lib $(LIBRARY_DIR)\util.lib \
	$(LIBRARY_DIR)\cobmgr.lib $(LIBRARY_DIR)\pe_ldr_sim.lib \
	$(LIBRARY_DIR)\basecrt.lib \
	$(LIBRARY_DIR)\simcrt.lib $(INTERFACES_LIB) $(WIN32_LIBS)

!if DEFINED(_CLR)
COMMON=$(COMMON) $(CLR_LIBS)
!endif

$(SYSTEM_DIR)\winbig.exe: winbig.$(O) everyns.$(O) \
	$(COMMON) runinit.$(O) \
	$(WINBIG_LIBS) \
	$(WIN32_WINSOCK_LIB) \
	$(CLR_LIBS)

$(SYSTEM_DIR)\winsoap.exe: winsoap.$(O) \
	$(COMMON) \
	$(SOAP_LIBS)

$(SYSTEM_DIR)\winsoap.bsc: $(SYSTEM_DIR)\winsoap.exe
    cd $(SYSTEM_DIR)
!if defined(_UNICODE)
    dir /s /b ..\..\$(TARGETTYPE)-u\obj\*.sbr > bsc.tmp
!else
    dir /s /b ..\..\$(TARGETTYPE)\obj\*.sbr > bsc.tmp
!endif
   "$(BSCMAKE)" $(BSCMAKE_FLAGS) winsoap.bsc @bsc.tmp
    -del bsc.tmp
