<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Add this-arg expansion -jvh 2000 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>
  <!-- Add <this-arg> for virtual concrete implements-methods -->
  <xsl:template match="mic:implements-method">
    <xsl:copy>
      <!-- Add std-name, c-name, cplus-name tags for doc linking -->
      <xsl:attribute name="dot-name"><xsl:value-of select="@implementation-class"></xsl:value-of>.<xsl:value-of select="@name"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="c-name"><xsl:value-of select="@implementation-class"></xsl:value-of>_<xsl:value-of select="@name"></xsl:value-of></xsl:attribute>
      <xsl:attribute name="cplus-name"><xsl:value-of select="@implementation-class"></xsl:value-of>::<xsl:value-of select="@name"></xsl:value-of></xsl:attribute>
      <!-- Copy the rest -->
      <xsl:apply-templates select="@*|comment()|processing-instruction()|text()"></xsl:apply-templates>
      <xsl:if test="@virtual = 'true'">
        <xsl:element name="this-arg" namespace="x-schema:expanded-schema.xml">
          <xsl:attribute name="name">iThis</xsl:attribute>
          <xsl:attribute name="type">
            <xsl:for-each select="//mic:interface[@name = current()/@interface-name]">
              <xsl:value-of select="@type"></xsl:value-of>
            </xsl:for-each>
          </xsl:attribute>
          <xsl:attribute name="direction">in</xsl:attribute>
        </xsl:element>
      </xsl:if>
      <xsl:apply-templates select="*"></xsl:apply-templates>
    </xsl:copy>
  </xsl:template>
  <!-- Add <this-arg> for virtual interface methods -->
  <xsl:template match="mic:method | mic:extended-method">
    <xsl:copy>
      <xsl:apply-templates select="@*|comment()|processing-instruction()|text()"></xsl:apply-templates>
      <xsl:if test="@virtual = 'true'">
        <xsl:element name="this-arg" namespace="x-schema:expanded-schema.xml">
          <xsl:attribute name="name">iThis</xsl:attribute>
          <xsl:attribute name="type">
            <xsl:value-of select="../@type"></xsl:value-of>
          </xsl:attribute>
          <xsl:attribute name="direction">in</xsl:attribute>
        </xsl:element>
      </xsl:if>
      <xsl:apply-templates select="*"></xsl:apply-templates>
    </xsl:copy>
  </xsl:template>

   <!-- filter out replicated string-entries -->
   <xsl:template match="mic:interface">
     <xsl:copy>
       <xsl:apply-templates select="@*|node()[name() != 'string-entry']"/>
       <xsl:for-each select="mic:string-entry">
         <xsl:if test="not(text() = preceding-sibling::mic:string-entry/text())">
           <xsl:copy><xsl:apply-templates select="@*|node()"/></xsl:copy>
         </xsl:if>
       </xsl:for-each>
     </xsl:copy>
   </xsl:template>

</xsl:stylesheet>
