<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Add this-arg expansion -jvh 2000 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>
  <!-- Add method-response for virtual interface methods -->
  <xsl:template match="mic:method">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"></xsl:apply-templates>
    </xsl:copy>
    <xsl:if test="@type != 'none'">
      <xsl:element name="method-response" namespace="x-schema:expanded-schema.xml">
        <xsl:apply-templates select="@*|node()"></xsl:apply-templates>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <!-- Add extended-method-response for virtual interface methods -->
  <xsl:template match="mic:extended-method">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"></xsl:apply-templates>
    </xsl:copy>
    <xsl:if test="@type != 'none'">
      <xsl:element name="extended-method-response" namespace="x-schema:expanded-schema.xml">
        <xsl:apply-templates select="@*|node()"></xsl:apply-templates>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <!-- Add ptype and cptype to structs when applicable -->
  <xsl:template match="mic:struct">
    <xsl:copy>
      <xsl:if test="@doptype"><xsl:attribute name="ptype">P<xsl:value-of select="@name"/></xsl:attribute></xsl:if>
      <xsl:if test="@docptype"><xsl:attribute name="cptype">CP<xsl:value-of select="@name"/></xsl:attribute></xsl:if>
      <xsl:apply-templates select="@*|node()"></xsl:apply-templates>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
