<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Resolve generic types to ctypes and xsd types -jvh 2004 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>
  <!-- Add method-response for virtual interface methods -->
  <xsl:template match="mic:arg|mic:this-arg|mic:field|mic:method|mic:extended-method|mic:implements-method"><!-- should be mic:*[@type] but ... -->
    <xsl:copy>
        <xsl:if test="not(@ctype)">
          <xsl:attribute name="ctype"><xsl:apply-templates select="@type" mode="ctype"></xsl:apply-templates></xsl:attribute>
        </xsl:if>
        <xsl:if test="self::mic:arg">
          <xsl:attribute name="frame-type"><xsl:apply-templates select="@type" mode="frame-type"></xsl:apply-templates></xsl:attribute>
        </xsl:if>
        <xsl:attribute name="xtype"><xsl:apply-templates select="@type" mode="xtype"></xsl:apply-templates>
        </xsl:attribute>
      <xsl:apply-templates select="@*|node()"></xsl:apply-templates>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="@type" mode="const"><xsl:if test="../@direction = 'in' or parent::mic:method or parent::mic:extended-method or parent::mic:extended-method or parent::mic:implements-method">const </xsl:if></xsl:template>

  <xsl:template match="@type" mode="ctype"><xsl:choose><xsl:when test=". = 'string' or . = 'QNAME' or . = 'URI'"><xsl:apply-templates select="." mode="const"/>_TCHAR *</xsl:when><xsl:when test=". = 'string[]'">_TCHAR**</xsl:when><xsl:when test=". = 'none'">SCODE</xsl:when><xsl:when test=". = 'BITMAP'"><xsl:apply-templates select="." mode="const"/>UINT32*</xsl:when><xsl:when test="contains(.,':')"><xsl:value-of select="substring-after(.,':')"/></xsl:when><xsl:when test=". = 'ANYTYPE'"><xsl:apply-templates select="." mode="const"/>void *</xsl:when><xsl:when test="../@list and ../@direction != 'in'"><xsl:value-of select="."/> *</xsl:when><xsl:otherwise><xsl:value-of select="."/></xsl:otherwise></xsl:choose></xsl:template>

  <xsl:template match="@type" mode="xtype"><xsl:choose><xsl:when test=". = 'BITMAP' or . = 'LISTNODE' or . = 'PICONTINUATION'">none</xsl:when><xsl:when test="../self::mic:field[@name = ../mic:field/@size-is or @name = ../mic:field/@length-is or @name = ../mic:field/@type-is or @name = ../mic:field/@selector-is]">none</xsl:when><xsl:when test="../self::mic:arg[@name = ../mic:arg/@size-is or @name = ../mic:arg/@length-is or @name = ../mic:arg/@type-is or @name = ../mic:arg/@selector-is]">none</xsl:when><xsl:when test="contains(.,':')"><xsl:value-of select="substring-after(.,':')"/></xsl:when><xsl:otherwise><xsl:value-of select="."/></xsl:otherwise></xsl:choose></xsl:template>

  <xsl:template match="@type" mode="frame-type"><xsl:choose><xsl:when test=". = 'UINT8' or . = 'UINT16'">UINT</xsl:when><xsl:when test=". = 'INT8' or . = 'INT16'">INT</xsl:when><xsl:when test=". = 'INT64' or . = 'TIME'">__PACKED_INT64</xsl:when><xsl:when test=". = 'UINT64' or . = 'VM_OFFSET' or . = 'VM_SIZE'">__PACKED_UINT64</xsl:when><xsl:otherwise><xsl:apply-templates select="." mode="ctype"/></xsl:otherwise></xsl:choose></xsl:template>

</xsl:stylesheet>


