<?xml version='1.0'  encoding="iso-8859-1"?>
<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Generate 'empty' methods for concrete classes -jvh 2000/2001 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="text"/>

  <xsl:template match="/" xml:space="preserve">
    <!-- orphan classes -->
    <xsl:for-each select="/mic:mmlite-spec/mic:concrete-class">/* @FILE:<xsl:value-of select="@name"/> *//* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Implements <xsl:value-of select="@name"/> concrete class */<xsl:apply-templates select="."/></xsl:for-each>

    <!-- components - gen component stub (CobMain) for first class file -->
    <xsl:for-each select="/mic:mmlite-spec/mic:component"><xsl:variable name="current-component" select="."/><xsl:for-each select="mic:concrete-class">/* @FILE:<xsl:value-of select="@name"/> *//* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Implements <xsl:value-of select="@name"/> concrete class in component <xsl:value-of select="$current-component/@name"/> */<xsl:apply-templates select="."/></xsl:for-each></xsl:for-each></xsl:template>

  <xsl:template match="//mic:concrete-class" xml:space="preserve">
<xsl:variable name="current-class" select="."/>
#include &lt;mmlite.h&gt;
#include &lt;mmmacros.h&gt;<xsl:if test="mic:implements[2]">
#include &lt;stddef.h&gt; /* for offsetof() */</xsl:if><xsl:if test="$current-class/@super-class">
#include &lt;base/cobdesc.h&gt;</xsl:if>
<xsl:for-each select="$current-class/mic:implements"><xsl:for-each select="//mic:interface[@name = current()]"><xsl:if test="@original-file">#include &lt;<xsl:value-of select="/@original-file"/>.h&gt;</xsl:if><xsl:if test="not(@original-file)"><xsl:for-each select="//mic:interface-group[@name = current()/@mygroup]">#include &lt;<xsl:value-of select="@original-file"/>.h&gt;</xsl:for-each></xsl:if></xsl:for-each>
</xsl:for-each>
typedef struct _<xsl:value-of select="$current-class/@name"/> {
<xsl:if test="@super-class">    struct _<xsl:value-of select="@super-class"/> super;
</xsl:if><xsl:for-each select="mic:implements"><xsl:if test="(not(../@super-class) or . != id(../@super-class)/mic:implements) and not(../@super-class and not(../mic:implements[2]))">    CONST_VTBL struct <xsl:value-of select="."/>Vtbl *<xsl:value-of select="@vtable-name"/>;
</xsl:if></xsl:for-each><xsl:if test="not(@super-class)">    UINT RefCnt;
</xsl:if>} <xsl:value-of select="$current-class/@name"/>;

#include "s_<xsl:value-of select="@name"/>_v.c"
<!-- Generate conversion macros -->
/* Convert between interface and instance pointer and vice versa */
<xsl:for-each select="mic:implements">#define p<xsl:value-of select="@prefix"/>(_i_) ((<xsl:value-of select="../@type"/><xsl:if test="not(../@type)"><xsl:value-of select="../@name"/> *</xsl:if>)((_i_)<xsl:if test="@vtable-name[not(. = 'v')]"> ? (ADDRESS)(_i_) - offsetof(struct _<xsl:value-of select="$current-class/@type" />, <xsl:value-of select="@vtable-name" />) : 0</xsl:if>))
#define i<xsl:value-of select="@prefix"/>(_p_) ((<xsl:value-of select="//mic:interface[@name = current()]/@type"/>)((_p_)<xsl:if test="@vtable-name[not(. = 'v')]"> ? &amp;(_p_)-><xsl:value-of select="@vtable-name" /> : NULL</xsl:if>))
</xsl:for-each><!-- Generate conversion macro for super-class when needed --><xsl:if test="@super-class">#define p<xsl:value-of select="id(@super-class)/mic:implements/@prefix"/>(_i_) ((struct _<xsl:value-of select="@super-class"/> *)((_i_)))
#define i<xsl:value-of select="id(@super-class)/mic:implements/@prefix"/>(_p_) ((PIUNKNOWN)((_p_)))
</xsl:if><!-- Generate each method --><xsl:for-each select="mic:implements-method"><xsl:if test="@implementation-class = $current-class/@name" >
<xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>PRIVATE <xsl:value-of select="@ctype"/> <xsl:value-of select="@implementation-name"/> (<xsl:if test="not(mic:this-arg|mic:arg)">void</xsl:if><xsl:for-each select="mic:this-arg|mic:arg">
    <xsl:if test="@direction != 'in'">/*<xsl:value-of select="@direction"/>*/ </xsl:if><xsl:value-of select="@ctype"/> <xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>)
{<xsl:choose><!-- Special code for IUNKNOWN METHODS --><xsl:when test="@extended-interface = 'IUnknown' and not(@vtable-name = 'v')"><!-- secondary -->
    PIUNKNOWN obj = i<xsl:value-of select="../mic:implements-method[@vtable-name = 'v' and @name = current()/@name]/@implementation-prefix"/>(p<xsl:value-of select="@implementation-prefix"/>(<xsl:value-of select="mic:this-arg/@name"/>));
    return obj->v-><xsl:value-of select ="@name"/>(obj<xsl:for-each select="mic:arg">, <xsl:value-of select="@name"/></xsl:for-each>);
</xsl:when><xsl:when test="@name = 'QueryInterface' and @extended-interface = 'IUnknown'">
</xsl:when><xsl:when test="@name = 'AddRef' and @extended-interface = 'IUnknown'">
</xsl:when><xsl:when test="@name = 'Release' and @extended-interface = 'IUnknown'">
</xsl:when><xsl:otherwise><!-- OTHER METHODS --><xsl:if test="@virtual = 'true'">
    METHOD_DECLARE<xsl:if test="$current-class/mic:implements[2]">_MULTI</xsl:if>(<xsl:value-of select ="$current-class/@name"/>, <xsl:if test="$current-class/mic:implements[2]"><xsl:value-of select="@implementation-prefix"/>, </xsl:if><xsl:value-of select ="@name"/>);

    UnusedParameter(This);
</xsl:if><xsl:for-each select="mic:arg">    UnusedParameter(<xsl:apply-templates select="@name" mode="CIdentifier"/>);
</xsl:for-each>
    sc = E_NOT_IMPLEMENTED;

METHOD_CLEANUP;<xsl:choose><xsl:when test="@type = 'SCODE' or @type = 'none'">
    return sc;
</xsl:when><xsl:when test="@type = 'PTR'">
    return NULL;
</xsl:when><xsl:when test="@type = 'BOOL'">
    return FALSE;
</xsl:when><xsl:when test="@type = 'void'"></xsl:when><xsl:otherwise>
    return 0;
</xsl:otherwise></xsl:choose></xsl:otherwise></xsl:choose>}<xsl:if test="mic:ifdef">
#endif</xsl:if></xsl:if>
</xsl:for-each><xsl:for-each select="mic:constructor">
<!-- Spit out constructors -->
/* Constructor */
<xsl:value-of select="@type"/> <xsl:apply-templates select="@name" mode="CIdentifier"/>(<xsl:for-each select="mic:arg">
    <xsl:value-of select="@ctype"/> <xsl:value-of select="@name"/><xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>)
{
    PIHEAP pHeap = CurrentHeap();
    <xsl:value-of select="../@type"/> This = (<xsl:value-of select="../@type"/>) pHeap->v->Alloc(pHeap, 0, sizeof *This, 0);
    if (!This)<xsl:choose><xsl:when test="@type = @interface-type">
        return NULL;</xsl:when><xsl:otherwise>
        return E_NOT_ENOUGH_MEMORY;</xsl:otherwise></xsl:choose>

<xsl:for-each select="../mic:implements">    This-><xsl:value-of select="@vtable-name"/> = &amp;<xsl:value-of select="@vtable-implementation-name"/>;
</xsl:for-each>    This->RefCnt = 1;
<xsl:for-each select="mic:arg">
    UnusedParameter(<xsl:value-of select="@name"/>);</xsl:for-each>
<xsl:choose><xsl:when test="@type = @interface-type">
    return i<xsl:value-of select="@implements-prefix"/>(This);</xsl:when><xsl:otherwise>
    *XXX = i<xsl:value-of select="@implements-prefix"/>(This);
    return S_OK;</xsl:otherwise></xsl:choose>
}</xsl:for-each>
PRIVATE SCODE <xsl:value-of select="$current-class/@name"/>Destroy(PIUNKNOWN iThis)
{
    METHOD_DECLARE(<xsl:value-of select="$current-class/@name"/>, Destroy);

    sc = S_OK;

METHOD_CLEANUP;
    return sc;
}</xsl:template>
<!-- Put an underscore in front of some reserved words that might be used as
     argument names -->
<xsl:template match="@name" mode="CIdentifier"><xsl:if test=". = 'return'">_</xsl:if><xsl:value-of select="."/></xsl:template>
</xsl:stylesheet>
