<?xml version='1.0'?>
<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Generate C style headers for interfaces -jvh 2000 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml"
                xml:space="preserve">
  <xsl:output method="text"/>

  <!-- method frame equivalent struct -->
  <xsl:template match="mic:method" mode="framestruct" xml:space="preserve">_PACKED struct _<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_FRAME {
    ADDRESS pThis;<xsl:for-each select="mic:arg[not(@is-return-value)]"><xsl:sort select="@index" data-type="number" order="ascending"/>
    <xsl:value-of select="@frame-type"/> _<xsl:value-of select="@name"/>_;</xsl:for-each>
<!--    ADDRESS Link;
-->};

</xsl:template>

<!-- TYPEDEF -->
<xsl:template match="mic:typedef">typedef <xsl:value-of select="@type"/> <xsl:if test="@arglist">(</xsl:if><xsl:if test="@linkage"><xsl:value-of select="@linkage"/> </xsl:if><xsl:if test="@arglist"> *</xsl:if><xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="@arglist">)(<xsl:value-of select="@arglist"/>)</xsl:if><xsl:if test="@array"> [<xsl:value-of select="@array"/>]</xsl:if>;
</xsl:template>

<!-- CONSTANT -->
<xsl:template match="mic:constant"><xsl:variable name="current-constant" select="."/><xsl:if test="@type">typedef <xsl:value-of select="@type"/> <xsl:value-of select="@name"/>;
</xsl:if><xsl:for-each select="mic:constant-value">#define <xsl:value-of select="$current-constant/@prefix"/><xsl:value-of select="@name"/> <xsl:if test="$current-constant/@typecast">((<xsl:value-of select="$current-constant/@typecast"/>) </xsl:if><xsl:if test="$current-constant/@base and not(@nobase)">(<xsl:value-of select="$current-constant/@base"/> + </xsl:if><xsl:value-of select="@ordinal"/><xsl:if test="$current-constant/@base and not(@nobase)">)</xsl:if><xsl:if test="$current-constant/@typecast">)</xsl:if>
</xsl:for-each>
</xsl:template>

  <!-- Template for printing interface prototypes -->
  <xsl:template match="//mic:interface" xml:space="preserve">
<xsl:if test="@original-file">
#endif
/* @FILE:<xsl:value-of select="@original-file"/>.h */
#ifndef  __<xsl:value-of select="@original-file"/>_h__
#define  __<xsl:value-of select="@original-file"/>_h__
<xsl:if test="@original-file = 'baseif'"><xsl:for-each select="//mic:interface">
typedef struct <xsl:value-of select="@name"/> *<xsl:value-of select="@type"/>;</xsl:for-each>
</xsl:if>
</xsl:if>
/********************** <xsl:value-of select="@name"/> **********************/
<!--CONSTANTS TYPEDEF--><xsl:apply-templates select="mic:constant|mic:typedef"/>
<!--STRUCT DECL--><xsl:for-each select="mic:struct"><xsl:if test="mic:ifdef and @dotype|@doptype|@docptype">
#if <xsl:value-of select="mic:ifdef"/></xsl:if><xsl:if test="@doptype = 'true'">typedef struct <xsl:value-of select="@name"/> *P<xsl:value-of select="@name"/>;
</xsl:if><xsl:if test="@dotype = 'true'">typedef struct <xsl:value-of select="@name"/> <xsl:value-of select="@name"/>;
</xsl:if><xsl:if test="@docptype = 'true'">typedef const struct <xsl:value-of select="@name"/> *CP<xsl:value-of select="@name"/>;
</xsl:if><xsl:if test="mic:ifdef and @dotype|@doptype|@docptype">#endif
</xsl:if></xsl:for-each>
<!--STRUCT DEF--><xsl:for-each select="mic:struct"><xsl:if test="mic:ifdef">
#if <xsl:value-of select="mic:ifdef"/></xsl:if>
struct <xsl:value-of select="@name"/><xsl:if test="mic:field"> {<xsl:for-each select="mic:field">
    <xsl:choose><xsl:when test="@type = 'LISTNODE'">ListNodeDeclare(<xsl:value-of select="../@name"/>, <xsl:value-of select="@name"/>)</xsl:when><xsl:otherwise><xsl:value-of select="@ctype"/> <xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="@array">[<xsl:value-of select="@array"/>]</xsl:if></xsl:otherwise></xsl:choose>;</xsl:for-each>
}</xsl:if>;
<xsl:if test="@initializer">
#define <xsl:value-of select="@name"/>_INITIALIZER <xsl:value-of select="@initializer"/>
</xsl:if><xsl:if test="mic:ifdef">#endif
</xsl:if></xsl:for-each>
<!--VTABLE--><xsl:if test="mic:method|mic:extended-method">struct <xsl:value-of select="@name"/>Vtbl {
    __VTABLE_COMPATIBILITY_FILLER_DECLARATION
<xsl:for-each select="mic:method|mic:extended-method">
<xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>    <xsl:value-of select="@ctype"/> (<xsl:if test="@convention"><xsl:value-of select="@convention"/> </xsl:if>*<xsl:value-of select="@name"/>) (<xsl:if test="not(mic:this-arg|mic:arg)">void</xsl:if><xsl:for-each select="mic:this-arg|mic:arg">
        /*<xsl:value-of select="@direction"/>*/ <xsl:value-of select="@ctype"/> <xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>);
<xsl:if test="mic:ifdef">#else
    void (*__filler<xsl:value-of select="position()"/>)(void);
#endif
</xsl:if></xsl:for-each>
};</xsl:if>

<!-- FUNCTION POINTER DECLARATIONS--><xsl:for-each select="mic:method|mic:extended-method"><xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>typedef <xsl:value-of select="@ctype"/> (<xsl:if test="@convention"><xsl:value-of select="@convention"/> </xsl:if>*_<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_TYPE)(<xsl:if test="not(mic:this-arg|mic:arg)">void</xsl:if><xsl:for-each select="mic:this-arg|mic:arg">
    <xsl:value-of select="@ctype"/> <xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>);
<xsl:if test="mic:ifdef">#endif
</xsl:if></xsl:for-each>
<!-- FUNCTION TYPE DECLARATIONS--><xsl:for-each select="mic:method|mic:extended-method"><xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>typedef <xsl:value-of select="@ctype"/> <xsl:if test="@convention"><xsl:value-of select="@convention"/> </xsl:if>_<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_FUNC(<xsl:if test="not(mic:this-arg|mic:arg)">void</xsl:if><xsl:for-each select="mic:this-arg|mic:arg">
    <xsl:value-of select="@ctype"/> <xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>);
<xsl:if test="mic:ifdef">#endif
</xsl:if></xsl:for-each>
<!--METHOD FRAMES-->/* Method frames */
#ifdef _MSC_VER
#pragma pack(push,gentypeinfo,4)
#endif
#if !(!(defined(mips) || defined(m68k)) || !defined(__GNUC__))
/* Old compiler crashes */
#undef _PACKED
#define _PACKED
#endif
<xsl:for-each select="mic:method"><xsl:apply-templates select="." mode="framestruct"/></xsl:for-each>
#ifdef _MSC_VER
#pragma pack(pop,gentypeinfo)
#endif
<!--STATIC DECLARATIONS--><xsl:for-each select="(mic:method|mic:extended-method)[@virtual = 'false' and not(@convention)]"><xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>EXTERN_C <xsl:value-of select="@ctype"/> <xsl:if test="@convention"><xsl:value-of select="@convention"/> </xsl:if><xsl:value-of select="@name"/>(<xsl:if test="not(mic:this-arg|mic:arg)">void</xsl:if><xsl:for-each select="mic:this-arg|mic:arg">
    <xsl:value-of select="@ctype"/> <xsl:value-of select="@name"/><xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>);
<xsl:if test="mic:ifdef">#endif
</xsl:if></xsl:for-each>
<!--C++ INTERFACE -->#if defined(__cplusplus) &amp;&amp; !defined(CINTERFACE)
typedef struct <xsl:value-of select="@name"/><xsl:for-each select="@extends"> : public <xsl:value-of select="."/></xsl:for-each> {
    public:
<xsl:for-each select="mic:method">
<xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>    <xsl:choose><xsl:when test="@virtual = 'true'">virtual</xsl:when><xsl:otherwise>static</xsl:otherwise></xsl:choose> <xsl:value-of select="@ctype"/> <xsl:choose><xsl:when test="@convention"><xsl:value-of select="@convention"/></xsl:when><xsl:otherwise>MCT</xsl:otherwise></xsl:choose> <xsl:value-of select="@name"/> ( <xsl:if test="not(mic:arg)">void )</xsl:if><xsl:if test="mic:arg">
</xsl:if><xsl:for-each select="mic:arg">        /*<xsl:value-of select="@direction"/>*/ <xsl:value-of select="@ctype"/> <xsl:apply-templates select="@name" mode="CIdentifier"/><xsl:if test="position()!=last()">, </xsl:if>
</xsl:for-each><xsl:if test="mic:arg">    )</xsl:if><xsl:if test="@virtual = 'true'"> = 0</xsl:if>;<xsl:if test="mic:ifdef">
#endif</xsl:if>
  </xsl:for-each>
} <xsl:value-of select="@name"/>;
#else
<!--INTERFACE TYPE-->typedef struct <xsl:value-of select="@name"/> {
    CONST_VTBL struct <xsl:value-of select="@name"/>Vtbl *v;
} <xsl:value-of select="@name"/>;
#endif

<!--IID DECLARATION-->EXTERN_C const struct IID IID_<xsl:value-of select="@name"/>;
</xsl:template>

<xsl:template match="//mic:interface-group" xml:space="preserve">
#endif
/* @FILE:<xsl:value-of select="@original-file"/>.h */
#ifndef  __<xsl:value-of select="@original-file"/>_h__
#define  __<xsl:value-of select="@original-file"/>_h__
<!--Dump all interface typedefs into baseif.h + any additional mentioned by uses-interface --><xsl:if test="@original-file = 'baseif'"><xsl:for-each select="//mic:interface[not(@documentation-only='true')]">
typedef struct <xsl:value-of select="@name"/> *<xsl:value-of select="@type"/>;</xsl:for-each><xsl:for-each select="//mic:interface/mic:uses-interface[not(//mic:interface/@name = @name)]">
typedef struct <xsl:value-of select="@name"/> *<xsl:value-of select="@type"/>;</xsl:for-each></xsl:if></xsl:template>

<!-- helpers for s_component.h generation -->
  <xsl:template match="mic:component[@prefix]" mode="cobmain"><xsl:value-of select="@prefix"/>CobMain</xsl:template>
  <xsl:template match="mic:component[not(@prefix)]" mode="cobmain"><xsl:value-of select="@name"/>CobMain</xsl:template>

<!-- main -->
<xsl:template match="/" xml:space="preserve">#ifndef __SPEC_H_
#define __SPEC_H_
<xsl:for-each select="//mic:interface[not(@documentation-only='true')]|//mic:interface-group"><xsl:apply-templates select="."/></xsl:for-each>
#endif
/* @FILE:s_cobtab.h */
#ifndef __S_COBTAB_H_
#define __S_COBTAB_H_
/* Generated list of known COB entry points (from &lt;component&gt;) */

<xsl:for-each select="//mic:component">EXTERN_C PIUNKNOWN <xsl:apply-templates select="." mode="cobmain"/>(void);
</xsl:for-each>
/* Profile groups of components, for precobtab use */
<xsl:for-each select="//mic:profile">#define <xsl:value-of select="@name"/>_COBS \
<xsl:for-each select="mic:expands-profile">    <xsl:value-of select="text()"/>_COBS \
</xsl:for-each><xsl:for-each select="mic:contains-component">    {_T("<xsl:value-of select='.'/>.cob"), <xsl:value-of select="id(.)/@prefix"/>CobMain }, \
</xsl:for-each>
</xsl:for-each>

<xsl:for-each select="//mic:interface"><xsl:apply-templates select="mic:namespace" mode="declare"/></xsl:for-each>

<xsl:for-each select="//mic:profile">#define <xsl:value-of select="@name"/>_NAMESPACES_COUNT <xsl:apply-templates select="." mode="count"/>
#define <xsl:value-of select="@name"/>_NAMESPACES \
<xsl:for-each select="mic:expands-profile">    <xsl:value-of select="."/>_NAMESPACES \
</xsl:for-each><xsl:for-each select="mic:uses-namespace">    (CPANY_ENTRY) &amp;<xsl:value-of select="//mic:namespace[@prefix = current()/@prefix]/../@name" />_ifd_namespace_<xsl:value-of select="@prefix"/>, \
</xsl:for-each>
</xsl:for-each>
#endif
</xsl:template>

<!-- Count number of <uses-namespace> recursively -->
<xsl:template match="//mic:profile" mode="count"><xsl:value-of select="count(mic:uses-namespace)"/><xsl:for-each select="mic:expands-profile">+<xsl:apply-templates select="//mic:profile[@name = current()]" mode="count"/></xsl:for-each></xsl:template>

<!-- Put an underscore in front of some reserved words that might be used as
     argument names. -->
<xsl:template match="@name" mode="CIdentifier"><xsl:if test=". = 'return'">_</xsl:if><xsl:value-of select="."/></xsl:template>

  <!-- namespace descriptor declaration -->
  <xsl:template match="mic:interface/mic:namespace" mode="declare">extern const struct XMLNAMESPACE <xsl:value-of select="../@name" />_ifd_namespace_<xsl:value-of select="@prefix"/>;
</xsl:template>

</xsl:stylesheet>

