<?xml version='1.0'?>
<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Generate MIDL specification of interface -jvh 2000 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="text"/>

  <xsl:template match="/" xml:space="preserve">
[
    uuid(695ed662-efe4-11d3-8c65-00e0291551e5)
] library spec {

<!-- Stop MIDL builtin types from getting in the way -->
#define SCODE __MYSCODE__

typedef unsigned __int64 UINT64;
typedef unsigned long UINT32;
typedef unsigned short UINT16;
typedef unsigned char UINT8;
typedef UINT32 UINT; <!-- ASSUME: 32 bit machine -->
typedef __int64 INT64;
typedef long INT32;
typedef short INT16;
typedef char INT8;
typedef INT32 INT;

typedef INT SCODE;
typedef UINT8 _TCHAR; <!-- ASSUME: not Unicode -->
typedef UINT8 BYTE;

typedef struct _GUID <!-- ASSUME: little endian structs -->
{
    UINT32  Data1;
    UINT16 Data2;
    UINT16 Data3;
    UINT8 Data4[8];
} IID;
typedef IID *REFIID;
typedef UINT NAME_SPACE_FLAGS;
typedef void *PTR; <!-- XXX Trouble with TLBIMP -->
typedef UINT ADDRESS;
typedef UINT ADDR_SIZE;
typedef INT BOOL;
typedef PTR THREAD_ARGUMENT;
typedef void (*THREAD_FUNCTION )(THREAD_ARGUMENT arg);
typedef struct _MACHINE_INFO {
    UINT32  MachineId;
    UINT32  OEMId;
    UINT    TotalPhysicalMemory;
    UINT    AvailablePhysicalMemory;
    UINT    Reserved[12];
} MACHINE_INFO;
typedef UINT MACHINE_INFO_FLAVOR;
typedef UINT32 ENDPOINT_NAME_TYPE;
typedef BYTE ENDPOINT_REQ_TYPES;
typedef INT64 TIME, *PTIME;
typedef struct _CXTINFO {UINT32 xxx;} *PCXTINFO;
typedef UINT *PUINT;
typedef void (* STRINGER)(void *Where, _TCHAR *String);
typedef PTR va_list; <!-- XXX ??? -->
typedef struct _MUTEX {UINT32 xxx;} *PMUTEX, MUTEX;
typedef struct _CONDITION {UINT32 xxx;} *PCONDITION;
typedef INT _CRITICALITY;          
typedef struct  _TIME_CONSTRAINT           
{
    TIME Start;
    TIME Estimate;
    TIME Deadline;
    _CRITICALITY Criticality;

} TIME_CONSTRAINT, *PTIME_CONSTRAINT;
typedef UINT size_t;

<!-- i386 specific gunk -->
typedef struct _DOSX_INTERFACE {UINT32 xxx;} *PDOSX_INTERFACE;
<!-- end of machine dep stuff -->

struct mbuf {UINT32 xxx;};
struct sockaddr {UINT32 xxx;};
struct rtentry {UINT32 xxx;};

<xsl:for-each select="//mic:interface[@extends or (@name = 'IUnknown')]">
interface <xsl:value-of select="@name"/>;
typedef <xsl:value-of select="@name"/> *<xsl:value-of select="@type"/>;</xsl:for-each>

    <xsl:for-each select="//mic:interface[@extends or (@name = 'IUnknown')]">

[
    object,
    uuid(<xsl:value-of select="@iid"/>),
    pointer_default(unique)
] interface <xsl:value-of select="@name"/> <xsl:for-each select="@extends">: <xsl:value-of select="." /></xsl:for-each> {
<xsl:for-each select="mic:method">
<xsl:value-of select="@type"/> <xsl:value-of select="@name"/> ( <xsl:if test="not(mic:arg)"> void </xsl:if>
<xsl:for-each select="mic:arg">        [<xsl:choose><xsl:when test="@direction = 'inout'">in, out</xsl:when><xsl:otherwise><xsl:value-of select="@direction"/></xsl:otherwise></xsl:choose>, <xsl:if test="@size-is">size_is(<xsl:value-of select="@size-is"/>), </xsl:if><xsl:if test="@length-is">size_is(<xsl:value-of select="@length-is"/>), </xsl:if><xsl:if test="@attributes"><xsl:value-of select="@attributes"/>, </xsl:if>] <xsl:value-of select="@type"/> <xsl:value-of select="@name"/> <xsl:if test="position()!=last()"> , </xsl:if>
</xsl:for-each>    );
  </xsl:for-each>
}
    </xsl:for-each>

    typedef struct FOOBAR { PINAMESPACE ns; } *_PFOOBAR;
}
  </xsl:template>
</xsl:stylesheet>
