<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Generate table of contents, MSDN style. -jvh 2000 -->
<!-- Generate MSDN style table of content -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template (for copying html tags) -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>
  <xsl:template match="/">
    <MTN title="Reference Manual" nodeType="node" type="none" tocPath="toc-2" ref="interfaces.htm">
      <xsl:for-each select="/mic:mmlite-spec/mic:interface-group">
        <xsl:variable name="current-group-ix" select="position()"/>
        <MTN nodeType="node" type="file">
          <xsl:attribute name="title"><xsl:value-of select="@name" /> Interfaces</xsl:attribute><xsl:attribute name="ref" >interfaces.htm#<xsl:value-of select="@name" /></xsl:attribute>
          <xsl:attribute name="tip"><xsl:value-of select="mic:P" /></xsl:attribute>
          <xsl:attribute name="tocPath"><xsl:value-of select="@name" />-2-<xsl:value-of select="format-number($current-group-ix - 1, '0')"/></xsl:attribute>
          <xsl:for-each select="/mic:mmlite-spec/mic:interface[@mygroup = current()/@name]">

            <MTN nodeType="leaf" type="file">
              <xsl:attribute name="title"><xsl:value-of select="@name"/></xsl:attribute>
              <xsl:attribute name="ref" ><xsl:value-of select="@name" />.htm</xsl:attribute>
              <xsl:attribute name="tip" ><xsl:value-of select="mic:P"/></xsl:attribute>
              <xsl:attribute name="tocPath">toc-2-<xsl:value-of select="format-number($current-group-ix - 1, '0')"/>-<xsl:value-of select="format-number(position() - 1, '0')"/></xsl:attribute>
            </MTN>
          </xsl:for-each>
        </MTN>
      </xsl:for-each>
      <MTN title="Concrete Classes" nodeType="node" type="none" tocPath="toc-2-14">
        <xsl:for-each select="//mic:concrete-class" >
          <MTN nodeType="leaf" type="file">
            <xsl:attribute name="title" ><xsl:value-of select="@name"/></xsl:attribute>
            <xsl:attribute name="ref" ><xsl:value-of select="@name"/>.htm</xsl:attribute>
            <xsl:attribute name="tip" ><xsl:value-of select="mic:P"/></xsl:attribute>
            <xsl:attribute name="tocPath" >toc-2-<xsl:value-of select="count(/mic:mmlite-spec/mic:interface-group)"/>-<xsl:value-of select="format-number(position() - 1, '0')"/></xsl:attribute>
          </MTN>
        </xsl:for-each>
      </MTN>
    </MTN>
  </xsl:template>
</xsl:stylesheet>
