<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Generate table of contents, MSDN style. -jvh 2000 -->
<!-- Reverse map stuff (generates map.inc).  Same structure as gentoc2.xslt -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template (for copying html tags) -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>
  <xsl:template match="/">
    <L url="interfaces.htm" pth="toc-2" />
      <xsl:for-each select="//mic:interface-group">
        <xsl:variable name="current-group-ix" select="position()"/>
          <xsl:for-each select="//mic:interface[@mygroup = current()/@name]">
            <L>
              <xsl:attribute name="url" ><xsl:value-of select="@name" />.htm</xsl:attribute>
              <xsl:attribute name="pth">toc-2-<xsl:value-of select="format-number($current-group-ix - 1, '0')"/>-<xsl:value-of select="format-number(position() - 1, '0')"/></xsl:attribute>
            </L>
          </xsl:for-each>
      </xsl:for-each>
        <xsl:for-each select="//mic:concrete-class" >
          <L>
            <xsl:attribute name="url" ><xsl:value-of select="@name"/>.htm</xsl:attribute>
            <xsl:attribute name="pth" >toc-2-<xsl:value-of select="count(//mic:interface-group)"/>-<xsl:value-of select="format-number(position() - 1, '0')"/></xsl:attribute>
          </L>
        </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
