<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Add this-arg expansion -jvh 2000 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="text" indent="yes" omit-xml-declaration="yes"/>

  <!-- token define -->
  <xsl:template match="mic:method" mode="token" xml:space="preserve">
#define TOKEN_<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_MET <xsl:value-of select="@iface-index"/></xsl:template>

  <xsl:template match="mic:struct" mode="token" xml:space="preserve">
#define TOKEN_<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_STRUCT <xsl:value-of select="@iface-index"/></xsl:template>

  <xsl:template match="mic:method-response" mode="token" xml:space="preserve">#define TOKEN_<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_response_MET <xsl:value-of select="@iface-index"/></xsl:template>

  <xsl:template match="mic:arg|mic:field" mode="token" xml:space="preserve">#define TOKEN_<xsl:value-of select="../../@name"/>_<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_ARG <xsl:value-of select="@iface-index"/></xsl:template>

<!-- allow some punctuation in QNAMEs, convert to underscores -->
  <xsl:template match="mic:string-entry" mode="token" xml:space="preserve">#define TOKEN_<xsl:value-of select="../@name"/>_<xsl:value-of select="translate(text(), '/*-+=.,?$^!:;#', '_________________')"/> <xsl:value-of select="@iface-index"/></xsl:template>

  <!-- top level template -->
  <xsl:template match="/" xml:space="preserve">

<xsl:for-each select="//mic:interface">
/* @FILE:<xsl:value-of select="@name"/> */
<xsl:for-each select="mic:namespace">#define NS_<xsl:value-of select="../@name"/>_ifd_namespace_<xsl:value-of select="@prefix"/> <xsl:value-of select="@token"/>
</xsl:for-each><xsl:for-each select="mic:method|mic:method-response"><xsl:apply-templates select="." mode="token"/>
<xsl:for-each select="mic:arg[parent::mic:method]"><xsl:apply-templates select="." mode="token"/>
</xsl:for-each></xsl:for-each>
<xsl:for-each select="mic:struct"><xsl:apply-templates select="." mode="token"/>
<xsl:for-each select="mic:field"><xsl:apply-templates select="." mode="token"/>
</xsl:for-each></xsl:for-each><xsl:for-each select="mic:string-entry"><xsl:apply-templates select="." mode="token"/>
</xsl:for-each></xsl:for-each>
</xsl:template>

</xsl:stylesheet>

