<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Add this-arg expansion -jvh 2000 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="text" indent="yes" omit-xml-declaration="yes"/>

  <!-- arg/field descriptor common -->
  <xsl:template match="mic:field|mic:arg" mode="item-helper"><xsl:variable name="type-ns"><xsl:choose><xsl:when test="contains(@type, ':')"><xsl:value-of select="substring-before(@type, ':')"/></xsl:when><xsl:otherwise><xsl:value-of select="../../@name"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="type-local"><xsl:choose><xsl:when test="contains(@type, ':')"><xsl:value-of select="substring-after(@type, ':')"/></xsl:when><xsl:otherwise><xsl:value-of select="@type"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:if test="not(contains(@xname, ':'))"><xsl:value-of select="../../@name"/>_<xsl:value-of select="../../mic:string-entry[text() = current()/@xname]/@iface-index"/>.Str /*<xsl:value-of select="@xname"/>*/</xsl:if><xsl:if test="contains(@xname, ':')">_T("<xsl:value-of select="@xname"/>")</xsl:if>, <xsl:value-of select="../../mic:string-entry[text() = current()/@name]/@iface-index"/>, TOKEN_invalid, <xsl:choose><xsl:when test="@type-tag = 'ARG_STRUCT' or @type-tag = 'ARG_LISTHEAD'">&amp;<xsl:value-of select="$type-ns"/>_iface_table[<xsl:value-of select="//mic:interface[@name = $type-ns]/mic:struct[@name = $type-local or @ptype = $type-local]/@iface-index"/>]</xsl:when><xsl:otherwise>NULL</xsl:otherwise></xsl:choose>,
     <xsl:apply-templates select="." mode="flags"/>,
     <xsl:value-of select="@iface-index"/>, <xsl:value-of select="@type-tag"/>,</xsl:template>

  <xsl:template match="mic:field|mic:arg" mode="item-helper-2"><xsl:variable name="type-ns"><xsl:choose><xsl:when test="contains(@type, ':')"><xsl:value-of select="substring-before(@type, ':')"/></xsl:when><xsl:otherwise><xsl:value-of select="../../@name"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="type-local"><xsl:choose><xsl:when test="contains(@type, ':')"><xsl:value-of select="substring-after(@type, ':')"/></xsl:when><xsl:otherwise><xsl:value-of select="@type"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:value-of select="@array"/><xsl:if test="@list">offsetof(struct <xsl:value-of select="//mic:interface[@name = $type-ns]/mic:struct[@ptype = $type-local or @type = $type-local]/mic:field[@type = 'LISTNODE' and @name = current()/@list]/../@name"/>, <xsl:value-of select="@list"/>)</xsl:if><xsl:if test="not(@list) and not(@array)">0</xsl:if>, <xsl:value-of select="@type-is-pos"/>+0, <xsl:value-of select="@selector-is-pos"/>+0, <xsl:value-of select="@size-is-pos"/>+0, <xsl:value-of select="@length-is-pos"/>+0, <xsl:choose><xsl:when test="contains(@type, ':')">(void*) &amp;<xsl:value-of select="substring-before(@type, ':')"/>_ifd_namespace_<xsl:value-of select="id(substring-before(@type, ':'))/mic:namespace/@prefix"/></xsl:when><xsl:otherwise>NULL</xsl:otherwise></xsl:choose></xsl:template>

  <!-- field descriptor -->
  <xsl:template match="mic:field" mode="item">
    {FE, <xsl:apply-templates select="." mode="item-helper"/>
     offsetof(struct <xsl:value-of select="../@name"/>, <xsl:value-of select="@name"/>), <xsl:apply-templates select="." mode="item-helper-2"/>},</xsl:template>

  <!-- arg descriptor -->
  <xsl:template match="mic:arg" mode="item">
    {AE, <xsl:apply-templates select="." mode="item-helper"/><xsl:if test="@is-return-value">0</xsl:if><xsl:if test="not(@is-return-value)"> offsetof(struct _<xsl:value-of select="../../@name"/>_<xsl:value-of select="../@name"/>_METHOD_FRAME, _<xsl:value-of select="@name"/>_)</xsl:if>, <xsl:apply-templates select="." mode="item-helper-2"/> },</xsl:template>

  <!-- method descriptor -->
  <xsl:template match="mic:method" mode="item">
    {ME<xsl:if test="@ctype = 'SCODE'">s</xsl:if><xsl:if test="@serialize-as = 'text()' or substring(@serialize-as,1,1) = '!' or contains(@serialize-as, '/')">n</xsl:if><xsl:if test="@cimcompat = 'true'">c</xsl:if>, <xsl:value-of select="../@name"/>_<xsl:value-of select="../mic:string-entry[text() = current()/@xname]/@iface-index"/>.Str, <xsl:value-of select="../mic:string-entry[text() = current()/@xname]/@iface-index"/>, <xsl:if test="@type = 'none'">TOKEN_invalid</xsl:if><xsl:value-of select="../mic:string-entry[text() = current()/@responsename]/@iface-index"/>, <xsl:choose><xsl:when test="mic:arg">&amp;<xsl:value-of select="../@name"/>_iface_table[<xsl:value-of select="mic:arg/@iface-index"/>],
        </xsl:when><xsl:otherwise>NULL,</xsl:otherwise></xsl:choose> <xsl:value-of select="count(mic:arg)"/>, <xsl:value-of select="@iface-index"/>, DESCR_TYPE_METHOD,
        sizeof(struct _<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_FRAME),
        <xsl:value-of select="@stacksize"/>+0, 0,0, <xsl:if test="@convention = '__stdcall'">sizeof(struct _<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_FRAME) XXX-untested-__stdcall-adjustment-calculation-XXX</xsl:if>+0, <xsl:value-of select="@ordinal"/>, <xsl:if test="@responsename">(void*)<xsl:value-of select="../@name"/>_<xsl:value-of select="../mic:string-entry[text() = current()/@responsename]/@iface-index"/>.Str</xsl:if><xsl:if test="not(@responsename)">NULL</xsl:if>},</xsl:template>

  <!-- method response descriptor -->
  <xsl:template match="mic:method-response" mode="item">
    {ME<xsl:if test="@type = 'SCODE'">s</xsl:if><xsl:if test="@serialize-as = 'text()' or substring(@serialize-as,1,1) = '!'">n</xsl:if>, <xsl:value-of select="../@name"/>_<xsl:value-of select="../mic:string-entry[text() = current()/@responsename]/@iface-index"/>.Str, <xsl:value-of select="../mic:string-entry[text() = current()/@responsename]/@iface-index"/>, TOKEN_invalid, <xsl:choose><xsl:when test="mic:arg">&amp;<xsl:value-of select="../@name"/>_iface_table[<xsl:value-of select="mic:arg/@iface-index"/>],
        </xsl:when><xsl:otherwise>NULL,</xsl:otherwise></xsl:choose> <xsl:value-of select="count(mic:arg)"/>, <xsl:value-of select="@iface-index"/>, DESCR_TYPE_METHOD_RESPONSE,
        sizeof(struct _<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_FRAME),
        <xsl:value-of select="@stacksize"/>+0, 0,0, <xsl:if test="@convention = '__stdcall'">sizeof(struct _<xsl:value-of select="../@name"/>_<xsl:value-of select="@name"/>_METHOD_FRAME) XXX-untested-__stdcall-adjustment-calculation-XXX</xsl:if>+0, <xsl:value-of select="@ordinal"/>, NULL},</xsl:template>

  <!-- struct descriptor -->
  <xsl:template match="mic:struct" mode="item">
    {SE<xsl:if test="@serialize-as = 'text()' or substring(@serialize-as,1,1) = '!'">n</xsl:if>, <xsl:value-of select="../@name"/>_<xsl:value-of select="../mic:string-entry[text() = current()/@xname]/@iface-index"/>.Str, <xsl:value-of select="../mic:string-entry[text() = current()/@xname]/@iface-index"/>, TOKEN_invalid, &amp;<xsl:value-of select="../@name"/>_iface_table[<xsl:value-of select="mic:field/@iface-index"/>], <xsl:value-of select="@fieldcount"/>, <xsl:value-of select="@iface-index"/>, DESCR_TYPE_STRUCT,
     sizeof(struct <xsl:value-of select="@name"/>), 0,0,0,0,0, NULL},</xsl:template>

  <!-- interface extras descriptor (not part of table) -->
  <xsl:template match="mic:interface" mode="extra_item">PRIVATE const struct _INTERFACE_EXTRAS <xsl:value-of select="@name" />_ifd_extras = {
    <xsl:choose><xsl:when test="mic:namespace">&amp;<xsl:value-of select="@name" />_ifd_namespace_<xsl:value-of select="mic:namespace/@prefix"/></xsl:when><xsl:otherwise>NULL</xsl:otherwise></xsl:choose>, &amp;IID_<xsl:value-of select="@name"/>, <xsl:choose><xsl:when test="@extends and @extends != 'IUnknown'">&amp;<xsl:value-of select="@extends"/>_iface_table[0]</xsl:when><xsl:otherwise>NULL</xsl:otherwise></xsl:choose>, NULL, <xsl:value-of select="@iface-index-count"/>};</xsl:template>

  <!-- interface descriptor -->
  <xsl:template match="mic:interface" mode="item">
    {IE, <xsl:value-of select="@name"/>_<xsl:value-of select="mic:string-entry[text() = current()/@name]/@iface-index"/>.Str, <xsl:value-of select="mic:string-entry[text() = current()/@name]/@iface-index"/>, TOKEN_invalid, &amp;<xsl:value-of select="@name"/>_iface_table[1], <xsl:value-of select="@iface-index-count"/>, 0, DESCR_TYPE_INTERFACE, 0,0,0,0,0,0, &amp;<xsl:value-of select="@name"/>_ifd_extras},</xsl:template>

  <!-- namespace descriptor declaration -->
  <xsl:template match="mic:interface/mic:namespace" mode="declare">extern const struct XMLNAMESPACE <xsl:value-of select="../@name" />_ifd_namespace_<xsl:value-of select="@prefix"/>;
</xsl:template>

  <!-- interface descriptor declaration -->
  <xsl:template match="mic:interface" mode="declare">extern const struct _METHOD_DESCR  <xsl:value-of select="@name" />_iface_table[<xsl:value-of select="@iface-index-count"/>];
</xsl:template>

  <!-- helper to print prev-iface/@name. I don't know why it was so hard! -->
  <xsl:template match="mic:interface" mode="prevname"><xsl:variable name="x" select="count(preceding-sibling::mic:interface)"/><xsl:value-of select="//mic:interface[$x]/@name" /></xsl:template>

  <!-- namespace descriptor (not part of table) -->
  <xsl:template match="mic:interface/mic:namespace">const struct XMLNAMESPACE <xsl:value-of select="../@name" />_ifd_namespace_<xsl:value-of select="@prefix"/> = {
    XE, _T("<xsl:value-of select='@prefix'/>"), _T("<xsl:value-of select='text()'/>"), NSTYPE_<xsl:value-of select="@type"/>, NS_<xsl:value-of select="../@name" />_ifd_namespace_<xsl:value-of select="@prefix"/>, <xsl:value-of select="string-length(text())"/><xsl:if test="@uri-skip-suffix">-<xsl:value-of select="string-length(@uri-skip-suffix)"/></xsl:if>, &amp;<xsl:value-of select="../@name"/>_iface_table[0], (CPNS_TABLE) &amp;<xsl:value-of select="../@name"/>_ns_table,
    <xsl:choose><xsl:when test="following-sibling::mic:namespace"><!--link to next ns in this iface-->&amp;<xsl:value-of select="../@name" />_ifd_namespace_<xsl:value-of select="following-sibling::mic:namespace/@prefix"/></xsl:when><xsl:when test="../following-sibling::mic:interface"><!--&amp;<xsl:value-of select="../following-sibling::mic:interface/@name"/>_ifd_namespace_<xsl:value-of select="../following-sibling::mic:interface/mic:namespace/@prefix"/>-->NULL</xsl:when><xsl:otherwise>PREDEFINED_NAMESPACES</xsl:otherwise></xsl:choose>};
</xsl:template>

  <!-- string descriptor declaration -->
<xsl:template match="mic:string-entry" mode="declare" xml:space="preserve">
struct _<xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/>;
extern const struct _<xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/> <xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/>;</xsl:template>

  <!-- strings as separate entries -->
  <xsl:template match="mic:interface" mode="entries">/* string entries */
<xsl:for-each select="mic:string-entry[@inheritance-depth = 0]">const struct _<xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/> {ANY_ENTRY any; _TCHAR Str[sizeof(_T("<xsl:value-of select='text()'/>"))];} <xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/> = {TE<xsl:if test="@qualified = 'no'">u</xsl:if>, _T("<xsl:value-of select='text()'/>")};
</xsl:for-each>

</xsl:template>

  <xsl:template match="mic:interface" mode="entries">/* string entries */
<xsl:for-each select="mic:string-entry[@inheritance-depth = 0]">const struct _<xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/> {ANY_ENTRY any; _TCHAR Str[sizeof(_T("<xsl:value-of select='text()'/>"))];} <xsl:value-of select="../@name" />_<xsl:value-of select="@iface-index"/> = {TE<xsl:if test="@qualified = 'no'">u</xsl:if>, _T("<xsl:value-of select='text()'/>")};
</xsl:for-each>

</xsl:template>

  <!-- string entry reference -->
  <xsl:template match="mic:interface/mic:string-entry" mode="entry-ref">
    (CPANY_ENTRY) &amp;<xsl:value-of select="@interface-name" />_<xsl:value-of select="@iface-index"/>, /* string: <xsl:value-of select="text()"/> */</xsl:template>

<!-- allow some punctuation in QNAMEs, convert to underscores -->
  <xsl:template match="mic:string-entry" mode="token" xml:space="preserve">#define TOKEN_<xsl:value-of select="../@name"/>_<xsl:value-of select="translate(text(), '/*-+=.,?$^!:;#', '_________________')"/> <xsl:value-of select="@iface-index"/></xsl:template>

  <!-- Figure out Flags field -->
  <xsl:template match="*" mode="flags">0<xsl:if test="@direction = 'in'">|IN</xsl:if><xsl:if test="@direction = 'out'">|OUT</xsl:if><xsl:if test="@direction = 'inout'">|IN|OUT</xsl:if><xsl:if test="@is-return-value = 'true'">|ARGUMENT_DESCR_FLAGS_RETURN</xsl:if><xsl:if test="@size-of|@length-of|@type-of|@selector-of">|ARGUMENT_DESCR_FLAGS_MODIFIER_OF</xsl:if><xsl:if test="@optional = 'true'">|ARGUMENT_DESCR_FLAGS_OPTIONAL</xsl:if><xsl:if test="@byref = 'true'">|ARGUMENT_DESCR_FLAGS_BYREF</xsl:if><xsl:if test="@is-array">|ARGUMENT_DESCR_FLAGS_ARRAY</xsl:if><xsl:if test="@serialize-as = 'text()' or @serialize-as = '@wsa:To' or substring(@serialize-as,1,1) = '!'">|ARGUMENT_DESCR_FLAGS_TEXT</xsl:if><xsl:if test="@serialize-as = 'none()'">|ARGUMENT_DESCR_FLAGS_NONE</xsl:if><xsl:if test="substring(@serialize-as,1,1) = '@'">|ARGUMENT_DESCR_FLAGS_ATTRIBUTE</xsl:if><xsl:if test="@serialize-as = '!HEADER'">|ARGUMENT_DESCR_FLAGS_HEADER</xsl:if><xsl:if test="@serialize-as = '!BIN'">|ARGUMENT_DESCR_ENC_BIN</xsl:if><xsl:if test="@serialize-as = '!CDATA'">|ARGUMENT_DESCR_ENC_CDATA</xsl:if><xsl:if test="substring(@serialize-as,1,5) = '!cid:' or substring(@serialize-as,1,5) = '!cim:'">|ARGUMENT_DESCR_ENC_XOP</xsl:if></xsl:template>

  <!-- Output ns table entries for one interface -->
  <xsl:template match="mic:interface" mode="nstable">
    <xsl:variable name="current-interface" select="."/>
    <xsl:apply-templates select="id(@extends)" mode="nstable"/>
<xsl:for-each select="(*|mic:method/*|mic:struct/*)[@iface-index][not(@inheritance-depth) or @inheritance-depth = 0]"><xsl:sort select="@iface-index" data-type="number"/><xsl:choose><xsl:when test="name() = 'string-entry'"><xsl:apply-templates select="." mode="entry-ref"/></xsl:when><xsl:otherwise>
    (CPANY_ENTRY) &amp;<xsl:value-of select="$current-interface/@name"/>_iface_table[<xsl:value-of select="@iface-index"/>], /* <xsl:value-of select="name()"/>: <xsl:value-of select="@name"/> */</xsl:otherwise></xsl:choose></xsl:for-each>
  </xsl:template>

  <!-- top level template -->
  <xsl:template match="/" xml:space="preserve">

<xsl:for-each select="//mic:interface"><xsl:variable name="current-interface" select="."/>/* @FILE:<xsl:value-of select="$current-interface/@name"/> */
/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Automatically generated metadata for <xsl:value-of select="@name"/> */
#include "web/gentypeinfo.h"
<xsl:choose><xsl:when test="$current-interface/@original-file">#include
"<xsl:value-of select='@original-file'/>.h"
</xsl:when><xsl:when test="id($current-interface/@mygroup)/@original-file">#include "<xsl:value-of select='id($current-interface/@mygroup)/@original-file'/>.h"
</xsl:when></xsl:choose>
<xsl:for-each select="//mic:interface">#include "s_<xsl:value-of select='@name'/>_t.h"
</xsl:for-each>

/* Namespaces */
<xsl:for-each select="//mic:interface"><xsl:apply-templates select="mic:namespace" mode="declare"/><xsl:apply-templates select="." mode="declare"/>
</xsl:for-each>

<xsl:for-each select="//mic:interface[mic:namespace]"><xsl:apply-templates select="mic:string-entry[@inheritance-depth = 0]" mode="declare"/></xsl:for-each>

<xsl:apply-templates select="." mode="entries"/>

/* Interface extras */
<xsl:apply-templates select="." mode="extra_item"/>

/* Interface table */
const struct _METHOD_DESCR <xsl:value-of select="@name"/>_iface_table[<xsl:value-of select="@iface-index-count"/>]  = {
    /* Interface */<xsl:apply-templates select="." mode="item"/>
    /* Methods */<xsl:apply-templates select="mic:method|mic:method-response" mode="item"/>
    /* Structs */<xsl:apply-templates select="mic:struct" mode="item"/>
    /* Method args */<xsl:apply-templates select="mic:method/mic:arg" mode="item"/>
    /* Struct fields */<xsl:apply-templates select="mic:struct/mic:field" mode="item"/>
};

/* NS table */
PRIVATE const struct {
    ANY_ENTRY any; INT Count; CPANY_ENTRY Table[<xsl:value-of select="@iface-index-count + @inherited-count + count(mic:string-entry[@inheritance-depth = 0])"/>];
} <xsl:value-of select="@name"/>_ns_table = {
    NE, <xsl:value-of select="@iface-index-count + @inherited-count + count(mic:string-entry[@inheritance-depth = 0])"/>, {
    (CPANY_ENTRY) &amp;<xsl:value-of select="$current-interface/@name"/>_iface_table[0],
<xsl:apply-templates select="." mode="nstable"/>
}};

/* Namespaces */
<xsl:apply-templates select="mic:namespace"/>

</xsl:for-each>

/* @FILE:typeinfo */
#include "web/gentypeinfo.h"

<xsl:apply-templates select="mic:namespace" mode="declare"/>
<xsl:apply-templates select="mic:interface[mic:namespace]" mode="declare"/>

/* Typeinfo struct */
struct TypeInfo __gentypeinfo = {
    &amp;<xsl:value-of select="//mic:interface/@name"/>_iface_table[0], <xsl:value-of select="count(//mic:interface)"/>,
    &amp;<xsl:value-of select="//mic:interface/@name"/>_ifd_namespace_<xsl:value-of select="//mic:interface/mic:namespace/@prefix"/>
};

</xsl:template>

</xsl:stylesheet>

