<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Munge spec into soap typeinfo, pre-pass
   - Zap non-remotable items from structs.
   - Zap non-remotable extended methods (IUnknown)
   - Zap other unnecessary stuff.
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>

  <!-- Filter out non-remotable elements -->
  <xsl:template match="mic:field[@serialize-as = 'none()']" />
  <xsl:template match="mic:interface[@name = 'IUnknown']"/>

  <!-- Filter out other stuff that is not needed for metadata -->
  <xsl:template match="comment()" />
  <xsl:template match="mic:P|mic:discussion|mic:notes|mic:see-also|mic:example" />
  <xsl:template match="mic:concrete-class|mic:component-group|mic:component|mic:profile|mic:product|mic:hardware-platform|mic:device|mic:toc-item" />
  <xsl:template match="mic:method-group|mic:return-value" />
  <xsl:template match="mic:constant|mic:extended-by|mic:implemented-by" />
  <xsl:template match="@doptype|@dotype|@documentation-only" />

  <!-- No metadata for struct forward defs -->
  <xsl:template match="mic:struct[not(mic:field)]" />

</xsl:stylesheet>
