<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Munge spec into soap typeinfo, part 2
   - Do uniq on string tables and add indexes to them
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

  <!-- Identity transformation template -->
  <xsl:template match="@*|/|node()"><xsl:copy><xsl:apply-templates select="@*|*|comment()|processing-instruction()|text()"></xsl:apply-templates></xsl:copy></xsl:template>

  <xsl:template match="mic:interface">
    <xsl:variable name="base">
      <!-- Add @iface-index - of total count of stuff in interface -->
      <xsl:value-of select="@iface-index-count + @inherited-count"/></xsl:variable>

    <xsl:copy>
      <xsl:apply-templates select="@*|node()[not(self::mic:string-entry)]"></xsl:apply-templates>

      <xsl:for-each select="mic:string-entry[@inheritance-depth = 0]">
        <xsl:copy>
          <xsl:attribute name="iface-index"><xsl:value-of select="position() - 1 + $base"/></xsl:attribute>
          <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
      </xsl:for-each>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
