<?xml version='1.0' encoding="iso-8859-1" ?>
<!-- Copyright (c) Microsoft Corporation. All rights reserved. -->
<!-- Generate filled in method table for concrete classes -jvh 2000 -->
<!-- Extended to generate class and component descriptors -jvh 2006 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:mic="x-schema:expanded-schema.xml">
  <xsl:output method="text"/>

  <!-- output function prototypes -->
  <xsl:template match="mic:concrete-class" mode="protos" xml:space="preserve"><xsl:variable name="current-class" select="."/><xsl:for-each select="mic:implements"><xsl:variable name="iface" select="text()"/><xsl:variable name="current-implements" select="."/><xsl:for-each select="../mic:implements-method"><xsl:if test="@implemented-interface = $iface and not($current-implements/following-sibling::mic:implements/@prefix = @implementation-prefix) and not($current-implements/preceding-sibling::mic:implements/@prefix = @implementation-prefix) and @implementation-name != 'NULL' and @implementation-name != 'UNIMPLEMENTED' and @manual-declare != 'true'">
#ifndef <xsl:value-of select="@implementation-name"/>
<xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if><xsl:if test="not(@private = 'false')">PRIVATE </xsl:if>_<xsl:value-of select="@implemented-interface"/>_<xsl:value-of select="@name"/>_METHOD_FUNC <xsl:value-of select="@implementation-name"/>;<xsl:if test="mic:ifdef">
#endif</xsl:if>
#endif</xsl:if></xsl:for-each></xsl:for-each></xsl:template>

  <!-- Top level template for printing vtabs -->
  <xsl:template match="/" xml:space="preserve">#include "mmlite.h"
    <xsl:for-each select="//mic:concrete-class"><xsl:variable name="current-class" select="."/><xsl:variable name="IsDesc" select="$current-class/mic:inherited-class[text() = 'CUnknown']"/>
/* @FILE:<xsl:value-of select="@name"/> */
/********************** <xsl:value-of select="@name"/> **********************/
<xsl:if test="$IsDesc">#include "base/cobdesc.h"

</xsl:if><xsl:apply-templates select="." mode="protos"/>
<xsl:if test="$IsDesc">
extern const CLASSDESC(<xsl:value-of select="$current-class/@name"/>, <xsl:value-of select="count($current-class/mic:inherits-interface)"/>);
</xsl:if><xsl:for-each select="mic:implements"><xsl:variable name="iface" select="text()"/><xsl:variable name="current-implements" select="."/>
<xsl:if test="$current-class[@binding = 'compile']">const </xsl:if>struct <xsl:if test="$IsDesc"> {
    const struct <xsl:value-of select="$current-class/@name"/>_ClassDesc *classd;
    <xsl:if test="$current-class[@binding = 'compile']">const </xsl:if>struct <xsl:value-of select="."/>Vtbl v;
}</xsl:if><xsl:if test="not($IsDesc)"><xsl:value-of select="text()"/>Vtbl</xsl:if> <xsl:value-of select="@vtable-implementation-name"/> = <xsl:if test="$IsDesc">{&amp;<xsl:value-of select="$current-class/@name"/>_ClassDesc, </xsl:if>{
    __VTABLE_COMPATIBILITY_FILLER_INITIALIZER<xsl:for-each select="../mic:implements-method"><!-- filter out methods belonging to other v-table --><xsl:if test="(@implemented-interface = $iface and not($current-implements/following-sibling::mic:implements/@prefix = @implementation-prefix) and not($current-implements/preceding-sibling::mic:implements/@prefix = @implementation-prefix)) or ((@extended-interface = 'IUnknown' or @interface-name = 'IUnknown') and  (@implementation-class = 'CUnknown' or @implementation-class = 'DefCob'))">
<xsl:if test="mic:ifdef">#if <xsl:value-of select="mic:ifdef"/>
</xsl:if>   <xsl:if test="(@interface-name != $iface and @implementation-class != ../@name and @implementation-name != 'NULL') or @implementation-name = 'UNIMPLEMENTED'"> (_<xsl:value-of select="$iface"/>_<xsl:value-of select="@name"/>_METHOD_TYPE)</xsl:if> <xsl:value-of select="@implementation-name"/><xsl:if test="@implementation-name = 'UNIMPLEMENTED'">Method<xsl:if test="@type = 'SCODE'">SCODE</xsl:if><xsl:if test="@type != 'SCODE'">Zero</xsl:if></xsl:if><xsl:if test="position()!=last()">,</xsl:if><xsl:if test="mic:ifdef">
#else
    NULL<xsl:if test="position()!=last()">,</xsl:if>
#endif</xsl:if></xsl:if></xsl:for-each>
<xsl:if test="$IsDesc">}</xsl:if>};
</xsl:for-each><xsl:if test="$IsDesc">
#ifndef <xsl:value-of select="$current-class/@name"/>Destroy
PRIVATE Destroy_METHOD_FUNC <xsl:value-of select="$current-class/@name"/>Destroy;
#endif

const struct <xsl:value-of select="$current-class/@name"/>_ClassDesc <xsl:value-of select="$current-class/@name"/>_ClassDesc = {
    _T("<xsl:value-of select='$current-class/@name'/>"), &amp;IID_IUnknown,
    _T("<xsl:value-of select='$current-class/@super-class'/>"), &amp;IID_IUnknown,
    <xsl:value-of select="$current-class/@name"/>Destroy,
    sizeof(<xsl:value-of select="$current-class/@name"/>),
    <xsl:value-of select="count($current-class/mic:inherits-interface)"/>, {
<xsl:for-each select="$current-class/mic:inherits-interface">        {(struct IUnknownVtbl*) &amp;<!--XXX does not work for multiple inheritance--><xsl:value-of select="$current-class/mic:implements[@prefix = current()/@prefix]/@vtable-implementation-name"/>.v, &amp;IID_<xsl:value-of select="text()"/>, <xsl:value-of select="count(id(.)/mic:method|id(.)/mic:extended-method)"/>, <xsl:choose><xsl:when test="not($current-class/mic:implements[1][@prefix = current()/@prefix])"><!--not first v-->offsetof(struct _<xsl:value-of select="$current-class/@name"/>, <xsl:value-of select="$current-class/mic:implements[@prefix = current()/@prefix]/@vtable-name"/>)</xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>},
</xsl:for-each>    }
};</xsl:if><xsl:if test="$current-class/mic:inherited-class = 'DefCob'"><!-- Assumes that the parent is mic:component XXX but I had difficulties writing the XPath test to verify that -->

<xsl:for-each select="$current-class/../mic:concrete-class[. != $current-class]">extern const struct <xsl:value-of select="@name"/>_ClassDesc <xsl:value-of select="@name"/>_ClassDesc;
</xsl:for-each>
const COBDESC(<xsl:value-of select="$current-class/../@name"/>, <xsl:value-of select="count($current-class/../mic:concrete-class)"/>);

const struct <xsl:value-of select="$current-class/../@name"/>_CobDesc <xsl:value-of select="$current-class/../@name"/>_CobDesc = {
    _T("<xsl:value-of select='$current-class/../@name'/>"),
    <xsl:value-of select="count($current-class/../mic:concrete-class)"/>, {<xsl:for-each select="$current-class/../mic:concrete-class">
        (struct _ClassDesc *) &amp;<xsl:value-of select="@name"/>_ClassDesc,</xsl:for-each>
    }
};

#ifndef _MANUAL_COBMAIN
PIUNKNOWN <xsl:value-of select="$current-class/../@name"/>CobMain(void)
{
    //TRACE("<xsl:value-of select='$current-class/../@name'/>CobMain()\n");
    return GenericCobInit((void*) &amp;<xsl:value-of select="$current-class/../@name"/>_CobDesc, NULL);
}
#endif
</xsl:if></xsl:for-each></xsl:template>

</xsl:stylesheet>
