# Copyright (c) Microsoft Corporation. All rights reserved.
#
SUBDIR=conf

!include $(MMLITE_SDK)/conf/make/first.mk

!if exist ($(SRC_DIR)\private.mk)
# define globally in this directory that privates are included
CC_FLAGS=$(CC_FLAGS) $(CC_DEF)_WITH_PRIVATE_INCLUDES=1
!endif

# Get generated makefile fragments
!include $(OBJECT_DIR)\s_iids.mk
!include $(OBJECT_DIR)\INCLUDE_FILES.mk
!include $(OBJECT_DIR)\VTAB_FILES.mk
!include $(OBJECT_DIR)\TYPEINFO_OBJS.mk
!include $(OBJECT_DIR)\TOKEN_FILES.mk
!include $(OBJECT_DIR)\PACKAGE_C_FILES.mk

MKFILES=s-imp.mk

TARGETS= $(INCLUDE_FILES) $(VTAB_FILES) $(TOKEN_FILES) $(PACKAGE_C_FILES) \
    $(LIBRARY_DIR)\iids.lib $(LIBRARY_DIR)\typeinfo.lib \
    $(MKFILES)

!include $(MMLITE_SDK)/conf/common.mk

$(LIBRARY_DIR)\iids.lib: iids.$(O) $(IIDOBJS)
$(LIBRARY_DIR)\typeinfo.lib: typeinfo.$(O) $(TYPEINFO_OBJS)

$(MKFILES): always
    $(_SILENT)nmake /nologo $(DEFAULT_MAKE_ARGS) -f $@ all SRC_DIR=$(OBJ_DIR)

always:
