/* Copyright (c) Microsoft Corporation. All rights reserved. */
#ifndef _IMPORT_WINDOWS_H_
#define _IMPORT_WINDOWS_H_

/* Get INT16 type */
#include <mmlite_md.h>

/* Turn off warnings generated with -W4 on windows includes.
 * One warning (4142) is needed later because of int/long conflicts,
 * but the rest are temporary.
 */
#pragma warning(disable:4142)   /* benign redefinition of type */

#pragma warning(push)
#pragma warning(disable:4201)   /* nameless struct union */
#pragma warning(disable:4214)   /* bitfield other than int */
#pragma warning(disable:4514)
#pragma warning(disable:4115)   /* named type definition in parentheses */

typedef INT16 WCHAR, *PWCHAR, wchar_t;

#define WIN32_LEAN_AND_MEAN
#define NOMCX
#define NOIME
/* BUGBUG: Our SDK\windef.h sets WINVER to 0x0500, but our
   SDK\windows.h spits out a big warning if WINVER >= 0x0500, so do we
   need to refresh our SDK header files in order to remove this WINVER
   hack? -JP */
#define WINVER 0x0400

/* winbase.h depends on UNICODE without an underscore. Define that too. */
#ifdef _UNICODE
#define UNICODE 1
#endif

/* wchar.h must be included first with VC8 */
#include <wchar.h>

/*  Avoid an unnecessary incompatibility with struct IID in guiddef.h
 */
#define IID ___bogus_IID

#undef DebugBreak
#include <windows.h>

#undef IID
#undef REFIID

#pragma warning(pop)

/* These OLE macros have the same value but are defined differently.
 * Simply undef them to quiet compiler.
 */
#undef S_OK
#undef S_FALSE
#undef E_FAIL
#undef E_OUTOFMEMORY

#endif  /* _IMPORT_WINDOWS_H_ */
