/* Copyright (c) Microsoft Corporation. All rights reserved. */
#ifndef _INC_STRING
#define _INC_STRING

#define __NEEDS_SIZE_T 1
#define __NEEDS_NULL 1
#include <__defs.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Function prototypes */

void *  __cdecl memcpy(void *, const void *, size_t);
int     __cdecl memcmp(const void *, const void *, size_t);
void *  __cdecl memset(void *, int, size_t);
char *  __cdecl _strset(char *, int);
char *  __cdecl strcpy(char *, const char *);
char *  __cdecl strcat(char *, const char *);
int     __cdecl strcmp(const char *, const char *);
size_t  __cdecl strlen(const char *);
void *  __cdecl _memccpy(void *, const void *, int, unsigned int);
void *  __cdecl memchr(const void *, int, size_t);
int     __cdecl _memicmp(const void *, const void *, unsigned int);
void *  __cdecl memmove(void *, const void *, size_t);


char *  __cdecl strchr(const char *, int);
int     __cdecl _strcmpi(const char *, const char *);
int     __cdecl _stricmp(const char *, const char *);
int     __cdecl strcoll(const char *, const char *);
int     __cdecl _stricoll(const char *, const char *);
int     __cdecl _strncoll(const char *, const char *, size_t);
int     __cdecl _strnicoll(const char *, const char *, size_t);
size_t  __cdecl strcspn(const char *, const char *);
char *  __cdecl _strdup(const char *);
char *  __cdecl _strndup(const char *, size_t);
char *  __cdecl _strerror(const char *);
char *  __cdecl strerror(int);
char *  __cdecl _strlwr(char *);
char *  __cdecl strncat(char *, const char *, size_t);
int     __cdecl strncmp(const char *, const char *, size_t);
int     __cdecl _strnicmp(const char *, const char *, size_t);
char *  __cdecl strncpy(char *, const char *, size_t);
char *  __cdecl _strnset(char *, int, size_t);
char *  __cdecl strpbrk(const char *, const char *);
char *  __cdecl strrchr(const char *, int);
char *  __cdecl _strrev(char *);
size_t  __cdecl strspn(const char *, const char *);
char *  __cdecl strstr(const char *, const char *);
char *  __cdecl strtok(char *, const char *);
char *  __cdecl _strupr(char *);
size_t  __cdecl strxfrm (char *, const char *, size_t);

/* Additional functions */
char * __cdecl _strsplit(char *s1, const char *delimit);
/*BOOL*/ int _strnequal(const char *s1, size_t l1, const char *s2, size_t l2);

#ifdef __cplusplus
}
#endif

#endif  /* _INC_STRING */
