/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Object that represents remote object -jvh */

#include <web/typeinfo.h>
#include <util/list-double2.h>
#include <wsif.h>

#if defined(_MSC_VER) && !defined(arm)
/* Only 386 VC++ */
#else
#define __fastcall
#define __stdcall
#endif

/* Set when pContext was entirely allocated in a single call 
 * and must be freed when the proxy is released:
 */
#define CONT_FLAGS_SHOULD_FREE_CONTEXT 0x8000

typedef struct _PROXY {
    ADDRESS *v;
    UINT RefCount;
    UINT Flags;
    PIHTTPCONNECTOR pConnector;
    CPXMLNAMESPACE NameSpace; /* XXX should be in interface */
    PWSCONTEXT pContext;
    Preservation pRsrv;
} *PPROXY;

#define pPX(_o_) ((PPROXY) (_o_))

UINT ProxyCodeInit(PUINT8 Where, CPMETHOD_DESCR pDescr,
        INT32 (__fastcall *Interpreter)(CPMETHOD_DESCR metd, PUINT32 pArgs));
