/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>

int _tmain()
{
/* BEGIN_SAMPLE */
/* Find first entry in system namespace. */
#define BUFLEN   20
#define BUFSIZE  BUFLEN*sizeof(_TCHAR)

INameSpace *pNS;
SCODE StatusCode;
_TCHAR Buf[BUFLEN];
UINT Len;

_tprintf(_T("Search for first name in system namespace.\n"));
pNS = CurrentNameSpace();
StatusCode = pNS->FindNext(NULL, NULL, Buf, BUFSIZE, &Len);
switch (StatusCode) {
    case S_OK:
        _tprintf(_T("The first name in the namespace is \"%s\".\n"), Buf);
        _tprintf(_T("The string length of \"%s\" is %d.\n"), Buf, Len);
        break;
    case S_NO_MORE_ENTRIES:    
        _tprintf(_T("The only name in the namespace is \"%s\".\n"), Buf);
        _tprintf(_T("The string length of \"%s\" is %d.\n"), Buf, Len);
        break;
    case S_BUFFER_TOO_SMALL:    
        _tprintf(_T("The name is %d characters long.\n"), Len); 
        _tprintf(_T("It's too long to fit in the buffer supplied.\n"));
        break;
    default:
        _tprintf(_T("The namespace is empty.\n"));
        break;
}
/* END_SAMPLE */
return 0; 
}
