; Copyright (c) Microsoft Corporation. All rights reserved.

;
; Run Time Library dispatch vector
;

;
; This is located in memory at a well known address,
; applications invoke/access the RTL services/infos
; via this table of pointers.
;
; For simplicity, we do not use ORG or the likes to
; specify the location of this table. This can be
; controlled externally (from the makefile) using
; linker directives (FIRST and Base)
;


	IMPORT	UnimplementedRtlCall

	;
	; Macros for rtl functions
	;

; Macro to specify function is unimplemented/replaced
    MACRO
    Unimplemented $Name
    GBLL $Name.Unimp
    MEND

; Macro to create a normal stub entry in table
	MACRO
	Stub $Name, $Alternate
  [ :DEF:$Name.Unimp
	b	_UnimplementedRTL
  |
	IMPORT	$Name
	b	$Name
  ]
	MEND

; Macro to create a stub passing PC as 1st arg
	MACRO
	StubPC $Name
  [ :DEF:$Name.Unimp
	b	_UnimplementedRTL
  |
	IMPORT	$Name.FromPC
	b	$Name.FromPC
  ]
	MEND

	AREA	RtlArea, CODE, READONLY

_UnimplementedRTL
	sub	a1,lr,#4
	b	UnimplementedRtlCall

	EXPORT	RtlBase
	KEEP	RtlBase
RtlBase
