/* Copyright (c) Microsoft Corporation. All rights reserved. */
    #include <arm_asm.h>
#if defined(__GNUC__)
    #include "_gnuRtl.inc"
#else
    #include "_armRtl.inc"
#endif

/*
 * MMLite kernel interface
 *
 *
 * This file defines offset values for the MMLITE RTL symbols,
 * in the order in which they are listed.
 * e.g. the functions and data pointers that make up the RunTime Library.
 * If you move, delete, or insert an entry, you must relink everything.
 *
 * This files knows the kernel well, especially _rtl.s and the makefile
 *
 * Notice that even if a symbol is defined here this does not mean it is
 * implemented/properly supported.  Check _rtl.s and rtl.c to make sure.
 */
	
    Stub    AtomicCmpAndSwap
    Stub    AtomicAdd
    Stub    AtomicSub
    Stub    AtomicDec
    Stub    AtomicInc
    Stub    AtomicSwap
    Stub    Mutex_Init
    Stub    Mutex_Destroy
    Stub    Mutex_Lock
    Stub    Mutex_Unlock
    Stub    Mutex_TryLock
    Stub    Mutex_Locked
    Stub    Condition_Init
    Stub    Condition_Destroy
    Stub    Condition_Signal
    Stub    Condition_Broadcast
    Stub    Condition_Wait
    Stub    Condition_TimedWait
    Stub    Condition_InterruptSignal
    Stub    Condition_WaitAndBeginConstraint
    Stub    Condition_TimedWaitAndBeginConstraint
    Stub    BeginConstraint
    Stub    EndConstraint
    Stub    memcpy,_memcpy
    Stub    memmove
    Stub    memset
    Stub    memcmp
    Stub    UuidCmp
    Stub    StrFormat
    Stub    SleepUntil
    Stub    CurrentTime
    Stub    AddDevice
    Stub    Delay
    Stub    ThreadExit
    Stub    CreateHeapFrom
    Stub    GetModuleContainsAddr
    Stub    GetModuleNext
    Stub    GetTlsPtr
    Stub    Int64Add,Uint64Add
    Stub    Int64AddInt32
    Stub    Uint64AddUint32
    Stub    Int64Subtract,Uint64Subtract
    Stub    Uint64SubtractUint32
    Stub    Int64LShift
    Stub    Int64RShift
    Stub    Uint64RShift
    Stub    Int64TimesInt32
    Stub    Int64TimesInt64
    Stub    Int64DividedByInt32
    Stub    Int64DividedByInt64
    Stub    __rt_udiv
    Stub    __rt_udiv10
    Stub    __rt_sdiv
    Stub    __rt_sdiv10
    Stub    CurrentThread
    Stub    CurrentProcess
    Stub    CurrentNameSpace
    Stub    CurrentHeap
    StubPC  ProcessImage
    StubPC  ProcessArgs
#if 1
    Stub    DebugBreak         /* XXX */
    Stub    DebugBreak         /* XXX */
    Stub    DebugBreak         /* XXX */
    Stub    DebugBreak         /* XXX */
#else
    Stub    WaitFor
    Stub    ActivitySetCurrent
    Stub    ActivityGetCurrent
    Stub    CreateEventStatic
#endif
    Stub    BaseSetLastError
    Stub    BaseGetLastError
#if defined(ANGEL_SEMIHOST)
    Stub    open
    Stub    close
    Stub    read
    Stub    write
    Stub    lseek
    Stub    filelength
#endif
    Stub    GenericQueryInterface
#if 1
    Stub    DebugBreak
#else
    Stub    QueueCreate
#endif
    Stub    DebugBreak

    _END
