/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <arm_asm.h>

/*
 * Startup code for ARM MMLite.
 *
 * Not in C for a variety of reasons.
 * Also contains other assembly misc.
 */

    _CODE(C$$code)

    _IMPORT(BaseInit)
    _IMPORT(TrapInit)
    _IMPORT(ExitUserMode)
    _IMPORT(IntStackPtr)
    _IMPORT(DebugBreak)
/*    _IMPORT(InitAEBMMU)*/

    _EXPORT(_start)

/* 
 * Entry point
 */
    _ENTRY

_FUNCTION(_start)

#if 1 || defined(NEED_EXITUSERMODE)
/*
 * Make sure we're in SVC mode
 */
   bl       ExitUserMode
#endif

/*
 * Disable interrupts for now, SVC mode
 */
    msr     cpsr_c, #0xD3

/*
 * Set stack pointer for SVC mode
 */
    ldr     sp, = _L(IntStackPtr)
    ldr     sp, [sp]

#ifdef HORNET
    /* Initialize the page tables */
    bl      PageTableInit
#endif
/*
 * Initialize interrupt dispatching
 */
    bl      _F(TrapInit)

#if defined(__GNUC__)
/*
 * Initialize gdb stub.
 */
    bl      _F(DebugBreak)
#endif

#if defined(ANGELX)
/*
 * Enable interrupts.  They are masked in the PIC, so we
 * won't get any that we own.
 */
    msr     CPSR_c, #0x13
#endif

/*
 * Go straight for MI init
 */
    b       _F(BaseInit)

    _END
