; Copyright (c) Microsoft Corporation. All rights reserved.
;
; Renesas HEW Assembler Version
;

;
;   Int Vector
;
    .SECTION    $VECT52,DATA,LOCATE=H'000000D0
    .DATA.L     H8TimerInt

    .SECTION    P,CODE,ALIGN=2

    .EXPORT     _HWLoadThreadContext
    .EXPORT     _Reschedule
    .EXPORT     H8TimerInt

    .IMPORT     _H8TimerIntProc
    .IMPORT     __Reschedule

;;;;;;;;;;;;;;;;
;    .IMPORT __dbg_sched_cnt1
;    .IMPORT __dbg_sched_cnt2
;;;;;;;;;;;;;;;;

    .EXPORT     _GetPC

;
; void Reschedule(void);
;
; Voluntary context-switch code.
; Only must save enough state for a function return.
; But reload might be from ctxt switch, hence frame.
;
_Reschedule:
    ; PC on stack already
    ; Get CCR and push it
    stc ccr,r0l
    mov.b r0l,@sp
	
	; disable interrupt
	orc #H'80,ccr
	
	; Push registers
	push	er6
	push	er5
	push	er4
	push	er3
	push	er2
	push	er1
	push	er0

;;;;;;;;;;;;;;;
;	mov.l @__dbg_sched_cnt1,ER0
;	add.l #1,ER0
;	mov.l ER0,@__dbg_sched_cnt1
;;;;;;;;;;;;;;;

	; Push sp (xxx redundant!)
	push	sp

	bra TI0

	;

H8TimerInt:

	; Push registers.
	push	er6
	push	er5
	push	er4
	push	er3
	push	er2
	push	er1
	push	er0

	; Push sp (xxx redundant!)
	push	sp

;;;;;;;;;;;;;;;
;	mov.l @__dbg_sched_cnt2,ER0
;	add.l #1,ER0
;	mov.l ER0,@__dbg_sched_cnt2
;;;;;;;;;;;;;;;

	; Clear IMFA
	; Update Kernel Time
	mov.l	sp,er0
	jsr @_H8TimerIntProc

TI0:
	; Frame is set, make call
	mov.l	sp,er0
	jsr	@__Reschedule

	; Fall-through on return

;
; void HWLoadThreadContext(CXTINFO *pCxt)
;
_HWLoadThreadContext:
    mov.l   er0,sp
    pop     er0 ;/* sp, really */
    pop     er0
    pop     er1
    pop     er2
    pop     er3
    pop     er4
    pop     er5
    pop     er6
    rte

_GetPC:
    mov.l @(0,sp),er0
    rts

	.END

