; Copyright (c) Microsoft Corporation. All rights reserved.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	A simple DOS extender
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.model tiny, c
	.386p
;;
;; Compilation switches
;;
DBGIT	EQU	0

;;
;;  Typedefs
;;

; The information we pass on to the EXE32
;
BOOT_INFO STRUCT 1t
	RelocationBase	DWORD	?
	ImageSize	DWORD	?
	CmdLinePtr	DWORD	?
	CallbackRoutine	DWORD	?
BOOT_INFO ENDS

; A lgdt/lidt pointer to them tables
;
GDT_PTR STRUCT 1t
	limit	WORD	?
	base	DWORD	?
GDT_PTR ENDS

; An entry in the Global Descriptor Table
;
GDT_ENTRY STRUCT 1t
	limit		WORD	?
	base0_15	WORD	?
	base16_23	BYTE	?
	access		BYTE	?
	granularity	BYTE	?
	base24_31	BYTE	?
GDT_ENTRY ENDS

;;
;; Selectors
;;
P_D_SEL	EQU	1*SIZEOF GDT_ENTRY	;; data32-P
P_C_SEL	EQU	2*SIZEOF GDT_ENTRY	;; code32-P
R_D_SEL EQU	3*SIZEOF GDT_ENTRY	;; data16-S
R_C_SEL EQU	4*SIZEOF GDT_ENTRY	;; code16-S
;;R_C32_SEL EQU	5*SIZEOF GDT_ENTRY	;; code32-S
;;; user segs plus tss
;;; does not include first (zero) and last ones which are not relocated.
N_DESCS EQU	9

; Protected mode bit in MSW (aka cr0)
CR0_MSW_PE EQU 1

; Offset in PSP where DOS stores the cmd line
PSP_CMD EQU	80h
CMD_LINE_LEN EQU 80h

; Offset in the NT EXE header where entry point is
EP_OFFSET EQU 0a8h
; Offset in the NT EXE header where image size is
IMGSZ_OFFSET EQU 0d0h

; Rounded size of memory we use (from startme to NT header)
; MUST be less than NT-EXE's header size
OUR_SIZE EQU 1024

page +
;;
;; Initialization, we get here in real more
;; Either the boot called us (ds==0) or DOS (ds!=0)
;; This is then used for stack space.
;;
;; WARNING: When changing this code verify that
;; "K_ep" below stays DWORD aligned
;;
	.code
startme PROC NEAR
	;; get cmd line, if any
	; if standalone boot ds==cs and no cmds
	; if DOS EXE cs=ds+100 and cmd @PSP+80h
	; if DOS COM ds==cs NO LONGER SUPPORTED !
	mov	ax,cs
	mov	bx,ds
	mov	es,ax	; es==cs
	sub	bx,ax
	je	segs
	; got cmd line, copy it
	cld
	mov	cx, CMD_LINE_LEN
	mov	si, PSP_CMD	; ds seg
	mov	di, OFFSET CmdLine ; es seg
	rep	movsb
	
segs:	;; setup segments
	mov	ds,ax	; ds==cs
	mov	ss,ax	; ss==cs
	mov	sp,OFFSET MyStack
	xor	eax,eax	; zero the unused
	mov	fs,ax
	mov	gs,ax

	;;
	;; Move up to a page-aligned paragraph, minus OUR_SIZE,
	;; because we want the EXE32's start to be page-aligned
	;;
	mov	ax,cs
	add	ax,(OUR_SIZE SHR 4)
	mov	bx,ax
	neg	bx
	add	ax,0ffh
	and	ax,0ff00h
	add	bx,ax
	je	algn

	; bx == dstseg-srcseg
	sub	ax,(OUR_SIZE SHR 4)
	; ax == new CS
	lea	di, cs:palgn
	mov	[di], ax

	; how many segs worth of data
	mov	si,(OFFSET startme + OUR_SIZE)
	mov	edx,[si+IMGSZ_OFFSET]		; ..where ImageSize is..
	add	edx,OUR_SIZE			; ..plus the 16 bit code
	shr	edx,16				; chopped!

	; init loop
	mov	ax,ds
	mov	cx,dx
	shl	cx,12
	add	ax,cx
	mov	ds,ax
	inc	dx				; fixchop

	; copy data
copy:	mov	ax,ds
	add	ax,bx
	mov	es,ax

	std
	mov	cx, 0ffffh
	mov	si, cx
	mov	di, si
	rep	movsb
	movsb

	; next seg pair
	mov	ax,ds
	sub	ax,1000h			; did 64k
	mov	ds,ax

	dec	dx
	jne	copy
	cld

	;; xfer to new copy (cannot use stack)
	mov	ax,es
	; jmp far es:segs
	db 0eah 	; jmp ptr16:16
	dw OFFSET segs	; es:segs
palgn::
	dw 0

algn:
	;; Patch CS in return-to-real-mode code
	mov	ax,cs
	lea	bx, cs:PatchCS

	; we will relocate, and the old copy 
	; will become invisible ==> new copy
	mov	cx,(OFFSET startme)+OUR_SIZE
	shr	cx,4
	add	ax,cx
	mov	[bx], ax

	;; Find where we have been loaded
	mov	ax,cs
	movzx	eax,ax
	shl	eax,4
	; we will relocate
	add	eax,(OFFSET startme)+OUR_SIZE
	mov	BootInfoData.RelocationBase,eax
	mov	ebx,eax

	;; Relocate all entries in the GDT table
IF 0
	mov	Gdt.base0_15+P_D_SEL,ax
	mov	Gdt.base0_15+P_C_SEL,ax
	mov	Gdt.base0_15+R_D_SEL,ax
	mov	Gdt.base0_15+R_C_SEL,ax
	mov	Gdt.base0_15+R_C32_SEL,ax

	shr	eax,16
	mov	Gdt.base16_23+P_D_SEL,al
	mov	Gdt.base16_23+P_C_SEL,al
	mov	Gdt.base16_23+R_D_SEL,al
	mov	Gdt.base16_23+R_C_SEL,al
	mov	Gdt.base16_23+R_C32_SEL,al

	mov	Gdt.base24_31+P_D_SEL,ah
	mov	Gdt.base24_31+P_C_SEL,ah
	mov	Gdt.base24_31+R_D_SEL,ah
	mov	Gdt.base24_31+R_C_SEL,ah
	mov	Gdt.base24_31+R_C32_SEL,ah
ELSE
        mov     dx,N_DESCS-1
        lea     bp,Gdt+SIZEOF GDT_ENTRY
        shr     eax,16
relocateGdt:
        mov     (GDT_ENTRY PTR [bp]).base0_15,bx
	mov	(GDT_ENTRY PTR [bp]).base16_23,al
	mov	(GDT_ENTRY PTR [bp]).base24_31,ah
        add     bp,SIZEOF GDT_ENTRY
        dec     dx
        jne     relocateGdt
ENDIF

	;;  Setup our gdt pointer
	lea	eax,Gdt
	add	eax,ebx
	mov	[OurGDT.base],eax


	;; Preserve the machine state we started off with.
	;; This way both boot and DOS loading will work.
	db 66h
	sgdt	[BiosGDT]
	db 66h
	sidt	[BiosIDT]
	db 66h
	mov	eax,cr0
	mov	[BiosCR0],eax
	or	ax,CR0_MSW_PE
	mov	[SaveCR0],eax

	;; find where EXE32's entry point is
	xor	ebx,ebx
	mov	bx,(OFFSET startme) + OUR_SIZE	; where NT header is
	mov	eax,[bx+EP_OFFSET]		; where entry point is
	mov	K_ep,eax

	;; find how large the 32bit image is
	mov	eax,[bx+IMGSZ_OFFSET]		; where ImageSize is
	mov	BootInfoData.ImageSize,eax

	;; make a copy of ourselves higher up
	mov	cx, 1024	; size of NT header we can use
	xor	si,si		; from our beginning..
	mov	di,bx		; ..to our end
	rep	movsb
	

	;; Switch to protected mode
	lea	ax,lback
	mov	bx,(OFFSET MyStack)+OUR_SIZE-2
	mov	[bx],ax	; because stack..

	call	ProtMode
lback:

	;; get ready for calling the EXE32
	mov	eax,K_ep

	;; Pass BootInfo pointer to EXE32
	pushd	OFFSET BootInfoData

	;; If the EXE32 ever "ret"urns..
	pushd	OFFSET GetOut

	;; Off we go
	; use32 data
	mov	cx,P_D_SEL
	mov	ds,cx
	mov	es,cx
	mov	ss,cx
	; move to 32bit segment
	db 66h
	db 0eah 	; jmp ptr16:32
	dd OFFSET l1	; P_C_SEL:lab
	dw P_C_SEL
l1:
	;; WARNING: think twice about the code you put here
	jmp	ax	; eax

startme ENDP

page +
;;
;;  Data externally visible
;;

;
; Info copied from the NT header before we clobber it
;
K_ep	DWORD	0

;
; NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE
; NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE
; CAVEAT EMPTOR                                 CAVEAT EMPTOR
; CAVEAT EMPTOR  Change this if the code grows  CAVEAT EMPTOR
; CAVEAT EMPTOR                                 CAVEAT EMPTOR
; NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE
; NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE
;
Filler BYTE 141 DUP (0)

;
; Pass DOS command line to EXE32
;
CmdLine	BYTE	CMD_LINE_LEN DUP (0)

;
; All of the above makes for recyclable mem
; of about ?? bytes.  Use as stack.
MyStack	DWORD	0

externdef	CallBack: NEAR

BootInfoData BOOT_INFO	{ 0,
	0,
	OFFSET	CmdLine,
	OFFSET	CallBack }


;;
;;  Data local to this module
;;
BiosCR0 DWORD	0
BiosIDT	GDT_PTR		{ 0, 0 }
BiosGDT GDT_PTR		{ 0, 0 }

SaveCR0 DWORD	0
SaveCR3 DWORD	0
Pad0	WORD	0
OurGDT	GDT_PTR		{ ((N_DESCS + 1) * (SIZEOF GDT_ENTRY)) - 1, 0 }
;;;  +1 for non-relocated entry. -1 for inclusiveness.

;;; The line is too long with comments so they are separately below [sic]
Gdt	GDT_ENTRY	{ 0, 0, 0, 0, 0, 0 },
		{ 0ffffh, 0, 0, 92h, 0cfh, 0},
		{ 0ffffh, 0, 0, 9ah, 0cfh, 0},
		{ 0ffffh, 0, 0, 92h, 00fh, 0},
		{ 0ffffh, 0, 0, 9ah, 00fh, 0},
		{ 0ffffh, 0, 0,0f2h, 0cfh, 0},
		{ 0ffffh, 0, 0,0fah, 0cfh, 0},
		{ 0ffffh, 0, 0,0f2h, 0cfh, 0},
		{ 0ffffh, 0, 0, 89h, 08fh, 0},
		{ 0ffffh, 0, 0, 92h, 0cfh, 0}   ; 9


; required null descriptor   	
; 1 prot, data               	
; 2 prot, code               	
; 3 real, data               	
; 4 real, code               	
; 5 user, data               	
; 6 user, code               	
; 7 user, data, spare (tcb)  	
; 8 tss                      		
; 9 prot, data  NOT relocated
	
page +
;;
;; Go back to DOS, assuming it is there.
;;
GetOut PROC NEAR

	;; If we ever get here..
	; back to 16bit segment
	db 0eah 	; jmp ptr16:32
	dd OFFSET l2	; R_C_SEL:lab
	dw R_C_SEL
l2:
	mov	ax,R_D_SEL
	mov	ds,ax
	mov	es,ax
	mov	ss,ax
	lea	sp,l2	; sanity stack ptr
	;; Back to real mode
	call	DosMode

	;; And back to DOS.
	.exit 3

	;; no DOS ?
;;
;; Reboot the machine
;; [or whatever the BIOS means by that]
;; Arguments:
;;	none
;; Clobbers:
;;	everyhting
;; Results:
;;	none
;; Mode:
;;	REAL16
;;
BiosReboot::
	xor	ax,ax
	int	19
	;; oh well..
here:	jmp	here
GetOut ENDP

;;
;; Procedure, called from real mode, to
;; put the processor in protected mode
;;
;; Arguments:
;;	bx	  if non zero, first call
;; Globals:
;;	OurGDT	  must be side-effected if needed
;;	R_?_SEL	  indexes of protected mode selectors
;; Clobbers:
;;	ebx eflags.I cs ds es ss gdtr
;; Results:
;;	none
;; Mode:
;;	USE16
;;
ProtMode PROC NEAR

	push	eax

	; no intrs for a while
	cli

	; set PDBR the way it was
	mov	eax,[SaveCR3]
	mov	cr3,eax

	;; set segments	before switch
	db 66h
	lgdt	[OurGDT]

	mov	bx,R_D_SEL
	mov	ds,bx
	mov	es,bx
	mov	ss,bx

	;; Turn prot mode on, flush prefetch
	; Another lesson learned the hard way:
	; you must use lmsw to boot from real,
	; "mov cr0,eax" wont work.
	smsw	ax
	or	ax,CR0_MSW_PE
	lmsw	ax

	;; MASM does not like non-relocatable segments
	;; [or I do not know how to say it]
	db 66h		; operand override
	db 0eah 	; jmp ptr16:32
	dd OFFSET lab	; R_C_SEL:lab
	dw R_C_SEL
lab:
	; now in (relocated) 16bit code segment.
	;; NOTE segments MUST be reloaded, or else
	mov	ds,bx
	mov	es,bx
	mov	ss,bx

	;; but we really want CR0..
	mov	eax,[SaveCR0]
	mov	cr0,eax

	pop	eax
	ret
ProtMode ENDP
page+
;;
;; Procedure to get back from protected mode
;; to real mode.	Does not work on 286.
;;
;; Arguments:
;;	none so far
;; Clobbers:
;;	eax cs ds es ss gdtr idtr eflags.I
;; Results:
;;	none
;; Mode:
;;	USE16
;;
DosMode PROC NEAR

	;; xfer to 16mode code
	;; MASM does not like non-relocatable segments
	;; [or I do not know how to say it]
	db 66h		; operand override
	db 0eah 	; jmp ptr16:32
	dd OFFSET lab16	; R_C_SEL:lab16
	dw R_C_SEL
lab16::
	;; no intrs
	cli

	;; save machine state
	mov	eax,cr0
	mov	[SaveCR0],eax
	mov	eax,cr3
	mov	[SaveCR3],eax

	;; back the way DOS had things
	mov	eax,[BiosCR0]
	mov	cr0,eax

	;; set CS properly, and flush pipes
	db 66h
	db 0eah
	dd OFFSET lreal
PatchCS::
	dw R_C_SEL	;	this gets patched

lreal:
	;; set other segments
	mov	ax, cs
	mov	ds, ax
	mov	es, ax
	mov	ss, ax

	;; flush TLB
	mov	eax,cr3
	mov	cr3,eax

	;; reload IDT, GDT
	db 66h
	lgdt	[BiosGDT]
	db 66h
	lidt	[BiosIDT]

	; interrupts back on now
	sti

	;; done
	ret

DosMode ENDP

page +
;;
;; Callback dispatcher
;; Invoked from protected mode EXE32 to dispatch
;; to real-mode code (BIOS, DOS, whatever).
;;
;; Arguments:
;;	[esp]	32bit return address
;;	[esp+4]	number of INT function to be executed
;;	[esp+8]	pointer to register state for call
;;	[esp+c] pointer to register state after call
;; Clobbers:
;;	donno yet
;;
;; Results:
;;	none
;; Mode:
;;	USE32
;;
CallBack PROC NEAR
	;; linkage
	push	bp	; ebp
	mov	bp,sp	; ebp,esp

	;; back to use16
	db 0eah 	; jmp ptr16:32
	dd OFFSET l2	; R_C_SEL:lab
	dw R_C_SEL
l2:
	; Back to real mode
	;
	call	DosMode

	; Build the INT N instruction
	;
	mov	ax,[bp+8]	; <N>
	lea	bx,OFFSET TheIntN
	mov	BYTE PTR [bx],al

	; Next piece of code cant take interrupts
	;
	cli

	; Prepare arguments..
	;
	mov	ebp,[ebp+12]	; regs before call
	mov	[ebp+12],esp	; save spot for esp (ESP inside regs-before)
	mov	esp,ebp;
	popad

        ; Skip segments for now..maybe later will do
        add     esp,24
        popfd
        mov    esp,[esp-20-28]  ; reload saved esp

	; Interrupts ok now
	;
	sti

	; Ready now, make the int call
	db 0cdh
TheIntN:
	db 0

	; Next piece of code cant take interrupts
	;
	cli

	; Save resulting register state
	;
        pushfd                  ; save resulting flags on stack
        push	ebp		; make ebp scratch, save later for real
	mov	ebp,[esp+16+8]	; regs after
	add	ebp,32  	; one pusha frame (no flags)
	xchg	ebp,esp		; ready for push
	pushad
	mov	ebp,[esp+8]	; saved ebp (really, esp)

	mov	eax,[ebp]	; result ebp, from save spot on stack
	mov	[esp+8],eax	; save ebp for real

	mov	eax,[ebp+4]	; result flags, from save spot on stack
	mov	[esp+(32+24)],eax	; save eflags

	mov	esp,ebp         ; back to real stack
	pop	eax             ; saved ebp, drop
	pop	eax             ; saved eflags, drop
        
	; Back to protected mode
	;
	call	ProtMode

	; use32 data
	mov	bx,P_D_SEL
	mov	ds,bx
	mov	es,bx
	mov	ss,bx

	; move to 32bit segment
	db 66h
	db 0eah 	; jmp ptr16:32
	dd OFFSET l1	; P_C_SEL:lab
	dw P_C_SEL
l1:
	pop	bp	; ebp
	ret
CallBack ENDP

page +
;;
;; Debug support
;;
IF DBGIT

putc PROC NEAR
	push	ax
	call	DosMode
	mov	bx,1
	pop	ax
	mov	ah,0eh
	int	10h
	jmp	ProtMode
putc ENDP

pd PROC NEAR
	and	ax,0fh
	add	al,'0'
	cmp	al,'9'
	jle	putc
	add	al,'A'-'9'-1
	jmp	putc
pd ENDP

;; print EAX content, in hex
px PROC NEAR
	push	ax
	ror	eax,16
	push	ax

	mov	ax,20h
	call	putc	; a space before it

	;; High 16 first
	pop	ax
	push	ax
	shr	ax,28-16
	call	pd

	pop	ax
	push	ax
	shr	ax,24-16
	call	pd

	pop	ax
	push	ax
	shr	ax,20-16
	call	pd

	pop	ax
	call	pd

	;; Low 16 now
	pop	ax
	push	ax
	shr	ax,12
	call	pd

	pop	ax
	push	ax
	shr	ax,8
	call	pd

	pop	ax
	push	ax
	shr	ax,4
	call	pd

	pop	ax
	jmp	pd

px ENDP

ENDIF
	.stack
	end startme
