/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mips_asm.h>

/*
 * Functions to access coprocessor 0
 */
        .set noreorder
/*
 *  UINT32 IntOff(void);
 *
 * Turns interrupts off, returns previous value of PSR
 */
ENTRY(IntOff)
        mfc0    $v0,$cp0_status
        /* Is this delay really needed */
        nop
        li      $t0,~CP0_SR_IEc
        and     $t0,$t0,$v0
        mtc0    $t0,$cp0_status
        j       $ra
        nop
END(IntOff)

/*
 *  UINT32 IntOn(void);
 *
 * Turns interrupts on, returns previous value of PSR
 */
ENTRY(IntOn)
        mfc0    $v0,$cp0_status
        /* Is this delay really needed */
        nop
        ori     $t0,$v0,CP0_SR_IEc|CP0_SR_INT  /* enable them all */
        mtc0    $t0,$cp0_status
        j       $ra
        nop
END(IntOn)

/*
 *  void SetPsr(UINT32 PsrValue);
 *
 * Restore the previous value of the PSR
 */
ENTRY(SetPsr)
        mtc0    $a0,$cp0_status
        j       $ra
        nop
END(SetPsr)


/*
 *  UINT32 GetPsr(void);
 *
 * Get the current value of the PSR
 */
ENTRY(GetPsr)
        mfc0    $v0,$cp0_status
        j       $ra
        nop
END(GetPsr)


