/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mips_asm.h>

/*
 * Support routines
 */

    _EXPORT(MMUFaultAddress)
    _EXPORT(MMUFaultStatus)
    _EXPORT(FlushCache)
    _EXPORT(ReadWrite)

/* We got no cache, and no MMU.
 * The EBI doesnt know what its doing, doesnt remember fault addresses.
 */
ENTRY(FlushCache)
_FUNCTION(MMUFaultAddress)
_FUNCTION(MMUFaultStatus)
    j    $ra
    move $v0,$zero
END(FlushCache)

/*
 * UINT32 ReadWrite(PUINT32 ReadAddress,
 *                  PUINT32 WriteAddress,
 *                  UINT32 WriteValue);
 * 
 * In well-known time, read the I/O location at READ_ADDRESS and then write
 * the WRITE_VALUE at I/O location WRITE_ADDRESS. Return the value read.
 * NB: This should live in scratch RAM.
 */
ENTRY(ReadWrite)
	.set noreorder
    lw      $v0,0($a0)
    j       $ra
    sw      $a2,0($a1)
	.set reorder
END(ReadWrite)

    _END
