/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mips_asm.h>

/*
 * Support routines
 */

    _EXPORT(MMUEnable)
    _EXPORT(MMUFaultAddress)
    _EXPORT(MMUEnter)
    _EXPORT(FlushCache)
    _EXPORT(ReadWrite)

    _EXPORT(GetEpc)
#if 0
    _EXPORT(PutWord)
    _IMPORT(ComPutChar) // pick which one
    _IMPORT(DCPutChar)
#define PutChar DCPutChar
#endif

/* UINT32 GetEpc(void)
 * Returns: the c0_epc
 */
ENTRY(GetEpc)
	.set noreorder
    mfc0 $v0, $cp0_epc
    jr     $ra
    nop
	.set reorder
END(GetEpc)

#if 0
/* int PutWord(UINT32 Word);
 * Returns: 0 if ok, -1 otherwise
 */
ENTRY(PutWord)
	.set noreorder
    subu   $sp,$sp,12
    sw     $s0,8($sp)
    sw     $s1,4($sp)
    sw     $ra,0($sp)

    or     $s1,$a0,$zero
    /* Spit all nibbles
     */
    li     $s0,8
_LABEL(PutWordLoop)
    srl    $a0,$s1,32-4
    li     $t0,10
    sltu   $t1,$a0,$t0
    bnez   $t1,Digit
    li     $a1,'0'
    subu   $a0,$a0,$t0
    li     $a1,'a'
Digit:
    sll    $s1,$s1,4
    jal    PutChar
    add    $a0,$a0,$a1

    subu   $s0,$s0,1
    bne    $v0,$zero,PutWordDone /* printed ok? */
    li     $v0,-1

    /* done yet? */
    bne    $s0,$zero,PutWordLoop
    nop

    /* done
     */
_LABEL(PutWordDoneOk)
    li     $v0,0
_LABEL(PutWordDone)
    lw     $ra,0($sp)
    lw     $s1,4($sp)
    lw     $s0,8($sp)
    jr     $ra
    addiu  $sp,$sp,12
	.set reorder
END(PutWord)

#endif

/* Enable the MMU
 */
ENTRY(MMUEnable)
	.set noreorder
    mfc0    $a0, $cp0_status
    li      $a1, ~CP0_SR_TS
    and     $a0,$a0,$a1
    j       $ra
    mtc0    $a0, $cp0_status
	.set reorder
END(MMUEnable)

/* Where did we fault on?
 * extern ADDRESS MMUFaultAddress(void)
 */
ENTRY(MMUFaultAddress)
	.set noreorder
    j       $ra
    mfc0    $v0, $cp0_badv
	.set reorder
END(MMUFaultAddress)

/* Enter a mapping in the TLB
 * extern void MMUEnter(UINT32 TlbHi, UINT32 TlbLo);
 */
ENTRY(MMUEnter)
	.set noreorder
    mtc0    $a0, $cp0_tlbhi
    mtc0    $a1, $cp0_tlblo
    j       $ra
    tlbwr
	.set reorder
END(MMUEnter)

/* We got no cache.
 */
ENTRY(FlushCache)
	.set noreorder
    j    $ra
    move $v0,$zero
	.set reorder
END(FlushCache)

    _END
