/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mips_asm.h>

/*
 * Startup code for eMIPS MMLite.
 * Version for the Xilinx Ml40x boards
 *
 * Not in C for a variety of reasons.
 * Also contains other assembly misc.
 */

    _EXPORT(_start)

/*
 * Entry point
 *
 * This startup code is executed at chip powerup/reset.
 * Lives in FLASH, is visible at address TBD on powerup.
 *
 * This very same code can also be downloaded at its intended
 * execution place in RAM, and started and debugged in there.
 * Or it might be placed <anywhere> and have it move itself.
 */
    _ENTRY

ENTRY(_start0)
	.set noreorder

	/* Find out where we are running from
     * Leave 0x100 bytes of room for the heap header
     * and/or an image signature with version and whatnot.
     */
    b    _L(_start1)
    nop /* ..and 60 more */
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
_LABEL(_start1)
    bgezal  $zero, _L(_start) /* Always jumps */
    nop /* ..and 62 more */

_LABEL(_start)
    or     $a0,$ra,$zero
    /* ..and fall-through to... */
END(_start)
    
#include "../_mipsstart.s"

