/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <ppc_asm.h>

	_CODE(text)

/*
 *  UINT32 IntOff(void);
 *
 * Turns interrupts off, returns previous value of PSR
 */
ENTRY(IntOff)
        mfmsr   r3
        li      r4,MSR_RI_MASK          /* keep b62! */
        mtmsree r4
        blr
END(IntOff)

/*
 *  void SetPsr(UINT32 Value);
 *
 * Restores previously saved value of PSR
 */
ENTRY(SetPsr)
        mtmsree r3
        blr
END(SetPsr)

/*
 *  UINT32 IntOn(void);
 *
 * Turns interrupts on, returns previous value of PSR
 */
ENTRY(IntOn)
        li      r4,MSR_EERI_MASK SHR 1
        add     r4,r4,r4
        mfmsr   r3
        mtmsree  r4
        blr
END(IntOn)

        _ENDCODE
        _END
