/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * BUGBUG BUGBUG
 * Should be rewritten when we better understand this processor.
 * BUGBUG BUGBUG
 */
#include <ppc_asm.h>
#define __ASSEMBLER__ 1
#include "eb63.h"
#include "../ppc_traps.h"

    _IMPORT(NonBootProcessorEntry)
    _IMPORT(CurrentProcessorTrap)
    _IMPORT(_Reschedule)
    _IMPORT(ExternalInterrupt)
#define USE_KD 0
#if USE_KD
    _IMPORT(KdPollBreakIn)
    _IMPORT(DbgBreakPointWithStatus)
#endif

    _IMPORT(nImiss)
    _IMPORT(nDmiss)

    _EXPORT(Real0SectionStart)
    _EXPORT(Real0SectionEnd)

/*
 *
 * ZEROTH_LEVEL_INTERRUPT_HANDLER
 *
 * Generates the code necessary to process a PowerPC interrupt at the zeroth
 * level.  On entry to this code, interrupts are disabled and all paging is
 * turned off.  This code partially saves the machine state at the time of the
 * exception and resume execution with paging reenabled.
 *
 */
#define SPR_PCR  272    /* SPRG0 */
#define SPR_GPR2 273    /* SPRG1 */
#define SPR_GPR3 274    /* SPRG2 */
#define SPR_GPR4 275    /* SPRG3 */

#define SPR_HGPR4 304   /* HSPRG0 */
#define SPR_HGPR3 305   /* HSPRG1 */

DEBUGINC MACRO Counter
        lis     r2,Counter
        addi    r2,r2,Counter
        clrlwi  r2,r2,1                    /* clear high order address bit */
        lwz     r3,0(r2)
        addi    r3,r3,1
        stw     r3,0(r2)
ENDM

FIRST_LEVEL_INTERRUPT_HANDLER_MSR           _EQU     \
    MSR_DR_MASK + MSR_IR_MASK + MSR_ME_MASK + \
    /*MSR_SF_MASK*/ + MSR_HV_MASK

ZEROTH_LEVEL_INTERRUPT_HANDLER MACRO FirstLevelHandler, SaveDarDsisr

        mtspr   SPR_GPR2,r2                 // save GPR2 in scratch register
        mtspr   SPR_GPR3,r3                 // save GPR3 in scratch register
        mtspr   SPR_GPR4,r4                 // save GPR4 in scratch register
IFNB <SaveDarDsisr>
        mfspr   r4,SPR_PCR                  // get real mode PCR address
        mfdar   r2
        mfdsisr r3
        std     r2,PCR_DarSave(r4)
        stw     r3,PCR_DsisrSave(r4)
ENDIF
        mfsrr1  r4                          // GPR4 = SRR1
        mfsrr0  r3                          // GPR3 = interrupt address
        /*
         * Build the Machine State Register at entry to a first level interrupt
         * handler.  Interrupts are disabled, but paging has been reenabled.
         * BUGBUG Find a better way to build this constant
         */
	    lis     r2,1                        // MSR_ME
        ori     r2,r2,0301H                 // MSR_DR+MSR_IR/*+MSR_SF*/+MSR_HV
        rldicr  r2,r2,60,63                 // shift in place
        mtsrr1  r2
        lis     r2,CommonInterruptHandler
        addi    r2,r2,CommonInterruptHandler
        mtsrr0  r2
                                            // GPR2 = first level handler
        addi    r2,r2,FirstLevelHandler - CommonInterruptHandler
        rfid

ENDM

        _CODESEG(REAL0)


_FUNCTION(Real0SectionStart)

/*
 *
 * 0x00000100 - System Reset Interrupt
 *
 */

        _ORG(00100h)

ENTRY(SystemResetInterruptZerothLevel)
        lis     r31,NonBootProcessorEntry
        addi    r31,r31,NonBootProcessorEntry
        clrlwi  r31,r31,1                   // clear high order address bit
        mtctr   r31
        bctr
END(SystemResetInterruptZerothLevel)

/*
 *
 * 0x00000200 - Machine Check Interrupt
 *
 */

        _ORG(00200h)
ENTRY(MachineCheckInterruptZerothLevel)
        b       MachineCheckInterruptZerothLevel
END(MachineCheckInterruptZerothLevel)

/*
 *
 * 0x00000300 - Data Storage Interrupt
 *
 * Data storage interrupts are raised when a data fetch fails address
 * translation, is not supported for the type of memory addressed, violates
 * memory protection, or triggers a data address breakpoint.
 *
 */

        _ORG(00300h)
ENTRY(DataStorageInterruptZerothLevel)
        /* NB: We cannot save registers in the same place as all other
         *     trap handlers do, because *they* want to run virtually
         *     and consequently they can take I/D TLB misses.
         *     And when they do, we clobber their saved values.
         */
        mtspr   SPR_HGPR3,r3                // save GPR3 in scratch register
        mtspr   SPR_HGPR4,r4                // save GPR4 in scratch register
        mfspr   r4,SPR_PCR                  // get real mode PCR address
        std     r2,PCR_Gpr2Save(r4)          // save GPR2 in PCR area
        std     r5,PCR_Gpr5Save(r4)          // save GPR5 in PCR area
        std     r6,PCR_Gpr6Save(r4)          // save GPR6 in PCR area
        DEBUGINC nDmiss
        mfocrf  r2,080h                     // preserve condition register
        mfdar   r3                          // obtain faulting data address
        mfdsisr r5                          // obtain fault code
        rlwinm. r6,r5,0,DSISR_HTEG_MISS,DSISR_HTEG_MISS
                                            // HTEG miss?
        beq-    _L(CheckDataBreakpoint)
        rlwinm  r6,r3,12,20,29              // MiGetPdeOffset(DAR)
        lwz     r6,PAGE_DIRECTORY_PHYSICAL_ADDRESS(r6)
                                            // load page directory entry
        andi.   r5,r6,1                     // PDE marked as valid?
        beq-    _L(StorageViolationData)
        andi.   r5,r6,8                     // PDE marked as large page?
        clrrwi  r5,r6,12                    // clear page attribute bits
        rlwimi  r6,r3,0,10,19               // merge large page base with offset
        rlwinm  r6,r6,0,29,27               // clear low software only bits
        bne+    _L(ConvertPseudoPte)
        rlwinm  r6,r3,22,20,29              // MiGetPteOffset(DAR)
        lwzx    r6,r6,r5                    // load page table entry
        andi.   r5,r6,1                     // PTE marked as valid?
        /* Move somewhere else, we only have room for 32 instructions here.
         */
        bne+    _L(ConvertPseudoPte)
        b       _L(CheckStackOverflow)

END(DataStorageInterruptZerothLevel)

/*
 *
 * 0x00000380 - Data Segment Interrupt
 *
 */

        _ORG(00380h)
ENTRY(DataSegmentInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleDataSegmentInterrupt
END(DataSegmentInterruptZerothLevel)

/*
 *
 * 0x00000400 - Instruction Storage Interrupt
 *
 * Instruction storage interrupts are raised when an instruction fetch fails
 * address translation, is made from a direct store segment, or violates memory
 * protection.
 *
 */

        _ORG(00400h)
ENTRY(InstructionStorageInterruptZerothLevel)
        mtspr   SPR_HGPR3,r3                // save GPR3 in scratch register
        mtspr   SPR_HGPR4,r4                // save GPR4 in scratch register
        mfspr   r4,SPR_PCR                  // get real mode PCR address
        std     r2,PCR_Gpr2Save(r4)          // save GPR2 in PCR area
        std     r5,PCR_Gpr5Save(r4)          // save GPR5 in PCR area
        std     r6,PCR_Gpr6Save(r4)          // save GPR6 in PCR area
        DEBUGINC nImiss
        mfocrf  r2,080h                     // preserve condition register
        mfsrr0  r3                          // obtain faulting code address
        mfsrr1  r5                          // obtain fault code
        rlwinm. r6,r5,0,DSISR_HTEG_MISS,DSISR_HTEG_MISS
                                            // HTEG miss (same as DSISR bit)?
        beq-    _L(StorageViolationInstruction)
        rlwinm  r6,r3,12,20,29              // MiGetPdeOffset(DAR)
        lwz     r6,PAGE_DIRECTORY_PHYSICAL_ADDRESS(r6)
                                            // load page directory entry
        andi.   r5,r6,1                     // PDE marked as valid?
        beq-    _L(StorageViolationInstruction)
        andi.   r5,r6,8                     // PDE marked as large page?
        clrrwi  r5,r6,12                    // clear page attribute bits
        rlwimi  r6,r3,0,10,19               // merge large page base with offset
        rlwinm  r6,r6,0,29,27               // clear low software only bits
        bne+    ConvertPseudoPte
        rlwinm  r6,r3,22,20,29              // MiGetPteOffset(DAR)
        lwzx    r6,r6,r5                    // load page table entry
        andi.   r5,r6,1                     // PTE marked as valid?
        /* Move somewhere else, we only have room for 32 instructions here.
         */
        bne+    _L(ConvertPseudoPte)
        b       _L(StorageViolationInstruction)

END(InstructionStorageInterruptZerothLevel)


/*
 *
 * 0x00000480 - Instruction Segment Interrupt
 *
 */

        _ORG(00480h)
ENTRY(InstructionSegmentInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleInstructionSegmentInterrupt
END(InstructionSegmentInterruptZerothLevel)

/*
 *
 * 0x00000500 - External Interrupt
 *
 * External interrupts are raised by the assertion of the external interrupt
 * signal.
 *
 */

        _ORG(00500h)
ENTRY(ExternalInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleExternalInterrupt
END(ExternalInterruptZerothLevel)

/*
 *
 * 0x00000600 - Alignment Interrupt
 *
 * Alignment interrupts are raised when a memory access is not on a natural
 * boundary and the processor cannot emulate the access, the instruction is not
 * supported in little-endian mode, the operand crosses a segment or BAT
 * boundary, or is not supported for the type of memory addressed.
 *
 */

        _ORG(00600h)
ENTRY(AlignmentInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleAlignmentInterrupt, TRUE
END(AlignmentInterruptZerothLevel)

/*
 *
 * 0x00000700 - Program Interrupt
 *
 * Program interrupts are raised as a result of floating point exception, an
 * attempt to execute illegal instruction, an attempt to execute a priviliged
 * instruction from user mode, or a trap instruction.
 *
 */

        _ORG(00700h)
ENTRY(ProgramInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleProgramInterrupt
END(ProgramInterruptZerothLevel)

/*
 *
 * 0x00000800 - Floating-Point Unavailable Interrupt
 *
 * Floating-point unavailable interrupts are raised when an attempt is made to
 * execute a floating-point instruction and MSR_FP is clear.
 *
 */

        _ORG(00800h)
ENTRY(FpuUnavailableInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleFpuUnavailableInterrupt, TRUE
END(FpuUnavailableInterruptZerothLevel)

/*
 *
 * 0x00000900 - Decrementer Interrupt
 *
 * Decrement interrupts are raised when the decrementer register passes through
 * zero.
 *
 */

        _ORG(00900h)
ENTRY(DecrementerInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleDecrementerInterrupt
END(DecrementerInterruptZerothLevel)

/*
 *
 * 0x00000980 - Hypervisor Decrementer Interrupt
 *
 * Decrement interrupts are raised when the decrementer register passes through
 * zero.
 * The hypervisor decrementer interrupt is a "level sensitive" interrupt based on bit
 * HDEC[0].  To reset the interrupt, change the decrementer value to MAXLONG.
 *
 */

        _ORG(00980h)
ENTRY(HypervisorDecrementerInterruptZerothLevel)
        mtspr   304,r2                      // save r2 in HSPRG0
        lis     r2,7FFFh
        ori     r2,r2,0FFFFh
        mtspr   310,r2                      // reset hypervisor decrementer level
        mfspr   r2,304                      // recover r2 from HSPRG0
        hrfid
END(HypervisorDecrementerInterruptZerothLevel)

/*
 *
 * 0x00000C00 - System Call Interrupt
 *
 * System call interrupts are raised as result of executing a system call
 * instruction (sc).
 *
 */

        _ORG(00C00h)
ENTRY(SystemCallInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleSystemCallInterrupt
END(SystemCallInterruptZerothLevel)

/*
 *
 * 0x00000D00 - Trace Interrupt
 *
 * Trace interrupts are raised when MSR_SE is enabled and any instruction other
 * than rfi[d] completes or when MSR_BE is enabled and any branch instruction
 * completes.
 *
 */

        _ORG(00D00h)
ENTRY(TraceInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleTraceInterrupt
END(TraceInterruptZerothLevel)

/*
 *
 * 0x00000F00 - Performance Monitor Interrupt
 *
 */

        _ORG(00F00h)
ENTRY(PerformanceMonitorInterruptZerothLevel)
        /* We only have room for 8 instructions here */
        b  PerformanceMonitorInterruptFirstLevel
END(PerformanceMonitorInterruptZerothLevel)

/*
 *
 * 0x00000F20 - Vector Processing Unavailable Interrupt
 *
 * This interrupt is raised when an attempt is made to
 * execute a vector processor instruction and MSR_VEC is clear.
 *
 */

        _ORG(00F20h)
ENTRY(VpuUnavailableInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleVpuUnavailableInterrupt, TRUE
END(VpuUnavailableInterruptZerothLevel)


ENTRY(PerformanceMonitorInterruptFirstLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandlePerformanceMonitorInterrupt
END(PerformanceMonitorInterruptFirstLevel)

/*
 *
 * 0x00001000 - TLB miss related code
 *
 * Jump here from the dispatch areas because we have more room.
 *
 */
        _ORG(01000h)
ENTRY(TlbMissHandlingCode)

/*
 * We have a PDE entry for a large page, convert to regular and insert
 */
_FUNCTION(ConvertPseudoPte)
        rlwinm  r6,r6,0,22,19               // clear high software only bits
        rlwimi  r6,r6,31,21,31              // right shift page attribute bits

/*
 * Compute the physical address of the primary page table entry group that maps
 * the faulting effective address.  Also, compute the low half of the hardware
 * PTE from the DAR (data) or SRR0 (instruction).
 */

ComputeHardwarePteGroupAddress:
        rlwinm  r6,r6,0,0,31                // clear upper 32-bits
        rlwinm  r5,r3,11,21,24              // extract VSID from DAR/SRR0
        rlwinm  r4,r3,27,14,24              // extract page index from DAR/SRR0
        rlwinm  r3,r3,16,16,24              // isolate PTE[VSID], PTE[API]
        xor     r4,r4,r5                    // compute primary hash group offset
        mfsdr1  r5                          // load processor's hashed page table
        clrrwi  r5,r5,18                    // clear HTABSIZE and reserved bits
        ori     r3,r3,1                     // PTE[V]=1
        or      r5,r5,r4                    // compute primary HTEG address

/*
 * Search the page table entry group for a page table entry that already maps the
 * virtual address or an empty slot.
 */

SearchForMatchingOrEmptyHardwarePte:
        ld      r4,0(r5)                    // load low half of PTE
        cmpld   r3,r4                       // PTE already loaded?
        beq-    HardwarePteAlreadyLoaded
        andi.   r4,r4,1                     // PTE marked as valid?
        beq+    WriteTargetHardwarePte
        addi    r5,r5,16                    // advance to the next PTE
        andi.   r4,r5,127                   // within the same PTE group?
        bne+    SearchForMatchingOrEmptyHardwarePte

/*
 * No empty slots exist in this page table entry group.  Select a random slot for
 * replacement.
 */

ReplaceRandomHardwarePte:
        mfdec   r4                          // use decrementer as random number
        subi    r5,r5,128                   // recompute primary HTEG address
        rlwimi  r5,r4,0,25,27               // insert random PTE index in address

/*
 * Write the hardware PTE to the selected slot and return from interrupt.
 */

WriteTargetHardwarePte:
        std     r6,8(r5)                    // store the high half of the PTE
        std     r3,0(r5)                    // store the low half of the PTE

HardwarePteAlreadyLoaded:
        mfspr   r4,SPR_PCR                  // get real mode PCR address
        mtocrf  080h,r2                     // restore condition register
        mfspr   r3, SPR_HGPR3               // restore r2-r6 and we're done
        ld      r2,PCR_Gpr2Save(r4)
        ld      r5,PCR_Gpr5Save(r4)
        ld      r6,PCR_Gpr6Save(r4)
        mfspr   r4, SPR_HGPR4
        rfid

/*
 * Check for a Data Breakpoint interrupt
 *
 * A data storage interrupt has occurred, but the cause is not a HTEG miss.
 * Check if this is a data breakpoint match.  If so, then disable the data
 * breakpoint (indicates to the kernel debugger that this breakpoint has fired)
 * and jump to the first level interrupt handler.  Otherwise, a data storage
 * violation has occurred.
 */

_FUNCTION(CheckDataBreakpoint)
        rlwinm. r6,r5,0,DSISR_DABR_MATCH,DSISR_DABR_MATCH
                                            // data breakpoint accessed?
        beq-    _L(StorageViolationData)

/*
 * Check if the address of the faulting instruction was inside the common trap
 * handler when attempting to allocate a trap frame.  If so, then the stack has
 * likely overflowed.  Recover from the exception by jumping to the panic
 * interrupt handler which will switch to the panic stack and bugcheck with the
 * context of the original exception.
 */

_FUNCTION(CheckStackOverflow)
        b       _L(StorageViolationData)


/*
 * A storage violation has occurred.
 */
_FUNCTION(StorageViolationInstruction)
        li      r5,TRAP_IS
        b       _L(StorageViolationCommon)

_FUNCTION(StorageViolationData)
        li      r5,TRAP_DS

_FUNCTION(StorageViolationCommon)
        mtocrf  080h,r2                     // restore condition register
        mfspr   r4,SPR_PCR                  // get real mode PCR address
        mfdar   r2
        mfdsisr r3
        std     r2,PCR_DarSave(r4)
        stw     r3,PCR_DsisrSave(r4)
        stw     r5,PCR_SegvCause(r4)          // Remember D/I fault diff
        ld      r5,PCR_Gpr2Save(r4)          // recover GPR2 from PCR area
        mfspr   r6,SPR_HGPR3                 // recover GPR3 from Hscratch
        mtspr   SPR_GPR2,r5                  // save GPR2 in scratch area
        mtspr   SPR_GPR3,r6                  // save GPR3 in scratch area
        mfspr   r5,SPR_HGPR4                 // recover GPR4 from Hscratch
        mtspr   SPR_GPR4,r5                  // save GPR4 in scratch area
        ld      r5,PCR_Gpr5Save(r4)          // recover GPR5 from PCR area
        ld      r6,PCR_Gpr6Save(r4)          // recover GPR6 from PCR area

        mfsrr1  r4                          // GPR4 = SRR1
        mfsrr0  r3                          // GPR3 = interrupt address
        /*
         * Build the Machine State Register at entry to a first level interrupt
         * handler.  Interrupts are disabled, but paging has been reenabled.
         * BUGBUG Find a better way to build this constant
         */
	    lis     r2,1                        // MSR_ME
        ori     r2,r2,0301H                 // MSR_DR+MSR_IR/*+MSR_SF*/+MSR_HV
        rldicr  r2,r2,60,63                 // shift in place
        mtsrr1  r2
        lis     r2,CommonInterruptHandler
        addi    r2,r2,CommonInterruptHandler
        mtsrr0  r2
                                            // GPR2 = first level handler
        addi    r2,r2,HandleStorageInterrupt - CommonInterruptHandler
        rfid

        


END(TlbMissHandlingCode)

/*
 *
 * 0x00001300 - Instruction Address Interrupt
 *
 */

        _ORG(01300h)
ENTRY(InstructionAddressInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleInstructionAddressInterrupt
END(InstructionAddressInterruptZerothLevel)


/*
 *
 * 0x00001400 - System Management Interrupt
 *
 */

        _ORG(01400h)
ENTRY(SystemManagementInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleSystemManagementInterrupt
END(SystemManagementInterruptZerothLevel)


/*
 *
 * 0x00001500 - Software Patch Interrupt
 *
 */

        _ORG(01500h)
ENTRY(SoftwarePatchInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleSoftwarePatchInterrupt
END(SoftwarePatchInterruptZerothLevel)


/*
 *
 * 0x00001600 - Maintenance Interrupt
 *
 * Various internal events plus the support processor can trigger this.
 *
 */

        _ORG(01600h)
ENTRY(MaintenanceInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleMaintenanceInterrupt
END(MaintenanceInterruptZerothLevel)


/*
 *
 * 0x00001700 - VMX Assist Interrupt
 *
 * VMX assist interrupts are raised when the VMX is operating in Java mode and
 * the input parameters or the result of an operation is denormalized.
 *
 */

        _ORG(01700h)
ENTRY(VmxAssistInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleVMXAssistInterrupt
END(VmxAssistInterruptZerothLevel)


/*
 *
 * 0x00001800 - Thermal Interrupt
 *
 * The thermal interrupt input signal is asserted.
 *
*/

        _ORG(01800h)
ENTRY(ThermalInterruptZerothLevel)
        ZEROTH_LEVEL_INTERRUPT_HANDLER HandleThermalInterrupt
END(ThermalInterruptZerothLevel)


/*
 *
 * End of zero-level handlers
 */
_FUNCTION(Real0SectionEnd)

        _ENDSEG(REAL0)

        _CODESEG(LTEXT)

/*
 *
 * Common code to handle an arbitrary type of interrupt.  The volatile processor
 * state is stored to the trap frame.  The interrupt is then dispatched to the
 * appropriate handler.
 *
 *       GPR2 = first level interrupt handler
 *       GPR3 = SRR0, interrupt address
 *       GPR4 = SRR1, saved MSR
 *       SPR_GPR2-4 = saved values for GPR2-4
 *
 * These registers are saved in this processor's control region.
 *
 */

ENTRY(CommonInterruptHandler)
	/* NB: The compiler does not keep the stack pointer coherent at all times,
	 *     it will store below it and then update it. So we keep some slack.
	 *     The value 152 below comes from __savegprlr_14
     */
INTERRUPT_FRAME_SIZE _EQU (152+64+SIZEOF_CXTINFO)
        stdu    sp,CXTR1-INTERRUPT_FRAME_SIZE(sp) // save original stack pointer
        subi    sp,sp,CXTR1                       // ..and adjust frame
        std     r3, CXTPC(sp)
        std     r4, CXTMSR(sp)
        std     r0, CXTR0(sp)
        std     r5, CXTR5(sp)
        std     r6, CXTR6(sp)
        mfspr   r5, SPR_GPR2
        mfspr   r6, SPR_GPR3
        std     r5, CXTR2(sp)
        std     r6, CXTR3(sp)
        std     r7, CXTR7(sp)
        std     r8, CXTR8(sp)
        mfspr   r5, SPR_GPR4
        std     r5, CXTR4(sp)
        std     r9, CXTR9(sp)
        std     r10, CXTR10(sp)
        std     r11, CXTR11(sp)
        std     r12, CXTR12(sp)
        std     r13, CXTR13(sp)
        std     r14, CXTR14(sp)
        std     r15, CXTR15(sp)
        std     r16, CXTR16(sp)
        std     r17, CXTR17(sp)
        std     r18, CXTR18(sp)
        std     r19, CXTR19(sp)
        std     r20, CXTR20(sp)
        std     r21, CXTR21(sp)
        std     r22, CXTR22(sp)
        std     r23, CXTR23(sp)
        std     r24, CXTR24(sp)
        std     r25, CXTR25(sp)
        std     r26, CXTR26(sp)
        std     r27, CXTR27(sp)
        std     r28, CXTR28(sp)
        std     r29, CXTR29(sp)
        std     r30, CXTR30(sp)
        std     r31, CXTR31(sp)
        mflr    r4
        std     r4, CXTLR(sp)
        mfctr   r4
        std     r4, CXTCTR(sp)
        mfcr    r4
        std     r4, CXTCR(sp)
        mfxer   r4
        std     r4, CXTXER(sp)

/*
 * Jump to the specific first level interrupt handler.
 *
 *       GPR2 = first level interrupt handler
 *       GPR3 = SRR0, interrupt address
 *       GPR4-6 = available
 */

        mtctr   r2
        bctr

END(CommonInterruptHandler)


COMMON_TRAP_HANDLER MACRO TrapCode
        li      r4,TrapCode                 // argument1 is cause code
        mr      r3,sp                       // argument0 is PCXTINFO

        bl      _F(CurrentProcessorTrap)

        mr      sp,r3                       // return (if any) is new PCXTINFO
        b       _L(CommonInterruptExit)
ENDM

/*
 * External Interrupt
 */

ENTRY(HandleExternalInterrupt)
        mr      r3,sp                       // argument0 is PCXTINFO
        bl      _F(ExternalInterrupt)
        mr      sp,r3                       // return (if any) is new PCXTINFO
        b       _L(CommonInterruptExit)
END(HandleExternalInterrupt)

/*
 * Restore the volatile integer and control context.
 *
 * Note that this sequence must be carefully coded to avoid TLB misses (TLB
 * invalidates could be initiated by other processors) after loading SRR0 and
 * SRR1.
 *
 */

ENTRY(CommonInterruptExit)
        ld      r4, CXTLR(sp)
        mtlr    r4
        ld      r4, CXTCTR(sp)
        mtctr   r4
        ld      r4, CXTCR(sp)
        mtcr    r4
        ld      r4, CXTXER(sp)
        mtxer   r4

        ld      r0, CXTR0(sp)

        ld      r2, CXTR2(sp)
        ld      r3, CXTR3(sp)
        ld      r4, CXTR4(sp)
        mtspr   SPR_GPR4,r4
        ld      r5, CXTR5(sp)
        ld      r6, CXTR6(sp)
        ld      r7, CXTR7(sp)
        ld      r8, CXTR8(sp)
        ld      r9, CXTR9(sp)
        ld      r10, CXTR10(sp)
        ld      r11, CXTR11(sp)
        ld      r12, CXTR12(sp)
        ld      r13, CXTR13(sp)
        ld      r14, CXTR14(sp)
        ld      r15, CXTR15(sp)
        ld      r16, CXTR16(sp)
        ld      r17, CXTR17(sp)
        ld      r18, CXTR18(sp)
        ld      r19, CXTR19(sp)
        ld      r20, CXTR20(sp)
        ld      r21, CXTR21(sp)
        ld      r22, CXTR22(sp)
        ld      r23, CXTR23(sp)
        ld      r24, CXTR24(sp)
        ld      r25, CXTR25(sp)
        ld      r26, CXTR26(sp)
        ld      r27, CXTR27(sp)
        ld      r28, CXTR28(sp)
        ld      r29, CXTR29(sp)
        ld      r30, CXTR30(sp)
        ld      r31, CXTR31(sp)

        ld      r4, CXTPC(sp)
        mtsrr0  r4

        
        ld      r4, CXTMSR(sp)
        mtsrr1  r4
	
        mfspr   r4,SPR_GPR4
        ld      sp, CXTR1(sp)
        rfid

END(CommonInterruptExit)

/*
 * Decrementer Interrupt
 *
 * The decrementer interrupt is a "level sensitive" interrupt based on bit
 * DEC[0].  To reset the interrupt, change the decrementer value to MAXLONG.
 *
 */

ENTRY(HandleDecrementerInterrupt)

        lis     r4,7FFFh
        ori     r4,r4,0FFFFh
        mtdec   r4                          // reset decrementer level

#if USE_KD
        bl      _F(KdPollBreakIn)
        cmplwi  r3,0
        beq+    NoBreak
        li      r3,1                        // DBG_STATUS_CONTROL_C
        bl      _F(DbgBreakPointWithStatus)
NoBreak:
#endif

        mr      r3,sp                       // argument is PCXTINFO
        bl      _F(_Reschedule)

        mr      sp,r3                       // return is new PCXTINFO
        b       _L(CommonInterruptExit)

END(HandleDecrementerInterrupt)

/*
 * Floating-point Unavailable Interrupt
 *
 */

ENTRY(HandleFpuUnavailableInterrupt)
        COMMON_TRAP_HANDLER TRAP_FPU
END(HandleFpuUnavailableInterrupt)

/*
 * Vector Processor Unavailable Interrupt
 *
 */

ENTRY(HandleVpuUnavailableInterrupt)
        COMMON_TRAP_HANDLER TRAP_VPU
END(HandleVpuUnavailableInterrupt)

/*
 * Program Interrupt
 *
 */

ENTRY(HandleProgramInterrupt)
        COMMON_TRAP_HANDLER TRAP_PI
END(HandleProgramInterrupt)

/*
 * Storage Violation, Data or Instruction
 *
 */

ENTRY(HandleStorageInterrupt)
        COMMON_TRAP_HANDLER TRAP_SV
END(HandleStorageInterrupt)

/*
 * Alignment Interrupt
 *
 */

ENTRY(HandleAlignmentInterrupt)
        COMMON_TRAP_HANDLER TRAP_AI
END(HandleAlignmentInterrupt)

/*
 * System Call
 *
 */

ENTRY(HandleSystemCallInterrupt)
        COMMON_TRAP_HANDLER TRAP_SC
END(HandleSystemCallInterrupt)

/*
 * Trace Interrupt
 *
 */

ENTRY(HandleTraceInterrupt)
        COMMON_TRAP_HANDLER TRAP_T
END(HandleTraceInterrupt)

/*
 * Maintenance Interrupt
 *
 */

ENTRY(HandleMaintenanceInterrupt)
        COMMON_TRAP_HANDLER TRAP_M
END(HandleMaintenanceInterrupt)

/*
 * VMX Assist Interrupt
 *
 */

ENTRY(HandleVMXAssistInterrupt)
        COMMON_TRAP_HANDLER TRAP_VMX
END(HandleVMXAssistInterrupt)

/*
 * Thermal Interrupt
 *
 */

ENTRY(HandleThermalInterrupt)
        COMMON_TRAP_HANDLER TRAP_TH
END(HandleThermalInterrupt)

/*
 * DataSegment Interrupt
 *
 */

ENTRY(HandleDataSegmentInterrupt)
        COMMON_TRAP_HANDLER TRAP_DSS
END(HandleDataSegmentInterrupt)

/*
 * InstructionSegment Interrupt
 *
 */

ENTRY(HandleInstructionSegmentInterrupt)
        COMMON_TRAP_HANDLER TRAP_ISS
END(HandleInstructionSegmentInterrupt)

/*
 * PerformanceMonitor Interrupt
 *
 */

ENTRY(HandlePerformanceMonitorInterrupt)
        COMMON_TRAP_HANDLER TRAP_PM
END(HandlePerformanceMonitorInterrupt)

/*
 * InstructionAddress Interrupt
 *
 */

ENTRY(HandleInstructionAddressInterrupt)
        COMMON_TRAP_HANDLER TRAP_IA
END(HandleInstructionAddressInterrupt)

/*
 * SystemManagement Interrupt
 *
 */

ENTRY(HandleSystemManagementInterrupt)
        COMMON_TRAP_HANDLER TRAP_SM
END(HandleSystemManagementInterrupt)

/*
 * SoftwarePatch Interrupt
 *
 */

ENTRY(HandleSoftwarePatchInterrupt)
        COMMON_TRAP_HANDLER TRAP_SP
END(HandleSoftwarePatchInterrupt)



        _ENDSEG(LTEXT)

        _END
