/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <mmlite.h>
#include <mmmacros.h>
#include <base/cons.h>
#include <loaders/cobtab.h>

/* Find preloaded COB before CobInit has been called - for boot - Bind lite
 * Also used by Bind proper through CreateCobObject.
 */
SCODE CobPreLookup(const _TCHAR *CobName, PIUNKNOWN *ppUnk)
{
    UINT i;

    for (i = 0; ThePreCobTable[i].name; i++)
        if (!_tcscmp(ThePreCobTable[i].name, CobName)) {
            PIUNKNOWN (*CobMainRoutine)(void);
            DBGME(1,printf("CobPreLookup found %s in ThePreCobTable r=%x\n",
                           CobName, (UINT) ThePreCobTable[i].CobMainRoutine));
            CobMainRoutine = ThePreCobTable[i].CobMainRoutine;
            *ppUnk = CobMainRoutine();
            return S_OK;
        }
    return E_ENTRY_NOT_FOUND;
}
