/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* This is a helper for MD code that starts one specific driver
 * using drivercfg.cob (e.g. start a serial line console)
 */

#include <mmlite.h>
#include <base/cons.h>
#include <base/loader.h>

EXTERN_C void ConfigureDrivers( PIMODULE pModule,
                                const _TCHAR *ConfigurationFileName,
                                BOOL LoadDllDrivers );

SCODE StartDriver(const _TCHAR *Name)
{
    PIMODULE pCurMod;

    GetCurrentModule(&pCurMod);
    ConfigureDrivers(pCurMod, Name, FALSE );
    if (pCurMod)
        pCurMod->v->Release(pCurMod);
    return S_OK;
}
