/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Implementation of user-mode time constraint routines. */

#include <mmlite.h>
#include <fred.h>
#include <base/tconstraint2.h>
#include <base/urgency2.h>

void TConstraint_Init(PTIME_CONSTRAINT ptcNew)
{
  TIME tNow = CurrentTime();
  TIME tZero;

  Int32ToInt64(tZero, 0);

  assert(ptcNew != NULL);

  TConstraint_SetStartTime(ptcNew, tNow);
  TConstraint_SetEstimateTime(ptcNew, tZero);
  TConstraint_SetDeadlineTime(ptcNew, tNow);
  TConstraint_SetTimeTaken(ptcNew, NULL);
  TConstraint_SetCriticality(ptcNew, _TIMESHARING);
  /* EndPrevious and criticality share a field, so there's no need to
   * initialize each separately.
   */
  /*      TConstraintClearEndPrevious(ptcNew); */
}
