/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Pick between unix style i/o vs. object interface */
#define __USE_IFILE 1

#ifdef __USE_IFILE
#include <mmlite.h>
#endif

struct _FILE {
        char *_ptr;
        int   _cnt;
        char *_base;
        int   _flag;
        void *_file;
        int   _bufsize;
#ifdef __USE_IFILE
    UINT64 Seek;
#endif
};

#if 0
/* reminder stdio.h sez: */
#define _IOFBF          0x0000
#define _IOLBF          0x0001
#define _IONBF          0x0002
#endif

#define _IOREAD         0x0004
#define _IOWRT          0x0008

#define _IOMYBUF        0x0080
#define _IOEOF          0x0100
#define _IOERR          0x0200
#define _IOSTRG         0x0400
#define _IORW           0x0800
#define _IOAPPEND       0x2000

#ifdef _INC_STDARG /* mandatory pre-inclusion of stdarg.h */
EXTERN_C INT __cdecl __svfscanf(FILE *fp,INT (*refill)(FILE *),char const *fmt0,va_list ap);
#ifdef _INC_WCHAR /* mandatory pre-inclusion of wchar.h */
EXTERN_C INT __cdecl __svwfscanf(FILE *fp,INT (*refill)(FILE *),wchar_t const *fmt0,va_list ap);
#endif
#endif

#ifdef _INC_TCHAR /* mandatory pre-inclusion of tchar.h */
#ifdef _UNICODE
#define __svtfscanf __svwfscanf
#else
#define __svtfscanf __svfscanf
#endif
#endif

EXTERN_C INT __cdecl frefill( FILE *stream);

/* Finalize stdio package for termination */
EXTERN_C void __closestdfile(void);
