/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Various junk called by gcc in some cases */

#include <mmlite.h>

#ifdef _MSC_VER
/* C++ code will call _purecall when a pure virtual method is called
 * and the compiler couldn't detect the error statically.
 */
void __cdecl _purecall(void)
{
    DebugBreak();
}
#endif

#ifdef __GNUC__
/* G++ generates references to these, assume they are bogus */
EXTERN_C void __pure_virtual(void)
{
    DebugBreak();
}

EXTERN_C PTR __get_eh_context(void)
{
    return NULL;                /* XXX */
}

EXTERN_C void __sjthrow(void)
{
    DebugBreak();
}

EXTERN_C void __terminate(void)
{
    DebugBreak();
}

void * __builtin_vec_new (size_t size)
{
    PIHEAP pHeap = CurrentHeap();
    void *p = pHeap->v->Alloc(pHeap,
                              HEAP_DEBUG_NAME("vec_new") | HEAP_ZERO_MEMORY,
                              size, 0);
#if 0
printf("__builtin_vex_new -> %x\n", (UINT) p);
    if (p == NULL)
        DebugBreak();
#endif
    return p;
}

void __builtin_vec_delete (void *pThis)
{
    PIHEAP pHeap = CurrentHeap();
    if (pThis != NULL)
        (void) pHeap->v->Free(pHeap, 0, pThis);
}

#endif

#ifdef ADS                      /* arm */
/* XXX NOT IMPLEMENTED */
void __cpp_initialise(void) {}
void __cpp_finalise(void) {}
void __cpp_finalise_dtors(void) {}
#endif


#if defined(__ADSPBLACKFIN__)
__vec_new()
{
    DebugBreak();
}

__vec_delete()
{
    DebugBreak();
}

__mark_dtor()
{
    DebugBreak();
}

EXTERN_C void __pure_virtual_called(void)
{
    DebugBreak();
}
#endif
