/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdarg.h>
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "_stdio.h"

INT __cdecl fclose( FILE *stream)
{
    int ret;

    fflush(stream);

    {
#ifdef __USE_IFILE
    PIFILE File = stream->_file;
    File->v->Release(File);
    ret = 0;
#else
    int fileno = (int) stream->_file;
    ret = close(fileno);
#endif
    }

    if (stream->_base && ((stream->_flag & _IOMYBUF) == 0))
        free(stream->_base);

    free(stream);
    return ret;
}
