/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <tchar.h>
#include <mmlite.h>             /* for StrFormat */

/* We cannot compile this file both for Unicode and not on the same system
 * because StrFormat is implemented only one way. We support Unicode
 * printing only when the entire system is Unicode enabled.
 */

static void __cdecl stupf( void *Where, _TCHAR * String)
{
    _fputts(String, (FILE *)Where);
}

/* returns < 0 iff error */
INT __cdecl vfprintf(FILE *stream,
                    const char *format,
                    va_list arg)
{
#if defined(_UNICODE)
    STRFORMAT_ESCAPE Format;

    Format.flag = UNICODE_NOT_A_CHARACTER;
    Format.ptr  = (BYTE*) format;
    format = (const char *) &Format;
#endif

    StrFormat( stupf, stream, (_TCHAR *) format, arg);

    /* xxx error check */
    return 0;
}

/* returns < 0 iff error */
INT __cdecl fprintf( FILE *stream, const char *format, ...)
{
    INT ret;
    va_list arg;

    va_start(arg,format);
    ret = vfprintf( stream, format, arg);
    va_end(arg);

    return ret;
}

#ifdef _UNICODE
INT __cdecl vfwprintf(FILE *stream,
                      const wchar_t *format,
                      va_list arg)
{
    StrFormat( stupf, stream, (_TCHAR *) format, arg);

    /* xxx error check */
    return 0;
}

INT __cdecl fwprintf( FILE *stream, const wchar_t *format, ...)
{
    INT ret;
    va_list arg;

    va_start(arg,format);
    ret = vfwprintf( stream, format, arg);
    va_end(arg);

    return ret;
}
#endif
