/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <tchar.h>
#include "_stdio.h"
#include <io.h>
#include <stdlib.h>

FILE* __cdecl freopen(const char *filename, const char *mode, FILE *stream)
{
    FILE *f;
    int fileno;

    /* inline fclose */

    fileno = (int) stream->_file;
    (void) close(fileno);

    if (stream->_base && ((stream->_flag & _IOMYBUF) == 0))
        free(stream->_base);

    f = fopen(filename, mode);

    if (f == NULL)
        free(stream);
    else {
        *stream = *f;
        free(f);
    }

    return f;
}

