/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include "_stdio.h"

#ifdef __USE_IFILE

/* returns 0 iff success */
INT __cdecl fseek(FILE *stream,
                 UINT offset,
                 int whence)
{
    SCODE sc;
    PIFILE pFile = stream->_file;
    INT64 NewPos, Offset64;

    if ((stream->_flag & _IONBF) == 0)
        fflush(stream);

    Int32ToInt64(Offset64, offset);
    NewPos = Uint64ToInt64(stream->Seek);

    switch (whence) {
    case SEEK_END:
        sc = pFile->v->GetSize( pFile, (UINT64*)&NewPos);
        if (FAILED(sc))
            break;

        /* else fall through */

    case SEEK_CUR:
        NewPos = Int64Add(NewPos,Offset64);
        break;

    case SEEK_SET:
        NewPos = Offset64;
        break;
    }

    stream->_cnt = 0; /* whack buffered case */

    stream->Seek = Int64ToUint64(NewPos);
    offset = Int64ToInt32(NewPos);

    /* BUGBUG "successful" is not all cases */
    stream->_flag &= ~_IOEOF;

    return offset;
}

#else
#include <io.h>

/* returns 0 iff success */
INT __cdecl fseek(FILE *stream,
                 UINT offset,
                 int whence)
{
    INT r;
    if ((stream->_flag & _IONBF) == 0)
        fflush(stream);
    r = (INT) lseek((FILE_HANDLE)stream->_file,offset,whence);
    /* BUGBUG "successful" is not all cases */
    stream->_flag &= ~_IOEOF;
    return r;
}
#endif
