/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Portable 64-bit integer math functions for MMLite, constants.
 */
#define __NO_BUILTIN_INT64 1
#if defined(MMLITE)
#include <mmlite.h>
#include <machdep.h>
#else
#define INT64 MYINT64
#define UINT64 MYUINT64
#include <windows.h>
#undef INT64
#undef UINT64
typedef struct _INT64 INT64;
typedef struct _UINT64 UINT64;
#define EXTERN_C extern
#include "int64.h"
#endif

const UINT64 UINT64_ZERO = Int64Initializer(0, 0);
const UINT64 UINT64_MAX = Int64Initializer(~0, ~0);
const INT64 INT64_ZERO = Int64Initializer(0, 0);
const INT64 INT64_MIN  = Int64Initializer(0x80000000,0);
const INT64 INT64_MAX  = Int64Initializer(0x7fffffff,~0);
const INT64 INT64_NEGATIVE_ONE  = Int64Initializer(~0,~0);
