/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <arm_asm.h>

/*
; Entry point for MMLite loadable images
*/

/*
; The loader loads the image into memory, replaces the nop
; instruction at the image entry point with an "stmfd r13!,{r0-r12,r14}"
; (to work around the fact that the linker generated code trashes all
; registers except r13).  Then the loader starts a thread and gives it
; a stack. This thread then calls into the loaded image, landing into
; the code the linker put at the image's start.  This initializes the
; BSS, then calls here.
*/

/*
; If we supported C++ we would have to call static con/destructors here.
*/

/*
; The compiler creates a reference to an external __main when it sees
; a function called "main".  That is what we implement here.
*/
    EXPORT  __main
    EXPORT  _main

/*
; But of course we are supposed to call "main" eventually.
*/
    IMPORT  __main2

/*
; This is what SB/r9 is supposed to be set to.
; Symbol is declared weak so its ok if the code is then non-rentrant.
;
;;;;;;;;        IMPORT  |sb$$adcons$$Base|,WEAK
*/
	
/*
; Declare our area with the proper flags.
*/
    AREA StartupCode, CODE, READONLY

/*
; Make sure the linker knows what to set the entry point to, without
; being explicitly told about it.
*/
    ENTRY

__main
_main
    ldmfd   r13!,{r0-r12,r14}
    stmfd   r13!,{r14}

    bl      __main2

    ldmfd   r13!,{r15}  ; return to our caller

    END
