/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <arm_asm.h>

/*        
;
; Default entry point for MMLite loadable images that don't have a main().
;

;
; The loader loads the image into memory, replaces the nop
; instruction at the image entry point with an "stmfd r13!,{r0-r12,r14}"
; (to work around the fact that the linker generated code trashes all
; registers except r13).  Then the loader starts a thread and gives it
; a stack. This thread then calls into the loaded image, landing into
; the code the linker put at the image's start.  This initializes the
; BSS, then calls here.
;
*/
    EXPORT  start
    IMPORT  _CobMainCRT
    AREA StartupCode, CODE, READONLY

;
; Make sure the linker knows what to set the entry point to, without
; being explicitly told about it.
;
    ENTRY

start
    ldmfd   r13!,{r0-r12,r14}
    stmfd   r13!,{r14}

/*  PIUNKNOWN MODENTRY _CobMainCRT(PIBASERTL pRtl); */
/* XXX Arg & return value??? */
    bl      _CobMainCRT

    ldmfd   r13!,{r15}  ; return to our caller

    END
