/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 *  Perform a 32bit multiplication, returns high part of 64bit result.
 */
	#include <arm_asm.h>

	_CODE(C$$code)

    _EXPORT(longjump)
    _EXPORT(setjump)

/*
 * void longjump(PCXTINFO regs, UINT32 retval);
 *
 * Reload the register state and return the indicated value
 * (e.g. in returning from the setjump() call that saved them regs)
 */
_FUNCTION(longjump)
	/* Set the return value, skip the CPSR field */
	str     r1, [r0, #+4]!
    ldmfd   r0, {r0-r15}^

/*
 * UINT32 setjump(PCXTINFO regs);
 *
 * Save the register state where indicated.
 * Returns 0 from this one call.
 * Upon invocation of longjump() it will appear as if setjump()
 * instead returns, with the value passed to longjump().
 *
 */
_FUNCTION(setjump)
	/* Save most registers */
	stmib   r0!,{r0-r14}
	/* save the return address as PC */
	str     lr, [r0, #+4]
	/* Return 0 */
	sub     r0,r0,r0
    mov     pc,lr

       _END
