/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * Return caller's PC
 */
#include <mmlite.h>

#pragma warning(disable:4035) /* no return value */

/*
 * Reload the register state and return the indicated value
 * (e.g. in returning from the setjump() call that saved them regs)
 */
__declspec(naked) void longjump(PCXTINFO regs, UINT32 retval)
{
    __asm {
        /* fix the return value
         */
        mov  ecx,4[esp];  /* regs */
        mov  eax,8[esp];  /* retval */
        mov  32/*__offsetof(struct _CXTINFO,EAX)*/[ecx],eax;

        /* put the EIP on the new stack
         */
        mov  eax,52/*__offsetof(struct _CXTINFO,EIP)*/[ecx];
        mov  edx,64/*__offsetof(struct _CXTINFO,ESP)*/[ecx];
        mov  [edx],eax;

        /* load state
         */
        mov  esp,ecx;     /* regs */
        pop  ecx;		  /* throw away pFpa */
        popad;
        pop  fs;
        pop  gs;
        pop  es;
        pop  ds;
        add  esp,8;       /* pop EIP,CS */
        popfd;
        pop  esp;
        ret;
    }
}

/*
 * Save the register state where indicated.
 * Returns 0 from this one call.
 * Upon invocation of longjump() it will appear as if setjump()
 * instead returns, with the value passed to longjump().
 *
 * Returns zero normally but may return anything when "longjmped" to.
 */
__declspec(naked) UINT32 setjump(PCXTINFO regs)
{
    __asm {

    /* Save ESP
     */
    mov  eax,esp;

    /* Get save area pointer, flip it
     */
    mov  esp,4[esp];
    add  esp,72;//sizeof(struct _CXTINFO);

	/* Build the full IRETD frame
	 */
    push  ss;
    push  eax;
	pushfd;
	push  cs;
    push  eax; /* EIP, to be fixed later */

	/* Build rest of frame. EAX is dont care.
	 */
	push ds;
	push es;
	push gs;
	push fs;
	pushad;
	push 0;			/*  pFpa */

    /* Now we can use all registers
     */
    mov  ecx,0[eax];
    mov  52/*__offsetof(struct _CXTINFO,EIP)*/[esp],ecx;

    /* Done
     */
    mov  esp,eax;
    mov  eax,0
    ret;
    }

}


