/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* main.c
 *
 * This file is included in ansic.lib because mainCRTStartup needs
 * to be defined in the exe.
 */

#include <mmlite.h>
#include <stdlib.h>

#if defined(_UNICODE)
#define _tmainCRTStartup1 wmainCRTStartup1
#else
#define _tmainCRTStartup1 mainCRTStartup1
#endif

EXTERN_C INT MODENTRY CrtInit(INT Op);
EXTERN_C INT __cdecl _tmain(UINT argc, _TCHAR *argv[]);

PIBASERTL _pTheBaseRtl;
struct IBaseRtlVtbl *_pTheBaseRtlVtbl;

INT MODENTRY _tmainCRTStartup1(PIBASERTL pRtl)
{
    INT Ret = 0;

    /* Enable RTL function calling */
    _pTheBaseRtl = pRtl;
    _pTheBaseRtlVtbl = (PTR) pRtl->v;

    /* This is the main module for a new process.
     * Initialize the module, call main, then Exit.
     */
    Ret = CrtInit(DLL_PROCESS_ATTACH);

    if (Ret) {
#if 1
        Ret = (*_tmain)(0, 0);
#else
        UINT argc;
        _TCHAR **argv;
        Ret = ParseCmdLine(&argc, &argv);
        if (Ret == 0) {
            _TCHAR *buffer = argv[0];
            argv[0] = pArgv0;

            Ret = _tmain(argc, argv, NULL);

            free(buffer);
            free(argv);
        }
#endif
    }

    CrtInit(DLL_PROCESS_DETACH);
    return Ret;
}
