/* Copyright (c) Microsoft Corporation. All rights reserved. */
 #include <mmlite.h>
#include <string.h>
#include <machdep.h>            /* for __MACHDEP_MEMFUNC */

/*
 * Quite often these functions have a strong effect on performance. 
 * They are good candidates for machine-dependent rewrites.
 */
#if !defined(__MACHDEP_MEMFUNC)

/*
 * Some compilers treat these functions as "intrinsics", e.g. they
 * generate inline code instead of funcalls.  But they might do so only
 * at the highest optimization levels.  MS VC++ is one such compiler.
 */
/* But we need the functions for the RTL.  In VC they are intrinsic
 * and cannot be defined.  Unless we use a pragma.  But the pragma
 * should be used in this file only...
 * This is really quite bogus as the compiler should just let us define
 * these and kepp its nouth shut.
 */
#ifdef _MSC_VER
#pragma function(memcmp)
#undef __MEMFUNC_ARE_INLINED
#endif

#if !defined(__MEMFUNC_ARE_INLINED)

/* Compare at most COUNT bytes starting at PTR1,PTR2.
 * Returns 0 IFF all COUNT bytes are equal.
 */
EXTERN_C int __cdecl memcmp(const void *Ptr1, const void *Ptr2, size_t Count)
{
    INT v = 0;
    BYTE *p1 = (BYTE *)Ptr1;
    BYTE *p2 = (BYTE *)Ptr2;

    while(Count-- > 0 && v == 0) {
        v = *(p1++) - *(p2++);
    }

    return v;
}
#endif
#endif
