/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <string.h>
#include <machdep.h>            /* for __MACHDEP_MEMFUNC */

/*
 * Quite often these functions have a strong effect on performance. 
 * They are good candidates for machine-dependent rewrites.
 */
#if !defined(__MACHDEP_MEMFUNC)

/* Copy C bytes from S to D.
 * Always works.
 */
EXTERN_C void * __cdecl memmove(void *d, const void *s, size_t c)
{
    if (d <= s)
        return memcpy(d,s,c);

    if ((((ADDRESS) s) | ((ADDRESS) d) | c) & (sizeof(UINT) - 1)) {

        BYTE *pS = (BYTE *) s;
        BYTE *pD = (BYTE *) (((ADDRESS) d) + c);
        BYTE *pE = (BYTE *) (((ADDRESS) s) + c);

        while (pS != pE)
            *(--pD) = *(--pE);
    }
    else {

        UINT *pS = (UINT *) s;
        UINT *pD = (UINT *) (BYTE *) (((ADDRESS) d) + c);
        UINT *pE = (UINT *) (BYTE *) (((ADDRESS) s) + c);

        while (pS != pE)
            *(--pD) = *(--pE);

    }

    return d;
}

#endif /* ! __MACHDEP_MEMFUNC */
