/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>

/* Parse an IID from standard (e.g. XML) representation */
SCODE ParseIid(const _TCHAR *Str, PIID iid)
{
    int ret;
    UINT x, y, a,b,c,d,e,f,g,h;
    ret = _stscanf(Str, _T("%8x-%4x-%4x-%2x%2x-%2x%2x%2x%2x%2x%2x"),
                   &iid->Data1, &x, &y,
                   &a,&b,&c,&d,&e,&f,&g,&h);

    iid->Data2 = (UINT16) x; iid->Data3 = (UINT16) y;
    iid->Data4[0] = (UINT8) a; iid->Data4[1] = (UINT8) b,
    iid->Data4[2] = (UINT8) c; iid->Data4[3] = (UINT8) d,
    iid->Data4[4] = (UINT8) e; iid->Data4[5] = (UINT8) f,
    iid->Data4[6] = (UINT8) g; iid->Data4[7] = (UINT8) h;

    if (ret != 11)
        return E_INVALID_PARAMETER;

    return S_OK;
}

/* Print an IID into standard (e.g. XML) representation
 * String must be at least 37 bytes long.
 */
void FormatIid(_TCHAR *Str, PIID iid)
{
    _stprintf(Str, _T("%08x-%04hx-%04hx-%02x%02x-%02x%02x%02x%02x%02x%02x"),
            iid->Data1, (UINT) iid->Data2, (UINT) iid->Data3,
            (UINT) iid->Data4[0], (UINT) iid->Data4[1],
            (UINT) iid->Data4[2], (UINT) iid->Data4[3],
            (UINT) iid->Data4[4], (UINT) iid->Data4[5],
            (UINT) iid->Data4[6], (UINT) iid->Data4[7]);
}
