/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <mmlite.h>
#include <stdlib.h>

/* Portable version, as per ISO.
 * Do NOT use for anything that is security-sensitive.
 */

/* NB: A better implementation would use per-thread data to hold 
 * the "next" global variable below.  That would make this thread-safe,
 * usable in a DLL and/or a shared COM object. Some other day..
 */

static UINT32 next = 1;

int __cdecl rand(void)
{
    next = next * 1103515245 + 12345;
    /* return (unsigned int)(next / 65536) % 32768;*/
    return (UINT32)(next>>16) & RAND_MAX;
}

void __cdecl srand(unsigned int seed)
{
    /* And you *should* get a warning if sizes dont match
     */
    next = seed;
}

