/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>

/* Convenience function: Do IFile->Read and loop to get enough data */
SCODE ReadWriteFile(PIFILE File, BOOL WriteIt, UINT64 Position,
                    BYTE * pBuffer, UINT Size,
                    UINT * pSizeActual)
{
    UINT GotBytes = 0, Length = 0;
    SCODE sc = S_OK;

    while (Length < Size && sc == S_OK) {
        /* The cast is for getting rid of const issue with param 3 */
        sc = (WriteIt ? (_IFile_ReadAt_METHOD_TYPE)File->v->WriteAt : File->v->ReadAt)(
            File,
            Position,
            pBuffer + Length,
            Size - Length,
            &GotBytes);

        if (FAILED(sc) || GotBytes == 0)
            break;
        Length += GotBytes;
        if (!Int64Equal(Position, UINT64_MAX))
            Position = Uint64AddUint32(Position, GotBytes);
    }

    if (pSizeActual)
        *pSizeActual = Length;
    return sc;
}
