/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include "_stdio.h"
#include <stdlib.h>
#include <mmlite.h>

void __cdecl setbuf( FILE *stream, char *buf)
{
    char *p;

    do {
        p = stream->_base;
    } while (!AtomicCmpAndSwap( (PUINT) &stream->_base, (UINT) p, (UINT) buf));

    if (p)
        free(p);

    if (buf == NULL) {
        stream->_flag = (stream->_flag & ~_IOLBF) | _IONBF;
        return;
    }

    stream->_flag |= _IOMYBUF;

    /*.. and I hope for good
     */
    stream->_bufsize = BUFSIZ;
}


/* returns 0 iff success */
int __cdecl setvbuf(FILE *stream,
            char *buf,
            int mode,
            size_t size)
{
    setbuf(stream,buf);
    if (stream->_base == buf) {
        stream->_bufsize = size;
        stream->_flag |= mode; /* urgh */
        return 0;
    }
    return -1;
}


