/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <tchar.h>
#include <mmlite.h>

typedef struct {
    char *AString;
    int nAvail;
} LimString;

static void __cdecl ypcnrts( void *Where, _TCHAR * String )
{
    LimString *Arg = (LimString*)Where;
    char *AString = Arg->AString;
    int n = Arg->nAvail;

    while (*String && (n > 0)) {
        *AString++ = (char)(*String++);
        n--;
    }
    if (n >= 0) {
       *AString = 0;
       n--;
    }

    Arg->AString = AString;
    Arg->nAvail = n;
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl _vsnprintf(char *s,
                    size_t count,
                    const char *format,
                    va_list arg)
{
    LimString l;
#if defined(_UNICODE)
    STRFORMAT_ESCAPE Format;

    Format.flag = UNICODE_NOT_A_CHARACTER;
    Format.ptr  = (BYTE*) format;
    format = (const char *) &Format;
#endif
    l.AString = s;
    l.nAvail = count;

    StrFormat( ypcnrts, &l, (_TCHAR *) format, arg);
    return (l.nAvail < 0) ? -1 : (count - l.nAvail);
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl _snprintf( char *s, size_t count, const char *format, ...)
{
    va_list arg;
    INT ret;

    va_start(arg,format);
    ret = _vsnprintf(s,count,format,arg);
    va_end(arg);

    return ret;
}
