/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <tchar.h>
#include <mmlite.h>

/* Like snprintf.c but inverted wstr/ascii settings */

#ifdef _UNICODE /* Does not deal with Unicode format strings when ASCII */

typedef struct {
    wchar_t *WString;
    int nAvail;
} LimString;

static void __cdecl ypcnrts( void *Where, _TCHAR * String )
{
    LimString *Arg = (LimString*)Where;
    wchar_t *WString = Arg->WString;
    int n = Arg->nAvail;

    while (*String && (n > 0)) {
        *WString++ = *String++;
        n--;
    }
    if (n >= 0) {
       *WString = 0;
       n--;
    }

    Arg->WString = WString;
    Arg->nAvail = n;
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl _vsnwprintf(wchar_t *s,
                        size_t count,
                        const wchar_t *format,
                        va_list arg)
{
    LimString l;
    l.WString = s;
    l.nAvail = count;

    StrFormat( ypcnrts, &l, format, arg);
    return (l.nAvail < 0) ? -1 : (count - l.nAvail);
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl _snwprintf( wchar_t *s, size_t count, const wchar_t *format, ...)
{
    va_list arg;
    INT ret;

    va_start(arg,format);
    ret = _vsnwprintf(s,count,format,arg);
    va_end(arg);

    return ret;
}
#endif
