/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <tchar.h>
#include <mmlite.h>
#include <string.h>

/* We cannot compile this file both for Unicode and not on the same system
 * because StrFormat is implemented only one way. We support Unicode
 * printing only when the entire system is Unicode enabled.
 */

static void __cdecl ypcrts( void *Where, _TCHAR * String )
{
    char *AString = *((char **)Where);

    while (*String)
        *AString++ = (char)(*String++);
    *AString = 0;

    *((char **)Where) = AString;
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl vsprintf(char *s,
                     const char *format,
                     va_list arg)
{
    char * tmpString = s;
#if defined(_UNICODE)
    STRFORMAT_ESCAPE Format;

    Format.flag = UNICODE_NOT_A_CHARACTER;
    Format.ptr  = (BYTE*) format;
    format = (const char *) &Format;
#endif

    StrFormat( ypcrts, &tmpString, (_TCHAR *) format, arg);
    return strlen(s);
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl sprintf( char *s, const char *format, ...)
{
    va_list arg;
    INT ret;

    va_start(arg,format);
    ret = vsprintf(s,format,arg);
    va_end(arg);

    return ret;
}

#ifdef _UNICODE
/* XXX This copy is probably redundant - no conversion here */
static void __cdecl copyw( void *Where, _TCHAR * String )
{
    _TCHAR *TString = *((_TCHAR **)Where);

    while (*String)
        *TString++ = (_TCHAR)(*String++);
    *TString = 0;

    *((_TCHAR **)Where) = TString;
}

INT __cdecl vswprintf(wchar_t *s,
                      const wchar_t *format,
                      va_list arg)
{
    StrFormat(copyw, &s, (_TCHAR *) format, arg);
    return wcslen(s);
}

/* returns number of chars written into S, not counting terminating 0 */
INT __cdecl swprintf( wchar_t *s, const wchar_t *format, ...)
{
    va_list arg;
    INT ret;

    va_start(arg,format);
    ret = vswprintf(s,format,arg);
    va_end(arg);

    return ret;
}
#endif
