/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdarg.h>
#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include "_stdio.h"

/* cant refill a string */
static INT __cdecl srefill( FILE *f)
{
    f->_flag |= _IOEOF;
    return EOF;
}

INT __cdecl _stscanf(const _TCHAR *s, const _TCHAR *format, ...)
{
    va_list args;
    int r;
    FILE pseudo;

    memset( &pseudo, 0, sizeof pseudo);
    pseudo._ptr = pseudo._base = (char*) s;
    pseudo._cnt = pseudo._bufsize = _tcslen(s) * sizeof(_TCHAR);
    pseudo._flag = _IOREAD;

    va_start(args,format);      /* Initialize variable arguments  */
    r = __svtfscanf( &pseudo, srefill, format, args);
    va_end(args);               /* Reset variable arguments       */

    return r;
}
