/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <string.h>
#include <stdlib.h>
#include <tchar.h>
#include <mmlite.h>

/* Copy a string to newly allocated memory.  Returns NULL if allocation failed.
 */

_TCHAR *_tcsdup(const _TCHAR *pStr)
{
    size_t Size = (_tcslen(pStr) + 1) * sizeof(_TCHAR);
    PIHEAP Heap = CurrentHeap();
    _TCHAR *pCopy = (_TCHAR *) Heap->v->Alloc(Heap, HEAP_DEBUG_NAME("strdup"),
                                              Size, 0);

    if (pCopy)
        memcpy((void*) pCopy, (void *) pStr, Size);

    return pCopy;
}
