/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <tchar.h>

#if defined(_MSC_VER) && (_MSC_VER > 1200) && (_MSC_VER < 1300)
#pragma function(_tcsncmp)
#endif

/* Compare, at most, the first Count chars in strings pointed by pSrt1, pSrt2.
 * Return 0 if same, < 0 if pStr1 less then pStr2, > 0 otherwise.
 */
int _tcsncmp(const _TCHAR *pStr1, const _TCHAR *pStr2, size_t Count)
{
    _TCHAR c1, c2;
    INT v;

    if (Count == 0)
        return 0;

    do {
        c1 = *pStr1++;
        c2 = *pStr2++;
        /* the casts are necessary when pStr1 is shorter & char is signed */
        v = (UINT)c1 - (UINT)c2;
    } while ((v == 0) && (c1 != '\0') && (--Count > 0));

    return v;
}
