/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <string.h>
#include <tchar.h>

#if defined(_MSC_VER) && (_MSC_VER > 1200) && (_MSC_VER < 1300)
#pragma function(_tcsncpy)
#endif

/* Copy string pointed by pSrc into the buffer pointed by pDst
 * up to Count bytes.  This function is different from strncpy()
 * of LIBC.LIB in that it won't zero out the buffer up to Count
 * bytes if Count is greater than the length of the pSrc.
 */
_TCHAR * _tcsncpy(_TCHAR * pDst, const _TCHAR *pSrc, size_t Count)
{
    _TCHAR * r = pDst;

    while ((Count-- > 0) && ((*pDst++ = *pSrc++) != _T('\0')))
        continue;

    return r;
}
