/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <string.h>
#include <stdlib.h>
#include <tchar.h>
#include <mmlite.h>

/* Copy a string of at most length Length to newly allocated memory.  Returns NULL if allocation failed.
 */

_TCHAR *_tcsndup(const _TCHAR *pStr, size_t Length)
{
    size_t MySize = (_tcslen(pStr) + 1) * sizeof(_TCHAR);
    PIHEAP Heap = CurrentHeap();
    _TCHAR *pCopy;

    Length++;
    Length *= sizeof(_TCHAR);
    if (MySize < Length)
        Length = MySize;

    pCopy = (_TCHAR *) Heap->v->Alloc(Heap, HEAP_DEBUG_NAME("strdup"),
                                      Length, 0);

    if (pCopy) {
        memcpy((void*) pCopy, (void *) pStr, Length);
        pCopy[Length-1] = _EOS;
    }

    return pCopy;
}
