/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <string.h>
#include <tchar.h>

/* Cmp two strings that have fixed length or are NUL terminated (l==0) -jvh */
/*BOOL*/ int _tcsnequal(const _TCHAR *s1, size_t l1,
                        const _TCHAR *s2, size_t l2)
{
    if (l1 == 0 && l2 == 0)
        return !_tcscmp(s1, s2);
    if (l1 == 0)
        l1 = _tcslen(s1);
    else if (l2 == 0)
        l2 = _tcslen(s2);

    if (l1 == l2)
        return !_tcsncmp(s1, s2, l1);
    else
        return 0; /*FALSE*/
            
}
