/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Copy an ASCII string to Unicode in newly allocated memory.
 * Returns NULL if allocation failed.
 */

#include <string.h>
#include <stdlib.h>
#include <tchar.h>

wchar_t *_strtow(const char *str)
{
    size_t i, n = strlen(str) + 1;
    wchar_t *wcstr, *pCopy = (wchar_t *) malloc(n * sizeof(wchar_t));

    if (pCopy) {
        wcstr = pCopy;
        for (i = 0; i < n; i++)
            *wcstr++ = (wchar_t) *str++;
    }
    return pCopy;
}

/* Copy a Unicode string to ASCII in newly allocated memory.
 * Returns NULL if allocation failed.
 */
char *_wcstos(const wchar_t *wcstr)
{
    size_t i, n = wcslen(wcstr) + 1;
    char *str, *pCopy = (char *) malloc(n * sizeof(char));

    if (pCopy) {
        str = pCopy;
        for (i = 0; i < n; i++)
            *str++ = (char) *wcstr++;
    }
    return pCopy;
}
