/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Trivial 64-bit integer math conversion functions.
 */
/* Portable 64-bit integer math functions for MMLite
 */
#define __NO_BUILTIN_INT64 1
#if defined(MMLITE)
#include <mmlite.h>
#include <machdep.h>
#else
#define INT64 MYINT64
#define UINT64 MYUINT64
#include <windows.h>
#undef INT64
#undef UINT64
typedef struct _INT64 INT64;
typedef struct _UINT64 UINT64;
#define EXTERN_C extern
#include "int64.h"
#endif

/* Can't define as macros because of return value conversion. */
UINT64 Uint64Add(UINT64 a, UINT64 b)
{
    INT64 x = Int64Add(Uint64ToInt64(a), Uint64ToInt64(b));
    return Int64ToUint64(x);
}

/* Can't define as macros because of return value conversion. */
UINT64 Uint64Subtract(UINT64 a, UINT64 b)
{
    INT64 x = Int64Subtract(Uint64ToInt64(a), Uint64ToInt64(b));
    return Int64ToUint64(x);
}

