/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <drivers/drivers.h>
#include "config.h"

/*
 * --------------------------------------------------------------------------
 * Builds each one of the statically/dynamically configured drivers, and
 * installs them as appropriate.
 */
EXTERN_C void PerformConfiguration( BOOL LoadDlls )
{
#ifndef h8 /* XXX we will need drivers eventually... */
    PIMODULE pCurMod;

    GetCurrentModule(&pCurMod);
    ConfigureDrivers(pCurMod, _T("fs/drivers.dat"), LoadDlls );
    if (pCurMod)
        pCurMod->v->Release(pCurMod);

#endif
}

/* For some (buggy!) compilers, must be defined */
#if defined(__TCS__) || defined(ecog)
struct _DEFCOB {
    struct IUnknownVtbl *v;
    UINT RefCnt;
};
#endif

extern struct _DEFCOB _DefaultCobObject;
PIUNKNOWN DriverCfgCobMain(void)
{
    PerformConfiguration( USE_DLLS );

    return (PIUNKNOWN) &_DefaultCobObject;
}
