/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <mmhal.h>
#define DLL_LINKAGE DLL_EXPORT
#include <drivers/drivers.h>
#include <drivers/ioqueue.h>


EXTERN_C SCODE DLL_EXPORT IoQueueInitialize(
    PIO_QUEUE pThis)
{
    InitializeListHead(&pThis->Link);
    return NO_ERROR;
}

EXTERN_C DLL_EXPORT SCODE IoQueueAdd(
    PIO_QUEUE pThis,
    PIO_QUEUE pElement,
    PMUTEX pLock,
    IO_QUEUE_WORKER StartIo)
{
    InterlockedInsertTailList(&pThis->Link,&pElement->Link,pLock);

    if (ListFirst(&pThis->Link) == &pElement->Link)
        return StartIo(pThis,pElement);

    return E_IO_PENDING;
}

EXTERN_C DLL_EXPORT SCODE IoQueuePop(
    PIO_QUEUE pThis,
    PMUTEX pLock,
    IO_QUEUE_WORKER StartIo,
    UINT Key)
{
    PLINK_ENTRY pComplete;

    UnusedParameter(Key);

    InterlockedRemoveHeadList(&pThis->Link,&pComplete,pLock);

    /* BUGBUG needs lock */
    if (ListIsEmpty(&pThis->Link))
        return NO_ERROR;

    return StartIo(pThis,(PIO_QUEUE)ListFirst(&pThis->Link));
}
