/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * Microsoft MMLITE June 1995 --jvh
 * NT server for remote IFile using serial lines or sockets.
 */

#include <import_windows.h>
#include <winsock.h>
#include <mmlite.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include <tchar.h>
#include <wchar.h>

#define __HOSTFS_SERVER 1
#include <drivers/hostfsp.h>

#ifdef InterlockedCompareExchangePointer
/* Resolve version differences between various winbase.h */
#define AtomicCmpAndSwap(Where,OldValue,NewValue) \
    ((PVOID)OldValue == (PVOID)InterlockedCompareExchange((PVOID)Where,NewValue,OldValue))
#else
#define AtomicCmpAndSwap(Where,OldValue,NewValue) \
    ((PVOID)OldValue == (PVOID)InterlockedCompareExchange((PVOID)Where,(PVOID)NewValue,(PVOID)OldValue))
#endif

UINT AtomicDec(PUINT pCount)
{
    UINT OldCount, NewCount;

    for (;;) {
        OldCount = *pCount;
        NewCount = OldCount - 1;
        if (AtomicCmpAndSwap(pCount, OldCount, NewCount)) {
            return NewCount;
        }
    }
}
UINT AtomicInc(PUINT pCount)
{
    UINT OldCount, NewCount;

    for (;;) {
        OldCount = *pCount;
        NewCount = OldCount + 1;
        if (AtomicCmpAndSwap(pCount, OldCount, NewCount)) {
            return NewCount;
        }
    }
}

/* The exe is not run under the simulator so no action needed */
UINT HostFsd_NTBegin()
{
    return 0;
}
void HostFsd_NTEnd(UINT State)
{
    UnusedParameter(State);
}
