/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* --------------------------------------------------------------------------
 *
 * Module:
 *
 *    bulk.h
 *
 * Purpose:
 *
 *    Bulk transport protocol definitions
 *
 * Author:
 *    A. Forin (sandrof)
 *
 * --------------------------------------------------------------------------
 */

/* Command Block Wrapper
 */
typedef UINT8 USB_CBW[31];

typedef _PACKED struct _USB_CBW_struct {
    UINT8   Signature[4];
    UINT8   Tag[4];
    UINT8   DataTransferLength[4];
    UINT8   Flags;
    UINT8   LUN;
    UINT8   CommandBlockLength;
#define USB_CBW_MAX_CB 16
    UINT8   CommandBlock[USB_CBW_MAX_CB];
} USB_CBW_struct, *PUSB_CBW_struct;

/* dCBWSignature */
#define USB_CBW_SIGNATURE      0x43425355    /* "USBC" */

/* bmCBWFlags */
#define USB_CBW_F_IN           0x80
#define USB_CBW_F_OUT          0x00

/* Command Status Wrapper
 */
typedef UINT8 USB_CSW[13];

typedef _PACKED struct _USB_CSW_struct {
    UINT8   Signature[4];
    UINT8   Tag[4];
    UINT8   DataResidue[4];
    UINT8   Status;
} USB_CSW_struct, *PUSB_CSW_struct;

/* dCSWSignature */
#define USB_CSW_SIGNATURE      0x53425355    /* "USBS" */

/* bCSWStatus */
#define USB_CSW_S_OK           0x00
#define USB_CSW_S_FAILED       0x01
#define USB_CSW_S_PHASE_ERROR  0x02
