/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* --------------------------------------------------------------------------
 *
 * Module:
 *
 *    cbi.h
 *
 * Purpose:
 *
 *    Command/Bulk/Interrupt transport protocol definitions
 *
 * Author:
 *    A. Forin (sandrof)
 *
 * --------------------------------------------------------------------------
 */

/* CBI Status
 */
typedef UINT8 USB_CBI_STATUS[2];

typedef _PACKED struct _USB_CBI_STATUS_struct {
    UINT8   Type;
    UINT8   Value;
} USB_CBI_STATUS_struct, *PUSB_CBI_STATUS_struct;

/* bType */
#define USB_CBI_STATUS_T_COMPLETION        0x00

/* bValue */
#define USB_CBI_STATUS_PASS                0x00
#define USB_CBI_STATUS_FAIL                0x01
#define USB_CBI_STATUS_PHASE_ERROR         0x02
#define USB_CBI_STATUS_PERSISTENT_FAILURE  0x03

