/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* --------------------------------------------------------------------------
 *
 * Module:
 *
 *    cdb.h
 *
 * Purpose:
 *
 *    Command description block (CDB) definitions
 *
 * Author:
 *    A. Forin (sandrof)
 *
 * --------------------------------------------------------------------------
 */

#ifndef _CDB_H_
#define _CDB_H_ 1

/* Generic data transfer descriptor
 */

typedef struct _CDB {
    SCODE FinalStatus;
    UINT8 *DataPointer;
    UINT16 DataLength;
    UINT8 Flags;
    /* Opaque command block, max 16 bytes
     */
    UINT8 CbLength;
    UINT8 Cb[16];
} CDB, *PCDB;

#define CDB_F_IN             0x01
#define CDB_F_OUT            0x02
#define CDB_F_COMPLETE       0x40
#define CDB_F_ERROR          0x80

#endif /* _CDB_H_ */
