/* Descriptors per USB.
 * BUGBUG This does not belong here, not at all.
 */

#define MOUSE 1
#define KEYBOARD 0
#define SERIAL_LINE 0

#if MOUSE

#define HAS_STRINGS 0

PRIVATE USB_DEVICE_DESCRIPTOR Myself = {
    sizeof(USB_DEVICE_DESCRIPTOR),
    USB_DT_DEVICE,
    Con2(USB_v1_0),
    0, 0, 0, /* class,subclass,protocol */
    8,                /* max packet size */
    Con2(0x45e), Con2(0x9), Con2(0x105),   /* vendor,product,device*/
    0, 0, 0,          /* ix of manuf,product,serial number */
    1                 /* num configurations */
};

#define sizeof_Irene 34

PRIVATE _PACKED struct {
    USB_CONFIGURATION_DESCRIPTOR Config;
    USB_INTERFACE_DESCRIPTOR Iface;
    USB_HID_DESCRIPTOR Hid;
    USB_ENDPOINT_DESCRIPTOR Ep1;
} Irene = 
    {
      {
        sizeof(USB_CONFIGURATION_DESCRIPTOR),
        USB_DT_CONFIG,
        Con2(sizeof_Irene),   /* total length of all descs returned */
        1,               /* num interfaces */
        1,               /* config value */
        0,               /* ix of config */
        USB_AT_SELF_POWERED|USB_AT_REMOTE_WAKEUP,  /* attributes */
        1                     /* max power */
      },{
        sizeof(USB_INTERFACE_DESCRIPTOR),
        USB_DT_IFACE,
        0,               /* iface no */
        0,               /* alternate */
        1,               /* num endp */
        USB_DC_HID, USB_DS_BOOT, USB_DP_MOUSE, /* class,subclass,protocol */
        0                /* ix of iface */
      },{
        sizeof(USB_HID_DESCRIPTOR),
        USB_DT_HID,
        Con2(0x100),    /* BcdHID */
        0,              /* CountryCode */
        1,              /* NumDescriptors to follow */
        USB_DT_REPORT,  /* ReportDescriptorType */
        Con2(74)        /* ReportDescriptorLength */
      },{
        sizeof(USB_ENDPOINT_DESCRIPTOR),
        USB_DT_ENDP,
        USB_EA_IN | 2,   /* address */
        USB_AE_INTERRUPT,/* attrib */
        Con2(4),         /* max pkt size */
        10               /* interval () */
      }
};

UINT8 IreneReport[74] = {
    5,0x1,     // USAGE_PAGE (Generic Desktop)
    0x9,0x2,   // USAGE (Mouse)
    0xa1,0x1,  // COLLECTION (Application)
     0x9,0x1,   // USAGE (Pointer)
     0xa1,0x0,  // COLLECTION (Physical)
      0x5,0x9,   // USAGE_PAGE (Button)
      0x19,0x1,  // USAGE_MIN (Button 1)
      0x29,0x3,  // USAGE_MAX (Button 3)
      0x15,0x0,  // LOGICAL_MINIMUM (0)
      0x25,0x1,  // LOGICAL_MAXIMUM (1)
      0x75,0x1,  // REPORT_SIZE (1)
      0x95,0x3,  // REPORT_COUNT (3)
      0x81,0x2,  // INPUT (Data, Var, Abs)
      0x75,0x5,  // REPORT_SIZE (5)
      0x95,0x1,  // REPORT_COUNT (1)
      0x81,0x1,  // INPUT (Constant)
      0x5,0x1,   // USAGE_PAGE (Generic Desktop)
      0x9,0x30,  // USAGE (X)
      0x9,0x31,  // USAGE (Y)
      0x9,0x38,  // USAGE (Wheel)
      0x15,0x81, // LOGICAL_MINIMUM (-127)
      0x25,0x7f, // LOGICAL_MAXIMUM (127)
      0x75,0x8,  // REPORT_SIZE (8)
      0x95,0x3,  // REPORT_COUNT (3)
      0x81,0x6,  // INPUT (Data, Var, Rel)
     0xc0,      // END_COLLECTION
     0x9,0x3c,  // USAGE (Motion Wakeup)
     0x5,0xff,  // USAGE_PAGE (Vendor Defined)
     0x9,0x1,   // USAGE (??)
     0x15,0x0,  // LOGICAL_MINIMUM (0)
     0x25,0x1,  // LOGICAL_MAXIMUM (1)
     0x75,0x1,  // REPORT_SIZE (1)
     0x95,0x2,  // REPORT_COUNT (2)
     0xb1,0x22, // FEATURE (Data, Var, Abs, No Preferred)
     0x75,0x6,  // REPORT_SIZE (6)
     0x95,0x1,  // REPORT_COUNT (1)
     0xb1,0x1,  // FEATURE (Constant)
    0xc0       // END_COLLECTION
};

#else /* !MOUSE */

#if KEYBOARD

/* NB: Not counting the "zero" one */
#define HAS_STRINGS 1
PRIVATE USB_STRING String1[] = 
    { (USB_DT_STRING<<8) | (66),
      /* "Microsoft Natural Keyboard Elite" */
      0x4d, 0x69, 0x63, 0x72, 0x6f, 0x73, 0x6f, 0x66, 0x74, 0x20,
      0x4e, 0x61, 0x74, 0x75, 0x72, 0x61, 0x6c, 0x20, 0x4b, 0x65,
      0x79, 0x62, 0x6f, 0x61, 0x72, 0x64, 0x20, 0x45, 0x6c, 0x69,
      0x74, 0x65
    };

PRIVATE USB_STRING_DESCRIPTOR Strings[] =
{ String1
};
#define nStrings (sizeof Strings / sizeof Strings[0] )

PRIVATE USB_DEVICE_DESCRIPTOR Myself = {
    sizeof(USB_DEVICE_DESCRIPTOR),
    USB_DT_DEVICE,
    Con2(USB_v2_0),
    0, 0, 0,          /* class,subclass,protocol */
    8,                /* max packet size */
    Con2(0x45e), Con2(0xb), Con2(0x207),   /* vendor,product,device*/
    0, 1, 0,          /* ix of manuf,product,serial number */
    1                 /* num configurations */
};

#define sizeof_Irene 34

PRIVATE _PACKED struct {
    USB_CONFIGURATION_DESCRIPTOR Config;
    USB_INTERFACE_DESCRIPTOR Iface;
    USB_HID_DESCRIPTOR Hid;
    USB_ENDPOINT_DESCRIPTOR Ep1;
} Irene = 
    {
      {
        sizeof(USB_CONFIGURATION_DESCRIPTOR),
        USB_DT_CONFIG,
        Con2(sizeof_Irene),   /* total length of all descs returned */
        1,               /* num interfaces */
        1,               /* config value */
        0,               /* ix of config */
        USB_AT_BUS_POWERED|USB_AT_REMOTE_WAKEUP,  /* attributes */
        100/2            /* max power */
      },{
        sizeof(USB_INTERFACE_DESCRIPTOR),
        USB_DT_IFACE,
        0,               /* iface no */
        0,               /* alternate */
        1,               /* num endp */
        USB_DC_HID, USB_DS_BOOT, USB_DP_KEYBOARD, /* class,subclass,protocol */
        0                /* ix of iface */
      },{
        sizeof(USB_HID_DESCRIPTOR),
        USB_DT_HID,
        Con2(0x110),    /* BcdHID */
        0,              /* CountryCode */
        1,              /* NumDescriptors to follow */
        USB_DT_REPORT,  /* ReportDescriptorType */
        Con2(63)        /* ReportDescriptorLength */
      },{
        sizeof(USB_ENDPOINT_DESCRIPTOR),
        USB_DT_ENDP,
        USB_EA_IN | 2,   /* address */
        USB_AE_INTERRUPT,/* attrib */
        Con2(8),         /* max pkt size */
        10               /* interval () */
      }
};

UINT8 IreneReport[63] = {
    0x05, 0x01,  // USAGE_PAGE (Generic Desktop)
    0x09, 0x06,  // USAGE (Keyboard)
    0xa1, 0x01,  // COLLECTION (Application)
      0x05, 0x07,  // USAGE_PAGE (Keyboard/Keypad)
      0x19, 0xe0,  // USAGE_MINIMUM (224)
      0x29, 0xe7,  // USAGE_MAXIMUM (231)
      0x15, 0x00,  // LOGICAL_MINIMUM (0)
      0x25, 0x01,  // LOGICAL_MAXIMUM (1)
      0x95, 0x08,  // REPORT_COUNT (8)
      0x75, 0x01,  // REPORT_SIZE (1)
      0x81, 0x02,  // INPUT (Data, Var, Abs)
      0x95, 0x01,  // REPORT_COUNT (1)
      0x75, 0x08,  // REPORT_SIZE (8)
      0x81, 0x01,  // INPUT (Constant)
      0x95, 0x05,  // REPORT_COUNT (5)
      0x75, 0x01,  // REPORT_SIZE (1)
      0x05, 0x08,  // USAGE_PAGE (LEDs)
      0x19, 0x01,  // USAGE_MINIMUM (1)
      0x29, 0x05,  // USAGE_MAXIMUM (5)
      0x91, 0x02,  // OUTPUT (Data, Var, Abs)
      0x95, 0x01,  // REPORT_COUNT (1)
      0x75, 0x03,  // REPORT_SIZE (3)
      0x91, 0x01,  // OUTPUT (Constant)
      0x95, 0x06,  // REPORT_COUNT (6)
      0x75, 0x08,  // REPORT_SIZE (8)
      0x15, 0x00,  // LOGICAL_MINIMUM (0)
      0x25, 0x65,  // LOGICAL_MAXIMUM (101)
      0x05, 0x07,  // USAGE_PAGE (Keyboard/Keypad)
      0x19, 0x00,  // USAGE_MINIMUM (0)
      0x29, 0x65,  // USAGE_MAXIMUM (101)
      0x81, 0x00,  // INPUT (Data, Array, Abs)
    0xc0         // END_COLLECTION
};

#else /* !KEYBOARD */

#if SERIAL_LINE  /* Intel's pseudo serial line (iPAQ & co). */

#define HAS_STRINGS 0

#define USB_R_SET_CONTROL_LINE_STATE 0x22
#define USB_CD_ACTIVATE_CARRIER 0x02
#define USB_CD_DTR_PRESENT 0x01
UINT SerialStatus = 0;

USB_DEVICE_DESCRIPTOR Myself = {
    sizeof(USB_DEVICE_DESCRIPTOR),
    USB_DT_DEVICE,
    Con2(USB_v1_0),
    0xff, 0xff, 0xff, /* class,subclass,protocol */
    8,                /* max packet size */
    Con2(0x5555), Con2(0x5555), Con2(0x201),   /* vendor,product,device*/
    0, 0, 0,          /* ix of manuf,product,serial number */
    1                 /* num configurations */
};

#define sizeof_Irene 32
struct {
    USB_CONFIGURATION_DESCRIPTOR Config;
    USB_INTERFACE_DESCRIPTOR Iface;
    USB_ENDPOINT_DESCRIPTOR Ep1;
    USB_ENDPOINT_DESCRIPTOR Ep2;
} Irene =
    {
      {
        sizeof(USB_CONFIGURATION_DESCRIPTOR),
        USB_DT_CONFIG,
        Con2(sizeof_Irene),   /* total length of all descs returned */
        1,               /* num interfaces */
        1,               /* config value */
        0,               /* ix of config */
        USB_AT_SELF_POWERED,  /* attributes */
        1                     /* max power */
      },{
        sizeof(USB_INTERFACE_DESCRIPTOR),
        USB_DT_IFACE,
        0,               /* iface no */
        0,               /* alternate */
        2,               /* num endp */
        0xff, 0xff, 0xff,/* class,subclass,protocol */
        0                /* ix of iface */
      },{
        sizeof(USB_ENDPOINT_DESCRIPTOR),
        USB_DT_ENDP,
        USB_EA_OUT | 1, /* address */
        USB_AE_BULK,    /* attrib */
        Con2(MAXOUT),   /* max pkt size */
        0               /* interval (n/a) */
      },{
        sizeof(USB_ENDPOINT_DESCRIPTOR),
        USB_DT_ENDP,
        USB_EA_IN | 2,  /* address */
        USB_AE_BULK,    /* attrib */
        Con2(MAXIN),    /* max pkt size */
        0               /* interval (n/a) */
      }
};

UINT8 IreneReport[1] = {0};

#endif /* SERIAL_LINE */
#endif /* KEYBOARD */
#endif /* MOUSE */

#if HAS_STRINGS

/* String descriptors
 * Index 0 is the array of LANGIDs
 * We only do English, regardless.
 */
PRIVATE UINT16 String0[] = { (USB_DT_STRING<<8) | (4), 0x409 };

#endif


typedef struct _IRENE {
//    struct CDevice CDevice;
    const struct IUsbSlaveDriverVtbl *v;
    BYTE RequestData[64];
} IRENE, *PIRENE;

#define pIRENE(_t_) ((PIRENE)(_t_))
#define pRR(_t_) ((PIRENE)(((BYTE *)_t_) - offsetof(UDC,v)))

SCODE IreneDriverQueryInterface (
        /*in*/ PIUSBSLAVEDRIVER pThis,
        /*in*/ REFIID iid,
        /*out*/ void** ppObject)
{
    PIRENE this = pRR(pThis);
    UnusedParameter(this);
    return E_NOT_IMPLEMENTED;
}

UINT IreneDriverAddRef (
        /*in*/ PIUSBSLAVEDRIVER pThis)
{
    PIRENE this = pRR(pThis);
    UnusedParameter(this);
    return 0;
}

UINT IreneDriverRelease (
        /*in*/ PIUSBSLAVEDRIVER pThis)
{
    PIRENE this = pRR(pThis);
    UnusedParameter(this);
    return 0;
}

SCODE IreneDriverGetDescriptor (
        /*in*/ PIUSBSLAVEDRIVER pThis,
        /*in*/ USBD_DESCRIPTOR_TYPE DescriptorType,
        /*in*/ UINT Index,
        /*out*/ BYTE ** ppDescriptor,
        /*out*/ UINT * pSize)
{
    PIRENE this = pRR(pThis);
    UnusedParameter(this);

    /* Validate arguments
     */
    if ((ppDescriptor == NULL) || (pSize == NULL))
        return E_INVALID_PARAMETER;

    switch (DescriptorType) {
    case USBD_DESCRIPTOR_DEVICE:
        *ppDescriptor = (BYTE*) &Myself;
        *pSize        = sizeof Myself;
        break;
    case USBD_DESCRIPTOR_CONFIGURATION:
        *ppDescriptor = (BYTE*) &Irene;
        *pSize        = sizeof_Irene;
        break;
    case USBD_DESCRIPTOR_REPORT:
        *ppDescriptor = (UINT8*) &IreneReport;
        *pSize        = sizeof IreneReport;
        break;
    case USBD_DESCRIPTOR_STRING:
#if HAS_STRINGS
        if (Index == 0) {
            *ppDescriptor = (UINT8*) &String0;
        } else if (Index <= nStrings) {
            *ppDescriptor = (UINT8*) Strings[Index-1];
        } else
            goto error;
        *pSize = (*ppDescriptor)[0];
        break;
#else
        goto error;
#endif
    case USBD_DESCRIPTOR_INTERFACE:
    case USBD_DESCRIPTOR_ENDPOINT:
    case USBD_DESCRIPTOR_DEVICE_QUALIFIER:
    case USBD_DESCRIPTOR_HID:
    case USBD_DESCRIPTOR_PHYSICAL:
    default:
    error:
        return E_NOT_IMPLEMENTED;
    }

    return S_OK;
}

SCODE IreneDriverSetDescriptor (
        /*in*/ PIUSBSLAVEDRIVER pThis,
        /*in*/ USBD_DESCRIPTOR_TYPE DescriptorType,
        /*in*/ UINT Index,
        /*in*/ const BYTE * Descriptor,
        /*in*/ UINT Size)
{
    PIRENE this = pRR(pThis);
    UnusedParameter(this);
    return E_NOT_IMPLEMENTED;
}

SCODE IreneDriverHandleRequest (
        /*in*/ PIUSBSLAVEDRIVER pThis,
        /*in*/ const PUSB_REQUEST_struct RequestPacket,
        /*inout*/ BYTE ** ppRequestData,
        /*inout*/ UINT * pSize)
{
    PIRENE this = pRR(pThis);
    BYTE *pData = *ppRequestData;

    switch (RequestPacket->Request) {

    case USB_R_GET_REPORT:      // 0x01
    case USB_R_GET_IDLE:        // 0x02
    case USB_R_GET_PROTOCOL:    // 0x03
        goto error;//NYI

    case USB_R_SET_REPORT:      // 0x09
        /* Did we get all we needed ?
         */
        if (pData == NULL) {
            /* Uhmm, definitely not
             * See how much the host wants to send us, trim if necessary
             */
            UINT Count = Get2(RequestPacket->Length);
            if (Count > sizeof this->RequestData)
                Count = sizeof this->RequestData;

            *pSize = Count;
            *ppRequestData = this->RequestData;
            return S_BUFFER_TOO_SMALL;
        }

        /* Got some data, all is well
         * BUGBUG Handle fragmented case for large xfers
         */
        break;

    case USB_R_SET_IDLE:        // 0x0a
    case USB_R_SET_PROTOCOL:    // 0x0b
        break;

#if SERIAL_LINE
    case USB_R_SET_CONTROL_LINE_STATE: // 0x22
        SerialStatus = Get2(RequestPacket->Value);
        break;
#endif

    default:
    error:
        return E_NOT_IMPLEMENTED;
    }

    return S_OK;
}

const struct IUsbSlaveDriverVtbl IreneVtbl = {
    __VTABLE_COMPATIBILITY_FILLER_INITIALIZER
    IreneDriverQueryInterface,
    IreneDriverAddRef,
    IreneDriverRelease,
    IreneDriverGetDescriptor,
    IreneDriverSetDescriptor,
    IreneDriverHandleRequest
};

/* Before split, avoid cob crap
 */
IRENE irr;

PIUSBSLAVEDRIVER IreneHack(void)
{
    irr.v = &IreneVtbl;

    return (PIUSBSLAVEDRIVER) &irr;
}
