/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <framebuffer.h>
#include <drivers\keybd_hw.h>
#include <drivers\mouse_hw.h>

extern void WinFbInit(void **ppState);

extern SCODE WinFbGetFramebufferAddress(PTR pState,
                                        PTR *pAddress);

extern SCODE WinFbGetProp(PTR pState,
                          FRAMEBUFFER_PROPERTY Property,
                          /*inout*/ UINT32 * Value);

extern SCODE WinFbSetMode (PTR pState,
                           FRAMEBUFFER_MODE Mode);

extern SCODE WinFbGetPalette(PTR pState,
                             /*out*/ UINT8* Buffer,
                             UINT Length,
                             PIXEL_ENCODING ExpectedPixelFormat);

extern SCODE WinFbGetPaletteEntry(PTR pState,
                                  UINT Index,
                                  /*out*/ UINT8* Buffer,
                                  UINT Length,
                                  PIXEL_ENCODING ExpectedPixelFormat);


extern SCODE WinFbSetPalette(PTR pState,
                             const UINT8* Buffer,
                             UINT Length,
                             PIXEL_ENCODING PixelFormat);

extern SCODE WinFbSetPaletteEntry(PTR pState,
                                  UINT Index,
                                  const UINT8* Buffer,
                                  UINT Length,
                                  PIXEL_ENCODING PixelFormat);

extern SCODE WinKbdRead(PTR pState,
                        PKEYBOARD_INPUT_DATA Report,
                        UINT *pSizeRead);

extern SCODE WinMsRead(PTR pState,
                       PMOUSE_INPUT_DATA Report,
                       UINT *pSizeRead);


