#include <mmlite.h>
#include <assert.h>
#define DBGLVL 0 /* rid of this once debugged */
#include <diagnostics.h>
#include "heap.h"

#include <s_GenericHeapFactory_v.c>

/*
 * This is the exported constructor
 */
/********************** IHeapFactory **********************/

SCODE GenericHeapFactoryQueryInterface (
                         /*in*/ PIHEAPFACTORY pThis,
                         /*in*/ REFIID iid,
                         /*out*/ void** ppObject
)
{
    DBGME(0,_tprintf(_TEXT("GenericHeapFactoryQI %x %x [%x %x %x %x]\n"),
                     (ADDRESS)pThis, (ADDRESS)ppObject, *iid));

    return GenericQueryInterface((PIUNKNOWN) pThis, iid, ppObject, &IID_IHeapFactory);
}

UINT GenericHeapFactoryAddRef (
        /*in*/ PIHEAPFACTORY pThis
)
{
    PHEAPCOB GenericHeapFactory = (PHEAPCOB) pThis;
    DBGME(0,_tprintf(_TEXT("GenericHeapFactoryAR %x\n"),(ADDRESS)pThis));
    return AtomicInc(&GenericHeapFactory->RefCnt);
}

UINT GenericHeapFactoryRelease (
                 /*in*/ PIHEAPFACTORY pThis
)
{
    PHEAPCOB GenericHeapFactory = (PHEAPCOB) pThis;
    UINT Refs;

    Refs = AtomicDec(&GenericHeapFactory->RefCnt);
    DBGME(0,_tprintf(_TEXT("GenericHeapFactoryR %x : %d\n"),(ADDRESS)pThis,Refs));
    /* Static object, no free */
    return Refs;
}

PRIVATE struct HEAPCOB GenericHeapHeapCobObject = {
    &GenericHeapFactoryVtbl,
    1
};

PIUNKNOWN GenericHeapCobMain(void)
{
    DBGME(0,_tprintf(_T("GenericHeapCobMain()\n")));

    return (PIUNKNOWN) &GenericHeapHeapCobObject;
}
