/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Glue code to let BaseInit drag in dbg_heap */

#include <mmlite.h>
#include <base/cons.h>

_IHeapFactory_CreateNested_METHOD_FUNC DebugHeapFactoryCreateNested;

PIHEAP CreateDebugHeap(const _TCHAR *Name, /* caller allocated */
                       UINT Flags,
                       UINT MaxSize,
                       UINT TrailerSize)
{
    SCODE sc;
    PIHEAP Heap, Master = CurrentHeap();

    sc = DebugHeapFactoryCreateNested(NULL,
                                      Master, Flags, MaxSize, TrailerSize,
                                      &Heap);
    if (FAILED(sc))
        return NULL;
    return Heap;
}
