/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Glue code to let MachineHeapCreate drag in the correct heap
 * implementation. Link base with this and ff_heap will be the system heap.
 */

#include <mmlite.h>
#include <mmmacros.h>
#include <base/cons.h>

_IHeapFactory_Create_METHOD_FUNC FirstFitHeapFactoryCreate;

PIHEAP RTLCALLTYPE CreateHeapFrom(ADDRESS Mem,
                      UINT Flags, ADDR_SIZE InitSize, ADDR_SIZE MaxSize)
{
    SCODE sc;
    PIHEAP Heap;
#if 1
    sc = FirstFitHeapFactoryCreate(NULL,
                                   Mem, Flags, InitSize, MaxSize,
                                   &Heap);
    if (FAILED(sc))
        return NULL;
    return Heap;
#else
    PIHEAPFACTORY HeapFactory;

    sc = CobPreLookup(_T("ff_heap.cob"), (PIUNKNOWN *) &HeapFactory);
    if (FAILED(sc)) {
        DBG(("CobPreLookup failed"));
        return NULL;
    }

    sc = HeapFactory->v->Create(HeapFactory,
                                Mem, Flags, InitSize, MaxSize,
                                &Heap);
    if (FAILED(sc))
        return NULL;

    return Heap;
#endif
}
