/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <sock.h>

#define __P(x) x
#define u_char UINT8
#define int16_t INT16
#define u_int16_t UINT16
#define int32_t INT32
#define u_int32_t UINT32
#ifdef _MSC_VER
#pragma warning(disable:4214)   /* bitfields not int */
#endif
#define __BEGIN_DECLS
#define __END_DECLS
extern int errno;
struct timeval {
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
};

int res_search(const char *name, int class, int type, u_char *answer, int anslen);
int res_query(const char *name, int class, int type, u_char *answer, int anslen);
#define INADDR_NONE 0xffffffff

/************************** stuff from winsock.h ***********************/

/*
 * The new type to be used in all
 * instances which refer to sockets.
 */
typedef u_int           SOCKET;
/*
 * Select uses arrays of SOCKETs.  These macros manipulate such
 * arrays.  FD_SETSIZE may be defined by the user before including
 * this file, but the default here should be >= 64.
 *
 * CAVEAT IMPLEMENTOR and USER: THESE MACROS AND TYPES MUST BE
 * INCLUDED IN WINSOCK.H EXACTLY AS SHOWN HERE.
 */
#ifndef FD_SETSIZE
#define FD_SETSIZE      64
#endif /* FD_SETSIZE */

typedef struct fd_set {
        u_short fd_count;               /* how many are SET? */
        SOCKET  fd_array[FD_SETSIZE];   /* an array of SOCKETs */
} fd_set;
#define FD_CLR(fd, set) do { \
    u_int __i; \
    for (__i = 0; __i < ((fd_set *)(set))->fd_count ; __i++) { \
        if (((fd_set *)(set))->fd_array[__i] == fd) { \
            while (__i < ((fd_set *)(set))->fd_count-1) { \
                ((fd_set *)(set))->fd_array[__i] = \
                    ((fd_set *)(set))->fd_array[__i+1]; \
                __i++; \
            } \
            ((fd_set *)(set))->fd_count--; \
            break; \
        } \
    } \
} while(set == 0)

#define FD_SET(fd, set) do { \
    if (((fd_set *)(set))->fd_count < FD_SETSIZE) \
        ((fd_set *)(set))->fd_array[((fd_set *)(set))->fd_count++]=(fd);\
} while(set == 0)

#define FD_ZERO(set) (((fd_set *)(set))->fd_count=0)

#define FD_ISSET(fd, set) __WSAFDIsSet((SOCKET)(fd), (fd_set *)(set))

#ifdef i386
#define PASCAL __stdcall
#else
#define PASCAL
#endif

SOCKET PASCAL socket (int af, int type, int protocol);
int PASCAL connect (SOCKET s, const struct sockaddr *name, int namelen);

int PASCAL send (SOCKET s, const char * buf, int len, int flags);

int PASCAL sendto (SOCKET s, const char * buf, int len, int flags,
                       const struct sockaddr *to, int tolen);

int PASCAL closesocket (SOCKET s);
int PASCAL select (int nfds, fd_set *readfds, fd_set *writefds,
                       fd_set *exceptfds, const struct timeval *timeout);
int PASCAL recv (SOCKET s, char * buf, int len, int flags);

int PASCAL recvfrom (SOCKET s, char * buf, int len, int flags,
                         struct sockaddr *from, int * fromlen);
int PASCAL gethostname (char * name, int namelen);
int PASCAL setsockopt (SOCKET s, int level, int optname,
                           const char * optval, int optlen);
int PASCAL bind (SOCKET s, const struct sockaddr *addr, int namelen);
