/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * Copyright (c) 1982, 1986, 1990, 1993
 *      The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      @(#)sys_socket.c        8.1 (Berkeley) 6/10/93
 */

#include <sock.h>
#include <domain.h>

#define __WANTS_STATS 0
#if __WANTS_STATS
#define STATS_INC(_x_) AtomicInc(&(_x_))
#define STATS_DEC(_x_) AtomicDec(&(_x_))
static struct mbstat mbstat;
#else
#define STATS_INC(_x_)
#define STATS_DEC(_x_)
#endif

#if 0
soo_stat(so, ub)
        register struct socket *so;
        register struct stat *ub;
{
        bzero((caddr_t)ub, sizeof (*ub));
        ub->st_mode = S_IFSOCK;
        return ((*so->so_proto->pr_usrreq)(so, PRU_SENSE,
            (struct mbuf *)ub, (struct mbuf *)0, 
            (struct mbuf *)0));
        return (EOPNOTSUPP);
}
#endif

/* From u_mbuf.c: only applicable when inside protocol stack.
 *
 * Ask protocols to free up space, if possible
 */
void
m_reclaim(void)
{
    struct domain *dp;
    const struct protosw *pr;

    NetLock();
    for (dp = domains; dp; dp = dp->dom_next)
        for (pr = dp->dom_protosw; pr < dp->dom_protoswNPROTOSW; pr++)
            if (pr->pr_drain)
                (*pr->pr_drain)();
    NetUnlock();
    STATS_INC(mbstat.m_drain);
}
