
#ifndef __queue_h__
#define __queue_h__

#ifdef __cplusplus
extern "C"{
#endif 

typedef struct IQueue IQueue;

typedef struct  _QUEUENODE
{
    struct _QUEUENODE * volatile pNext;
    IQueue *ReturnQueue;
    UINT32  Request;
    UINT32  Result;
} QUEUENODE;

EXTERN_C const struct IID IID_IQueue;
    
    typedef struct IQueueVtbl
    {
        __VTABLE_COMPATIBILITY_FILLER_DECLARATION

    SCODE ( MCT *QueryInterface )( 
        IQueue *This,
        /* [in] */ REFIID Iid,
        /* [out] */ void **ppObject);
    
    UINT ( MCT *AddRef )( 
        IQueue *This);
    
    UINT ( MCT *Release )( 
        IQueue *This);
    
    void ( MCT *Put )( 
        IQueue *This,
        QUEUENODE *pMsg);
    
    BOOL ( MCT *PutFromInterrupt )( 
        IQueue *This,
        QUEUENODE *pMsg);
    
    QUEUENODE *( MCT *Get )( 
        IQueue *This);
    
    QUEUENODE *( MCT *GetFromInterrupt )( 
        IQueue *This);

    PCONDITION ( MCT *GetConditionVariable )( 
        IQueue *This);
    } IQueueVtbl;

    struct IQueue
    {
    CONST_VTBL struct IQueueVtbl *v;
    };


SCODE QueueCreate(PCONDITION pCond, 
    IQueue **ppIQueue);

#ifdef __cplusplus
}
#endif

#endif
