/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <fred.h>
#include <vmemif.h>

extern PIVMVIEW TheCurrentVmView;	/* XXX */

void HWLoadThreadContext(PCXTINFO CxtInfo);

CXTINFO *_Reschedule( CXTINFO *pState )
{
    PITHREAD NextThread, ThisThread;

    /* Return immediately if we cannot reschedule.
     */
    if (Cbs.PreemptionDisableCount) {
/*         WriteLogEntry(LOG_NO_RESCHEDULE, (UINT)pState); */
        RescheduleNeeded(); /* later */
        /*printf("Hit upon preemption disabled..\n");*/
        return pState;
    }

/* Don't switch away from Angel.
 */
#ifdef ANGELX
if (0 && ((pState->CPSR & 0x1f) == 0x10 || pState->PC < 0x8000 || pState->PC >= 0x20000)) {
    TIME t = Int64Initializer(0,TIME_MILLIS(1));

    SetNextInterrupt(t, NULL);
    return pState;
}
#endif

    /* Remember where we stored our state
     * BUGBUG can this be done with interrupts on ?
     */
    ThisThread = CurrentThread();

    if (Cbs.FirstThreadBooted)
        pTH(ThisThread)->CxtInfo = pState;
    Cbs.FirstThreadBooted = TRUE;

#if 0
Restart:
#endif
    /* Rescheduling path cannot be reentrant.
     */
    Cbs.PreemptionDisableCount++;

    /* Interrupts ok now
     */
    IntOn();

    /* Invoke scheduler to find who should run next
     */
    NextThread = CbsReschedule(pTheScheduler, ThisThread);

    /* Decided who should run next. No more interrupts.
     */
    IntOff();
    Cbs.PreemptionDisableCount--;

#if 0
    if (Cbs.ContextSwitchNeeded) {
        ThisThread = NextThread;
        goto Restart;
    }
#endif

    /* Switch address spaces if necessary */
    if (TheCurrentVmView != pTH(NextThread)->pVmView) {
	register PIVMVIEW vv = pTH(NextThread)->pVmView;
	if (vv) {
	    TheCurrentVmView = vv;
	    vv->v->SwitchTo(vv);
	}
    }

    return  pTH(NextThread)->CxtInfo;
}

#define LoadThreadContext(_th_) \
    HWLoadThreadContext(pTH(_th_)->CxtInfo)


