/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include "listfunc.h"

/* Insert new node pNew after an existing node pNode.
 * Returns pointer to the new node.
 */
PLISTNODE ListInsert(PLISTNODE pNode, PLISTNODE pNew)
{
    if (pNode == NULL)
        pNew->pNext = pNew->pPrev = pNew;
    else {
        pNew->pNext = pNode->pNext;
        pNew->pNext->pPrev = pNew;
        pNode->pNext = pNew;
        pNew->pPrev = pNode;
    }
    return pNew;
}

/* Remove a node from a list.
 * Returns pointer to the next node; NULL if this was the only node.
 */
PLISTNODE ListRemove(PLISTNODE pNode)
{
    PLISTNODE pNext;

#if 0 /* Valuable debug code for x86 - don't remove */
    if ((((UINT) pNode) & 0xffff0000) == 0xcccc0000) {
        UINT fp,ra,fp2,ra2;
        __asm {
                mov fp,ebp
                mov eax,[ebp+4]
                mov ra,eax
                mov eax,[ebp]
                mov fp2,eax
                mov eax,[eax+4]
                mov ra2,eax
              }
        dprintf("fp %08x ra %08x Caller's fp %08x ra %08x\n",fp,ra,fp2,ra2);

        DebugBreak();
    }
#endif

    if ((pNext = pNode->pNext) == pNode)
        return NULL;

    pNext->pPrev = pNode->pPrev;
    pNode->pPrev->pNext = pNext;
    pNode->pPrev = pNode->pNext = pNode;
    return pNext;
}

