/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <util/string.h>


/* Compares the part of the string only till / or \. For example strings such as demo and demo/test are equal*/

int _tcscmpprefix(const _TCHAR *pStr1, const _TCHAR *pStr2)
{
_TCHAR c1, c2;
    INT v=0;
    INT v1;

    do {
        v1= v;
        c1 = *pStr1++;
        c2 = *pStr2++;
        /* the casts are necessary when pStr1 is shorter & char is signed */
        v = (UINT)c1 - (UINT)c2;
    } while ((v == 0) && ((c1 != _T('\0')) && (c1 != _T('\\')) && (c1 != _T('/'))));

    if(c1 == _T('\\') || c1 == _T('/'))
        return v1;
    else
        return v;
}

/*Returns the part of the string after the first '/' or '\' */
const _TCHAR* _tcsreturnfield(const _TCHAR *pStr1)
{
    _TCHAR c1;
  //  _TCHAR *pStr2 = malloc(strlen(pStr1));
   // _tcscpy(pStr2,pStr1);
   // _TCHAR* temp;
    do {
        c1 = *pStr1++;
        /* the casts are necessary when pStr1 is shorter & char is signed */
    } while ((c1 != _T('\0')) && (c1 != _T('\\')) && (c1 != _T('/')));


   if(c1 == _T('\0'))
       return NULL;
   else 
       return pStr1; 
}

/*Returns the part of the string after the first '/' or '\' . The only difference is , in case of null it returns the original string*/
const _TCHAR* _tcsreturnsuffix(const _TCHAR *pStr1)
{
    _TCHAR c1;
    const _TCHAR *pStr2 = pStr1;

   // _TCHAR* temp;
    do {
        c1 = *pStr1++;
        /* the casts are necessary when pStr1 is shorter & char is signed */
    } while ((c1 != _T('\0')) && (c1 != _T('\\')) && (c1 != _T('/')));


   if(c1 == _T('\0'))
       return pStr2;
   else 
       return pStr1; 
}

/*Returns the part of the string before the first '/' or '\'. Allocates memory. */
_TCHAR* _tcsreturnprefix(const _TCHAR *pStr1)
{
    _TCHAR c1;
    _TCHAR *dest = malloc((_tcslen(pStr1) + 1) * sizeof(_TCHAR));
    UINT count = 0;
    do {
        c1 = *pStr1++;
        dest[count] = c1;
        count++;
        /* the casts are necessary when pStr1 is shorter & char is signed */
    } while ((c1 != _T('\0')) && (c1 != _T('\\')) && (c1 != _T('/')));
 
    dest[count-1] = _T('\0');
    return dest; 
}
