// Copyright (c) Microsoft Corporation. All rights reserved.
//
 
// Test script for SOAP server. 
// Runs on Windows using SOAP Toolkit 3.0.
// Sends a WS-Action behavior message.


var BASE_SOAP_ACTION_URI = "http://tempuri.org/whatever";
var WRAPPER_ELEMENT_NAMESPACE = "http://tempuri.org/X-Action/0.01";

var host1 = "127.0.0.1";
var proto1 = "http";
var proto2 = "x-udp-soap";

var rpns = "http://schemas.xmlsoap.org/rp";
var rsns = "http://tempuri.org/X-Action/0.01";

// @relay is not part of soap 1.1 so can't add; SOAP-ENV:relay=\"1\"
var rsrv = 
  "<rs:behavior xmlns:rs=\"" + rsns + "\" name=\"test\" > \
      <rs:reservation name=\"Producer\" duration=\"P0.1S\"> \
        <trigger what=\"Message\"/> \
      </rs:reservation> \
      <rs:reservation xmlns:rs=\"" + rsns + "\" name=\"Message\" duration=\"P0.1S\"> \
        <trigger what=\"Consumer\"/> \
     </rs:reservation> \
      <rs:reservation xmlns:rs=\"" + rsns + "\" name=\"Consumer\" duration=\"P0.1S\"> \
     </rs:reservation> \
 </rs:task>";
 
//x-udp-aes-soap
var END_POINT_URL = "http://" + host1 + "/COB/wsres.cob"
 
WScript.echo("Sending request to: " + END_POINT_URL);
 
var Answer
 
Answer = Execute(END_POINT_URL, "SetLed", 5, 28)
WScript.Echo("return=" + Answer);
WScript.Echo("done");
 
function Execute(EndPointURL, Method, A, B)
{
 
    var Serializer;
    var Reader;
    var Connector;
    
    Connector = WScript.CreateObject("MSSOAP.HttpConnector30");
    Connector.Property("EndPointURL") = EndPointURL;
 
Connector.Property("Timeout") = 100000; 
    
    Connector.Property("SoapAction") = BASE_SOAP_ACTION_URI & Method;
    Connector.BeginMessage();
    
    Serializer = WScript.CreateObject("MSSOAP.SoapSerializer30");
    Serializer.Init(Connector.InputStream);
    
    Serializer.StartEnvelope();
    Serializer.StartBody("STANDARD");
    Serializer.WriteXML(rsrv);
    Serializer.EndBody();
    Serializer.EndEnvelope();
    
    Connector.EndMessage();
    
    Reader = WScript.CreateObject("MSSOAP.SoapReader30");
    Reader.Load(Connector.OutputStream);
    
    if( Reader.Fault == null )
    {
        return Reader.Envelope.xml;
    }
    else
    {
        return "FAULT: " + Reader.FaultString.text;
    }    
}
 
