/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include "../convert/ssoap.h"

typedef struct SAMPLECALCULATOR{
    struct ISampleCalculatorVtbl const *v;
    UINT                Refs;
    PSELFINFO           Self;
    PICYPHER            Cypher;
    char                *InfoFileName;
    _TCHAR                *OwnerURL;
    CERTIFICATE         ClientCert;
    BYTE XXXPad[128]; /* XXX RSA usage overwrites buffer BUGBUG XXX */
    MUTEX InitOwnerLock; 
    SESSIONKEY    SKey;
    BOOL isSKeyValid;
} SAMPLECALCULATOR, *PSAMPLECALCULATOR;

/* Convert between interface and instance pointer and vice versa */
#define pSAMPLECalculator(_i_) ((PSAMPLECALCULATOR)((_i_)))
#define iSAMPLECalculator(_p_) ((PISAMPLECALCULATOR)((_p_)))

SCODE CryptABlock(/*in*/PICYPHER Cypher,
            /*in*/void *InText,
            /*in*/UINT InTextLen,
            /*in*/const BYTE *Key,
            /*in*/UINT Flag,
            /*out*/void *OutText);

SCODE SignCertificate(PICYPHER Cypher,
                    /*in*/BYTE *cert, 
                    /*out*/BYTE *signedCert,
                    /*in*/PBSAFE_KEY PriKey);

SCODE VerifyCertificate(PICYPHER Cypher, 
                       /*in*/BYTE *SignedCert,
                       /*out*/BYTE *UnsignedCert,
                       /*in*/PBSAFE_KEY PubKey);

SCODE SetSessionKey(PISAMPLECALCULATOR calc,
                    /*in*/PIHTTPCONNECTOR pConn,
                    /*in*/const _TCHAR *PartnerURL,
                    /*in*/CERTIFICATE PartnerCert,
                    /*out*/PSESSIONKEY SKey);

SCODE ClearSessionKey(/*in*/PIHTTPCONNECTOR pisc,
                      /*in*/const _TCHAR *PartnerURL,
                      /*out*/PSESSIONKEY SKey);

SCODE ParnerAuthenticate(PISAMPLECALCULATOR calc,
                         /*in*/PIHTTPCONNECTOR pConn,
                         /*in*/const _TCHAR *PartnerURL,
                         /*out*/PCERTIFICATE PartnerCert);
