// Copyright (c) Microsoft Corporation. All rights reserved.
//
 
// Test script for SOAP server. 
// Runs on Windows using SOAP Toolkit 3.0.
// Sends a WS-Routing message.


var BASE_SOAP_ACTION_URI = "http://tempuri.org/Calc/action/Calc.";
var WRAPPER_ELEMENT_NAMESPACE = "http://tempuri.org/Calc/message/";
 
var host1 = "172.31.46.200";
var host1 = "127.0.0.1";
//var host1 = "127.0.0.1:4000";
var host2 = "127.0.0.1";
var proto1 = "http";
var proto2 = "x-udp-soap";
 
var rpns = "http://schemas.xmlsoap.org/rp";
var rsns = "http://tempuri.org/X-Reservation/0.01";

// @relay is not part of soap 1.1 so can't add; SOAP-ENV:relay=\"1\"
var rsrv = 
  "<rs:task xmlns:rs=\"" + rsns + "\" name=\"test\" > \
      <rs:reservation name=\"a\" deadLine=\"2004-12-31T00:00:00.5Z\" tolerance=\"P456S\" duration=\"P0.1S\"> \
            <rs:resource name=\"led0\"> \
                  <rs:quantity>10</rs:quantity> \
            </rs:resource> \
            <rs:resource name=\"led2\"> \
                  <rs:quantity>777</rs:quantity> \
            </rs:resource> \
      </rs:reservation> \
      <rs:reservation xmlns:rs=\"" + rsns + "\" name=\"b\" deadLine=\"2004-12-31T00:00:00.2Z\" tolerance=\"P82S\" duration=\"P0.1S\"> \
            <rs:resource name=\"led1\"> \
                  <rs:quantity>99</rs:quantity> \
            </rs:resource> \
            <rs:resource name=\"led3\"> \
                  <rs:quantity>9999</rs:quantity> \
            </rs:resource> \
     </rs:reservation> \
 </rs:task>";
 
var path = 
      "<rp:path xmlns:rp=\"" + rpns + "\"> \
            <rp:action>" + BASE_SOAP_ACTION_URI + "</rp:action> \
            <rp:fwd> \
                  <rp:via rp:reservation=\"test/b\">" + proto1 + "://" + host1 + "/COB/calc.cob</rp:via> \
                  <rp:via rp:reservation=\"test/a\">" + proto2 + "://" + host2 + "/COB/calc.cob</rp:via> \
            </rp:fwd> \
            <rp:rev> \
                  <rp:via/> \
            </rp:rev> \
      </rp:path>";
      
var meth = 
      "<m:SetLed xmlns:m=\"" + WRAPPER_ELEMENT_NAMESPACE + "\" > \
            <m:A>0</m:A> \
            <m:B>1</m:B> \
      </m:SetLed>";
 
//x-udp-aes-soap
var END_POINT_URL = "http://" + host1 + "/"
//var END_POINT_URL = "http://172.31.41.244/COB/calc.cob"
//var END_POINT_URL = "https://t-yongx/MSSoapSamples30/Calc/Service/SrSz/AspJs/Calc.asp"
 
WScript.echo("Sending request to: " + END_POINT_URL);
 
var Answer
 
Answer = Execute(END_POINT_URL, "SetLed", 5, 28)
WScript.Echo("leds=" + Answer);
 
Answer = Execute(END_POINT_URL, "SetLed", 3, 28)
WScript.Echo("leds=" + Answer);
 
Answer = Execute(END_POINT_URL, "SetLed", 5, 0)
Answer = Execute(END_POINT_URL, "SetLed", 3, 0)
WScript.Echo("leds=" + Answer);
 
WScript.Echo("done");
 
function Execute(EndPointURL, Method, A, B)
{
 
    var Serializer;
    var Reader;
    var Connector;
    
    Connector = WScript.CreateObject("MSSOAP.HttpConnector30");
    Connector.Property("EndPointURL") = EndPointURL;
 
Connector.Property("Timeout") = 100000; 
    
    Connector.Property("SoapAction") = BASE_SOAP_ACTION_URI & Method;
    Connector.BeginMessage();
    
    Serializer = WScript.CreateObject("MSSOAP.SoapSerializer30");
    Serializer.Init(Connector.InputStream);
    
    Serializer.StartEnvelope();
    Serializer.StartHeader();
    Serializer.WriteXML(path);
    Serializer.WriteXML(rsrv);
    Serializer.EndHeader();
    Serializer.StartBody("STANDARD");
    Serializer.WriteXML(meth);
    Serializer.EndBody();
    Serializer.EndEnvelope();
    
    Connector.EndMessage();
    
    Reader = WScript.CreateObject("MSSOAP.SoapReader30");
    Reader.Load(Connector.OutputStream);
    
    if( Reader.Fault == null )
    {
        return Reader.RpcResult.text;
    }
    else
    {
        return "FAULT: " + Reader.FaultString.text;
    }    
}
 
