/* Copyright (c) Microsoft Corporation. All rights reserved. */

#define P (struct PossibleStates2*)

const static struct PossibleStates2 pos[11] = {
    {_T("Non-Critical"),       {P &pos[1], P &pos[10]}},
    {_T("Lower Non-Critical"), {P &pos[2], P &pos[0]}},
    {_T("Upper Non-Critical"), {P &pos[3], P &pos[1]}},
    {_T("Critical"),           {P &pos[4], P &pos[2]}},
    {_T("Lower Critical"),     {P &pos[5], P &pos[3]}},
    {_T("Upper Critical"),     {P &pos[6], P &pos[4]}},
    {_T("Fatal"),              {P &pos[7], P &pos[5]}},
    {_T("Lower Fatal"),        {P &pos[8], P &pos[6]}},
    {_T("Upper Fatal"),        {P &pos[9], P &pos[7]}},
    {_T("Normal"),             {P &pos[10], P &pos[8]}},
    {_T("Unknown"),            {P &pos[0], P &pos[9]}}
};

#define SEN(_name_,_id_,_type_,_units_,_mod_) {{ \
    _T("[Caption]"), \
    _T("[Description]"), \
    _T(# _name_), \
    \
    Int64Initializer(0,0), \
    _T("[Name]"), \
    _T("OK"), \
    _T("OK"), \
    \
    _T("Enabled"), \
    _T("[OtherEnabledState]"), \
    _T("Not Applicable"), \
    _T("[EnabledDefault]"), \
    Int64Initializer(0,0), \
    \
    _T("demo_sensor"), \
    _T(# _name_), \
    _T("[OtherIdentifyingInfo]"), \
    _T("[IdentifyingDescriptions]"), \
    \
    _type_, \
    _T("[OtherSensorTypeDescription]"), \
    P pos, \
    _T("Normal"), \
    \
    _mod_, \
    _units_, \
    0, \
    _T("[SettableThreasholds]"), \
    _T("[SupportedThresholds]"), \
    _T("Tech Ed Demo System"), \
    _T("UnaryComputerSystem")}, _id_}

#if 0
DemoSensor zz = {{
    _T("[Caption]"), 
    _T("[Description]"), 
    _T("_name"), 
    
    Int64Initializer(0,0), 
    _T("[Name]"), 
    _T("OK"), 
    _T("OK"), 
    
    _T("Enabled"), 
    _T("[OtherEnabledState]"), 
    _T("Not Applicable"), 
    _T("[EnabledDefault]"), 
    Int64Initializer(0,0), 
    
    _T("demo_sensor"), 
    _T(" _name"), 
    _T("[OtherIdentifyingInfo]"), 
    _T("[IdentifyingDescriptions]"), 
    
    22, 
    _T("[OtherSensorTypeDescription]"), 
    pos, 
    _T("Normal"), 
    
    4444, 
    6666, 
    0, 
    _T("[SettableThreasholds]"), 
    _T("[SupportedThresholds]"), 
    _T("Tech Ed Demo System"), 
    _T("UnaryComputerSystem")}, 0};
#endif

PRIVATE const DemoSensor _demo_init_data[] = {
    SEN(CPU0_Temp,           0, 2, 2, 0),
    SEN(CPU1_Temp,           1, 2, 2, 0),
    SEN(CPU2_Temp,           2, 2, 2, 0),
    SEN(CPU3_Temp,           3, 2, 2, 0),
    SEN(MB0_Temp,            4, 2, 2, 0),
    SEN(MB1_Temp,            5, 2, 2, 0),
    SEN(MB2_Temp,            6, 2, 2, 0),
    SEN(MB3_Temp,            7, 2, 2, 0),
    SEN(VRM0_Temp,           8, 2, 2, 0),
    SEN(VRM1_Temp,           9, 2, 2, 0),
    SEN(VRM2_Temp,          10, 2, 2, 0),
    SEN(VRM3_Temp,          11, 2, 2, 0),

    SEN(Volt1,              12, 3, 5, -1),
    SEN(Volt2,              13, 3, 5, -1),
    SEN(Volt3,              14, 3, 5, -1),
    SEN(Volt4,              15, 3, 5, -1),
    SEN(Volt5,              16, 3, 5, -1),

    SEN(Power GPIO,         17, 7, 60, 0),
    SEN(Reset GPIO,         18, 7, 60, 0),
    SEN(NMI GPIO,           19, 7, 60, 0),
    SEN(SMI GPIO,           20, 7, 60, 0),
    SEN(PCI_Reset GPIO,     21, 7, 60, 0),
    SEN(mCard_ID0 GPIO,     22, 7, 60, 0),
    SEN(mCard_ID1 GPIO,     23, 7, 60, 0),
    SEN(mCard_ID2 GPIO,     24, 7, 60, 0),
    SEN(Fault_LED GPIO,     25, 7, 60, 0),
    SEN(Chassis_ID GPIO,    26, 7, 60, 0),
    SEN(Local_Lockout GPIO, 27, 7, 60, 0),
    SEN(SCI_Int GPIO,       28, 7, 60, 0),
    SEN(Clear_CMOS GPIO,    29, 7, 60, 0),
    SEN(Therm_Trip GPIO,    30, 7, 60, 0),
    SEN(ACPI0 GPIO,         31, 7, 60, 0),
    SEN(ACPI1 GPIO,         32, 7, 60, 0),
    SEN(ACPI2 GPIO,         33, 7, 60, 0),
    SEN(Power_OK GPIO,      34, 7, 60, 0),
    SEN(AC_OK GPIO,         35, 7, 60, 0)
};

#define DEMO_INIT_COUNT sizeof(_demo_init_data)/sizeof(DemoSensor)
