/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <dbres.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct _DemoGyroPolicy {
    struct GyroPolicy super;
    UINT UnitID;
} DemoGyroPolicy;


PRIVATE SCODE Demo_GyroPolicy_Get(const PropertyClass *Class, PTR Value, CurrentRequest *currentRequest)
{
    return S_OK;
}

PRIVATE SCODE Demo_GyroPolicy_Put(const PropertyClass *Class, PTR Value)
{    
    return S_OK;
}

/* Initialize private fields */
PRIVATE SCODE Demo_GyroPolicy_Init(const PropertyClass *Class, PTR Value,
                                /*unused*/ PIHEAP Heap,PICIMRESOURCE Resource)
{
    DemoGyroPolicy *sub = Value;
 
#if 0
    /* Disallow aboslute time in minimum wait */
    if (!TimeIsRelative(app->MinimumWait)) {
        app->MinimumWait = TIME_ORIGIN;
        return E_INVALID_PARAMETER;
    }
    
#endif
    return S_OK;
}

PRIVATE SCODE Demo_GyroPolicy_Copy(const PropertyClass *Class,
                                PTR _Dst, const void *_Src, PIHEAP Heap)
{
    DemoGyroPolicy *sub = _Dst;
    const DemoGyroPolicy *src = _Src;

    sub->UnitID = src->UnitID;

    return S_OK;
}

PRIVATE SCODE Demo_GyroPolicy_Apply(const PropertyClass *Class,
                                PICIMRESOURCE AppliedResource, PICIMRESOURCE Resource)
{
    CimResource *cim_app = (CimResource *) AppliedResource;
    CimResource *cim_res = (CimResource *) Resource;
    
    struct GyroPolicy *app = cim_app->Value;
    struct StickState *res = cim_res->Value;
    TIME t;

    SCODE sc = S_OK;

    if(app->LowerThreshold)
        if((res->AxisA < (app->LowerThreshold + 100000)) && (res->AxisB < (app->LowerThreshold + 100000)))
            sc = E_FAIL;

    if(sc == S_OK) {
        if(!Int64IsZero(app->MinimumWait)) {
            t = TimeSubtract(app->LastNotificationTime, app->MinimumWait);
            if(TimeLess(CurrentTime(), t)) {
                sc = E_FAIL;
            }
            else {
                app->LastNotificationTime = CurrentTime();
            }
        }
    }

    return sc;
}

extern const PropertyClass GyroPolicy_Prop;

const PropertyClass Demo_GyroPolicy_Prop = {
    _T("dssp:demo_GyroPolicy"), _T("demo_GyroPolicy"),
    sizeof(DemoGyroPolicy),
    _T("dssp:GyroPolicy"), _T("dssp:GyroPolicy"),
    &GyroPolicy_Prop,
    Demo_GyroPolicy_Get, Demo_GyroPolicy_Put,
    Demo_GyroPolicy_Init, NULL, Demo_GyroPolicy_Copy,
    NULL, NULL, NULL,NULL, NULL /*Demo_GyroPolicy_Start*/,
    Demo_GyroPolicy_Apply
};
