/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <dbres.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct _DemoSubscription {
    struct Subscription super;
    PIDSSP peer;
} DemoSubscription;


PRIVATE SCODE Demo_Subscription_Get(const PropertyClass *Class, PTR Value, CurrentRequest *currentRequest)
{
    return S_OK;
}

PRIVATE SCODE Demo_Subscription_Put(const PropertyClass *Class, PTR Value)
{    
    return S_OK;
}

/* Initialize private fields */
PRIVATE SCODE Demo_Subscription_Init(const PropertyClass *Class, PTR Value,
                                /*unused*/ PIHEAP Heap,PICIMRESOURCE Resource)
{
    DemoSubscription *sub = Value;

    return S_OK;
}

PRIVATE SCODE Demo_Subscription_Copy(const PropertyClass *Class,
                                PTR _Dst, const void *_Src, PIHEAP Heap)
{
    DemoSubscription *sub = _Dst;
    const DemoSubscription *src = _Src;

    return S_OK;
}

PRIVATE SCODE Demo_Subscription_Apply(const PropertyClass *Class,
                                PICIMRESOURCE Subscription, PICIMRESOURCE Resource)
{
    CimResource *cim_sub = (CimResource *) Subscription;
    CimResource *cim_res = (CimResource *) Resource;
    struct Subscription *sub = cim_sub->Value;

    EndpointReference ep = {0,};
    WSCONTEXT ctx = {0,};

    PIDSSP dssp = NULL;

    PISOAPFACTORY soapfactory = NULL;
    _TCHAR MessageId[50];
    SCODE sc = S_OK;

    _tcscpy(MessageId, _T("uuid:E9E02CCC-5EB2-4A46-0000-000000000000"));
                            {
                                TIME t = CurrentTime();
                                INT tt = Int64ToInt32(t);

                                _stprintf(MessageId + 29, _T("%012u"), tt);
                            }

    ep.Address = sub->Subscriber;

    ctx.To = &ep;
    ctx.ReplyTo = NULL;
    ctx.MessageId = MessageId;
    ctx.ForwardedAction = _T("http://schemas.microsoft.com/xw/2004/10/dssp.html:ReplaceRequest");


    sc = BindToObject(CurrentNameSpace(), _T("COB/soap.cob"), NAME_SPACE_READ,
                          &IID_ISoapFactory, (void **) &soapfactory);

    sc = soapfactory->v->CreateProxy3(soapfactory, NULL,
                                          &ctx, _T("dssp"),
                                          0,
                                          (PIUNKNOWN*) &dssp);
        
#ifndef _MINIMIZE
    printf("wstest Created dssp proxy: wxf=%x iunk=%x sc=%x\n",
           (UINT) dssp, (UINT) &IID_IUnknown, sc);
#endif
    sc = dssp->v->NotifyRequest(dssp,                      
                                ep.Address,                        
                                _T("http://schemas.microsoft.com/xw/2004/10/dssp.html:ReplaceRequest"),
                                cim_res->Value,                                   
                                _T("st1:StickState")                
                                );

    RELEASE_NULL(dssp); 
    
    return sc;
}

extern const PropertyClass Subscription_Prop;

const PropertyClass Demo_Subscription_Prop = {
    _T("dssp:demo_subscription"), _T("demo_subscription"),
    sizeof(DemoSubscription),
    _T("dssp:Subscription"), _T("dssp:Subscription"),
    &Subscription_Prop,
    Demo_Subscription_Get, Demo_Subscription_Put,
    Demo_Subscription_Init, NULL, Demo_Subscription_Copy,
    NULL, NULL, NULL,NULL, NULL /*Demo_Subscription_Start*/,
    Demo_Subscription_Apply
};
