/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include "demotevidence.h"
#include <ctype.h>
#include <limits.h>
#include <stdlib.h>

#define DEMO_TRUST_EVIDENCE_OK 0

int GetTrustEvidence(UINT8 ID, UINT8 * val);
int SetTrustEvidence(UINT8 ID, UINT8 * val);

int GetTrustEvidence(UINT8 ID, UINT8 * val)
{
    return DEMO_TRUST_EVIDENCE_OK;
}

int SetTrustEvidence(UINT8 ID, UINT8 * val)
{
    return DEMO_TRUST_EVIDENCE_OK;
}

PRIVATE SCODE DemoTrustEvidence_Get(const PropertyClass *Class, PTR Value, CurrentRequest *currentRequest)
{
         DemoTrustEvidence *dte = Value;
        if(dte->super.Url){
          PICIMRESOURCE Resource=NULL;
          PICIMRESOURCE Context = currentRequest->Context;
          struct Selector  selector;
          selector.Name = _T("Name");
          selector.Value = dte->super.Url;
          selector.Type = NULL;
          selector.ListNode_Selector.pNext = &selector;
          selector.ListNode_Selector.pPrev = &selector;
       //   CimResourceRefresh(Context, _T("TrustScript"), &selector, OutValue);
          Resource = CimResourceShadowLookup(Context, _T("DemoTrustScript"), &selector);
          if(Resource)
          {
              dte->super.Value = CimResourceGetValue(Resource, currentRequest,_tcsreturnfield(dte->super.Url));
              dte->super.RequiredEvidenceUrl = ((TrustScript *)((CimResource *)Resource)->Value)->RequiredEvidenceUrl;
          }
        }
        return S_OK;

}

PRIVATE SCODE DemoTrustEvidence_Put(const PropertyClass *Class, PTR Value)
{
    return DEMO_TRUST_EVIDENCE_OK;
}

/* Initialize private fields */
PRIVATE SCODE DemoTrustEvidence_Init(const PropertyClass *Class, PTR Value,
                                /*unused*/ PIHEAP Heap,PICIMRESOURCE Resource)
{
    DemoTrustEvidence *dte = Value;
    if (!dte->super.RequiredEvidenceUrl)
    {
        dte->super.RequiredEvidenceUrl = _tcsdup(dte->super.Name);
    }
    return DEMO_TRUST_EVIDENCE_OK;
}

PRIVATE SCODE DemoTrustEvidence_Copy(const PropertyClass *Class,
                                     PTR _Dst, const void *_Src, PIHEAP Heap)
{
    DemoTrustEvidence *dte = _Dst;
    const DemoTrustEvidence *src = _Src;

    dte->UnitId = src->UnitId;

    return S_OK;
}
PRIVATE UINT DemoTrustEvidence_GetValue(const PropertyClass *Class, PTR Value, CurrentRequest *currentRequest ,const _TCHAR *Field)
{
      DemoTrustEvidence *dte = Value;
      if(Field)
     {
        if(!_tcscmp(Field,_T("Value")))
            return dte->super.Value;
        else if(!_tcscmp(Field,_T("Threshold")))
            return dte->super.Threshold;
     }
    return dte->super.Value;
}


extern const PropertyClass TrustEvidence_Prop;

const PropertyClass DemoTrustEvidence_Prop = {
    _T("http://tempuri.org/trust/DemoTrustEvidence"), 
    _T("DemoTrustEvidence"),
    sizeof(DemoTrustEvidence),
    _T("tpolicy:TrustEvidence"),
    _T("tpolicy:TrustEvidence"),
    &TrustEvidence_Prop,
    DemoTrustEvidence_Get, 
    DemoTrustEvidence_Put,
    DemoTrustEvidence_Init, 
    NULL, 
    DemoTrustEvidence_Copy,    NULL, 
    NULL,
    NULL,
    DemoTrustEvidence_GetValue,
    
    NULL
};
