/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include "demotscript.h"

#include <ctype.h>
#include <limits.h>
#include <stdlib.h>

/*********** Demo sensor interface as specified ******************/
#define DEMO_TRUST_SCRIPT_OK 0
#define MAX_ARGUMENTS 10
#define dtsOff offsetof(DemoTrustScript, super.ListNode)

int GetTrustScript(UINT8 ID, UINT8 * val);
int SetTrustScript(UINT8 ID, UINT8 * val);

/*********** Fake implementation ******************/
int GetTrustScript(UINT8 ID, UINT8 * val)
{
    return DEMO_TRUST_SCRIPT_OK;
}

int SetTrustScript(UINT8 ID, UINT8 * val)
{
    return DEMO_TRUST_SCRIPT_OK;
}

/*********** map names ******************/

#if 0
PRIVATE const _TCHAR * const id_names[] = {
    _T("Test1"),
    _T("Test2"),
    _T("Test3"),
    _T("Test4"),
    _T("Test5"),
};

#define ID_NAMES_COUNT sizeof(id_names)/sizeof(_TCHAR*)

PRIVATE UINT FindId(const _TCHAR *Name)
{
    UINT id;
    const _TCHAR *entry;
    for (id = 0; id < ID_NAMES_COUNT; id++) {
        entry = id_names[id];
        if (!_tcscmp(entry, Name))
            return id;
    }
    /* Nothing found, return invalid id */
    return ~0;
}

PRIVATE const _TCHAR *FindName(UINT id)
{
    if (id >= ID_NAMES_COUNT)
        return NULL;

    return id_names[id];
}

#endif
/*********** demo_sensor class ******************/

PRIVATE SCODE DemoTrustScript_Get(const PropertyClass *Class, PTR Value,CurrentRequest *currentRequest)
{
 return DEMO_TRUST_SCRIPT_OK;
}

PRIVATE SCODE DemoTrustScript_Put(const PropertyClass *Class, PTR Value)
{
    return DEMO_TRUST_SCRIPT_OK;
}

/* Initialize private fields */
PRIVATE SCODE DemoTrustScript_Init(const PropertyClass *Class, PTR Value,
                                /*unused*/ PIHEAP Heap,PICIMRESOURCE Resource)
{
    return DEMO_TRUST_SCRIPT_OK;
}

PRIVATE SCODE DemoTrustScript_Copy(const PropertyClass *Class,
                                     PTR _Dst, const void *_Src, PIHEAP Heap)
{
    DemoTrustScript *dts = _Dst;
    const DemoTrustScript *src = _Src;

    dts->UnitId = src->UnitId;

    return S_OK;
}

PRIVATE UINT DemoTrustScript_GetValue(const PropertyClass *Class, PTR Value,CurrentRequest *currentRequest,const _TCHAR *Field )
{
          
          DemoTrustScript *dts = Value;
          UINT count ;
          UINT tempValue = 1;
          UINT values[MAX_ARGUMENTS];

          count = 0;
          if(dts->super.ArgList)
          {
               PLIST_HEAD Head;
               PTR pHead = &dts->super.ArgList;
               PTR pItem, Next;
              
               Head = pHead;
               pItem = *Head;
               if(!_tcscmp(dts->super.Name, _T("Select")))
               {
                    if (pItem) do {
                        if(count == currentRequest->Mode)
                        {
                            PICIMRESOURCE Resource = NULL;
                            PICIMRESOURCE Context = currentRequest->Context;
                            struct Selector  selector;
                            selector.Name = _T("Name");
                            selector.Value = ((DemoTrustScript * )pItem)->super.Name;
                            selector.Type = NULL;
                            selector.ListNode_Selector.pNext = &selector;
                            selector.ListNode_Selector.pPrev = &selector;
                            Resource = CimResourceShadowLookup(Context, _T("DemoTrustScript"), &selector);
                            if(Resource)
                            {
                                tempValue = CimResourceGetValue(Resource, currentRequest,_tcsreturnfield((_TCHAR* )pItem));
                                dts->super.RequiredEvidenceUrl = ((DemoTrustScript *)((CimResource *)Resource)->Value)->super.RequiredEvidenceUrl;
                            }
                            break;
                        }
                        Next = ListNodeNext(dtsOff, pItem);
                        count++;
                        pItem = Next;
                   } while (*Head && pItem != *Head);
               }
             else
             {
               
               if (pItem) do {
                    Next = ListNodeNext(dtsOff, pItem);
                    values[count++] = DemoTrustScript_GetValue(Class,Next,currentRequest,Field);
                    if(values[count-1]!=1)
                            dts->super.RequiredEvidenceUrl = ((DemoTrustScript *)Next)->super.RequiredEvidenceUrl;
                    pItem = Next;
               } while (*Head && pItem != *Head);
               if(count == 1)
               {
                    tempValue = values[0];
               }else if (!_tcscmp(dts->super.Name, _T("Min")))
               {
                  UINT i;
                  UINT min = values[0];
                  for(i = 0; i < count; i++)
                      if(values[i] <  min)
                          min = values[i];
                  tempValue = min;
               }else if (!_tcscmp(dts->super.Name, _T("Max")))
               {
                  UINT i;
                  UINT max = values[0];
                  for(i = 0; i < count; i++)
                      if(values[i] >  max)
                          max = values[i];
                  tempValue = max;
               }else if (!_tcscmp(dts->super.Name, _T("Average")))
               {
                  UINT i;
                  UINT avg = 0;
                  for(i = 0; i < count; i++)
                      avg = avg + values[i];
                  tempValue = avg/count;
               }else if (!_tcscmp(dts->super.Name, _T("Multiply")))
               {
                  UINT i;
                  UINT pdt = 1;
                  for(i = 0; i < count; i++)
                      pdt = pdt * values[i];
                  tempValue = pdt;
               }else if (!_tcscmp(dts->super.Name, _T("Or")))
                   {
                      UINT i;
                      UINT flag = 0;
                      for(i = 0; i < count; i++)
                          if (values[i]>0)
                            flag++;
                      if(flag>0)
                          flag = 1;
                      tempValue = flag;
                   }else if (!_tcscmp(dts->super.Name, _T("And")))
                   {
                      UINT i;
                      tempValue = 1;
                      for(i = 0; i < count; i++)
                      {
                          if(values[i]==0)
                               tempValue = 0;
                      }
                   }
                
            }
          }
        else {
          PICIMRESOURCE Resource = NULL;
          PICIMRESOURCE Client = currentRequest->Client;
          struct Selector  selector;
          selector.Name = _T("Name");
          selector.Value = dts->super.Name;
          selector.ListNode_Selector.pNext = &selector;
          selector.ListNode_Selector.pPrev = &selector;
          Resource = CimResourceShadowLookup(Client, _T("DemoTrustEvidence"), &selector);

          if(Resource)
          {
              tempValue = CimResourceGetValue(Resource, currentRequest,_tcsreturnfield(dts->super.Name));
              dts->super.RequiredEvidenceUrl = ((TrustEvidence *)((CimResource *)Resource)->Value)->RequiredEvidenceUrl;
          }
       }
        if(Field)
       {
           if(!_tcscmp(Field,_T("Weight")))
               return dts->super.Weight;
       }
       return tempValue;
}


extern const PropertyClass TrustScript_Prop;

const PropertyClass DemoTrustScript_Prop = {
    _T("http://tempuri.org/trust/DemoTrustScript"), 
    _T("DemoTrustScript"),
    sizeof(DemoTrustScript),
    _T("tpolicy:TrustScript"),
    _T("tpolicy:TrustScript"),
 
    &TrustScript_Prop,
    DemoTrustScript_Get, 
    DemoTrustScript_Put,
    DemoTrustScript_Init, 
    NULL, 
    DemoTrustScript_Copy,
    NULL, 
    NULL,
    NULL,
    DemoTrustScript_GetValue,
   
    NULL
};
