/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <dbres.h>
#include <stdlib.h>
#include<wsif.h>
#include<wsifhelp.h>

#define MAX_ARGUMENTS 10

PRIVATE SCODE GyroPolicy_Finalize(const PropertyClass *Class,
                                         PTR Value, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(GyroPolicy, Finalize);
    struct GyroPolicy *val = Value;

    sc = S_OK;

    S_DEL(Name);

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE GyroPolicy_Copy(const PropertyClass *Class,
                                     PTR _Dst, const void *_Src, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(GyroPolicy, Copy);
    struct GyroPolicy *dst = _Dst;
    const struct GyroPolicy *src = _Src;
    _TCHAR *tmp;
    sc = S_OK;
    
    /* Copy all the fields. */

    S_COPY(Name);
    N_COPY(LowerThreshold);
    N_COPY(MinimumWait);

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE GyroPolicy_Match2(const PropertyClass *Class, PTR Value,
                                const void *Value2, const UINT32 *FieldSel)
{
    METHOD_DECLARE_NOTHIS(GyroPolicy, Match2);
    struct GyroPolicy *val = Value;
    struct GyroPolicy *ref = (void *)Value2;

    S_MATCH2(Name, 0);

    if (FieldSel) {
        N_MATCH2(LowerThreshold, 1);
    }

    sc = S_OK;
    METHOD_CLEANUP;
    return sc;
}

/* Initialize private fields */
PRIVATE SCODE GyroPolicy_Init(const PropertyClass *Class, PTR Value,
                                /*unused*/ PIHEAP Heap, PICIMRESOURCE Resource)
{
    return S_OK;
}


const PropertyClass GyroPolicy_Prop = {
    _T("st1:GyroPolicy"), _T("GyroPolicy"),
    sizeof(struct GyroPolicy),
    _T("st1:GyroPolicy"), _T("st1:GyroPolicy"),
    NULL,
    NULL, NULL, NULL,
    GyroPolicy_Finalize,
    GyroPolicy_Copy,
    NULL /*GyroPolicy_Match*/, GyroPolicy_Match2,
    NULL /*GyroPolicy_UpdateSelector*/, NULL, NULL,
    NULL
};


