/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <dbres.h>
#include <stdlib.h>

#define posOff offsetof(struct PossibleStates2, ListNode)

PTR PossibleStates2_Copy(PTR a, PTR b)
{
    PPossibleStates2 pos, src = a;
    PIHEAP Heap = b;

    UINT size = (_tcslen(src->Value) + 1) * sizeof(_TCHAR) + sizeof(*pos);
    pos = Heap->v->Alloc(Heap, HEAP_DEBUG_NAME("cimdb:possible2"), size, 0);
    if (!pos)
        return NULL;

    pos->Value = (PTR) (pos + 1);
    _tcscpy(pos->Value, src->Value);
    ListNodeInit(posOff, pos);

    return pos;
} 

INT PossibleStates2_Delete(PTR a, PTR b)
{
    PIHEAP Heap = b;

    Heap->v->Free(Heap, 0, a);
    return 0;
} 


PRIVATE SCODE CIM_NumericSensor_Copy(const PropertyClass *Class,
                                     PTR _Dst, const void *_Src, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(CIM_NumericSensor, Copy);
    struct CIM_NumericSensor *sen = _Dst;
    const struct CIM_NumericSensor *src = _Src;
    _TCHAR *tmp;
    sc = S_OK;

    /* Copy all the fields. */
//memcpy(&sen->super + 1, &src->super + 1, sizeof(*sen)-sizeof(sen->super));
#define N(f) sen->f = src->f
#define S(f) if (sen->f) {Heap->v->Free(Heap, 0, sen->f); sen->f = NULL;} if (!src->f || !*src->f) {sen->f = NULL;} else {tmp = Heap->v->Alloc(Heap, HEAP_DEBUG_NAME("cimdb:string"), (_tcslen(src->f)+1)*sizeof(_TCHAR), 0); CHECKSETSC(tmp, E_NOT_ENOUGH_MEMORY, "alloc string"); _tcscpy(tmp, src->f); sen->f = tmp;}

    S(Caption);
    S(Description);
    S(ElementName);

    N(InstallDate);
    S(Name);
    S(OperationalStatus);
    S(HealthState);

    S(EnabledState);
    S(OtherEnabledState);
    S(RequestedState);
    S(EnabledDefault);
    N(TimeOfLastStateChange);

    S(CreationClassName);
    S(DeviceID);
    S(OtherIdentifyingInfo);
    S(IdentifyingDescriptions);

    N(SensorType);
    S(OtherSensorTypeDescription);
    if (sen->PossibleStates) {
        ListDelete(&sen->PossibleStates, posOff,
                   PossibleStates2_Delete,
                   Heap);
    }
    if (src->PossibleStates) {
        tmp = ListCopy(&src->PossibleStates, posOff,
                       PossibleStates2_Copy,
                       PossibleStates2_Delete,
                       Heap);
        CHECKSETSC(tmp, E_NOT_ENOUGH_MEMORY, "copy PossibleStates");
        sen->PossibleStates = (PTR) tmp;
    } else {
        sen->PossibleStates = NULL;
    }
    S(CurrentState);

    N(UnitModifier);
    N(RateUnits);
    N(CurrentReading);
    S(SettableThresholds);
    S(SupportedThresholds);
    S(SystemName);
    S(SystemCreationClassName);

#if 0
    S(OtherDedicatedDescriptions);
    N(BaseUnits);
    N(NominalReading);
    N(NormalMax);
    N(NormalMin);
    N(MaxReadable);
    N(MinReadable);
    N(Resolution);
    N(Accuracy);
    N(IsLinear);
    N(Hysteresis);
    N(LowerThresholdNonCritical);
    N(UpperThresholdNonCritical);
    N(LowerThresholdCritical);
    N(UpperThresholdCritical);
    N(LowerThresholdFatal);
    N(UpperThresholdFatal);
    S(AdditionalAvailability);
    S(Availability);
    S(EnabledThresholds);
    S(ErrorCleared);
    S(ErrorDescription);
    S(LastErrorCode);
    S(MaxQuiesceTime);
    S(PollingInterval);
    S(PowerManagementSupported);
    S(PowerOnHours);
    S(StatusInfo);
    S(Tolerance);
    S(TotalPowerOnHours);
    S(PrimaryOwnerContact);
    S(PrimaryOwnerName);
    S(PowerManagementCapabilities);
    S(ResetCapability);
    S(Status);
    S(StatusDescriptions);
//PLocation Location);
    S(nHours);
#endif
#undef S
#undef N
METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE CIM_NumericSensor_Finalize(const PropertyClass *Class,
                                         PTR Value, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(CIM_NumericSensor, Finalize);
    struct CIM_NumericSensor *sen = Value;

    sc = S_OK;

#define N(f)
#define S(f) if (sen->f) {Heap->v->Free(Heap, 0, sen->f); sen->f = NULL;}

    S(Caption);
    S(Description);
    S(ElementName);

    N(InstallDate);
    S(Name);
    S(OperationalStatus);
    S(HealthState);

    S(EnabledState);
    S(OtherEnabledState);
    S(RequestedState);
    S(EnabledDefault);
    N(TimeOfLastStateChange);

    S(CreationClassName);
    S(DeviceID);
    S(OtherIdentifyingInfo);
    S(IdentifyingDescriptions);

    N(SensorType);
    S(OtherSensorTypeDescription);
    if (sen->PossibleStates) {
        ListDelete(&sen->PossibleStates, posOff, PossibleStates2_Delete, Heap);
    }
    S(CurrentState);

    N(UnitModifier);
    N(RateUnits);
    N(CurrentReading);
    S(SettableThresholds);
    S(SupportedThresholds);
    S(SystemName);
    S(SystemCreationClassName);
#undef S
#undef N
METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE CIM_NumericSensor_Match(const PropertyClass *Class, PTR Value,
                                      PSelector Selector)
{
    METHOD_DECLARE_NOTHIS(CIM_NumericSensor, Match);
    struct CIM_NumericSensor *sen = Value;
    INT64 tmp;

#define N(f) if (!_tcscmp(_T(# f), Selector->Name)) return (_ttoi(Selector->Value) - sen->f) ? E_FAIL : S_OK
#define N64(f) if (!_tcscmp(_T(# f), Selector->Name)) {tmp = Int64Subtract(_ttoi64(Selector->Value), sen->f); return Int64IsZero(tmp) ? S_OK : E_FAIL;}
#define S(f) if (sen->f && !_tcscmp(_T(# f), Selector->Name)) return _tcscmp(Selector->Value, sen->f) ? E_FAIL : S_OK

    // XXX should only compare those that are "keys"
    S(Caption);
    S(Description);
    S(ElementName);

    N64(InstallDate);
    S(Name);
    S(OperationalStatus);
    S(HealthState);

    S(EnabledState);
    S(OtherEnabledState);
    S(RequestedState);
    S(EnabledDefault);
    N64(TimeOfLastStateChange);

    S(CreationClassName);
    S(DeviceID);
    S(OtherIdentifyingInfo);
    S(IdentifyingDescriptions);

    N(SensorType);
    S(OtherSensorTypeDescription);
    //PossibleStates
    S(CurrentState);

    N(UnitModifier);
    N(RateUnits);
    N(CurrentReading);
    S(SettableThresholds);
    S(SupportedThresholds);
    S(SystemName);
    S(SystemCreationClassName);
#undef S
#undef N
    sc = E_NAME_NOT_FOUND;
METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE CIM_NumericSensor_Match2(const PropertyClass *Class, PTR Value,
                                       const void *Value2, const UINT32 *FieldSel)
{
    METHOD_DECLARE_NOTHIS(CIM_NumericSensor, Match2);
    struct CIM_NumericSensor *sen = Value;
    struct CIM_NumericSensor *sen2 = (void *)Value2;

#define S(f) if (sen->f && sen2->f) return _tcscmp(sen->f, sen2->f) ? E_FAIL : S_OK

    S(DeviceID);

#undef S

    sc = E_NAME_NOT_FOUND;
METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE CIM_NumericSensor_UpdateSelector(const PropertyClass *Class,
           PTR Value, PSelector Selector,
           UINT *pCount, UINT *pSize)
{
    METHOD_DECLARE_NOTHIS(CIM_NumericSensor, Match2);
    struct CIM_NumericSensor *sen = Value;

    if (pCount)
        *pCount = 1;
    if (pSize)
        *pSize = 0;
    if (Selector) {
        Selector->Name = _T("DeviceID");
        Selector->Value = sen->DeviceID;
    }

    sc = S_OK;
METHOD_CLEANUP;
    return sc;
}

const PropertyClass CIM_NumericSensor_Prop = {
    _T("cimns:CIM_NumericSensor"), _T("CIM_NumericSensor"),
    sizeof(struct CIM_NumericSensor),
    _T("cimns:CIM_NumericSensor"), _T("cimns:CIM_NumericSensor"),
    NULL,
    NULL, NULL, NULL,
    CIM_NumericSensor_Finalize,
    CIM_NumericSensor_Copy,
    CIM_NumericSensor_Match, CIM_NumericSensor_Match2,
    CIM_NumericSensor_UpdateSelector, NULL,NULL
};

