/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <dbres.h>
#include <stdlib.h>
#include <wsif.h>
#include <wsifhelp.h>
#include <s_IServiceTutorial1_t.h>

#define MAX_ARGUMENTS 10



PRIVATE SCODE StickState_Copy(const PropertyClass *Class,
                                     PTR _Dst, const void *_Src, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(StickState, Copy);
    struct StickState *dst = _Dst;
    const struct StickState *src = _Src;
    _TCHAR *tmp;
    sc = S_OK;

    S_COPY(Name);
    N_COPY(AxisA);
    N_COPY(AxisB);

METHOD_CLEANUP;
    return sc;
}


PRIVATE SCODE StickState_Finalize(const PropertyClass *Class,
                                         PTR Value, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(StickState, Finalize);
    struct StickState *val = Value;

    sc = S_OK;

    S_DEL(Name)
 
METHOD_CLEANUP;
    return sc;
}


PRIVATE SCODE StickState_Match2(const PropertyClass *Class, PTR Value,
                                const void *Value2, const UINT32 *FieldSel)
{
    METHOD_DECLARE_NOTHIS(StickState, Match2);
    struct StickState *val = Value;
    struct StickState *ref = (void *)Value2;

    S_MATCH2(Name, 0);

    if (FieldSel) {
        N_MATCH2(AxisA, 1);
        N_MATCH2(AxisB, 2);
    }

    sc = S_OK;

METHOD_CLEANUP;
    return sc;
}

const PropertyClass StickState_Prop = {
    _T("st1:StickState"), _T("StickState"),
    sizeof(struct StickState),
    _T("st1:StickState"), _T("st1:StickState"),
    NULL,
    NULL, NULL, NULL,
    StickState_Finalize,
    StickState_Copy,
    NULL, StickState_Match2,
    NULL, NULL, NULL,
    NULL
};

