/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <dbres.h>
#include <stdlib.h>
#include<wsif.h>
#include<wsifhelp.h>

#define MAX_ARGUMENTS 10

PRIVATE SCODE Subscription_Finalize(const PropertyClass *Class,
                                         PTR Value, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(Subscription, Finalize);
    struct Subscription *val = Value;

    sc = S_OK;

    S_DEL(Subscriber);

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE Subscription_Copy(const PropertyClass *Class,
                                     PTR _Dst, const void *_Src, PIHEAP Heap)
{
    METHOD_DECLARE_NOTHIS(Subscription, Copy);
    struct Subscription *dst = _Dst;
    const struct Subscription *src = _Src;
    _TCHAR *tmp;
    sc = S_OK;
    
    /* Copy all the fields. */

    S_COPY(Subscriber);
    N_COPY(Expiration);
    N_COPY(NotificationCount);

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE Subscription_Match2(const PropertyClass *Class, PTR Value,
                                const void *Value2, const UINT32 *FieldSel)
{
    METHOD_DECLARE_NOTHIS(Subscription, Match2);
    struct Subscription *val = Value;
    struct Subscription *ref = (void *)Value2;

    S_MATCH2(Subscriber, 0);

    if (FieldSel) {
        //N_MATCH2(Expiration, 1);
        N_MATCH2(NotificationCount, 2);
    }

    sc = S_OK;
    METHOD_CLEANUP;
    return sc;
}

/* Initialize private fields */
PRIVATE SCODE Subscription_Init(const PropertyClass *Class, PTR Value,
                                /*unused*/ PIHEAP Heap, PICIMRESOURCE Resource)
{
    return S_OK;
}


const PropertyClass Subscription_Prop = {
    _T("dssp:Subscription"), _T("Subscription"),
    sizeof(struct Subscription),
    _T("dssp:Subscription"), _T("dssp:Subscription"),
    NULL,
    NULL, NULL, NULL,
    Subscription_Finalize,
    Subscription_Copy,
    NULL /*Subscription_Match*/, Subscription_Match2,
    NULL /*Subscription_UpdateSelector*/, NULL, NULL,
    NULL
};


