/* Copyright (c) Microsoft Corporation. All rights reserved. */

typedef _TCHAR BCHAR;
typedef const _TCHAR CBCHAR;

struct _NS_TABLE100 {
#define MAXNSSIZE 100
    struct _ANY_ENTRY any;

    INT Count;          /* 0 is empty */
    PANY_ENTRY Table[100];
};

/* Descriptor for storing attributes and xmlns specifiers */
typedef struct _ATTR_ENTRY {
    struct _ANY_ENTRY any;

    UINT ns;             /* tokenized aaa in aaa:foo="bar" */
    UINT id;             /* tokenized foo in aaa:foo="bar" */

    PSTR_ENTRY val;      /* literal bar in xmlns:foo="bar" or aaa:foo="bar" */
} ATTR_ENTRY, *PATTR_ENTRY;

BOOL PushEntry(PNS_TABLE This, CPANY_ENTRY Entry);
BOOL AssignEntry(PNS_TABLE This, UINT Which, CPANY_ENTRY Entry);
/* Allocate string entry and initialize all but data */
PANY_ENTRY AllocNsTable(PIHEAP Heap);
/* Return copy of top relative entry */
PANY_ENTRY GetTop(PANY_ENTRY any, UINT Which, BOOL AddRef, ENTRY_TYPE Type);
/* Return copy of absolute (bottom relative) entry */
PANY_ENTRY GetBottom(CPANY_ENTRY any, UINT Which, BOOL AddRef, ENTRY_TYPE Type);
/* Get entry as string, or "" */
CBCHAR *GetString(CPNS_TABLE table, UINT Which);
/* push attr */
SCODE AttrPush(PNS_TABLE This, UINT ns, UINT id, PSTR_ENTRY val);
/* push xmlns */
SCODE XnsRefPush(PNS_TABLE This, PSTR_ENTRY Prefix, PSTR_ENTRY QName,
                 PISAXHANDLER, UINT XmlDepth);
/* push literal */
SCODE StrPushLiteral(PNS_TABLE This, CBCHAR *str, UINT Len);
/* push copy of entry n */
SCODE DupN(PNS_TABLE This, UINT Which);
/* push partial copy of top entry, dropped */
SCODE StrSubstr(PNS_TABLE This, UINT Start, UINT Len);
/* push glued together copy of N top entries, dropped */
SCODE StrConcat(PNS_TABLE This, UINT n);
/* drop top entry */
SCODE Drop(PNS_TABLE This, UINT Which);

UINT AddRefEntry(PANY_ENTRY Entry);
UINT ReleaseEntry(PANY_ENTRY Entry);
