/* Copyright (c) Microsoft Corporation. All rights reserved. */


#ifndef __HTTP__
#define __HTTP__ 1

#include <util/list-double2.h>
#include <wsif.h>
#include <soapif.h>
#include <httpif.h>
#include <base/cobdesc.h>

typedef struct _HttpFactory HttpFactory;
struct _HttpFactory {
    /* WS-Discovery message processing */
    struct _DefCob super;

    PILISTENER Server; /* Default server */
    UINT ThreadCount;  /* In the default server */
};

/* In httpconnector.c */
SCODE MCT HttpFactoryCreateConnector (
    PIWEBPROTOCOLFACTORY iThis,
    const _TCHAR *Url,
    PARSE_URL_FLAGS ExtraFlags,
    /*out*/ PIHTTPCONNECTOR *pISoapConnector);

/* In tcpserver.c */
SCODE MCT HttpFactoryCreateServer (
    PIWEBPROTOCOLFACTORY Factory, 
    PINAMESPACE NameSpace,
    UINT Flags,
    /*out*/ PILISTENER* Server);

SCODE MCT
HttpServerService(PILISTENER This, PIENDPOINT ep,
                  PARSE_URL_FLAGS UrlFlags, PIHTTPCONNECTOR Conn);

SCODE MCT HttpSend(
    PIFILE ContentFile,
    PIENDPOINT ep,

    UINT Flags,
    const _TCHAR *HostName,
    _TCHAR *LocalUrl,
    const char *BasicKey,       /* RFC 2617 basic authentication. UNSECURE. */
    struct sockaddr *sockaddr,
    UINT sockaddr_size,

    const _TCHAR *SoapAction,
    INT HTTPVersion,
    UINT HttpToken,             /* POST/GET/... or "200"/... */
    BOOL ConnectionClose);      /* Generate Connection: close */

/* Transfer some nice quantity in one message... one mbuf worth.
 * Must be multiple of AES CHUNKSIZE
 */
//#include <../soap/ssoap.h>
//#define MAX_CHUNK_SIZE __TRUNC(0x7d0, CHUNKSIZE)
#define MAX_CHUNK_SIZE 0x10000

#endif /* __HTTP__ */
