/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include "httpserver.h"
#include "httpconstants.h"

/* If an array below includes a token string (such as "Accept")
 * which is a substring of another token string member (such as
 * "Accept-Charset") then the substring (the shorter string) must always 
 * occur at a higher index in the array than the superstring. (The 
 * parsing code relies on this invariant...)
 */

/* BUGBUG the strings are duplicated elsewhere... */
/* BUGBUG can we use string compression? */

#ifndef _MINIMIZE
const HTTPTOKENSTRING 
RequestFieldTokens[NUM_REQUEST_FIELD_TOKENS] = {
    { "Accept-Charset",         14,     TOKEN_ACCEPT_CHARSET },
    { "Accept-Encoding",        15,     TOKEN_ACCEPT_ENCODING },
    { "Accept-Language",        15,     TOKEN_ACCEPT_LANGUAGE },
    { "Accept",                 6,      TOKEN_ACCEPT },
    { "Authorization",          13,     TOKEN_AUTHORIZATION },
    { "From",                   4,      TOKEN_FROM },
    { "Host",                   4,      TOKEN_HOST },
    { "If-Match",               8,      TOKEN_IF_MATCH },
    { "If-Modified-Since",      17,     TOKEN_IF_MODIFIED_SINCE },
    { "If-None-Match",          13,     TOKEN_IF_NONE_MATCH },
    { "If-Range",               8,      TOKEN_IF_RANGE },
    { "If-Unmodified-Since",    19,     TOKEN_IF_UNMODIFIED_SINCE },
    { "Max-Forwards",           12,     TOKEN_MAX_FORWARDS },
    { "Proxy-Authorization",    19,     TOKEN_PROXY_AUTHORIZATION },
    { "Range",                  5,      TOKEN_RANGE },
    { "Referer",                7,      TOKEN_REFERER },
    { "User-Agent",             10,     TOKEN_USER_AGENT },
};

const HTTPTOKENSTRING
ResponseFieldTokens[NUM_RESPONSE_FIELD_TOKENS] = {
    { "Age",                    3,      TOKEN_AGE },
    { "Location",               8,      TOKEN_LOCATION },
    { "Proxy-Authenticate",     18,     TOKEN_PROXY_AUTH },
    { "Public",                 6,      TOKEN_PUBLIC },
    { "Retry-After",            11,     TOKEN_RETRY_AFTER },
    { "Server",                 6,      TOKEN_SERVER },
    { "Vary",                   4,      TOKEN_VARY },
    { "Warning",                7,      TOKEN_WARNING },
    { "WWW-Authenticate",       16,     TOKEN_WWW_AUTH },
};
#endif

const HTTPTOKENSTRING
EntityFieldTokens[NUM_ENTITY_FIELD_TOKENS] = {
#ifndef _MINIMIZE
    { "Allow",                  5,      TOKEN_ALLOW },
    { "Content-Base",           12,     TOKEN_CONTENT_BASE },
    { "Content-Encoding",       16,     TOKEN_CONTENT_ENCODING },
    { "Content-Language",       16,     TOKEN_CONTENT_LANGUAGE },
#endif
    { "Content-Length",         14,     TOKEN_CONTENT_LENGTH },
#ifndef _MINIMIZE
    { "Content-Location",       16,     TOKEN_CONTENT_LOCATION },
    { "Content-MD5",            11,     TOKEN_CONTENT_MD5 },
    { "Content-Range",          13,     TOKEN_CONTENT_RANGE },
#endif
    { "Content-Type",           12,     TOKEN_CONTENT_TYPE },
#ifndef _MINIMIZE
    { "ETag",                   4,      TOKEN_ETAG },
    { "Expires",                7,      TOKEN_EXPIRES },
    { "Last-Modified",          13,     TOKEN_LAST_MODIFIED },
#endif
    { "Connection",             10,     TOKEN_CONNECTION },
    { "Transfer-Encoding",      17,     TOKEN_TRANSFER_ENCODING },
    { "transfer-encoding",      17,     TOKEN_TRANSFER_ENCODING }
};
