/* Copyright (c) Microsoft Corporation. All rights reserved. */
#ifndef __HTTP_CONSTANTS__ 
#define __HTTP_CONSTANTS__ 1

typedef struct {
    const char*      String;
    const UINT       Length;
    INT              Token;
} HTTPTOKENSTRING;

/* If an array below includes a token string (such as "Accept")
 * which is a substring of another token string member (such as
 * "Accept-Charset") then the substring (the shorter string) must always 
 * occur at a higher index in the array than the superstring. (The 
 * parsing code relies on this invariant...)
 */

extern const HTTPTOKENSTRING RequestFieldTokens[]; 
extern const HTTPTOKENSTRING ResponseFieldTokens[];
extern const HTTPTOKENSTRING EntityFieldTokens[];

#endif /* __HTTP_CONSTANTS__ */
