/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Sensor demo implementation. 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <mmlite.h>
#include <mmmacros.h>
#include <util/list-double2.h>
#include <wsif.h>
#include <soapif.h>
#include <wsifhelp.h>
#include <web/proxy.h>
#include <web/udpsoapserv.h>
#include <arm/at91m63200.h>

#include "sensor.h"
#include "../sampling/builder.h"
#include "../sampling/planner.h"


#define PRODUCER_RESERVATION_NAME _T("sensnet-producer-reserve")
#define CONSUMER_RESERVATION_NAME _T("sensnet-consumer-reserve")

#define TRANSMISSION_TIME_SAMPLE_POOL _T("xmit-delay")
#define TRANSMISSION_TIME_CONFIDENCE 95


typedef struct _Instigator {
    /* Housekeeping */
    CONST_VTBL struct IInstigatorVtbl *v;   
    UINT RefCnt;
    /* Instigated task */
    PITASKBUILDER Task;
    /* Dispatch data */
    _TCHAR *ProducerUri;
    _TCHAR *ConsumerUri;
    _TCHAR *ProducerReservationFullName;
    _TCHAR *ConsumerReservationFullName;
    _TCHAR *FeedbackUri;

    /* What to do, NULL for default */
    _TCHAR *method;
} Instigator, *PINSTIGATOR;


/* Convert between interface and instance pointer and vice versa */
#define pInstigator(_i_) ((PINSTIGATOR)((_i_)))
#define iInstigator(_p_) ((PIINSTIGATOR)((_p_)))
    

SCODE MCT 
SensorDemoAdaptation(
    PTR pArg, 
    PIPLANNER Planner, 
    PRESERVATIONBUILDER Reservation, 
    PMAINTAINERDATA PlannerData, 
    PISTATISTICS Statistics, 
    PBOOL NothingAdapts);
