/* Copyright (c) Microsoft Corporation. All rights reserved. */


#ifndef __SENSORDEMO__
#define __SENSORDEMO__

#include <util/list-double2.h>
#include <wsif.h>
#include <sampleif.h>
#include <base/cobdesc.h>

/* The number of sensor readings to collect and deliver. 
 * If the period is 10 seconds then 1000 loops take 
 * roughly three hours to complete. 
 */
#define nTOTAL_DEMO_LOOPS 1000

#define PRODUCER_REPEATS nTOTAL_DEMO_LOOPS
#define PRODUCER_PERIOD 10

#define CONSUMER_REPEATS PRODUCER_REPEATS
#define CONSUMER_PERIOD PRODUCER_PERIOD

#define WILDLY_INACCURATE_TRANSMISSION_TIME_GUESS \
    TIME_RELATIVE(TIME_MILLIS(3000))


typedef struct _SensorDemo {
    //struct ISensorVtbl const *Sensorv;
    struct _DefCob super;

    struct IRecorderVtbl const *Recorderv;
    MUTEX Mutex;
    UINT State;
} SENSORDEMO, *PSENSORDEMO, SensorDemo, SENSOR, *PSENSOR, RECORDER, *PRECORDER;


#define pSensor(_x_) ((PSENSOR)_x_)
#define pRecorder(_x_) \
        ((PRECORDER)((UINT)(_x_) - offsetof(RECORDER,Recorderv)))


UINT32 MCT RecorderSetLed(PIRECORDER Recorder, UINT32 LedNumber, UINT32 OnOff);

void StartButtonThread(PSENSORDEMO demo);
void StopButtonThread(PSENSORDEMO demo);

#endif /* __SENSORDEMO__ */
