// Copyright (c) Microsoft Corporation. All rights reserved.
//

// Test script for SOAP server. 
// Runs on Windows using SOAP Toolkit 3.0.
// Sends a WS-Routing message.

var BASE_SOAP_ACTION_URI = "http://tempuri.org/Sensor/action/Sensor.";
var WRAPPER_ELEMENT_NAMESPACE = "http://tempuri.org/Sensor/message/";

var host1 = "127.0.0.1";
var host2 = "127.0.0.1";
// var proto = "x-udp-soap";
var proto = "http";

var rpns = "http://schemas.xmlsoap.org/rp";
var rsns = "http://something.jvh/likes";

var rsrv = 
	"<rs:rsrv xmlns:rs=\"" + rsns + "\" id=\"a/b/c\" dl=\"?\" tol=\"?\" dur=\"?\"> \
		<rs:res id=\"led0\"> \
			<rs:quant>ignored</rs:quant> \
		</rs:res> \
	</rs:rsrv> \
	<rs:rsrv xmlns:rs=\"" + rsns + "\" id=\"a/d/e\" dl=\"?\" tol=\"?\" dur=\"?\"> \
		<rs:res id=\"led0\"> \
			<rs:quant>ignored</rs:quant> \
		</rs:res> \
	</rs:rsrv>";

var path = 
	"<rp:path xmlns:rp=\"" + rpns + "\"> \
		<rp:action>" + BASE_SOAP_ACTION_URI + "</rp:action> \
		<rp:fwd> \
			<rp:via rp:rsrv=\"a/b/c\">" + proto + "://" + host1 + "/COB/sensor.cob</rp:via> \
			<rp:via rp:rsrv=\"a/d/e\">" + proto + "://" + host2 + "/COB/sensor.cob</rp:via> \
		</rp:fwd> \
		<rp:rev> \
			<rp:via/> \
		</rp:rev> \
	</rp:path>";
	
var meth = 
	"<m:SetLed xmlns:m=\"" + WRAPPER_ELEMENT_NAMESPACE + "\" rp:rsrv=\"a/b/c\"> \
		<m:LedNumber>0</m:LedNumber> \
		<m:OnOff>1</m:OnOff> \
	</m:SetLed>";

//x-udp-aes-soap
var END_POINT_URL = "http://" + host1 + "/"
//var END_POINT_URL = "http://172.31.41.244/COB/calc.cob"
//var END_POINT_URL = "https://t-yongx/MSSoapSamples30/Calc/Service/SrSz/AspJs/Calc.asp"

WScript.echo("Sending request to: " + END_POINT_URL);

var Answer

Answer = Execute(END_POINT_URL, "SetLed", 5, 28)
WScript.Echo("leds=" + Answer);

Answer = Execute(END_POINT_URL, "SetLed", 3, 28)
WScript.Echo("leds=" + Answer);

Answer = Execute(END_POINT_URL, "SetLed", 5, 0)
Answer = Execute(END_POINT_URL, "SetLed", 3, 0)
WScript.Echo("leds=" + Answer);

WScript.Echo("done");

function Execute(EndPointURL, Method, A, B)
{

    var Serializer;
    var Reader;
    var Connector;
    
    Connector = WScript.CreateObject("MSSOAP.HttpConnector30");
    Connector.Property("EndPointURL") = EndPointURL;

Connector.Property("Timeout") = 100000; 
    
    Connector.Property("SoapAction") = BASE_SOAP_ACTION_URI & Method;
    Connector.BeginMessage();
    
    Serializer = WScript.CreateObject("MSSOAP.SoapSerializer30");
    Serializer.Init(Connector.InputStream);
    
    Serializer.StartEnvelope();
    Serializer.StartHeader();
    Serializer.WriteXML(rsrv);
    Serializer.WriteXML(path);
    Serializer.WriteXML(meth);
    Serializer.EndHeader();
    Serializer.StartBody("STANDARD");
    Serializer.StartElement(Method, WRAPPER_ELEMENT_NAMESPACE, "NONE", "m");
    Serializer.StartElement("A");
    Serializer.WriteString(A);
    Serializer.EndElement();
    Serializer.StartElement("B");
    Serializer.WriteString(B);
    Serializer.EndElement();
    Serializer.EndElement();
    Serializer.EndBody();
    Serializer.EndEnvelope();
    
    Connector.EndMessage();
    
    Reader = WScript.CreateObject("MSSOAP.SoapReader30");
    Reader.Load(Connector.OutputStream);
    
    if( Reader.Fault == null )
    {
        return Reader.RpcResult.text;
    }
    else
    {
        return "FAULT: " + Reader.FaultString.text;
    }    
}

