/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <stdio.h>
#include <mmlite.h>
#include <base/cons.h>

int _tmain(int argc, _TCHAR** argv)
{
    SCODE sc;
    const _TCHAR *Url = _T("http");

    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
        _tprintf(_T("runsoap.c/main: No command line args sc=x%x\n"), sc);
        goto Out;
    }
    if (argc > 1)
        Url = argv[1];

    sc = RunSoapServer(Url, FALSE);
    if (FAILED(sc)) {
        _tprintf(_T("runsoap.c/main: RunSoapServer failed sc=x%x\n"), sc);
        goto Out;
    }
Out:
    FreeCmdLine(&argc, &argv);
    return sc;
}
