/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* XXX OBSOLETE CODE */

#include <stdio.h>
#include <string.h>
#include <mmlite.h>
#include <netif.h>
#include <util/list-double2.h>
#include <wsif.h>
#include <soapif.h>
#include <httpif.h>
#include <winsock.h>
#include <net/if.h>             /* for struct ifreq */

int _tmain(int argc, _TCHAR** argv)
{
    SCODE           sc;
    PINAMESPACE     NameSpace       = CurrentNameSpace();
    PIUNKNOWN       Unk             = NULL;
    PILISTENER      HTTPServer      = NULL;
    UINT32          LocalIPAddr     = 0;
    UINT16          LocalPort       = 0;

    TRACE("main");

    /* Make sure the network stack COB has been loaded */
    sc = NameSpace->v->Bind(NameSpace, _T("COB/protocol.cob"), 0, (PIUNKNOWN*) &Unk);
    if (FAILED(sc)) {
        DBG(("httptest.c::main: Failed to load network stack\n"));
        goto err_proto_bind;
    }

    /* Load the HTTP COB and construct a server */
    { 
        PIWEBPROTOCOLFACTORY Factory;

        sc = NameSpace->v->Bind(NameSpace, 
                                _T("COB/http.cob"),
                                0,
                                (PIUNKNOWN*) &Unk);
        if (FAILED(sc)) {
            DBG(("httptest.c::main: Failed to load HTTP COB\n"));
            goto err_http_bind;
        }

        sc = Unk->v->QueryInterface(Unk, &IID_IWebProtocolFactory, (void**) &Factory);
        Unk->v->Release(Unk);
        if (FAILED(sc)) {
            DBG(("httptest.c::main: HTTP COB doesn't support IHTTPFactory (?)\n"));
            goto err_http_query;
        }

        /* Construct the test server instance */
        sc = Factory->v->CreateServer(Factory, CurrentNameSpace(), 0, &HTTPServer);
        Factory->v->Release(Factory);
        if (FAILED(sc)) goto err_http_create;
    }
#if 0    
   /* Prepare address and port to listen at */
    {
        PIENDPOINTFACTORY ef;
        PIENDPOINT ep;
        struct ifreq ifr;
        memset((void*) &ifr, 0, sizeof(struct ifreq));
        
        /* Get an endpoint factory to create an endpoint */
        sc = NameSpace->v->Bind(NameSpace,
                                _T("COB/protocol.cob"),
                                NAME_SPACE_READ,
                                &Unk);
        if (FAILED(sc)) goto err_ef_bind;
        sc = Unk->v->QueryInterface(Unk, &IID_IEndpointFactory, (void**) &ef);
        Unk->v->Release(Unk);
        if (FAILED(sc)) goto err_ef_query;

        /* Create an endpoint to query for the interface address */
        sc = ef->v->CreateEndpoint(ef, AF_INET, SOCK_DGRAM, 0, &ep);
        ef->v->Release(ef);
        if (FAILED(sc)) goto err_ep_create;

        /* This is where we specify which interface to use */
        strncpy(ifr.ifr_name, "sr1"/*"*0"*/, sizeof(ifr.ifr_name));

        /* Query for the interface address */
        sc = ep->v->Ioctl(ep, SIOCGIFADDR, (BYTE*) &ifr);
        ep->v->Release(ep);
        if (FAILED(sc)) goto err_ep_ioctl;

        LocalIPAddr = 
            ((struct sockaddr_in *) &(ifr.ifr_addr))->sin_addr.s_addr;
        LocalPort = (UINT16) htons(80);
    }
#endif
    LocalIPAddr = htonl (INADDR_ANY);
    LocalPort = (UINT16) htons(80);

    /* Start the HTTP server listening for HTTP requests... */
    sc = HTTPServer->v->Listen(HTTPServer, _T("XXX URL"));
    if (FAILED(sc)) goto error;

#if 0
    {
        /* Create a thread inside the HTTPServer module */
        PIPROCESS prc;
        PITHREAD pthd;
        PIMODULE mod;

        sc = GetModuleContainsAddr((ADDRESS) HTTPServer->v->Loop, &mod);
        if (FAILED(sc)) goto error;
        sc = mod->v->QueryInterface(mod, &IID_IProcess, &prc);
        mod->v->Release(mod);
        if (FAILED(sc)) goto error;

        sc = prc->v->CreateThread(prc, HTTPServer->v->Loop, HTTPServer, 0, 0, &pthd);
        prc->v->Release(prc);
        if (FAILED(sc))
            goto error;
        pthd->v->Release(pthd);
    }
#else
    sc = HTTPServer->v->Loop(HTTPServer);
    if (FAILED(sc)) goto error;
    /* Should never get here */
#endif

    return 0;


error:
err_http_create:
    HTTPServer->v->Release(HTTPServer);
err_http_query:
err_http_bind:
err_proto_bind:

    printf("soaptest.exe failed sc=%x\n",sc);
    return -1;
}
