/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <stdio.h>
#include <string.h>
#include <mmlite.h>
#include <assert.h>
#include <util/list-double2.h>
#include <wsif.h>
#include <soapif.h>
#include <sampleif.h>
#include <wsif.h>

int _tmain(INT argc, _TCHAR *argv[])
{
    METHOD_DECLARE_NOTHIS("wstest.exe");
    PIWSTRANSFER wxf = NULL;
    //_TCHAR *url = _T("http://127.0.0.1/COB/wsman.cob");
    _TCHAR *url = _T("http://127.0.0.1:4000/COB/wsman.cob");
    _TCHAR typeis[100], _ep[1000];
    PEndpointReference ep = (void*) _ep;
    SOAPStruct ss = {42, _T("Test"), 314159265};
    SOAPStruct ss2 = {43, _T("tEST"), 4444444};
    SOAPStruct *pss;
    UINT fieldsel = ~0;
    
    PISOAPFACTORY soapfactory = NULL;

    /*** Command line ***/
    ParseCmdLine(&argc,&argv);
    if (argc > 3) {
        printf("Usage: proxytest2.exe <url> [<urlB>]\n");
        return 1;
    }

    if (argc >= 2) {
        url = argv[1];
    }

    sc = BindToObject(CurrentNameSpace(), _T("COB/soap.cob"), NAME_SPACE_READ,
                      &IID_ISoapFactory, (void **) &soapfactory);
    CHECKSC("get soap factory");

    sc = soapfactory->v->CreateProxy(soapfactory, NULL,
                                     url, _T("wxf"),
                                     FALSE,
                                     (PIUNKNOWN*) &wxf);
    CHECKSC("CreateProxy");

    printf("wstest Created proxy: wxf=%x iunk=%x sc=%x sizeof(_ep)=%d\n",
           (UINT) wxf, (UINT) &IID_IUnknown, sc, sizeof(_ep));

    pss = (void *) ep;

    /* WS-Transfer */
#if 1
    // _T("(TestResource)"),
    sc = wxf->v->Put(wxf, &ss,
                     _T("tnstype:SOAPStruct"), &fieldsel,
                     (void*) pss, typeis, sizeof(_ep));
    CHECKSC("wxf:Put");
    printf("wxf:Put OK\n");

    //sc = wxf->v->Put(wxf, _T("Foo"), NULL);
    //CHECKSC("wxf:Put");
    //printf("wxf:Put OK\n");

    sc = wxf->v->Get(wxf, (void*) pss, typeis, sizeof(_ep));
    CHECKSC("wxf:Get");
    printf("wxf:Get {%d, %s, %d}\n", ss.varInt, ss.varString, ss.varFloat);

    sc = wxf->v->Delete(wxf);
    CHECKSC("wxf:Delete");
    printf("wxf:Delete OK\n");
#endif

    ep->Address = (void*) (ep+1);
    sc = wxf->v->Create(wxf,
                        (void*) &ss2, _T("tnstype:SOAPStruct"),
                        (void*) ep,  (void*) &ss, typeis, sizeof(ss));
    CHECKSC("wxf:Create");
    printf("wxf:Create {%d, %s, %d}\n", ss.varInt, ss.varString, ss.varFloat);


METHOD_CLEANUP;
    RELEASE(wxf);
    if (soapfactory)
        soapfactory->v->Release(soapfactory);

    printf("done\n");

    FreeCmdLine(&argc,&argv);
    return 0;
}
