/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Implements Dssp concrete class in component dssp */

#include <stdio.h>
#include <mmlite.h>
#include <mmmacros.h>
#include <stddef.h> /* for offsetof() */
#include <util/list-double2.h>
#include <baseif.h>
#include <wsif.h>
#include <sampleif.h>
#include <soapif.h>
#include <httpif.h>
#include <wsifhelp.h>
#include <base/cobdesc.h>
#include <tchar.h>
#include <stdlib.h>
#include <io.h>
#include <string.h> 
#include "../cim/gyro.c"
#include <util/string.h>

UINT doMeasure = 0;

const static struct DefaultInsertResponse ins_resp = {    
    {(struct DefaultInsertResponse *) &ins_resp, (struct DefaultInsertResponse *) &ins_resp}
};
const static struct DefaultReplaceResponse rep_resp = {    
    {(struct DefaultReplaceResponse *) &rep_resp, (struct DefaultReplaceResponse *) &rep_resp}
};
const static struct DefaultDeleteResponse del_resp = {    
    {(struct DefaultDeleteResponse *) &del_resp, (struct DefaultDeleteResponse *) &del_resp}
};
const static struct DefaultUpsertResponse ups_resp = {    
    {(struct DefaultUpsertResponse *) &ups_resp, (struct DefaultUpsertResponse *) &ups_resp}
};
const static struct DefaultUpdateResponse upd_resp = {    
    {(struct DefaultUpdateResponse *) &upd_resp, (struct DefaultUpdateResponse *) &upd_resp}
};

const _TCHAR* _tcsgetresourcetype(const _TCHAR *pStr1);

const static struct Partner part[] = {
    {_T("Partner1"), _T("ServiceDir1"), {(struct Partner *) &part[0],
                                         (struct Partner *) &part[0]}}
};

const static struct Alias ali[] = {
    {_T("Alias1"), {(struct Alias *) &ali[0], (struct Alias *) &ali[0]}}
};

//#ifndef _MINIMIZE
const static struct ServiceInfoType service_info_type_EVI[] = {{
    _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html"),
    _T("EVIDENCE"),
    (struct Alias *) ali,
    (struct Partner *) part
}};

const static struct ServiceInfoType service_info_type0[] = {{
    _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html"),
    _T("TEST0"),
    (struct Alias *) ali,
    (struct Partner *) part
}};

const static struct ServiceInfoType service_info_type[] = {{
    _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html"),
    _T("TEST"),
    (struct Alias *) ali,
    (struct Partner *) part
}};

const static struct ServiceInfoType service_info_type2[] = {{
    _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html"),
    _T("TEST2"),
    (struct Alias *) ali,
    (struct Partner *) part
}};
//#endif

typedef struct _Dssp {
    struct _DefCob super;
    CONST_VTBL struct IDsspVtbl *dsspv;
    
	PICIMRESOURCE Cim;
} Dssp;

#include "s_Dssp_v.c"

/* Convert between interface and instance pointer and vice versa */
#define pprog(_i_) ((Dssp *)((_i_)))
#define iprog(_p_) ((PIPROGRAM)((_p_)))
#define pdssp(_i_) ((Dssp *)((_i_) ? (ADDRESS)(_i_) - offsetof(struct _Dssp, dsspv) : 0))
#define idssp(_p_) ((PIDSSP)((_p_) ? &(_p_)->dsspv : NULL))
#define pCUnknown(_i_) ((struct DefCob *)((_i_)))
#define iCUnknown(_p_) ((PIUNKNOWN)((_p_)))


PRIVATE SCODE DsspDestroy(IUnknown *iThis)
{
    METHOD_DECLARE(Dssp, Destroy);
    sc = S_OK;

    RELEASE_NULL(This->Cim);

METHOD_CLEANUP;
    return sc;
}

/* XXX dig out ResourceURI from header processor */
#include <web/cont.h>
PRIVATE const PWSCONTEXT GetContext(void)
{
    PITHREAD thd = CurrentThread();
    PCONTINFO cont = (PCONTINFO) thd->v->GetValue(thd,
                                               THREAD_VALUE_RPC_CONTINUATION);
    if (!cont)
        return NULL;
    return (PWSCONTEXT) cont->pContext;
}

PRIVATE const _TCHAR *CimBaseName(const _TCHAR *name)
{
#if 0
    if (!_tcsncmp(name, CIM_NS _T("/"), sizeof(CIM_NS)/sizeof(_TCHAR)))
        return name + sizeof(CIM_NS)/sizeof(_TCHAR);
    if (!_tcsncmp(name, _T("wsman:"), sizeof(_T("wsman"))/sizeof(_TCHAR)))
        return name + sizeof(_T("wsman"))/sizeof(_TCHAR);
#endif
    return name;
}
PRIVATE const _TCHAR* GetLocal(const _TCHAR *Url)
{
    PISOAPFACTORY SoapFactory = NULL;
    const _TCHAR* pPath;
    BindToObject(CurrentNameSpace(), _T("COB/soap.cob"), NAME_SPACE_READ,
                      &IID_ISoapFactory, (void **) &SoapFactory);
    SoapFactory->v->ParseURL(SoapFactory, Url, NULL, 
                                  NULL, NULL, 
                                  NULL, &pPath,NULL, NULL,NULL,NULL);
     RELEASE(SoapFactory); 
    return pPath;
}

PRIVATE const PICIMRESOURCE GetCim(Dssp * This)
{
    if (!This->Cim) {
        PICIMRESOURCE obj;
        SCODE sc = BindToObject(CurrentNameSpace(), _T("COB/cimdb.cob"),
                                NAME_SPACE_READ | NAME_SPACE_WRITE,
                                &IID_ICimResource, (void **) &obj);
        if (FAILED(sc)) {
            DBG(("GetCimFactory failed to bind to COB/cimdb.cob\n"));
        } else {
            /* In case somebody beat us to it, zap the extra */
            if (!AtomicCmpAndSwap((ADDRESS*) &This->Cim,
                                  0, (ADDRESS) obj))
                obj->v->Release(obj);
        }
    }
    return This->Cim;
}


PRIVATE SCODE dsspQueryInterface (
    PIDSSP iThis,
    REFIID iid,
    /*out*/ void** ppObject)
{
    PIUNKNOWN obj = iCUnknown(pdssp(iThis));
    return obj->v->QueryInterface(obj, iid, ppObject);
}

PRIVATE UINT dsspAddRef (
    PIDSSP iThis)
{
    PIUNKNOWN obj = iCUnknown(pdssp(iThis));
    return obj->v->AddRef(obj);
}

PRIVATE UINT dsspRelease (
    PIDSSP iThis)
{
    PIUNKNOWN obj = iCUnknown(pdssp(iThis));
    return obj->v->Release(obj);
}


PRIVATE SCODE dsspTimestamp (
    PIDSSP iThis,
    PICONTINUATION iCont,
    TIME Value
	)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, Timestamp);

    sc = S_OK;

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspNotificationHeader (
    PIDSSP iThis,
    PICONTINUATION iCont,
    const _TCHAR *ForwardedAction
	)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, NotificationHeader);

    sc = S_OK;

METHOD_CLEANUP;
    return sc;
}



#define rloff offsetof(struct RecordList, ListNode)


PRIVATE SCODE dsspCreateRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void * InitialValue,
    const _TCHAR * ValueType,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, CreateRequest);

    PICIMRESOURCE sub;
    const _TCHAR *base;

    const _TCHAR *resourcetype = _tcsgetresourcetype(ValueType);
    const _TCHAR *local;

    /* Measurement:  How long it takes to create service */
    if(doMeasure == 1) {
        TIME t0,t1,timediff;
        t0 = CurrentTime();

        local = GetLocal(To);
        base = CimBaseName(resourcetype);

        sub = GetCim(This);
        CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

        sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, local, base, NULL,
                                 InitialValue, ValueType, NULL,
                                 Value, pValueType, ValueSize,NULL);

        CHECKSC("resource Create");

        t1=CurrentTime();
        timediff = Int64Subtract(t1, t0);
     
        printf("Time taken to create resource: %d, %s\n", timediff, To);


    } else {
    local = GetLocal(To);
    base = CimBaseName(resourcetype);

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

    sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, local, base, NULL,
                             InitialValue, ValueType, NULL,
                             Value, pValueType, ValueSize,NULL);

    CHECKSC("resource Create");
    }

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspDeleteRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void * NewValue,
    const _TCHAR * NewValueType,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, DeleteRequest);

    PICIMRESOURCE sub;
    const _TCHAR *base;

    base = CimBaseName(To);    
    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

    sc = sub->v->ChangeResource(sub, RESOURCE_DELETE,GetLocal(To), base, NULL,
                        NewValue, NewValueType, NULL,
                        NULL, NULL, 0, NULL);

    CHECKSC("resource Delete");

    memcpy(Value, &del_resp, sizeof(DefaultDeleteResponse));
    _tcscpy(pValueType, _T("dssp:DefaultDeleteResponse"));

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspDropRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    BOOL HasWrapper,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, DropRequest);

    PICIMRESOURCE sub;
    const _TCHAR *local = GetLocal(To);
    _TCHAR *RecursiveTo = NULL;
    PServiceInfoType RecursiveService;
    const _TCHAR *pStr1 = GetLocal(To) + _tcslen(local);
    UINT a;
    _TCHAR c1;
    _TCHAR uponelevel[50];

    SCODE sc_pull = S_OK;
    PRecordList it;
    UINT count = 0;
    _TCHAR *local2 = NULL;

    PIENUM enm;
    PIHEAP Heap;
    PITHREAD thd = CurrentThread();
    PCONTINFO cont = (PCONTINFO) thd->v->GetValue(thd,
                                                THREAD_VALUE_RPC_CONTINUATION);
    CHECKSETSC(cont, E_FAIL, "get current continuation");
    Heap = cont->TmpHeap;
    CHECKSETSC(Heap, E_FAIL, "get cont heap");

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE,
               "Get resource provider");

    sc = sub->v->Enumerate(sub, CurrentHeap(),local, local, 0, NULL, (void*) &enm,NULL);
    CHECKSC("resource Enumerate");

    do {
        /* Get some space for result. XXX 100 chars for type */
        it = Heap->v->Alloc(Heap, 0, sizeof(*it) + 100 * sizeof(_TCHAR), 0);
        CHECKSETSC(it, E_NOT_ENOUGH_MEMORY, "alloc Item from tmp heap");

        it->ValueType = (_TCHAR *)(it + 1);

        sc_pull = enm->v->Pull(enm, Heap, NULL,
                          &it->Value, (_TCHAR*) it->ValueType);
        CHECKSC("sub Pull");

        /* If resource is of ServiceInfoType, recursively dssp:Drop() service. */
        if(!_tcscmp(it->ValueType, _T("dssp:ServiceInfoType"))) {

            /* Update the 'To' field by concatenating the service name. */
            RecursiveService = it->Value;
            
            RecursiveTo = malloc(_tcslen(To) + _tcslen(RecursiveService->Name) + 2);
            _tcscpy(RecursiveTo, To);
            _tcscat(RecursiveTo, _T("/"));
            _tcscat(RecursiveTo, RecursiveService->Name);

            dsspDropRequest (iThis, (_TCHAR *)RecursiveTo, FALSE, NULL, NULL, 0);

            if(RecursiveTo)
                free(RecursiveTo);

            /* Delete the service */
            sc = sub->v->ChangeResource(sub, RESOURCE_DELETE, local, local, NULL,
                                it->Value, _T("dssp:ServiceInfoType"), 
                                NULL, NULL, NULL, 0, NULL);

        }
        else {
            
            /* Otherwise, delete each resource currently in this service  */
            sc = sub->v->ChangeResource(sub, RESOURCE_DELETE, local, local, NULL,
                                it->Value, it->ValueType, NULL,
                                NULL, NULL, 0, NULL);
        }
    } while (sc_pull != S_FALSE);

    if(HasWrapper) {

        /* XXX Name is the only important data below.  Used for matching with existing service */
        a = _tcslen(local);
        do {
            c1 = *pStr1;
            count++;
            *pStr1--;
        } while ((c1 != '/') && (count < a));

        if(count == a)
            _tcscpy(uponelevel, _T("root"));
        else {
            memcpy(uponelevel, local, a-count+1);
            uponelevel[a-count+1] = '\0';
        }

        *pStr1++;
        *pStr1++;
        
        
        RecursiveService->Name = (_TCHAR *) pStr1;
        RecursiveService->Contract = _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html");
        RecursiveService->AliasList = (struct Alias *) ali;
        RecursiveService->PartnerList = (struct Partner *) part;

        /* Delete the service */
        sc = sub->v->ChangeResource(sub, RESOURCE_DELETE, uponelevel, uponelevel, NULL,
                            RecursiveService, _T("dssp:ServiceInfoType"), 
                            NULL, NULL, NULL, 0, NULL);
    }

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspGetRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    BOOL HasWrapper,
    void *Buffer, UINT BufferSize,
    /*out*/ PRecordList * Items)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, GetRequest);

    PRecordList it;
    PICIMRESOURCE sub;
    const _TCHAR *local = GetLocal(To);
    const _TCHAR *base = CimBaseName(local);

    PIENUM enm;
    PIHEAP Heap;
    PITHREAD thd = CurrentThread();
    PCONTINFO cont = (PCONTINFO) thd->v->GetValue(thd,
                                                THREAD_VALUE_RPC_CONTINUATION);
    CHECKSETSC(cont, E_FAIL, "get current continuation");
    Heap = cont->TmpHeap;
    CHECKSETSC(Heap, E_FAIL, "get cont heap");

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE,
               "Get resource provider");

    sc = sub->v->Enumerate(sub, CurrentHeap(),local, base, 0, NULL,
                           (void*) &enm, NULL);
    CHECKSC("resource Enumerate");

    do {

        /* Get some space for result. XXX 100 chars for type */
        it = Heap->v->Alloc(Heap, 0, sizeof(*it) + 100 * sizeof(_TCHAR), 0);
        CHECKSETSC(it, E_NOT_ENOUGH_MEMORY, "alloc Item from tmp heap");

        it->ValueType = (_TCHAR *)(it + 1);

        sc = enm->v->Pull(enm, Heap, NULL,
                          &it->Value, (_TCHAR*) it->ValueType);
        CHECKSC("sub Pull");

        ListAddLast(Items, rloff, it);
    } while (sc != S_FALSE);

METHOD_CLEANUP;
    /* DSSP does not associate any faults with GET */
    return S_OK;
}

PRIVATE SCODE dsspInsertRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void * NewValue,
    const _TCHAR * NewValueType,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, InsertRequest);

    PICIMRESOURCE sub;
    const _TCHAR *base;

    const _TCHAR *resourcetype;
    const _TCHAR *local;

    CHECKSETSC(NewValueType, E_INVALID_PARAMETER, "NewValueType");

    resourcetype = _tcsgetresourcetype(NewValueType);
    local = GetLocal(To);
    base = CimBaseName(resourcetype);

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

    sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, local, base, NULL,
                             NewValue, NewValueType, NULL,
                             NULL, NULL, 0, NULL);
    CHECKSC("resource Insert");

    memcpy(Value, &ins_resp, sizeof(DefaultInsertResponse));
    _tcscpy(pValueType, _T("dssp:DefaultInsertResponse"));

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspLookupRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    BOOL HasWrapper,
    void *Buffer, UINT BufferSize,
    /*out*/ PRecordList * Items)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, LookupRequest);

    PICIMRESOURCE sub;
    _TCHAR c1;
    UINT count = 0;
    
    const _TCHAR *local = GetLocal(To);
    const _TCHAR *pStr1 = GetLocal(To) + _tcslen(local);
    _TCHAR uponelevel[50];
    UINT a;

    PIENUM enm;
    PIHEAP Heap;
    PITHREAD thd = CurrentThread();
    PCONTINFO cont = (PCONTINFO) thd->v->GetValue(thd,
                                                THREAD_VALUE_RPC_CONTINUATION);
    CHECKSETSC(cont, E_FAIL, "get current continuation");
    Heap = cont->TmpHeap;
    CHECKSETSC(Heap, E_FAIL, "get cont heap");

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE,
               "Get resource provider");
    a = _tcslen(local);
    do {
        c1 = *pStr1;
        count++;
        *pStr1--;
    } while ((c1 != '/') && (count < a));

    if(count == a)
        _tcscpy(uponelevel, _T("root"));
    else {
        memcpy(uponelevel, local, a-count+1);
        uponelevel[a-count+1] = '\0';
    }

    sc = sub->v->Enumerate(sub, CurrentHeap(),uponelevel, uponelevel, 0, NULL,
                           (void*) &enm, NULL);
    CHECKSC("resource Enumerate");

    do {
        PRecordList it;

        /* Get some space for result. XXX 100 chars for type */
        it = Heap->v->Alloc(Heap, 0, sizeof(*it) + 100 * sizeof(_TCHAR), 0);
        CHECKSETSC(it, E_NOT_ENOUGH_MEMORY, "alloc Item from tmp heap");

        it->ValueType = (_TCHAR *)(it + 1);

        sc = enm->v->Pull(enm, Heap, NULL,
                          &it->Value, (_TCHAR*) it->ValueType);
        CHECKSC("sub Pull");

        if(!(_tcscmp(it->ValueType, _T("dssp:ServiceInfoType"))))
            ListAddLast(Items, rloff, it);
    } while (sc != S_FALSE);


METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspNotifyRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const _TCHAR * ForwardedAction,
    const void * NewValue,
    const _TCHAR * NewValueType)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, NotifyRequest);

    sc = S_OK;

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspQueryRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void *QueryValue, const _TCHAR *QueryValueType, const UINT32 *FieldSel, 
    void *Buffer, UINT BufferSize,
    /*out*/ PRecordList * Items)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, QueryRequest);

#if 1
    PDataItem di;
    PICIMRESOURCE sub;
    const _TCHAR *local = GetLocal(To);
    const _TCHAR *base = CimBaseName(local);

    PIENUM enm;
    PIHEAP Heap;
    PITHREAD thd = CurrentThread();
    PCONTINFO cont = (PCONTINFO) thd->v->GetValue(thd,
                                                THREAD_VALUE_RPC_CONTINUATION);
    CHECKSETSC(cont, E_FAIL, "get current continuation");
    Heap = cont->TmpHeap;
    CHECKSETSC(Heap, E_FAIL, "get cont heap");

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE,
               "Get resource provider");

    di = Heap->v->Alloc(Heap, sizeof(*di), HEAP_ZERO_MEMORY, 0);
    CHECKSETSC(sub, E_NOT_ENOUGH_MEMORY, "alloc from temp heap");
    
    di->Value = (void *) QueryValue;
    di->ValueType = (_TCHAR *) QueryValueType;
    di->ValueSelector = (UINT32 *) FieldSel;

    sc = sub->v->Enumerate(sub, CurrentHeap(),local, base, 0, di, (void*) &enm, NULL);
    CHECKSC("resource Enumerate");

    do {
        PRecordList it;

        /* Get some space for result. XXX 100 chars for type */
        it = Heap->v->Alloc(Heap, 0, sizeof(*it) + 100 * sizeof(_TCHAR), 0);
        CHECKSETSC(it, E_NOT_ENOUGH_MEMORY, "alloc Item from tmp heap");

        it->ValueType = (_TCHAR *)(it + 1);

        sc = enm->v->Pull(enm, Heap, NULL,
                          &it->Value, (_TCHAR*) it->ValueType);
        CHECKSC("sub Pull");

        ListAddLast(Items, rloff, it);
    } while (sc != S_FALSE);

#endif
METHOD_CLEANUP;
    return S_OK;
}

PRIVATE SCODE dsspReplaceRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void * NewValue,
    const _TCHAR * NewValueType,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, ReplaceRequest);

    PICIMRESOURCE sub;
    const _TCHAR *local = GetLocal(To);

    PIENUM enm;
    PIHEAP Heap;
    PITHREAD thd = CurrentThread();
    PCONTINFO cont = (PCONTINFO) thd->v->GetValue(thd,
                                                THREAD_VALUE_RPC_CONTINUATION);
    CHECKSETSC(cont, E_FAIL, "get current continuation");
    Heap = cont->TmpHeap;
    CHECKSETSC(Heap, E_FAIL, "get cont heap");

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE,
               "Get resource provider");

    sc = sub->v->Enumerate(sub, CurrentHeap(),local, local, 0, NULL, (void*) &enm,NULL);
    CHECKSC("resource Enumerate");

    do {
        PRecordList it;

        /* Get some space for result. XXX 100 chars for type */
        it = Heap->v->Alloc(Heap, 0, sizeof(*it) + 100 * sizeof(_TCHAR), 0);
        CHECKSETSC(it, E_NOT_ENOUGH_MEMORY, "alloc Item from tmp heap");

        it->ValueType = (_TCHAR *)(it + 1);

        sc = enm->v->Pull(enm, Heap, NULL,
                          &it->Value, (_TCHAR*) it->ValueType);
        CHECKSC("sub Pull");

        /* Delete each resource currently in this service */
        sc = sub->v->ChangeResource(sub, RESOURCE_DELETE, local, local, NULL,
                            it->Value, it->ValueType, NULL,
                            NULL, NULL, 0, NULL);

    } while (sc != S_FALSE);

    /* Insert the new state into this service */
    sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, local, local, NULL,
                             NewValue, NewValueType, NULL,
                             NULL, NULL, 0, NULL);
    CHECKSC("resource Insert");

    memcpy(Value, &rep_resp, sizeof(DefaultReplaceResponse));
    _tcscpy(pValueType, _T("dssp:DefaultReplaceResponse"));

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspSubscribeRequest (
    PIDSSP iThis,
    const _TCHAR * To,    
    TIME Expiration,
    UINT NotificationCount,
    /*out*/ _TCHAR * SubscriptionManager,
    UINT ManagerSize,
    /*inout*/ _TCHAR * Subscriber,
    UINT SubscriberSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, SubscribeRequest);
    PICIMRESOURCE sub;
    
    const _TCHAR *local; 
    _TCHAR local2[100];
    _TCHAR newname[30];
    UINT index, index2 = 0, len2;
    BOOL exit;

    struct Subscription subsc;
    struct ServiceInfoType sub_service_info_type;

    local = GetLocal(To);

    /* Create the SUBSCRIPTIONS directory -- If exists, this will fail as desired.*/
    _tcscpy(local2, _T("SUBSCRIPTIONS"));

    sub_service_info_type.Contract = _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html");
    sub_service_info_type.Name = _T("SUBSCRIPTIONS");
    sub_service_info_type.AliasList = (struct Alias *) ali;
    sub_service_info_type.PartnerList = (struct Partner *) part;

    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

    sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, _T("root"), _T("ServiceInfoType"), NULL,
                             &sub_service_info_type, _T("dssp:ServiceInfoType"), NULL,
                             NULL, NULL, 0, NULL);
    CHECKSC("resource Subscribe");

    /* Create the rest of the subdirectories.*/    
    exit = FALSE;
    while(!exit) {
        len2 = _tcslen(local);
        index = _tcslen(local2);
        index2 = 0;

        while(index2 < len2 && local[index2] != '/') {
            newname[index2++] = local[index2];        
        }
        if(index2 == len2)
            exit = TRUE;
        newname[index2] = '\0';
        local += (_tcslen(newname) + 1);

        sub_service_info_type.Contract = _T("http://schemas.tempuri.org/2007/07/ServiceInfoType.html");
        sub_service_info_type.Name = newname;
        sub_service_info_type.AliasList = (struct Alias *) ali;
        sub_service_info_type.PartnerList = (struct Partner *) part;

        CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

        sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, local2, _T("ServiceInfoType"), NULL,
                                 &sub_service_info_type, _T("dssp:ServiceInfoType"), NULL,
                                 NULL, NULL, 0, NULL);
        CHECKSC("resource Subscribe");

        _tcscat(local2, _T("/"));
        _tcscat(local2, newname);
    }

    /* Insert the subscription into the 'SUBSCRIPTIONS' directory.*/

    subsc.Subscriber = Subscriber;
    subsc.Expiration = Expiration;
    subsc.NotificationCount = NotificationCount;

    sc = sub->v->ChangeResource(sub, NAME_SPACE_FAILIFEXIST | NAME_SPACE_CREATE, local2, _T("Subscription"), NULL,
                             &subsc, _T("dssp:Subscription"), NULL,
                             NULL, NULL, 0, NULL);
    CHECKSC("resource Insert");

    /* Set the SubscriptionManager address for output */
    _tcscpy(SubscriptionManager, To);
    memcpy(SubscriptionManager + 20, local2, _tcslen(local2));

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspUpdateRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void * NewValue,
    const _TCHAR * NewValueType,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, UpdateRequest);

	 /* Use ResourceURI first piece to bind to sub-handler.
     * Give remaining ResourceURI as arg.
     */
    PICIMRESOURCE sub;
    const _TCHAR *base;

    const _TCHAR *resourcetype = _tcsgetresourcetype(NewValueType);
    const _TCHAR *local;

    local = GetLocal(To);
    base = CimBaseName(resourcetype);
    
    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

    sc = sub->v->ChangeResource(sub, 0, local, base, NULL,
                             NewValue, NewValueType, NULL,
                             Value, pValueType, ValueSize, NULL);
  
    CHECKSC("resource Update");

    if(sc == S_OK)
    {
         memcpy(Value, &upd_resp, sizeof(DefaultUpdateResponse));
         _tcscpy(pValueType, _T("dssp:DefaultUpdateResponse"));
    }

METHOD_CLEANUP;
    return sc;
}

PRIVATE SCODE dsspUpsertRequest (
    PIDSSP iThis,
    const _TCHAR * To,
    const void * NewValue,
    const _TCHAR * NewValueType,
    /*out*/ void * Value,
    /*out*/ _TCHAR * pValueType,
    UINT ValueSize)
{
    METHOD_DECLARE_MULTI(Dssp, dssp, UpsertRequest);

    PICIMRESOURCE sub;
    const _TCHAR *base;

    const _TCHAR *resourcetype = _tcsgetresourcetype(NewValueType);
    const _TCHAR *local;

    local = GetLocal(To);
    base = CimBaseName(resourcetype); 
    
    sub = GetCim(This);
    CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

    sc = sub->v->ChangeResource(sub, NAME_SPACE_CREATE, local , base, NULL,
                             NewValue, NewValueType, NULL,
                             Value, pValueType, ValueSize, NULL);
    CHECKSC("resource Upsert");

    if(sc == S_OK)
    {
         memcpy(Value, &ups_resp, sizeof(DefaultUpsertResponse));
         _tcscpy(pValueType, _T("dssp:DefaultUpsertResponse"));
    }

METHOD_CLEANUP;
    return sc;
}

#define TIME_FOREVER_INITIALIZER Int64Initializer(~0,~0)
#define TIME_ORIGIN_INITIALIZER Int64Initializer(0,0)

//#ifndef _MINIMIZE
const static struct StickState StickState1 = {
    _T("[StickStateName]"),
    1256,
    783
};

struct StickState StickState2 = {
    _T("[StickStateName]"),
    0,
    123
};

const struct GyroPolicy GP = {
    _T("[GyroPolicyName]"),
    10,
    Int64Initializer(-1,TIME_RELATIVE(TIME_SECONDS(20))),
    TIME_ORIGIN_INITIALIZER
};
//#endif

PRIVATE SCODE progMain (
    PIPROGRAM iThis,
    const _TCHAR * cmdline)
{
    METHOD_DECLARE(Dssp, Main);
	PIDSSP dssp = NULL;
    /* The following address are for creating resources "under each other" */
    const _TCHAR *url = _T("http://127.0.0.1/TEST0/TEST");
//#ifndef _MINIMIZE
    const _TCHAR *url0 = _T("http://127.0.0.1/TEST0");
    const _TCHAR *url2 = _T("http://127.0.0.1/TEST0/TEST/TEST2");

    const _TCHAR *urlroot = _T("http://127.0.0.1/root");

    const _TCHAR *urlevi = _T("http://127.0.0.1/EVIDENCE");
    const _TCHAR *urlevi0 = _T("http://127.0.0.1/EVIDENCE/TEST0");
    const _TCHAR *urlevi1 = _T("http://127.0.0.1/EVIDENCE/TEST0/TEST");
    const _TCHAR *urlevi2 = _T("http://127.0.0.1/EVIDENCE/TEST0/TEST/TEST2");
//#endif
    
    
    UINT a=1,b=2;
    const _TCHAR *resourcetype = _tcsgetresourcetype(_T("st1:StickState"));
    
    void *Value = NULL;
    _TCHAR *pValueType = NULL;
    UINT ValueSize;
//#ifndef _MINIMIZE
    TIME t;
    _TCHAR typeis[100];
    PICIMRESOURCE sub;
    const _TCHAR *base;
    const _TCHAR *local;
//#endif
    _TCHAR *CmdLine2 = NULL, *User = NULL, *Pass = NULL, *Tests = NULL;
    _TCHAR context[100], MessageId[50];

    PISOAPFACTORY soapfactory = NULL;
    PBYTE Buffer;
    PRecordList MoreItems = NULL;
    PRecordList MoreItems2 = NULL;
    EndpointReference ep = {0,};
    EndpointReference ep2 = {0,};

    WSCONTEXT ctx = {0,};
    UINT32 fieldsel[1] = {4}; // AxisB

#ifdef arm
    
#if 0
    INT32 offset_HA[8], offset_LA[8], offset_HB[8], offset_LB[8];
    INT32 off_A, off_B;

    INT32 HA[8], LA[8], HB[8], LB[8];
	INT32 net_A, net_B, raw_A, raw_B;
#else
    UINT8 offset_HA = 0, offset_LA = 0, offset_HB = 0, offset_LB = 0;
    INT32 off_A = 0, off_B = 0;

    UINT8 HA = 0, LA = 0, HB = 0, LB = 0;
	INT32 net_A = 0, net_B = 0, raw_A = 0, raw_B = 0;

#endif
#endif
  
#define BUFFERSIZE 8192
    sc = S_OK;
    Buffer = malloc(BUFFERSIZE);
    if (!Buffer)
        return E_NOT_ENOUGH_MEMORY;

    ValueSize = BUFFERSIZE;


    if (_tcslen(cmdline) > 0) {
        if (_tcspbrk(cmdline, _T(" \t"))) {
            /* Parsing required: wsmantest.cob [[-b user pass] url] */
            CmdLine2 = _tcsdup(cmdline);
            User = _tcssplit(CmdLine2, _T(" \t"));
            CHECKSETSC(!_tcscmp(CmdLine2, _T("-b")), E_INVALID_PARAMETER,
                       "recognize commandline arg");
            Pass = _tcssplit(User, _T(" \t"));
            CHECKSETSC(Pass, E_INVALID_PARAMETER, "parse commandline Pass");
            url = _tcssplit(Pass, _T(" \t"));
            CHECKSETSC(url, E_INVALID_PARAMETER, "parse commandline url");
            Tests = _tcssplit((_TCHAR*) url, _T(" \t"));
        }
        else if (_tcslen(cmdline) > 0 && !_tcsncmp(cmdline, _T("-m"), 2)) {
            doMeasure = 1;
            cmdline += 2;
        }
        else {
            url = cmdline;
        }
    }

    _tcscpy(MessageId, _T("uuid:E9E02CCC-5EB2-4A46-0000-000000000000"));
    {
        TIME t = CurrentTime();
        INT tt = Int64ToInt32(t);

        _stprintf(MessageId + 29, _T("%012u"), tt);
    }
    ep.Address = (_TCHAR *) url;
    ep2.Address = _T("http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous");

    ctx.To = &ep;
    ctx.ReplyTo = &ep2;
    ctx.MessageId = MessageId;
    _tcscpy(context, _T(""));

    sc = BindToObject(CurrentNameSpace(), _T("COB/soap.cob"), NAME_SPACE_READ,
                      &IID_ISoapFactory, (void **) &soapfactory);
    CHECKSC("get soap factory");

    if (TRUE) {

        sc = soapfactory->v->CreateProxy3(soapfactory, NULL,
                                          &ctx, _T("dssp"),
                                          0,
                                          (PIUNKNOWN*) &dssp);
        CHECKSC("CreateProxy3 dssp");
#ifndef _MINIMIZE 
        printf("wstest Created dssp proxy: wxf=%x iunk=%x sc=%x\n",
               (UINT) dssp, (UINT) &IID_IUnknown, sc);
#endif
        if (User) {
            PIHTTPCONNECTOR conn;

            sc = dssp->v->QueryInterface(dssp, &IID_IHttpConnector,
                                        (void**) &conn);
            CHECKSC("get connector from dssp proxy");

            sc = conn->v->SetBasicKey(conn, User, Pass);
            CHECKSC("set basic key for wxf proxy");

            conn->v->Release(conn);
        }
    }

//#ifndef _MINIMIZE

    if (!Tests || !_tcscmp(Tests, _T("p0"))) {
        memset(typeis, 0, sizeof(typeis));
        
#ifdef arm
        /* PowerUp and StartUp -- Initializing the gyro. */
	    gyro_power_start(&offset_HA, &offset_LA, &offset_HB, &offset_LB);

	    off_A = BytesToHalfword(offset_HA, offset_LA);
	    off_B = BytesToHalfword(offset_HB, offset_LB);
#ifndef _MINIMIZE
	    /* This value should be near 0x8000 (or 32,000 decimal) 
         * It is the offset (idle) value of the gyro
         */
        printf("%d %d \n", off_A, off_B);
#endif
#endif
	    
        /* XXX HERE ARE ALL OF THE DSSP TEST REQUESTS */

#if 0
        sc = dssp->v->QueryRequest(dssp,                          //iThis
                            ep.Address,                            
                            &gcreq,
                            _T("rgc:GetControllersRequest"),
				            (void*) Buffer,                     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:QueryRequest");
        printf("dssp:QueryRequest sc=%x typeis=%s\n", sc, typeis);

        sc = dssp->v->GetRequest(dssp,                          //iThis
                            ep.Address,                         //To
				            TRUE,                               //wrapper element
                            (void*) Buffer,                     //Value 
                            BUFFERSIZE,                        //ValueSize
                            &MoreItems); // XXX

        CHECKSC("dssp:GetRequest");
        printf("dssp:GetRequest sc=%x Items=%s\n", sc, MoreItems);
#endif

        //Creating EVIDENCE
        ep.Address = (_TCHAR *) urlroot;
        ctx.To = &ep;        
        
        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type_EVI,                //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);

        //Creating EVIDENCE/TEST0
        ep.Address = (_TCHAR *) urlevi;
        ctx.To = &ep;

        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type0,                //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);

        //Creating EVIDENCE/TEST0/TEST
        ep.Address = (_TCHAR *) urlevi0;
        ctx.To = &ep;

        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type,                //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);

        //Creating EVIDENCE/TEST0/TEST/TEST2
        ep.Address = (_TCHAR *) urlevi1;
        ctx.To = &ep;

        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type2,                //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);
        
        //Inserting GyroPolicy
        ep.Address = (_TCHAR *) urlevi2;
        ctx.To = &ep;

        sc = dssp->v->InsertRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &GP,                                //NewValue
                    _T("st1:GyroPolicy"),               //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:InsertRequest");
        printf("dssp:InsertRequest sc=%x typeis=%s\n", sc, typeis);


        //CREATING TEST0/
        ep.Address = (_TCHAR *) url0;
        ctx.To = &ep;

        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type0,                //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);

        //CREATING TEST0/TEST
        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type,                 //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);

        //CREATING TEST0/TEST/TEST2
        ep.Address = (_TCHAR *) url;
        ctx.To = &ep;

        sc = dssp->v->CreateRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &service_info_type2,                 //InitialValue
                    _T("dssp:ServiceInfoType"),         //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:CreateRequest");
        printf("dssp:CreateRequest sc=%x typeis=%s\n", sc, typeis);

        ep.Address = (_TCHAR *) url2;
        ctx.To = &ep;

        //Inserting initial gyro state
        sc = dssp->v->InsertRequest(dssp,               //iThis
	                ep.Address,                         //To
	                &StickState1,                       //NewValue
                    _T("st1:StickState"),               //NewValueType
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:InsertRequest");
        printf("dssp:InsertRequest sc=%x typeis=%s\n", sc, typeis);

#if 0
        ep.Address = (_TCHAR *) url;
        ctx.To = &ep;


        sc = dssp->v->DropRequest(dssp,               //iThis
	                ep.Address,                         //To
                    TRUE,                               //wrapper element
	                (void*) Buffer,                     //Value 
                    typeis,                             //pValueType
                    BUFFERSIZE);                        //ValueSize


        CHECKSC("dssp:DropRequest");
        printf("dssp:DropRequest sc=%x typeis=%s\n", sc, typeis);

        ep.Address = (_TCHAR *) url0;
        ctx.To = &ep;

        sc = dssp->v->GetRequest(dssp,                          //iThis
                            ep.Address,                         //To
				            TRUE,                               //wrapper element
                            (void*) Buffer,                     //Value 
                            BUFFERSIZE,                        //ValueSize
                            &MoreItems); // XXX

        CHECKSC("dssp:GetRequest");
        printf("dssp:GetRequest sc=%x Items=%s\n", sc, MoreItems);

        sc = dssp->v->UpdateRequest(dssp,                       //iThis
				            ep.Address,                         //To
                            &StickState2,                       //NewValue
                            _T("st1:StickState"),               //NewValueType 
				            (void*) Buffer,                     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:UpdateRequest");
        printf("dssp:UpdateRequest sc=%x typeis=%s\n", sc, typeis);

        
        sc = dssp->v->QueryRequest(dssp,                          //iThis
                            ep.Address,
                            &StickState2, _T("st1:StickState"), fieldsel, // ask for AxisB == 123
				            (void*) Buffer,                     //Value 
                            BUFFERSIZE,                         //ValueSize
                            &MoreItems);                        //ValueSize

        CHECKSC("dssp:QueryRequest");
        printf("dssp:QueryRequest sc=%x typeis=%s\n", sc, typeis);

        sc = dssp->v->LookupRequest(dssp,               //iThis
	                ep.Address,                         //To
                    TRUE,                               //wrapper element
	                (void*) Buffer,                     //Value 
                    BUFFERSIZE,                         //ValueSize
                    &MoreItems);                        //ValueSize

        CHECKSC("dssp:LookupRequest");
        printf("dssp:LookupRequest sc=%x\n", sc);

        sc = dssp->v->UpdateRequest(dssp,                       //iThis
				            ep.Address,                         //To
                            &StickState2,                       //NewValue
                            _T("st1:StickState"),               //NewValueType 
				            (void*) Buffer,                     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:UpdateRequest");
        printf("dssp:UpdateRequest sc=%x typeis=%s\n", sc, typeis);

        sc = dssp->v->SubscribeRequest(dssp,                    //iThis
                            ep.Address,                         //To
                            sub,
                            sizeof(sub),
                            subtime,
                            0,
                            submgr,
                            sizeof(submgr));
                            
        CHECKSC("dssp:SubscribeRequest");
        printf("dssp:SubscribeRequest sc=%x typeis=%s\n", sc, typeis);

        sc = dssp->v->GetRequest(dssp,                          //iThis
                            ep.Address,                         //To
				            TRUE,                               //wrapper element
                            (void*) Buffer,                     //Value 
                            BUFFERSIZE,                        //ValueSize
                            &MoreItems); // XXX

        CHECKSC("dssp:GetRequest");
        printf("dssp:GetRequest sc=%x Items=%s\n", sc, MoreItems);
     
        sc = dssp->v->UpdateRequest(dssp,                       //iThis
				            ep.Address,                         //To
                            &StickState2,                              //NewValue
                            _T("st1:StickState"),               //NewValueType 
				            (void*) Buffer,                     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:UpdateRequest");
        printf("dssp:UpdateRequest sc=%x typeis=%s\n", sc, typeis);

        sc = dssp->v->GetRequest(dssp,                          //iThis
                            ep.Address,                         //To
				            TRUE,                               //wrapper element
                            (void*) Buffer,                     //Value 
                            BUFFERSIZE,                        //ValueSize
                            &MoreItems); // XXX

        CHECKSC("dssp:GetRequest");
        printf("dssp:GetRequest sc=%x Items=%s\n", sc, MoreItems);

        sc = dssp->v->UpdateRequest(dssp,                       //iThis
				            ep.Address,                         //To   
                            &StickState1,                             //NewValue
                            _T("st1:StickState"),                     //NewValueType
				            (void*) Buffer,                     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:UpdateRequest");
        printf("dssp:UpdateRequest sc=%x typeis=%s\n", sc, typeis);

        printf("\nBEFORE GET REQUEST\n");

        sc = dssp->v->GetRequest(dssp,                          //iThis
                            ep.Address,                         //To
				            TRUE,                               //wrapper element
                            (void*) Buffer,                     //Value 
                            BUFFERSIZE,                        //ValueSize
                            &MoreItems); // XXX

        CHECKSC("dssp:GetRequest");
        printf("dssp:GetRequest sc=%x Items=%s\n", sc, MoreItems);

        printf("\nAFTER GET REQUEST");

        subscribe_request[0].Expiration = CurrentTime() + 10000000;      
        sc = dssp->v->SubscribeRequest(dssp,                            //iThis
                            ep.Address,                                 //To
				            &subscribe_request,                         //NewValue
                            _T("dssp:SubscribeRequest"),                //NewValueType
                            (PSubscribeResponse*) &subscribe_response,  //Value 
                            typeis,                                     //pValueType
                            BUFFERSIZE);                                //ValueSize

        CHECKSC("dssp:SubscribeRequest");
        printf("dssp:SubscribeRequest sc=%x typeis=%s\n", sc, typeis);
        
        sc = dssp->v->ReplaceRequest(dssp,                          //iThis
                            ep.Address,                               //To
				            &replace_request,                       //NewValue
                            _T("ax:ServiceTutorial1State"),              //NewValueType
                            (void*) Buffer,                     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:ReplaceRequest");
        printf("dssp:ReplaceRequest sc=%x typeis=%s\n", sc, typeis);


        sc = dssp->v->GetRequest(dssp,                          //iThis
                            ep.Address,                         //To
				            TRUE,                               // wrapper element
                            (PGameControllerState*) &gcon2,     //Value 
                            typeis,                             //pValueType
                            BUFFERSIZE);                        //ValueSize

        CHECKSC("dssp:GetRequest");
        printf("dssp:GetRequest sc=%x typeis=%s\n", sc, typeis);
#endif    
        /* Give Robotics Studio a chance to subscribe, even though it could later also. */
        printf("Wait 30 seconds\n");
        Int32ToInt64(t, TIME_RELATIVE(TIME_SECONDS(30)));
        SleepUntil(t);
        printf("Awake!\n");
        local = GetLocal(ep.Address);
        base = CimBaseName(resourcetype);
        
        sub = GetCim(This);
        CHECKSETSC(sub, E_WSA_DESTINATION_UNREACHABLE, "get resource provider");

        RELEASE_NULL(dssp);

        /* Loop:  Poll gyro and update gyro state on 'embedded server'. */
        while(1)
        {
            Int32ToInt64(t, TIME_RELATIVE(TIME_SECONDS(10)));
            SleepUntil(t);

            /* For simulation (not ARM)*/
            StickState2.AxisA = a++;
            StickState2.AxisB = b++;
#ifdef arm          
            /* Poll the real gyro (ARM)*/
            gyro_poll(&HA, &LA, &HB, &LB);
			
	        /* Get "raw" values */
            raw_A = BytesToHalfword(HA, LA);
	        raw_B = BytesToHalfword(HB, LB);
			
            /* Subtract offset (idle) value measured earlier */
	        net_A = raw_A - off_A;
	        net_B = raw_B - off_B;

            printf("%d %d \n", net_A, net_B);

            StickState2.AxisA = net_A;
            StickState2.AxisB = net_B;
#endif       

            /* We add 100000 to avoid dealing with negative numbers 
             * This value is subtracted in Robotics Studio
             */

            StickState2.AxisA += 100000;
            StickState2.AxisB += 100000;

            sc = sub->v->ChangeResource(sub, 0, local, base, NULL,
                                 &StickState2, _T("st1:StickState"), NULL,
                                 Value, pValueType, ValueSize,NULL);
      
            CHECKSC("resource Update");
        };
    }//endbigif
  
    printf("Tests completed OK\n");

//#endif  //_MINIMIZE

METHOD_CLEANUP;
    RELEASE(dssp);
    RELEASE(soapfactory);
    if (CmdLine2)
        free(CmdLine2);
    if (Buffer)
        free(Buffer);

    return sc;
}//endmain


/* This function serves to extract (e.g. 'ServiceInfoType' from "dssp:ServiceInfoType"). */
const _TCHAR* _tcsgetresourcetype(const _TCHAR *pStr1)
{
    _TCHAR c1;
    const _TCHAR *pStr2 = pStr1;

   // _TCHAR* temp;
    do {
        c1 = *pStr1++;
        /* the casts are necessary when pStr1 is shorter & char is signed */
    } while (c1 !=':');


   if(c1 == '\0')
       return pStr2;
   else 
       return (_TCHAR*)pStr1; 
}

   
