// Copyright (c) Microsoft Corporation. All rights reserved.
//

// Test script for WS-Addressing. 
// Runs on Windows using SOAP Toolkit 3.0

var ACTION = "http://tempuri.org/Calc/action/Calc.";
var SERVICE = "http://tempuri.org/Calc/message/";
var WSA = "http://schemas.xmlsoap.org/ws/2004/08/addressing";

// var LOCALHOST = "127.0.0.1";
var LOCALHOST = "172.31.41.95";
var PROTOCOL = "http"; // "x-udp-aes-soap";

var ADDRESSING = 
   "<wsa:MessageID>uuid:1C679413-D71A-4c13-A619-FECAE55BFF42</wsa:MessageID> \
	<wsa:To>http://" + LOCALHOST + "/COB/calc.cob</wsa:To> \
	<wsa:Action>http://tempuri.org/Calc/action/Calc.</wsa:Action> \
	<wsa:RelatedTo>84F7ED15-A9D3-4640-9B05-3A0BCFD859D2</wsa:RelatedTo> \
	<wsa:ReplyTo> \
		<wsa:Address>http://" + LOCALHOST + "/COB/calc.cob</wsa:Address> \
	</wsa:ReplyTo>";

var END_POINT_URL = "http://" + LOCALHOST + "/COB/calc.cob"
//var END_POINT_URL = "http://172.31.41.244/COB/calc.cob"
//var END_POINT_URL = "https://t-yongx/MSSoapSamples30/Calc/Service/SrSz/AspJs/Calc.asp"

WScript.echo("Sending request to: " + END_POINT_URL);

var Answer

Answer = Execute(END_POINT_URL, "Subtract", 5, 28)
WScript.Echo("leds=" + Answer);

Answer = Execute(END_POINT_URL, "Add", 3, 28)
WScript.Echo("leds=" + Answer);

Answer = Execute(END_POINT_URL, "Multiply", 5, 0)
WScript.Echo("leds=" + Answer);

Answer = Execute(END_POINT_URL, "Divide", 6, 2)
WScript.Echo("leds=" + Answer);

WScript.Echo("done");

function Execute(EndPointURL, Method, A, B)
{

    var Serializer;
    var Reader;
    var Connector;
    
    Connector = WScript.CreateObject("MSSOAP.HttpConnector30");
    Connector.Property("EndPointURL") = EndPointURL;

	Connector.Property("Timeout") = 100000; 
    
    Connector.Property("SoapAction") = ACTION & Method;
    Connector.BeginMessage();
    
    Serializer = WScript.CreateObject("MSSOAP.SoapSerializer30");
    Serializer.Init(Connector.InputStream);
    
    Serializer.StartEnvelope();
    Serializer.StartHeader();
    Serializer.SoapNamespace("wsa", WSA);
    Serializer.WriteXML(ADDRESSING);
    Serializer.EndHeader();
    Serializer.StartBody("STANDARD");
    Serializer.StartElement(Method, SERVICE, "NONE", "m");
    Serializer.StartElement("A");
    Serializer.WriteString(A);
    Serializer.EndElement();
    Serializer.StartElement("B");
    Serializer.WriteString(B);
    Serializer.EndElement();
    Serializer.EndElement();
    Serializer.EndBody();
    Serializer.EndEnvelope();
    
    Connector.EndMessage();
    
    Reader = WScript.CreateObject("MSSOAP.SoapReader30");
    Reader.Load(Connector.OutputStream);
    
    if( Reader.Fault == null )
    {
        return Reader.RpcResult.text;
    }
    else
    {
        return "FAULT: " + Reader.FaultString.text;
    }
    
}

