/* Copyright (c) Microsoft Corporation. All rights reserved. */

#ifndef __WS__
#define __WS__

#include <web/cont.h>
#include <util/list-double2.h>
#include <wsif.h>
#include <wsifhelp.h>

#define eprloff offsetof(struct EndpointReference, ListNode)
#define qnloff offsetof(struct QNameItem, ListNode)
#define scloff offsetof(struct Scopes, ListNode)
#define aloff offsetof(WSADVERT, ListNode)
#define pmloff offsetof(struct ProbeMatch, ListNode)
#define sloff offsetof(struct StringItem, ListNode)

#define IWsAddressing_NSID "wsa"
#define IWsDiscovery_NSID "wsd"

PEndpointReference WsEndpointNew(const _TCHAR *Address);
PTR /*PEndpointReference*/ WsEndpointCopy(PTR pItem, PTR pArg);
INT WsEndpointDelete(PTR pItem, PTR pArg);

PQNameItem WsQNameItemNew(const _TCHAR *str);
INT WsQNameItemDelete(PTR pItem, PTR pArg);
PTR /*PQNameItem*/ WsQNameItemCopy(PTR pItem, PTR pArg);
INT WsQNameItemCmp(PTR p1, PTR p2);

PScopes WsScopesNew(const _TCHAR *matchby, const PQNameItem item);
INT WsScopesDelete(PTR pItem, PTR pArg);
PTR /*PScopes*/ WsScopesCopy(PTR pItem, PTR pArg);

PStringItem WsStringItemNew(const _TCHAR *str);
INT WsStringItemDelete(PTR pItem, PTR pArg);
PTR /*PStringItem*/ WsStringItemCopy(PTR pItem, PTR pArg);

PWSADVERT WsAdvertNew(
    PEndpointReference pEndpoint,   //const _TCHAR *Address,
    PQNameItem pTypes,              //const _TCHAR *Types,
    PScopes pScopes,                //const _TCHAR *Scopes,
    PStringItem pXAddrs,             //const _TCHAR *XAddrs,
    UINT MetadataVersion);
INT WsAdvertDelete(PTR pItem, PTR pArg); 
PTR /*PWSADVERT*/ WsAdvertCopy(PTR pItem, PTR pArg); 
INT WsAdvertEndpointCmp(PTR p1, PTR p2);

PProbeMatch WsProbeMatchNew(
    PEndpointReference pEndpoint,   //const _TCHAR *Address,
    PQNameItem pTypes,              //const _TCHAR *Types,
    PScopes pScopes,                //const _TCHAR *Scopes,
    PStringItem pXAddrs,             //const _TCHAR *XAddrs,
    UINT MetadataVersion);
INT WsProbeMatchDelete(PTR pItem, PTR pArg); 
#endif /* __WS__ */
