/* Copyright (c) Microsoft Corporation. All rights reserved. */

#ifndef __WSDISCOV__
#define __WSDISCOV__

#include "ws.h"
#include <base/cobdesc.h>

/* Constants */

/* Name space identifier strings, suffixes, sizes */
/*
#define WS_NSID _T("ws")
#define WSD_NSID _T("ws/discovery/")
#define WSDE_NSID _T("ws/discovery/endpoints/")
#define WSDT_NSID _T("ws/discovery/types/")
#define WSDS_NSID _T("ws/discovery/scopes/")

#define WS_NSID_SZ (_tcslen(WS_NSID))
#define WSD_NSID_SZ (_tcslen(WSD_NSID))
#define WSDE_NSID_SZ (_tcslen(WSDE_NSID))
#define WSDT_NSID_SZ (_tcslen(WSDT_NSID))
#define WSDS_NSID_SZ (_tcslen(WSDS_NSID))

#define WS_NSSUF _T("ws/")
#define WSD_NSSUF _T("discovery/")
#define WSDE_NSSUF _T("endpoints/")
#define WSDT_NSSUF _T("types/")
#define WSDS_NSSUF _T("scopes/")

#define WS_NSSUF_SZ (_tcslen(WS_NSSUF))
#define WSD_NSSUF_SZ (_tcslen(WSD_NSSUF))
#define WSDE_NSSUF_SZ (_tcslen(WSDE_NSSUF))
#define WSDT_NSSUF_SZ (_tcslen(WSDT_NSSUF))
#define WSDS_NSSUF_SZ (_tcslen(WSDS_NSSUF))
*/
/* Track the adverts of a given type or scope.
 *
 * Adverts are arranged into a buffer of pointers. 
 * The Capacity is the total size of the buffer.
 * The Size is the occupied size of the buffer.
 * Removing an existing advert from a property set 
 * will leave a hole in the buffer; this is not reflected 
 * in the size. For example, it's possible to fill the 
 * buffer (Size == Capacity), then clear every seat by 
 * removing the adverts (Size == Capacity still...). 
 * However, adding an advert will always re-use a hole 
 * when possible (but then the Size is not updated 
 * although a new advert was added to the set...). 
 *
 * In other words, Size and Capacity are only for memory 
 * management... yes, this is a bit lame. 
 *
 * The buffer never shrinks, but can grow until no more
 * memory is available or a maximum size is reached.  
 */

//typedef struct WSPROPERTYSET {
//    const _TCHAR *Property;      /* QName of propery */
//    /* Advertisements of endpoints of that property */
//    PWSADVERT *ppAdverts;
//    UINT Size;              /* Number of advertisements */ 
//    UINT Capacity;          /* Buffer size */
//    /* Other properties */
//    ListNodeDeclare(WSPROPERTYSET, ListNode);
//} WSPROPERTYSET, *PWSPROPERTYSET;
//#define psloff offsetof(WSPROPERTYSET, ListNode)

struct _WsDiscoEnum;

/* WS-Discovery singleton object */
typedef struct _WsDiscovery {
    /* WS-Discovery message processing */
    struct _DefCob super;

    /* WS-Discovery utilities for local clients */
    struct IWsDiscoveryUtilVtbl const *WsDiscoveryUtilv;

/*
    PProbeMatch Advertize;
    PProbeMatch Cached;
*/

    PWSADVERT CacheLocal;
    PWSADVERT CacheRemote;

    /* Active enumerators */
    struct WsDiscoEnum *Enumerators;

    /* Integration into the system name space */
//    struct INameSpaceVtbl const *vns;
    /* Known local target services */
//    PWSADVERT CacheLocal;        /* Lists population of /ws/discovery/endpoints/ */
//    PWSPROPERTYSET Types;   /* Lists population of /ws/discovery/types/     */
//    PWSPROPERTYSET Scopes;  /* Lists population of /ws/discovery/scopes/    */
    /* Housekeeping */
    MUTEX mx;
    CONDITION cd;
} WsDiscovery, WSDISCOVERY, *PWSDISCOVERY;

#define pD(_x_) ((PWSDISCOVERY)(_x_))
#define iD(_x_) ((PIWSDISCOVERY)(_x_))
#define pDU(_x_) \
        ((PWSDISCOVERY)((UINT)(_x_) - offsetof(WSDISCOVERY, WsDiscoveryUtilv)))
#define iDU(_x_) \
        ((PIWSDISCOVERYUTIL)(&(_x_)->WsDiscoveryUtilv))

typedef struct _WsDiscoEnum {
    struct CUnknown super;

    PWSDISCOVERY Owner;
    PWSADVERT Current;
    PIHEAP Heap;

    /* When the last probe message was sent */
    TIME LastProbe;
    enum {DEN_LOCAL, DEN_REMOTE, DEN_END} State;

    PQNameItem Types;
    PScopes Scopes;
    
    ListNodeDeclare(_WsDiscoEnum, ListNode);
#define denoff offsetof(struct _WsDiscoEnum, ListNode)
} WsDiscoEnum;

#endif /* __WSDISCOV_H__ */
