/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <mmlite.h>
#include <stdlib.h>
#include <tchar.h>

/* Dumps memory content into a binary file
 */
int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc;
    UINT *Cur, *End;
    INT RetVal = EXIT_FAILURE;
    FILE *fout;
    int i;
    
    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
        _tprintf(_TEXT("No command line args (%x), test FAILED\r\n"), sc);
        exit(RetVal);
    }

    if (argc < 4) {
        _tprintf(_TEXT("Usage: %s StartAddressInHex EndAddressInHex outfile\r\n"), 
                 argv[0]);
        goto Done;
    }

    Cur = (UINT *) _tcstoul(argv[1],NULL,16);
    End = (UINT *) _tcstoul(argv[2],NULL,16);

    fout = _tfopen(argv[3],_T("wb"));
    if (fout == NULL) {
        _tprintf(_TEXT("Could not create output file %s\r\n"), argv[3]);
        goto Done;
    }

    for (i = 0; Cur < End; Cur++, i++) {
        fwrite(Cur,sizeof Cur[0],1,fout);
    }

    fclose(fout);

    RetVal = EXIT_SUCCESS;
Done:
    (void) FreeCmdLine(&argc,&argv);
    exit(RetVal);
    return 0;
}
