/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Computes the appropriate constants to tune the Delay() API.
 * Separate file for too-smart compilers
 */
#include <mmlite.h>
#include <tchar.h>
#include <stdio.h>

extern void TuneDelay(UINT uSec);

struct ITuneBaseRtlVtbl {
    __VTABLE_COMPATIBILITY_FILLER_DECLARATION

    SCODE (*QueryInterface) (
        /*in*/ PIBASERTL pThis,
        /*in*/ REFIID iid,
        /*out*/ void** ppObject);

    UINT (*AddRef) (
        /*in*/ PIBASERTL pThis);

    UINT (*Release) (
        /*in*/ PIBASERTL pThis);

    /* .... */

    void (*Delay) (
        /*in*/ UINT MicroSeconds);

};

struct ITuneBaseRtlVtbl TheTuneBaseRtlVtable = {
    __VTABLE_COMPATIBILITY_FILLER_INITIALIZER
    NULL, NULL, NULL,
    &TuneDelay
};


struct ITuneBaseRtl {
    const struct ITuneBaseRtlVtbl *v;
};

struct ITuneBaseRtl TheTuneBaseRtl = {
    &TheTuneBaseRtlVtable
};

struct ITuneBaseRtl *pTheTuneBaseRtl = &TheTuneBaseRtl;

void MyDelay (
    /*in*/ UINT MicroSeconds)
{
    pTheTuneBaseRtl->v->Delay(
        MicroSeconds);
}

