/* Copyright (c) Microsoft Corporation. All rights reserved. */

/* Computes the appropriate constants to tune the Delay() API.
 * Separate file for too-smart compilers.
 */
#include <mmlite.h>
#include <tchar.h>
#include <stdio.h>

/* Look in the assembly file md\<cpu>\_delay.s for ..
 */
extern void TuneDelayLoop(INT32 LoopCount);

#if 0
UINT TuneDelayMultiplier = 1024; /* platform should define/refine this */
UINT TuneDelayShifter    = 10;   /* platform should define/refine this */
UINT TuneDelayOverhead   = 0;    /* platform should define/refine this */
#else
UINT TuneDelayMultiplier = 5662;
UINT TuneDelayShifter    = 10;
UINT TuneDelayOverhead   = 14131;
#endif

void TuneDelay(UINT uSec)
{
    INT nLoops = (INT)uSec;
    /* Spell it out so the compiler does not promote expressions stupidly
     */
    nLoops = (nLoops * TuneDelayMultiplier) - TuneDelayOverhead;
    nLoops = nLoops >> TuneDelayShifter;
    TuneDelayLoop(nLoops);
}


