/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* Dumps memory content.
 */
int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc;
    UINT *Cur, *End;
    INT RetVal = EXIT_FAILURE;
    int i;
    
    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
        _tprintf(_TEXT("No command line args (%x), test FAILED\r\n"), sc);
        exit(RetVal);
    }

    if (argc < 3) {
        _tprintf(_TEXT("Usage: %s StartAddressInHex EndAddressInHex\r\n"), 
                 argv[0]);
        goto Done;
    }

    Cur = (UINT *) _tcstoul(argv[1],NULL,16);
    End = (UINT *) _tcstoul(argv[2],NULL,16);

    for (i = 0; Cur < End; Cur++, i++) {
        if ((i & 7) == 0)
            _tprintf(_TEXT("\r\n"));
        _tprintf(_TEXT("%8x "), Cur[0]);
    }

    _tprintf(_TEXT("\r\n"));

    RetVal = EXIT_SUCCESS;
Done:
    (void) FreeCmdLine(&argc,&argv);
    exit(RetVal);
    return 0;
}
