/* Copyright (c) Microsoft Corporation. All rights reserved. */

DECIMAL SubtractDecimals(DECIMAL a, DECIMAL b)
{
    DECIMAL c;
    c.i = a.i - b.i;
    return c;
}

void PrintDecimal(DECIMAL a)
{
    UINT64 u64;
    _TCHAR c;

    c = _T('+');
    if (a.i < 0) {
        c = _T('-');
        a.i = -a.i;
    }
    /* needs 64bit math, sigh */
    Uint32ToUint64(u64,a.v.DecimalPart);
    u64 = Uint64TimesUint32(u64,100000);
    u64 = Uint64RShift(u64,16);

    _tprintf(_T("%c%d.%05u"), c, a.v.IntegerPart, Uint64Low32Bits(u64));
}

void TestDecimals(void)
{
    static struct {
        DECIMAL a, b, c;
    } Tests[] = {
        { Point(0,0), Point(0,0), Point(0,0) },
        { Point(1,0), Point(1,0), Point(0,0) },
        { Point(0,0), Point(1,0), Point(-1,0) },

        /*1.0-0.9=0.1 */
        { Point(1,0), Point(0,58982), Point(0,6554) },

        /*-0.x looks funny */
        { Point(3,29421), Point(3,31378), Point(~0, -1957) },

            /* BUGBUG and many more BUGBUG */
        { Point(1,0), Point(1,0), Point(0,0) }
    };
#define nTests (sizeof Tests / sizeof Tests[0])
    int i;
    DECIMAL r;

    for (i = 0; i < nTests; i++) {
        r = SubtractDecimals(Tests[i].a, Tests[i].b);
        if (r.u != Tests[i].c.u) {
            _tprintf(_T("Test[%d]: result "), i);
            PrintDecimal(r);
            _tprintf(_T(" is not "));
            PrintDecimal(Tests[i].c);
            _tprintf(_T(" ["));
            PrintDecimal(Tests[i].a);
            _tprintf(_T("-"));
            PrintDecimal(Tests[i].b);
            _tprintf(_T("]\r\n"));
        }
    }
}


