/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <arm\at91m55800.h>

/* Simple test for the M55800A processor's shutdown/wakeup logic.
 */
int _tmain (int argc, _TCHAR **argv)
{
    _tprintf(_T("Powering off, press the WAKE_UP button for restart...\r\n"));

    /* Set the WAKEUP edge, lest we never wakeup again (until JP7 is opened)
     * Default for SHDN is low, but make sure
     */
    ThePmc->PowerMode = PMCPM_SDAHL_L0|PMCPM_WKEDG_POS;

    /* Do it! */
    ThePmc->PowerControl = PMCPC_SDAHLC;

    /* Methinks we'll get a reset interrupt, wont get back in here */
    _tprintf(_T("Still here ?!?!?  Jumper JP7 must be open, cork it and retry!\r\n"));

    /* One thing would be to do nothing else. As soon as the user plugs JP7
     * the power goes off.  Since that could be surprising.. another thing
     * is to undo the damage and diffuse the bomb we set off.
     * Meaning, turn around the polarity of SHDN for instance.
     */
    ThePmc->PowerMode = PMCPM_SDAHL_L1|PMCPM_WKEDG_NON;
    ThePmc->PowerControl = PMCPC_SDAHLC;

    return 1;
}





