/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Copyright (c) Microsoft Corporation. All rights reserved. */

#define DEVICE_ORDER LITTLE_ENDIAN
#include <mmlite.h>
#include <stdio.h>
#include <arm/at91m63200.h>
#include <stdlib.h>
#include <tchar.h>

/* Check parsing of command line arguments
 */
int _tmain(int argc, _TCHAR **argv)
{
    SCODE sc;
    int ledno, on;

    /* Get args
     */
    sc = ParseCmdLine(&argc, &argv);

#if 1
    if (argc < 3)
        goto Usage;

    /* Parse and say what
     */
    ledno = _ttoi(argv[1]);
    on    = _ttoi(argv[2]);

    if ((ledno < 1) || (ledno > 8)) {
        _tprintf(_TEXT("LED numbers are between 1 and 8 inclusive\n\r"));
        goto Usage;
    }

    _tprintf(_TEXT("Setting LED no.%d %s\n\r"), ledno,
             (on) ? _TEXT("on") : _TEXT("off"));

    /* Turn on/off the given LED
     */
    if (on)
        PioB->ClearData = _bs32(PIOB_PB8 << (ledno - 1));
    else
        PioB->SetData = _bs32(PIOB_PB8 << (ledno - 1));


#else
    for (ledno = 1; ledno < 9; ledno++)
        for (on = 0; on < 3; on++) {
            TIME OneSecondRelative;

            _tprintf(_TEXT("Setting LED no.%d %s\n\r"), ledno,
                     (on&1) ? _TEXT("on") : _TEXT("off"));
            
            /* Turn on/off the given LED
             */
            if (on & 1)
                PioB->ClearData = _bs32(PIOB_PB8 << (ledno - 1));
            else
                PioB->SetData = _bs32(PIOB_PB8 << (ledno - 1));

            Int32ToInt64(OneSecondRelative, TIME_RELATIVE(TIME_SECONDS(1)));

            SleepUntil(Int64TimesInt32(OneSecondRelative, 2));
        }
#endif

    (void) FreeCmdLine(&argc,&argv);
    exit(EXIT_SUCCESS);

    Usage:
    _tprintf(_TEXT("Usage: %s led_number 1|0\n\r"), argv[0]);
    (void) FreeCmdLine(&argc,&argv);
    exit(EXIT_FAILURE);
}
