/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* Check parsing of command line arguments
 */
int _tmain(int argc, _TCHAR **argv)
{
    SCODE sc;
    _TCHAR *line = (_TCHAR*) ProcessArgs();
    _TCHAR *fname;
    PIFILE File;
    UINT bytes;
    INT RetVal = EXIT_FAILURE;

    printf("Command line is <%s>\n", line);
    fname = line;
    line = _tcschr(line, ' ');
    if (!line) {
        _tprintf(_TEXT("Not enough arguments\n"));
        goto Out;
    }
    *line = '\0';
    line++;

    sc = BindToObject(CurrentNameSpace(), fname,
                      NAME_SPACE_READ | NAME_SPACE_WRITE, &IID_IFile,
                      (void *) &File);
    if (FAILED(sc)) {
        _tprintf(_TEXT("Could not open %s sc=%x\n"), fname, sc);
        goto Out;
    }

    sc = File->v->WriteAt(File, UINT64_ZERO,
                          (void *) line, _tcslen(line) * sizeof(_TCHAR),
                          &bytes);
    if (FAILED(sc)) {
        _tprintf(_TEXT("Could not write to %s sc=%x\n"), fname, sc);
        goto Out;
    }

    RetVal = EXIT_SUCCESS;
 Out:
    exit(RetVal);
}
