/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Trivial test for file I/O routines
 */

#include <stdio.h>
#include <stdlib.h>
#include <mmlite.h>
#include <string.h>

char goofy[] = "Goofy was here.";
char buf[BUFSIZ];

int _tmain(INT argc, _TCHAR **argv)
{
    _TCHAR *tmpname = _T("fs/foo.dat");
    FILE *f;
    size_t n;
    SCODE sc;
    INT RetVal = EXIT_FAILURE;

    sc = ParseCmdLine(&argc, &argv);
    if (argc > 1)
        tmpname = argv[1];

    printf("Trivial testing of ANSI file I/O, using file %s\n", tmpname);

    /* fopen */
    f = _tfopen(tmpname, _T("r+b"));
    if (f == NULL) {
        _tprintf(_T("%s wont open, creating it..\n"), tmpname);
        f = _tfopen(tmpname, _T("wb"));
        if (f == NULL) {
            printf("FAILED: fopen is broken ???\n");
            goto Done;
        }
    }

    /* fwrite */
    n = fwrite(goofy, sizeof goofy, 1, f);

    if (n != 1) {
        printf("FAILED: fwrite is broken\n");
        goto Done;
    }

    /* fseek */
    if (0 != fseek(f, 0, SEEK_SET)) {
        printf("FAILED: fseek is broken\n");
        goto Done;
    }

    /* fread */
    n = fread(buf, sizeof goofy, 1, f);
    if (n != 1 ||
        strncmp(goofy,buf,n)) {
        printf("FAILED: fread is broken\n");
        goto Done;
    }

    if (0 != fclose(f)) {
        printf("FAILED: fclose is broken\n");
        goto Done;
    }

    /* if we get here... */
    printf("This test PASSED\n");
    RetVal = EXIT_SUCCESS;
 Done:
    FreeCmdLine(&argc, &argv);
    exit(RetVal);
}
