/*
* GS.C GetSize - recovers file size and prints to screen. 
* Can bind file with various flags first .. 
* Copyright (c) Microsoft Corporation. All rights reserved. 
*/

#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include "..\utilities\utility.h"

int _tmain(INT argc, _TCHAR **argv)
{
    IFile * pFile;
    UINT64 nPos, nSize;
    UINT flags = 0;
    SCODE sc; 

    Uint32ToUint64(nPos,0);
    Uint32ToUint64(nSize,0);

    ParseCmdLine(&argc, &argv); 
    OptionalBreak(argc, argv);
    if(argc < 2) 
    {
        _tprintf(_T("\n\rUsage:<prog> <filename>[flags]")); //usage screen
        _tprintf(_T("\n\rFlags are: -r -w -c -x -sr -sw")); 
        _tprintf(_T("\n\rMeaning: -r->Read -w->Write -c->Create -x->fail if eXists -sr->Share Read -sw->Share Write -bogus->Bogus flag")); 
        _tprintf(_T("\n\rUse this to get size of a file, and to test IFile::GetSize() for various parms")); //usage screen
        TellAboutOptionalBreak();
        return SetAndReturn(1);
    }

    flags = FetchFlagsFromCommandLine(argc, argv, &nSize); 
    
    sc = BindToObject(CurrentNameSpace(), argv[1], flags, &IID_IFile, (void **)&pFile); 

    Outcome(BIND, sc, argv[1], flags, UINT64_ZERO); 
    if(FAILED(sc)) 
    {
        FreeCmdLine(&argc, &argv); 
        return SetAndReturn(1); 
    }

    sc = pFile->v->GetSize(pFile, &nSize); 
    Outcome(GETSIZE, sc, argv[1], flags, nSize);

    pFile->v->Release(pFile);
    FreeCmdLine(&argc, &argv);
    return SetAndReturn(0); 
}

