/*
* Heap extraction smoke test
* Real extraction testing is done in prime_realloc_and_free.c
* Copyright (c) Microsoft Corporation All rights reserved.
* a-ericf
*/
#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include "heaputils.h"
#include "../utilities/utility.h"

int _tmain(INT argc, _TCHAR **argv)
{

    PTR p0 = 0, p1 = 0; 

    PIHEAP pHeap = CurrentHeap(); 

    ParseCmdLine(&argc, &argv);
    OptionalBreak(argc, argv);
    TellAboutOptionalBreak();

    p0 = pHeap->v->Alloc(pHeap, 0, 0x1000, 0); 

    p1 = pHeap->v->Extract(pHeap, 0, (char *)p0 + 0x20 + pHeap->v->Size(pHeap, 0, p0), 0x200); 

    if(p0) pHeap->v->Free(pHeap, 0, p0); 

    if(p1) pHeap->v->Free(pHeap, 0, p1); 

    FreeCmdLine(&argc, &argv);

    return SetAndReturn(0);

}


