/*
* Heaputils.h - contains some generic heap testing utility function prototypes. 
* Copyright (c) Microsoft Corp. All rights reserved. 
*/
#ifndef _HEAPUTILS_H_
#define _HEAPUTILS_H_

#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>

#define             MEMORY_OVERHEAD_SIZE (8) //fixed overhead for one allocation
#define             HEAPSIZE              0x10000

UINT PhysicalMemoryAvailable(void);
void anomaly(const _TCHAR *, const _TCHAR *, UINT, const _TCHAR *);
void error(const _TCHAR *, const _TCHAR *, UINT, const _TCHAR *);
void params(const IHeap * pHeap, const void * pAllocBlock, UINT nFlags, UINT nSize, UINT nAllocAlign);
UINT GetAlignment(const void *);
BOOL CheckAlignment(const PTR, UINT, UINT);
BOOL CheckSize(IHeap *,UINT, UINT);
BOOL MemoryAllZeroes(const PTR pMem, UINT nLenOverall, UINT nOffset);
void StuffMemory(PTR pMem, UINT nLen);
BOOL MemoryNotThrashed(const PTR pMem, UINT nLen);

#endif
