/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* Happily jumps somewhere
 */
int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc;
    void (*jumpy)(void);
    INT RetVal = EXIT_FAILURE;
    
    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
        _tprintf(_TEXT("No command line args (%x), test FAILED\r\n"), sc);
        exit(RetVal);
    }

    if (argc < 2) {
        _tprintf(_TEXT("Usage: %s JumpAddressInHex\r\n"), 
                 argv[0]);
        goto Done;
    }

    jumpy = (void (*)(void)) _tcstoul(argv[1],NULL,16);

    _tprintf(_TEXT("Jumping to x%x, see ya..\r\n"), (ADDRESS)jumpy);

    jumpy();

    RetVal = EXIT_SUCCESS;
Done:
    (void) FreeCmdLine(&argc,&argv);
    exit(RetVal);
    return 0;
}
