/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* Tests longjump/setjump
 */
/* Only these have longjump so far */
#if defined(arm) || defined(mips) || defined(i386)
extern UINT32 setjump(PCXTINFO regs);
extern void longjump(PCXTINFO regs, UINT32 retval);

struct _CXTINFO state;

#define t0(_n_) longjump(&state,_n_)
#define t1(_n_) setjump(&state);

#else
void t0(UINT32 n)
{
    _tprintf(_T("setjump/longjump not available for this processor\n"));
}
UINT32 t1(UINT32 n)
{
    _tprintf(_T("setjump/longjump not available for this processor\n"));
    return 0x666;
}
#endif

UINT32 step, v;

int _tmain(INT argc, _TCHAR **argv)
{
    INT RetVal = EXIT_FAILURE;
    
    step = 0;
    v = t1(0);
    switch (v) {
    case 0:
        /* we setjumped */
        if (step != 0) {
            _tprintf(_T("Step0 error: %d, v = %d\n"), step, v);
            goto Done;
        }
        step++;
        t0(1);
        break;
    case 1:
        /* we longjumped */
        if (step != 1) {
            _tprintf(_T("Step1 error: %d, v = %d\n"), step, v);
            goto Done;
        }
        step++;
        t0(2);
        break;
    case 2:
        /* we longjumped again */
        if (step != 2) {
            _tprintf(_T("Step2 error: %d, v = %d\n"), step, v);
            goto Done;
        }
        break;
    default:
        _tprintf(_T("Step? error: %d, v = %d\n"), step, v);
        goto Done;
    }

    _tprintf(_T("setjump/longjump tested OK.\n"));

    RetVal = EXIT_SUCCESS;
Done:
    (void) FreeCmdLine(&argc,&argv);
    exit(RetVal);
    return 0;
}
