/*
* Copyright (c) Microsoft Corporation All Rights Reserved. 
* Very basic test. 
*/
#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include <stddef.h>
#include <util/list-double2.h>
#include <wsif.h>
#include <soapif.h>
#include <sampleif.h>
//#include "..\utilities\utility.h"
#include "measurement.h"

int _tmain(int argc, _TCHAR ** argv)
{
	METHOD_DECLARE_NOTHIS("_tmain");
	PITEST test = NULL;
	PISOAPFACTORY soapfactory = NULL;
    long i = 0, j = 0;
    TIME t1[4], t2[4];

	sc = BindToObject(CurrentNameSpace(), _T("COB/soap.cob"), NAME_SPACE_READ,
						&IID_ISoapFactory, (void **) &soapfactory);

	CHECKSC("get soap factory");

    sc = soapfactory->v->CreateProxy(soapfactory, NULL, _T("http://127.0.0.1/COB/testservice.cob"), 
									_T("ITest"), 0, (PIUNKNOWN*) &test);
	CHECKSC("CreateProxy itest");

    _tprintf(_T("\n+++++ native to native (remote) start +++++\n"));
    for (i = 0; i < 10; i++) sc = test->v->Simple1(test, 1);
    t1[0] = CurrentTime();
    for (i = 0; i < 100; i++) 
        sc = test->v->Simple1(test, 1);
    t2[0] = CurrentTime();
    t1[0] = Int64Subtract(t2[0], t1[0]);

    for (i = 0; i < 10; i++) sc = test->v->Simple2(test, 1, 2);
    t1[1] = CurrentTime();
    for (i = 0; i < 100; i++) 
        sc = test->v->Simple2(test, 1, 2);
    t2[1] = CurrentTime();
    t1[1] = Int64Subtract(t2[1], t1[1]);

    for (i = 0; i < 10; i++) sc = test->v->Simple3(test, 1, 2, 3);
    t1[2] = CurrentTime();
    for (i = 0; i < 100; i++)
        sc = test->v->Simple3(test, 1, 2, 3);
    t2[2] = CurrentTime();
    t1[2] = Int64Subtract(t2[2], t1[2]);

    for (i = 0; i < 10; i++) sc = test->v->Simple4(test, 1, 2, 3, 4);
    t1[3] = CurrentTime();
    for (i = 0; i < 100; i++)
        sc = test->v->Simple4(test, 1, 2, 3, 4);
    t2[3] = CurrentTime();
    t1[3] = Int64Subtract(t2[3], t1[3]);

    _tprintf(_T("\n+++++ native to native (remote) +++++\n"));
    PrintTime(_T("\nSimple1"), t1[0]);
    PrintTime(_T("\nSimple2"), t1[1]);
    PrintTime(_T("\nSimple3"), t1[2]);
    PrintTime(_T("\nSimple4"), t1[3]);

    METHOD_CLEANUP;
	RELEASE(test);
	RELEASE(soapfactory);
	return 0; 
}