/*
* Copyright (c) Microsoft Corporation All Rights Reserved. 
* Very basic test. 
*/
#include <mmlite.h>
#include <mmmacros.h>
#include <stdio.h>
/*
#include <tchar.h>
#include <stdlib.h>
#include <stddef.h>

#include <util/list-double2.h>
#include <wsif.h>
#include <soapif.h>
#include <sampleif.h>
//#include "..\utilities\utility.h"
*/

#ifndef PrintTime
#define PrintTime(_desc_,_time_) \
    { \
        _TCHAR buf[50]; \
        TimeFormat(_time_, buf, sizeof(buf)-1); \
        _tprintf(_desc_); \
        _tprintf(_T(": %s\n"), buf); \
    }
#endif
PRIVATE INT8 days[2][12] = {{31,28,31,30,31,30, 31,31,30,31,30,31},
                            {31,29,31,30,31,30, 31,31,30,31,30,31}};
PRIVATE char *DayName[7] = {"Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"};

PRIVATE BOOL IsLeap(UINT y)
{
    BOOL is = (!(y%4) && ((y%100) || !(y%400)));
    //DBG(("IsLeap(%d) => %d\n", y, is));
    return is;
}

void TimeFormat(TIME t, _TCHAR *buf, UINT Len)
{
    TIME t2;
    INT leaps, f,s,min,h,d,mo,y, wd, xxx;
    BOOL relative = TimeIsRelative(t) || Int64Equal(t, TIME_ORIGIN);

    if (relative)
        t = Int64Subtract(TIME_ORIGIN, t);

    /* First deal with fractions */
    t2 = Int64ModulusInt32(t,  10000000);
    t = Int64DividedByInt32(t, 10000000);
    f = Int64ToInt32(t2);

    if (relative) {
        _stprintf(buf, _T("PT%lld.%07dS"), t,f);
        return;
    }

    /* seconds */
    t2 = Int64ModulusInt32(t, 60);
    t = Int64DividedByInt32(t, 60);
    s = Int64ToInt32(t2);

    /* minutes */
    t2 = Int64ModulusInt32(t, 60);
    t = Int64DividedByInt32(t, 60);
    min = Int64ToInt32(t2);

    /* hours */
    t2 = Int64ModulusInt32(t, 24);
    t = Int64DividedByInt32(t, 24);
    h = Int64ToInt32(t2);
    
#if !defined(arm)               /* arm_arm generates call to __rt_divtest */
    /* days since Jan 1, 1601, Gregorian calendar. */
    xxx = wd = Int64ToInt32(t);
    wd %= 7;
    wd++;
#endif

    /* figure out rough year, then adjust with leap days */
    t2 = Int64ModulusInt32(t, 365);
    t = Int64DividedByInt32(t, 365);
    d = Int64ToInt32(t2);

    y = Int64ToInt32(t);        /* from 1601 */

    leaps = y / 4 - y / 100 + y / 400; /* from 1600, does not include current year */

    d -= leaps;

    //printf("y=%d leaps=%d now=%d d=%d wd=%d [%s] totaldays=%d\n",
             //y, leaps, (y%4 == 0), d, wd, DayName[wd-1], xxx);

    while (d < 0) {
      /* if we are millenia in the future there might be more bogus leaps
       * than one year worth */
        leaps = IsLeap(y+1601-1);       /* last year */
        d += (leaps ? 366 : 365);
        y--;
    }
    leaps = IsLeap(y+1601);       /* this year */

    for (mo = 0; mo < 12; ) {
        if (d < days[leaps][mo])
            break;
        d -= days[leaps][mo];
        mo++;
    }
    /* make them one-based */
    mo++;
    d++;
    y += 1601;

    /* Time zone: UTC (boot time?) */
    _stprintf(buf,_T("%04d-%02d-%02dT%02d:%02d:%02d.%07dZ"), y,mo,d,h,min,s,f);
}


void test1(int i) {}
void test2(int i, int j) {}
void test3(int i, int j, int k) {}
void test4(int i, int j, int k, int l) {}


int _tmain(int argc, _TCHAR ** argv)
{
    long i = 0, j = 0;
    TIME t1, t2;

    

    t1 = CurrentTime();
    for (i = 0; i < 100000; i++)
        for (j = 0; j < 1000; j++);
    t2 = CurrentTime();
    t1 = Int64Subtract(t2, t1);
    PrintTime(_T("no op  "), t1);

    // test1()
    for (i = 0; i < 5; i++) test1(1);
    t1 = CurrentTime();
    for (i = 0; i < 100000; i++) for (j = 0; j < 1000; j++) test1(1);
    t2 = CurrentTime();
    t1 = Int64Subtract(t2, t1);
    PrintTime(_T("test1()"), t1);

    // test2()
    for (i = 0; i < 5; i++) test2(1, 1);
    t1 = CurrentTime();
    for (i = 0; i < 100000; i++) for (j = 0; j < 1000; j++) test2(1, 1);
    t2 = CurrentTime();
    t1 = Int64Subtract(t2, t1);
    PrintTime(_T("test2()"), t1);

    // test3()
    for (i = 0; i < 5; i++) test3(1, 1, 1);
    t1 = CurrentTime();
    for (i = 0; i < 100000; i++) for (j = 0; j < 1000; j++) test3(1, 1, 1);
    t2 = CurrentTime();
    t1 = Int64Subtract(t2, t1);
    PrintTime(_T("test3()"), t1);

    // test4()
    for (i = 0; i < 5; i++) test4(1, 1, 1, 1);
    t1 = CurrentTime();
    for (i = 0; i < 100000; i++) for (j = 0; j < 1000; j++) test4(1, 1, 1, 1);
    t2 = CurrentTime();
    t1 = Int64Subtract(t2, t1);
    PrintTime(_T("test4()"), t1);

}