/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <mips/ml40x.h>

/* Special instructions */
#ifdef mips
extern UINT32 SpecialInstruction0(UINT32 a0_r4, UINT32 a1_r5, UINT32 a2_r6, UINT32 a3_r7);
extern UINT32 SpecialInstruction1(UINT32 a0_r4, UINT32 a1_r5, UINT32 a2_r6, UINT32 a3_r7);
extern UINT32 SpecialInstruction2(UINT32 a0_r4, UINT32 a1_r5, UINT32 a2_r6, UINT32 a3_r7);
#else
#define SpecialInstruction0(a0_, _a1_, _a2_, _a3_) 0
#define SpecialInstruction1(a0_, _a1_, _a2_, _a3_) 0
#define SpecialInstruction2(a0_, _a1_, _a2_, _a3_) 0
#endif

#define Puts(x)    _tprintf(_T(x))
#define PutWord(x) _tprintf(_T("%8.8X"),x);
#define PutChar(c) _puttchar(c)

void DumpUint32(char *What, UINT32 Value)
{
    Puts(What);
    PutWord(Value);
    PutChar('\n');
}

int _tmain(INT argc, _TCHAR **argv)
{
    char Step = 'a'-1;
    UINT32 x;

    /* Test utils */
    Step++;
    DumpUint32("ext_test step=", (UINT32)Step);

    /* Execute extended instruction.
     * This will trap if the extension is not loaded (and we get terminated)
     */
    Step++;
	x = SpecialInstruction0(0,0,0,0);

    /* Did it work or did it fail?
     */
    DumpUint32("logged writes", x);
    Puts("TEST PASSED SUCCESSFULLY\n");
    return 0;

    /* We never get here */
#if 0
 error:
    Puts("TEST FAILED at Step=");
    PutChar(Step);
    Puts("\n");
    return -1;
#endif
}
