/*
bind.c - Calls INamespace::Bind() with various parms
Copyright (c) Microsoft Corporation. All rights reserved
*/

#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include "..\utilities\utility.h"

int _tmain(INT argc, _TCHAR **argv)
{
    IFile * pFile = 0;
    UINT flags = 0;
    SCODE sc; 

    ParseCmdLine(&argc, &argv); 
    OptionalBreak(argc, argv); 

    if(argc < 2) 
    {
        _tprintf(_T("\n\rUsage:<progname> <filename>[flags]")); 
        _tprintf(_T("\n\rFlags are: -r -w -c -x -sr -sw -bogus")); 
        _tprintf(_T("\n\rMeaning: -r->Read -w->Write -c->Create -x->fail if eXists -sr->Share Read -sw->Share Write -bogus->Bogus flag")); 
        TellAboutOptionalBreak();
        FreeCmdLine(&argc, &argv); 
        return SetAndReturn(1);
    }

    flags = FetchFlagsFromCommandLine(argc, argv, 0); 
 
    sc = BindToObject(CurrentNameSpace(), argv[1], flags, &IID_IFile, (void **)&pFile);
 
    Outcome(BIND, sc, argv[1], flags, UINT64_ZERO);
    
    if(SUCCEEDED(sc)) 
        pFile->v->Release(pFile);

    FreeCmdLine(&argc, &argv); 
    return SetAndReturn(0);
}

