/*
ur.c - Simple utility to unregister an object in a namespace. 
Calls UnRegister() with flags passed on cmd line. 
Copyright (c) 2002 Microsoft Corporation - All US and International Rights reserved. 
a-ericf
*/

#include <tchar.h>
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include "..\utilities\utility.h"


int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc; 
    UINT64 ZERO64 = Int64Initializer(0,0);
    
    ParseCmdLine(&argc, &argv); 
    OptionalBreak(argc, argv); 

    if(argc < 2) 
    {
        _tprintf(_T("%s"), _T("\n\rUsage:UR.EXE <filename>")); 
        _tprintf(_T("%s"), _T("\n\rUse to test IFile::UnRegister() fxn. Will attempt to UnRegister().")); 
        TellAboutOptionalBreak();
        FreeCmdLine(&argc, &argv); 
        return SetAndReturn(1);
    }
       
    sc = CurrentNameSpace()->v->Unregister(CurrentNameSpace(), argv[1]);
    Outcome(UNREGISTER, sc, argv[1], 0, ZERO64);
    FreeCmdLine(&argc, &argv);
    
    return SetAndReturn(0);
}
