#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include "../utilities/utility.h"
/*
Early test for LoadImage(). Loads binary and tests refcount. 
*/
void Usage(void);

int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc; 
    IModule * pModule = 0;
    UINT64 ZERO64 = Int64Initializer(0,0);
    int i; 
    _TCHAR sArg[1024]; 
    const _TCHAR *sProc = 0, * sFlags = 0;
    _TCHAR *stop = 0;
    UINT flags;
    IProcess * pCur = CurrentProcess();

    *sArg = 0;
    
    ParseCmdLine(&argc, &argv); 
    OptionalBreak(argc, argv);
    TellAboutOptionalBreak();

    if(argc < 3)
    {
        Usage(); 
        FreeCmdLine(&argc, &argv);
        return SetAndReturn(1);
    }

    sFlags = GetArgFromCommandLine(argc, argv, _TEXT("procflags")); 
    
    if(!sFlags)
    {
        Usage(); 
        flags = LOAD_IMAGE_CALL_ENTRY_POINT | LOAD_IMAGE_CREATE_THREAD;
        _tprintf(_T("\n\rProceeding with default flags value of 0x%x"), flags); 
    }
    else
        if(!*sFlags)
        {
            Usage(); 
            flags = LOAD_IMAGE_CALL_ENTRY_POINT | LOAD_IMAGE_CREATE_THREAD;
            _tprintf(_T("\n\rProceeding with default flags value of 0x%x"), flags); 
        }
        else
            flags = _tcstoul(sFlags, &stop, 16);

    for(i = 1; i < argc; ++i)
        _stprintf(sArg + _tcslen(sArg), _T("%s "), argv[i]);

    sProc = GetArgFromCommandLine(argc, argv, _T("exe"));
    if(!sProc)
    {
        _tprintf(_T("\n\rNeed an EXE, bucko!")); 
        Usage(); 
        FreeCmdLine(&argc, &argv); 
        return SetAndReturn(1);
    }
    else
        if(!*sProc)
        {
            _tprintf(_T("\n\rNeed an EXE, bucko!")); 
            Usage(); 
            FreeCmdLine(&argc, &argv); 
            return SetAndReturn(1);
        }


    sc = pCur->v->LoadImage(pCur, sProc, argc > 1 ? sArg : 0, flags, &pModule); 
    if(SUCCEEDED(sc))
    {
        _tprintf(_T("\n\rCreated a new process OK")); 
        Outcome(LOADIMAGE, sc, argv[1], flags, ZERO64);
/*        if(pModule)
            _tprintf(_T("\n\rModule refcount is %d"), pModule->v->Release(pModule));
            */
    }
    else
        Outcome(LOADIMAGE, sc, argv[1], flags, ZERO64);

    FreeCmdLine(&argc, &argv); 
    return SetAndReturn(0);
}


void Usage()
{
    _tprintf(_T("\n\rUsage:C.EXE -exe <binary> -procflags <flags>")); //usage screen
    _tprintf(_T("\n\rMeaning: Execute <binary> with <flags>")); 
    _tprintf(_T("\n\rUse this to test IProcess::LoadImage()")); //usage screen
}
