/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include "..\utilities\utility.h"

/*
* GO.EXE does nothing but serve as an EXE target for LI.EXE and other process manipulation
* tests. 
* It takes a command line arg that is expected to be an integer, sets the ExitCode to 
* that value and exits. 
*/

int _tmain(INT argc, _TCHAR ** argv)
{
    _TCHAR *stop = 0;
    UINT32 idx; 
    UINT32 nExitCode = 0;
    PIPROCESS pPrc;

    ParseCmdLine(&argc, &argv); 

    _tprintf(_T("\n\rExecuting [%s]"), argv[0]);

    if(argc > 1)
    {
        nExitCode = _tcstoul(argv[1], &stop, 10); 
        _tprintf(_T("\n\r[%s]Recovered exit code of [%d] from command line [%s]"), argv[0], nExitCode, argv[1]);
    }
   
    for(idx = 0; idx < nExitCode; ++idx)
    {
        UINT32 nInnerLoop; 
        for(nInnerLoop = 0; nInnerLoop < nExitCode; ++nInnerLoop)
            ;
    }

    pPrc = CurrentProcess();

    pPrc->v->SetValue(pPrc, PROCESS_VALUE_EXIT_CODE, nExitCode);

    SetExitCodeOutcome(SETEXITCODE, 0);

    _tprintf(_T("\n\r[%s] exiting ..."), argv[0]);
    
    return SetAndReturn(0); 
}

