#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include "icorn.c"
#include "corn.h"
/*
MUNCH - A driver for CORN.COB. 
Used to test basic loading / unloading of modules. 
Used in conjunction with CORN.COB. 
Just loads and binds the COB, calls a few functions on the COB, and unloads it. 
*/
int _tmain(int argc, _TCHAR ** argv);
int _tmain(int argc, _TCHAR ** argv)
{
    SCODE sc; 
    UINT n = 0;
    IUnknown * pUnk;
    ICORN * pCorn = 0;
    INameSpace * pSysNs = 0; 
  
    DebugBreak(); 

    pSysNs = CurrentNameSpace(); 

    sc = pSysNs->v->Bind(pSysNs, _TEXT("COB/corn.cob"), 0, &pUnk); 
    if(sc != S_OK)
        return 1; 

    n = pUnk->v->AddRef(pUnk); 
    n = pUnk->v->Release(pUnk);

    sc = pUnk->v->QueryInterface(pUnk, &IID_ICorn, (void**)&pCorn); 
    if(sc == S_OK)
    {
        n = pCorn->v->AddRef(pCorn); 
        n = pCorn->v->Release(pCorn);

        pCorn->v->AddKernels(pCorn, 10) ; 
        pCorn->v->EatKernels(pCorn, 10) ; 
        pCorn->v->Release(pCorn);
    }
    
    pUnk->v->Release(pUnk);

    return 0; 
}


