#include <mmlite.h>
#include <stdio.h>
#define UNICODE 1
#define _UNICODE 1
#include <tchar.h>
#include <stdlib.h>

int _tmain(int argc, _TCHAR ** argv);
int _tmain(int argc, _TCHAR ** argv)
{
    SCODE sc;
    IHeap * pHeap = CurrentHeap(); 
    PTR *pMem; 
    _TCHAR * stopstr;
    UINT nAllocSize = 00,  nFlags = 0, iterations = 0;
    
    sc = ParseCmdLine(&argc, &argv);

    _tprintf(_T("\n\rIllustrates BUG 90, heap corruption when Free() called twice. ")\
        _T("\n\rRun once as CHOKEALLOC.EXE 100 0 100, then again as CHOKEALLOC 100 0 1. Bugcheck."));
    
    if(argc < 2)
        _tprintf(_T("\n\rUsage:<prog.exe> <allocsize base 10><flags in hex><iter>\r\n...Or use blank params for defaults"));
    
    if(argc >= 2)
    {
        nAllocSize = _tcstol(argv[1], &stopstr, 10); 
    }
  
    if(argc >= 3)
    {
        nFlags = _tcstol(argv[2], &stopstr, 16); 
    }

    if(argc >= 4)
    {
        iterations = _tcstol(argv[3], &stopstr, 10); 
    }
    
    for( ; iterations; --iterations)
    {

        _tprintf(_T("\n\rIteration %d: Allocating %d, flags are 0x%x"), iterations, nAllocSize, nFlags); 
    
        pMem = pHeap->v->Alloc(pHeap, nFlags, nAllocSize, 8); 

        if(!pMem) 
        {
            DebugBreak();
            _tprintf(_T("\n\rAlloc failed")); 
            return 0; 
        }

        _tprintf(_T("\n\rAlloc succeeded")); 
         
        pHeap->v->Free(pHeap, 0, pMem);
        pHeap->v->Free(pHeap, 0, pMem);
    
    }
     
    FreeCmdLine(&argc, &argv);
    return 0;
}

