#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>

const unsigned NUM_ENTRIES  = 0x20; 
const unsigned BLOCKSIZE    = 0x10000; 


int _tmain(int, _TCHAR **); 

int _tmain(int argc, _TCHAR **argv)
{
    SCODE hr;
    unsigned idx; 
    int nMemAvail; 
    struct MACHINE_INFO mach;
    char *MemArray[NUM_ENTRIES]; 
    IHeap * pHeap;
    PIPROCESS pPrc = CurrentProcess(); 

    
    pHeap = CurrentHeap(); 
    nMemAvail = 0; 

    for(idx = 0; idx < NUM_ENTRIES; ++idx)
    {
        hr = pPrc->v->MachineInfo(pPrc, MACHINE_KIND_GENERIC, (struct MACHINE_INFO *)&mach); 
        if(SUCCEEDED(hr))
        {
            if(!idx)
                printf("\n\rTotal Physical mem is %u", mach.TotalPhysicalMemory); 
            
            printf("\n\rAvailable Physical mem is %u", mach.AvailablePhysicalMemory); 
            
            printf("\n\rRequesting %u bytes", mach.AvailablePhysicalMemory/2); 
            MemArray[idx] = pHeap->v->Alloc(pHeap, HEAP_ZERO_MEMORY, mach.AvailablePhysicalMemory/2, 1);
            if(!MemArray[idx])
            {
                printf("\n\rFailed memory allocation on iteration %d, size %ul", idx, mach.AvailablePhysicalMemory/2); 
                break; 
            }

            if(idx)
                printf("\n\rMem delta is %d, expect %d", nMemAvail - mach.AvailablePhysicalMemory, mach.AvailablePhysicalMemory); 
            nMemAvail = mach.AvailablePhysicalMemory;
        }
        else
        {
            printf("\nFailed to get machine info, code 0x%x", hr); 
            return -1; 
        }
    }

    for(--idx ; idx >= 0; --idx)
        if(MemArray)
            pHeap->v->Free(pHeap,0, MemArray[idx]);

    printf("\nHello, world!"); 
    return 0;
    
}
