#include <mmlite.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>


//yes, 1 is not prime, but since they are multiplied, we want the primes themselves in there too
int aPrimes[] = {1,2,3,5,7,11,13,17,19,23,29,31,37,41,47,53};
const unsigned HEAPSIZE    = 0x10000; 
const unsigned NUM_ENTRIES  = sizeof(aPrimes)/sizeof(aPrimes[0]); 
const unsigned ALIGNMENT    = 8;

int _tmain(int, _TCHAR **); 

int _tmain(int argc, _TCHAR **argv)
{
    SCODE hr;
    char * p = 0;
    unsigned k; 
    int nMemAvail; 
    struct MACHINE_INFO mach;
    //char *MemArray[NUM_ENTRIES]; 
    IHeap * pHeap;
    PIPROCESS pPrc = CurrentProcess(); 

    
    pHeap = CurrentHeap(); 
    nMemAvail = 0; 
    
    for(k = 0; k < NUM_ENTRIES; ++k)
    {
        hr = pPrc->v->MachineInfo(pPrc, MACHINE_KIND_GENERIC, (struct MACHINE_INFO *)&mach); 
        if(SUCCEEDED(hr))
        {
            unsigned int nRes, nCom, nUsed, nMaxUsed;
            unsigned int nSubHeap = HEAPSIZE / 4; 
            unsigned int nBlock     = HEAPSIZE / 2;
            char * pMem = pHeap->v->Alloc(pHeap, HEAP_ZERO_MEMORY, nSubHeap, ALIGNMENT); 
            if(!pMem)
                printf("\n\rInitial allocation failed!");
            nMemAvail = mach.AvailablePhysicalMemory;


            printf("\n\rAvailable Physical mem is %u", nMemAvail); 
        
            printf("\n\rRequesting %u bytes", nBlock); 
            pHeap->v->Status(pHeap, &nRes, &nCom, &nUsed, &nMaxUsed);
            printf("\n\rGonna try for %d bytes now .. got res>%d com>%d used>%d max_used>%d", nBlock, nRes, nCom, nUsed, nMaxUsed); 
            p = pHeap->v->Extract(pHeap, HEAP_ZERO_MEMORY, 0, nBlock);
            if(!p)
            {
                printf("\n\rFailed memory allocation on iteration %d, size %u", k, nBlock); 
                break; 
            }
        }
        else
        {
            printf("\nFailed to get machine info, code 0x%x", hr); 
            return -1; 
        }
        pHeap->v->Free(pHeap, 0, p);
    }

    
    printf("\n\rHello again, world!"); 
    pHeap->v->Release(pHeap);
    pPrc->v->Release(pPrc);
    return 0;
    
}
