/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include "../utilities/utility.h"
/* Check parsing of command line arguments
 */
int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc;
    
    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
        _tprintf(_TEXT("No command line args (%x), test FAILED\n\r"), sc);
        return SetAndReturn(EXIT_FAILURE);
    }

    _tprintf(_TEXT("Got %d arguments:\n\r"), argc);
    for (; argc > 0; argc--, argv++)
        _tprintf(_TEXT("%s\n\r"), argv[0]);

    _tprintf(_TEXT("Test PASSED\n\r"));

    (void) FreeCmdLine(&argc,&argv);

    return SetAndReturn(EXIT_SUCCESS);
}
