/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <mmlite.h>

/* Repro for RAID 505: fseek() does not clear EOF
 */
UINT8 Buffer0[16];
UINT8 Buffer[16];

int _tmain(int argc, _TCHAR ** argv)
{
    FILE *f;
    SCODE sc;
    size_t n, i;

    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc) || (argc < 2)) {
        _tprintf(_TEXT("No command line args (%x), "), sc);
        goto Fail;
    }    

    f = _tfopen(argv[1],_T("r"));
    if (f == NULL) {
        _tprintf(_TEXT("Could not open file %s for reading, "), argv[1]);
        goto Fail;
    }

    /* Read all file, make sure not empty
     */
    n = fread(Buffer0, 1, sizeof Buffer0, f);

    if (n == 0) {
        fclose(f);
        _tprintf(_TEXT("Cannot use file %s because empty, "), argv[1]);
        goto Fail;
    }

    while (fread(Buffer, 1, sizeof Buffer, f))
        ;

    fseek(f,0,SEEK_SET);

    i = fread(Buffer, 1, sizeof Buffer, f);

    fclose(f);

    if ((i != n) ||
        (memcmp(Buffer,Buffer0,n) != 0)) {
        _tprintf(_TEXT("Re-read botch %d %d, "), i, n);
        goto Fail;
    }

    _tprintf(_T("This test PASSED\n\r"));
    exit(EXIT_SUCCESS);
    return 0;/*amusme*/

 Fail:
    (void) FreeCmdLine(&argc,&argv);
    _tprintf(_T("This test FAILED\n\r"));
    exit(EXIT_FAILURE);
    return 0;/*amusme*/
}

