/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

#define RELATIVE_TIME_MICROS(time) (time * -10)

int _tmain(int argc, _TCHAR **argv)
{
    int i;
    TIME tTimeWait;
    TIME tSleep,tWake,tOvhd;
    INT32 tw;
    BOOL Passed = TRUE;

    UnusedParameter(argc);
    UnusedParameter(argv);

    /* Get some idea of the basic overheads involved
     */
    tOvhd = TIME_FOREVER;
    for (i = 0; i < 10; i++) {
        tSleep = CurrentTime();
        tWake = CurrentTime();
        tWake = Int64Subtract(tWake, tSleep);
        if (TimeLess(tWake,tOvhd))
            tOvhd = tWake;
    }
    _tprintf(_TEXT("Ovhd = %llx\n\r"), tOvhd);

    for (i = 700; i <= 25700; i += 977) {
        Int32ToInt64(tTimeWait,RELATIVE_TIME_MICROS(i));
        tSleep = CurrentTime();
        SleepUntil(tTimeWait);
        tWake = CurrentTime();
        tWake = Int64Subtract(tWake, tSleep);
        tWake = Int64Subtract(tWake, tOvhd);
        tw = Int64ToInt32(tWake);
        _tprintf(_TEXT("SleepTime: %d us   ActualTime: %d us\n\r"),
                 i, tw / 10);

        /* This test meant to watch SleepUntil's accuracy
         */
        if ((tw/10 - i) > 300) {
            _tprintf(_TEXT("  This took too much\n\r"));
            Passed = FALSE;
        }
    }

    if (Passed)
        _tprintf(_TEXT("SleepUntil test PASSED\n\r"));
    else {
        _tprintf(_TEXT("SleepUntil test FAILED\n\r"));
    }

    exit(Passed?EXIT_SUCCESS:EXIT_FAILURE);
}
