/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include "../utilities/utility.h"

/* Which test(s) should we perform
 */
#define P_TIME_OVERHEADS _TEXT("  Basic overheads timings\n\r")


int nn = 0;
BOOL Passed = TRUE;

void THREAD_LINKAGE FirstThread(THREAD_ARGUMENT arg)
{
    int me, i;

    UnusedParameter(arg);

    me = nn++;

    if (me == 0)
      _tprintf(_TEXT("Will perform the following test:\n\r") \
               P_TIME_OVERHEADS
               );

    if (me == 0) {

        TIME t0, t1, tn, t;

        Int32ToInt64(tn,10000000);
        for (i = 0; i < 10; i++) {
            t0 = CurrentTime();
            t1 = CurrentTime();
            t1 = TimeSubtract(t1,t0);
            if (TimeLess(t1,tn)) {
                tn = t1;
            }
            /*_tprintf(_TEXT("CurrentTime() costs %lld (%d-th loop)\n\r"), t1, i);*/
        }
        _tprintf(_TEXT("Minimum CurrentTime() cost is %lld00 nanos\n\r"), tn);

        Int32ToInt64(t,TIME_RELATIVE(10000)); /* 1milli */
        Int32ToInt64(tn,100000); /* 10milli */
        for (i = 0; i < 10; i++) {
            t0 = CurrentTime();
            SleepUntil(t);
            t1 = CurrentTime();
            t1 = TimeSubtract(t1,t0);
            t1 = TimeAdd(t1,t);
            if (TimeLess(t1,tn)) {
                /*_tprintf(_TEXT("SL %lld\n\r"), t1);*/
                tn = t1;
            }
        }
        _tprintf(_TEXT("Minimum SleepUntil() cost is %lld00 nanos\n\r"), tn);
    }

    /* BUGBUG Should check sensible values according to processor speed ?
     */
    _tprintf(_TEXT("This test PASSED\n\r"));
}

int _tmain(int argc, _TCHAR **argv)
{
    UnusedParameter(argc);
    UnusedParameter(argv);

    FirstThread(0);
    return SetAndReturn(Passed?EXIT_SUCCESS:EXIT_FAILURE);
}
