/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * C test program -- 64-bit signed add/subtract
 */

#if defined(MMLITE)
#include <mmlite.h>
#define XXXX 1

#else
#include <windows.h>
#define i386 /* uhu? */
#define EXTERN_C extern
#include "int64.h"
typedef INT64 TIME;
TIME CurrentTime(void)
{
    TIME t;
    Int64FromHighAndLow(t,0,GetCurrentTime());
#define XXXX 10000
    return t;
}
#endif

/* Was useful for testing under Win32 */
UINT32 TimeDifference(TIME Stop, TIME Start)
{
    UINT32 r;
    Stop = TimeSubtract(Stop,Start);
    r = ((UINT32) Int64ToInt32(Stop) ) * XXXX;
    return r;
}

#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* grumble.. */
typedef struct
    {
    UINT32 LowPart;
    INT32 HighPart;
    }   MY_INT64;


/* NOTE:
 * - We must test Int64Add, Int64Subtract, Int64AddInt32, Int64SubtractInt32
 * - The LowPart is used as 'B' operand in the Int64...Int32 cases.
 * - For each input pair we record all 4 results in the table below.
 * - 6 entries: a, b, a+b, a-b, a+b.low, a-b.low
 */
#define ZERO 0,0
#define ONE  1,0
#define TWO  2,0
#define THRE 3,0
#define NEG1   ~0,~0
#define NEG2   0xfffffffe,~0
#define NEG3   0xfffffffd,~0
MY_INT64 abcdef[] = {
 {ZERO},{ZERO},     {ZERO},{ZERO},{ZERO},{ZERO},
 {ONE},{ZERO},      {ONE},{ONE},{ONE},{ONE},
 {ZERO},{ONE},      {ONE},{NEG1},{ONE},{NEG1},
 {ONE},{ONE},       {TWO},{ZERO},{TWO},{ZERO},
 {NEG1},{NEG1},     {NEG2},{ZERO},{NEG2},{ZERO},
 {NEG1},{ZERO},     {NEG1},{NEG1},{NEG1},{NEG1},
 {ZERO},{NEG1},     {NEG1},{ONE},{NEG1},{ONE},
 {NEG1},{ONE},      {ZERO},{NEG2},{ZERO},{NEG2},
 {ONE},{NEG1},      {ZERO},{TWO},{ZERO},{TWO},
 {ONE},{TWO},       {THRE},{NEG1},{THRE},{NEG1},
 {TWO},{ONE},       {THRE},{ONE},{THRE},{ONE},
 {NEG1},{TWO},      {ONE},{NEG3},{ONE},{NEG3},
 {TWO},{NEG1},      {ONE},{THRE},{ONE},{THRE},
/*13*/
 {~0,0},{0,0},      {~0,0},{~0,0},{~0,0},{~0,0},
 {0,~0},{0,0},      {0,~0},{0,~0},{0,~0},{0,~0},
 {0,0},{~0,0},      {~0,0},{1,~0},{NEG1},{ONE},
 {0,0},{0,~0},      {0,~0},{0,1},{ZERO},{ZERO},
 {~0,0},{~0,0},     {~0-1,1},{0,0},{~0-1,0},{0,1},
 {~0,0},{0,~0},     {~0,~0},{~0,1},{~0,0},{~0,0},
 {0,~0},{~0,0},     {~0,~0},{1,~0-1},{~0,~0-1},{1,~0},
 {0,~0},{0,~0},     {0,~0-1},{0,0},{0,~0},{0,~0},
/*21*/  /* 500 random pairs*/
 {0x1078,0x1a7d8f70}, {0x77ebffe8,0xe6b}, {0x77ec1060,0x1a7d9ddb},
   {0x88141090,0x1a7d8104}, {0x77ec1060,0x1a7d8f70}, {0x88141090,0x1a7d8f6f},
 {0x4e6a,0x70ec}, {0x7b3f,0x32f7af05}, {0xc9a9,0x32f81ff1},
   {0xffffd32b,0xcd08c1e6}, {0xc9a9,0x70ec}, {0xffffd32b,0x70eb},
 {0x43f2,0x14ad}, {0x4b22,0xc9385ba9}, {0x8f14,0xc9387056},
   {0xfffff8d0,0x36c7b903}, {0x8f14,0x14ad}, {0xfffff8d0,0x14ac},
 {0x636d,0xaf2a6524}, {0x2a456bf5,0x27e0}, {0x2a45cf62,0xaf2a8d04},
   {0xd5baf778,0xaf2a3d43}, {0x2a45cf62,0xaf2a6524}, {0xd5baf778,0xaf2a6523},
 {0x1f6b,0x3e544aaf}, {0x4fe1,0x56810d0a}, {0x6f4c,0x94d557b9},
   {0xffffcf8a,0xe7d33da4}, {0x6f4c,0x3e544aaf}, {0xffffcf8a,0x3e544aae},
 {0xcebc1d49,0x6a75}, {0x12a2,0x23b3}, {0xcebc2feb,0x8e28},
   {0xcebc0aa7,0x46c2}, {0xcebc2feb,0x6a75}, {0xcebc0aa7,0x6a75},
 {0x4cb2,0xfc802544}, {0x1669,0x396c}, {0x631b,0xfc805eb0},
   {0x3649,0xfc7febd8}, {0x631b,0xfc802544}, {0x3649,0xfc802544},
 {0xf06915fa,0x176d}, {0x16151748,0x820ee18e}, {0x67e2d42,0x820ef8fc},
   {0xda53feb2,0x7df135df}, {0x67e2d42,0x176e}, {0xda53feb2,0x176d},
 {0x147f,0xaef}, {0x2fe9,0x5ff}, {0x4468,0x10ee},
   {0xffffe496,0x4ef}, {0x4468,0xaef}, {0xffffe496,0xaee},
 {0x49ecf30c,0x696d}, {0x35ff,0x623793e3}, {0x49ed290b,0x6237fd50},
   {0x49ecbd0d,0x9dc8d58a}, {0x49ed290b,0x696d}, {0x49ecbd0d,0x696d},
 {0x259a5365,0x67bc}, {0x90371664,0x48d521bb}, {0xb5d169c9,0x48d58977},
   {0x95633d01,0xb72b4600}, {0xb5d169c9,0x67bb}, {0x95633d01,0x67bc},
 {0xb60bb382,0x7fa5}, {0x6aae,0x2169}, {0xb60c1e30,0xa10e},
   {0xb60b48d4,0x5e3c}, {0xb60c1e30,0x7fa5}, {0xb60b48d4,0x7fa5},
 {0x2aed,0x636ff9ae}, {0xa803be34,0x2634}, {0xa803e921,0x63701fe2},
   {0x57fc6cb9,0x636fd379}, {0xa803e921,0x636ff9ad}, {0x57fc6cb9,0x636ff9ae},
 {0x70d5e10f,0x631247c7}, {0xaf7b5253,0xdf868ddf}, {0x20513362,0x4298d5a7},
   {0xc15a8ebc,0x838bb9e7}, {0x20513362,0x631247c7}, {0xc15a8ebc,0x631247c7},
 {0xda733235,0x39a7}, {0x7620befd,0x316e}, {0x5093f132,0x6b16},
   {0x64527338,0x839}, {0x5093f132,0x39a8}, {0x64527338,0x39a7},
 {0x5d6c,0xe7ea33a4}, {0x3df2,0x7580c90e}, {0x9b5e,0x5d6afcb2},
   {0x1f7a,0x72696a96}, {0x9b5e,0xe7ea33a4}, {0x1f7a,0xe7ea33a4},
 {0xcdda4c05,0x5b79}, {0x233d68eb,0x7078}, {0xf117b4f0,0xcbf1},
   {0xaa9ce31a,0xffffeb01}, {0xf117b4f0,0x5b79}, {0xaa9ce31a,0x5b79},
 {0x7bbd,0x536acb31}, {0x293d,0x47f3}, {0xa4fa,0x536b1324},
   {0x5280,0x536a833e}, {0xa4fa,0x536acb31}, {0x5280,0x536acb31},
 {0x25a91c77,0x604f842f}, {0x33ab3d2d,0x83a}, {0x595459a4,0x604f8c69},
   {0xf1fddf4a,0x604f7bf4}, {0x595459a4,0x604f842f}, {0xf1fddf4a,0x604f842e},
 {0x1464,0xa739c5ba}, {0x18a2,0x60f5ae36}, {0x2d06,0x82f73f0},
   {0xfffffbc2,0x46441783}, {0x2d06,0xa739c5ba}, {0xfffffbc2,0xa739c5b9},
 {0x9a4d5787,0x2a22}, {0x6fd22ad6,0x1537}, {0xa1f825d,0x3f5a},
   {0x2a7b2cb1,0x14eb}, {0xa1f825d,0x2a23}, {0x2a7b2cb1,0x2a22},
 {0x22af,0x2433}, {0x9a98d4be,0x51d6e343}, {0x9a98f76d,0x51d70776},
   {0x65674df1,0xae2940ef}, {0x9a98f76d,0x2432}, {0x65674df1,0x2433},
 {0x161f43d8,0xab7bf03d}, {0x2b8175f9,0x11b318d9}, {0x41a0b9d1,0xbd2f0916},
   {0xea9dcddf,0x99c8d763}, {0x41a0b9d1,0xab7bf03d}, {0xea9dcddf,0xab7bf03c},
 {0xfc6a5649,0x492e52c3}, {0xeda987f4,0x4c0783e6}, {0xea13de3d,0x9535d6aa},
   {0xec0ce55,0xfd26cedd}, {0xea13de3d,0x492e52c3}, {0xec0ce55,0x492e52c4},
 {0x4460,0x1810b0f5}, {0x2333,0x14f9b8f9}, {0x6793,0x2d0a69ee},
   {0x212d,0x316f7fc}, {0x6793,0x1810b0f5}, {0x212d,0x1810b0f5},
 {0x6726,0x86589e5f}, {0x382754d7,0x111d9663}, {0x3827bbfd,0x977634c2},
   {0xc7d9124f,0x753b07fb}, {0x3827bbfd,0x86589e5f}, {0xc7d9124f,0x86589e5e},
 {0x7ce7e14a,0x25a5}, {0x46af,0x51e8}, {0x7ce827f9,0x778d},
   {0x7ce79a9b,0xffffd3bd}, {0x7ce827f9,0x25a5}, {0x7ce79a9b,0x25a5},
 {0x2bb1fc27,0x39b8}, {0x65,0xd9b09f6f}, {0x2bb1fc8c,0xd9b0d927},
   {0x2bb1fbc2,0x264f9a49}, {0x2bb1fc8c,0x39b8}, {0x2bb1fbc2,0x39b8},
 {0x533a,0xed06de04}, {0xa31d27b1,0xf61f8263}, {0xa31d7aeb,0xe3266067},
   {0x5ce32b89,0xf6e75ba0}, {0xa31d7aeb,0xed06de03}, {0x5ce32b89,0xed06de04},
 {0x6e4f532b,0x50d59daa}, {0x7567,0x3dfb}, {0x6e4fc892,0x50d5dba5},
   {0x6e4eddc4,0x50d55faf}, {0x6e4fc892,0x50d59daa}, {0x6e4eddc4,0x50d59daa},
 {0x2a8,0x7eb0}, {0x3735,0x5a8dae42}, {0x39dd,0x5a8e2cf2},
   {0xffffcb73,0xa572d06d}, {0x39dd,0x7eb0}, {0xffffcb73,0x7eaf},
 {0x6b4ecd1c,0x7fdd15ce}, {0x6932,0x1f32}, {0x6b4f364e,0x7fdd3500},
   {0x6b4e63ea,0x7fdcf69c}, {0x6b4f364e,0x7fdd15ce}, {0x6b4e63ea,0x7fdd15ce},
 {0xc678aae3,0x5f2b}, {0x367f0370,0xceed7b6f}, {0xfcf7ae53,0xceedda9a},
   {0x8ff9a773,0x3112e3bc}, {0xfcf7ae53,0x5f2b}, {0x8ff9a773,0x5f2b},
 {0xaa71ff28,0xbbf3a6d3}, {0x622e,0xdbe78796}, {0xaa726156,0x97db2e69},
   {0xaa719cfa,0xe00c1f3d}, {0xaa726156,0xbbf3a6d3}, {0xaa719cfa,0xbbf3a6d3},
 {0x8b2,0xfa92bb90}, {0x3d3a,0x79a4}, {0x45ec,0xfa933534},
   {0xffffcb78,0xfa9241eb}, {0x45ec,0xfa92bb90}, {0xffffcb78,0xfa92bb8f},
 {0x65c7a727,0xdfb173cb}, {0xf5a3d8d4,0xfb42100f}, {0x5b6b7ffb,0xdaf383db},
   {0x7023ce53,0xe46f63bb}, {0x5b6b7ffb,0xdfb173cb}, {0x7023ce53,0xdfb173cb},
 {0x777e8f79,0xabd521a4}, {0x632a,0x65f7}, {0x777ef2a3,0xabd5879b},
   {0x777e2c4f,0xabd4bbad}, {0x777ef2a3,0xabd521a4}, {0x777e2c4f,0xabd521a4},
 {0x25a3,0x7677}, {0x2caa,0x708b429f}, {0x524d,0x708bb916},
   {0xfffff8f9,0x8f7533d7}, {0x524d,0x7677}, {0xfffff8f9,0x7676},
 {0x35f3,0x30be}, {0xf73150f8,0xa858d7ca}, {0xf73186eb,0xa8590888},
   {0x8cee4fb,0x57a758f3}, {0xf73186eb,0x30bd}, {0x8cee4fb,0x30be},
 {0xafc75b91,0x6aff}, {0x5ba7,0xb19c4f9a}, {0xafc7b738,0xb19cba99},
   {0xafc6ffea,0x4e641b65}, {0xafc7b738,0x6aff}, {0xafc6ffea,0x6aff},
 {0x67e4,0x4fdae65f}, {0x47e9597a,0x2bfb}, {0x47e9c15e,0x4fdb125a},
   {0xb8170e6a,0x4fdaba63}, {0x47e9c15e,0x4fdae65f}, {0xb8170e6a,0x4fdae65e},
 {0x6f351d25,0x4c67}, {0xb66c2df1,0x4eab077c}, {0x25a14b16,0x4eab53e4},
   {0xb8c8ef34,0xb15544ea}, {0x25a14b16,0x4c67}, {0xb8c8ef34,0x4c67},
 {0x3c2e,0x69141a63}, {0xb920f544,0xa5ca87b2}, {0xb9213172,0xedea215},
   {0x46df46ea,0xc34992b0}, {0xb9213172,0x69141a62}, {0x46df46ea,0x69141a63},
 {0x2621371b,0xd5f03b67}, {0x34a6,0x603feea3}, {0x26216bc1,0x36302a0a},
   {0x26210275,0x75b04cc4}, {0x26216bc1,0xd5f03b67}, {0x26210275,0xd5f03b67},
 {0x6236047b,0x5abf}, {0x2c335482,0x75e3}, {0x8e6958fd,0xd0a2},
   {0x3602aff9,0xffffe4dc}, {0x8e6958fd,0x5abf}, {0x3602aff9,0x5abf},
 {0x4276,0x6eb4}, {0xdd461e32,0x26e8}, {0xdd4660a8,0x959c},
   {0x22ba2444,0x47cb}, {0xdd4660a8,0x6eb3}, {0x22ba2444,0x6eb4},
 {0x811ca521,0xa5524ece}, {0x6da6,0xd4e0e39b}, {0x811d12c7,0x7a333269},
   {0x811c377b,0xd0716b33}, {0x811d12c7,0xa5524ece}, {0x811c377b,0xa5524ece},
 {0x72f5d78a,0x3fad}, {0x58b5,0x3860}, {0x72f6303f,0x780d},
   {0x72f57ed5,0x74d}, {0x72f6303f,0x3fad}, {0x72f57ed5,0x3fad},
 {0x3b4755d8,0xcd1604b2}, {0x466ded7c,0x4969}, {0x81b54354,0xcd164e1b},
   {0xf4d9685c,0xcd15bb48}, {0x81b54354,0xcd1604b2}, {0xf4d9685c,0xcd1604b1},
 {0x3aba,0x893c8e7c}, {0x24ef,0x29a0}, {0x5fa9,0x893cb81c},
   {0x15cb,0x893c64dc}, {0x5fa9,0x893c8e7c}, {0x15cb,0x893c8e7c},
 {0x5ea85ccb,0x77c}, {0x2267,0xde9}, {0x5ea87f32,0x1565},
   {0x5ea83a64,0xfffff993}, {0x5ea87f32,0x77c}, {0x5ea83a64,0x77c},
 {0xfecb3909,0x6e6e}, {0x35fd,0x165}, {0xfecb6f06,0x6fd3},
   {0xfecb030c,0x6d09}, {0xfecb6f06,0x6e6e}, {0xfecb030c,0x6e6e},
 {0x105ab842,0x74f7}, {0x8ed,0xfb3b1d2a}, {0x105ac12f,0xfb3b9221},
   {0x105aaf55,0x4c557cd}, {0x105ac12f,0x74f7}, {0x105aaf55,0x74f7},
 {0x44408ab0,0x5329f80a}, {0x47ab,0x617de5c6}, {0x4440d25b,0xb4a7ddd0},
   {0x44404305,0xf1ac1244}, {0x4440d25b,0x5329f80a}, {0x44404305,0x5329f80a},
 {0x879d81a0,0xeef782eb}, {0xab7,0x592903aa}, {0x879d8c57,0x48208695},
   {0x879d76e9,0x95ce7f41}, {0x879d8c57,0xeef782eb}, {0x879d76e9,0xeef782eb},
 {0x6834,0x733c}, {0x7c6f7bc5,0x4b4}, {0x7c6fe3f9,0x77f0},
   {0x8390ec6f,0x6e87}, {0x7c6fe3f9,0x733c}, {0x8390ec6f,0x733b},
 {0x23b9,0x3eef}, {0x7062,0x2e43014e}, {0x941b,0x2e43403d},
   {0xffffb357,0xd1bd3da0}, {0x941b,0x3eef}, {0xffffb357,0x3eee},
 {0x48fc,0x3525}, {0x5d77,0x273e}, {0xa673,0x5c63},
   {0xffffeb85,0xde6}, {0xa673,0x3525}, {0xffffeb85,0x3524},
 {0x2a8d8f9d,0x51ec}, {0x30e2,0x8f4901ca}, {0x2a8dc07f,0x8f4953b6},
   {0x2a8d5ebb,0x70b75022}, {0x2a8dc07f,0x51ec}, {0x2a8d5ebb,0x51ec},
 {0x5261,0xc4b13f89}, {0x4483edf1,0x14e0}, {0x44844052,0xc4b15469},
   {0xbb7c6470,0xc4b12aa8}, {0x44844052,0xc4b13f89}, {0xbb7c6470,0xc4b13f88},
 {0xb65df144,0xee993337}, {0x7bc4c150,0x19fc}, {0x3222b294,0xee994d34},
   {0x3a992ff4,0xee99193b}, {0x3222b294,0xee993338}, {0x3a992ff4,0xee993337},
 {0x1227,0x22ef}, {0x14f8,0x1b65}, {0x271f,0x3e54},
   {0xfffffd2f,0x789}, {0x271f,0x22ef}, {0xfffffd2f,0x22ee},
 {0x60893e0b,0x4da3}, {0xee1245d1,0xe272c2bb}, {0x4e9b83dc,0xe273105f},
   {0x7276f83a,0x1d8d8ae7}, {0x4e9b83dc,0x4da3}, {0x7276f83a,0x4da3},
 {0xe5666771,0x2434d648}, {0x2271,0x1cba}, {0xe56689e2,0x2434f302},
   {0xe5664500,0x2434b98e}, {0xe56689e2,0x2434d648}, {0xe5664500,0x2434d648},
 {0xd3c1352e,0x1f2}, {0x54440d73,0xa4}, {0x280542a1,0x297},
   {0x7f7d27bb,0x14e}, {0x280542a1,0x1f3}, {0x7f7d27bb,0x1f2},
 {0x37e9,0x9bdecdce}, {0xc471468f,0x4aa7}, {0xc4717e78,0x9bdf1875},
   {0x3b8ef15a,0x9bde8326}, {0xc4717e78,0x9bdecdcd}, {0x3b8ef15a,0x9bdecdce},
 {0x8477c249,0x663f}, {0x4f3c,0xb7c8123f}, {0x84781185,0xb7c8787e},
   {0x8477730d,0x48385400}, {0x84781185,0x663f}, {0x8477730d,0x663f},
 {0xd513645a,0x5d8ddbc3}, {0xeaa50529,0x36611180}, {0xbfb86983,0x93eeed44},
   {0xea6e5f31,0x272cca42}, {0xbfb86983,0x5d8ddbc3}, {0xea6e5f31,0x5d8ddbc3},
 {0x1e6d,0x14541015}, {0x6376,0x50a30ea8}, {0x81e3,0x64f71ebd},
   {0xffffbaf7,0xc3b1016c}, {0x81e3,0x14541015}, {0xffffbaf7,0x14541014},
 {0x6f79,0x37e5}, {0x6dab,0x9ac0adfe}, {0xdd24,0x9ac0e5e3},
   {0x1ce,0x653f89e7}, {0xdd24,0x37e5}, {0x1ce,0x37e5},
 {0xb500269b,0xb316e607}, {0xc9d2b232,0x44e4}, {0x7ed2d8cd,0xb3172aec},
   {0xeb2d7469,0xb316a122}, {0x7ed2d8cd,0xb316e607}, {0xeb2d7469,0xb316e607},
 {0x786ff098,0x2fa70c1e}, {0x3b39,0x7731}, {0x78702bd1,0x2fa7834f},
   {0x786fb55f,0x2fa694ed}, {0x78702bd1,0x2fa70c1e}, {0x786fb55f,0x2fa70c1e},
 {0x1aae,0x4d283d0d}, {0xe9,0x7aea}, {0x1b97,0x4d28b7f7},
   {0x19c5,0x4d27c223}, {0x1b97,0x4d283d0d}, {0x19c5,0x4d283d0d},
 {0x873ba15b,0x257d}, {0x1c62,0x3139}, {0x873bbdbd,0x56b6},
   {0x873b84f9,0xfffff444}, {0x873bbdbd,0x257d}, {0x873b84f9,0x257d},
 {0x643d,0x1365}, {0x59aa,0xe3cddd9f}, {0xbde7,0xe3cdf104},
   {0xa93,0x1c3235c6}, {0xbde7,0x1365}, {0xa93,0x1365},
 {0x149f6a99,0x345acc50}, {0x4b6b,0x18a2ac57}, {0x149fb604,0x4cfd78a7},
   {0x149f1f2e,0x1bb81ff9}, {0x149fb604,0x345acc50}, {0x149f1f2e,0x345acc50},
 {0x2c36,0xa850eaee}, {0x56f5,0x1ab}, {0x832b,0xa850ec99},
   {0xffffd541,0xa850e942}, {0x832b,0xa850eaee}, {0xffffd541,0xa850eaed},
 {0x127c,0x68264cef}, {0xcb257549,0xda2f18a8}, {0xcb2587c5,0x42556597},
   {0x34da9d33,0x8df73446}, {0xcb2587c5,0x68264cee}, {0x34da9d33,0x68264cef},
 {0x34b8,0x45b4}, {0x2baf,0xa750946}, {0x6067,0xa754efa},
   {0x909,0xf58b3c6e}, {0x6067,0x45b4}, {0x909,0x45b4},
 {0x542c,0xf5bd733d}, {0x29466c31,0x5669}, {0x2946c05d,0xf5bdc9a6},
   {0xd6b9e7fb,0xf5bd1cd3}, {0x2946c05d,0xf5bd733d}, {0xd6b9e7fb,0xf5bd733c},
 {0x7771,0x595eb9f}, {0xd2d4bb69,0x1c3d}, {0xd2d532da,0x59607dc},
   {0x2d2bbc08,0x595cf61}, {0xd2d532da,0x595eb9e}, {0x2d2bbc08,0x595eb9f},
 {0xd5c4653d,0x777a4f44}, {0x74b5,0x376b8f13}, {0xd5c4d9f2,0xaee5de57},
   {0xd5c3f088,0x400ec031}, {0xd5c4d9f2,0x777a4f44}, {0xd5c3f088,0x777a4f44},
 {0x25ba,0xbbc}, {0x28e8,0x403e}, {0x4ea2,0x4bfa},
   {0xfffffcd2,0xffffcb7d}, {0x4ea2,0xbbc}, {0xfffffcd2,0xbbb},
 {0x12feedf6,0x2ea6}, {0x3d6d,0x57d}, {0x12ff2b63,0x3423},
   {0x12feb089,0x2929}, {0x12ff2b63,0x2ea6}, {0x12feb089,0x2ea6},
 {0x3e3d,0x37d4baf9}, {0x6c20,0x660989c6}, {0xaa5d,0x9dde44bf},
   {0xffffd21d,0xd1cb3132}, {0xaa5d,0x37d4baf9}, {0xffffd21d,0x37d4baf8},
 {0x9c472f9e,0x2d75}, {0xf599582e,0x3bfe8217}, {0x91e087cc,0x3bfeaf8d},
   {0xa6add770,0xc401ab5d}, {0x91e087cc,0x2d75}, {0xa6add770,0x2d75},
 {0x2aea8627,0x5ca36aa8}, {0xa86bfba,0xdb6}, {0x357145e1,0x5ca3785e},
   {0x2063c66d,0x5ca35cf2}, {0x357145e1,0x5ca36aa8}, {0x2063c66d,0x5ca36aa8},
 {0x1afa,0xaf05aaa0}, {0x1bb6,0x2626}, {0x36b0,0xaf05d0c6},
   {0xffffff44,0xaf058479}, {0x36b0,0xaf05aaa0}, {0xffffff44,0xaf05aa9f},
 {0x3e66,0x6cae}, {0xcac0324,0x2470}, {0xcac418a,0x911e},
   {0xf3543b42,0x483d}, {0xcac418a,0x6cae}, {0xf3543b42,0x6cad},
 {0x7be4,0x44f2}, {0x5f2f,0x54e3}, {0xdb13,0x99d5},
   {0x1cb5,0xfffff00f}, {0xdb13,0x44f2}, {0x1cb5,0x44f2},
 {0x82101ae9,0x7132}, {0xda6,0x52c63562}, {0x8210288f,0x52c6a694},
   {0x82100d43,0xad3a3bd0}, {0x8210288f,0x7132}, {0x82100d43,0x7132},
 {0xb76c973c,0x55ad}, {0x6e79,0x6c89ff5}, {0xb76d05b5,0x6c8f5a2},
   {0xb76c28c3,0xf937b5b8}, {0xb76d05b5,0x55ad}, {0xb76c28c3,0x55ad},
 {0x16f38276,0xed0cf16b}, {0xdc564cd9,0x4fa2}, {0xf349cf4f,0xed0d410d},
   {0x3a9d359d,0xed0ca1c8}, {0xf349cf4f,0xed0cf16a}, {0x3a9d359d,0xed0cf16b},
 {0x6ebf,0x39a3}, {0x537c,0x3a9}, {0xc23b,0x3d4c},
   {0x1b43,0x35fa}, {0xc23b,0x39a3}, {0x1b43,0x39a3},
 {0x1b07edeb,0x5362}, {0x497a,0x1f63}, {0x1b083765,0x72c5},
   {0x1b07a471,0x33ff}, {0x1b083765,0x5362}, {0x1b07a471,0x5362},
 {0x7ad7ca0c,0x12fe842c}, {0xf1ec866,0xb6f0d325}, {0x89f69272,0xc9ef5751},
   {0x6bb901a6,0x5c0db107}, {0x89f69272,0x12fe842c}, {0x6bb901a6,0x12fe842c},
 {0x46bb,0x33e1}, {0xed929d71,0x1d79f6eb}, {0xed92e42c,0x1d7a2acc},
   {0x126da94a,0xe2863cf5}, {0xed92e42c,0x33e0}, {0x126da94a,0x33e1},
 {0xa3bc2f2,0x3ca9}, {0x6cbb,0x13c}, {0xa3c2fad,0x3de5},
   {0xa3b5637,0x3b6d}, {0xa3c2fad,0x3ca9}, {0xa3b5637,0x3ca9},
 {0xc75109c3,0xed43af50}, {0xf224e77e,0x34a4a126}, {0xb975f141,0x21e85077},
   {0xd52c2245,0xb89f0e29}, {0xb975f141,0xed43af50}, {0xd52c2245,0xed43af50},
 {0x6534439b,0x8649efd6}, {0x4ba4,0xc04b1531}, {0x65348f3f,0x46950507},
   {0x6533f7f7,0xc5fedaa5}, {0x65348f3f,0x8649efd6}, {0x6533f7f7,0x8649efd6},
 {0x44ec,0x59e5}, {0x43d91a3d,0xbcf9cd7b}, {0x43d95f29,0xbcfa2760},
   {0xbc272aaf,0x43068c69}, {0x43d95f29,0x59e5}, {0xbc272aaf,0x59e4},
 {0xd062fb28,0x85fc25fb}, {0xe8f7fed8,0x9f4d5d54}, {0xb95afa00,0x25498350},
   {0xe76afc50,0xe6aec8a6}, {0xb95afa00,0x85fc25fb}, {0xe76afc50,0x85fc25fb},
 {0x54be,0x1ee9}, {0xfcae40cf,0xb1212a80}, {0xfcae958d,0xb1214969},
   {0x35213ef,0x4edef468}, {0xfcae958d,0x1ee8}, {0x35213ef,0x1ee9},
 {0x5b3e,0x4c5d504a}, {0x262b,0x3a65}, {0x8169,0x4c5d8aaf},
   {0x3513,0x4c5d15e5}, {0x8169,0x4c5d504a}, {0x3513,0x4c5d504a},
 {0x29e3dad0,0xa09d5b8c}, {0x7da3,0x6e74}, {0x29e45873,0xa09dca00},
   {0x29e35d2d,0xa09ced18}, {0x29e45873,0xa09d5b8c}, {0x29e35d2d,0xa09d5b8c},
 {0x3661d081,0x845c3f01}, {0x5adebac7,0x1e73a7f4}, {0x91408b48,0xa2cfe6f5},
   {0xdb8315ba,0x65e8970c}, {0x91408b48,0x845c3f01}, {0xdb8315ba,0x845c3f00},
 {0xf9d76225,0xb5195b28}, {0xada2a0bc,0x42ba}, {0xa77a02e1,0xb5199de3},
   {0x4c34c169,0xb519186e}, {0xa77a02e1,0xb5195b28}, {0x4c34c169,0xb5195b29},
 {0xc9fc27d3,0xa4b510ad}, {0x4e0dde40,0x16ac}, {0x180a0613,0xa4b5275a},
   {0x7bee4993,0xa4b4fa01}, {0x180a0613,0xa4b510ae}, {0x7bee4993,0xa4b510ad},
 {0xf7e45611,0x6b9eeccd}, {0x14c9b078,0xdeb943d5}, {0xcae0689,0x4a5830a3},
   {0xe31aa599,0x8ce5a8f8}, {0xcae0689,0x6b9eecce}, {0xe31aa599,0x6b9eeccd},
 {0x782f,0xaeff32f7}, {0x6fbb609a,0x217f}, {0x6fbbd8c9,0xaeff5476},
   {0x90451795,0xaeff1177}, {0x6fbbd8c9,0xaeff32f7}, {0x90451795,0xaeff32f6},
 {0x34e6738b,0x683cafb7}, {0xdc33e69f,0x18fa859d}, {0x111a5a2a,0x81373555},
   {0x58b28cec,0x4f422a19}, {0x111a5a2a,0x683cafb7}, {0x58b28cec,0x683cafb7},
 {0xbfbf4d69,0x68e8}, {0x6773,0x7caa}, {0xbfbfb4dc,0xe592},
   {0xbfbee5f6,0xffffec3e}, {0xbfbfb4dc,0x68e8}, {0xbfbee5f6,0x68e8},
 {0x910d180c,0xbb7}, {0x731,0xd2c}, {0x910d1f3d,0x18e3},
   {0x910d10db,0xfffffe8b}, {0x910d1f3d,0xbb7}, {0x910d10db,0xbb7},
 {0x53e4,0x602f}, {0x49bf,0x7ee7851b}, {0x9da3,0x7ee7e54a},
   {0xa25,0x8118db14}, {0x9da3,0x602f}, {0xa25,0x602f},
 {0x22c750c1,0x4533246a}, {0x67fc,0x4724}, {0x22c7b8bd,0x45336b8e},
   {0x22c6e8c5,0x4532dd46}, {0x22c7b8bd,0x4533246a}, {0x22c6e8c5,0x4533246a},
 {0x316f,0x4b6d14c5}, {0x58ae,0xdf8}, {0x8a1d,0x4b6d22bd},
   {0xffffd8c1,0x4b6d06cc}, {0x8a1d,0x4b6d14c5}, {0xffffd8c1,0x4b6d14c4},
 {0x2d29,0x4b36}, {0x12fad089,0x2f24}, {0x12fafdb2,0x7a5a},
   {0xed055ca0,0x1c11}, {0x12fafdb2,0x4b36}, {0xed055ca0,0x4b35},
 {0xc6e6b272,0x72c99346}, {0xa1af0888,0x7a5cb846}, {0x6895bafa,0xed264b8d},
   {0x2537a9ea,0xf86cdb00}, {0x6895bafa,0x72c99346}, {0x2537a9ea,0x72c99347},
 {0x313f,0x39bd}, {0x99aab1d5,0x4c153a73}, {0x99aae314,0x4c157430},
   {0x66557f6a,0xb3eaff49}, {0x99aae314,0x39bc}, {0x66557f6a,0x39bd},
 {0xdddcddd8,0x5f5f2064}, {0xbfd2ecbb,0x10aa}, {0x9dafca93,0x5f5f310f},
   {0x1e09f11d,0x5f5f0fba}, {0x9dafca93,0x5f5f2064}, {0x1e09f11d,0x5f5f2065},
 {0xb33cdb64,0xa60c3f4d}, {0x6efa382c,0xdaf}, {0x22371390,0xa60c4cfd},
   {0x4442a338,0xa60c319e}, {0x22371390,0xa60c3f4e}, {0x4442a338,0xa60c3f4d},
 {0xe9473c1a,0x3969}, {0x870,0x6f1f3f80}, {0xe947448a,0x6f1f78e9},
   {0xe94733aa,0x90e0f9e9}, {0xe947448a,0x3969}, {0xe94733aa,0x3969},
 {0x622d,0x6a95b0e1}, {0x39b2,0x1bff}, {0x9bdf,0x6a95cce0},
   {0x287b,0x6a9594e2}, {0x9bdf,0x6a95b0e1}, {0x287b,0x6a95b0e1},
 {0xfea,0x386b}, {0x2ea3,0x14b8}, {0x3e8d,0x4d23},
   {0xffffe147,0x23b2}, {0x3e8d,0x386b}, {0xffffe147,0x386a},
 {0x282f,0xe34d0017}, {0x35f0,0x3c3ec80a}, {0x5e1f,0x1f8bc821},
   {0xfffff23f,0xa70e380c}, {0x5e1f,0xe34d0017}, {0xfffff23f,0xe34d0016},
 {0x7df8,0x18333b8c}, {0x14e1,0xd0977058}, {0x92d9,0xe8caabe4},
   {0x6917,0x479bcb34}, {0x92d9,0x18333b8c}, {0x6917,0x18333b8c},
 {0xf6029697,0x28ef}, {0x64eba48f,0xeb3d1b2c}, {0x5aee3b26,0xeb3d441c},
   {0x9116f208,0x14c30dc3}, {0x5aee3b26,0x28f0}, {0x9116f208,0x28ef},
 {0x2cb9,0x3f71}, {0x1e25,0x79043592}, {0x4ade,0x79047503},
   {0xe94,0x86fc09df}, {0x4ade,0x3f71}, {0xe94,0x3f71},
 {0xe2e84bea,0x16471210}, {0xc5220a7e,0xd8e02093}, {0xa80a5668,0xef2732a4},
   {0x1dc6416c,0x3d66f17d}, {0xa80a5668,0x16471210}, {0x1dc6416c,0x16471211},
 {0x3e32,0xbf8e3e70}, {0x166de853,0x917813c4}, {0x166e2685,0x51065234},
   {0xe99255df,0x2e162aab}, {0x166e2685,0xbf8e3e70}, {0xe99255df,0xbf8e3e6f},
 {0xc38626ec,0x4375}, {0x4cad,0xf76}, {0xc3867399,0x52eb},
   {0xc385da3f,0x33ff}, {0xc3867399,0x4375}, {0xc385da3f,0x4375},
 {0x787dc3af,0x98ad473a}, {0x7364,0x6233}, {0x787e3713,0x98ada96d},
   {0x787d504b,0x98ace507}, {0x787e3713,0x98ad473a}, {0x787d504b,0x98ad473a},
 {0x82d,0x84444ca1}, {0x3fb,0xe12b7677}, {0xc28,0x656fc318},
   {0x432,0xa318d62a}, {0xc28,0x84444ca1}, {0x432,0x84444ca1},
 {0xe8884be0,0xee98172}, {0x47839242,0x4dfb}, {0x300bde22,0xee9cf6e},
   {0xa104b99e,0xee93377}, {0x300bde22,0xee98173}, {0xa104b99e,0xee98172},
 {0x509c9591,0x6b24}, {0x1664,0x4fe9b374}, {0x509cabf5,0x4fea1e98},
   {0x509c7f2d,0xb016b7b0}, {0x509cabf5,0x6b24}, {0x509c7f2d,0x6b24},
 {0x582e,0x15829f85}, {0x6f57faed,0x35624c32}, {0x6f58531b,0x4ae4ebb7},
   {0x90a85d41,0xe0205352}, {0x6f58531b,0x15829f85}, {0x90a85d41,0x15829f84},
 {0x2262,0x1ea0}, {0x216ebb69,0x6e79}, {0x216eddcb,0x8d19},
   {0xde9166f9,0xffffb026}, {0x216eddcb,0x1ea0}, {0xde9166f9,0x1e9f},
 {0x410f4020,0x1e8}, {0x3af8,0x51d26025}, {0x410f7b18,0x51d2620d},
   {0x410f0528,0xae2da1c3}, {0x410f7b18,0x1e8}, {0x410f0528,0x1e8},
 {0xbbe7de03,0xe03daac3}, {0x164fa289,0xeba603b3}, {0xd237808c,0xcbe3ae76},
   {0xa5983b7a,0xf497a710}, {0xd237808c,0xe03daac3}, {0xa5983b7a,0xe03daac3},
 {0x1bae,0x914554b9}, {0x5c39,0x19f8}, {0x77e7,0x91456eb1},
   {0xffffbf75,0x91453ac0}, {0x77e7,0x914554b9}, {0xffffbf75,0x914554b8},
 {0x222b,0x73b8011c}, {0xe05a3593,0x64fa}, {0xe05a57be,0x73b86616},
   {0x1fa5ec98,0x73b79c21}, {0xe05a57be,0x73b8011b}, {0x1fa5ec98,0x73b8011c},
 {0xd8055fa5,0x1ff5}, {0xa5b955fd,0xeeb33346}, {0x7dbeb5a2,0xeeb3533c},
   {0x324c09a8,0x114cecaf}, {0x7dbeb5a2,0x1ff5}, {0x324c09a8,0x1ff6},
 {0x148f9c60,0xf088d98b}, {0xa4c5f4ed,0x7272}, {0xb955914d,0xf0894bfd},
   {0x6fc9a773,0xf0886718}, {0xb955914d,0xf088d98a}, {0x6fc9a773,0xf088d98b},
 {0x854866ff,0x4475}, {0x9ec39941,0x5c76}, {0x240c0040,0xa0ec},
   {0xe684cdbe,0xffffe7fe}, {0x240c0040,0x4475}, {0xe684cdbe,0x4475},
 {0x74a3044e,0x9c4380a0}, {0xb305d52e,0xb23dbbe4}, {0x27a8d97c,0x4e813c85},
   {0xc19d2f20,0xea05c4bb}, {0x27a8d97c,0x9c4380a0}, {0xc19d2f20,0x9c4380a0},
 {0x16ed,0xb374b1c1}, {0x35e0,0x11b33b5d}, {0x4ccd,0xc527ed1e},
   {0xffffe10d,0xa1c17663}, {0x4ccd,0xb374b1c1}, {0xffffe10d,0xb374b1c0},
 {0x31e1,0xafa}, {0x7aa3,0xf6189500}, {0xac84,0xf6189ffa},
   {0xffffb73e,0x9e775f9}, {0xac84,0xafa}, {0xffffb73e,0xaf9},
 {0x5a2a1cb5,0xee0}, {0x17df2735,0xfd343e93}, {0x720943ea,0xfd344d73},
   {0x424af580,0x2cbd04d}, {0x720943ea,0xee0}, {0x424af580,0xee0},
 {0x3a7b,0xffe6b16f}, {0x61ed,0x5d65}, {0x9c68,0xffe70ed4},
   {0xffffd88e,0xffe65409}, {0x9c68,0xffe6b16f}, {0xffffd88e,0xffe6b16e},
 {0x88f1dccc,0xc9e34e94}, {0xa7d276d2,0x2db5}, {0x30c4539e,0xc9e37c4a},
   {0xe11f65fa,0xc9e320de}, {0x30c4539e,0xc9e34e94}, {0xe11f65fa,0xc9e34e94},
 {0xc517911b,0x1edde7bd}, {0xe3433a68,0xf22}, {0xa85acb83,0x1eddf6e0},
   {0xe1d456b3,0x1eddd89a}, {0xa85acb83,0x1edde7bd}, {0xe1d456b3,0x1edde7bd},
 {0x7ff9,0x50e21833}, {0x3f0a999b,0x962e9f9e}, {0x3f0b1994,0xe710b7d1},
   {0xc0f5e65e,0xbab37894}, {0x3f0b1994,0x50e21833}, {0xc0f5e65e,0x50e21832},
 {0x8b0,0x7b28}, {0x76f6,0x3b28}, {0x7fa6,0xb650},
   {0xffff91ba,0x3fff}, {0x7fa6,0x7b28}, {0xffff91ba,0x7b27},
 {0x61b8,0xe6309576}, {0x1e236f90,0xef0}, {0x1e23d148,0xe630a466},
   {0xe1dcf228,0xe6308685}, {0x1e23d148,0xe6309576}, {0xe1dcf228,0xe6309575},
 {0xd7f,0xe9ef62e5}, {0x7030,0xfe6}, {0x7daf,0xe9ef72cb},
   {0xffff9d4f,0xe9ef52fe}, {0x7daf,0xe9ef62e5}, {0xffff9d4f,0xe9ef62e4},
 {0x2d000bf6,0x4645558b}, {0xdcf32049,0x1db0}, {0x9f32c3f,0x4645733c},
   {0x500cebad,0x464537da}, {0x9f32c3f,0x4645558b}, {0x500cebad,0x4645558b},
 {0x7371,0x530}, {0x4fed,0x516a}, {0xc35e,0x569a},
   {0x2384,0xffffb3c6}, {0xc35e,0x530}, {0x2384,0x530},
 {0x33bf65b5,0x58fd}, {0xec1b77c1,0xc6d425f0}, {0x1fdadd76,0xc6d47eee},
   {0x47a3edf4,0x392c330c}, {0x1fdadd76,0x58fd}, {0x47a3edf4,0x58fd},
 {0xea3,0x2aef}, {0x6c27,0x41ac}, {0x7aca,0x6c9b},
   {0xffffa27c,0xffffe942}, {0x7aca,0x2aef}, {0xffffa27c,0x2aee},
 {0x6bf6,0x783d2c35}, {0x50eb,0xbd8b0604}, {0xbce1,0x35c83239},
   {0x1b0b,0xbab22631}, {0xbce1,0x783d2c35}, {0x1b0b,0x783d2c35},
 {0xf72644ef,0x507c94ca}, {0x7635,0x21ea}, {0xf726bb24,0x507cb6b4},
   {0xf725ceba,0x507c72e0}, {0xf726bb24,0x507c94ca}, {0xf725ceba,0x507c94ca},
 {0x40bd,0x5f38}, {0x15e5,0x6834}, {0x56a2,0xc76c},
   {0x2ad8,0xfffff704}, {0x56a2,0x5f38}, {0x2ad8,0x5f38},
 {0xe0515bc6,0x67f7}, {0x56d17dbd,0xdf8154d8}, {0x3722d983,0xdf81bcd0},
   {0x897fde09,0x207f131f}, {0x3722d983,0x67f8}, {0x897fde09,0x67f7},
 {0x3439,0x8ccb2673}, {0x716e4ab5,0x3932}, {0x716e7eee,0x8ccb5fa5},
   {0x8e91e984,0x8ccaed40}, {0x716e7eee,0x8ccb2673}, {0x8e91e984,0x8ccb2672},
 {0x4ac7e5cc,0xdc9e8026}, {0x75a7,0x4a24}, {0x4ac85b73,0xdc9eca4a},
   {0x4ac77025,0xdc9e3602}, {0x4ac85b73,0xdc9e8026}, {0x4ac77025,0xdc9e8026},
 {0xf28da3d5,0x3bfc11f3}, {0x486a,0x685e847a}, {0xf28dec3f,0xa45a966d},
   {0xf28d5b6b,0xd39d8d79}, {0xf28dec3f,0x3bfc11f3}, {0xf28d5b6b,0x3bfc11f3},
 {0xea5d54ae,0xc44debda}, {0x7eb6,0x1a7e}, {0xea5dd364,0xc44e0658},
   {0xea5cd5f8,0xc44dd15c}, {0xea5dd364,0xc44debda}, {0xea5cd5f8,0xc44debda},
 {0x3ba2,0x15f0}, {0x2576,0x62cc214}, {0x6118,0x62cd804},
   {0x162c,0xf9d353dc}, {0x6118,0x15f0}, {0x162c,0x15f0},
 {0x64d7d7e5,0x1174}, {0x4b2b7260,0x628a3340}, {0xb0034a45,0x628a44b4},
   {0x19ac6585,0x9d75de34}, {0xb0034a45,0x1174}, {0x19ac6585,0x1174},
 {0x8805e03,0xa8729f6f}, {0x187221e8,0x227b}, {0x20f27feb,0xa872c1ea},
   {0xf00e3c1b,0xa8727cf3}, {0x20f27feb,0xa8729f6f}, {0xf00e3c1b,0xa8729f6e},
 {0x963,0x557c}, {0x5a023942,0x27708ee}, {0x5a0242a5,0x2775e6a},
   {0xa5fdd021,0xfd894c8d}, {0x5a0242a5,0x557c}, {0xa5fdd021,0x557b},
 {0x4de2,0x3536}, {0xe2f5a8,0x6eab}, {0xe3438a,0xa3e1},
   {0xff1d583a,0xffffc68a}, {0xe3438a,0x3536}, {0xff1d583a,0x3535},
 {0x1036,0x69a7}, {0x68bbe66b,0x42f7}, {0x68bbf6a1,0xac9e},
   {0x974429cb,0x26af}, {0x68bbf6a1,0x69a7}, {0x974429cb,0x69a6},
 {0x5fec,0x45b8}, {0x6318df9d,0x7c74a34a}, {0x63193f89,0x7c74e902},
   {0x9ce7804f,0x838ba26d}, {0x63193f89,0x45b8}, {0x9ce7804f,0x45b7},
 {0xf4cd3889,0xe17206f6}, {0xe79,0x6bf76667}, {0xf4cd4702,0x4d696d5d},
   {0xf4cd2a10,0x757aa08f}, {0xf4cd4702,0xe17206f6}, {0xf4cd2a10,0xe17206f6},
 {0x476,0xab3cdf0}, {0x3532,0x2396c0fa}, {0x39a8,0x2e4a8eea},
   {0xffffcf44,0xe71d0cf5}, {0x39a8,0xab3cdf0}, {0xffffcf44,0xab3cdef},
 {0x568c1d0e,0x597d}, {0x7ff,0x534}, {0x568c250d,0x5eb1},
   {0x568c150f,0x5449}, {0x568c250d,0x597d}, {0x568c150f,0x597d},
 {0x5e79,0x6b29}, {0xfbcf9202,0x6e586f5b}, {0xfbcff07b,0x6e58da84},
   {0x430cc77,0x91a7fbcd}, {0xfbcff07b,0x6b28}, {0x430cc77,0x6b29},
 {0x39ceb5fc,0x372c33d6}, {0x2c39,0xfa9078a0}, {0x39cee235,0x31bcac76},
   {0x39ce89c3,0x3c9bbb36}, {0x39cee235,0x372c33d6}, {0x39ce89c3,0x372c33d6},
 {0x3ca1410,0x2a35}, {0x4de5,0x1a3b}, {0x3ca61f5,0x4470},
   {0x3c9c62b,0xffa}, {0x3ca61f5,0x2a35}, {0x3c9c62b,0x2a35},
 {0x7db5,0x4bdf701e}, {0x7a8fcd47,0x228d6aec}, {0x7a904afc,0x6e6cdb0a},
   {0x8570b06e,0x29520531}, {0x7a904afc,0x4bdf701e}, {0x8570b06e,0x4bdf701d},
 {0x3a38,0x11e84480}, {0xe3,0x87100596}, {0x3b1b,0x98f84a16},
   {0x3955,0x8ad83eea}, {0x3b1b,0x11e84480}, {0x3955,0x11e84480},
 {0x443c,0x75ab5c09}, {0x6b7e,0x5070}, {0xafba,0x75abac79},
   {0xffffd8be,0x75ab0b98}, {0xafba,0x75ab5c09}, {0xffffd8be,0x75ab5c08},
 {0x9797abfd,0x71cec44b}, {0x7fe0f3ae,0x6cd6dd9a}, {0x17789fab,0xdea5a1e6},
   {0x17b6b84f,0x4f7e6b1}, {0x17789fab,0x71cec44c}, {0x17b6b84f,0x71cec44b},
 {0x99523967,0x49ad}, {0x3778,0xcd7a1e1}, {0x995270df,0xcd7eb8e},
   {0x995201ef,0xf328a7cc}, {0x995270df,0x49ad}, {0x995201ef,0x49ad},
 {0x5f14ebc5,0x9e5e959e}, {0x7ba4,0x62a6}, {0x5f156769,0x9e5ef844},
   {0x5f147021,0x9e5e32f8}, {0x5f156769,0x9e5e959e}, {0x5f147021,0x9e5e959e},
 {0xda566bd9,0xe360bc56}, {0x68a1,0x757a}, {0xda56d47a,0xe36131d0},
   {0xda560338,0xe36046dc}, {0xda56d47a,0xe360bc56}, {0xda560338,0xe360bc56},
 {0x77b071e8,0x43fd}, {0xa3abdebd,0x4067}, {0x1b5c50a5,0x8465},
   {0xd404932b,0x395}, {0x1b5c50a5,0x43fd}, {0xd404932b,0x43fd},
 {0xf50b3913,0x666a}, {0x6daa,0x4269}, {0xf50ba6bd,0xa8d3},
   {0xf50acb69,0x2401}, {0xf50ba6bd,0x666a}, {0xf50acb69,0x666a},
 {0x1625,0x722d}, {0x170,0x65f44be8}, {0x1795,0x65f4be15},
   {0x14b5,0x9a0c2645}, {0x1795,0x722d}, {0x14b5,0x722d},
 {0x6d233b40,0x30a1}, {0x6d24,0x6d63}, {0x6d23a864,0x9e04},
   {0x6d22ce1c,0xffffc33e}, {0x6d23a864,0x30a1}, {0x6d22ce1c,0x30a1},
 {0x129c3e09,0x6bb0}, {0x57df6c0c,0x5a2d}, {0x6a7baa15,0xc5dd},
   {0xbabcd1fd,0x1182}, {0x6a7baa15,0x6bb0}, {0xbabcd1fd,0x6baf},
 {0x31a4,0xdc9a1dc4}, {0x3ab0,0xe79050ae}, {0x6c54,0xc42a6e72},
   {0xfffff6f4,0xf509cd15}, {0x6c54,0xdc9a1dc4}, {0xfffff6f4,0xdc9a1dc3},
 {0x21f2,0x3765}, {0xaaeaad6e,0xa11e90}, {0xaaeacf60,0xa155f5},
   {0x55157484,0xff5f18d4}, {0xaaeacf60,0x3764}, {0x55157484,0x3765},
 {0x317f,0x653e}, {0x72a9,0x80cddb00}, {0xa428,0x80ce403e},
   {0xffffbed6,0x7f328a3d}, {0xa428,0x653e}, {0xffffbed6,0x653d},
 {0xacd928d3,0x94ee889c}, {0x1fd3638f,0x636a}, {0xccac8c62,0x94eeec06},
   {0x8d05c544,0x94ee2532}, {0xccac8c62,0x94ee889c}, {0x8d05c544,0x94ee889c},
 {0xc0e34678,0x7cb2}, {0x8b815be2,0xaa1b9a72}, {0x4c64a25a,0xaa1c1725},
   {0x3561ea96,0x55e4e240}, {0x4c64a25a,0x7cb2}, {0x3561ea96,0x7cb3},
 {0x1139,0x3ea06d7e}, {0x2d65,0x1dca114c}, {0x3e9e,0x5c6a7eca},
   {0xffffe3d4,0x20d65c31}, {0x3e9e,0x3ea06d7e}, {0xffffe3d4,0x3ea06d7d},
 {0x3dd93ae8,0xfabad068}, {0x5be0,0x1c7c}, {0x3dd996c8,0xfabaece4},
   {0x3dd8df08,0xfabab3ec}, {0x3dd996c8,0xfabad068}, {0x3dd8df08,0xfabad068},
 {0x562efc03,0xff1a060f}, {0x2772,0x567b}, {0x562f2375,0xff1a5c8a},
   {0x562ed491,0xff19af94}, {0x562f2375,0xff1a060f}, {0x562ed491,0xff1a060f},
 {0xabe288d5,0x47fb}, {0x4d2a,0x7523}, {0xabe2d5ff,0xbd1e},
   {0xabe23bab,0xffffd2d8}, {0xabe2d5ff,0x47fb}, {0xabe23bab,0x47fb},
 {0x57be,0x7b097b86}, {0x5df9,0x5bf24d56}, {0xb5b7,0xd6fbc8dc},
   {0xfffff9c5,0x1f172e2f}, {0xb5b7,0x7b097b86}, {0xfffff9c5,0x7b097b85},
 {0x9b4cd2d3,0x79e7}, {0x2aa3,0x69367889}, {0x9b4cfd76,0x6936f270},
   {0x9b4ca830,0x96ca015e}, {0x9b4cfd76,0x79e7}, {0x9b4ca830,0x79e7},
 {0x4da3aa58,0xb46a485b}, {0xdc4dfa71,0xc1086558}, {0x29f1a4c9,0x7572adb4},
   {0x7155afe7,0xf361e302}, {0x29f1a4c9,0xb46a485b}, {0x7155afe7,0xb46a485b},
 {0x2ab2,0xe784d5ea}, {0x66a5,0x5dee}, {0x9157,0xe78533d8},
   {0xffffc40d,0xe78477fb}, {0x9157,0xe784d5ea}, {0xffffc40d,0xe784d5e9},
 {0x3a0c9d3f,0xf21cd57}, {0xb8395dbb,0x2dbca548}, {0xf245fafa,0x3cde729f},
   {0x81d33f84,0xe165280e}, {0xf245fafa,0xf21cd56}, {0x81d33f84,0xf21cd57},
 {0x3d21,0x2539}, {0x7f749a4,0x4e885c42}, {0x7f786c5,0x4e88817b},
   {0xf808f37d,0xb177c8f6}, {0x7f786c5,0x2539}, {0xf808f37d,0x2538},
 {0x3576,0x1a7c}, {0x74a6,0xda052739}, {0xaa1c,0xda0541b5},
   {0xffffc0d0,0x25faf342}, {0xaa1c,0x1a7c}, {0xffffc0d0,0x1a7b},
 {0x2e2b,0x74ec}, {0x2b6f11d8,0x587f671c}, {0x2b6f4003,0x587fdc08},
   {0xd4911c53,0xa7810dcf}, {0x2b6f4003,0x74ec}, {0xd4911c53,0x74eb},
 {0x6e2e4ddb,0x1367}, {0x5440e1cb,0x3f7d}, {0xc26f2fa6,0x52e4},
   {0x19ed6c10,0xffffd3ea}, {0xc26f2fa6,0x1367}, {0x19ed6c10,0x1367},
 {0xa1769b99,0x2768}, {0x6d7f,0x45e8}, {0xa1770918,0x6d50},
   {0xa1762e1a,0xffffe180}, {0xa1770918,0x2768}, {0xa1762e1a,0x2768},
 {0x9e8,0x6c3774a5}, {0xf7e4d526,0x1e0b6f43}, {0xf7e4df0e,0x8a42e3e8},
   {0x81b34c2,0x4e2c0561}, {0xf7e4df0e,0x6c3774a4}, {0x81b34c2,0x6c3774a5},
 {0x7020,0x34b245a3}, {0xf2a44212,0x9bb6a6f6}, {0xf2a4b232,0xd068ec99},
   {0xd5c2e0e,0x98fb9eac}, {0xf2a4b232,0x34b245a2}, {0xd5c2e0e,0x34b245a3},
 {0x3755de22,0x2f64}, {0x47b8,0x1672}, {0x375625da,0x45d6},
   {0x3755966a,0x18f2}, {0x375625da,0x2f64}, {0x3755966a,0x2f64},
 {0x5fe1,0x7268}, {0x38,0x4f3e0363}, {0x6019,0x4f3e75cb},
   {0x5fa9,0xb0c26f05}, {0x6019,0x7268}, {0x5fa9,0x7268},
 {0xb4d33739,0x1278}, {0x2b8,0xa4cd03aa}, {0xb4d339f1,0xa4cd1622},
   {0xb4d33481,0x5b330ece}, {0xb4d339f1,0x1278}, {0xb4d33481,0x1278},
 {0x3eb5,0xf9}, {0x5a3c,0x4f34}, {0x98f1,0x502d},
   {0xffffe479,0xffffb1c4}, {0x98f1,0xf9}, {0xffffe479,0xf8},
 {0x204b9a79,0x7fe6}, {0x4231,0x7b5b40fa}, {0x204bdcaa,0x7b5bc0e0},
   {0x204b5848,0x84a53eec}, {0x204bdcaa,0x7fe6}, {0x204b5848,0x7fe6},
 {0x3870,0x851c8fe0}, {0xce20caf4,0xfae}, {0xce210364,0x851c9f8e},
   {0x31df6d7c,0x851c8031}, {0xce210364,0x851c8fdf}, {0x31df6d7c,0x851c8fe0},
 {0x4ee5ea66,0x6da8f584}, {0x52afd129,0x46ffe5f7}, {0xa195bb8f,0xb4a8db7b},
   {0xfc36193d,0x26a90f8c}, {0xa195bb8f,0x6da8f584}, {0xfc36193d,0x6da8f583},
 {0xbb99e566,0x4b19bef1}, {0x1dba,0xc23}, {0xbb9a0320,0x4b19cb14},
   {0xbb99c7ac,0x4b19b2ce}, {0xbb9a0320,0x4b19bef1}, {0xbb99c7ac,0x4b19bef1},
 {0x92336a0a,0x2e7e}, {0x68c58d1b,0x6bf2}, {0xfaf8f725,0x9a70},
   {0x296ddcef,0xffffc28c}, {0xfaf8f725,0x2e7e}, {0x296ddcef,0x2e7e},
 {0x73b0,0xec6300f0}, {0x1c953e9,0x998aab84}, {0x1c9c799,0x85edac74},
   {0xfe371fc7,0x52d8556b}, {0x1c9c799,0xec6300f0}, {0xfe371fc7,0xec6300ef},
 {0xe69ed087,0x1f63}, {0x57706ace,0x42fe}, {0x3e0f3b55,0x6262},
   {0x8f2e65b9,0xffffdc65}, {0x3e0f3b55,0x1f64}, {0x8f2e65b9,0x1f63},
 {0x752d,0x213d}, {0x72f82eb9,0xcd8fd300}, {0x72f8a3e6,0xcd8ff43d},
   {0x8d084674,0x32704e3c}, {0x72f8a3e6,0x213d}, {0x8d084674,0x213c},
 {0x527f,0x4765}, {0x6633,0x8bcd03ef}, {0xb8b2,0x8bcd4b54},
   {0xffffec4c,0x74334375}, {0xb8b2,0x4765}, {0xffffec4c,0x4764},
 {0x6000e204,0xd6bfd9cd}, {0x5851e578,0x1ce833e0}, {0xb852c77c,0xf3a80dad},
   {0x7aefc8c,0xb9d7a5ed}, {0xb852c77c,0xd6bfd9cd}, {0x7aefc8c,0xd6bfd9cd},
 {0x6933,0x68295093}, {0x603c,0x6e77}, {0xc96f,0x6829bf0a},
   {0x8f7,0x6828e21c}, {0xc96f,0x68295093}, {0x8f7,0x68295093},
 {0x2a22,0x233ebb2a}, {0x78955388,0x8f4ff304}, {0x78957daa,0xb28eae2e},
   {0x876ad69a,0x93eec825}, {0x78957daa,0x233ebb2a}, {0x876ad69a,0x233ebb29},
 {0xd1f89d09,0x48f8}, {0x4ef1,0xd3b}, {0xd1f8ebfa,0x5633},
   {0xd1f84e18,0x3bbd}, {0xd1f8ebfa,0x48f8}, {0xd1f84e18,0x48f8},
 {0x2e2b,0x1068}, {0x782f,0x60aea00f}, {0xa65a,0x60aeb077},
   {0xffffb5fc,0x9f517058}, {0xa65a,0x1068}, {0xffffb5fc,0x1067},
 {0x3930,0x1bf}, {0x1ce8,0x9c537aa}, {0x5618,0x9c53969},
   {0x1c48,0xf63aca15}, {0x5618,0x1bf}, {0x1c48,0x1bf},
 {0xb62f8d95,0x62e0}, {0x7b2,0x67ee}, {0xb62f9547,0xcace},
   {0xb62f85e3,0xfffffaf2}, {0xb62f9547,0x62e0}, {0xb62f85e3,0x62e0},
 {0x7239,0x1d32}, {0xb01e0aaf,0x1ef}, {0xb01e7ce8,0x1f21},
   {0x4fe2678a,0x1b42}, {0xb01e7ce8,0x1d31}, {0x4fe2678a,0x1d32},
 {0x5629,0x931a8dbb}, {0xd7071b12,0xd0fec656}, {0xd707713b,0x64195411},
   {0x28f93b17,0xc21bc764}, {0xd707713b,0x931a8dba}, {0x28f93b17,0x931a8dbb},
 {0x283e,0x77a9}, {0xf87552c9,0xb32f0a63}, {0xf8757b07,0xb32f820c},
   {0x78ad575,0x4cd16d45}, {0xf8757b07,0x77a8}, {0x78ad575,0x77a9},
 {0x52b5,0x6d2980d8}, {0x2d09a703,0x76056576}, {0x2d09f9b8,0xe32ee64e},
   {0xd2f6abb2,0xf7241b61}, {0x2d09f9b8,0x6d2980d8}, {0xd2f6abb2,0x6d2980d7},
 {0x5876,0x47cf7da0}, {0x8df13edf,0x5528}, {0x8df19755,0x47cfd2c8},
   {0x720f1997,0x47cf2877}, {0x8df19755,0x47cf7d9f}, {0x720f1997,0x47cf7da0},
 {0xc0f59122,0xb4bbfa24}, {0x523a,0x6b64}, {0xc0f5e35c,0xb4bc6588},
   {0xc0f53ee8,0xb4bb8ec0}, {0xc0f5e35c,0xb4bbfa24}, {0xc0f53ee8,0xb4bbfa24},
 {0x71a8,0x938}, {0x463,0x606a}, {0x760b,0x69a2},
   {0x6d45,0xffffa8ce}, {0x760b,0x938}, {0x6d45,0x938},
 {0x6e743e28,0x326}, {0x78bf,0x37fd}, {0x6e74b6e7,0x3b23},
   {0x6e73c569,0xffffcb29}, {0x6e74b6e7,0x326}, {0x6e73c569,0x326},
 {0x7127,0x207deb81}, {0x1114342f,0xb8cf9786}, {0x1114a556,0xd94d8307},
   {0xeeec3cf8,0x67ae53fa}, {0x1114a556,0x207deb81}, {0xeeec3cf8,0x207deb80},
 {0x2f65,0x699d97cf}, {0x7cbc,0x520}, {0xac21,0x699d9cef},
   {0xffffb2a9,0x699d92ae}, {0xac21,0x699d97cf}, {0xffffb2a9,0x699d97ce},
 {0x54fd7d21,0x3afea70d}, {0xb2bb00b4,0x7cf1c211}, {0x7b87dd5,0xb7f0691f},
   {0xa2427c6d,0xbe0ce4fb}, {0x7b87dd5,0x3afea70d}, {0xa2427c6d,0x3afea70d},
 {0x18bf,0x3d69}, {0x497d,0xcb88c792}, {0x623c,0xcb8904fb},
   {0xffffcf42,0x347775d6}, {0x623c,0x3d69}, {0xffffcf42,0x3d68},
 {0xcfb87974,0x1d7886a8}, {0x2770,0x58957cb}, {0xcfb8a0e4,0x2301de73},
   {0xcfb85204,0x17ef2edd}, {0xcfb8a0e4,0x1d7886a8}, {0xcfb85204,0x1d7886a8},
 {0xabc8518e,0x5ba1}, {0x22b0,0xffc}, {0xabc8743e,0x6b9d},
   {0xabc82ede,0x4ba5}, {0xabc8743e,0x5ba1}, {0xabc82ede,0x5ba1},
 {0x13b6,0x7e75}, {0x19ea,0x7241c888}, {0x2da0,0x724246fd},
   {0xfffff9cc,0x8dbeb5ec}, {0x2da0,0x7e75}, {0xfffff9cc,0x7e74},
 {0x94f44d2a,0x18b4}, {0xfb,0x22fc}, {0x94f44e25,0x3bb0},
   {0x94f44c2f,0xfffff5b8}, {0x94f44e25,0x18b4}, {0x94f44c2f,0x18b4},
 {0xf4cce933,0x8f507b07}, {0x27b0,0x227}, {0xf4cd10e3,0x8f507d2e},
   {0xf4ccc183,0x8f5078e0}, {0xf4cd10e3,0x8f507b07}, {0xf4ccc183,0x8f507b07},
 {0xe56f6033,0x9fa3dfb8}, {0x3d537377,0x1f30}, {0x22c2d3aa,0x9fa3fee9},
   {0xa81becbc,0x9fa3c088}, {0x22c2d3aa,0x9fa3dfb9}, {0xa81becbc,0x9fa3dfb8},
 {0x3464,0x7642afa4}, {0x5da6,0x676975a0}, {0x920a,0xddac2544},
   {0xffffd6be,0xed93a03}, {0x920a,0x7642afa4}, {0xffffd6be,0x7642afa3},
 {0x45ef,0xe374bb6e}, {0xaa996a70,0x97530418}, {0xaa99b05f,0x7ac7bf86},
   {0x5566db7f,0x4c21b755}, {0xaa99b05f,0xe374bb6d}, {0x5566db7f,0xe374bb6e},
 {0x63bcbe5a,0x463c}, {0xdb5cbd0f,0x61c6b9ce}, {0x3f197b69,0x61c7000b},
   {0x8860014b,0x9e398c6d}, {0x3f197b69,0x463c}, {0x8860014b,0x463c},
 {0x55b5,0xe24a54fc}, {0x3673,0x6c7a}, {0x8c28,0xe24ac176},
   {0x1f42,0xe249e882}, {0x8c28,0xe24a54fc}, {0x1f42,0xe24a54fc},
 {0x90cd097c,0x4bab}, {0x6971e24f,0x4c22}, {0xfa3eebcb,0x97cd},
   {0x275b272d,0xffffff89}, {0xfa3eebcb,0x4bab}, {0x275b272d,0x4bab},
 {0x32eb,0x771d82b6}, {0x18a64572,0xfa2824e2}, {0x18a6785d,0x7145a798},
   {0xe759ed79,0x7cf55dd3}, {0x18a6785d,0x771d82b6}, {0xe759ed79,0x771d82b5},
 {0x21af,0x5b3de8a6}, {0x3865,0x6eacdce7}, {0x5a14,0xc9eac58d},
   {0xffffe94a,0xec910bbe}, {0x5a14,0x5b3de8a6}, {0xffffe94a,0x5b3de8a5},
 {0x1bd8c8fb,0x38ee}, {0x658f995b,0x43b1}, {0x81686256,0x7c9f},
   {0xb6492fa0,0xfffff53c}, {0x81686256,0x38ee}, {0xb6492fa0,0x38ed},
 {0xd7609269,0x88cff25f}, {0x78e7,0x62e9}, {0xd7610b50,0x88d05548},
   {0xd7601982,0x88cf8f76}, {0xd7610b50,0x88cff25f}, {0xd7601982,0x88cff25f},
 {0x5e64,0x1d4df57c}, {0xd9ef86df,0x2e7c}, {0xd9efe543,0x1d4e23f8},
   {0x2610d785,0x1d4dc6ff}, {0xd9efe543,0x1d4df57b}, {0x2610d785,0x1d4df57c},
 {0xea98e1ab,0x59be}, {0x595483ce,0xcdb71b09}, {0x43ed6579,0xcdb774c8},
   {0x91445ddd,0x32493eb5}, {0x43ed6579,0x59bf}, {0x91445ddd,0x59be},
 {0x6478,0x3bd92ea3}, {0x94514bf3,0x44b6252d}, {0x9451b06b,0x808f53d0},
   {0x6baf1885,0xf7230975}, {0x9451b06b,0x3bd92ea2}, {0x6baf1885,0x3bd92ea3},
 {0x6d2a,0xf13b1056}, {0x1e71,0xc72100a1}, {0x8b9b,0xb85c10f7},
   {0x4eb9,0x2a1a0fb5}, {0x8b9b,0xf13b1056}, {0x4eb9,0xf13b1056},
 {0x8a2315b9,0x17774394}, {0xd7ef9a7f,0x5477}, {0x6212b038,0x1777980c},
   {0xb2337b3a,0x1776ef1c}, {0x6212b038,0x17774394}, {0xb2337b3a,0x17774394},
 {0x15f9,0x25760120}, {0x5ee5,0x1f22}, {0x74de,0x25762042},
   {0xffffb714,0x2575e1fd}, {0x74de,0x25760120}, {0xffffb714,0x2576011f},
 {0xd7a,0xa410136b}, {0x57fc,0x186c}, {0x6576,0xa4102bd7},
   {0xffffb57e,0xa40ffafe}, {0x6576,0xa410136b}, {0xffffb57e,0xa410136a},
 {0x7ca8,0xcd99a3f7}, {0xb4e101ea,0x1b1ff7ee}, {0xb4e17e92,0xe8b99be5},
   {0x4b1f7abe,0xb279ac08}, {0xb4e17e92,0xcd99a3f6}, {0x4b1f7abe,0xcd99a3f7},
 {0x5af6,0x2868}, {0x2ea3,0x257f}, {0x8999,0x4de7},
   {0x2c53,0x2e9}, {0x8999,0x2868}, {0x2c53,0x2868},
 {0x29eb,0xa221967f}, {0x1ab4,0x568}, {0x449f,0xa2219be7},
   {0xf37,0xa2219117}, {0x449f,0xa221967f}, {0xf37,0xa221967f},
 {0x77b,0x4c7c}, {0x922f8bb1,0x7c38}, {0x922f932c,0xc8b4},
   {0x6dd07bca,0xffffd043}, {0x922f932c,0x4c7b}, {0x6dd07bca,0x4c7c},
 {0x68ac,0x16bb}, {0x5f8,0x797a}, {0x6ea4,0x9035},
   {0x62b4,0xffff9d41}, {0x6ea4,0x16bb}, {0x62b4,0x16bb},
 {0x53e4,0x50f17fe6}, {0x294ad69e,0x2debfa28}, {0x294b2a82,0x7edd7a0e},
   {0xd6b57d46,0x230585bd}, {0x294b2a82,0x50f17fe6}, {0xd6b57d46,0x50f17fe5},
 {0x7362,0x582dafc9}, {0x3733,0x3ac720c5}, {0xaa95,0x92f4d08e},
   {0x3c2f,0x1d668f04}, {0xaa95,0x582dafc9}, {0x3c2f,0x582dafc9},
 {0xbc520992,0x15527f37}, {0xd45fcf49,0x10e0}, {0x90b1d8db,0x15529018},
   {0xe7f23a49,0x15526e56}, {0x90b1d8db,0x15527f37}, {0xe7f23a49,0x15527f37},
 {0x26e3,0x6f69}, {0x59fe,0x4338}, {0x80e1,0xb2a1},
   {0xffffcce5,0x2c30}, {0x80e1,0x6f69}, {0xffffcce5,0x6f68},
 {0xfffa92d2,0x5260}, {0x2e30,0x4a74}, {0xfffac102,0x9cd4},
   {0xfffa64a2,0x7ec}, {0xfffac102,0x5260}, {0xfffa64a2,0x5260},
 {0x3478,0x5076}, {0x25e0,0x1ff8}, {0x5a58,0x706e},
   {0xe98,0x307e}, {0x5a58,0x5076}, {0xe98,0x5076},
 {0xcf27fc80,0x29efaf02}, {0xb1b64e31,0x1c5d7589}, {0x80de4ab1,0x464d248c},
   {0x1d71ae4f,0xd923979}, {0x80de4ab1,0x29efaf02}, {0x1d71ae4f,0x29efaf03},
 {0xb8d3fe70,0x756a}, {0x4164,0x69e1}, {0xb8d43fd4,0xdf4b},
   {0xb8d3bd0c,0xb89}, {0xb8d43fd4,0x756a}, {0xb8d3bd0c,0x756a},
 {0x6b2d48cf,0x580cb255}, {0x4fbd,0x5a61}, {0x6b2d988c,0x580d0cb6},
   {0x6b2cf912,0x580c57f4}, {0x6b2d988c,0x580cb255}, {0x6b2cf912,0x580cb255},
 {0x3aec993c,0x6468}, {0x61ba,0xe7807d0e}, {0x3aecfaf6,0xe780e176},
   {0x3aec3782,0x187fe75a}, {0x3aecfaf6,0x6468}, {0x3aec3782,0x6468},
 {0x81a993e8,0x49e4}, {0xbc7347b0,0x5d69}, {0x3e1cdb98,0xa74e},
   {0xc5364c38,0xffffec7a}, {0x3e1cdb98,0x49e4}, {0xc5364c38,0x49e4},
 {0xb144889a,0x48aa}, {0x49ab,0xe0a6e609}, {0xb144d245,0xe0a72eb3},
   {0xb1443eef,0x1f5962a1}, {0xb144d245,0x48aa}, {0xb1443eef,0x48aa},
 {0xbdc5b447,0x24e2288e}, {0xb2bd7ebe,0x8a1}, {0x70833305,0x24e23130},
   {0xb083589,0x24e21fed}, {0x70833305,0x24e2288e}, {0xb083589,0x24e2288f},
 {0x3946dea8,0xee1c9483}, {0x4e318ddf,0xe65}, {0x87786c87,0xee1ca2e8},
   {0xeb1550c9,0xee1c861d}, {0x87786c87,0xee1c9483}, {0xeb1550c9,0xee1c9482},
 {0xb63,0x18ec}, {0x4efc,0x4ae4}, {0x5a5f,0x63d0},
   {0xffffbc67,0xffffce07}, {0x5a5f,0x18ec}, {0xffffbc67,0x18eb},
 {0x32f6,0x207a3f08}, {0x51434b04,0x3fdaf4e3}, {0x51437dfa,0x605533eb},
   {0xaebce7f2,0xe09f4a24}, {0x51437dfa,0x207a3f08}, {0xaebce7f2,0x207a3f07},
 {0x6074,0x97a4e6f5}, {0x384974c4,0x941ecf7f}, {0x3849d538,0x2bc3b674},
   {0xc7b6ebb0,0x3861775}, {0x3849d538,0x97a4e6f5}, {0xc7b6ebb0,0x97a4e6f4},
 {0x6aea,0xbcd7cb55}, {0xb2a,0xf918884c}, {0x7614,0xb5f053a1},
   {0x5fc0,0xc3bf4309}, {0x7614,0xbcd7cb55}, {0x5fc0,0xbcd7cb55},
 {0x1f45c9f6,0x23bd}, {0x4b5,0x5a027ab7}, {0x1f45ceab,0x5a029e74},
   {0x1f45c541,0xa5fda906}, {0x1f45ceab,0x23bd}, {0x1f45c541,0x23bd},
 {0x333c,0x6e6f}, {0x59f164cd,0x5ccdb268}, {0x59f19809,0x5cce20d7},
   {0xa60ece6f,0xa332bc06}, {0x59f19809,0x6e6f}, {0xa60ece6f,0x6e6e},
 {0xfdc4e3a,0x55a4}, {0x64f4,0x5b23}, {0xfdcb32e,0xb0c7},
   {0xfdbe946,0xfffffa81}, {0xfdcb32e,0x55a4}, {0xfdbe946,0x55a4},
 {0xd7840b6a,0xd29a3598}, {0x7372,0x7fd8c8ac}, {0xd7847edc,0x5272fe44},
   {0xd78397f8,0x52c16cec}, {0xd7847edc,0xd29a3598}, {0xd78397f8,0xd29a3598},
 {0xb30,0x25}, {0xd6a,0x27b1}, {0x189a,0x27d6},
   {0xfffffdc6,0xffffd873}, {0x189a,0x25}, {0xfffffdc6,0x24},
 {0x19b0,0xe03f6190}, {0x793e,0x2055c469}, {0x92ee,0x9525f9},
   {0xffffa072,0xbfe99d26}, {0x92ee,0xe03f6190}, {0xffffa072,0xe03f618f},
 {0x76fe,0x5f74d62a}, {0x74c18cfd,0xb8d32c90}, {0x74c203fb,0x184802ba},
   {0x8b3eea01,0xa6a1a999}, {0x74c203fb,0x5f74d62a}, {0x8b3eea01,0x5f74d629},
 {0x36ef,0x301e1e14}, {0x8c99430e,0x5ecbf3e6}, {0x8c9979fd,0x8eea11fa},
   {0x7366f3e1,0xd1522a2d}, {0x8c9979fd,0x301e1e13}, {0x7366f3e1,0x301e1e14},
 {0x28146d78,0x7a0a14ca}, {0x57746030,0xa99f349c}, {0x7f88cda8,0x23a94966},
   {0xd0a00d48,0xd06ae02d}, {0x7f88cda8,0x7a0a14ca}, {0xd0a00d48,0x7a0a14c9},
 {0xc2d92e9b,0x83e11819}, {0x889c4e4b,0x51a6}, {0x4b757ce6,0x83e169c0},
   {0x3a3ce050,0x83e0c673}, {0x4b757ce6,0x83e11819}, {0x3a3ce050,0x83e1181a},
 {0xa6feb0c1,0x7a62}, {0xd37,0x5d342f76}, {0xa6febdf8,0x5d34a9d8},
   {0xa6fea38a,0xa2cc4aec}, {0xa6febdf8,0x7a62}, {0xa6fea38a,0x7a62},
 {0x1061,0xaeab464d}, {0x4d11db87,0x2670}, {0x4d11ebe8,0xaeab6cbd},
   {0xb2ee34da,0xaeab1fdc}, {0x4d11ebe8,0xaeab464d}, {0xb2ee34da,0xaeab464c},
 {0x1ebfc7fd,0x7b872dcb}, {0xa3b0e157,0x7fa8}, {0xc270a954,0x7b87ad73},
   {0x7b0ee6a6,0x7b86ae22}, {0xc270a954,0x7b872dca}, {0x7b0ee6a6,0x7b872dcb},
 {0xb4cc2c9e,0xce6}, {0x430edbf9,0xa75}, {0xf7db0897,0x175b},
   {0x71bd50a5,0x271}, {0xf7db0897,0xce6}, {0x71bd50a5,0xce6},
 {0x3bb36a70,0x2a850197}, {0x4ee00279,0x4274de71}, {0x8a936ce9,0x6cf9e008},
   {0xecd367f7,0xe8102325}, {0x8a936ce9,0x2a850197}, {0xecd367f7,0x2a850196},
 {0x8817f8ad,0xc5080465}, {0x38b3,0x2d108271}, {0x88183160,0xf21886d6},
   {0x8817bffa,0x97f781f4}, {0x88183160,0xc5080465}, {0x8817bffa,0xc5080465},
 {0xa6dd824c,0xa54a01d0}, {0xdcee2c4f,0xaa15327c}, {0x83cbae9b,0x4f5f344d},
   {0xc9ef55fd,0xfb34cf53}, {0x83cbae9b,0xa54a01d0}, {0xc9ef55fd,0xa54a01d0},
 {0x9207e0ee,0x54b7}, {0x4767,0x21ef}, {0x92082855,0x76a6},
   {0x92079987,0x32c8}, {0x92082855,0x54b7}, {0x92079987,0x54b7},
 {0x71a4,0x78eb}, {0x553e,0xffd7133d}, {0xc6e2,0xffd78c28},
   {0x1c66,0x2965ae}, {0xc6e2,0x78eb}, {0x1c66,0x78eb},
 {0x30f4,0x667d}, {0x76a3,0x692e}, {0xa797,0xcfab},
   {0xffffba51,0xfffffd4e}, {0xa797,0x667d}, {0xffffba51,0x667c},
 {0x42f2,0x54b9}, {0x161eeced,0x1b6e}, {0x161f2fdf,0x7027},
   {0xe9e15605,0x394a}, {0x161f2fdf,0x54b9}, {0xe9e15605,0x54b8},
 {0x57e1,0x1858d382}, {0x59f9,0x5ded}, {0xb1da,0x1859316f},
   {0xfffffde8,0x18587594}, {0xb1da,0x1858d382}, {0xfffffde8,0x1858d381},
 {0xa65,0x41f8}, {0x112d,0xe8948830}, {0x1b92,0xe894ca28},
   {0xfffff938,0x176bb9c7}, {0x1b92,0x41f8}, {0xfffff938,0x41f7},
 {0x63b1,0x64e3}, {0xff45c2b8,0x43e1}, {0xff462669,0xa8c4},
   {0xbaa0f9,0x2101}, {0xff462669,0x64e2}, {0xbaa0f9,0x64e3},
 {0xb53f5850,0xe24e448f}, {0x2a33d8ca,0x632a}, {0xdf73311a,0xe24ea7b9},
   {0x8b0b7f86,0xe24de165}, {0xdf73311a,0xe24e448f}, {0x8b0b7f86,0xe24e448f},
 {0x5b27,0x44ed}, {0x2036,0x9c90098f}, {0x7b5d,0x9c904e7c},
   {0x3af1,0x63703b5e}, {0x7b5d,0x44ed}, {0x3af1,0x44ed},
 {0x5d6d,0xeaa323aa}, {0x25cdd22c,0xb69a028a}, {0x25ce2f99,0xa13d2634},
   {0xda328b41,0x3409211f}, {0x25ce2f99,0xeaa323aa}, {0xda328b41,0xeaa323a9},
 {0x8c40230b,0x21f6f325}, {0xaca9707e,0x781eea0d}, {0x38e99389,0x9a15dd33},
   {0xdf96b28d,0xa9d80917}, {0x38e99389,0x21f6f325}, {0xdf96b28d,0x21f6f325},
 {0xa70cadb0,0x122}, {0x72afc30d,0x62dae37c}, {0x19bc70bd,0x62dae49f},
   {0x345ceaa3,0x9d251da6}, {0x19bc70bd,0x123}, {0x345ceaa3,0x122},
 {0x1df8,0xd09cf249}, {0xc218bbdd,0xe59e82ac}, {0xc218d9d5,0xb63b74f5},
   {0x3de7621b,0xeafe6f9c}, {0xc218d9d5,0xd09cf248}, {0x3de7621b,0xd09cf249},
 {0xd8a158cc,0x6f8}, {0xfa7f294c,0x6aa1}, {0xd3208218,0x719a},
   {0xde222f80,0xffff9c56}, {0xd3208218,0x6f8}, {0xde222f80,0x6f8},
 {0x566d,0x48e3}, {0x39ed,0xfd56d4c0}, {0x905a,0xfd571da3},
   {0x1c80,0x2a97423}, {0x905a,0x48e3}, {0x1c80,0x48e3},
 {0x716b,0x236f}, {0x447b,0x507b}, {0xb5e6,0x73ea},
   {0x2cf0,0xffffd2f4}, {0xb5e6,0x236f}, {0x2cf0,0x236f},
 {0x5965,0xe1b052b1}, {0x6065,0x33e3}, {0xb9ca,0xe1b08694},
   {0xfffff900,0xe1b01ecd}, {0xb9ca,0xe1b052b1}, {0xfffff900,0xe1b052b0},
 {0x1dc4870,0x4c23}, {0x8ba8c777,0x3b67}, {0x8d850fe7,0x878a},
   {0x763380f9,0x10bb}, {0x8d850fe7,0x4c22}, {0x763380f9,0x4c23},
 {0x45bc,0x6b37}, {0x4064,0x3be5}, {0x8620,0xa71c},
   {0x558,0x2f52}, {0x8620,0x6b37}, {0x558,0x6b37},
 {0xa376efa,0x2d32}, {0x29b5,0x1cb5853}, {0xa3798af,0x1cb8585},
   {0xa374545,0xfe34d4df}, {0xa3798af,0x2d32}, {0xa374545,0x2d32},
 {0xc17f3420,0x4ab3}, {0x32a7,0x5ce0}, {0xc17f66c7,0xa793},
   {0xc17f0179,0xffffedd3}, {0xc17f66c7,0x4ab3}, {0xc17f0179,0x4ab3},
 {0x21bb,0x1578}, {0x32764076,0x26c}, {0x32766231,0x17e4},
   {0xcd89e145,0x130b}, {0x32766231,0x1578}, {0xcd89e145,0x1577},
 {0x542f2204,0x843e24fa}, {0x1934,0x9eafda6a}, {0x542f3b38,0x22edff64},
   {0x542f08d0,0xe58e4a90}, {0x542f3b38,0x843e24fa}, {0x542f08d0,0x843e24fa},
 {0xbfa0e00e,0x3ff3}, {0x2ba4,0xcd2f3e73}, {0xbfa10bb2,0xcd2f7e66},
   {0xbfa0b46a,0x32d10180}, {0xbfa10bb2,0x3ff3}, {0xbfa0b46a,0x3ff3},
 {0x94cc5bf3,0x4735f3b6}, {0x274,0x6bf0daa6}, {0x94cc5e67,0xb326ce5c},
   {0x94cc597f,0xdb451910}, {0x94cc5e67,0x4735f3b6}, {0x94cc597f,0x4735f3b6},
 {0x1b6d5a63,0x513e}, {0xedebf3f5,0x5426}, {0x9594e58,0xa565},
   {0x2d81666e,0xfffffd17}, {0x9594e58,0x513e}, {0x2d81666e,0x513e},
 {0x2ea5,0x486f}, {0x7b5043a8,0x1bd8976f}, {0x7b50724d,0x1bd8dfde},
   {0x84afeafd,0xe427b0ff}, {0x7b50724d,0x486f}, {0x84afeafd,0x486e},
 {0xd7e9f94b,0x8d07be43}, {0x2a890ac4,0x35ed}, {0x273040f,0x8d07f431},
   {0xad60ee87,0x8d078856}, {0x273040f,0x8d07be44}, {0xad60ee87,0x8d07be43},
 {0x133e,0x814440ac}, {0x859b7395,0x442e}, {0x859b86d3,0x814484da},
   {0x7a649fa9,0x8143fc7d}, {0x859b86d3,0x814440ab}, {0x7a649fa9,0x814440ac},
 {0xdc95c32,0xf7100965}, {0x4649f627,0x7ef5}, {0x54135259,0xf710885a},
   {0xc77f660b,0xf70f8a6f}, {0x54135259,0xf7100965}, {0xc77f660b,0xf7100964},
 {0x1837,0x87cb0160}, {0xb72d1968,0x7b3e}, {0xb72d319f,0x87cb7c9e},
   {0x48d2fecf,0x87ca8621}, {0xb72d319f,0x87cb015f}, {0x48d2fecf,0x87cb0160},
 {0xed7811f7,0x76baee0f}, {0x577d,0x1b2f}, {0xed786974,0x76bb093e},
   {0xed77ba7a,0x76bad2e0}, {0xed786974,0x76baee0f}, {0xed77ba7a,0x76baee0f},
 {0x9472a568,0x4e35}, {0x74401ff0,0x3e7a}, {0x8b2c558,0x8cb0},
   {0x20328578,0xfbb}, {0x8b2c558,0x4e36}, {0x20328578,0x4e35},
 {0x37bb,0x3abf}, {0xe79fffc6,0x8e43714e}, {0xe7a03781,0x8e43ac0d},
   {0x186037f5,0x71bcc970}, {0xe7a03781,0x3abe}, {0x186037f5,0x3abf},
 {0x28b2,0xb948503}, {0x3a6c,0x491ff430}, {0x631e,0x54b47933},
   {0xffffee46,0xc27490d2}, {0x631e,0xb948503}, {0xffffee46,0xb948502},
 {0x3828,0x2cf3dde8}, {0x8d97ab11,0x1cea947e}, {0x8d97e339,0x49de7266},
   {0x72688d17,0x10094969}, {0x8d97e339,0x2cf3dde7}, {0x72688d17,0x2cf3dde8},
 {0x173a,0x262d}, {0x4ca5,0x4f7c}, {0x63df,0x75a9},
   {0xffffca95,0xffffd6b0}, {0x63df,0x262d}, {0xffffca95,0x262c},
 {0xbbceaf05,0x46ef}, {0x95d14767,0x7728ea92}, {0x519ff66c,0x77293182},
   {0x25fd679e,0x88d75c5d}, {0x519ff66c,0x46ef}, {0x25fd679e,0x46f0},
 {0x76fb,0x642b}, {0xeba643c9,0x8c7cb7e7}, {0xeba6bac4,0x8c7d1c12},
   {0x145a3332,0x7383ac43}, {0xeba6bac4,0x642a}, {0x145a3332,0x642b},
 {0xb5b2c12,0x6769}, {0xc1539ccc,0x3232}, {0xccaec8de,0x999b},
   {0x4a078f46,0x3536}, {0xccaec8de,0x6768}, {0x4a078f46,0x6769},
 {0x48a1,0xde0}, {0xc1264615,0xac7e591f}, {0xc1268eb6,0xac7e66ff},
   {0x3eda028c,0x5381b4c0}, {0xc1268eb6,0xddf}, {0x3eda028c,0xde0},
 {0x3e8e3315,0x313b}, {0xe20fd4eb,0x3f2b}, {0x209e0800,0x7067},
   {0x5c7e5e2a,0xfffff20f}, {0x209e0800,0x313b}, {0x5c7e5e2a,0x313b},
 {0x44be,0xfaaf46bf}, {0x6505dd3f,0x5926}, {0x650621fd,0xfaaf9fe5},
   {0x9afa677f,0xfaaeed98}, {0x650621fd,0xfaaf46bf}, {0x9afa677f,0xfaaf46be},
 {0x786b,0x7f87c4e8}, {0x6ed62268,0x7b20}, {0x6ed69ad3,0x7f884008},
   {0x912a5603,0x7f8749c7}, {0x6ed69ad3,0x7f87c4e8}, {0x912a5603,0x7f87c4e7},
 {0x13e6,0x5e0}, {0x3637,0xbccb545f}, {0x4a1d,0xbccb5a3f},
   {0xffffddaf,0x4334b180}, {0x4a1d,0x5e0}, {0xffffddaf,0x5df},
 {0x36e1,0x2f137cd2}, {0x56b6,0x7e12ab9f}, {0x8d97,0xad262871},
   {0xffffe02b,0xb100d132}, {0x8d97,0x2f137cd2}, {0xffffe02b,0x2f137cd1},
 {0x89d591c1,0x91dec5d}, {0x8d449a3,0x4a6}, {0x92a9db64,0x91df103},
   {0x8101481e,0x91de7b7}, {0x92a9db64,0x91dec5d}, {0x8101481e,0x91dec5d},
 {0x58e8,0xb4621c47}, {0x49e2,0x7cf5}, {0xa2ca,0xb462993c},
   {0xf06,0xb4619f52}, {0xa2ca,0xb4621c47}, {0xf06,0xb4621c47},
 {0x97c2f600,0x6b6b}, {0x3eb6,0x69b5}, {0x97c334b6,0xd520},
   {0x97c2b74a,0x1b6}, {0x97c334b6,0x6b6b}, {0x97c2b74a,0x6b6b},
 {0x165d4880,0x63b084ea}, {0x38f8,0x43b8}, {0x165d8178,0x63b0c8a2},
   {0x165d0f88,0x63b04132}, {0x165d8178,0x63b084ea}, {0x165d0f88,0x63b084ea},
 {0x7a33,0x1f5ef152}, {0x1caa,0x3c1a0125}, {0x96dd,0x5b78f277},
   {0x5d89,0xe344f02d}, {0x96dd,0x1f5ef152}, {0x5d89,0x1f5ef152},
 {0xef7,0xc912ebb6}, {0x5e60,0x2cff}, {0x6d57,0xc91318b5},
   {0xffffb097,0xc912beb6}, {0x6d57,0xc912ebb6}, {0xffffb097,0xc912ebb5},
 {0x6a3d,0x36acdc64}, {0xadfd619f,0xb5d70c7b}, {0xadfdcbdc,0xec83e8df},
   {0x5203089e,0x80d5cfe8}, {0xadfdcbdc,0x36acdc63}, {0x5203089e,0x36acdc64},
 {0x3fbd,0xdfa}, {0x3cb7,0x426d}, {0x7c74,0x5067},
   {0x306,0xffffcb8d}, {0x7c74,0xdfa}, {0x306,0xdfa},
 {0x4cb2,0x2e939d7a}, {0xcc2fc8ce,0x47fb}, {0xcc301580,0x2e93e575},
   {0x33d083e4,0x2e93557e}, {0xcc301580,0x2e939d79}, {0x33d083e4,0x2e939d7a},
 {0xee498cc5,0x7e120730}, {0x18e4194f,0x3d8ba63d}, {0x72da614,0xbb9dad6e},
   {0xd5657376,0x408660f3}, {0x72da614,0x7e120731}, {0xd5657376,0x7e120730},
 {0xc5778228,0x4de8}, {0x3b21,0x36ec}, {0xc577bd49,0x84d4},
   {0xc5774707,0x16fc}, {0xc577bd49,0x4de8}, {0xc5774707,0x4de8},
 {0xc6a28007,0x49f3}, {0x3ef31f10,0x1f9}, {0x5959f17,0x4bed},
   {0x87af60f7,0x47fa}, {0x5959f17,0x49f4}, {0x87af60f7,0x49f3},
 {0xe6813296,0xe85a1170}, {0xdd52c5dd,0x1577f0e5}, {0xc3d3f873,0xfdd20256},
   {0x92e6cb9,0xd2e2208b}, {0xc3d3f873,0xe85a1170}, {0x92e6cb9,0xe85a1171},
 {0x2925,0x4718abb}, {0x66a5fe4f,0x5b75}, {0x66a62774,0x471e630},
   {0x995a2ad6,0x4712f45}, {0x66a62774,0x4718abb}, {0x995a2ad6,0x4718aba},
 {0x2c70,0xa5c4bf8}, {0x3a22,0xd70c3f1b}, {0x6692,0xe1688b13},
   {0xfffff24e,0x33500cdc}, {0x6692,0xa5c4bf8}, {0xfffff24e,0xa5c4bf7},
 {0xf1d52c29,0x6dfd}, {0x4665,0x5125}, {0xf1d5728e,0xbf22},
   {0xf1d4e5c4,0x1cd8}, {0xf1d5728e,0x6dfd}, {0xf1d4e5c4,0x6dfd},
 {0x763c,0x946406d8}, {0x91034d14,0xdba}, {0x9103c350,0x94641492},
   {0x6efd2928,0x9463f91d}, {0x9103c350,0x946406d7}, {0x6efd2928,0x946406d8},
 {0x5da1,0x72a5}, {0x276c,0x72b0}, {0x850d,0xe555},
   {0x3635,0xfffffff5}, {0x850d,0x72a5}, {0x3635,0x72a5},
 {0x83a05286,0xfdd86e0}, {0x73d2425b,0x5be5}, {0xf77294e1,0xfdde2c5},
   {0xfce102b,0xfdd2afb}, {0xf77294e1,0xfdd86e0}, {0xfce102b,0xfdd86e0},
 {0x73a,0xf5a808f}, {0x573f,0xe88b2f71}, {0x5e79,0xf7e5b000},
   {0xffffaffb,0x26cf511d}, {0x5e79,0xf5a808f}, {0xffffaffb,0xf5a808e},
 {0x7e0802c1,0x3e3c}, {0x7fe8,0xd5e07e9d}, {0x7e0882a9,0xd5e0bcd9},
   {0x7e0782d9,0x2a1fbf9f}, {0x7e0882a9,0x3e3c}, {0x7e0782d9,0x3e3c},
 {0x5b22,0x7aae}, {0xd7906af4,0x1571}, {0xd790c616,0x901f},
   {0x286ff02e,0x653c}, {0xd790c616,0x7aad}, {0x286ff02e,0x7aae},
 {0x9e359e90,0xc2acc651}, {0x1768,0xd90a61ee}, {0x9e35b5f8,0x9bb7283f},
   {0x9e358728,0xe9a26463}, {0x9e35b5f8,0xc2acc651}, {0x9e358728,0xc2acc651},
 {0xde4754f9,0xf8efe94d}, {0x5bf,0xc3f0e61a}, {0xde475ab8,0xbce0cf67},
   {0xde474f3a,0x34ff0333}, {0xde475ab8,0xf8efe94d}, {0xde474f3a,0xf8efe94d},
 {0xf0c22322,0x6474}, {0x4d605f32,0x7cbe}, {0x3e228254,0xe133},
   {0xa361c3f0,0xffffe7b6}, {0x3e228254,0x6475}, {0xa361c3f0,0x6474},
 {0x7233,0xda9b18f0}, {0x521d6867,0x7734}, {0x521dda9a,0xda9b9024},
   {0xade309cc,0xda9aa1bb}, {0x521dda9a,0xda9b18f0}, {0xade309cc,0xda9b18ef},
 {0xda4,0x4da6}, {0x8c9fb932,0xee44b8c5}, {0x8c9fc6d6,0xee45066b},
   {0x73605472,0x11bb94e0}, {0x8c9fc6d6,0x4da5}, {0x73605472,0x4da6},
 {0x284df52f,0x2d9e3aa9}, {0xcd440d12,0xd959c87c}, {0xf5920241,0x6f80325},
   {0x5b09e81d,0x5444722c}, {0xf5920241,0x2d9e3aa8}, {0x5b09e81d,0x2d9e3aa9},
 {0x3371,0x72bd}, {0x14ff,0xcbe9e9c3}, {0x4870,0xcbea5c80},
   {0x1e72,0x341688fa}, {0x4870,0x72bd}, {0x1e72,0x72bd},
 {0x1122,0x3f205229}, {0x4a61,0x1e7724ff}, {0x5b83,0x5d977728},
   {0xffffc6c1,0x20a92d29}, {0x5b83,0x3f205229}, {0xffffc6c1,0x3f205228},
 {0x797addd5,0x6ce57da6}, {0x2efeae62,0xa1f45f}, {0xa8798c37,0x6d877205},
   {0x4a7c2f73,0x6c438947}, {0xa8798c37,0x6ce57da6}, {0x4a7c2f73,0x6ce57da6},
 {0x4d97b156,0x2db9}, {0x183c,0xc45ba2a1}, {0x4d97c992,0xc45bd05a},
   {0x4d97991a,0x3ba48b18}, {0x4d97c992,0x2db9}, {0x4d97991a,0x2db9},
 {0x21b5,0x7d94a6e7}, {0xe06a1dfe,0x4ba0}, {0xe06a3fb3,0x7d94f287},
   {0x1f9603b7,0x7d945b46}, {0xe06a3fb3,0x7d94a6e6}, {0x1f9603b7,0x7d94a6e7},
 {0x6071,0x9eaf92fd}, {0xa96e0b28,0xbf61c611}, {0xa96e6b99,0x5e11590e},
   {0x56925549,0xdf4dcceb}, {0xa96e6b99,0x9eaf92fc}, {0x56925549,0x9eaf92fd},
 {0x3fb8,0x682c}, {0x8e5b6d9e,0x1b75cafe}, {0x8e5bad56,0x1b76332a},
   {0x71a4d21a,0xe48a9d2d}, {0x8e5bad56,0x682b}, {0x71a4d21a,0x682c},
 {0x647b,0x856f96ff}, {0x47f3,0x7660}, {0xac6e,0x85700d5f},
   {0x1c88,0x856f209f}, {0xac6e,0x856f96ff}, {0x1c88,0x856f96ff},
 {0x29a4,0xfac}, {0x83dc11d,0x3f6782d5}, {0x83deac1,0x3f679281},
   {0xf7c26887,0xc0988cd6}, {0x83deac1,0xfac}, {0xf7c26887,0xfab},
 {0x23237391,0x7639}, {0x8caa6d9f,0xd3c396fb}, {0xafcde130,0xd3c40d34},
   {0x967905f2,0x2c3cdf3d}, {0xafcde130,0x7638}, {0x967905f2,0x7639},
 {0xcb8bc5dd,0x31bc}, {0x1b495381,0xd8a37d71}, {0xe6d5195e,0xd8a3af2d},
   {0xb042725c,0x275cb44b}, {0xe6d5195e,0x31bc}, {0xb042725c,0x31bc},
 {0xb85ab4b7,0x8806519}, {0x5eb5,0x17ba}, {0xb85b136c,0x8807cd3},
   {0xb85a5602,0x8804d5f}, {0xb85b136c,0x8806519}, {0xb85a5602,0x8806519},
 {0xab18af92,0xaf8}, {0xf7bda5e1,0x3cc0b09e}, {0xa2d65573,0x3cc0bb97},
   {0xb35b09b1,0xc33f5a59}, {0xa2d65573,0xaf8}, {0xb35b09b1,0xaf8},
 {0x3b74,0xa429cc2b}, {0x562d,0x797d}, {0x91a1,0xa42a45a8},
   {0xffffe547,0xa42952ad}, {0x91a1,0xa429cc2b}, {0xffffe547,0xa429cc2a},
 {0x48b9,0x387c}, {0x6326,0x69ef}, {0xabdf,0xa26b},
   {0xffffe593,0xffffce8c}, {0xabdf,0x387c}, {0xffffe593,0x387b},
 {0x528,0x8eb7ec31}, {0xa332ba1,0x2db5}, {0xa3330c9,0x8eb819e6},
   {0xf5ccd987,0x8eb7be7b}, {0xa3330c9,0x8eb7ec31}, {0xf5ccd987,0x8eb7ec30},
 {0x9e84c0dd,0x58562d03}, {0x49a6,0x6e365382}, {0x9e850a83,0xc68c8085},
   {0x9e847737,0xea1fd981}, {0x9e850a83,0x58562d03}, {0x9e847737,0x58562d03},
 {0x4cb0b843,0x71aa}, {0x56e2,0x67}, {0x4cb10f25,0x7211},
   {0x4cb06161,0x7143}, {0x4cb10f25,0x71aa}, {0x4cb06161,0x71aa},
 {0xc0a11d0a,0x4075}, {0xe6273252,0x2321}, {0xa6c84f5c,0x6397},
   {0xda79eab8,0x1d53}, {0xa6c84f5c,0x4075}, {0xda79eab8,0x4075},
 {0x50ec,0x2a7e}, {0x66a6,0x4021}, {0xb792,0x6a9f},
   {0xffffea46,0xffffea5c}, {0xb792,0x2a7e}, {0xffffea46,0x2a7d},
 {0x4030,0xf529ebaa}, {0x6979,0x7f2e}, {0xa9a9,0xf52a6ad8},
   {0xffffd6b7,0xf5296c7b}, {0xa9a9,0xf529ebaa}, {0xffffd6b7,0xf529eba9},
 {0x5b28,0x58a2}, {0x5b916318,0x70b9}, {0x5b91be40,0xc95b},
   {0xa46ef810,0xffffe7e8}, {0x5b91be40,0x58a2}, {0xa46ef810,0x58a1},
 {0x8a0,0x3b74}, {0x14f2,0x7be5}, {0x1d92,0xb759},
   {0xfffff3ae,0xffffbf8e}, {0x1d92,0x3b74}, {0xfffff3ae,0x3b73},
 {0x166,0x14f9}, {0x6aa7,0x5df2}, {0x6c0d,0x72eb},
   {0xffff96bf,0xffffb706}, {0x6c0d,0x14f9}, {0xffff96bf,0x14f8},
 {0x3170,0x3662}, {0x472d,0x23e9}, {0x789d,0x5a4b},
   {0xffffea43,0x1278}, {0x789d,0x3662}, {0xffffea43,0x3661},
 {0x1cbb1572,0xbc04db14}, {0xda3f7ff7,0x2b31}, {0xf6fa9569,0xbc050645},
   {0x427b957b,0xbc04afe2}, {0xf6fa9569,0xbc04db13}, {0x427b957b,0xbc04db14},
 {0x1635,0xa1430bfb}, {0x1a8,0x39a6}, {0x17dd,0xa14345a1},
   {0x148d,0xa142d255}, {0x17dd,0xa1430bfb}, {0x148d,0xa1430bfb},
 {0x232,0xe1}, {0x337,0xed182e28}, {0x569,0xed182f09},
   {0xfffffefb,0x12e7d2b8}, {0x569,0xe1}, {0xfffffefb,0xe0},
 {0x1c37,0x90d173f7}, {0x7335,0xab1c4f21}, {0x8f6c,0x3bedc318},
   {0xffffa902,0xe5b524d5}, {0x8f6c,0x90d173f7}, {0xffffa902,0x90d173f6},
 {0x499c57d1,0x34e8}, {0x5568,0x428b429}, {0x499cad39,0x428e911},
   {0x499c0269,0xfbd780bf}, {0x499cad39,0x34e8}, {0x499c0269,0x34e8},
 {0x4138,0xf9cf648d}, {0x1839,0x81cb141e}, {0x5971,0x7b9a78ab},
   {0x28ff,0x7804506f}, {0x5971,0xf9cf648d}, {0x28ff,0xf9cf648d},
 {0x22aa,0xc764e13f}, {0xd762f299,0x2027}, {0xd7631543,0xc7650166},
   {0x289d3011,0xc764c117}, {0xd7631543,0xc764e13e}, {0x289d3011,0xc764e13f},
 {0x2263,0x426d}, {0x613919fe,0x6e0}, {0x61393c61,0x494d},
   {0x9ec70865,0x3b8c}, {0x61393c61,0x426d}, {0x9ec70865,0x426c},
 {0xd8af97b1,0x4db6}, {0x2735,0x33b}, {0xd8afbee6,0x50f1},
   {0xd8af707c,0x4a7b}, {0xd8afbee6,0x4db6}, {0xd8af707c,0x4db6},
 {0xd0d15a3c,0x4e655067}, {0x762,0xe30}, {0xd0d1619e,0x4e655e97},
   {0xd0d152da,0x4e654237}, {0xd0d1619e,0x4e655067}, {0xd0d152da,0x4e655067},
 {0x4cec,0x9a4ac835}, {0x1e78,0x2bf0bb9e}, {0x6b64,0xc63b83d3},
   {0x2e74,0x6e5a0c97}, {0x6b64,0x9a4ac835}, {0x2e74,0x9a4ac835},
 {0xf77ab7a8,0x31aa}, {0x31f9,0x1626}, {0xf77ae9a1,0x47d0},
   {0xf77a85af,0x1b84}, {0xf77ae9a1,0x31aa}, {0xf77a85af,0x31aa},
 {0xcb59bac7,0x3b0a286}, {0x4aec,0x1cb5}, {0xcb5a05b3,0x3b0bf3b},
   {0xcb596fdb,0x3b085d1}, {0xcb5a05b3,0x3b0a286}, {0xcb596fdb,0x3b0a286},
 {0x4274,0x130}, {0xd13ca48d,0x52ae}, {0xd13ce701,0x53de},
   {0x2ec39de7,0xffffae81}, {0xd13ce701,0x12f}, {0x2ec39de7,0x130},
 {0x59515bd8,0x3ced}, {0x4f2a,0x78e37bb6}, {0x5951ab02,0x78e3b8a3},
   {0x59510cae,0x871cc137}, {0x5951ab02,0x3ced}, {0x59510cae,0x3ced},
 {0x3b3a34a3,0xbd9b9c5f}, {0xd27,0x4a2e49a0}, {0x3b3a41ca,0x7c9e5ff},
   {0x3b3a277c,0x736d52bf}, {0x3b3a41ca,0xbd9b9c5f}, {0x3b3a277c,0xbd9b9c5f},
 {0x376d,0x453894d5}, {0x396b,0xfb2}, {0x70d8,0x4538a487},
   {0xfffffe02,0x45388522}, {0x70d8,0x453894d5}, {0xfffffe02,0x453894d4},
 {0x3dd52f69,0x8f0cfadb}, {0x6ac688b5,0x158640f}, {0xa89bb81e,0x90655eea},
   {0xd30ea6b4,0x8db496cb}, {0xa89bb81e,0x8f0cfadb}, {0xd30ea6b4,0x8f0cfada},
 {0x1f08448e,0x6b2c}, {0x518ee517,0x18b8}, {0x709729a5,0x83e4},
   {0xcd795f77,0x5273}, {0x709729a5,0x6b2c}, {0xcd795f77,0x6b2b},
 {0xd65faa46,0x742a}, {0xb836117a,0x6e3858e2}, {0x8e95bbc0,0x6e38cd0d},
   {0x1e2998cc,0x91c81b48}, {0x8e95bbc0,0x742a}, {0x1e2998cc,0x742b},
 {0x647a,0x740abe8e}, {0x2d9443b,0x11de81ca}, {0x2d9a8b5,0x85e94058},
   {0xfd27203f,0x622c3cc3}, {0x2d9a8b5,0x740abe8e}, {0xfd27203f,0x740abe8d},
 {0x29f29eb3,0x605db615}, {0xfca5ace8,0xe390eaf8}, {0x26984b9b,0x43eea10e},
   {0x2d4cf1cb,0x7ccccb1c}, {0x26984b9b,0x605db615}, {0x2d4cf1cb,0x605db615},
 {0x413e4aae,0x48cb09a}, {0x57f,0xdea0749f}, {0x413e502d,0xe32d2539},
   {0x413e452f,0x25ec3bfb}, {0x413e502d,0x48cb09a}, {0x413e452f,0x48cb09a},
 {0x20d6467c,0xeeab1389}, {0x59be,0x442beef8}, {0x20d6a03a,0x32d70281},
   {0x20d5ecbe,0xaa7f2491}, {0x20d6a03a,0xeeab1389}, {0x20d5ecbe,0xeeab1389},
 {0x48f3,0x40680928}, {0x48ff27bf,0x21c5eb63}, {0x48ff70b2,0x622df48b},
   {0xb7012134,0x1ea21dc4}, {0x48ff70b2,0x40680928}, {0xb7012134,0x40680927},
 {0x197a,0x4ea9}, {0x172e,0x4471ba8c}, {0x30a8,0x44720935},
   {0x24c,0xbb8e941d}, {0x30a8,0x4ea9}, {0x24c,0x4ea9},
 {0x3fbe16ea,0x6ffe}, {0x4bbb,0x4371}, {0x3fbe62a5,0xb36f},
   {0x3fbdcb2f,0x2c8d}, {0x3fbe62a5,0x6ffe}, {0x3fbdcb2f,0x6ffe},
 {0x73a9d20a,0x948ad04e}, {0x3f68,0xc9d191a8}, {0x73aa1172,0x5e5c61f6},
   {0x73a992a2,0xcab93ea6}, {0x73aa1172,0x948ad04e}, {0x73a992a2,0x948ad04e},
 {0x535,0x2e9}, {0x12e9,0x2b927095}, {0x181e,0x2b92737e},
   {0xfffff24c,0xd46d9253}, {0x181e,0x2e9}, {0xfffff24c,0x2e8},
 {0x18ad,0xe67cdfae}, {0x3975,0x923a8df5}, {0x5222,0x78b76da3},
   {0xffffdf38,0x544251b8}, {0x5222,0xe67cdfae}, {0xffffdf38,0xe67cdfad},
 {0x2567,0x14f7}, {0x1bbb,0x84bf13d8}, {0x4122,0x84bf28cf},
   {0x9ac,0x7b41011f}, {0x4122,0x14f7}, {0x9ac,0x14f7},
 {0x702e,0x70e8}, {0x7d31,0x1ee87494}, {0xed5f,0x1ee8e57c},
   {0xfffff2fd,0xe117fc53}, {0xed5f,0x70e8}, {0xfffff2fd,0x70e7},
 {0x485c04dc,0x2574}, {0xbdfe5122,0x39cfd071}, {0x65a55fe,0x39cff5e6},
   {0x8a5db3ba,0xc6305502}, {0x65a55fe,0x2574}, {0x8a5db3ba,0x2574},
 {0x18ba,0x6a6e}, {0x6938,0x19bc}, {0x81f2,0x842a},
   {0xffffaf82,0x50b1}, {0x81f2,0x6a6e}, {0xffffaf82,0x6a6d},
 {0x6d27,0x7be27a16}, {0x71f1,0x353c}, {0xdf18,0x7be2af52},
   {0xfffffb36,0x7be244d9}, {0xdf18,0x7be27a16}, {0xfffffb36,0x7be27a15},
 {0x60b4,0x77bba361}, {0x2118cbc,0x48aa}, {0x211ed70,0x77bbec0b},
   {0xfdeed3f8,0x77bb5ab6}, {0x211ed70,0x77bba361}, {0xfdeed3f8,0x77bba360},
 {0x6bff,0x46e8}, {0x7339b10f,0x91469676}, {0x733a1d0e,0x9146dd5e},
   {0x8cc6baf0,0x6eb9b071}, {0x733a1d0e,0x46e8}, {0x8cc6baf0,0x46e7},
 {0x77ec1cd6,0x28bd}, {0xea28162,0x31e6}, {0x868e9e38,0x5aa3},
   {0x69499b74,0xfffff6d7}, {0x868e9e38,0x28bd}, {0x69499b74,0x28bd},
 {0x6670,0x6278}, {0xf27c9f79,0x18e0}, {0xf27d05e9,0x7b58},
   {0xd83c6f7,0x4997}, {0xf27d05e9,0x6277}, {0xd83c6f7,0x6278},
 {0x247f6410,0x46a8}, {0x6f7d,0xa60b7c7d}, {0x247fd38d,0xa60bc325},
   {0x247ef493,0x59f4ca2b}, {0x247fd38d,0x46a8}, {0x247ef493,0x46a8},
 {0xef333533,0x63ec}, {0x17fb,0xe44beda3}, {0xef334d2e,0xe44c518f},
   {0xef331d38,0x1bb47649}, {0xef334d2e,0x63ec}, {0xef331d38,0x63ec},
 {0x526b,0x919b6ed4}, {0x20118dfc,0x54247e08}, {0x2011e067,0xe5bfecdc},
   {0xdfeec46f,0x3d76f0cb}, {0x2011e067,0x919b6ed4}, {0xdfeec46f,0x919b6ed3},
 {0x33ea,0x2eb3}, {0x55b7,0x421490f3}, {0x89a1,0x4214bfa6},
   {0xffffde33,0xbdeb9dbf}, {0x89a1,0x2eb3}, {0xffffde33,0x2eb2},
 {0x5b4,0x6b6d5114}, {0x27a593a9,0x1bf2}, {0x27a5995d,0x6b6d6d06},
   {0xd85a720b,0x6b6d3521}, {0x27a5995d,0x6b6d5114}, {0xd85a720b,0x6b6d5113},
 {0x18ae,0x2dfd}, {0x76825937,0x4ab9}, {0x768271e5,0x78b6},
   {0x897dbf77,0xffffe343}, {0x768271e5,0x2dfd}, {0x897dbf77,0x2dfc},
 {0x99602452,0x12e98227}, {0x42bf,0x3e29}, {0x99606711,0x12e9c050},
   {0x995fe193,0x12e943fe}, {0x99606711,0x12e98227}, {0x995fe193,0x12e98227},
 {0x3efb,0x84e15381}, {0x2be2,0xff415543}, {0x6add,0x8422a8c4},
   {0x1319,0x859ffe3e}, {0x6add,0x84e15381}, {0x1319,0x84e15381},
 {0x78006280,0x2327}, {0x67eb,0xe4bd37b3}, {0x7800ca6b,0xe4bd5ada},
   {0x77fffa95,0x1b42eb74}, {0x7800ca6b,0x2327}, {0x77fffa95,0x2327},
 {0x7c24a3fc,0xb70}, {0x4236,0x29f0}, {0x7c24e632,0x3560},
   {0x7c2461c6,0xffffe180}, {0x7c24e632,0xb70}, {0x7c2461c6,0xb70},
 {0x76eb5721,0x695b9c1}, {0x5e48ef70,0x90dd3c42}, {0xd5344691,0x9772f603},
   {0x18a267b1,0x75b87d7f}, {0xd5344691,0x695b9c1}, {0x18a267b1,0x695b9c1},
 {0x122e,0x2142db5b}, {0xa2713c9b,0x503e}, {0xa2714ec9,0x21432b99},
   {0x5d8ed593,0x21428b1c}, {0xa2714ec9,0x2142db5a}, {0x5d8ed593,0x2142db5b},
 {0x77f5,0x3661}, {0x3a7,0xadddcbd8}, {0x7b9c,0xadde0239},
   {0x744e,0x52226a89}, {0x7b9c,0x3661}, {0x744e,0x3661},
 {0x3d8a5ed3,0xe6f3576d}, {0x6d07bbf0,0x4fe2}, {0xaa921ac3,0xe6f3a74f},
   {0xd082a2e3,0xe6f3078a}, {0xaa921ac3,0xe6f3576d}, {0xd082a2e3,0xe6f3576c},
 {0x4fef,0x79a1}, {0x6a0,0xc18ffe7d}, {0x568f,0xc190781e},
   {0x494f,0x3e707b24}, {0x568f,0x79a1}, {0x494f,0x79a1},
 {0x356a,0x28f5c96a}, {0x127e,0xaa0d53f1}, {0x47e8,0xd3031d5b},
   {0x22ec,0x7ee87579}, {0x47e8,0x28f5c96a}, {0x22ec,0x28f5c96a},
 {0x49af,0x1fa6}, {0x7a67,0x34ff}, {0xc416,0x54a5},
   {0xffffcf48,0xffffeaa6}, {0xc416,0x1fa6}, {0xffffcf48,0x1fa5},
 {0x2b79e69d,0x142f}, {0x7cf4,0x4fb5}, {0x2b7a6391,0x63e4},
   {0x2b7969a9,0xffffc47a}, {0x2b7a6391,0x142f}, {0x2b7969a9,0x142f},
 {0x1cbc,0xcf52b037}, {0x6efd,0x6333}, {0x8bb9,0xcf53136a},
   {0xffffadbf,0xcf524d03}, {0x8bb9,0xcf52b037}, {0xffffadbf,0xcf52b036},
 {0x73ab,0x2aaa}, {0xe423a069,0xeb977bcb}, {0xe4241414,0xeb97a675},
   {0x1bdcd342,0x1468aede}, {0xe4241414,0x2aa9}, {0x1bdcd342,0x2aaa},
 {0x5aa0,0x69c59058}, {0xf15c9a8a,0x422d}, {0xf15cf52a,0x69c5d285},
   {0xea3c016,0x69c54e2a}, {0xf15cf52a,0x69c59057}, {0xea3c016,0x69c59058},
 {0x4aea,0x426e}, {0xea6d8329,0xe6d4b9ff}, {0xea6dce13,0xe6d4fc6d},
   {0x1592c7c1,0x192b886e}, {0xea6dce13,0x426d}, {0x1592c7c1,0x426e},
 {0x6829,0x573c1ecf}, {0x1d8b3c01,0x3a404d7f}, {0x1d8ba42a,0x917c6c4e},
   {0xe2752c28,0x1cfbd14f}, {0x1d8ba42a,0x573c1ecf}, {0xe2752c28,0x573c1ece},
 {0x2afd0cc1,0x5abe}, {0xe0c924bd,0xf38}, {0xbc6317e,0x69f7},
   {0x4a33e804,0x4b85}, {0xbc6317e,0x5abe}, {0x4a33e804,0x5abe},
 {0x6a6f,0x11f7}, {0xe3c7c77,0xbebafe1a}, {0xe3ce6e6,0xbebb1011},
   {0xf1c3edf8,0x414513dc}, {0xe3ce6e6,0x11f7}, {0xf1c3edf8,0x11f6},
 {0x45b1,0x5aaa}, {0xacd11182,0x1d190f4b}, {0xacd15733,0x1d1969f5},
   {0x532f342f,0xe2e74b5e}, {0xacd15733,0x5aa9}, {0x532f342f,0x5aaa},
 {0x7b74,0x3af4a818}, {0x4f022c97,0x47126166}, {0x4f02a80b,0x8207097e},
   {0xb0fe4edd,0xf3e246b1}, {0x4f02a80b,0x3af4a818}, {0xb0fe4edd,0x3af4a817},
 {0x2e3e,0x41fc}, {0x15bb,0x1d76}, {0x43f9,0x5f72},
   {0x1883,0x2486}, {0x43f9,0x41fc}, {0x1883,0x41fc},
 {0x2159138f,0xfb5f0677}, {0x2d3c,0x77cd1b99}, {0x215940cb,0x732c2210},
   {0x2158e653,0x8391eade}, {0x215940cb,0xfb5f0677}, {0x2158e653,0xfb5f0677},
 {0x245544cf,0x24ba}, {0x63f68c34,0x4c34}, {0x884bd103,0x70ee},
   {0xc05eb89b,0xffffd885}, {0x884bd103,0x24ba}, {0xc05eb89b,0x24b9},
 {0xef90b293,0x12ae}, {0x14f20548,0x72abf95a}, {0x482b7db,0x72ac0c09},
   {0xda9ead4b,0x8d541954}, {0x482b7db,0x12af}, {0xda9ead4b,0x12ae},
 {0xc3be611,0x78c1b8d6}, {0x5543b51e,0xf2662ab5}, {0x617f9b2f,0x6b27e38b},
   {0xb6f830f3,0x865b8e20}, {0x617f9b2f,0x78c1b8d6}, {0xb6f830f3,0x78c1b8d5},
 {0xb1d3294c,0xb6ddb158}, {0x2f1c732b,0xbbfe8761}, {0xe0ef9c77,0x72dc38b9},
   {0x82b6b621,0xfadf29f7}, {0xe0ef9c77,0xb6ddb158}, {0x82b6b621,0xb6ddb158},
 {0x53b0,0x6efb}, {0x5b30,0x84896c1c}, {0xaee0,0x8489db17},
   {0xfffff880,0x7b7702de}, {0xaee0,0x6efb}, {0xfffff880,0x6efa},
 {0x72f4,0x3efa}, {0x277108f6,0x24fb67ad}, {0x27717bea,0x24fba6a7},
   {0xd88f69fe,0xdb04d74c}, {0x27717bea,0x3efa}, {0xd88f69fe,0x3ef9},
 {0x7af1,0x77e}, {0xe2c281b5,0x7cf97106}, {0xe2c2fca6,0x7cf97884},
   {0x1d3df93c,0x83069677}, {0xe2c2fca6,0x77d}, {0x1d3df93c,0x77e},
 {0x5974,0x6bae}, {0x78eb,0x36a1}, {0xd25f,0xa24f},
   {0xffffe089,0x350c}, {0xd25f,0x6bae}, {0xffffe089,0x6bad},
 {0x7e308cfe,0x9029b11b}, {0x930892b0,0x2521}, {0x11391fae,0x9029d63d},
   {0xeb27fa4e,0x90298bf9}, {0x11391fae,0x9029b11b}, {0xeb27fa4e,0x9029b11b},
 {0x4bac,0x6ea3}, {0x5f3,0x5c1226ce}, {0x519f,0x5c129571},
   {0x45b9,0xa3ee47d5}, {0x519f,0x6ea3}, {0x45b9,0x6ea3},
 {0x3d62a2cd,0x59a4}, {0x2f5,0x7171}, {0x3d62a5c2,0xcb15},
   {0x3d629fd8,0xffffe833}, {0x3d62a5c2,0x59a4}, {0x3d629fd8,0x59a4},
 {0x35b7,0x4dadd334}, {0x6db07571,0xcd8e774}, {0x6db0ab28,0x5a86baa8},
   {0x924fc046,0x40d4ebbf}, {0x6db0ab28,0x4dadd334}, {0x924fc046,0x4dadd333},
 {0x1c5ba7fe,0x5c64}, {0x67df8b85,0x39aa0ecb}, {0x843b3383,0x39aa6b2f},
   {0xb47c1c79,0xc6564d98}, {0x843b3383,0x5c64}, {0xb47c1c79,0x5c63},
 {0x6bbd6e07,0x2a316cf1}, {0x395272d1,0x4234}, {0xa50fe0d8,0x2a31af25},
   {0x326afb36,0x2a312abd}, {0xa50fe0d8,0x2a316cf1}, {0x326afb36,0x2a316cf1},
 {0x693176db,0x4d26}, {0x4241b52b,0x14ff}, {0xab732c06,0x6225},
   {0x26efc1b0,0x3827}, {0xab732c06,0x4d26}, {0x26efc1b0,0x4d26},
 {0xf924bcef,0x626e}, {0x3fb8,0x67ce76f2}, {0xf924fca7,0x67ced960},
   {0xf9247d37,0x9831eb7c}, {0xf924fca7,0x626e}, {0xf9247d37,0x626e},
 {0x8a6c2263,0xee868014}, {0x5036,0xe598b2ff}, {0x8a6c7299,0xd41f3313},
   {0x8a6bd22d,0x8edcd15}, {0x8a6c7299,0xee868014}, {0x8a6bd22d,0xee868014},
 {0xfec7638e,0x59f37617}, {0x6330,0x3932}, {0xfec7c6be,0x59f3af49},
   {0xfec7005e,0x59f33ce5}, {0xfec7c6be,0x59f37617}, {0xfec7005e,0x59f37617},
 {0x777aa2f4,0x7e2e}, {0x60fc,0xf30d04d}, {0x777b03f0,0xf314e7b},
   {0x777a41f8,0xf0cfade1}, {0x777b03f0,0x7e2e}, {0x777a41f8,0x7e2e},
 {0x23b4,0x7131}, {0x219c937a,0x10a4}, {0x219cb72e,0x81d5},
   {0xde63903a,0x608c}, {0x219cb72e,0x7131}, {0xde63903a,0x7130},
 {0x74eb,0x44e4}, {0xb4c57155,0x43e5}, {0xb4c5e640,0x88c9},
   {0x4b3b0396,0xfe}, {0xb4c5e640,0x44e3}, {0x4b3b0396,0x44e4},
 {0x1fb9,0x387aa83d}, {0xf095cb40,0x6221}, {0xf095eaf9,0x387b0a5e},
   {0xf6a5479,0x387a461b}, {0xf095eaf9,0x387aa83c}, {0xf6a5479,0x387aa83d},
 {0xca54c205,0x6473}, {0x4d65,0x442d}, {0xca550f6a,0xa8a0},
   {0xca5474a0,0x2046}, {0xca550f6a,0x6473}, {0xca5474a0,0x6473},
 {0xd574a377,0xee2fb262}, {0x29f7,0x6187b706}, {0xd574cd6e,0x4fb76968},
   {0xd5747980,0x8ca7fb5c}, {0xd574cd6e,0xee2fb262}, {0xd5747980,0xee2fb262},
 {0x376c,0x72af}, {0x3da97ca7,0x3337}, {0x3da9b413,0xa5e6},
   {0xc256bac5,0x3f77}, {0x3da9b413,0x72af}, {0xc256bac5,0x72ae},
 {0x1631,0xb6f}, {0x1060,0x75e5}, {0x2691,0x8154},
   {0x5d1,0xffff958a}, {0x2691,0xb6f}, {0x5d1,0xb6f}
};
#define NTESTS ((UINT) (sizeof abcdef / (sizeof abcdef[0] * 6)))
#undef ZERO
#undef ONE
#undef TWO
#undef THRE
#undef NEG1
#undef NEG2
#undef NEG3

int CompilerBuiltin(void);
int NoCompilerBuiltin(void);

void error(_TCHAR *Op,
           MY_INT64 *a,
           MY_INT64 *b,
           MY_INT64 *c,
           MY_INT64 *d,
           int i)
{
    _tprintf(_TEXT("a = { 0x%x, 0x%x }, "), *a);
    _tprintf(_TEXT("b = { 0x%x, 0x%x }, "), *b);
    _tprintf(_TEXT("a %s b = { 0x%x, 0x%x }\n\r"), Op, *c);
    _tprintf(_TEXT("  ==> a %s b should be { 0x%x, 0x%x }!!!\n\r"), Op, *d);
    _tprintf(_TEXT("64-bit addition test FAILED "));
    _tprintf(_TEXT("in iteration %d.\n\r"), i); 
}

#define MYERROR(o,a,b,c,d,i) error(o,(MY_INT64*)&a,(MY_INT64*)&b,(MY_INT64*)&c,(MY_INT64*)&d,i)

#define Test(_name_) \
int _name_(void)    \
{    \
    int i;    \
    MY_INT64 *p;    \
    INT64 a, b, c, d;    \
    INT32 blo;    \
    int nPass, nFail;    \
    TIME Tstart, Tend;    \
    \
    Tstart = CurrentTime();    \
    \
    nPass = nFail = 0;    \
    p = abcdef;    \
    for (i = 0; i < NTESTS; i++) {    \
    \
        Int64FromHighAndLow(a, p->HighPart, p->LowPart);    \
        p++;    \
        blo = p->LowPart;    \
        Int64FromHighAndLow(b, p->HighPart, p->LowPart);    \
        p++;    \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Int64Add(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("+"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Int64Subtract(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("-"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Int64AddInt32(a,blo);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("+_"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Int64SubtractInt32(a,blo);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("-_"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
    }    \
    Tend = CurrentTime();    \
    \
    _tprintf(_TEXT("64-bit addition test "));    \
    if (nFail == 0) {    \
        _tprintf(_TEXT("PASSED.\n\r"));    \
    \
    } else {    \
        _tprintf(_TEXT("FAILED (%d fail %d pass).\n\r"),    \
                 nFail, nPass);    \
    }    \
    \
    i = TimeDifference(Tend,Tstart);    \
    _tprintf(_TEXT("Took %d microseconds for %d tests (%d/test)\n\r"),    \
             i / 10,    \
             4*NTESTS,    \
             i / (4*NTESTS*10));    \
    return nFail;    \
}


/* In any event, test the os-supported routines.
 * If the compiler supports it, repeat for the builtin routines.
 */
int _tmain()
{
    int nFail = 0;

    _tprintf(_TEXT("\n\rTesting os-supported 64bit addition.\n\r"));
    nFail = NoCompilerBuiltin();

#if !defined(__NO_BUILTIN_INT64)
    _tprintf(_TEXT("\n\rTesting compiler-supported 64bit addition.\n\r"));
    nFail += CompilerBuiltin();
#endif

    if (nFail)
        _tprintf(_TEXT("Test FAILED, %d errors.\n\r"), nFail);

    exit ((nFail == 0) ? EXIT_SUCCESS : EXIT_FAILURE);
    return 0;/*amusme*/
}

#include "tst64again.c"

