/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * C test program -- 64-bit unsigned add/subtract
 */

#if defined(MMLITE)
#include <mmlite.h>
#define XXXX 1

#else
#include <windows.h>
#define i386 /* uhu? */
#define EXTERN_C extern
#include "int64.h"
typedef INT64 TIME;
TIME CurrentTime(void)
{
    TIME t;
    Int64FromHighAndLow(t,0,GetCurrentTime());
#define XXXX 10000
    return t;
}
#endif

/* Was useful for testing under Win32 */
UINT32 TimeDifference(TIME Stop, TIME Start)
{
    UINT32 r;
    Stop = TimeSubtract(Stop,Start);
    r = ((UINT32) Int64ToInt32(Stop) ) * XXXX;
    return r;
}

#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* grumble.. */
typedef struct
    {
    UINT32 LowPart;
    INT32 HighPart;
    }   MY_UINT64;


/* NOTE:
 * - Test for Uint64Add, Uint64Subtract, Uint64AddUint32, Uint64SubtractUint32
 * - The LowPart is used as 'B' operand in the Uint64...Uint32 cases.
 * - For each input pair we record all 4 results in the table below.
 * - 6 entries: a, b, a+b, a-b, a+b.low, a-b.low
 */
#define ZERO 0,0
#define ONE  1,0
#define TWO  2,0
#define THRE 3,0
#define NEG1   ~0,~0
#define NEG2   0xfffffffe,~0
#define NEG3   0xfffffffd,~0
MY_UINT64 abcdef[] = {
 {ZERO},{ZERO},     {ZERO},{ZERO},{ZERO},{ZERO},
 {ONE},{ZERO},      {ONE},{ONE},{ONE},{ONE},
 {ZERO},{ONE},      {ONE},{NEG1},{ONE},{NEG1},
 {ONE},{ONE},       {TWO},{ZERO},{TWO},{ZERO},
 {NEG1},{NEG1},     {NEG2},{ZERO},{~0-1,0},{0,~0},
 {NEG1},{ZERO},     {NEG1},{NEG1},{NEG1},{NEG1},
 {ZERO},{NEG1},     {NEG1},{ONE},{~0,0},{1,~0},
 {NEG1},{ONE},      {ZERO},{NEG2},{ZERO},{NEG2},
 {ONE},{NEG1},      {ZERO},{TWO},{0,1},{2,~0},
 {ONE},{TWO},       {THRE},{NEG1},{THRE},{NEG1},
 {TWO},{ONE},       {THRE},{ONE},{THRE},{ONE},
 {NEG1},{TWO},      {ONE},{NEG3},{ONE},{NEG3},
 {TWO},{NEG1},      {ONE},{THRE},{1,1},{3,~0},
/*13*/
 {~0,0},{0,0},      {~0,0},{~0,0},{~0,0},{~0,0},
 {0,~0},{0,0},      {0,~0},{0,~0},{0,~0},{0,~0},
 {0,0},{~0,0},      {~0,0},{1,~0},{~0,0},{1,~0},
 {0,0},{0,~0},      {0,~0},{0,1},{ZERO},{ZERO},
 {~0,0},{~0,0},     {~0-1,1},{0,0},{~0-1,1},{0,0},
 {~0,0},{0,~0},     {~0,~0},{~0,1},{~0,0},{~0,0},
 {0,~0},{~0,0},     {~0,~0},{1,~0-1},{~0,~0},{1,~0-1},
 {0,~0},{0,~0},     {0,~0-1},{0,0},{0,~0},{0,~0},
/*21*/  /* 500 random pairs*/
 {0x68a0,0x60cc453c}, {0x7b22c5f9,0xdb0f0876}, {0x7b232e99,0x3bdb4db2},
   {0x84dda2a7,0x85bd3cc5}, {0x7b232e99,0x60cc453c}, {0x84dda2a7,0x60cc453b},
 {0x5374,0x8f593143}, {0x62b5,0x3da3}, {0xb629,0x8f596ee6},
   {0xfffff0bf,0x8f58f39f}, {0xb629,0x8f593143}, {0xfffff0bf,0x8f593142},
 {0x3baa,0x9d32b758}, {0x5c6f45a3,0xe36}, {0x5c6f814d,0x9d32c58e},
   {0xa390f607,0x9d32a921}, {0x5c6f814d,0x9d32b758}, {0xa390f607,0x9d32b757},
 {0x70e3,0x9cb888dc}, {0x2b6f,0x6168}, {0x9c52,0x9cb8ea44},
   {0x4574,0x9cb82774}, {0x9c52,0x9cb888dc}, {0x4574,0x9cb888dc},
 {0x2733,0x196a}, {0xcd0849a4,0x39a5}, {0xcd0870d7,0x530f},
   {0x32f7dd8f,0xffffdfc4}, {0xcd0870d7,0x196a}, {0x32f7dd8f,0x1969},
 {0xbdb0e6a1,0x6d091def}, {0x4fd7e6fb,0xc451b45e}, {0xd88cd9c,0x315ad24e},
   {0x6dd8ffa6,0xa8b76991}, {0xd88cd9c,0x6d091df0}, {0x6dd8ffa6,0x6d091def},
 {0x80a2eb3a,0xf6ecf010}, {0x374,0x3d3d}, {0x80a2eeae,0xf6ed2d4d},
   {0x80a2e7c6,0xf6ecb2d3}, {0x80a2eeae,0xf6ecf010}, {0x80a2e7c6,0xf6ecf010},
 {0x3261,0x6e06ade4}, {0x7fd,0x44e5}, {0x3a5e,0x6e06f2c9},
   {0x2a64,0x6e0668ff}, {0x3a5e,0x6e06ade4}, {0x2a64,0x6e06ade4},
 {0x764b6dad,0xca3538f6}, {0x437a,0x34e1}, {0x764bb127,0xca356dd7},
   {0x764b2a33,0xca350415}, {0x764bb127,0xca3538f6}, {0x764b2a33,0xca3538f6},
 {0xe2652903,0x5b4bd4d9}, {0x3ea,0xba5fea1b}, {0xe2652ced,0x15abbef4},
   {0xe2652519,0xa0ebeabe}, {0xe2652ced,0x5b4bd4d9}, {0xe2652519,0x5b4bd4d9},
 {0x63f13142,0xb6ca8d07}, {0x76f44089,0x5771}, {0xdae571cb,0xb6cae478},
   {0xecfcf0b9,0xb6ca3595}, {0xdae571cb,0xb6ca8d07}, {0xecfcf0b9,0xb6ca8d06},
 {0x338,0xe92e0e95}, {0x87840849,0x5c24}, {0x87840b81,0xe92e6ab9},
   {0x787bfaef,0xe92db270}, {0x87840b81,0xe92e0e95}, {0x787bfaef,0xe92e0e94},
 {0x622d,0x66f03313}, {0x6c21,0xf94150f9}, {0xce4e,0x6031840c},
   {0xfffff60c,0x6daee219}, {0xce4e,0x66f03313}, {0xfffff60c,0x66f03312},
 {0x2cee568e,0x63e2}, {0xa44e2c4d,0x3cb8}, {0xd13c82db,0xa09a},
   {0x88a02a41,0x2729}, {0xd13c82db,0x63e2}, {0x88a02a41,0x63e1},
 {0x518b221d,0xa2e37b93}, {0x369c2bd8,0x5baa2098}, {0x88274df5,0xfe8d9c2b},
   {0x1aeef645,0x47395afb}, {0x88274df5,0xa2e37b93}, {0x1aeef645,0xa2e37b93},
 {0xb2215a60,0x46ac}, {0x58f9,0x7762}, {0xb221b359,0xbe0e},
   {0xb2210167,0xffffcf4a}, {0xb221b359,0x46ac}, {0xb2210167,0x46ac},
 {0xb0e38ba5,0x6674}, {0x4c25,0xe2a49814}, {0xb0e3d7ca,0xe2a4fe88},
   {0xb0e33f80,0x1d5bce60}, {0xb0e3d7ca,0x6674}, {0xb0e33f80,0x6674},
 {0xff,0x2e2ead90}, {0x30e4,0x6c2e6320}, {0x31e3,0x9a5d10b0},
   {0xffffd01b,0xc2004a6f}, {0x31e3,0x2e2ead90}, {0xffffd01b,0x2e2ead8f},
 {0x975cf478,0x17aff59}, {0xd89f73d0,0x53a1}, {0x6ffc6848,0x17b52fb},
   {0xbebd80a8,0x17aabb7}, {0x6ffc6848,0x17aff5a}, {0xbebd80a8,0x17aff58},
 {0x57ef2493,0x4365}, {0xb2acdc13,0x2a26}, {0xa9c00a6,0x6d8c},
   {0xa5424880,0x193e}, {0xa9c00a6,0x4366}, {0xa5424880,0x4364},
 {0x85eceb39,0xe901be2a}, {0x2f7aab7f,0x60b0}, {0xb56796b8,0xe9021eda},
   {0x56723fba,0xe9015d7a}, {0xb56796b8,0xe901be2a}, {0x56723fba,0xe901be2a},
 {0x7f69,0x8156fd96}, {0x658bb831,0x4eb7}, {0x658c379a,0x81574c4d},
   {0x9a74c738,0x8156aede}, {0x658c379a,0x8156fd96}, {0x9a74c738,0x8156fd95},
 {0xb999a756,0x8f20752d}, {0x8d386d17,0x8182f261}, {0x46d2146d,0x10a3678f},
   {0x2c613a3f,0xd9d82cc}, {0x46d2146d,0x8f20752e}, {0x2c613a3f,0x8f20752d},
 {0x3e66,0x8044639}, {0x6fd024e9,0x346d47a6}, {0x6fd0634f,0x3c718ddf},
   {0x9030197d,0xd396fe92}, {0x6fd0634f,0x8044639}, {0x9030197d,0x8044638},
 {0x29bf,0xbe752567}, {0x36c32cb1,0x2c635736}, {0x36c35670,0xead87c9d},
   {0xc93cfd0e,0x9211ce30}, {0x36c35670,0xbe752567}, {0xc93cfd0e,0xbe752566},
 {0x37aa,0xdb0ce62e}, {0x3db6,0x27f2}, {0x7560,0xdb0d0e20},
   {0xfffff9f4,0xdb0cbe3b}, {0x7560,0xdb0ce62e}, {0xfffff9f4,0xdb0ce62d},
 {0xafc21667,0x3227}, {0x25089f82,0x6363}, {0xd4cab5e9,0x958a},
   {0x8ab976e5,0xffffcec4}, {0xd4cab5e9,0x3227}, {0x8ab976e5,0x3227},
 {0x5d65,0xd92ebdd}, {0x49ae,0x2660}, {0xa713,0xd93123d},
   {0x13b7,0xd92c57d}, {0xa713,0xd92ebdd}, {0x13b7,0xd92ebdd},
 {0xfa8,0x8dbff966}, {0x1ca5,0x1de6}, {0x2c4d,0x8dc0174c},
   {0xfffff303,0x8dbfdb7f}, {0x2c4d,0x8dbff966}, {0xfffff303,0x8dbff965},
 {0x7f25,0xff73ee16}, {0x1230,0x8b07b02d}, {0x9155,0x8a7b9e43},
   {0x6cf5,0x746c3de9}, {0x9155,0xff73ee16}, {0x6cf5,0xff73ee16},
 {0x637,0x9d14620}, {0xeb2972c2,0x123c}, {0xeb2978f9,0x9d1585c},
   {0x14d69375,0x9d133e3}, {0xeb2978f9,0x9d14620}, {0x14d69375,0x9d1461f},
 {0x57e2f016,0x462a}, {0xe3834f6f,0x223d}, {0x3b663f85,0x6868},
   {0x745fa0a7,0x23ec}, {0x3b663f85,0x462b}, {0x745fa0a7,0x4629},
 {0x1082b279,0x359c1903}, {0x51be6bc0,0xd66}, {0x62411e39,0x359c2669},
   {0xbec446b9,0x359c0b9c}, {0x62411e39,0x359c1903}, {0xbec446b9,0x359c1902},
 {0x1736,0xaac4f4d8}, {0x90b66d34,0x6815c0a4}, {0x90b6846a,0x12dab57c},
   {0x6f49aa02,0x42af3433}, {0x90b6846a,0xaac4f4d8}, {0x6f49aa02,0xaac4f4d7},
 {0x2264,0x5f7f}, {0x3519e533,0x883c4908}, {0x351a0797,0x883ca887},
   {0xcae63d31,0x77c41676}, {0x351a0797,0x5f7f}, {0xcae63d31,0x5f7e},
 {0x2578,0x39e0}, {0x8710c299,0x36287fec}, {0x8710e811,0x3628b9cc},
   {0x78ef62df,0xc9d7b9f3}, {0x8710e811,0x39e0}, {0x78ef62df,0x39df},
 {0xda3c6560,0x29166d70}, {0xbe8,0xe1517ba}, {0xda3c7148,0x372b852a},
   {0xda3c5978,0x1b0155b6}, {0xda3c7148,0x29166d70}, {0xda3c5978,0x29166d70},
 {0x44f0,0x16f}, {0xf5bc8093,0xa63823fc}, {0xf5bcc583,0xa638256b},
   {0xa43c45d,0x59c7dd72}, {0xf5bcc583,0x16f}, {0xa43c45d,0x16e},
 {0xad259906,0x7cf2}, {0xe2f14369,0x73d201be}, {0x9016dc6f,0x73d27eb1},
   {0xca34559d,0x8c2e7b33}, {0x9016dc6f,0x7cf3}, {0xca34559d,0x7cf1},
 {0x5327,0x67b0}, {0x39a4,0x1d65}, {0x8ccb,0x8515},
   {0x1983,0x4a4b}, {0x8ccb,0x67b0}, {0x1983,0x67b0},
 {0x53cfd7d9,0x70ab}, {0x4d6c,0x66c4a92}, {0x53d02545,0x66cbb3d},
   {0x53cf8a6d,0xf9942619}, {0x53d02545,0x70ab}, {0x53cf8a6d,0x70ab},
 {0x52f6,0x69eec924}, {0x23f7,0x7e6f}, {0x76ed,0x69ef4793},
   {0x2eff,0x69ee4ab5}, {0x76ed,0x69eec924}, {0x2eff,0x69eec924},
 {0x5077,0x4722}, {0xdb1,0x56ab}, {0x5e28,0x9dcd},
   {0x42c6,0xfffff077}, {0x5e28,0x4722}, {0x42c6,0x4722},
 {0x1de5,0x7069dad0}, {0xf8ffb33c,0x5fef}, {0xf8ffd121,0x706a3abf},
   {0x7006aa9,0x70697ae0}, {0xf8ffd121,0x7069dad0}, {0x7006aa9,0x7069dacf},
 {0x48ad,0x2a74}, {0xb040ceec,0x5037181a}, {0xb0411799,0x5037428e},
   {0x4fbf79c1,0xafc91259}, {0xb0411799,0x2a74}, {0x4fbf79c1,0x2a73},
 {0x3a71,0xf535da0e}, {0xdcf64073,0x7a4435b0}, {0xdcf67ae4,0x6f7a0fbe},
   {0x2309f9fe,0x7af1a45d}, {0xdcf67ae4,0xf535da0e}, {0x2309f9fe,0xf535da0d},
 {0x719ca3db,0x83ca595a}, {0x9e7afddf,0x5e9}, {0x1017a1ba,0x83ca5f44},
   {0xd321a5fc,0x83ca5370}, {0x1017a1ba,0x83ca595b}, {0xd321a5fc,0x83ca5959},
 {0x8dba9c3c,0x8a05d1d3}, {0x74ef,0x4b79}, {0x8dbb112b,0x8a061d4c},
   {0x8dba274d,0x8a05865a}, {0x8dbb112b,0x8a05d1d3}, {0x8dba274d,0x8a05d1d3},
 {0x56f1275b,0x9f4336c2}, {0xd1b16051,0x38ad}, {0x28a287ac,0x9f436f70},
   {0x853fc70a,0x9f42fe14}, {0x28a287ac,0x9f4336c3}, {0x853fc70a,0x9f4336c1},
 {0xa7bf13cd,0x4e20}, {0x353c,0xff0}, {0xa7bf4909,0x5e10},
   {0xa7bede91,0x3e30}, {0xa7bf4909,0x4e20}, {0xa7bede91,0x4e20},
 {0x3864,0x6ee3}, {0xb3ce71d2,0x27fb}, {0xb3ceaa36,0x96de},
   {0x4c31c692,0x46e7}, {0xb3ceaa36,0x6ee3}, {0x4c31c692,0x6ee2},
 {0x1764,0xe1c5503b}, {0x43f1,0xa5fef06d}, {0x5b55,0x87c440a8},
   {0xffffd373,0x3bc65fcd}, {0x5b55,0xe1c5503b}, {0xffffd373,0xe1c5503a},
 {0x78b1,0x7db21af0}, {0x736f,0x8e4}, {0xec20,0x7db223d4},
   {0x542,0x7db2120c}, {0xec20,0x7db21af0}, {0x542,0x7db21af0},
 {0x272b,0x45a732ad}, {0xe528323a,0x2c3a}, {0xe5285965,0x45a75ee7},
   {0x1ad7f4f1,0x45a70672}, {0xe5285965,0x45a732ad}, {0x1ad7f4f1,0x45a732ac},
 {0x1e1ec540,0x816d38af}, {0x6aeda675,0x73a5}, {0x890c6bb5,0x816dac54},
   {0xb3311ecb,0x816cc509}, {0x890c6bb5,0x816d38af}, {0xb3311ecb,0x816d38ae},
 {0x7eb0,0x58f4}, {0x47cb57fe,0xba963048}, {0x47cbd6ae,0xba96893c},
   {0xb83526b2,0x456a28ab}, {0x47cbd6ae,0x58f4}, {0xb83526b2,0x58f3},
 {0x7639,0x67c37a50}, {0x8b029d10,0x2e23}, {0x8b031349,0x67c3a873},
   {0x74fdd929,0x67c34c2c}, {0x8b031349,0x67c37a50}, {0x74fdd929,0x67c37a4f},
 {0x43cd9787,0x663b}, {0xd15d565b,0x3c10965c}, {0x152aede2,0x3c10fc98},
   {0x7270412c,0xc3efcfde}, {0x152aede2,0x663c}, {0x7270412c,0x663a},
 {0x1e7d,0xe6a93721}, {0x46eb3eeb,0x1b37}, {0x46eb5d68,0xe6a95258},
   {0xb914df92,0xe6a91be9}, {0x46eb5d68,0xe6a93721}, {0xb914df92,0xe6a93720},
 {0x196c05b1,0x79b8}, {0x7f4015a2,0x7d2d}, {0x98ac1b53,0xf6e5},
   {0x9a2bf00f,0xfffffc8a}, {0x98ac1b53,0x79b8}, {0x9a2bf00f,0x79b7},
 {0x9b471e03,0xe7ff305f}, {0x2779,0x2be8ab1f}, {0x9b47457c,0x13e7db7e},
   {0x9b46f68a,0xbc168540}, {0x9b47457c,0xe7ff305f}, {0x9b46f68a,0xe7ff305f},
 {0x5874,0x7bab}, {0xddafe2d4,0x1dfe}, {0xddb03b48,0x99a9},
   {0x225075a0,0x5dac}, {0xddb03b48,0x7bab}, {0x225075a0,0x7baa},
 {0x56e2,0x67b2}, {0xe36,0xd6c}, {0x6518,0x751e},
   {0x48ac,0x5a46}, {0x6518,0x67b2}, {0x48ac,0x67b2},
 {0x283c,0x423c}, {0xfb6406f7,0x742f5cfb}, {0xfb642f33,0x742f9f37},
   {0x49c2145,0x8bd0e540}, {0xfb642f33,0x423c}, {0x49c2145,0x423b},
 {0xa861f2af,0x3ac48a9}, {0xd32c7fb7,0x3f07e67b}, {0x7b8e7266,0x42b42f25},
   {0xd53572f8,0xc4a4622d}, {0x7b8e7266,0x3ac48aa}, {0xd53572f8,0x3ac48a8},
 {0x920fb55c,0x19221e3e}, {0xfc9c6dc2,0x4b7c}, {0x8eac231e,0x192269bb},
   {0x9573479a,0x1921d2c1}, {0x8eac231e,0x19221e3f}, {0x9573479a,0x19221e3d},
 {0x3946124b,0x2027}, {0x5df28cdf,0x3875}, {0x97389f2a,0x589c},
   {0xdb53856c,0xffffe7b1}, {0x97389f2a,0x2027}, {0xdb53856c,0x2026},
 {0x3ec64952,0xef443a9a}, {0x6f79,0x692d}, {0x3ec6b8cb,0xef44a3c7},
   {0x3ec5d9d9,0xef43d16d}, {0x3ec6b8cb,0xef443a9a}, {0x3ec5d9d9,0xef443a9a},
 {0x96df1611,0xf36196c1}, {0x521e7f6a,0x51a3}, {0xe8fd957b,0xf361e864},
   {0x44c096a7,0xf361451e}, {0xe8fd957b,0xf36196c1}, {0x44c096a7,0xf36196c1},
 {0x367,0x1038}, {0x5a72,0x49bd}, {0x5dd9,0x59f5},
   {0xffffa8f5,0xffffc67a}, {0x5dd9,0x1038}, {0xffffa8f5,0x1037},
 {0xd409335e,0xc323cf76}, {0xec0b99ac,0x7acd4e86}, {0xc014cd0a,0x3df11dfd},
   {0xe7fd99b2,0x485680ef}, {0xc014cd0a,0xc323cf77}, {0xe7fd99b2,0xc323cf75},
 {0x39b5,0x4ef8}, {0x7c5706db,0x56864b4}, {0x7c574090,0x568b3ac},
   {0x83a932da,0xfa97ea43}, {0x7c574090,0x4ef8}, {0x83a932da,0x4ef7},
 {0xff538fd2,0x11d76a2b}, {0xd17df8e0,0x27976221}, {0xd0d188b2,0x396ecc4d},
   {0x2dd596f2,0xea40080a}, {0xd0d188b2,0x11d76a2c}, {0x2dd596f2,0x11d76a2b},
 {0x285290fe,0x29bf}, {0x1fdd7e16,0x312d}, {0x48300f14,0x5aec},
   {0x87512e8,0xfffff892}, {0x48300f14,0x29bf}, {0x87512e8,0x29bf},
 {0xbc2aa214,0x562aaa05}, {0xcaae0ff3,0x2765e2fa}, {0x86d8b207,0x7d908d00},
   {0xf17c9221,0x2ec4c70a}, {0x86d8b207,0x562aaa06}, {0xf17c9221,0x562aaa04},
 {0x5fa0,0xe5921e09}, {0x2b547d2d,0xe8815b05}, {0x2b54dccd,0xce13790e},
   {0xd4abe273,0xfd10c303}, {0x2b54dccd,0xe5921e09}, {0xd4abe273,0xe5921e08},
 {0x3339,0x3be0}, {0xc3f19940,0x1030}, {0xc3f1cc79,0x4c10},
   {0x3c0e99f9,0x2baf}, {0xc3f1cc79,0x3be0}, {0x3c0e99f9,0x3bdf},
 {0x4faf,0x618c4777}, {0x3db4,0x4570}, {0x8d63,0x618c8ce7},
   {0x11fb,0x618c0207}, {0x8d63,0x618c4777}, {0x11fb,0x618c4777},
 {0xb773701d,0x2671}, {0x7034,0x5922}, {0xb773e051,0x7f93},
   {0xb772ffe9,0xffffcd4f}, {0xb773e051,0x2671}, {0xb772ffe9,0x2671},
 {0x7f2d,0xf130860a}, {0xaf5a07d,0x5bd0a7de}, {0xaf61faa,0x4d012de8},
   {0xf50adeb0,0x955fde2b}, {0xaf61faa,0xf130860a}, {0xf50adeb0,0xf1308609},
 {0x66b6,0x54e8}, {0x1dfc,0x2224}, {0x84b2,0x770c},
   {0x48ba,0x32c4}, {0x84b2,0x54e8}, {0x48ba,0x54e8},
 {0x7234,0x5ca2}, {0x4966,0x5ef5294}, {0xbb9a,0x5efaf36},
   {0x28ce,0xfa110a0e}, {0xbb9a,0x5ca2}, {0x28ce,0x5ca2},
 {0x765e500b,0x3070fb99}, {0x53bf,0x8125793a}, {0x765ea3ca,0xb19674d3},
   {0x765dfc4c,0xaf4b825f}, {0x765ea3ca,0x3070fb99}, {0x765dfc4c,0x3070fb99},
 {0x316c,0x4e38eaed}, {0x4ae5,0x5910ad50}, {0x7c51,0xa749983d},
   {0xffffe687,0xf5283d9c}, {0x7c51,0x4e38eaed}, {0xffffe687,0x4e38eaec},
 {0xbed0f0ea,0xb1c0dbe5}, {0x2cdbe2ed,0xa0fdca15}, {0xebacd3d7,0x52bea5fa},
   {0x91f50dfd,0x10c311d0}, {0xebacd3d7,0xb1c0dbe5}, {0x91f50dfd,0xb1c0dbe5},
 {0x2f2a,0x5b6e}, {0x36f8,0xc98794e}, {0x6622,0xc98d4bc},
   {0xfffff832,0xf367e21f}, {0x6622,0x5b6e}, {0xfffff832,0x5b6d},
 {0x14beb4c5,0x71ff8214}, {0x4273,0x31c952ba}, {0x14bef738,0xa3c8d4ce},
   {0x14be7252,0x40362f5a}, {0x14bef738,0x71ff8214}, {0x14be7252,0x71ff8214},
 {0xe2eb469e,0x79c9fca1}, {0x4e3f,0xe8499f8c}, {0xe2eb94dd,0x62139c2d},
   {0xe2eaf85f,0x91805d15}, {0xe2eb94dd,0x79c9fca1}, {0xe2eaf85f,0x79c9fca1},
 {0x563,0x2fe1}, {0x11f7,0x5371}, {0x175a,0x8352},
   {0xfffff36c,0xffffdc6f}, {0x175a,0x2fe1}, {0xfffff36c,0x2fe0},
 {0x450dee6d,0x121483d3}, {0x1db9,0xb35ba39a}, {0x450e0c26,0xc570276d},
   {0x450dd0b4,0x5eb8e039}, {0x450e0c26,0x121483d3}, {0x450dd0b4,0x121483d3},
 {0xf6f94a22,0x2dea}, {0x69fa,0x19f4}, {0xf6f9b41c,0x47de},
   {0xf6f8e028,0x13f6}, {0xf6f9b41c,0x2dea}, {0xf6f8e028,0x2dea},
 {0x6070,0x2ac9b99e}, {0x2d3f,0x3ca6}, {0x8daf,0x2ac9f644},
   {0x3331,0x2ac97cf8}, {0x8daf,0x2ac9b99e}, {0x3331,0x2ac9b99e},
 {0x3d061fc9,0x57b1}, {0x1ee4,0x40843891}, {0x3d063ead,0x40849042},
   {0x3d0600e5,0xbf7c1f20}, {0x3d063ead,0x57b1}, {0x3d0600e5,0x57b1},
 {0x5487fefc,0x607c}, {0x7f79,0x202b}, {0x54887e75,0x80a7},
   {0x54877f83,0x4051}, {0x54887e75,0x607c}, {0x54877f83,0x607c},
 {0x653007e1,0xccb3310d}, {0xd366aa8a,0x7f36}, {0x3896b26b,0xccb3b044},
   {0x91c95d57,0xccb2b1d6}, {0x3896b26b,0xccb3310e}, {0x91c95d57,0xccb3310c},
 {0x4dec396,0x1d76}, {0xf7316144,0x839408bc}, {0xfc1024da,0x83942632},
   {0xdad6252,0x7c6c14b9}, {0xfc1024da,0x1d76}, {0xdad6252,0x1d75},
 {0x44450863,0x194364b}, {0x2b26,0x496d}, {0x44453389,0x1947fb8},
   {0x4444dd3d,0x193ecde}, {0x44453389,0x194364b}, {0x4444dd3d,0x194364b},
 {0x4aa9,0x3d60}, {0x9f7,0x4fa3}, {0x54a0,0x8d03},
   {0x40b2,0xffffedbd}, {0x54a0,0x3d60}, {0x40b2,0x3d60},
 {0xbd73c821,0x5460}, {0xc476d8be,0x32}, {0x81eaa0df,0x5493},
   {0xf8fcef63,0x542d}, {0x81eaa0df,0x5461}, {0xf8fcef63,0x545f},
 {0xfe2d8e01,0x69b5}, {0x6d94aeeb,0x888602c7}, {0x6bc23cec,0x88866c7d},
   {0x9098df16,0x777a66ee}, {0x6bc23cec,0x69b6}, {0x9098df16,0x69b5},
 {0x12f9,0xbd3a5c8d}, {0x2c8089ab,0xd6c}, {0x2c809ca4,0xbd3a69f9},
   {0xd37f894e,0xbd3a4f20}, {0x2c809ca4,0xbd3a5c8d}, {0xd37f894e,0xbd3a5c8c},
 {0xbc4665c0,0x4f2f}, {0x5f74,0x1ea9}, {0xbc46c534,0x6dd8},
   {0xbc46064c,0x3086}, {0xbc46c534,0x4f2f}, {0xbc46064c,0x4f2f},
 {0x5a9dd773,0x65ad}, {0x877d6c74,0x15ae}, {0xe21b43e7,0x7b5b},
   {0xd3206aff,0x4ffe}, {0xe21b43e7,0x65ad}, {0xd3206aff,0x65ac},
 {0x253b0f09,0x64f8}, {0x3aa39c01,0xf2ddaf23}, {0x5fdeab0a,0xf2de141b},
   {0xea977308,0xd22b5d4}, {0x5fdeab0a,0x64f8}, {0xea977308,0x64f7},
 {0xc8e6e94b,0xf64}, {0x280df412,0x9eb74ca}, {0xf0f4dd5d,0x9eb842e},
   {0xa0d8f539,0xf6149a9a}, {0xf0f4dd5d,0xf64}, {0xa0d8f539,0xf64},
 {0x2b553b88,0xb2231167}, {0x5e4b48eb,0x71bd}, {0x89a08473,0xb2238324},
   {0xcd09f29d,0xb2229fa9}, {0x89a08473,0xb2231167}, {0xcd09f29d,0xb2231166},
 {0x73e5316e,0x21ecabfb}, {0x6976,0x6a3}, {0x73e59ae4,0x21ecb29e},
   {0x73e4c7f8,0x21eca558}, {0x73e59ae4,0x21ecabfb}, {0x73e4c7f8,0x21ecabfb},
 {0x3709dd7e,0x8cd914a4}, {0x4c2849c,0xe6e}, {0x3bcc621a,0x8cd92312},
   {0x324758e2,0x8cd90636}, {0x3bcc621a,0x8cd914a4}, {0x324758e2,0x8cd914a4},
 {0x1da3,0x74e904c9}, {0xfb0ecdf,0x5e75}, {0xfb10a82,0x74e9633e},
   {0xf04f30c4,0x74e8a653}, {0xfb10a82,0x74e904c9}, {0xf04f30c4,0x74e904c8},
 {0x6f3c,0x16ff}, {0x945687b9,0xdbbb9789}, {0x9456f6f5,0xdbbbae88},
   {0x6ba9e783,0x24447f75}, {0x9456f6f5,0x16ff}, {0x6ba9e783,0x16fe},
 {0x2f2a,0x90e711cc}, {0x3868,0x7269}, {0x6792,0x90e78435},
   {0xfffff6c2,0x90e69f62}, {0x6792,0x90e711cc}, {0xfffff6c2,0x90e711cb},
 {0x29f7,0x6d2d}, {0x4bebc324,0x1b77}, {0x4bebed1b,0x88a4},
   {0xb41466d3,0x51b5}, {0x4bebed1b,0x6d2d}, {0xb41466d3,0x6d2c},
 {0x43b0,0xd998c75f}, {0x2a2a,0x335785c}, {0x6dda,0xdcce3fbb},
   {0x1986,0xd6634f03}, {0x6dda,0xd998c75f}, {0x1986,0xd998c75f},
 {0x49b7,0xb7f464aa}, {0x8cb5b2aa,0x84736db0}, {0x8cb5fc61,0x3c67d25a},
   {0x734a970d,0x3380f6f9}, {0x8cb5fc61,0xb7f464aa}, {0x734a970d,0xb7f464a9},
 {0x7078,0x53f2}, {0x713d,0x2daa}, {0xe1b5,0x819c},
   {0xffffff3b,0x2647}, {0xe1b5,0x53f2}, {0xffffff3b,0x53f1},
 {0x3ab,0x2db1}, {0x17bf,0x2629}, {0x1b6a,0x53da},
   {0xffffebec,0x787}, {0x1b6a,0x2db1}, {0xffffebec,0x2db0},
 {0x3f37,0x2535c014}, {0x6b38,0x727d}, {0xaa6f,0x25363291},
   {0xffffd3ff,0x25354d96}, {0xaa6f,0x2535c014}, {0xffffd3ff,0x2535c013},
 {0x66b3,0x5273}, {0x632b,0x7c359ef5}, {0xc9de,0x7c35f168},
   {0x388,0x83cab37e}, {0xc9de,0x5273}, {0x388,0x5273},
 {0xf979caa7,0x537a4688}, {0x44bb,0x1b72ea1b}, {0xf97a0f62,0x6eed30a3},
   {0xf97985ec,0x38075c6d}, {0xf97a0f62,0x537a4688}, {0xf97985ec,0x537a4688},
 {0x1a29,0xc9dc4f50}, {0x64b4,0x1227}, {0x7edd,0xc9dc6177},
   {0xffffb575,0xc9dc3d28}, {0x7edd,0xc9dc4f50}, {0xffffb575,0xc9dc4f4f},
 {0x9a4417da,0x55a8d9f4}, {0x9e4b41de,0x6fa340ee}, {0x388f59b8,0xc54c1ae3},
   {0xfbf8d5fc,0xe6059905}, {0x388f59b8,0x55a8d9f5}, {0xfbf8d5fc,0x55a8d9f3},
 {0xf20e20ee,0x9daa98d6}, {0x4ff9df2a,0x793d}, {0x42080018,0x9dab1214},
   {0xa21441c4,0x9daa1f99}, {0x42080018,0x9daa98d7}, {0xa21441c4,0x9daa98d6},
 {0x6c67,0x8ff8ebbd}, {0x2c2824fa,0x3d3a9ed}, {0x2c289161,0x93cc95aa},
   {0xd3d8476d,0x8c2541cf}, {0x2c289161,0x8ff8ebbd}, {0xd3d8476d,0x8ff8ebbc},
 {0xe26abc3a,0x1eb9}, {0x1ba7,0x3c71}, {0xe26ad7e1,0x5b2a},
   {0xe26aa093,0xffffe248}, {0xe26ad7e1,0x1eb9}, {0xe26aa093,0x1eb9},
 {0xeddd3a26,0x2bd0c0fe}, {0xe2b579de,0x55b673b9}, {0xd092b404,0x818734b8},
   {0xb27c048,0xd61a4d45}, {0xd092b404,0x2bd0c0ff}, {0xb27c048,0x2bd0c0fe},
 {0x51bb62a4,0xe6ee8dfc}, {0x6ca19011,0x43bcc2ae}, {0xbe5cf2b5,0x2aab50aa},
   {0xe519d293,0xa331cb4d}, {0xbe5cf2b5,0xe6ee8dfc}, {0xe519d293,0xe6ee8dfb},
 {0xfbd06f6a,0x5377}, {0xc01dd369,0xe6f40d5d}, {0xbbee42d3,0xe6f460d5},
   {0x3bb29c01,0x190c461a}, {0xbbee42d3,0x5378}, {0x3bb29c01,0x5377},
 {0xdbe,0x51c59d6a}, {0x326a,0x34ea}, {0x4028,0x51c5d254},
   {0xffffdb54,0x51c5687f}, {0x4028,0x51c59d6a}, {0xffffdb54,0x51c59d69},
 {0x874cb814,0x76b54a52}, {0x113b,0x6ee2}, {0x874cc94f,0x76b5b934},
   {0x874ca6d9,0x76b4db70}, {0x874cc94f,0x76b54a52}, {0x874ca6d9,0x76b54a52},
 {0x5f77,0x9ff7793d}, {0x30ac,0x6e38}, {0x9023,0x9ff7e775},
   {0x2ecb,0x9ff70b05}, {0x9023,0x9ff7793d}, {0x2ecb,0x9ff7793d},
 {0x66e9f45e,0x74e3}, {0xc61e0100,0x7bc24ece}, {0x2d07f55e,0x7bc2c3b2},
   {0xa0cbf35e,0x843e2614}, {0x2d07f55e,0x74e4}, {0xa0cbf35e,0x74e2},
 {0x5b566f1,0x92165ae2}, {0x37b1,0x7ea7}, {0x5b59ea2,0x9216d989},
   {0x5b52f40,0x9215dc3b}, {0x5b59ea2,0x92165ae2}, {0x5b52f40,0x92165ae2},
 {0xa44135b4,0x6f24}, {0x723f,0x29f3}, {0xa441a7f3,0x9917},
   {0xa440c375,0x4531}, {0xa441a7f3,0x6f24}, {0xa440c375,0x6f24},
 {0x9ae,0x8af571c7}, {0x4169aa1,0x3862}, {0x416a44f,0x8af5aa29},
   {0xfbe96f0d,0x8af53964}, {0x416a44f,0x8af571c7}, {0xfbe96f0d,0x8af571c6},
 {0x2d60,0x1fbb}, {0xf96a0bd9,0x58b7}, {0xf96a3939,0x7872},
   {0x6962187,0xffffc703}, {0xf96a3939,0x1fbb}, {0x6962187,0x1fba},
 {0xe71469ab,0xe03a663b}, {0x5caf,0x3631}, {0xe714c65a,0xe03a9c6c},
   {0xe7140cfc,0xe03a300a}, {0xe714c65a,0xe03a663b}, {0xe7140cfc,0xe03a663b},
 {0x1b79,0x33d02781}, {0x78b8,0xe26e059c}, {0x9431,0x163e2d1d},
   {0xffffa2c1,0x516221e4}, {0x9431,0x33d02781}, {0xffffa2c1,0x33d02780},
 {0x4a5,0x483a2a7c}, {0x287c,0x35d86ec2}, {0x2d21,0x7e12993e},
   {0xffffdc29,0x1261bbb9}, {0x2d21,0x483a2a7c}, {0xffffdc29,0x483a2a7b},
 {0x3f69ea53,0x302e}, {0x1f35,0x412e}, {0x3f6a0988,0x715c},
   {0x3f69cb1e,0xffffef00}, {0x3f6a0988,0x302e}, {0x3f69cb1e,0x302e},
 {0x27989926,0x5a43bcfe}, {0xe780bf91,0x4770}, {0xf1958b7,0x5a44046f},
   {0x4017d995,0x5a43758d}, {0xf1958b7,0x5a43bcff}, {0x4017d995,0x5a43bcfd},
 {0xf8da0fbd,0x4d488d50}, {0xe52dec53,0x5b6d}, {0xde07fc10,0x4d48e8be},
   {0x13ac236a,0x4d4831e3}, {0xde07fc10,0x4d488d51}, {0x13ac236a,0x4d488d50},
 {0x73975a6f,0x6ebf}, {0x10b47fc5,0x6dad20c3}, {0x844bda34,0x6dad8f82},
   {0x62e2daaa,0x92534dfc}, {0x844bda34,0x6ebf}, {0x62e2daaa,0x6ebf},
 {0xd7082e26,0xb72f46b5}, {0x323c,0x1aff}, {0xd7086062,0xb72f61b4},
   {0xd707fbea,0xb72f2bb6}, {0xd7086062,0xb72f46b5}, {0xd707fbea,0xb72f46b5},
 {0x3435,0x74ab}, {0x24f3c9f3,0x53f2}, {0x24f3fe28,0xc89d},
   {0xdb0c6a42,0x20b8}, {0x24f3fe28,0x74ab}, {0xdb0c6a42,0x74aa},
 {0x405d67bd,0x23f6}, {0xdf5d2ced,0x35b4}, {0x1fba94aa,0x59ab},
   {0x61003ad0,0xffffee41}, {0x1fba94aa,0x23f7}, {0x61003ad0,0x23f5},
 {0xa11d8406,0x5eed}, {0x8551a28a,0xa57759b9}, {0x266f2690,0xa577b8a7},
   {0x1bcbe17c,0x5a890534}, {0x266f2690,0x5eee}, {0x1bcbe17c,0x5eed},
 {0x2b35,0x3fb9}, {0x442e,0xf2beda09}, {0x6f63,0xf2bf19c2},
   {0xffffe707,0xd4165af}, {0x6f63,0x3fb9}, {0xffffe707,0x3fb8},
 {0xbd00c98f,0x9295da7a}, {0x1da1,0x29e6a665}, {0xbd00e730,0xbc7c80df},
   {0xbd00abee,0x68af3415}, {0xbd00e730,0x9295da7a}, {0xbd00abee,0x9295da7a},
 {0x6829,0x84b8a9ae}, {0x5abd,0x2f2a}, {0xc2e6,0x84b8d8d8},
   {0xd6c,0x84b87a84}, {0xc2e6,0x84b8a9ae}, {0xd6c,0x84b8a9ae},
 {0x566e,0x4125}, {0x385177b,0x3036}, {0x3856de9,0x715b},
   {0xfc7b3ef3,0x10ee}, {0x3856de9,0x4125}, {0xfc7b3ef3,0x4124},
 {0xab589e96,0xc0f4b41a}, {0x574ab042,0xdae38399}, {0x2a34ed8,0x9bd837b4},
   {0x540dee54,0xe6113081}, {0x2a34ed8,0xc0f4b41b}, {0x540dee54,0xc0f4b41a},
 {0x86864b20,0x4250ecf9}, {0xd0fe6e70,0x3c2ed601}, {0x5784b990,0x7e7fc2fb},
   {0xb587dcb0,0x62216f7}, {0x5784b990,0x4250ecfa}, {0xb587dcb0,0x4250ecf8},
 {0x361f6067,0x5c5894c0}, {0xd4868916,0x16434e92}, {0xaa5e97d,0x729be353},
   {0x6198d751,0x4615462d}, {0xaa5e97d,0x5c5894c1}, {0x6198d751,0x5c5894bf},
 {0xf4a89191,0x1dc1d272}, {0x17752d1b,0x317b}, {0xc1dbeac,0x1dc203ee},
   {0xdd336476,0x1dc1a0f7}, {0xc1dbeac,0x1dc1d273}, {0xdd336476,0x1dc1d272},
 {0x56a5,0xa35}, {0xa714ab1c,0x7caa}, {0xa71501c1,0x86df},
   {0x58ebab89,0xffff8d8a}, {0xa71501c1,0xa35}, {0x58ebab89,0xa34},
 {0x3ffb,0xfbad6639}, {0x1279,0x116e}, {0x5274,0xfbad77a7},
   {0x2d82,0xfbad54cb}, {0x5274,0xfbad6639}, {0x2d82,0xfbad6639},
 {0xb44b992c,0x13ec}, {0x2ac,0x643192b6}, {0xb44b9bd8,0x6431a6a2},
   {0xb44b9680,0x9bce8136}, {0xb44b9bd8,0x13ec}, {0xb44b9680,0x13ec},
 {0xe3292b7d,0x41e6}, {0x5c8d6f8d,0x6632}, {0x3fb69b0a,0xa819},
   {0x869bbbf0,0xffffdbb4}, {0x3fb69b0a,0x41e7}, {0x869bbbf0,0x41e6},
 {0x6e21c9f4,0x37fb}, {0x424d013d,0x63b5}, {0xb06ecb31,0x9bb0},
   {0x2bd4c8b7,0xffffd446}, {0xb06ecb31,0x37fb}, {0x2bd4c8b7,0x37fb},
 {0x1b16e36,0xde5}, {0x52fc4f1f,0x3a33}, {0x54adbd55,0x4818},
   {0xaeb51f17,0xffffd3b1}, {0x54adbd55,0xde5}, {0xaeb51f17,0xde4},
 {0x7c26,0x1bbf}, {0xbc218100,0x2c34}, {0xbc21fd26,0x47f3},
   {0x43defb26,0xffffef8a}, {0xbc21fd26,0x1bbf}, {0x43defb26,0x1bbe},
 {0x81027d94,0x366a}, {0x736e,0x1a68}, {0x8102f102,0x50d2},
   {0x81020a26,0x1c02}, {0x8102f102,0x366a}, {0x81020a26,0x366a},
 {0x382e,0xd548fd7e}, {0x257f,0x13bf}, {0x5dad,0xd549113d},
   {0x12af,0xd548e9bf}, {0x5dad,0xd548fd7e}, {0x12af,0xd548fd7e},
 {0x2ae1,0x37e0}, {0x50486279,0xbf983bd0}, {0x50488d5a,0xbf9873b0},
   {0xafb7c868,0x4067fc0f}, {0x50488d5a,0x37e0}, {0xafb7c868,0x37df},
 {0xf9efaedd,0x4f16b1a3}, {0x3e69,0x6a67}, {0xf9efed46,0x4f171c0a},
   {0xf9ef7074,0x4f16473c}, {0xf9efed46,0x4f16b1a3}, {0xf9ef7074,0x4f16b1a3},
 {0x8a917b5a,0xbbc44aaa}, {0xf01907a2,0x7e72}, {0x7aaa82fc,0xbbc4c91d},
   {0x9a7873b8,0xbbc3cc37}, {0x7aaa82fc,0xbbc44aab}, {0x9a7873b8,0xbbc44aa9},
 {0x426a1a64,0x1f22}, {0x68ac,0x13a}, {0x426a8310,0x205c},
   {0x4269b1b8,0x1de8}, {0x426a8310,0x1f22}, {0x4269b1b8,0x1f22},
 {0xe30138d8,0xb20}, {0x26e6,0x1c72}, {0xe3015fbe,0x2792},
   {0xe30111f2,0xffffeeae}, {0xe3015fbe,0xb20}, {0xe30111f2,0xb20},
 {0x51a5,0x1c66}, {0x8e87569d,0x928af9b8}, {0x8e87a842,0x928b161e},
   {0x7178fb08,0x6d7522ad}, {0x8e87a842,0x1c66}, {0x7178fb08,0x1c65},
 {0x516caccb,0x63e48984}, {0x25e3,0x4424}, {0x516cd2ae,0x63e4cda8},
   {0x516c86e8,0x63e44560}, {0x516cd2ae,0x63e48984}, {0x516c86e8,0x63e48984},
 {0x4223,0x7539}, {0x3c6dfb74,0x820c326b}, {0x3c6e3d97,0x820ca7a4},
   {0xc39246af,0x7df442cd}, {0x3c6e3d97,0x7539}, {0xc39246af,0x7538},
 {0x32f918c9,0x82fa3599}, {0x6935,0x209f9f6c}, {0x32f981fe,0xa399d505},
   {0x32f8af94,0x625a962d}, {0x32f981fe,0x82fa3599}, {0x32f8af94,0x82fa3599},
 {0xa79d16,0xf7bf9e95}, {0x5e6a,0x3cf4}, {0xa7fb80,0xf7bfdb89},
   {0xa73eac,0xf7bf61a1}, {0xa7fb80,0xf7bf9e95}, {0xa73eac,0xf7bf9e95},
 {0x47b3,0xf4378150}, {0x7c7e,0x283a}, {0xc431,0xf437a98a},
   {0xffffcb35,0xf4375915}, {0xc431,0xf4378150}, {0xffffcb35,0xf437814f},
 {0x69a7,0x357a}, {0xd1a90594,0x3724}, {0xd1a96f3b,0x6c9e},
   {0x2e576413,0xfffffe55}, {0xd1a96f3b,0x357a}, {0x2e576413,0x3579},
 {0xbcb085bf,0x48b757c}, {0x3160,0x23bf657b}, {0xbcb0b71f,0x284adaf7},
   {0xbcb0545f,0xe0cc1001}, {0xbcb0b71f,0x48b757c}, {0xbcb0545f,0x48b757c},
 {0xc04b9475,0x4c192aeb}, {0xc23f7941,0x682becaa}, {0x828b0db6,0xb4451796},
   {0xfe0c1b34,0xe3ed3e40}, {0x828b0db6,0x4c192aec}, {0xfe0c1b34,0x4c192aea},
 {0xacdd2c47,0x2ebb}, {0x4abcca43,0x7c69705b}, {0xf799f68a,0x7c699f16},
   {0x62206204,0x8396be60}, {0xf799f68a,0x2ebb}, {0x62206204,0x2ebb},
 {0xa5a59b86,0xf66662b4}, {0xd3e,0xcc526415}, {0xa5a5a8c4,0xc2b8c6c9},
   {0xa5a58e48,0x2a13fe9f}, {0xa5a5a8c4,0xf66662b4}, {0xa5a58e48,0xf66662b4},
 {0x5ce0,0x91a366ed}, {0x8ac6af49,0x5c64}, {0x8ac70c29,0x91a3c351},
   {0x7539ad97,0x91a30a88}, {0x8ac70c29,0x91a366ed}, {0x7539ad97,0x91a366ec},
 {0xdfa58eff,0x4065}, {0x64d44953,0x47ea}, {0x4479d852,0x8850},
   {0x7ad145ac,0xfffff87b}, {0x4479d852,0x4066}, {0x7ad145ac,0x4065},
 {0x6941670b,0x7aed}, {0x17c6c224,0x61eeb44a}, {0x8108292f,0x61ef2f37},
   {0x517aa4e7,0x9e11c6a3}, {0x8108292f,0x7aed}, {0x517aa4e7,0x7aed},
 {0x323d80f3,0x49bb}, {0x5379,0x46a69ad4}, {0x323dd46c,0x46a6e48f},
   {0x323d2d7a,0xb959aee7}, {0x323dd46c,0x49bb}, {0x323d2d7a,0x49bb},
 {0x5f3b,0x5123}, {0x1a31361,0x13a0}, {0x1a3729c,0x64c3},
   {0xfe5d4bda,0x3d82}, {0x1a3729c,0x5123}, {0xfe5d4bda,0x5122},
 {0x6df1,0x44f3}, {0x7024ec5b,0x266ad187}, {0x70255a4c,0x266b167a},
   {0x8fdb8196,0xd995736b}, {0x70255a4c,0x44f3}, {0x8fdb8196,0x44f2},
 {0x98b4f9bf,0x633c}, {0x6557562f,0x1f2c}, {0xfe0c4fee,0x8268},
   {0x335da390,0x4410}, {0xfe0c4fee,0x633c}, {0x335da390,0x633c},
 {0x2ea0,0x97442e0a}, {0x57a0,0xc95cd75a}, {0x8640,0x60a10564},
   {0xffffd700,0xcde756af}, {0x8640,0x97442e0a}, {0xffffd700,0x97442e09},
 {0xc5d7ebf2,0x2f25}, {0x16b1,0x72f47435}, {0xc5d802a3,0x72f4a35a},
   {0xc5d7d541,0x8d0bbaf0}, {0xc5d802a3,0x2f25}, {0xc5d7d541,0x2f25},
 {0x323,0x3ea4}, {0x4e25,0x60a6}, {0x5148,0x9f4a},
   {0xffffb4fe,0xffffddfd}, {0x5148,0x3ea4}, {0xffffb4fe,0x3ea3},
 {0x63e0e4d8,0x69a4}, {0xaaa64cea,0x7bfa3e7b}, {0xe8731c2,0x7bfaa820},
   {0xb93a97ee,0x84062b28}, {0xe8731c2,0x69a5}, {0xb93a97ee,0x69a3},
 {0x22f0,0x9758816}, {0x25dbfeac,0x293280b7}, {0x25dc219c,0x32a808cd},
   {0xda242444,0xe043075e}, {0x25dc219c,0x9758816}, {0xda242444,0x9758815},
 {0x1eb1,0xbcb7d33d}, {0xef5c3a4f,0x2e22}, {0xef5c5900,0xbcb8015f},
   {0x10a3e462,0xbcb7a51a}, {0xef5c5900,0xbcb7d33d}, {0x10a3e462,0xbcb7d33c},
 {0x3db8,0x25f8}, {0x3a1ddc2b,0x2f2f}, {0x3a1e19e3,0x5527},
   {0xc5e2618d,0xfffff6c8}, {0x3a1e19e3,0x25f8}, {0xc5e2618d,0x25f7},
 {0x7c6b,0x1b5}, {0x1dbcd0b0,0x68fa}, {0x1dbd4d1b,0x6aaf},
   {0xe243abbb,0xffff98ba}, {0x1dbd4d1b,0x1b5}, {0xe243abbb,0x1b4},
 {0x4fd,0x34a0}, {0xbf17ef34,0x3b4}, {0xbf17f431,0x3854},
   {0x40e815c9,0x30eb}, {0xbf17f431,0x34a0}, {0x40e815c9,0x349f},
 {0x42ab,0x66e3}, {0xcb3,0x93868009}, {0x4f5e,0x9386e6ec},
   {0x35f8,0x6c79e6da}, {0x4f5e,0x66e3}, {0x35f8,0x66e3},
 {0x477cc7c2,0x21a1d7ef}, {0xd4ca2edf,0x5d79}, {0x1c46f6a1,0x21a23569},
   {0x72b298e3,0x21a17a75}, {0x1c46f6a1,0x21a1d7f0}, {0x72b298e3,0x21a1d7ee},
 {0x5d6e,0x2020}, {0x757c,0x7ab0493a}, {0xd2ea,0x7ab0695a},
   {0xffffe7f2,0x854fd6e5}, {0xd2ea,0x2020}, {0xffffe7f2,0x201f},
 {0x4d1179f9,0x753f}, {0x84468517,0x55ff}, {0xd157ff10,0xcb3e},
   {0xc8caf4e2,0x1f3f}, {0xd157ff10,0x753f}, {0xc8caf4e2,0x753e},
 {0x76f2,0x33b6}, {0x6d69,0x457a}, {0xe45b,0x7930},
   {0x989,0xffffee3c}, {0xe45b,0x33b6}, {0x989,0x33b6},
 {0x48ae235f,0x7627}, {0x7e7e,0xd0b7a0f1}, {0x48aea1dd,0xd0b81718},
   {0x48ada4e1,0x2f48d536}, {0x48aea1dd,0x7627}, {0x48ada4e1,0x7627},
 {0x5dbf,0x5b9a0b57}, {0x3b,0x9c7096c6}, {0x5dfa,0xf80aa21d},
   {0x5d84,0xbf297491}, {0x5dfa,0x5b9a0b57}, {0x5d84,0x5b9a0b57},
 {0xea47be1f,0x4aeb}, {0x91ce7056,0x94016fa}, {0x7c162e75,0x94061e6},
   {0x58794dc9,0xf6c033f1}, {0x7c162e75,0x4aec}, {0x58794dc9,0x4aeb},
 {0x1a6e,0x4677dd72}, {0x1f2f,0xb0b9fdee}, {0x399d,0xf731db60},
   {0xfffffb3f,0x95bddf83}, {0x399d,0x4677dd72}, {0xfffffb3f,0x4677dd71},
 {0xfe75a28f,0xbe177318}, {0xc950e0c1,0xe3493d56}, {0xc7c68350,0xa160b06f},
   {0x3524c1ce,0xdace35c2}, {0xc7c68350,0xbe177319}, {0x3524c1ce,0xbe177318},
 {0x383d,0x3c32}, {0x2f75,0x45a1bc1e}, {0x67b2,0x45a1f850},
   {0x8c8,0xba5e8014}, {0x67b2,0x3c32}, {0x8c8,0x3c32},
 {0x879a2d81,0xe8b110e4}, {0x4b7b,0xabd140b5}, {0x879a78fc,0x94825199},
   {0x8799e206,0x3cdfd02f}, {0x879a78fc,0xe8b110e4}, {0x8799e206,0xe8b110e4},
 {0x6873,0x38bc}, {0x7f6a917d,0x67b6}, {0x7f6af9f0,0xa072},
   {0x8095d6f6,0xffffd105}, {0x7f6af9f0,0x38bc}, {0x8095d6f6,0x38bb},
 {0x1fb,0xa7fc6682}, {0x497d,0x5fa5}, {0x4b78,0xa7fcc627},
   {0xffffb87e,0xa7fc06dc}, {0x4b78,0xa7fc6682}, {0xffffb87e,0xa7fc6681},
 {0x36e0,0x58f4}, {0xd985d72c,0x34ef}, {0xd9860e0c,0x8de3},
   {0x267a5fb4,0x2404}, {0xd9860e0c,0x58f4}, {0x267a5fb4,0x58f3},
 {0x503c,0xa84ba2f2}, {0x57a1,0xd38700ca}, {0xa7dd,0x7bd2a3bc},
   {0xfffff89b,0xd4c4a227}, {0xa7dd,0xa84ba2f2}, {0xfffff89b,0xa84ba2f1},
 {0x573ca00f,0xe60fa98f}, {0x17e8,0x207c}, {0x573cb7f7,0xe60fca0b},
   {0x573c8827,0xe60f8913}, {0x573cb7f7,0xe60fa98f}, {0x573c8827,0xe60fa98f},
 {0x4bbd,0xe2a}, {0x47e1,0x6fa4}, {0x939e,0x7dce},
   {0x3dc,0xffff9e86}, {0x939e,0xe2a}, {0x3dc,0xe2a},
 {0x4f3a,0x23e7}, {0x3624,0x296a}, {0x855e,0x4d51},
   {0x1916,0xfffffa7d}, {0x855e,0x23e7}, {0x1916,0x23e7},
 {0x4fba4cf1,0x721b07d3}, {0x737641ed,0x2a6572d3}, {0xc3308ede,0x9c807aa6},
   {0xdc440b04,0x47b594ff}, {0xc3308ede,0x721b07d3}, {0xdc440b04,0x721b07d2},
 {0x70449c2b,0x3ff50fd1}, {0xfad6fb4b,0xc7d5a4a0}, {0x6b1b9776,0x7cab472},
   {0x756da0e0,0x781f6b30}, {0x6b1b9776,0x3ff50fd2}, {0x756da0e0,0x3ff50fd0},
 {0x977b145c,0x20fb0440}, {0x77f9,0x84dc714f}, {0x977b8c55,0xa5d7758f},
   {0x977a9c63,0x9c1e92f1}, {0x977b8c55,0x20fb0440}, {0x977a9c63,0x20fb0440},
 {0xb3379f1b,0x1024}, {0x2078,0xd55420cb}, {0xb337bf93,0xd55430ef},
   {0xb3377ea3,0x2aabef59}, {0xb337bf93,0x1024}, {0xb3377ea3,0x1024},
 {0x329ef6,0x6b0f084c}, {0x747a,0x8d784d}, {0x331370,0x6b9c8099},
   {0x322a7c,0x6a818fff}, {0x331370,0x6b0f084c}, {0x322a7c,0x6b0f084c},
 {0x322302a8,0x72cb8d0b}, {0x60a0,0x1e185047}, {0x32236348,0x90e3dd52},
   {0x3222a208,0x54b33cc4}, {0x32236348,0x72cb8d0b}, {0x3222a208,0x72cb8d0b},
 {0x246404ce,0xe167e0b3}, {0x8c411dd7,0x3179830}, {0xb0a522a5,0xe47f78e3},
   {0x9822e6f7,0xde504882}, {0xb0a522a5,0xe167e0b3}, {0x9822e6f7,0xe167e0b2},
 {0x75f4,0x81f1abec}, {0xa74a8fe4,0x4ca4c57a}, {0xa74b05d8,0xce967166},
   {0x58b5e610,0x354ce671}, {0xa74b05d8,0x81f1abec}, {0x58b5e610,0x81f1abeb},
 {0x68b7,0x40c7fb9d}, {0xdacece2d,0x6734}, {0xdacf36e4,0x40c862d1},
   {0x25319a8a,0x40c79468}, {0xdacf36e4,0x40c7fb9d}, {0x25319a8a,0x40c7fb9c},
 {0xd6523588,0x5bfc}, {0x4fa,0xc5860ed7}, {0xd6523a82,0xc5866ad3},
   {0xd652308e,0x3a7a4d25}, {0xd6523a82,0x5bfc}, {0xd652308e,0x5bfc},
 {0x4e2,0x52a7}, {0xbbaac1d8,0x3236d47a}, {0xbbaac6ba,0x32372721},
   {0x4455430a,0xcdc97e2c}, {0xbbaac6ba,0x52a7}, {0x4455430a,0x52a6},
 {0x7da2,0x6d2e57a8}, {0x1231,0x5f31}, {0x8fd3,0x6d2eb6d9},
   {0x6b71,0x6d2df877}, {0x8fd3,0x6d2e57a8}, {0x6b71,0x6d2e57a8},
 {0x310eea1b,0xefc954da}, {0x182a,0xf70d09aa}, {0x310f0245,0xe6d65e84},
   {0x310ed1f1,0xf8bc4b30}, {0x310f0245,0xefc954da}, {0x310ed1f1,0xefc954da},
 {0xef1b39f1,0x17a}, {0x7cba,0x49e0}, {0xef1bb6ab,0x4b5a},
   {0xef1abd37,0xffffb79a}, {0xef1bb6ab,0x17a}, {0xef1abd37,0x17a},
 {0x3bfe,0x207b}, {0x334192b7,0xec8af951}, {0x3341ceb5,0xec8b19cc},
   {0xccbea947,0x13752729}, {0x3341ceb5,0x207b}, {0xccbea947,0x207a},
 {0x45ee,0xa4ae8564}, {0x430fc7ee,0x673d}, {0x43100ddc,0xa4aeeca1},
   {0xbcf07e00,0xa4ae1e26}, {0x43100ddc,0xa4ae8564}, {0xbcf07e00,0xa4ae8563},
 {0x9c96c928,0x6631}, {0x626d8fc3,0x25b9a1bf}, {0xff0458eb,0x25ba07f0},
   {0x3a293965,0xda46c472}, {0xff0458eb,0x6631}, {0x3a293965,0x6631},
 {0x767f,0x2e34}, {0xaf8d5248,0x46ee}, {0xaf8dc8c7,0x7522},
   {0x50732437,0xffffe745}, {0xaf8dc8c7,0x2e34}, {0x50732437,0x2e33},
 {0x61760992,0x60e4}, {0x166e,0xd0d7927c}, {0x61762000,0xd0d7f360},
   {0x6175f324,0x2f28ce68}, {0x61762000,0x60e4}, {0x6175f324,0x60e4},
 {0x10e85784,0x6e6372f8}, {0x58f549b6,0x5aa629c7}, {0x69dda13a,0xc9099cbf},
   {0xb7f30dce,0x13bd4930}, {0x69dda13a,0x6e6372f8}, {0xb7f30dce,0x6e6372f7},
 {0xcba573ca,0x5e4dff09}, {0x3e078b56,0x3931827f}, {0x9acff20,0x977f8189},
   {0x8d9de874,0x251c7c8a}, {0x9acff20,0x5e4dff0a}, {0x8d9de874,0x5e4dff09},
 {0x9eb,0xdf8f0bdb}, {0x30f1,0x27af7ac6}, {0x3adc,0x73e86a1},
   {0xffffd8fa,0xb7df9114}, {0x3adc,0xdf8f0bdb}, {0xffffd8fa,0xdf8f0bda},
 {0x6eab,0x5c7f}, {0x112b12ab,0xfc187145}, {0x112b8156,0xfc18cdc4},
   {0xeed55c00,0x3e7eb39}, {0x112b8156,0x5c7f}, {0xeed55c00,0x5c7e},
 {0x1fa2,0x927fb27e}, {0x46bf,0x2aefc9a2}, {0x6661,0xbd6f7c20},
   {0xffffd8e3,0x678fe8db}, {0x6661,0x927fb27e}, {0xffffd8e3,0x927fb27d},
 {0x7767,0x79ec}, {0xbdd3a086,0xf8b80539}, {0xbdd417ed,0xf8b87f25},
   {0x422cd6e1,0x74874b2}, {0xbdd417ed,0x79ec}, {0x422cd6e1,0x79eb},
 {0xcfbcdc77,0x3d20}, {0xc87585ff,0xadc68f35}, {0x98326276,0xadc6cc56},
   {0x7475678,0x5239adeb}, {0x98326276,0x3d21}, {0x7475678,0x3d20},
 {0xe6c0b40f,0x17dea2aa}, {0x1112641d,0xb493d314}, {0xf7d3182c,0xcc7275be},
   {0xd5ae4ff2,0x634acf96}, {0xf7d3182c,0x17dea2aa}, {0xd5ae4ff2,0x17dea2aa},
 {0x1bee,0x75f6}, {0x7a6,0x5fa3}, {0x2394,0xd599},
   {0x1448,0x1653}, {0x2394,0x75f6}, {0x1448,0x75f6},
 {0x9a4f2867,0x5434}, {0x30a3c38a,0x2b7f}, {0xcaf2ebf1,0x7fb3},
   {0x69ab64dd,0x28b5}, {0xcaf2ebf1,0x5434}, {0x69ab64dd,0x5434},
 {0x929cb182,0x3beb}, {0x1d20,0x779fac3f}, {0x929ccea2,0x779fe82a},
   {0x929c9462,0x88608fac}, {0x929ccea2,0x3beb}, {0x929c9462,0x3beb},
 {0x1e638768,0x64bf}, {0x1534,0x181b6abb}, {0x1e639c9c,0x181bcf7a},
   {0x1e637234,0xe7e4fa04}, {0x1e639c9c,0x64bf}, {0x1e637234,0x64bf},
 {0x5fe650cf,0xb70}, {0x743e,0x1c34}, {0x5fe6c50d,0x27a4},
   {0x5fe5dc91,0xffffef3c}, {0x5fe6c50d,0xb70}, {0x5fe5dc91,0xb70},
 {0x10ac,0x44f3}, {0x41a7,0x5eb0}, {0x5253,0xa3a3},
   {0xffffcf05,0xffffe642}, {0x5253,0x44f3}, {0xffffcf05,0x44f2},
 {0x5227,0x6eb5}, {0x2abfbefd,0x34fe0fbe}, {0x2ac01124,0x34fe7e73},
   {0xd540932a,0xcb025ef6}, {0x2ac01124,0x6eb5}, {0xd540932a,0x6eb4},
 {0x486e,0x57fc45e}, {0x4fe9,0x35e1d07f}, {0x9857,0x3b6194dd},
   {0xfffff885,0xcf9df3de}, {0x9857,0x57fc45e}, {0xfffff885,0x57fc45d},
 {0x48e9c78b,0x4ec906ad}, {0x6fd8d588,0x3433}, {0xb8c29d13,0x4ec93ae0},
   {0xd910f203,0x4ec8d279}, {0xb8c29d13,0x4ec906ad}, {0xd910f203,0x4ec906ac},
 {0x5dbc,0x5f72}, {0x4625,0xf44ba2c7}, {0xa3e1,0xf44c0239},
   {0x1797,0xbb4bcab}, {0xa3e1,0x5f72}, {0x1797,0x5f72},
 {0x33fa50ec,0x8a6}, {0x7d35472e,0x63bc}, {0xb12f981a,0x6c62},
   {0xb6c509be,0xffffa4e9}, {0xb12f981a,0x8a6}, {0xb6c509be,0x8a5},
 {0x46fb3f5d,0x832}, {0x3a35dce9,0xb70aaabf}, {0x81311c46,0xb70ab2f1},
   {0xcc56274,0x48f55d73}, {0x81311c46,0x832}, {0xcc56274,0x832},
 {0x7837e78c,0x2471}, {0xef4659c,0x3dbb}, {0x872c4d28,0x622c},
   {0x694381f0,0xffffe6b6}, {0x872c4d28,0x2471}, {0x694381f0,0x2471},
 {0x60fb456e,0x75be}, {0x5f20,0x6d2a}, {0x60fba48e,0xe2e8},
   {0x60fae64e,0x894}, {0x60fba48e,0x75be}, {0x60fae64e,0x75be},
 {0x12a0,0xd5517c04}, {0x4b172719,0xf60c41e4}, {0x4b1739b9,0xcb5dbde8},
   {0xb4e8eb87,0xdf453a1f}, {0x4b1739b9,0xd5517c04}, {0xb4e8eb87,0xd5517c03},
 {0x76e9,0x36a7}, {0x3d1f9e0d,0x3f3c}, {0x3d2014f6,0x75e3},
   {0xc2e0d8dc,0xfffff76a}, {0x3d2014f6,0x36a7}, {0xc2e0d8dc,0x36a6},
 {0x867dd5d9,0xc8d122a1}, {0x596c,0xa7cad5f6}, {0x867e2f45,0x709bf897},
   {0x867d7c6d,0x21064cab}, {0x867e2f45,0xc8d122a1}, {0x867d7c6d,0xc8d122a1},
 {0x38e1,0x451272bc}, {0x820,0x4da2}, {0x4101,0x4512c05e},
   {0x30c1,0x4512251a}, {0x4101,0x451272bc}, {0x30c1,0x451272bc},
 {0x89e9dc4c,0xa038af72}, {0x2734,0xb423d9e9}, {0x89ea0380,0x545c895b},
   {0x89e9b518,0xec14d589}, {0x89ea0380,0xa038af72}, {0x89e9b518,0xa038af72},
 {0x613e,0x15fb}, {0x5711d2d8,0x416f}, {0x57123416,0x576a},
   {0xa8ee8e66,0xffffd48b}, {0x57123416,0x15fb}, {0xa8ee8e66,0x15fa},
 {0x3033,0x8469dac6}, {0xa25,0x820}, {0x3a58,0x8469e2e6},
   {0x260e,0x8469d2a6}, {0x3a58,0x8469dac6}, {0x260e,0x8469dac6},
 {0x20ba,0x3d72}, {0x14f0,0xebf2908f}, {0x35aa,0xebf2ce01},
   {0xbca,0x140dace3}, {0x35aa,0x3d72}, {0xbca,0x3d72},
 {0x1b74,0x942116d9}, {0x4e053da3,0x4f67}, {0x4e055917,0x94216640},
   {0xb1faddd1,0x9420c771}, {0x4e055917,0x942116d9}, {0xb1faddd1,0x942116d8},
 {0x4ee5,0x13ef}, {0xe8ba672b,0xb54957d3}, {0xe8bab610,0xb5496bc2},
   {0x1745e7ba,0x4ab6bc1b}, {0xe8bab610,0x13ef}, {0x1745e7ba,0x13ee},
 {0xa53abee3,0xf9ae9497}, {0xa76185ce,0xf4b369f}, {0x4c9c44b1,0x8f9cb37},
   {0xfdd93915,0xea635df7}, {0x4c9c44b1,0xf9ae9498}, {0xfdd93915,0xf9ae9496},
 {0xc28b848a,0x67f4}, {0x6f66,0x165960d}, {0xc28bf3f0,0x165fe01},
   {0xc28b1524,0xfe9ad1e7}, {0xc28bf3f0,0x67f4}, {0xc28b1524,0x67f4},
 {0x16bcb82e,0x51f2bc41}, {0x6131,0x37a}, {0x16bd195f,0x51f2bfbb},
   {0x16bc56fd,0x51f2b8c7}, {0x16bd195f,0x51f2bc41}, {0x16bc56fd,0x51f2bc41},
 {0xc29e7630,0x373b}, {0xfb64807d,0x6c703fcc}, {0xbe02f6ad,0x6c707708},
   {0xc739f5b3,0x938ff76e}, {0xbe02f6ad,0x373c}, {0xc739f5b3,0x373a},
 {0x16fc,0x2b37}, {0x177b,0x69ea1fe0}, {0x2e77,0x69ea4b17},
   {0xffffff81,0x96160b56}, {0x2e77,0x2b37}, {0xffffff81,0x2b36},
 {0xa407a332,0x41f7}, {0xb833902a,0x4eab}, {0x5c3b335c,0x90a3},
   {0xebd41308,0xfffff34b}, {0x5c3b335c,0x41f8}, {0xebd41308,0x41f6},
 {0xa58cb87e,0x92a58fa1}, {0xe6c,0x6cbaba5f}, {0xa58cc6ea,0xff604a00},
   {0xa58caa12,0x25ead542}, {0xa58cc6ea,0x92a58fa1}, {0xa58caa12,0x92a58fa1},
 {0xc30,0x8a33521}, {0x3cbe,0x7cff}, {0x48ee,0x8a3b220},
   {0xffffcf72,0x8a2b821}, {0x48ee,0x8a33521}, {0xffffcf72,0x8a33520},
 {0x536e,0x58b5}, {0x7ce7,0x668b4292}, {0xd055,0x668b9b47},
   {0xffffd687,0x99751622}, {0xd055,0x58b5}, {0xffffd687,0x58b4},
 {0x53a8,0x891902f1}, {0xd3c3debc,0xe3c80e63}, {0xd3c43264,0x6ce11154},
   {0x2c3c74ec,0xa550f48d}, {0xd3c43264,0x891902f1}, {0x2c3c74ec,0x891902f0},
 {0x7e23,0xc469465e}, {0xddeebe13,0xf22f3755}, {0xddef3c36,0xb6987db3},
   {0x2211c010,0xd23a0f08}, {0xddef3c36,0xc469465e}, {0x2211c010,0xc469465d},
 {0xf8fa09fb,0x3237}, {0xd8dcb0b9,0x1eb2}, {0xd1d6bab4,0x50ea},
   {0x201d5942,0x1385}, {0xd1d6bab4,0x3238}, {0x201d5942,0x3237},
 {0x301ead26,0xb40379fb}, {0x772d,0x47ab}, {0x301f2453,0xb403c1a6},
   {0x301e35f9,0xb4033250}, {0x301f2453,0xb40379fb}, {0x301e35f9,0xb40379fb},
 {0x55bda1c5,0x5422eef8}, {0x1ae0,0x74812d21}, {0x55bdbca5,0xc8a41c19},
   {0x55bd86e5,0xdfa1c1d7}, {0x55bdbca5,0x5422eef8}, {0x55bd86e5,0x5422eef8},
 {0x7d30,0xba6e9c9f}, {0x25ed25ce,0x45547969}, {0x25eda2fe,0xffc31608},
   {0xda135762,0x751a2335}, {0x25eda2fe,0xba6e9c9f}, {0xda135762,0xba6e9c9e},
 {0x67bc,0x6025}, {0x23b1,0x6919fb04}, {0x8b6d,0x691a5b29},
   {0x440b,0x96e66521}, {0x8b6d,0x6025}, {0x440b,0x6025},
 {0x5837,0x2e36}, {0x4621,0x90736ffd}, {0x9e58,0x90739e33},
   {0x1216,0x6f8cbe39}, {0x9e58,0x2e36}, {0x1216,0x2e36},
 {0xf59fd7bd,0x2b2f}, {0x1e105af6,0x721}, {0x13b032b3,0x3251},
   {0xd78f7cc7,0x240e}, {0x13b032b3,0x2b30}, {0xd78f7cc7,0x2b2f},
 {0x29a2,0xef1}, {0xd91e74d4,0xe7352687}, {0xd91e9e76,0xe7353578},
   {0x26e1b4ce,0x18cae869}, {0xd91e9e76,0xef1}, {0x26e1b4ce,0xef0},
 {0xb2a2e32d,0x4273}, {0x261,0x3d56e9d6}, {0xb2a2e58e,0x3d572c49},
   {0xb2a2e0cc,0xc2a9589d}, {0xb2a2e58e,0x4273}, {0xb2a2e0cc,0x4273},
 {0x5cff,0xe3629c66}, {0x9f5,0x924da475}, {0x66f4,0x75b040db},
   {0x530a,0x5114f7f1}, {0x66f4,0xe3629c66}, {0x530a,0xe3629c66},
 {0x7e2a,0x5f66}, {0x104546d7,0x2efd}, {0x1045c501,0x8e63},
   {0xefbb3753,0x3068}, {0x1045c501,0x5f66}, {0xefbb3753,0x5f65},
 {0x4532,0x50ac}, {0x7ae9b870,0xa1f43f3c}, {0x7ae9fda2,0xa1f48fe8},
   {0x85168cc2,0x5e0c116f}, {0x7ae9fda2,0x50ac}, {0x85168cc2,0x50ab},
 {0x64eb,0xeeae1807}, {0x6ef9,0x7dc703c9}, {0xd3e4,0x6c751bd0},
   {0xfffff5f2,0x70e7143d}, {0xd3e4,0xeeae1807}, {0xfffff5f2,0xeeae1806},
 {0x7707b749,0xcfcfb76}, {0xd726a019,0x616e}, {0x4e2e5762,0xcfd5ce5},
   {0x9fe11730,0xcfc9a07}, {0x4e2e5762,0xcfcfb77}, {0x9fe11730,0xcfcfb75},
 {0x5dae,0x5b66}, {0x4dfb,0x2477}, {0xaba9,0x7fdd},
   {0xfb3,0x36ef}, {0xaba9,0x5b66}, {0xfb3,0x5b66},
 {0x7eea,0x3d0bab81}, {0x73f2,0x3de9}, {0xf2dc,0x3d0be96a},
   {0xaf8,0x3d0b6d98}, {0xf2dc,0x3d0bab81}, {0xaf8,0x3d0bab81},
 {0x4eb2,0x32ff97fa}, {0x31f3,0x17a83f6e}, {0x80a5,0x4aa7d768},
   {0x1cbf,0x1b57588c}, {0x80a5,0x32ff97fa}, {0x1cbf,0x32ff97fa},
 {0x3e31e8b6,0x642b}, {0x51bb,0x34f5}, {0x3e323a71,0x9920},
   {0x3e3196fb,0x2f36}, {0x3e323a71,0x642b}, {0x3e3196fb,0x642b},
 {0x14c62d,0x6ce8}, {0x385b50ea,0x2668}, {0x38701717,0x9350},
   {0xc7b97543,0x467f}, {0x38701717,0x6ce8}, {0xc7b97543,0x6ce7},
 {0xaa07504f,0x165226f0}, {0x68,0xc77cd417}, {0xaa0750b7,0xddcefb07},
   {0xaa074fe7,0x4ed552d9}, {0xaa0750b7,0x165226f0}, {0xaa074fe7,0x165226f0},
 {0x3d72,0xb69f5ce5}, {0x3225,0x2b8f999c}, {0x6f97,0xe22ef681},
   {0xb4d,0x8b0fc349}, {0x6f97,0xb69f5ce5}, {0xb4d,0xb69f5ce5},
 {0x5cdc2098,0x9afb6f3a}, {0x6263,0x7223}, {0x5cdc82fb,0x9afbe15d},
   {0x5cdbbe35,0x9afafd17}, {0x5cdc82fb,0x9afb6f3a}, {0x5cdbbe35,0x9afb6f3a},
 {0x696a,0x1825}, {0x15be,0x2477}, {0x7f28,0x3c9c},
   {0x53ac,0xfffff3ae}, {0x7f28,0x1825}, {0x53ac,0x1825},
 {0x28ea,0xb91ec68}, {0xdeab87bc,0x1aa1}, {0xdeabb0a6,0xb920709},
   {0x2154a12e,0xb91d1c6}, {0xdeabb0a6,0xb91ec68}, {0x2154a12e,0xb91ec67},
 {0x97d8cc4c,0x506d}, {0x6d39,0x2c60}, {0x97d93985,0x7ccd},
   {0x97d85f13,0x240d}, {0x97d93985,0x506d}, {0x97d85f13,0x506d},
 {0xef8c3b03,0xac1ccf0}, {0xc3db526e,0xf11096a9}, {0xb3678d71,0xfbd2639a},
   {0x2bb0e895,0x19b13647}, {0xb3678d71,0xac1ccf1}, {0x2bb0e895,0xac1ccf0},
 {0xa384c69a,0xc97f8f83}, {0x273b,0x58abb562}, {0xa384edd5,0x222b44e5},
   {0xa3849f5f,0x70d3da21}, {0xa384edd5,0xc97f8f83}, {0xa3849f5f,0xc97f8f83},
 {0x163a,0x7bd03685}, {0x4ae5,0x3f33}, {0x611f,0x7bd075b8},
   {0xffffcb55,0x7bcff751}, {0x611f,0x7bd03685}, {0xffffcb55,0x7bd03684},
 {0x5b74,0x696a}, {0x75a4,0xf4f87f98}, {0xd118,0xf4f8e902},
   {0xffffe5d0,0xb07e9d1}, {0xd118,0x696a}, {0xffffe5d0,0x6969},
 {0x43f2,0xe54c7e5c}, {0x654ddd05,0x68b2}, {0x654e20f7,0xe54ce70e},
   {0x9ab266ed,0xe54c15a9}, {0x654e20f7,0xe54c7e5c}, {0x9ab266ed,0xe54c7e5b},
 {0x3eaf1472,0x51e1}, {0x901ef46,0xe2cd3ea2}, {0x47b103b8,0xe2cd9083},
   {0x35ad252c,0x1d33133f}, {0x47b103b8,0x51e1}, {0x35ad252c,0x51e1},
 {0xd2392477,0x6377e111}, {0x717d,0x38dde305}, {0xd23995f4,0x9c55c416},
   {0xd238b2fa,0x2a99fe0c}, {0xd23995f4,0x6377e111}, {0xd238b2fa,0x6377e111},
 {0x2163,0xa23e8f36}, {0xe1f5695e,0xffb9b6a4}, {0xe1f58ac1,0xa1f845da},
   {0x1e0ab805,0xa284d891}, {0xe1f58ac1,0xa23e8f36}, {0x1e0ab805,0xa23e8f35},
 {0x30b2,0x7c2e}, {0x34a0,0x6d73}, {0x6552,0xe9a1},
   {0xfffffc12,0xeba}, {0x6552,0x7c2e}, {0xfffffc12,0x7c2d},
 {0xbddfcb94,0xc42f7147}, {0xc7426522,0xd7c68e00}, {0x852230b6,0x9bf5ff48},
   {0xf69d6672,0xec68e346}, {0x852230b6,0xc42f7148}, {0xf69d6672,0xc42f7146},
 {0x3dba,0x162c}, {0x1269,0x4bc0296f}, {0x5023,0x4bc03f9b},
   {0x2b51,0xb43fecbd}, {0x5023,0x162c}, {0x2b51,0x162c},
 {0x1d21,0x6fe9}, {0x4220,0x32fc}, {0x5f41,0xa2e5},
   {0xffffdb01,0x3cec}, {0x5f41,0x6fe9}, {0xffffdb01,0x6fe8},
 {0x24fa,0x9b7}, {0x3a4a2bb6,0x592f}, {0x3a4a50b0,0x62e6},
   {0xc5b5f944,0xffffb087}, {0x3a4a50b0,0x9b7}, {0xc5b5f944,0x9b6},
 {0x30bf,0x3a977c12}, {0x5d38,0x34f2}, {0x8df7,0x3a97b104},
   {0xffffd387,0x3a97471f}, {0x8df7,0x3a977c12}, {0xffffd387,0x3a977c11},
 {0x2eae,0x1239}, {0x6ca6,0x483a}, {0x9b54,0x5a73},
   {0xffffc208,0xffffc9fe}, {0x9b54,0x1239}, {0xffffc208,0x1238},
 {0x668dddfa,0xa08c5194}, {0x67b0,0x20b1}, {0x668e45aa,0xa08c7245},
   {0x668d764a,0xa08c30e3}, {0x668e45aa,0xa08c5194}, {0x668d764a,0xa08c5194},
 {0x11723b84,0x52d0f6c}, {0x1171,0x3baa3675}, {0x11724cf5,0x40d745e1},
   {0x11722a13,0xc982d8f7}, {0x11724cf5,0x52d0f6c}, {0x11722a13,0x52d0f6c},
 {0x5ea21616,0x9fc5f05}, {0x1b569da3,0xb36}, {0x79f8b3b9,0x9fc6a3b},
   {0x434b7873,0x9fc53cf}, {0x79f8b3b9,0x9fc5f05}, {0x434b7873,0x9fc5f05},
 {0xfc43179d,0x35ad}, {0x477d79f0,0x5f36}, {0x43c0918d,0x94e4},
   {0xb4c59dad,0xffffd677}, {0x43c0918d,0x35ae}, {0xb4c59dad,0x35ad},
 {0x1467,0x5a4}, {0x8c54cc0a,0x1630}, {0x8c54e071,0x1bd4},
   {0x73ab485d,0xffffef73}, {0x8c54e071,0x5a4}, {0x73ab485d,0x5a3},
 {0x63b9,0x6825}, {0x2774df8e,0x9ba18dc8}, {0x27754347,0x9ba1f5ed},
   {0xd88b842b,0x645eda5c}, {0x27754347,0x6825}, {0xd88b842b,0x6824},
 {0x15b0,0x9741fe4}, {0x71ff,0x2236}, {0x87af,0x974421a},
   {0xffffa3b1,0x973fdad}, {0x87af,0x9741fe4}, {0xffffa3b1,0x9741fe3},
 {0xdf5461d8,0x7884e547}, {0x6d6eda24,0x57a}, {0x4cc33bfc,0x7884eac2},
   {0x71e587b4,0x7884dfcd}, {0x4cc33bfc,0x7884e548}, {0x71e587b4,0x7884e547},
 {0x39b8cc60,0xd04d7187}, {0x466b,0x4ef6}, {0x39b912cb,0xd04dc07d},
   {0x39b885f5,0xd04d2291}, {0x39b912cb,0xd04d7187}, {0x39b885f5,0xd04d7187},
 {0x7c,0x6677}, {0xb75f9cbc,0x14ab}, {0xb75f9d38,0x7b22},
   {0x48a063c0,0x51cb}, {0xb75f9d38,0x6677}, {0x48a063c0,0x6676},
 {0x81afc207,0x7bb}, {0x707119b0,0x35ef}, {0xf220dbb7,0x3daa},
   {0x113ea857,0xffffd1cc}, {0xf220dbb7,0x7bb}, {0x113ea857,0x7bb},
 {0x6423,0xcf6}, {0xde2ba466,0x328f35dd}, {0xde2c0889,0x328f42d3},
   {0x21d4bfbd,0xcd70d718}, {0xde2c0889,0xcf6}, {0x21d4bfbd,0xcf5},
 {0xdef0e185,0x3f27495f}, {0x59b2,0x28554f50}, {0xdef13b37,0x677c98af},
   {0xdef087d3,0x16d1fa0f}, {0xdef13b37,0x3f27495f}, {0xdef087d3,0x3f27495f},
 {0xb7afec95,0x68ee}, {0xcaa1bb9b,0x31af}, {0x8251a830,0x9a9e},
   {0xed0e30fa,0x373e}, {0x8251a830,0x68ef}, {0xed0e30fa,0x68ed},
 {0xa163d51b,0x532d421b}, {0x7e23,0x626c}, {0xa164533e,0x532da487},
   {0xa16356f8,0x532cdfaf}, {0xa164533e,0x532d421b}, {0xa16356f8,0x532d421b},
 {0x2862,0x226d}, {0x73f4,0x7e}, {0x9c56,0x22eb},
   {0xffffb46e,0x21ee}, {0x9c56,0x226d}, {0xffffb46e,0x226c},
 {0x5522,0x37b13c3d}, {0x2ebf1594,0x206a2f54}, {0x2ebf6ab6,0x581b6b91},
   {0xd1413f8e,0x17470ce8}, {0x2ebf6ab6,0x37b13c3d}, {0xd1413f8e,0x37b13c3c},
 {0x6930,0x3a63}, {0x72b2,0x7596c9d}, {0xdbe2,0x759a700},
   {0xfffff67e,0xf8a6cdc5}, {0xdbe2,0x3a63}, {0xfffff67e,0x3a62},
 {0x632f23b2,0x185ea16c}, {0x70e1,0xec9de09f}, {0x632f9493,0x4fc820b},
   {0x632eb2d1,0x2bc0c0cd}, {0x632f9493,0x185ea16c}, {0x632eb2d1,0x185ea16c},
 {0x31fa,0x5d970b5d}, {0x236,0x36a}, {0x3430,0x5d970ec7},
   {0x2fc4,0x5d9707f3}, {0x3430,0x5d970b5d}, {0x2fc4,0x5d970b5d},
 {0x68ba,0x7320}, {0x1ca5,0x5bb5}, {0x855f,0xced5},
   {0x4c15,0x176b}, {0x855f,0x7320}, {0x4c15,0x7320},
 {0x2b7f,0x24fc}, {0x7875,0xdfc}, {0xa3f4,0x32f8},
   {0xffffb30a,0x16ff}, {0xa3f4,0x24fc}, {0xffffb30a,0x24fb},
 {0x2572,0x6071}, {0xbb46adaa,0x43e4}, {0xbb46d31c,0xa455},
   {0x44b977c8,0x1c8c}, {0xbb46d31c,0x6071}, {0x44b977c8,0x6070},
 {0x8fb,0x3ad}, {0xeec,0x4d62}, {0x17e7,0x510f},
   {0xfffffa0f,0xffffb64a}, {0x17e7,0x3ad}, {0xfffffa0f,0x3ac},
 {0xfa9,0x31f2}, {0x5f6d,0x9cd4b6bc}, {0x6f16,0x9cd4e8ae},
   {0xffffb03c,0x632b7b35}, {0x6f16,0x31f2}, {0xffffb03c,0x31f1},
 {0xe9b9ff24,0x61bb}, {0x284f5f3c,0x8c6313a8}, {0x12095e60,0x8c637564},
   {0xc16a9fe8,0x739d4e13}, {0x12095e60,0x61bc}, {0xc16a9fe8,0x61bb},
 {0x68af,0x4c144f1d}, {0x440d3a75,0x9959b39c}, {0x440da324,0xe56e02b9},
   {0xbbf32e3a,0xb2ba9b80}, {0x440da324,0x4c144f1d}, {0xbbf32e3a,0x4c144f1c},
 {0x4121,0x28bb}, {0x1697921a,0x8868ef25}, {0x1697d33b,0x886917e0},
   {0xe968af07,0x77973995}, {0x1697d33b,0x28bb}, {0xe968af07,0x28ba},
 {0xf676514e,0x3d0eaede}, {0x706b,0x1dbf}, {0xf676c1b9,0x3d0ecc9d},
   {0xf675e0e3,0x3d0e911f}, {0xf676c1b9,0x3d0eaede}, {0xf675e0e3,0x3d0eaede},
 {0xa5be69c0,0xe53c357b}, {0x8fbf5220,0xece4afbf}, {0x357dbbe0,0xd220e53b},
   {0x15ff17a0,0xf85785bc}, {0x357dbbe0,0xe53c357c}, {0x15ff17a0,0xe53c357b},
 {0x3bbe1f2c,0x4f27ce51}, {0x5465,0xc34abcc4}, {0x3bbe7391,0x12728b15},
   {0x3bbdcac7,0x8bdd118d}, {0x3bbe7391,0x4f27ce51}, {0x3bbdcac7,0x4f27ce51},
 {0x14ae,0x22de1224}, {0x9da9a670,0xafe62f4d}, {0x9da9bb1e,0xd2c44171},
   {0x62566e3e,0x72f7e2d6}, {0x9da9bb1e,0x22de1224}, {0x62566e3e,0x22de1223},
 {0xdf3bb5b0,0x5cb6b504}, {0x54e8,0x6a36}, {0xdf3c0a98,0x5cb71f3a},
   {0xdf3b60c8,0x5cb64ace}, {0xdf3c0a98,0x5cb6b504}, {0xdf3b60c8,0x5cb6b504},
 {0x2fb7,0x20d6d7d2}, {0xfad81924,0x78ec}, {0xfad848db,0x20d750be},
   {0x5281693,0x20d65ee5}, {0xfad848db,0x20d6d7d2}, {0x5281693,0x20d6d7d1},
 {0x825fb608,0x4479}, {0x923,0x7929}, {0x825fbf2b,0xbda2},
   {0x825face5,0xffffcb50}, {0x825fbf2b,0x4479}, {0x825face5,0x4479},
 {0x7522,0x54e6}, {0x27be,0x3b68}, {0x9ce0,0x904e},
   {0x4d64,0x197e}, {0x9ce0,0x54e6}, {0x4d64,0x54e6},
 {0x26be,0x5197a03}, {0x1078,0x672a1e7e}, {0x3736,0x6c439881},
   {0x1646,0x9def5b85}, {0x3736,0x5197a03}, {0x1646,0x5197a03},
 {0x2df6,0x7ca5}, {0xa39a8392,0x8713777}, {0xa39ab188,0x871b41c},
   {0x5c65aa64,0xf78f452d}, {0xa39ab188,0x7ca5}, {0x5c65aa64,0x7ca4},
 {0x2de3,0x2c77}, {0x775,0xf108dde7}, {0x3558,0xf1090a5e},
   {0x266e,0xef74e90}, {0x3558,0x2c77}, {0x266e,0x2c77},
 {0x4e39,0x3cb6}, {0x53ba,0x4f72}, {0xa1f3,0x8c28},
   {0xfffffa7f,0xffffed43}, {0xa1f3,0x3cb6}, {0xfffffa7f,0x3cb5},
 {0xa1728727,0x6fa4}, {0xa7d4a437,0x6a79}, {0x49472b5e,0xda1e},
   {0xf99de2f0,0x52a}, {0x49472b5e,0x6fa5}, {0xf99de2f0,0x6fa3},
 {0x5baa,0x14ec926b}, {0xb2d,0xba971329}, {0x66d7,0xcf83a594},
   {0x507d,0x5a557f42}, {0x66d7,0x14ec926b}, {0x507d,0x14ec926b},
 {0xc3d37b08,0x54f1}, {0xff2,0x74ff}, {0xc3d38afa,0xc9f0},
   {0xc3d36b16,0xffffdff2}, {0xc3d38afa,0x54f1}, {0xc3d36b16,0x54f1},
 {0x6b185c4b,0x6c3e}, {0x107d,0xc04503ef}, {0x6b186cc8,0xc045702d},
   {0x6b184bce,0x3fbb684f}, {0x6b186cc8,0x6c3e}, {0x6b184bce,0x6c3e},
 {0x3334,0x6224}, {0x8ed40417,0xfd07f8fb}, {0x8ed4374b,0xfd085b1f},
   {0x712c2f1d,0x2f86928}, {0x8ed4374b,0x6224}, {0x712c2f1d,0x6223},
 {0x5473,0x9e5ae1ae}, {0xb9893547,0xe3bc4105}, {0xb98989ba,0x821722b3},
   {0x46771f2c,0xba9ea0a8}, {0xb98989ba,0x9e5ae1ae}, {0x46771f2c,0x9e5ae1ad},
 {0x6540ea18,0xda7}, {0x65d0f4d0,0xa52ec060}, {0xcb11dee8,0xa52ece07},
   {0xff6ff548,0x5ad14d46}, {0xcb11dee8,0xda7}, {0xff6ff548,0xda6},
 {0x7465,0x8c856db4}, {0x6730,0xe90950fa}, {0xdb95,0x758ebeae},
   {0xd35,0xa37c1cba}, {0xdb95,0x8c856db4}, {0xd35,0x8c856db4},
 {0x4e637034,0x2e3e}, {0x7cf5,0x36fe}, {0x4e63ed29,0x653c},
   {0x4e62f33f,0xfffff740}, {0x4e63ed29,0x2e3e}, {0x4e62f33f,0x2e3e},
 {0x37b0,0xf7ee45c4}, {0x1e6e,0x7be6}, {0x561e,0xf7eec1aa},
   {0x1942,0xf7edc9de}, {0x561e,0xf7ee45c4}, {0x1942,0xf7ee45c4},
 {0x7de0,0x1334}, {0xa2235d85,0xe5fa1b21}, {0xa223db65,0xe5fa2e55},
   {0x5ddd205b,0x1a05f812}, {0xa223db65,0x1334}, {0x5ddd205b,0x1333},
 {0xbeee6291,0xe81ed14c}, {0x18f0,0x2ab1}, {0xbeee7b81,0xe81efbfd},
   {0xbeee49a1,0xe81ea69b}, {0xbeee7b81,0xe81ed14c}, {0xbeee49a1,0xe81ed14c},
 {0x3b9fe879,0xbcc5aafb}, {0x2de1,0x6aff}, {0x3ba0165a,0xbcc615fa},
   {0x3b9fba98,0xbcc53ffc}, {0x3ba0165a,0xbcc5aafb}, {0x3b9fba98,0xbcc5aafb},
 {0x17b3,0x48ed}, {0x1cad,0x2cbe}, {0x3460,0x75ab},
   {0xfffffb06,0x1c2e}, {0x3460,0x48ed}, {0xfffffb06,0x48ec},
 {0x9ae590b3,0x5bec}, {0x726,0x1a14cdaa}, {0x9ae597d9,0x1a152996},
   {0x9ae5898d,0xe5eb8e42}, {0x9ae597d9,0x5bec}, {0x9ae5898d,0x5bec},
 {0x3d62,0xa5736827}, {0x7ef481c3,0x8679a02d}, {0x7ef4bf25,0x2bed0854},
   {0x810bbb9f,0x1ef9c7f9}, {0x7ef4bf25,0xa5736827}, {0x810bbb9f,0xa5736826},
 {0xc373a807,0xe10d44b8}, {0x1639,0x30c43535}, {0xc373be40,0x11d179ed},
   {0xc37391ce,0xb0490f83}, {0xc373be40,0xe10d44b8}, {0xc37391ce,0xe10d44b8},
 {0xea719464,0x53141a63}, {0x59ad35e4,0x6e8}, {0x441eca48,0x5314214c},
   {0x90c45e80,0x5314137b}, {0x441eca48,0x53141a64}, {0x90c45e80,0x53141a63},
 {0x12d04690,0x2e36}, {0xbd62e5c0,0x9f7}, {0xd0332c50,0x382d},
   {0x556d60d0,0x243e}, {0xd0332c50,0x2e36}, {0x556d60d0,0x2e35},
 {0x6cfd375c,0x6b46e2d8}, {0x4ab3c779,0x1be7}, {0xb7b0fed5,0x6b46febf},
   {0x22496fe3,0x6b46c6f1}, {0xb7b0fed5,0x6b46e2d8}, {0x22496fe3,0x6b46e2d8},
 {0xfb0ad60a,0x1aab}, {0x8b32645a,0x1df46ee4}, {0x863d3a64,0x1df48990},
   {0x6fd871b0,0xe20babc7}, {0x863d3a64,0x1aac}, {0x6fd871b0,0x1aab},
 {0x9518b8e5,0xd6cb17cb}, {0x13e8,0xfca2cc10}, {0x9518cccd,0xd36de3db},
   {0x9518a4fd,0xda284bbb}, {0x9518cccd,0xd6cb17cb}, {0x9518a4fd,0xd6cb17cb},
 {0x1e20699,0x3036}, {0x4a6d,0x2a4}, {0x1e25106,0x32da},
   {0x1e1bc2c,0x2d92}, {0x1e25106,0x3036}, {0x1e1bc2c,0x3036},
 {0x2ceb21f1,0xd4237bf1}, {0x29e0,0x733}, {0x2ceb4bd1,0xd4238324},
   {0x2ceaf811,0xd42374be}, {0x2ceb4bd1,0xd4237bf1}, {0x2ceaf811,0xd4237bf1},
 {0xdf3798f4,0xe7dddc4f}, {0xa7c4b69d,0xc9ffd878}, {0x86fc4f91,0xb1ddb4c8},
   {0x3772e257,0x1dde03d7}, {0x86fc4f91,0xe7dddc50}, {0x3772e257,0xe7dddc4f},
 {0x57ef,0x34aa}, {0xf4e4ce6c,0x1a7d}, {0xf4e5265b,0x4f27},
   {0xb1b8983,0x1a2c}, {0xf4e5265b,0x34aa}, {0xb1b8983,0x34a9},
 {0x8c055733,0x3ee8}, {0x20ed,0xf09576be}, {0x8c057820,0xf095b5a6},
   {0x8c053646,0xf6ac82a}, {0x8c057820,0x3ee8}, {0x8c053646,0x3ee8},
 {0xd1d47d0,0x3fab}, {0x51e0,0x6979b996}, {0xd1d99b0,0x6979f941},
   {0xd1cf5f0,0x96868615}, {0xd1d99b0,0x3fab}, {0xd1cf5f0,0x3fab},
 {0x923c412d,0x27338e5e}, {0xb737c94c,0xe3950654}, {0x49740a79,0xac894b3},
   {0xdb0477e1,0x439e8809}, {0x49740a79,0x27338e5f}, {0xdb0477e1,0x27338e5d},
 {0x47ba23aa,0x3f1ba8a5}, {0x266c,0xe1574ed0}, {0x47ba4a16,0x2072f775},
   {0x47b9fd3e,0x5dc459d5}, {0x47ba4a16,0x3f1ba8a5}, {0x47b9fd3e,0x3f1ba8a5},
 {0x85a69450,0x9b2ce358}, {0x48d8e619,0x2159ba1d}, {0xce7f7a69,0xbc869d75},
   {0x3ccdae37,0x79d3293b}, {0xce7f7a69,0x9b2ce358}, {0x3ccdae37,0x9b2ce358},
 {0xa96a091b,0x5e97ac63}, {0x42a2,0x6abd}, {0xa96a4bbd,0x5e981720},
   {0xa969c679,0x5e9741a6}, {0xa96a4bbd,0x5e97ac63}, {0xa969c679,0x5e97ac63},
 {0xee63e201,0xd8e5e1d5}, {0x5cc570ac,0x1413624b}, {0x4b2952ad,0xecf94421},
   {0x919e7155,0xc4d27f8a}, {0x4b2952ad,0xd8e5e1d6}, {0x919e7155,0xd8e5e1d5},
 {0xdd7164eb,0x46390dd6}, {0x4c3f,0x59347313}, {0xdd71b12a,0x9f6d80e9},
   {0xdd7118ac,0xed049ac3}, {0xdd71b12a,0x46390dd6}, {0xdd7118ac,0x46390dd6},
 {0x3ff6,0x1166}, {0x3db7,0x54c713e8}, {0x7dad,0x54c7254e},
   {0x23f,0xab38fd7e}, {0x7dad,0x1166}, {0x23f,0x1166},
 {0x66ef1f46,0xb6d08eee}, {0x4df9,0x4ea2}, {0x66ef6d3f,0xb6d0dd90},
   {0x66eed14d,0xb6d0404c}, {0x66ef6d3f,0xb6d08eee}, {0x66eed14d,0xb6d08eee},
 {0x26ae,0x1481823d}, {0x293b,0x623293a9}, {0x4fe9,0x76b415e6},
   {0xfffffd73,0xb24eee93}, {0x4fe9,0x1481823d}, {0xfffffd73,0x1481823c},
 {0x7826,0x257d}, {0x772b,0x62772106}, {0xef51,0x62774683},
   {0xfb,0x9d890477}, {0xef51,0x257d}, {0xfb,0x257d},
 {0x1625,0xb3838046}, {0x24f2,0x673d}, {0x3b17,0xb383e783},
   {0xfffff133,0xb3831908}, {0x3b17,0xb3838046}, {0xfffff133,0xb3838045},
 {0x9928a,0x51b8}, {0xd6b,0x4038}, {0x99ff5,0x91f0},
   {0x9851f,0x1180}, {0x99ff5,0x51b8}, {0x9851f,0x51b8},
 {0x59e2,0xf23}, {0xeed22a2,0x1e22}, {0xeed7c84,0x2d45},
   {0xf1133740,0xfffff100}, {0xeed7c84,0xf23}, {0xf1133740,0xf22},
 {0xacb98af8,0x6a67001e}, {0x850f9e43,0x670}, {0x31c9293b,0x6a67068f},
   {0x27a9ecb5,0x6a66f9ae}, {0x31c9293b,0x6a67001f}, {0x27a9ecb5,0x6a67001e},
 {0xffaddc6,0xdbdbb652}, {0x10ae,0x3437}, {0xffaee74,0xdbdbea89},
   {0xffacd18,0xdbdb821b}, {0xffaee74,0xdbdbb652}, {0xffacd18,0xdbdbb652},
 {0x6e74486,0x542b}, {0x2434,0x5eb9}, {0x6e768ba,0xb2e4},
   {0x6e72052,0xfffff572}, {0x6e768ba,0x542b}, {0x6e72052,0x542b},
 {0x54b8cf3e,0x538be645}, {0x3468,0x3b001f4b}, {0x54b903a6,0x8e8c0590},
   {0x54b89ad6,0x188bc6fa}, {0x54b903a6,0x538be645}, {0x54b89ad6,0x538be645},
 {0x5537,0x37bf}, {0x81439b5b,0x51f7}, {0x8143f092,0x89b6},
   {0x7ebcb9dc,0xffffe5c7}, {0x8143f092,0x37bf}, {0x7ebcb9dc,0x37be},
 {0xd90a5c47,0x8075b51d}, {0x350a5082,0xe6b86079}, {0xe14acc9,0x672e1597},
   {0xa4000bc5,0x99bd54a4}, {0xe14acc9,0x8075b51e}, {0xa4000bc5,0x8075b51d},
 {0xaefa1095,0x1ab1}, {0xb45e635d,0x15b5}, {0x635873f2,0x3067},
   {0xfa9bad38,0x4fb}, {0x635873f2,0x1ab2}, {0xfa9bad38,0x1ab0},
 {0x5123,0x452d}, {0x7a5b9b7,0x12b4}, {0x7a60ada,0x57e1},
   {0xf85a976c,0x3278}, {0x7a60ada,0x452d}, {0xf85a976c,0x452c},
 {0x82178bfa,0x5f5}, {0x7eb4,0x1900e060}, {0x82180aae,0x1900e655},
   {0x82170d46,0xe6ff2595}, {0x82180aae,0x5f5}, {0x82170d46,0x5f5},
 {0xf7f,0xd3ac5fd4}, {0x5a61,0x4b7d}, {0x69e0,0xd3acab51},
   {0xffffb51e,0xd3ac1456}, {0x69e0,0xd3ac5fd4}, {0xffffb51e,0xd3ac5fd3},
 {0x8cb89222,0x1f142593}, {0x14779135,0xe6eaa6d5}, {0xa1302357,0x5fecc68},
   {0x784100ed,0x38297ebe}, {0xa1302357,0x1f142593}, {0x784100ed,0x1f142593},
 {0x7643e002,0x10e1}, {0x70b7,0x5a3e}, {0x764450b9,0x6b1f},
   {0x76436f4b,0xffffb6a3}, {0x764450b9,0x10e1}, {0x76436f4b,0x10e1},
 {0x566d127c,0x58342103}, {0xd17fe869,0x7a98b73a}, {0x27ecfae5,0xd2ccd83e},
   {0x84ed2a13,0xdd9b69c8}, {0x27ecfae5,0x58342104}, {0x84ed2a13,0x58342102},
 {0xb21c66d5,0x4cb7}, {0x47a5,0x7f2d}, {0xb21cae7a,0xcbe4},
   {0xb21c1f30,0xffffcd8a}, {0xb21cae7a,0x4cb7}, {0xb21c1f30,0x4cb7},
 {0xdeb,0x2b1}, {0x15f4,0x2c6c}, {0x23df,0x2f1d},
   {0xfffff7f7,0xffffd644}, {0x23df,0x2b1}, {0xfffff7f7,0x2b0},
 {0x67bd,0x20e2}, {0x4230,0x52301976}, {0xa9ed,0x52303a58},
   {0x258d,0xadd0076c}, {0xa9ed,0x20e2}, {0x258d,0x20e2},
 {0x244070e0,0xa3}, {0x4cf0,0xd9c1018c}, {0x2440bdd0,0xd9c1022f},
   {0x244023f0,0x263eff17}, {0x2440bdd0,0xa3}, {0x244023f0,0xa3},
 {0xf0068269,0x3337}, {0x573190b,0xfe1}, {0xf5799b74,0x4318},
   {0xea93695e,0x2356}, {0xf5799b74,0x3337}, {0xea93695e,0x3337},
 {0x2562,0x58be}, {0x527c,0x7127}, {0x77de,0xc9e5},
   {0xffffd2e6,0xffffe796}, {0x77de,0x58be}, {0xffffd2e6,0x58bd},
 {0x1fa37607,0x6ba5c33a}, {0x1cf8,0x46a7}, {0x1fa392ff,0x6ba609e1},
   {0x1fa3590f,0x6ba57c93}, {0x1fa392ff,0x6ba5c33a}, {0x1fa3590f,0x6ba5c33a},
 {0x879bfc64,0x9fa8b539}, {0x5311724e,0x78da02b1}, {0xdaad6eb2,0x1882b7ea},
   {0x348a8a16,0x26ceb288}, {0xdaad6eb2,0x9fa8b539}, {0x348a8a16,0x9fa8b539},
 {0x70b6,0x93f}, {0xe5f911f9,0x4e23bcef}, {0xe5f982af,0x4e23c62e},
   {0x1a075ebd,0xb1dc4c4f}, {0xe5f982af,0x93f}, {0x1a075ebd,0x93e},
 {0x636427b6,0x28e1}, {0x3fa2,0x166e}, {0x63646758,0x3f4f},
   {0x6363e814,0x1273}, {0x63646758,0x28e1}, {0x6363e814,0x28e1},
 {0x3d33,0x5243139c}, {0xe6ce87d7,0x3ab4}, {0xe6cec50a,0x52434e50},
   {0x1931b55c,0x5242d8e7}, {0xe6cec50a,0x5243139c}, {0x1931b55c,0x5243139b},
 {0x4a76,0xeb42c147}, {0xf351e5d5,0x6ce9}, {0xf352304b,0xeb432e30},
   {0xcae64a1,0xeb42545d}, {0xf352304b,0xeb42c147}, {0xcae64a1,0xeb42c146},
 {0xd949b911,0x3f71}, {0x24fc,0x9dacc2d5}, {0xd949de0d,0x9dad0246},
   {0xd9499415,0x62537c9c}, {0xd949de0d,0x3f71}, {0xd9499415,0x3f71},
 {0x1aa5,0x6914d480}, {0xf0e91a2c,0x69f0}, {0xf0e934d1,0x69153e70},
   {0xf170079,0x69146a8f}, {0xf0e934d1,0x6914d480}, {0xf170079,0x6914d47f},
 {0x2e69,0x3872c7d3}, {0x3631,0x3779e439}, {0x649a,0x6fecac0c},
   {0xfffff838,0xf8e399}, {0x649a,0x3872c7d3}, {0xfffff838,0x3872c7d2},
 {0x74281228,0x1b76}, {0x2af3,0x673b}, {0x74283d1b,0x82b1},
   {0x7427e735,0xffffb43b}, {0x74283d1b,0x1b76}, {0x7427e735,0x1b76},
 {0x6970,0x4a3d}, {0x317be953,0x3535bf90}, {0x317c52c3,0x353609cd},
   {0xce84801d,0xcaca8aac}, {0x317c52c3,0x4a3d}, {0xce84801d,0x4a3c},
 {0x3821,0x16ef}, {0x5cf5ed51,0x294f6494}, {0x5cf62572,0x294f7b83},
   {0xa30a4ad0,0xd6b0b25a}, {0x5cf62572,0x16ef}, {0xa30a4ad0,0x16ee},
 {0x6ec06bad,0x7daf}, {0x20dcc12d,0x7dfb}, {0x8f9d2cda,0xfbaa},
   {0x4de3aa80,0xffffffb4}, {0x8f9d2cda,0x7daf}, {0x4de3aa80,0x7daf},
 {0xbd52e799,0x7b6da2fe}, {0x18b8,0x989c5689}, {0xbd530051,0x1409f987},
   {0xbd52cee1,0xe2d14c75}, {0xbd530051,0x7b6da2fe}, {0xbd52cee1,0x7b6da2fe},
 {0x4023,0x782eb1f6}, {0x3110f7d2,0x79257cbd}, {0x311137f5,0xf1542eb3},
   {0xceef4851,0xff093538}, {0x311137f5,0x782eb1f6}, {0xceef4851,0x782eb1f5},
 {0x5944686f,0x79e03d3b}, {0xc873ab8c,0x968bed40}, {0x21b813fb,0x106c2a7c},
   {0x90d0bce3,0xe3544ffa}, {0x21b813fb,0x79e03d3c}, {0x90d0bce3,0x79e03d3a},
 {0x5ba8a88,0x65c816f7}, {0x68ac,0xa71}, {0x5baf334,0x65c82168},
   {0x5ba21dc,0x65c80c86}, {0x5baf334,0x65c816f7}, {0x5ba21dc,0x65c816f7},
 {0xa5f8cee8,0xeb2b054d}, {0x2db70f88,0x45f1}, {0xd3afde70,0xeb2b4b3e},
   {0x7841bf60,0xeb2abf5c}, {0xd3afde70,0xeb2b054d}, {0x7841bf60,0xeb2b054d},
 {0xde91b9e5,0x173b}, {0x78e0,0x6920}, {0xde9232c5,0x805b},
   {0xde914105,0xffffae1b}, {0xde9232c5,0x173b}, {0xde914105,0x173b},
 {0x4bd965c,0x12272e1f}, {0x21e3,0x1ba565b7}, {0x4bdb83f,0x2dcc93d6},
   {0x4bd7479,0xf681c868}, {0x4bdb83f,0x12272e1f}, {0x4bd7479,0x12272e1f},
 {0x2df3,0x2ee8}, {0x32b6,0xdf7}, {0x60a9,0x3cdf},
   {0xfffffb3d,0x20f0}, {0x60a9,0x2ee8}, {0xfffffb3d,0x2ee7},
 {0xad99d46,0x537}, {0x38ffbd5a,0x7d20}, {0x43d95aa0,0x8257},
   {0xd1d9dfec,0xffff8816}, {0x43d95aa0,0x537}, {0xd1d9dfec,0x536},
 {0xc466a6ae,0x1ae45e3}, {0x1321,0x73e1}, {0xc466b9cf,0x1aeb9c4},
   {0xc466938d,0x1add202}, {0xc466b9cf,0x1ae45e3}, {0xc466938d,0x1ae45e3},
 {0x43bc,0x2fdc3a81}, {0x770,0x2b61}, {0x4b2c,0x2fdc65e2},
   {0x3c4c,0x2fdc0f20}, {0x4b2c,0x2fdc3a81}, {0x3c4c,0x2fdc3a81},
 {0x16550f4d,0xf0}, {0xab9b5603,0x55c510c5}, {0xc1f06550,0x55c511b5},
   {0x6ab9b94a,0xaa3af02a}, {0xc1f06550,0xf0}, {0x6ab9b94a,0xef},
 {0x4524,0x34c10c84}, {0x2f2c,0x524ba2a9}, {0x7450,0x870caf2d},
   {0x15f8,0xe27569db}, {0x7450,0x34c10c84}, {0x15f8,0x34c10c84},
 {0x8ba5ae2b,0x4fc}, {0x2677,0xbb7}, {0x8ba5d4a2,0x10b3},
   {0x8ba587b4,0xfffff945}, {0x8ba5d4a2,0x4fc}, {0x8ba587b4,0x4fc},
 {0xecdadfea,0x7229}, {0xea9cf2b2,0xdc95d041}, {0xd777d29c,0xdc96426b},
   {0x23ded38,0x236aa1e8}, {0xd777d29c,0x722a}, {0x23ded38,0x7229},
 {0xbf8891c1,0x48278c98}, {0xc38156cd,0x831967ac}, {0x8309e88e,0xcb40f445},
   {0xfc073af4,0xc50e24eb}, {0x8309e88e,0x48278c99}, {0xfc073af4,0x48278c97},
 {0xe03cbc5c,0xd120a19c}, {0x1670,0x3711ec03}, {0xe03cd2cc,0x8328d9f},
   {0xe03ca5ec,0x9a0eb599}, {0xe03cd2cc,0xd120a19c}, {0xe03ca5ec,0xd120a19c},
 {0x7cab,0x56f0}, {0x73e5,0x1db5}, {0xf090,0x74a5},
   {0x8c6,0x393b}, {0xf090,0x56f0}, {0x8c6,0x56f0},
 {0x233b,0x7731}, {0x5a33,0x7d6a366d}, {0x7d6e,0x7d6aad9e},
   {0xffffc908,0x829640c3}, {0x7d6e,0x7731}, {0xffffc908,0x7730},
 {0x2ff0,0x7720}, {0x47a3f2bf,0xca85ab31}, {0x47a422af,0xca862251},
   {0xb85c3d31,0x357acbee}, {0x47a422af,0x7720}, {0xb85c3d31,0x771f},
 {0x6afd,0x435}, {0x50f4e1b3,0x7cb3}, {0x50f54cb0,0x80e8},
   {0xaf0b894a,0xffff8781}, {0x50f54cb0,0x435}, {0xaf0b894a,0x434},
 {0x28459d18,0x70b0}, {0x7c21,0x2ffe}, {0x28461939,0xa0ae},
   {0x284520f7,0x40b2}, {0x28461939,0x70b0}, {0x284520f7,0x70b0},
 {0xc222f7a4,0x6a68285e}, {0x11d09ada,0x2f2b}, {0xd3f3927e,0x6a685789},
   {0xb0525cca,0x6a67f933}, {0xd3f3927e,0x6a68285e}, {0xb0525cca,0x6a68285e},
 {0x6721,0xf0b8977a}, {0x308428f8,0x563a}, {0x30849019,0xf0b8edb4},
   {0xcf7c3e29,0xf0b8413f}, {0x30849019,0xf0b8977a}, {0xcf7c3e29,0xf0b89779},
 {0x5335,0x35a794dc}, {0x40ebfbe4,0x3ee}, {0x40ec4f19,0x35a798ca},
   {0xbf145751,0x35a790ed}, {0x40ec4f19,0x35a794dc}, {0xbf145751,0x35a794db},
 {0x6faf,0xf583b826}, {0x53a2,0x3c7f}, {0xc351,0xf583f4a5},
   {0x1c0d,0xf5837ba7}, {0xc351,0xf583b826}, {0x1c0d,0xf583b826},
 {0x5cb8,0x1cf9}, {0x962a5941,0x2ced}, {0x962ab5f9,0x49e6},
   {0x69d60377,0xfffff00b}, {0x962ab5f9,0x1cf9}, {0x69d60377,0x1cf8},
 {0x6852f082,0x2d64e9e3}, {0xe23,0x6346a66e}, {0x6852fea5,0x90ab9051},
   {0x6852e25f,0xca1e4375}, {0x6852fea5,0x2d64e9e3}, {0x6852e25f,0x2d64e9e3},
 {0x80ef8458,0xd62b44ed}, {0xd41c3d8,0x2aa1}, {0x8e314830,0xd62b6f8e},
   {0x73adc080,0xd62b1a4c}, {0x8e314830,0xd62b44ed}, {0x73adc080,0xd62b44ed},
 {0x7ba8,0xb1c9f20}, {0x8784ae1e,0x2ee5}, {0x878529c6,0xb1cce05},
   {0x787bcd8a,0xb1c703a}, {0x878529c6,0xb1c9f20}, {0x787bcd8a,0xb1c9f1f},
 {0x1ced,0xf653ce80}, {0x2b1052b9,0x42452ffd}, {0x2b106fa6,0x3898fe7d},
   {0xd4efca34,0xb40e9e82}, {0x2b106fa6,0xf653ce80}, {0xd4efca34,0xf653ce7f},
 {0x5cb1,0xb914625e}, {0xa3abbc7,0x4b7170d0}, {0xa3b1878,0x485d32e},
   {0xf5c5a0ea,0x6da2f18d}, {0xa3b1878,0xb914625e}, {0xf5c5a0ea,0xb914625d},
 {0x212c,0x28ce72f3}, {0x51a99ca9,0x7b67}, {0x51a9bdd5,0x28ceee5a},
   {0xae568483,0x28cdf78b}, {0x51a9bdd5,0x28ce72f3}, {0xae568483,0x28ce72f2},
 {0x1ad5018b,0xa06dde3e}, {0x432b,0x4837613}, {0x1ad544b6,0xa4f15451},
   {0x1ad4be60,0x9bea682b}, {0x1ad544b6,0xa06dde3e}, {0x1ad4be60,0xa06dde3e},
 {0x78a5,0xc2803fc3}, {0x362f,0xd818ca14}, {0xaed4,0x9a9909d7},
   {0x4276,0xea6775af}, {0xaed4,0xc2803fc3}, {0x4276,0xc2803fc3},
 {0x927,0x6537}, {0x26ab1829,0x3251f935}, {0x26ab2150,0x32525e6c},
   {0xd954f0fe,0xcdae6c01}, {0x26ab2150,0x6537}, {0xd954f0fe,0x6536},
 {0x75ab322d,0xf34}, {0x797c,0xfc}, {0x75ababa9,0x1030},
   {0x75aab8b1,0xe38}, {0x75ababa9,0xf34}, {0x75aab8b1,0xf34},
 {0x5c815c5b,0x5ca7}, {0x1d598d26,0x1b83b0e0}, {0x79dae981,0x1b840d87},
   {0x3f27cf35,0xe47cabc7}, {0x79dae981,0x5ca7}, {0x3f27cf35,0x5ca7},
 {0xb8fa2bc9,0xc8aed088}, {0xc16856ad,0x7b06a448}, {0x7a628276,0x43b574d1},
   {0xf791d51c,0x4da82c3f}, {0x7a628276,0xc8aed089}, {0xf791d51c,0xc8aed087},
 {0x2d6c,0xec81de51}, {0x6e34,0xca6a6eb6}, {0x9ba0,0xb6ec4d07},
   {0xffffbf38,0x22176f9a}, {0x9ba0,0xec81de51}, {0xffffbf38,0xec81de50},
 {0x2b6f,0x50ec}, {0x686c,0x127}, {0x93db,0x5213},
   {0xffffc303,0x4fc4}, {0x93db,0x50ec}, {0xffffc303,0x50eb},
 {0xa0900d34,0xa25d97da}, {0xc9c29f78,0x4489d2c}, {0x6a52acac,0xa6a63507},
   {0xd6cd6dbc,0x9e14faad}, {0x6a52acac,0xa25d97db}, {0xd6cd6dbc,0xa25d97d9},
 {0x3bb2,0x6e28604b}, {0x934162df,0xc8e76402}, {0x93419e91,0x370fc44d},
   {0x6cbed8d3,0xa540fc48}, {0x93419e91,0x6e28604b}, {0x6cbed8d3,0x6e28604a},
 {0xd99f7c71,0x682e}, {0x6387d847,0x7dab}, {0x3d2754b8,0xe5da},
   {0x7617a42a,0xffffea83}, {0x3d2754b8,0x682f}, {0x7617a42a,0x682e},
 {0x3336,0x6165}, {0x4639,0x24af}, {0x796f,0x8614},
   {0xffffecfd,0x3cb5}, {0x796f,0x6165}, {0xffffecfd,0x6164},
 {0x33b8e79e,0x513f}, {0xe5156e32,0x2bb3}, {0x18ce55d0,0x7cf3},
   {0x4ea3796c,0x258b}, {0x18ce55d0,0x5140}, {0x4ea3796c,0x513e},
 {0xb1358c7c,0x5e7c}, {0x157b,0xea6c6eb2}, {0xb135a1f7,0xea6ccd2e},
   {0xb1357701,0x1593efca}, {0xb135a1f7,0x5e7c}, {0xb1357701,0x5e7c},
 {0xcb2f115e,0x4ae1}, {0x122c,0x192b}, {0xcb2f238a,0x640c},
   {0xcb2eff32,0x31b6}, {0xcb2f238a,0x4ae1}, {0xcb2eff32,0x4ae1},
 {0x31323d36,0x31fb}, {0x616d,0x5e31ad2a}, {0x31329ea3,0x5e31df25},
   {0x3131dbc9,0xa1ce84d1}, {0x31329ea3,0x31fb}, {0x3131dbc9,0x31fb},
 {0x9e05fd96,0x3160}, {0x3fd65a74,0x51e1c3}, {0xdddc580a,0x521323},
   {0x5e2fa322,0xffae4f9d}, {0xdddc580a,0x3160}, {0x5e2fa322,0x3160},
 {0xde19a9,0x1d7e6e64}, {0xfac6b862,0x50b4}, {0xfba4d20b,0x1d7ebf18},
   {0x6176147,0x1d7e1daf}, {0xfba4d20b,0x1d7e6e64}, {0x6176147,0x1d7e6e63},
 {0x2eb0,0x4a18b14c}, {0x4db6,0xa2155f19}, {0x7c66,0xec2e1065},
   {0xffffe0fa,0xa8035232}, {0x7c66,0x4a18b14c}, {0xffffe0fa,0x4a18b14b},
 {0x93b78500,0x3bb4}, {0xfd553658,0x36aa}, {0x910cbb58,0x725f},
   {0x96624ea8,0x509}, {0x910cbb58,0x3bb5}, {0x96624ea8,0x3bb3},
 {0xbf3,0x59b7}, {0x13aa,0xfb2d9436}, {0x1f9d,0xfb2deded},
   {0xfffff849,0x4d2c580}, {0x1f9d,0x59b7}, {0xfffff849,0x59b6},
 {0x34b6f0b2,0x2eaa}, {0x4330,0x1ebbefb2}, {0x34b733e2,0x1ebc1e5c},
   {0x34b6ad82,0xe1443ef8}, {0x34b733e2,0x2eaa}, {0x34b6ad82,0x2eaa},
 {0x7dcd139f,0x3fad}, {0x4f34,0x482ef3ff}, {0x7dcd62d3,0x482f33ac},
   {0x7dccc46b,0xb7d14bae}, {0x7dcd62d3,0x3fad}, {0x7dccc46b,0x3fad},
 {0xbfedefdc,0x3e0febbb}, {0x8f76bda1,0x2d7c0c39}, {0x4f64ad7d,0x6b8bf7f5},
   {0x3077323b,0x1093df82}, {0x4f64ad7d,0x3e0febbc}, {0x3077323b,0x3e0febbb},
 {0xaf836ab1,0x1dad880d}, {0xab0,0xb47de082}, {0xaf837561,0xd22b688f},
   {0xaf836001,0x692fa78b}, {0xaf837561,0x1dad880d}, {0xaf836001,0x1dad880d},
 {0x35036517,0x55ba}, {0x5bf7d445,0x3c67}, {0x90fb395c,0x9221},
   {0xd90b90d2,0x1952}, {0x90fb395c,0x55ba}, {0xd90b90d2,0x55b9},
 {0x7aa777b4,0x7e6f}, {0x35beadce,0x17f6f7e6}, {0xb0662582,0x17f77655},
   {0x44e8c9e6,0xe8098689}, {0xb0662582,0x7e6f}, {0x44e8c9e6,0x7e6f},
 {0x7ba1,0x27f7799a}, {0x13f798eb,0x790c54c}, {0x13f8148c,0x2f883ee6},
   {0xec08e2b6,0x2066b44d}, {0x13f8148c,0x27f7799a}, {0xec08e2b6,0x27f77999},
 {0x58e1,0x6e27}, {0xe6eb7521,0x6378}, {0xe6ebce02,0xd19f},
   {0x1914e3c0,0xaae}, {0xe6ebce02,0x6e27}, {0x1914e3c0,0x6e26},
 {0x85712612,0x3d7b}, {0x2de0,0xd6a6faa8}, {0x857153f2,0xd6a73823},
   {0x8570f832,0x295942d3}, {0x857153f2,0x3d7b}, {0x8570f832,0x3d7b},
 {0xdc0f5430,0x1b6}, {0x7a5458ad,0xb9d79d30}, {0x5663acdd,0xb9d79ee7},
   {0x61bafb83,0x46286486}, {0x5663acdd,0x1b7}, {0x61bafb83,0x1b6},
 {0x5fb7,0x7d9d5d85}, {0x2130,0x2a2b366b}, {0x80e7,0xa7c893f0},
   {0x3e87,0x5372271a}, {0x80e7,0x7d9d5d85}, {0x3e87,0x7d9d5d85},
 {0x6570,0xa4eb49a1}, {0x1d5b358,0x9c38b1a3}, {0x1d618c8,0x4123fb44},
   {0xfe2ab218,0x8b297fd}, {0x1d618c8,0xa4eb49a1}, {0xfe2ab218,0xa4eb49a0},
 {0xf39,0x196a}, {0x7b510ba2,0x688f58f3}, {0x7b511adb,0x688f725d},
   {0x84af0397,0x9770c076}, {0x7b511adb,0x196a}, {0x84af0397,0x1969},
 {0x6e278036,0x146e}, {0x786f,0xfe499e93}, {0x6e27f8a5,0xfe49b301},
   {0x6e2707c7,0x1b675db}, {0x6e27f8a5,0x146e}, {0x6e2707c7,0x146e},
 {0x1c98337e,0x1164}, {0xc2196906,0x582e}, {0xdeb19c84,0x6992},
   {0x5a7eca78,0xffffb935}, {0xdeb19c84,0x1164}, {0x5a7eca78,0x1163},
 {0x19fe,0x13b5}, {0x17fa,0x6906355b}, {0x31f8,0x69064910},
   {0x204,0x96f9de5a}, {0x31f8,0x13b5}, {0x204,0x13b5},
 {0xd1b46c10,0x20bd}, {0x6c73,0x60e1}, {0xd1b4d883,0x819e},
   {0xd1b3ff9d,0xffffbfdc}, {0xd1b4d883,0x20bd}, {0xd1b3ff9d,0x20bd}
};
#define NTESTS ((UINT) (sizeof abcdef / (sizeof abcdef[0] * 6)))
#undef ZERO
#undef ONE
#undef TWO
#undef THRE
#undef NEG1
#undef NEG2
#undef NEG3

int CompilerBuiltin(void);
int NoCompilerBuiltin(void);

void error(_TCHAR *Op,
           MY_UINT64 *a,
           MY_UINT64 *b,
           MY_UINT64 *c,
           MY_UINT64 *d,
           int i)
{
    _tprintf(_TEXT("a = { 0x%x, 0x%x }, "), *a);
    _tprintf(_TEXT("b = { 0x%x, 0x%x }, "), *b);
    _tprintf(_TEXT("a %s b = { 0x%x, 0x%x }\n\r"), Op, *c);
    _tprintf(_TEXT("  ==> a %s b should be { 0x%x, 0x%x }!!!\n\r"), Op, *d);
    _tprintf(_TEXT("64-bit unsigned addition test FAILED "));
    _tprintf(_TEXT("in iteration %d.\n\r"), i); 
}

#define MYERROR(o,a,b,c,d,i) error(o,(MY_UINT64*)&a,(MY_UINT64*)&b,(MY_UINT64*)&c,(MY_UINT64*)&d,i)

#define Test(_name_) \
int _name_(void)    \
{    \
    int i;    \
    MY_UINT64 *p;    \
    UINT64 a, b, c, d;    \
    UINT32 blo;    \
    int nPass, nFail;    \
    TIME Tstart, Tend;    \
    \
    Tstart = CurrentTime();    \
    \
    nPass = nFail = 0;    \
    p = abcdef;    \
    for (i = 0; i < NTESTS; i++) {    \
    \
        Int64FromHighAndLow(a, p->HighPart, p->LowPart);    \
        p++;    \
        blo = p->LowPart;    \
        Int64FromHighAndLow(b, p->HighPart, p->LowPart);    \
        p++;    \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64Add(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("+"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64Subtract(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("-"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64AddUint32(a,blo);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("+_"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64SubtractUint32(a,blo);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("-_"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
    }    \
    Tend = CurrentTime();    \
    \
    _tprintf(_TEXT("64-bit unsigned addition test "));    \
    if (nFail == 0) {    \
        _tprintf(_TEXT("PASSED.\n\r"));    \
    \
    } else {    \
        _tprintf(_TEXT("FAILED (%d fail %d pass).\n\r"),    \
                 nFail, nPass);    \
    }    \
    \
    i = TimeDifference(Tend,Tstart);    \
    _tprintf(_TEXT("Took %d microseconds for %d tests (%d/test)\n\r"),    \
             i / 10,    \
             4*NTESTS,    \
             i / (4*NTESTS*10));    \
    return nFail;    \
}


/* In any event, test the os-supported routines.
 * If the compiler supports it, repeat for the builtin routines.
 */
int _tmain()
{
    int nFail = 0;

    _tprintf(_TEXT("\n\rTesting os-supported 64bit unsigned addition.\n\r"));
    nFail = NoCompilerBuiltin();

#if !defined(__NO_BUILTIN_INT64)
    _tprintf(_TEXT("\n\rTesting compiler-supported 64bit unsigned addition.\n\r"));
    nFail += CompilerBuiltin();
#endif

    if (nFail)
        _tprintf(_TEXT("Test FAILED, %d errors.\n\r"), nFail);

    exit ((nFail == 0) ? EXIT_SUCCESS : EXIT_FAILURE);
    return 0;/*amusme*/
}

#include "tst64again.c"

