/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * C test program -- unsigned 64-bit nodulus function Uint64ModulusUint64()
 */

#if defined(MMLITE)
#include <mmlite.h>
#define XXXX 1

#else
#include <windows.h>
#define i386 /* uhu? */
#define EXTERN_C extern
#include "int64.h"
typedef INT64 TIME;
TIME CurrentTime(void)
{
    TIME t;
    Int64FromHighAndLow(t,0,GetCurrentTime());
#define XXXX 10000
    return t;
}
#endif

/* Was useful for testing under Win32 */
UINT32 TimeDifference(TIME Stop, TIME Start)
{
    UINT32 r;
    Stop = TimeSubtract(Stop,Start);
    r = ((UINT32) Int64ToInt32(Stop) ) * XXXX;
    return r;
}

#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* grumble.. */
typedef struct
    {
    UINT32 LowPart;
    UINT32 HighPart;
    }   MY_UINT64;


MY_UINT64 abc[] = {
/*0*/ { 0x80000000, 0xffffc88a }, { 0x649f0000, 0x0 }, { 0x16570000, 0x0 },
/*1*/ { 0x80000000, 0xffffe14d }, { 0x54000000, 0x10 }, { 0x2c000000, 0x10 },
/*2*/ { 0x80000000, 0xffffc467 }, { 0x91800000, 0x0 }, { 0x7d800000, 0x0 },
#if defined(i386) || defined(mips) || defined(ppc)
  /* On the i386 the hardware division exists, and generates a trap
   * on zero-divide. Since we dont support any exception reporting/handling
   * mechanism there is no way to cope with this case in a sensible way.
   *
   * Division by zero is undefined so the test is meaningless on the Tigon.
   *
   * Division does not trap on PPC, but the compiler makes sure it does.
   */
#else
  { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
#endif
/*3*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*4*/ { 0x0, 0x0 }, { 0xffffffff, 0xffffffff }, { 0x0, 0x0 },
/*5*/ { 0x0, 0x0 }, { 0x0, 0x80000000 }, { 0x0, 0x0 },
/*6*/ { 0x0, 0x0 }, { 0xffffffff, 0x7fffffff }, { 0x0, 0x0 },
/*7*/ { 0x0, 0x0 }, { 0x1, 0x80000000 }, { 0x0, 0x0 },
/*8*/ { 0x1, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*9*/ { 0x1, 0x0 }, { 0xffffffff, 0xffffffff }, { 0x1, 0x0 },
/*10*/ { 0xffffffff, 0xffffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*11*/ { 0xffffffff, 0xffffffff }, { 0xffffffff, 0xffffffff }, { 0x0, 0x0 },
/*12*/ { 0x1, 0x0 }, { 0x2, 0x0 }, { 0x1, 0x0 },
/*13*/ { 0x1, 0x0 }, { 0xfffffffe, 0xffffffff }, { 0x1, 0x0 },
/*14*/ { 0xffffffff, 0xffffffff }, { 0x2, 0x0 }, { 0x1, 0x0 },
/*15*/ { 0xffffffff, 0xffffffff }, { 0xfffffffe, 0xffffffff }, { 0x1, 0x0 },
/*16*/ { 0x2, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*17*/ { 0x2, 0x0 }, { 0xffffffff, 0xffffffff }, { 0x2, 0x0 },
/*18*/ { 0xfffffffe, 0xffffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*19*/ { 0xfffffffe, 0xffffffff }, { 0xffffffff, 0xffffffff }, { 0xfffffffe, 0xffffffff },
/*20*/ { 0x0, 0x80000000 }, { 0x1, 0x0 }, { 0x0, 0x0 },
#if !defined(ppc)
    /* This traps on PPC */
/*21*/ { 0x0, 0x80000000 }, { 0xffffffff, 0xffffffff }, { 0x0, 0x80000000 },
#endif
/*22*/ { 0x1, 0x80000000 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*23*/ { 0x1, 0x80000000 }, { 0xffffffff, 0xffffffff }, { 0x1, 0x80000000 },
/*24*/ { 0xffffffff, 0x7fffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*25*/ { 0xffffffff, 0x7fffffff }, { 0xffffffff, 0xffffffff }, { 0xffffffff, 0x7fffffff },
/*26*/ { 0x0, 0x80000000 }, { 0x0, 0x80000000 }, { 0x0, 0x0 },
/*27*/ { 0xffffffff, 0x7fffffff }, { 0x0, 0x80000000 }, { 0xffffffff, 0x7fffffff },
/*28*/ { 0x0, 0x80000000 }, { 0xffffffff, 0x7fffffff }, { 0x1, 0x0 },
/*29*/ { 0xffffffff, 0x7fffffff }, { 0xffffffff, 0x7fffffff }, { 0x0, 0x0 },
/*30*/ { 0x1, 0x80000000 }, { 0x0, 0x80000000 }, { 0x1, 0x0 },
/*31*/ { 0x0, 0x80000000 }, { 0x1, 0x80000000 }, { 0x0, 0x80000000 },
/*32*/ { 0x1, 0x80000000 }, { 0x1, 0x80000000 }, { 0x0, 0x0 },
/*33*/ { 0xffffb51f, 0xffff987b }, { 0x4823, 0x29 }, { 0x9693a169, 0x17 },
/*34*/ { 0x6df1, 0x0 }, { 0x6952, 0x0 }, { 0x49f, 0x0 },
/*35*/ { 0xffffed25, 0xffffd159 }, { 0x1eb, 0x26e9 }, { 0xf3618522, 0x4e8 },
/*36*/ { 0x305e, 0x0 }, { 0xfffff0c2, 0xffffffff }, { 0x305e, 0x0 },
/*37*/ { 0x37, 0x0 }, { 0x33, 0x0 }, { 0x4, 0x0 },
/*38*/ { 0x6443, 0x4dc8 }, { 0x26a6, 0x428b }, { 0x3d9d, 0xb3d },
/*39*/ { 0x125, 0x0 }, { 0x7d, 0x0 }, { 0x2b, 0x0 },
/*40*/ { 0x7ff5, 0x7f96 }, { 0x63cb, 0x1ad4 }, { 0xfffef0c9, 0x1445 },
/*41*/ { 0x1c, 0x0 }, { 0xd, 0x0 }, { 0x2, 0x0 },
/*42*/ { 0xffffdd12, 0xffffffff }, { 0xfffffee0, 0xffffffff }, { 0xffffdd12, 0xffffffff },
/*43*/ { 0x5f32, 0x0 }, { 0x5cfd, 0x0 }, { 0x235, 0x0 },
/*44*/ { 0xffffa0b7, 0xffffffff }, { 0x314f, 0x0 }, { 0x2f86, 0x0 },
/*45*/ { 0xffffc995, 0xffffffef }, { 0xffffd1c0, 0xfffffffb }, { 0xffffc995, 0xffffffef },
/*46*/ { 0x6032, 0x7eb7 }, { 0x5422, 0x15a1 }, { 0xfffebb88, 0x1291 },
/*47*/ { 0x409d, 0x1 }, { 0xffffede1, 0xfffffffe }, { 0x409d, 0x1 },
/*48*/ { 0x2, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*49*/ { 0x4a80, 0x692c }, { 0x6899, 0x16c5 }, { 0xfffea81c, 0xe17 },
/*50*/ { 0x48cc, 0x3c9 }, { 0x5db2, 0x80 }, { 0xfffdb8ee, 0x48 },
/*51*/ { 0x3cd6, 0x5c67 }, { 0x6ad6, 0x2f14 }, { 0xffffd200, 0x2d52 },
/*52*/ { 0x368e, 0x1c }, { 0x75ef, 0x3 }, { 0xfffc1127, 0x0 },
/*53*/ { 0x3a61, 0x8f }, { 0x2fff, 0x61 }, { 0xa62, 0x2e },
/*54*/ { 0x6172, 0x0 }, { 0x5e9d, 0x0 }, { 0x2d5, 0x0 },
/*55*/ { 0xa, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*56*/ { 0x1953, 0x542c }, { 0x6be8, 0x18d7 }, { 0xfffed59b, 0x9a6 },
/*57*/ { 0xffffdb62, 0xffff878b }, { 0xffffa0e2, 0xfffff1ed }, { 0xffffdb62, 0xffff878b },
/*58*/ { 0x6ad4, 0x0 }, { 0x5fa4, 0x0 }, { 0xb30, 0x0 },
/*59*/ { 0xffffe50c, 0xffff92dd }, { 0x7cf, 0x35 }, { 0x4883f2da, 0x32 },
/*60*/ { 0xe90, 0x1d3 }, { 0x57d3, 0x48 }, { 0xfffdff9e, 0x22 },
/*61*/ { 0xffffc81b, 0xffffffff }, { 0x19d9, 0x0 }, { 0x16d4, 0x0 },
/*62*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*63*/ { 0x3a8d, 0x0 }, { 0x2b00, 0x0 }, { 0xf8d, 0x0 },
/*64*/ { 0x33, 0x0 }, { 0x15, 0x0 }, { 0x9, 0x0 },
/*65*/ { 0xffff9d90, 0xffffffff }, { 0x5064, 0x0 }, { 0x9e8, 0x0 },
/*66*/ { 0xffff95eb, 0xffff9296 }, { 0x4c85, 0x3bb1 }, { 0xb7d45063, 0x12d },
/*67*/ { 0x470e, 0x0 }, { 0x3004, 0x0 }, { 0x170a, 0x0 },
/*68*/ { 0x2cf7, 0xd4 }, { 0x4d67, 0x2f }, { 0xfffef75b, 0x17 },
/*69*/ { 0x4e57, 0xd0 }, { 0x66fa, 0x76 }, { 0xffffe75d, 0x59 },
/*70*/ { 0x74ad, 0x2f11 }, { 0x588, 0x1d24 }, { 0x6f25, 0x11ed },
/*71*/ { 0xffffb725, 0xffffffed }, { 0xfffff21b, 0xfffffffc }, { 0xffffb725, 0xffffffed },
/*72*/ { 0x13d3, 0x0 }, { 0x9ce, 0x0 }, { 0x37, 0x0 },
/*73*/ { 0x3b97, 0x0 }, { 0x3960, 0x0 }, { 0x237, 0x0 },
/*74*/ { 0x7ac2, 0x9d0 }, { 0x5e76, 0x959 }, { 0x1c4c, 0x77 },
/*75*/ { 0xd4, 0x0 }, { 0xffffff87, 0xffffffff }, { 0xd4, 0x0 },
/*76*/ { 0x293b, 0x0 }, { 0x940, 0x0 }, { 0x43b, 0x0 },
/*77*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*78*/ { 0xf97, 0x0 }, { 0xf1, 0x0 }, { 0x87, 0x0 },
/*79*/ { 0xffffffff, 0xffffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*80*/ { 0x6486, 0x0 }, { 0x5fa8, 0x0 }, { 0x4de, 0x0 },
/*81*/ { 0x50bf, 0x0 }, { 0x10d9, 0x0 }, { 0xd5b, 0x0 },
/*82*/ { 0x390, 0x4e55 }, { 0xffffae2f, 0xfffff8d7 }, { 0x390, 0x4e55 },
/*83*/ { 0xffffb39a, 0xffffffff }, { 0xfffffe1f, 0xffffffff }, { 0xffffb39a, 0xffffffff },
/*84*/ { 0x1bd9, 0x4efe }, { 0x4fe2, 0x159f }, { 0xffff2c33, 0xe20 },
/*85*/ { 0xffffbc9b, 0xffff98b8 }, { 0x549b, 0x2f0c }, { 0x33a1a407, 0x8e7 },
/*86*/ { 0x2079, 0x182 }, { 0x1289, 0x146 }, { 0xdf0, 0x3c },
/*87*/ { 0x4626, 0x1 }, { 0x36c2, 0x0 }, { 0x27fa, 0x0 },
/*88*/ { 0x64e0, 0x2462 }, { 0x676d, 0xe29 }, { 0xffff9606, 0x80f },
/*89*/ { 0x1d3f, 0x6da6 }, { 0x4ebf, 0x5f34 }, { 0xffffce80, 0xe71 },
/*90*/ { 0xfffff594, 0xffffffff }, { 0x56d, 0x0 }, { 0x342, 0x0 },
/*91*/ { 0x2120, 0x0 }, { 0x12c2, 0x0 }, { 0xe5e, 0x0 },
/*92*/ { 0x7, 0x0 }, { 0x4, 0x0 }, { 0x3, 0x0 },
/*93*/ { 0x6b28, 0x1 }, { 0xffffa73b, 0xfffffffe }, { 0x6b28, 0x1 },
/*94*/ { 0x1edc, 0x3308 }, { 0xffffbcba, 0xffffff71 }, { 0x1edc, 0x3308 },
/*95*/ { 0xeb, 0x71f2 }, { 0x78fe, 0x578d }, { 0xffff87ed, 0x1a64 },
/*96*/ { 0xffffb630, 0xffff9b5f }, { 0x3106, 0x1c75 }, { 0x46fc7566, 0x107b },
/*97*/ { 0x5478, 0xa87 }, { 0x67d0, 0x84d }, { 0xffffeca8, 0x239 },
/*98*/ { 0x3, 0x0 }, { 0xffffffff, 0xffffffff }, { 0x3, 0x0 },
/*99*/ { 0xaf0, 0x5a70 }, { 0xffff90d0, 0xfffffc05 }, { 0xaf0, 0x5a70 },
/*100*/ { 0xffffb0a5, 0xffffffff }, { 0x2332, 0x0 }, { 0x1fe1, 0x0 },
/*101*/ { 0x58e6, 0x2f0b }, { 0x1eca, 0x13f5 }, { 0x1b52, 0x721 },
/*102*/ { 0x389, 0x0 }, { 0xffffffe5, 0xffffffff }, { 0x389, 0x0 },
/*103*/ { 0xffff9098, 0xffff9cb0 }, { 0x7b, 0x3a72 }, { 0xfde4cf28, 0x2710 },
/*104*/ { 0x7d3, 0x0 }, { 0xffffffbc, 0xffffffff }, { 0x7d3, 0x0 },
/*105*/ { 0x4f66, 0x0 }, { 0x190b, 0x0 }, { 0x445, 0x0 },
/*106*/ { 0xfffffafd, 0xffffffff }, { 0x45e, 0x0 }, { 0x361, 0x0 },
/*107*/ { 0x3605, 0x48e6 }, { 0x4a0e, 0x4531 }, { 0xffffebf7, 0x3b4 },
/*108*/ { 0x1927, 0x65ca }, { 0xffffd32b, 0xffffcd30 }, { 0x1927, 0x65ca },
/*109*/ { 0x1279, 0x0 }, { 0x914, 0x0 }, { 0x51, 0x0 },
/*110*/ { 0x6af8, 0x0 }, { 0xffffc784, 0xffffffff }, { 0x6af8, 0x0 },
/*111*/ { 0x7020, 0x7 }, { 0x17b8, 0x4 }, { 0x5868, 0x3 },
/*112*/ { 0x504c, 0x3895 }, { 0x248d, 0x65a }, { 0xffff2be4, 0x5c4 },
/*113*/ { 0x3260, 0x72b1 }, { 0x5ae7, 0x7299 }, { 0xffffd779, 0x17 },
/*114*/ { 0xe9, 0x0 }, { 0xad, 0x0 }, { 0x3c, 0x0 },
/*115*/ { 0x5718, 0x0 }, { 0x11d5, 0x0 }, { 0xfc4, 0x0 },
/*116*/ { 0x424c, 0x3e }, { 0xe00, 0x2 }, { 0xfffe9e4c, 0x1 },
/*117*/ { 0xb93, 0x5804 }, { 0x38f, 0x9b3 }, { 0xffffeb8c, 0xb8 },
/*118*/ { 0x27e, 0x0 }, { 0x243, 0x0 }, { 0x3b, 0x0 },
/*119*/ { 0x4ecf, 0x0 }, { 0xc95, 0x0 }, { 0x351, 0x0 },
/*120*/ { 0x3b65, 0x3e }, { 0x43f6, 0x2a }, { 0xfffff76f, 0x13 },
/*121*/ { 0x15b4, 0x6 }, { 0xffffce42, 0xfffffffe }, { 0x15b4, 0x6 },
/*122*/ { 0x1b32, 0x6469 }, { 0x12c, 0x3e09 }, { 0x1a06, 0x2660 },
/*123*/ { 0x6bdb, 0x0 }, { 0xffff9ee9, 0xffffffff }, { 0x6bdb, 0x0 },
/*124*/ { 0xfffff928, 0xffffffff }, { 0x181, 0x0 }, { 0xbd, 0x0 },
/*125*/ { 0xffffb198, 0xffffffff }, { 0xfffffc07, 0xffffffff }, { 0xffffb198, 0xffffffff },
/*126*/ { 0x6778, 0x0 }, { 0x3371, 0x0 }, { 0x96, 0x0 },
/*127*/ { 0x1d, 0x0 }, { 0x19, 0x0 }, { 0x4, 0x0 },
/*128*/ { 0xffffa9e4, 0xffff978b }, { 0x2237, 0x14f }, { 0xda989cf9, 0x14e },
/*129*/ { 0xffffa321, 0xffffffff }, { 0xffffd06b, 0xffffffff }, { 0xffffa321, 0xffffffff },
/*130*/ { 0x7b8b, 0x63d9 }, { 0x448d, 0x176d }, { 0xffff6957, 0x624 },
/*131*/ { 0x5079, 0x16 }, { 0x7a08, 0x11 }, { 0xffffd671, 0x4 },
/*132*/ { 0xffffea1f, 0xffff9b1f }, { 0x2015, 0x21eb }, { 0xddbca6e, 0x20d0 },
/*133*/ { 0x275b, 0xff4 }, { 0x673c, 0xa6e }, { 0xffffc01f, 0x585 },
/*134*/ { 0x1f7, 0x5c }, { 0x188f, 0xa }, { 0xffff24f0, 0x1 },
/*135*/ { 0xffff949f, 0xffffa964 }, { 0xfffff6c5, 0xffffe9b5 }, { 0xffff949f, 0xffffa964 },
/*136*/ { 0x1dc3, 0x63c6 }, { 0xffffe5d0, 0xffffe258 }, { 0x1dc3, 0x63c6 },
/*137*/ { 0x12f, 0x603 }, { 0x6275, 0x2ee }, { 0xffff3c45, 0x26 },
/*138*/ { 0x45c8, 0x0 }, { 0x3510, 0x0 }, { 0x10b8, 0x0 },
/*139*/ { 0x2e9, 0x0 }, { 0x28, 0x0 }, { 0x19, 0x0 },
/*140*/ { 0x81, 0x0 }, { 0xffffff94, 0xffffffff }, { 0x81, 0x0 },
/*141*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*142*/ { 0x7, 0x0 }, { 0x2, 0x0 }, { 0x1, 0x0 },
/*143*/ { 0x6959, 0x2d50 }, { 0x1c, 0x15bd }, { 0x6921, 0x1d6 },
/*144*/ { 0x675f, 0x0 }, { 0xb7f, 0x0 }, { 0xb67, 0x0 },
/*145*/ { 0x52e5, 0x0 }, { 0x2c4e, 0x0 }, { 0x2697, 0x0 },
/*146*/ { 0x3742, 0x5198 }, { 0xffffcdd5, 0xffffe0f2 }, { 0x3742, 0x5198 },
/*147*/ { 0x4673, 0x512f }, { 0x69bb, 0x2ec }, { 0xfff51fba, 0x24a },
/*148*/ { 0x3d84, 0x0 }, { 0x267d, 0x0 }, { 0x1707, 0x0 },
/*149*/ { 0x60be, 0x0 }, { 0x5b16, 0x0 }, { 0x5a8, 0x0 },
/*150*/ { 0xffffb07d, 0xffffffff }, { 0x2518, 0x0 }, { 0x7c5, 0x0 },
/*151*/ { 0xfffff8f2, 0xffffffff }, { 0xfffffcd2, 0xffffffff }, { 0xfffff8f2, 0xffffffff },
/*152*/ { 0xffffe093, 0xffffffff }, { 0xfca, 0x0 }, { 0x8e1, 0x0 },
/*153*/ { 0xffffbf4b, 0xffff8a72 }, { 0xffff8b8c, 0xffffaf6d }, { 0xffffbf4b, 0xffff8a72 },
/*154*/ { 0xffff87a2, 0xfffffe2a }, { 0x19fc, 0x40 }, { 0x1000717e, 0x3 },
/*155*/ { 0x4736, 0x0 }, { 0x54b, 0x0 }, { 0x267, 0x0 },
/*156*/ { 0x7f7d, 0x0 }, { 0x672, 0x0 }, { 0x507, 0x0 },
/*157*/ { 0x2871, 0x8d }, { 0x36b8, 0x8c }, { 0xfffff1b9, 0x0 },
/*158*/ { 0xffffc850, 0xffff9940 }, { 0xffffc051, 0xffffeab1 }, { 0xffffc850, 0xffff9940 },
/*159*/ { 0xffffef8b, 0xffffffe2 }, { 0x7210, 0x1c }, { 0x24a3a96b, 0x18 },
/*160*/ { 0x5df2, 0x0 }, { 0xffffc460, 0xffffffff }, { 0x5df2, 0x0 },
/*161*/ { 0xffff96e3, 0xffff8c34 }, { 0x6f49, 0xde9 }, { 0xfff0f6cb, 0x514 },
/*162*/ { 0x77d2, 0x555 }, { 0x1b0b, 0x51a }, { 0x5cc7, 0x3b },
/*163*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*164*/ { 0x62e1, 0xad }, { 0x6788, 0x35 }, { 0xffff2c49, 0xd },
/*165*/ { 0x7ae5, 0x0 }, { 0xffffe8ce, 0xffffffff }, { 0x7ae5, 0x0 },
/*166*/ { 0x62b5, 0x0 }, { 0xf77, 0x0 }, { 0x5eb, 0x0 },
/*167*/ { 0x3b0d, 0x0 }, { 0x396c, 0x0 }, { 0x1a1, 0x0 },
/*168*/ { 0x7268, 0x0 }, { 0x479a, 0x0 }, { 0x2ace, 0x0 },
/*169*/ { 0x20bc, 0x6 }, { 0x50e6, 0x5 }, { 0xffffcfd6, 0x0 },
/*170*/ { 0x652a, 0x0 }, { 0xffffb93d, 0xffffffff }, { 0x652a, 0x0 },
/*171*/ { 0xfffffffc, 0xffffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*172*/ { 0x6bb, 0x3dae }, { 0xffff9da0, 0xffffffe3 }, { 0x6bb, 0x3dae },
/*173*/ { 0x2c45, 0x0 }, { 0x75d, 0x0 }, { 0x17, 0x0 },
/*174*/ { 0x7da8, 0x0 }, { 0x3d0d, 0x0 }, { 0x38e, 0x0 },
/*175*/ { 0x2784, 0x0 }, { 0x1255, 0x0 }, { 0x2da, 0x0 },
/*176*/ { 0x20d5, 0x72ed }, { 0xffff97c9, 0xfffffa07 }, { 0x20d5, 0x72ed },
/*177*/ { 0xffff93df, 0xffff8e60 }, { 0xffff93b2, 0xffffe2a3 }, { 0xffff93df, 0xffff8e60 },
/*178*/ { 0x17b0, 0x0 }, { 0x1785, 0x0 }, { 0x2b, 0x0 },
/*179*/ { 0x74b1, 0xe }, { 0x7fe9, 0x5 }, { 0xffff74df, 0x3 },
/*180*/ { 0x12c6, 0xb8b }, { 0x15e2, 0x466 }, { 0xffffe702, 0x2be },
/*181*/ { 0x5e32, 0x0 }, { 0xfffffc0c, 0xffffffff }, { 0x5e32, 0x0 },
/*182*/ { 0x3002, 0x1c04 }, { 0x71e0, 0x152c }, { 0xffffbe22, 0x6d7 },
/*183*/ { 0x3, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*184*/ { 0x92, 0x0 }, { 0x1c, 0x0 }, { 0x6, 0x0 },
/*185*/ { 0x2737, 0x0 }, { 0x4fb, 0x0 }, { 0x45a, 0x0 },
/*186*/ { 0x126, 0x0 }, { 0xffffff0a, 0xffffffff }, { 0x126, 0x0 },
/*187*/ { 0x19ca, 0x0 }, { 0xf55, 0x0 }, { 0xa75, 0x0 },
/*188*/ { 0xffffff94, 0xffffffff }, { 0xffffffc1, 0xffffffff }, { 0xffffff94, 0xffffffff },
/*189*/ { 0x223a, 0x0 }, { 0xfffffde4, 0xffffffff }, { 0x223a, 0x0 },
/*190*/ { 0xffffc9e5, 0xffff9b1b }, { 0x7aba, 0x47dd }, { 0x4acfe011, 0x3930 },
/*191*/ { 0xffffa038, 0xffffffff }, { 0xffffbde3, 0xffffffff }, { 0xffffa038, 0xffffffff },
/*192*/ { 0x318, 0x50c3 }, { 0x624a, 0x3b2b }, { 0xffffa0ce, 0x1597 },
/*193*/ { 0x2c4, 0x0 }, { 0x26a, 0x0 }, { 0x5a, 0x0 },
/*194*/ { 0x3, 0x0 }, { 0xfffffffd, 0xffffffff }, { 0x3, 0x0 },
/*195*/ { 0x11a, 0x0 }, { 0x65, 0x0 }, { 0x50, 0x0 },
/*196*/ { 0x3105, 0x773c }, { 0x7cb3, 0x14a }, { 0xffd360b1, 0xa3 },
/*197*/ { 0x47a1, 0x0 }, { 0x2a9e, 0x0 }, { 0x1d03, 0x0 },
/*198*/ { 0xd, 0x0 }, { 0xa, 0x0 }, { 0x3, 0x0 },
/*199*/ { 0x6ff8, 0x0 }, { 0xffffd8ec, 0xffffffff }, { 0x6ff8, 0x0 },
/*200*/ { 0xffffb4af, 0xffffe897 }, { 0x47c5, 0x3c0 }, { 0xdc89fef9, 0x4 },
/*201*/ { 0xffffe797, 0xfffff26b }, { 0x5d12, 0x694 }, { 0xd9ffa5dd, 0x3b9 },
/*202*/ { 0x4f41, 0x5 }, { 0x3af, 0x3 }, { 0x4b92, 0x2 },
/*203*/ { 0x1da1, 0x0 }, { 0xfffff9b1, 0xffffffff }, { 0x1da1, 0x0 },
/*204*/ { 0x25c, 0x0 }, { 0x1fd, 0x0 }, { 0x5f, 0x0 },
/*205*/ { 0xe, 0x0 }, { 0xfffffff7, 0xffffffff }, { 0xe, 0x0 },
/*206*/ { 0x224b, 0x7836 }, { 0xffff90a2, 0xffffb41d }, { 0x224b, 0x7836 },
/*207*/ { 0xffffff96, 0xffffffff }, { 0x2f, 0x0 }, { 0xd, 0x0 },
/*208*/ { 0x68c5, 0x0 }, { 0x116c, 0x0 }, { 0x3d, 0x0 },
/*209*/ { 0x1d, 0x0 }, { 0xa, 0x0 }, { 0x9, 0x0 },
/*210*/ { 0xffffa471, 0xffffd267 }, { 0xfffff64f, 0xfffffd0d }, { 0xffffa471, 0xffffd267 },
/*211*/ { 0x174f, 0x0 }, { 0x774, 0x0 }, { 0xf3, 0x0 },
/*212*/ { 0x1454, 0x2742 }, { 0x3be, 0x10df }, { 0xcd8, 0x584 },
/*213*/ { 0xffffb6f4, 0xffffff99 }, { 0xffffaae5, 0xffffffe3 }, { 0xffffb6f4, 0xffffff99 },
/*214*/ { 0x666e, 0x0 }, { 0xfffff289, 0xffffffff }, { 0x666e, 0x0 },
/*215*/ { 0xffff96bc, 0xffff9058 }, { 0xffffa9fe, 0xffffb9c1 }, { 0xffff96bc, 0xffff9058 },
/*216*/ { 0xffff824a, 0xffff8678 }, { 0x22dd, 0x4c22 }, { 0x8ac50874, 0xb1c },
/*217*/ { 0xffffc19f, 0xffffb322 }, { 0xffffc2c3, 0xffffe291 }, { 0xffffc19f, 0xffffb322 },
/*218*/ { 0x7dc4, 0x67 }, { 0x1e2f, 0x3c }, { 0x5f95, 0x2b },
/*219*/ { 0x44cc, 0x0 }, { 0xffffd370, 0xffffffff }, { 0x44cc, 0x0 },
/*220*/ { 0x761e, 0x1c11 }, { 0x5341, 0x74b }, { 0xffff7c5b, 0x62f },
/*221*/ { 0x2bb8, 0x1 }, { 0x83f, 0x0 }, { 0x4c2, 0x0 },
/*222*/ { 0x4d51, 0x531 }, { 0xffff94b7, 0xfffffd56 }, { 0x4d51, 0x531 },
/*223*/ { 0x19, 0x0 }, { 0xe, 0x0 }, { 0xb, 0x0 },
/*224*/ { 0x381c, 0x1e }, { 0x2277, 0xe }, { 0xfffff32e, 0x1 },
/*225*/ { 0x10a, 0x0 }, { 0xd3, 0x0 }, { 0x37, 0x0 },
/*226*/ { 0x7f10, 0x0 }, { 0x1ef6, 0x0 }, { 0x338, 0x0 },
/*227*/ { 0xab6, 0x5326 }, { 0xffffd97c, 0xffffe3d2 }, { 0xab6, 0x5326 },
/*228*/ { 0x4802, 0x0 }, { 0xdaf, 0x0 }, { 0x397, 0x0 },
/*229*/ { 0x6fc6, 0xde }, { 0x759, 0xba }, { 0x686d, 0x24 },
/*230*/ { 0x4f36, 0x5147 }, { 0x65cf, 0xa65 }, { 0xfffd868d, 0x883 },
/*231*/ { 0xffffe167, 0xfffffffd }, { 0x7d4b, 0x1 }, { 0x3d532ff6, 0x0 },
/*232*/ { 0x22e0, 0x65c0 }, { 0x5d20, 0x3091 }, { 0xffff68a0, 0x49d },
/*233*/ { 0xffff8312, 0xffffaa7b }, { 0xffffd2b1, 0xffffb29d }, { 0xffff8312, 0xffffaa7b },
/*234*/ { 0x7a0c, 0x1 }, { 0xffffdbdc, 0xffffffff }, { 0x7a0c, 0x1 },
/*235*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*236*/ { 0xbd, 0x9 }, { 0x77b8, 0x4 }, { 0xffff114d, 0x0 },
/*237*/ { 0x6, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*238*/ { 0xffff80e0, 0xffffcd7c }, { 0x4574, 0x1337 }, { 0x62acde94, 0xce0 },
/*239*/ { 0x57fd, 0x3 }, { 0xffffe2bc, 0xfffffffd }, { 0x57fd, 0x3 },
/*240*/ { 0x7b09, 0x0 }, { 0x618, 0x0 }, { 0x129, 0x0 },
/*241*/ { 0x4975, 0x7b34 }, { 0x339a, 0x3450 }, { 0xffffe241, 0x1293 },
/*242*/ { 0xffff8705, 0xffff969c }, { 0x4ee1, 0x49 }, { 0x62a3affa, 0x5 },
/*243*/ { 0x3a2c, 0x0 }, { 0x350a, 0x0 }, { 0x522, 0x0 },
/*244*/ { 0xffffff61, 0xffff9886 }, { 0xffffdc90, 0xffffcd83 }, { 0xffffff61, 0xffff9886 },
/*245*/ { 0x1c0a, 0x0 }, { 0xfffff820, 0xffffffff }, { 0x1c0a, 0x0 },
/*246*/ { 0xfffffffe, 0xffffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*247*/ { 0x636c, 0x0 }, { 0x412b, 0x0 }, { 0x2241, 0x0 },
/*248*/ { 0xffffaf79, 0xffffffff }, { 0xb2e, 0x0 }, { 0x14f, 0x0 },
/*249*/ { 0xffffc7cd, 0xffffd667 }, { 0xffffedb8, 0xfffff157 }, { 0xffffc7cd, 0xffffd667 },
/*250*/ { 0x49c2, 0x0 }, { 0x426e, 0x0 }, { 0x754, 0x0 },
/*251*/ { 0xffffd0b7, 0xffff83f1 }, { 0x1c80, 0x42c7 }, { 0x92bdd937, 0x12e0 },
/*252*/ { 0x350b, 0x2 }, { 0x31ce, 0x1 }, { 0x33d, 0x1 },
/*253*/ { 0x6c69, 0x6064 }, { 0xfffff44d, 0xffffa1ee }, { 0x6c69, 0x6064 },
/*254*/ { 0xc15, 0xcd }, { 0x2beb, 0x1c }, { 0xfffed8a8, 0x8 },
/*255*/ { 0xffffec41, 0xffffd847 }, { 0x22da, 0x1755 }, { 0x819bbcdf, 0x168d },
/*256*/ { 0x6795, 0x7b59 }, { 0xfffff7a0, 0xffffd515 }, { 0x6795, 0x7b59 },
/*257*/ { 0x1fd2, 0x1980 }, { 0x3daf, 0x16f2 }, { 0xffffe223, 0x28d },
/*258*/ { 0xffff9a3c, 0xffffff5f }, { 0x6945, 0x57 }, { 0x3dcd2e0a, 0x44 },
/*259*/ { 0x3, 0x0 }, { 0xfffffffe, 0xffffffff }, { 0x3, 0x0 },
/*260*/ { 0xbf9, 0x3ee1 }, { 0x242d, 0x9d1 }, { 0xffff32eb, 0x3fa },
/*261*/ { 0x5, 0x0 }, { 0x4, 0x0 }, { 0x1, 0x0 },
/*262*/ { 0xe, 0x0 }, { 0x9, 0x0 }, { 0x5, 0x0 },
/*263*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*264*/ { 0x43f, 0x0 }, { 0x14f, 0x0 }, { 0x52, 0x0 },
/*265*/ { 0x5704, 0x0 }, { 0x4bf7, 0x0 }, { 0xb0d, 0x0 },
/*266*/ { 0x7ec, 0x3f }, { 0xffff93ee, 0xffffffe9 }, { 0x7ec, 0x3f },
/*267*/ { 0x2e01, 0x7245 }, { 0x2a6d, 0x30d7 }, { 0xffffd927, 0x1096 },
/*268*/ { 0xffffc233, 0xffffffff }, { 0x3775, 0x0 }, { 0x1f75, 0x0 },
/*269*/ { 0x78e, 0x0 }, { 0xfffff879, 0xffffffff }, { 0x78e, 0x0 },
/*270*/ { 0x74a3, 0x2e }, { 0x2425, 0x2a }, { 0x507e, 0x4 },
/*271*/ { 0xffff8f28, 0xffffffff }, { 0x128b, 0x0 }, { 0x10df, 0x0 },
/*272*/ { 0x3777, 0x0 }, { 0x1932, 0x0 }, { 0x513, 0x0 },
/*273*/ { 0x14d, 0x0 }, { 0x149, 0x0 }, { 0x4, 0x0 },
/*274*/ { 0x49d, 0x5f21 }, { 0x46be, 0xa8b }, { 0xfffd87ef, 0x3d },
/*275*/ { 0x9e1, 0x1c04 }, { 0x34a4, 0x840 }, { 0xffff6bf5, 0x343 },
/*276*/ { 0x7550, 0x14 }, { 0xffffbee1, 0xfffffff5 }, { 0x7550, 0x14 },
/*277*/ { 0x3c47, 0x5a7d }, { 0xffffbcca, 0xffffd3e2 }, { 0x3c47, 0x5a7d },
/*278*/ { 0xffffbec7, 0xfffff2bb }, { 0x6a23, 0x89e }, { 0xaee2a2c1, 0x3f3 },
/*279*/ { 0x39c4, 0x0 }, { 0x2ec1, 0x0 }, { 0xb03, 0x0 },
/*280*/ { 0xffffbf0e, 0xfffffff0 }, { 0x45f2, 0x0 }, { 0x1868, 0x0 },
/*281*/ { 0x5f46, 0x0 }, { 0xffffc76a, 0xffffffff }, { 0x5f46, 0x0 },
/*282*/ { 0x1f, 0x0 }, { 0xfffffffb, 0xffffffff }, { 0x1f, 0x0 },
/*283*/ { 0x3, 0x0 }, { 0xfffffffe, 0xffffffff }, { 0x3, 0x0 },
/*284*/ { 0xffff9256, 0xffffba5c }, { 0x763f, 0x1bf0 }, { 0xc47a4122, 0x718 },
/*285*/ { 0x3185, 0x0 }, { 0xfffffeaf, 0xffffffff }, { 0x3185, 0x0 },
/*286*/ { 0xd5, 0x0 }, { 0xffffff7f, 0xffffffff }, { 0xd5, 0x0 },
/*287*/ { 0xffffcc17, 0xffffffff }, { 0x3325, 0x0 }, { 0x2b39, 0x0 },
/*288*/ { 0x500d, 0x0 }, { 0x444a, 0x0 }, { 0xbc3, 0x0 },
/*289*/ { 0x34d5, 0xa97 }, { 0xffffa9a8, 0xfffff5fe }, { 0x34d5, 0xa97 },
/*290*/ { 0xd0f, 0x248 }, { 0xffffecf8, 0xfffffeea }, { 0xd0f, 0x248 },
/*291*/ { 0x51e8, 0x1 }, { 0xffffc5ec, 0xffffffff }, { 0x51e8, 0x1 },
/*292*/ { 0x7060, 0x0 }, { 0x3285, 0x0 }, { 0xb56, 0x0 },
/*293*/ { 0x681d, 0x0 }, { 0xffffa0d3, 0xffffffff }, { 0x681d, 0x0 },
/*294*/ { 0x6450, 0x0 }, { 0xffffe9a3, 0xffffffff }, { 0x6450, 0x0 },
/*295*/ { 0xffffdc3c, 0xfffffffc }, { 0x1ee1, 0x0 }, { 0x1204, 0x0 },
/*296*/ { 0x32c, 0x0 }, { 0x165, 0x0 }, { 0x62, 0x0 },
/*297*/ { 0x2760, 0x0 }, { 0xffffdc9e, 0xffffffff }, { 0x2760, 0x0 },
/*298*/ { 0x1a, 0x0 }, { 0xfffffff0, 0xffffffff }, { 0x1a, 0x0 },
/*299*/ { 0xfffffd3d, 0xfffffc97 }, { 0x102d, 0xba }, { 0xbc8f7240, 0x27 },
/*300*/ { 0xfffffff5, 0xffffffff }, { 0xffffffff, 0xffffffff }, { 0xfffffff5, 0xffffffff },
/*301*/ { 0x494a, 0x0 }, { 0xffffffeb, 0xffffffff }, { 0x494a, 0x0 },
/*302*/ { 0x25f2, 0xa5 }, { 0x65a2, 0x20 }, { 0xfffe29c8, 0x4 },
/*303*/ { 0xffffce29, 0xfffffffe }, { 0x14b7, 0x1 }, { 0x1acfdb1, 0x0 },
/*304*/ { 0xffff8e4f, 0xffffffff }, { 0x21e9, 0x0 }, { 0x15ef, 0x0 },
/*305*/ { 0x7d1d, 0x5de1 }, { 0xffff9973, 0xffffe47d }, { 0x7d1d, 0x5de1 },
/*306*/ { 0xffff8032, 0xffffffff }, { 0xffffe3c3, 0xffffffff }, { 0xffff8032, 0xffffffff },
/*307*/ { 0x7706, 0x0 }, { 0x63a, 0x0 }, { 0xb8, 0x0 },
/*308*/ { 0xfffff24a, 0xffffffff }, { 0x34b, 0x0 }, { 0xf4, 0x0 },
/*309*/ { 0x4619, 0x17 }, { 0x4ed7, 0x16 }, { 0xfffff742, 0x0 },
/*310*/ { 0x20cb, 0x0 }, { 0xfffff159, 0xffffffff }, { 0x20cb, 0x0 },
/*311*/ { 0x79, 0x0 }, { 0x28, 0x0 }, { 0x1, 0x0 },
/*312*/ { 0x5ff7, 0x1 }, { 0x2af9, 0x1 }, { 0x34fe, 0x0 },
/*313*/ { 0x31, 0x0 }, { 0x1d, 0x0 }, { 0x14, 0x0 },
/*314*/ { 0x7250, 0x5224 }, { 0x1ccc, 0x39fc }, { 0x5584, 0x1828 },
/*315*/ { 0xffffd443, 0xffffa15c }, { 0x1db4, 0x34b2 }, { 0x6fb30107, 0x2876 },
/*316*/ { 0x7275, 0x0 }, { 0xded, 0x0 }, { 0x30d, 0x0 },
/*317*/ { 0x1ef, 0x12 }, { 0x7c44, 0xe }, { 0xffff85ab, 0x3 },
/*318*/ { 0xffffb256, 0xfffffffc }, { 0xd41, 0x3 }, { 0x1348bb, 0x1 },
/*319*/ { 0x7fc3, 0xeee }, { 0x90, 0x53a }, { 0x7ea3, 0x47a },
/*320*/ { 0xffff9fe4, 0xffffffff }, { 0x4e6e, 0x0 }, { 0x3e60, 0x0 },
/*321*/ { 0x71ca, 0x5072 }, { 0x7425, 0x91a }, { 0xfffcd0a2, 0x7a1 },
/*322*/ { 0x5009, 0x76 }, { 0x4975, 0x5 }, { 0xfff9b686, 0x2 },
/*323*/ { 0xffffa548, 0xffffffff }, { 0x3969, 0x0 }, { 0x1df7, 0x0 },
/*324*/ { 0x7cb0, 0xf9a }, { 0xf0f, 0x835 }, { 0x6da1, 0x765 },
/*325*/ { 0x6bd6, 0x7950 }, { 0x6ede, 0x1ba3 }, { 0xfffeb05e, 0xac3 },
/*326*/ { 0x476b, 0x7f7 }, { 0xffff9f94, 0xfffff91f }, { 0x476b, 0x7f7 },
/*327*/ { 0x1, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*328*/ { 0x58d, 0x0 }, { 0xffffffb4, 0xffffffff }, { 0x58d, 0x0 },
/*329*/ { 0x52c0, 0x0 }, { 0x11e4, 0x0 }, { 0xb30, 0x0 },
/*330*/ { 0x4ffc, 0x0 }, { 0x2089, 0x0 }, { 0xeea, 0x0 },
/*331*/ { 0x7b02, 0x0 }, { 0xe07, 0x0 }, { 0xaca, 0x0 },
/*332*/ { 0xffff9683, 0xffff9ad0 }, { 0x42a7, 0xbed }, { 0x693df3e4, 0x936 },
/*333*/ { 0x525b, 0x0 }, { 0x17fb, 0x0 }, { 0xa6a, 0x0 },
/*334*/ { 0xffff8ad7, 0xffffffff }, { 0x5d1e, 0x0 }, { 0x3ff5, 0x0 },
/*335*/ { 0x2312, 0x5f4f }, { 0x693f, 0x3ff }, { 0xfff6ae69, 0x365 },
/*336*/ { 0x6, 0x0 }, { 0x5, 0x0 }, { 0x1, 0x0 },
/*337*/ { 0x603d, 0x1e13 }, { 0x5920, 0xc88 }, { 0xffffadfd, 0x502 },
/*338*/ { 0xffff8e3a, 0xffffffff }, { 0x2c76, 0x0 }, { 0x1e2c, 0x0 },
/*339*/ { 0x7dc3, 0x72 }, { 0xffffc9ce, 0xffffffae }, { 0x7dc3, 0x72 },
/*340*/ { 0x4, 0x0 }, { 0x3, 0x0 }, { 0x1, 0x0 },
/*341*/ { 0x2e, 0x0 }, { 0x26, 0x0 }, { 0x8, 0x0 },
/*342*/ { 0x434a, 0x7 }, { 0xffffadc5, 0xffffffff }, { 0x434a, 0x7 },
/*343*/ { 0x6f, 0x0 }, { 0xb, 0x0 }, { 0x1, 0x0 },
/*344*/ { 0x293c, 0x727 }, { 0x1f6c, 0x307 }, { 0xffffea64, 0x118 },
/*345*/ { 0x49e3, 0x0 }, { 0x1880, 0x0 }, { 0x63, 0x0 },
/*346*/ { 0x3, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*347*/ { 0x8d1, 0xe01 }, { 0x28fa, 0x37d }, { 0xffff64e9, 0xc },
/*348*/ { 0x4a2e, 0x0 }, { 0x29e2, 0x0 }, { 0x204c, 0x0 },
/*349*/ { 0x4a67, 0x5ada }, { 0x1df, 0x25ba }, { 0x46a9, 0xf66 },
/*350*/ { 0x41ff, 0x0 }, { 0xffffd8ee, 0xffffffff }, { 0x41ff, 0x0 },
/*351*/ { 0x5a94, 0x5c93 }, { 0x4166, 0x3049 }, { 0x192e, 0x2c4a },
/*352*/ { 0xffffa27b, 0xffff8582 }, { 0x3fd9, 0x1d2d }, { 0xcfc75551, 0x1b4e },
/*353*/ { 0xffff9b92, 0xffffffff }, { 0x4e69, 0x0 }, { 0x1597, 0x0 },
/*354*/ { 0xffff923a, 0xffff8040 }, { 0xdc9, 0x1422 }, { 0x50b6bbd2, 0xcf0 },
/*355*/ { 0x9, 0x0 }, { 0x2, 0x0 }, { 0x1, 0x0 },
/*356*/ { 0x4c60, 0x1b }, { 0x7423, 0x6 }, { 0xfffe7bd4, 0x2 },
/*357*/ { 0x2, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*358*/ { 0x38ba, 0x32f3 }, { 0x64ea, 0x61b }, { 0xfffd116a, 0x21a },
/*359*/ { 0x6fa4, 0x0 }, { 0xffffaa69, 0xffffffff }, { 0x6fa4, 0x0 },
/*360*/ { 0x574c, 0x7 }, { 0x4aea, 0x4 }, { 0xc62, 0x3 },
/*361*/ { 0x6, 0x0 }, { 0xffffffff, 0xffffffff }, { 0x6, 0x0 },
/*362*/ { 0xffffce72, 0xffff9b0e }, { 0x4a4e, 0x4d3a }, { 0x9afdc9c, 0x1e7c },
/*363*/ { 0x1, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*364*/ { 0xffff8e36, 0xffffffff }, { 0x6413, 0x0 }, { 0x1bba, 0x0 },
/*365*/ { 0x30, 0x0 }, { 0x18, 0x0 }, { 0x0, 0x0 },
/*366*/ { 0x6641, 0x67f2 }, { 0xffff8c0f, 0xffff9cab }, { 0x6641, 0x67f2 },
/*367*/ { 0xa3, 0x0 }, { 0x9d, 0x0 }, { 0x6, 0x0 },
/*368*/ { 0x4435, 0x3dcb }, { 0x32c1, 0xf32 }, { 0xffff7931, 0x102 },
/*369*/ { 0x5205, 0x5723 }, { 0xffffdd46, 0xffffb808 }, { 0x5205, 0x5723 },
/*370*/ { 0x5883, 0x0 }, { 0x15be, 0x0 }, { 0x18b, 0x0 },
/*371*/ { 0x7ffd, 0x0 }, { 0x4339, 0x0 }, { 0x3cc4, 0x0 },
/*372*/ { 0x7775, 0xf }, { 0x468a, 0x2 }, { 0xfffe89af, 0x0 },
/*373*/ { 0xffff92a1, 0xffffffff }, { 0x85a, 0x0 }, { 0x6a9, 0x0 },
/*374*/ { 0xf56, 0x0 }, { 0x98c, 0x0 }, { 0x5ca, 0x0 },
/*375*/ { 0x28f1, 0x0 }, { 0xeb0, 0x0 }, { 0xb91, 0x0 },
/*376*/ { 0x6fb4, 0x0 }, { 0x292a, 0x0 }, { 0x1d60, 0x0 },
/*377*/ { 0xffffabcd, 0xffffffff }, { 0x4178, 0x0 }, { 0x425, 0x0 },
/*378*/ { 0x1ff, 0x0 }, { 0x161, 0x0 }, { 0x9e, 0x0 },
/*379*/ { 0x154, 0x0 }, { 0x141, 0x0 }, { 0x13, 0x0 },
/*380*/ { 0xe6a, 0x42cf }, { 0x605c, 0x357e }, { 0xffffae0e, 0xd50 },
/*381*/ { 0x2b8d, 0x7f }, { 0x3b90, 0x5d }, { 0xffffeffd, 0x21 },
/*382*/ { 0x6017, 0x15c }, { 0x63fe, 0x9b }, { 0xffff981b, 0x25 },
/*383*/ { 0x6ea, 0x0 }, { 0xfffffb57, 0xffffffff }, { 0x6ea, 0x0 },
/*384*/ { 0x7664, 0xe9 }, { 0xffffbec0, 0xffffff7e }, { 0x7664, 0xe9 },
/*385*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*386*/ { 0x1533, 0x3eda }, { 0x2967, 0x644 }, { 0xfffe772d, 0x31 },
/*387*/ { 0x6ca1, 0x2682 }, { 0x1426, 0x1fa }, { 0xfffeedcf, 0xf3 },
/*388*/ { 0xeea, 0x0 }, { 0x1a, 0x0 }, { 0x16, 0x0 },
/*389*/ { 0x672c, 0x7572 }, { 0x3954, 0x311a }, { 0xfffff484, 0x133d },
/*390*/ { 0x44f3, 0x7522 }, { 0x4e73, 0x1ffb }, { 0xffff599a, 0x1530 },
/*391*/ { 0x6de0, 0x0 }, { 0x48fe, 0x0 }, { 0x24e2, 0x0 },
/*392*/ { 0x6738, 0x188e }, { 0xfffffcc0, 0xfffff0df }, { 0x6738, 0x188e },
/*393*/ { 0x215d, 0x0 }, { 0xffffee67, 0xffffffff }, { 0x215d, 0x0 },
/*394*/ { 0x9d8, 0x361f }, { 0x512a, 0x13b5 }, { 0xffff6784, 0xeb4 },
/*395*/ { 0x6a73, 0x0 }, { 0x3fce, 0x0 }, { 0x2aa5, 0x0 },
/*396*/ { 0xffffe8aa, 0xffffffe1 }, { 0x42f, 0x4 }, { 0x4001226f, 0x2 },
/*397*/ { 0xffffbc7e, 0xfffffffe }, { 0x3505, 0x0 }, { 0x2fc4, 0x0 },
/*398*/ { 0x26b1, 0x1386 }, { 0x21f4, 0x6b5 }, { 0xffffe2c9, 0x61b },
/*399*/ { 0x4a9f, 0x0 }, { 0x347, 0x0 }, { 0x285, 0x0 },
/*400*/ { 0x37c0, 0x4cbd }, { 0xd42, 0xa55 }, { 0xffffdaf2, 0x469 },
/*401*/ { 0x35cd, 0x7d48 }, { 0xffff96ef, 0xffffd419 }, { 0x35cd, 0x7d48 },
/*402*/ { 0x579, 0xea6 }, { 0x5aed, 0xb03 }, { 0xffffaa8c, 0x3a2 },
/*403*/ { 0x5292, 0x0 }, { 0x5100, 0x0 }, { 0x192, 0x0 },
/*404*/ { 0xffffff83, 0xffffffff }, { 0xd, 0x0 }, { 0x8, 0x0 },
/*405*/ { 0xffffc17e, 0xffffffff }, { 0x2ac, 0x0 }, { 0x46, 0x0 },
/*406*/ { 0x36a9, 0x3 }, { 0x7633, 0x0 }, { 0x6f55, 0x0 },
/*407*/ { 0x4504, 0x6043 }, { 0x74a1, 0x77 }, { 0xffa1f6d5, 0x9 },
/*408*/ { 0x7, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*409*/ { 0xfffffd44, 0xfffff390 }, { 0x30f8, 0x4cf }, { 0xd100b8a4, 0xb2 },
/*410*/ { 0xffffd1cb, 0xffffffff }, { 0xffffd1ea, 0xffffffff }, { 0xffffd1cb, 0xffffffff },
/*411*/ { 0x2f8a, 0x1e }, { 0x46d5, 0x12 }, { 0xffffe8b5, 0xb },
/*412*/ { 0xffff9633, 0xffffffff }, { 0xffffd17b, 0xffffffff }, { 0xffff9633, 0xffffffff },
/*413*/ { 0x7, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*414*/ { 0xb, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*415*/ { 0x6266, 0x6c56 }, { 0x5646, 0x464e }, { 0xc20, 0x2608 },
/*416*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*417*/ { 0xffff9a2c, 0xffffffff }, { 0x986, 0x0 }, { 0x82a, 0x0 },
/*418*/ { 0xffffff04, 0xffffffff }, { 0xffffff0e, 0xffffffff }, { 0xffffff04, 0xffffffff },
/*419*/ { 0xffff9256, 0xffffffff }, { 0x68be, 0x0 }, { 0x5e1e, 0x0 },
/*420*/ { 0x354a, 0x0 }, { 0x7c4, 0x0 }, { 0x6b2, 0x0 },
/*421*/ { 0xffff8b77, 0xffffffff }, { 0x367a, 0x0 }, { 0x1a8d, 0x0 },
/*422*/ { 0x50ce, 0x0 }, { 0xffffd862, 0xffffffff }, { 0x50ce, 0x0 },
/*423*/ { 0x7b84, 0x5691 }, { 0x4a3, 0x256a }, { 0x723e, 0xbbd },
/*424*/ { 0xffffe8d2, 0xffffee10 }, { 0x7441, 0x290 }, { 0xa1f6b613, 0x73 },
/*425*/ { 0x660c, 0x343a }, { 0x3f7b, 0x2eb7 }, { 0x2691, 0x583 },
/*426*/ { 0x2ac7, 0x44b0 }, { 0x617e, 0x3899 }, { 0xffffc949, 0xc16 },
/*427*/ { 0xffffffb4, 0xffffffff }, { 0x35, 0x0 }, { 0x2d, 0x0 },
/*428*/ { 0x14e7, 0x0 }, { 0xfffff3fd, 0xffffffff }, { 0x14e7, 0x0 },
/*429*/ { 0x7fd9, 0x0 }, { 0xffffd5f7, 0xffffffff }, { 0x7fd9, 0x0 },
/*430*/ { 0xffffb9df, 0xffffff6c }, { 0x34cf, 0x2a }, { 0x1e7c2039, 0x27 },
/*431*/ { 0x37b6, 0x0 }, { 0x2521, 0x0 }, { 0x1295, 0x0 },
/*432*/ { 0x50ae, 0x0 }, { 0x1108, 0x0 }, { 0xc8e, 0x0 },
/*433*/ { 0xffffad13, 0xffffff44 }, { 0xffffba21, 0xffffff91 }, { 0xffffad13, 0xffffff44 },
/*434*/ { 0xffffe38d, 0xffffdeb5 }, { 0x648b, 0x1d2e }, { 0x8dea45b2, 0x64 },
/*435*/ { 0x7bc7, 0x32a }, { 0x69d3, 0x81 }, { 0xfffe00d5, 0x23 },
/*436*/ { 0xd, 0x0 }, { 0xc, 0x0 }, { 0x1, 0x0 },
/*437*/ { 0x6c70, 0x39 }, { 0xffffe5ae, 0xffffffe0 }, { 0x6c70, 0x39 },
/*438*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*439*/ { 0x6694, 0x0 }, { 0x4d82, 0x0 }, { 0x1912, 0x0 },
/*440*/ { 0x5, 0x0 }, { 0x2, 0x0 }, { 0x1, 0x0 },
/*441*/ { 0x508c, 0x0 }, { 0x2304, 0x0 }, { 0xa84, 0x0 },
/*442*/ { 0xffff8838, 0xffffffff }, { 0x2fb4, 0x0 }, { 0x1c5c, 0x0 },
/*443*/ { 0x18eb, 0x6384 }, { 0xecd, 0x45d5 }, { 0xa1e, 0x1daf },
/*444*/ { 0xffff9c25, 0xffffff86 }, { 0x2caa, 0x50 }, { 0x13338aef, 0x48 },
/*445*/ { 0xffffb0ac, 0xffffa2af }, { 0x1403, 0x596 }, { 0x6ae133ec, 0x52c },
/*446*/ { 0xffff980d, 0xffff9d19 }, { 0x360d, 0x10fa }, { 0xd0f05d6e, 0xc38 },
/*447*/ { 0x7ae5, 0x425f }, { 0x69f3, 0xef8 }, { 0xfffed319, 0x67e },
/*448*/ { 0x5e35, 0x0 }, { 0x438b, 0x0 }, { 0x1aaa, 0x0 },
/*449*/ { 0x1b74, 0x556b }, { 0x5a1, 0x63b }, { 0xffffd247, 0x46b },
/*450*/ { 0x1aa0, 0x67c9 }, { 0x463d, 0x3695 }, { 0xffffd463, 0x3133 },
/*451*/ { 0x6ef2, 0x1509 }, { 0x7009, 0x305 }, { 0xfffdcebc, 0x2ea },
/*452*/ { 0xffff85f3, 0xfffff26a }, { 0xe67, 0x74a }, { 0x62c1b5a, 0x3b3 },
/*453*/ { 0x7, 0x0 }, { 0x7, 0x0 }, { 0x0, 0x0 },
/*454*/ { 0x1c03, 0x5 }, { 0xffffa7fe, 0xfffffffb }, { 0x1c03, 0x5 },
/*455*/ { 0x3441, 0x64be }, { 0x5464, 0x40ca }, { 0xffffdfdd, 0x23f3 },
/*456*/ { 0x20c4, 0x7430 }, { 0x6927, 0x491e }, { 0xffffb79d, 0x2b11 },
/*457*/ { 0xffffe764, 0xffffffc3 }, { 0x6dd7, 0x11 }, { 0xf11c349e, 0x3 },
/*458*/ { 0x7499, 0x0 }, { 0xffffaea2, 0xffffffff }, { 0x7499, 0x0 },
/*459*/ { 0x3006, 0x0 }, { 0x92, 0x0 }, { 0x1e, 0x0 },
/*460*/ { 0x58a0, 0x1 }, { 0x293f, 0x0 }, { 0x249, 0x0 },
/*461*/ { 0xffffa6b4, 0xffff81fa }, { 0x8de, 0x683d }, { 0xea38c9be, 0x2ad9 },
/*462*/ { 0x7efa, 0x0 }, { 0x769, 0x0 }, { 0x101, 0x0 },
/*463*/ { 0xf, 0x0 }, { 0x2, 0x0 }, { 0x1, 0x0 },
/*464*/ { 0x46d7, 0x0 }, { 0x90d, 0x0 }, { 0x77c, 0x0 },
/*465*/ { 0x54bd, 0x0 }, { 0x46dc, 0x0 }, { 0xde1, 0x0 },
/*466*/ { 0xa87, 0x0 }, { 0xfffff630, 0xffffffff }, { 0xa87, 0x0 },
/*467*/ { 0x30d, 0x0 }, { 0x2d0, 0x0 }, { 0x3d, 0x0 },
/*468*/ { 0x4998, 0x7c00 }, { 0x16b1, 0x15fc }, { 0xffffd823, 0xe13 },
/*469*/ { 0x6b01, 0x0 }, { 0x3786, 0x0 }, { 0x337b, 0x0 },
/*470*/ { 0x2201, 0x338a }, { 0xffffb61f, 0xffffe49c }, { 0x2201, 0x338a },
/*471*/ { 0x7143, 0x3 }, { 0xffff96be, 0xfffffffe }, { 0x7143, 0x3 },
/*472*/ { 0x6800, 0x5508 }, { 0x108b, 0x1f12 }, { 0x46ea, 0x16e4 },
/*473*/ { 0xffffa2f7, 0xffffffff }, { 0x746, 0x0 }, { 0x371, 0x0 },
/*474*/ { 0x6ef0, 0x0 }, { 0xc52, 0x0 }, { 0xe, 0x0 },
/*475*/ { 0x532f, 0x0 }, { 0x4602, 0x0 }, { 0xd2d, 0x0 },
/*476*/ { 0x3f53, 0x203 }, { 0x2fdd, 0x100 }, { 0xffffdf99, 0x2 },
/*477*/ { 0x7a0, 0x0 }, { 0x13b, 0x0 }, { 0x3e, 0x0 },
/*478*/ { 0xffffdd1a, 0xffffffb7 }, { 0x249f, 0x1c }, { 0x2db8e314, 0x11 },
/*479*/ { 0xfffffffc, 0xffffffff }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*480*/ { 0xffff87f5, 0xffff9e23 }, { 0xffff80d3, 0xffffa06f }, { 0xffff87f5, 0xffff9e23 },
/*481*/ { 0x33ed, 0x1c85 }, { 0xffffeab6, 0xfffff135 }, { 0x33ed, 0x1c85 },
/*482*/ { 0x64b, 0x0 }, { 0x26a, 0x0 }, { 0x177, 0x0 },
/*483*/ { 0xffffb2a7, 0xffffffa5 }, { 0x1b9, 0x13 }, { 0xca1ab00f, 0x6 },
/*484*/ { 0xffffe747, 0xffffffff }, { 0xe4b, 0x0 }, { 0xa29, 0x0 },
/*485*/ { 0x1ff, 0x0 }, { 0x193, 0x0 }, { 0x6c, 0x0 },
/*486*/ { 0xffffa5b5, 0xfffff2b5 }, { 0xb38, 0x6bb }, { 0x55486655, 0x1b8 },
/*487*/ { 0xfffff9b4, 0xffffffff }, { 0x19c, 0x0 }, { 0x190, 0x0 },
/*488*/ { 0xffffbb36, 0xffffffff }, { 0xffffe20f, 0xffffffff }, { 0xffffbb36, 0xffffffff },
/*489*/ { 0x2305, 0x39 }, { 0x2dc3, 0x21 }, { 0xfffff542, 0x17 },
/*490*/ { 0x7326, 0x0 }, { 0xfffffcbf, 0xffffffff }, { 0x7326, 0x0 },
/*491*/ { 0x15c, 0x363d }, { 0xffffa246, 0xffffd527 }, { 0x15c, 0x363d },
/*492*/ { 0x74d6, 0x3f80 }, { 0x5d5d, 0x2316 }, { 0x1779, 0x1c6a },
/*493*/ { 0xffff8129, 0xffffffff }, { 0x2097, 0x0 }, { 0x1103, 0x0 },
/*494*/ { 0x465b, 0x710e }, { 0x71f3, 0xf9b }, { 0xfffd28b6, 0x3d0 },
/*495*/ { 0x6011, 0x0 }, { 0x5ac2, 0x0 }, { 0x54f, 0x0 },
/*496*/ { 0x1447, 0x712 }, { 0xffff89ed, 0xffffffd3 }, { 0x1447, 0x712 },
/*497*/ { 0x6dbe, 0x0 }, { 0x4a95, 0x0 }, { 0x2329, 0x0 },
/*498*/ { 0xfffffe0b, 0xffffffff }, { 0xcd, 0x0 }, { 0x82, 0x0 },
/*499*/ { 0x4947, 0x142 }, { 0x7fa5, 0x11c }, { 0xffffc9a2, 0x25 },
/*500*/ { 0xffffc23d, 0xffffff63 }, { 0x545b, 0x97 }, { 0xfc9c6667, 0x6 },
/*501*/ { 0x767f, 0x0 }, { 0x520e, 0x0 }, { 0x2471, 0x0 },
/*502*/ { 0xffff9289, 0xffffff66 }, { 0x4819, 0x2a }, { 0x8c3495ea, 0x29 },
/*503*/ { 0x0, 0xa0 }, { 0x100000, 0x0 }, { 0x0, 0x0 },
/*504*/ { 0x5d2ca, 0x0 }, { 0xa, 0x0 }, { 0x2, 0x0 }
};
#define NTESTS ((UINT) (sizeof abc / (sizeof abc[0] * 3)))

int CompilerBuiltin(void);
int NoCompilerBuiltin(void);

#define Test(_name_) \
int _name_(void)    \
{    \
    int i;    \
    MY_UINT64 *p;    \
    UINT64 a, b, c, d;    \
    int nPass, nFail;    \
    TIME Tstart, Tend;    \
    \
    Tstart = CurrentTime();    \
    \
    nPass = nFail = 0;    \
    p = abc;    \
    for (i = 0; i < NTESTS; i++) {    \
    \
        Int64FromHighAndLow(a, p->HighPart, p->LowPart);    \
        p++;    \
        Int64FromHighAndLow(b, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64ModulusUint64(a, b);    \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
    \
        if (!Int64Equal(c,d)) {    \
            _tprintf(_TEXT("a = { 0x%x, 0x%x }, "), Uint64High32Bits(a), Uint64Low32Bits(a));    \
            _tprintf(_TEXT("b = { 0x%x, 0x%x }, "), Uint64High32Bits(b), Uint64Low32Bits(b));    \
            _tprintf(_TEXT("a%%b = { 0x%x, 0x%x }\n\r"), Uint64High32Bits(c), Uint64Low32Bits(c));    \
            _tprintf(_TEXT("  ==> a %% b should be { 0x%x, 0x%x }!!!\n\r"), Uint64High32Bits(d), Uint64Low32Bits(d));    \
            _tprintf(_TEXT("64-bit unsigned modulus test FAILED "));    \
            _tprintf(_TEXT("in iteration %d.\n\r"), i);    \
            nFail++;    \
        } else    \
            nPass++;    \
    }    \
    Tend = CurrentTime();    \
    \
    _tprintf(_TEXT("64-bit unsigned modulus test "));    \
    if (nFail == 0) {    \
        _tprintf(_TEXT("PASSED.\n\r"));    \
    \
    } else {    \
        _tprintf(_TEXT("FAILED (%d fail %d pass).\n\r"),    \
                 nFail, nPass);    \
    }    \
    \
    i = TimeDifference(Tend,Tstart);    \
    _tprintf(_TEXT("Took %d microseconds for %d tests (%d/test)\n\r"),    \
             i / 10,    \
             NTESTS,    \
             i / (NTESTS*10));    \
    return nFail;    \
}


/* In any event, test the os-supported routines.
 * If the compiler supports it, repeat for the builtin routines.
 */
int _tmain()
{
    int nFail = 0;

    _tprintf(_TEXT("\n\rTesting os-supported 64bit unsigned modulus.\n\r"));
    nFail = NoCompilerBuiltin();

#if !defined(__NO_BUILTIN_INT64)
    _tprintf(_TEXT("\n\rTesting compiler-supported 64bit unsigned modulus.\n\r"));
    nFail += CompilerBuiltin();
#endif

    if (nFail)
        _tprintf(_TEXT("Test FAILED, %d errors.\n\r"), nFail);

    exit ((nFail == 0) ? EXIT_SUCCESS : EXIT_FAILURE);
    return 0;/*amusme*/
}


#include "tst64again.c"

