/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * C test program -- 64-bit multiply function Uint64TimesUint64()
 */

#if defined(MMLITE)
#include <mmlite.h>
#define XXXX 1

#else
#include <windows.h>
#define i386 /* uhu? */
#define EXTERN_C extern
#include "int64.h"
typedef INT64 TIME;
TIME CurrentTime(void)
{
    TIME t;
    Int64FromHighAndLow(t,0,GetCurrentTime());
#define XXXX 10000
    return t;
}
#endif

/* Was useful for testing under Win32 */
UINT32 TimeDifference(TIME Stop, TIME Start)
{
    UINT32 r;
    Stop = TimeSubtract(Stop,Start);
    r = ((UINT32) Int64ToInt32(Stop) ) * XXXX;
    return r;
}

#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* grumble.. */
typedef struct
    {
    UINT32 LowPart;
    INT32 HighPart;
    }   MY_INT64;

/* NOTE:
 * 64x64->64 is the same, signed or unsigned.
 * What we do here is to actually test 64x32->64 unsigned.
 * Therefore the HighPart of 'b' in this table is always 0.
 */

MY_INT64 abc[] = {
/*0*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*1*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*2*/ { 0x1, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*3*/ { 0x0, 0x0 }, { 0xffffffff, 0x0 }, { 0x0, 0x0 },
/*4*/ { 0xffffffff, 0xffffffff }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*5*/ { 0x1, 0x0 }, { 0x1, 0x0 }, { 0x1, 0x0 },
/*6*/ { 0x1, 0x0 }, { 0xffffffff, 0x0 }, { 0xffffffff, 0x0 },
/*7*/ { 0xffffffff, 0xffffffff }, { 0x1, 0x0 }, { 0xffffffff, 0xffffffff },
/*8*/ { 0xffffffff, 0xffffffff }, { 0xffffffff, 0x0 }, { 0x1, 0xffffffff },
/*9*/ { 0x1, 0x0 }, { 0x2, 0x0 }, { 0x2, 0x0 },
/*10*/ { 0x1, 0x0 }, { 0xfffffffe, 0x0 }, { 0xfffffffe, 0x0 },
/*11*/ { 0xffffffff, 0xffffffff }, { 0x2, 0x0 }, { 0xfffffffe, 0xffffffff },
/*12*/ { 0xffffffff, 0xffffffff }, { 0xfffffffe, 0x0 }, { 0x2, 0xffffffff },
/*13*/ { 0x2, 0x0 }, { 0x1, 0x0 }, { 0x2, 0x0 },
/*14*/ { 0x2, 0x0 }, { 0xffffffff, 0x0 }, { 0xfffffffe, 0x1 },
/*15*/ { 0xfffffffe, 0xffffffff }, { 0x1, 0x0 }, { 0xfffffffe, 0xffffffff },
/*16*/ { 0xfffffffe, 0xffffffff }, { 0xffffffff, 0x0 }, { 0x2, 0xfffffffe },
/*17*/ { 0x80000000, 0x0 }, { 0x80000000, 0x0 }, { 0x0, 0x40000000 },
/*18*/ { 0x80000000, 0x0 }, { 0x7fffffff, 0x0 }, { 0x80000000, 0x3fffffff },
/*19*/ { 0x7fffffff, 0x0 }, { 0x80000000, 0x0 }, { 0x80000000, 0x3fffffff },
/*20*/ { 0x7fffffff, 0x0 }, { 0x7fffffff, 0x0 }, { 0x1, 0x3fffffff },
/*21*/ { 0x0, 0x1 }, { 0x40000000, 0x0 }, { 0x0, 0x40000000 },
/*22*/ { 0x0, 0x1 }, { 0x3fffffff, 0x0 }, { 0x0, 0x3fffffff },
/*23*/ { 0xffffffff, 0x0 }, { 0x40000000, 0x0 }, { 0xc0000000, 0x3fffffff },
/*24*/ { 0x40000000, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*25*/ { 0x40000000, 0x0 }, { 0xffffffff, 0x0 }, { 0xc0000000, 0x3fffffff },
/*26*/ { 0x3fffffff, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*27*/ { 0x3ffffff, 0x0 }, { 0xffffffff, 0x0 }, { 0xfc000001, 0x3fffffe },
/*28*/ { 0x0, 0xffffda29 }, { 0x222c, 0x0 }, { 0x0, 0xfaf2f10c },
/*29*/ { 0xffffb7dd, 0xffffffd6 }, { 0x3d6c, 0x0 }, { 0xeeb13a3c, 0xfff629b3 },
/*30*/ { 0x6952, 0x0 }, { 0x5af1, 0x0 }, { 0x2569fa32, 0x0 },
/*31*/ { 0x1eb, 0x26e9 }, { 0x153c, 0x0 }, { 0x28ba14, 0x33a3b9c },
/*32*/ { 0xfffff0c2, 0xffffffff }, { 0xffffbbf3, 0x0 }, { 0x40d3e26, 0xfffff0c2 },
/*33*/ { 0x37, 0x0 }, { 0x12, 0x0 }, { 0x3de, 0x0 },
/*34*/ { 0x6443, 0x4dc8 }, { 0x701f, 0x0 }, { 0x2be9741d, 0x2210eb38 },
/*35*/ { 0xffffff83, 0xffffffff }, { 0x1f, 0x0 }, { 0xfffff0dd, 0xffffffff },
/*36*/ { 0x63cb, 0x1ad4 }, { 0x4e45, 0x0 }, { 0x1e82bfb7, 0x833d324 },
/*37*/ { 0xd, 0x0 }, { 0x1db, 0x0 }, { 0x181f, 0x0 },
/*38*/ { 0xfffffee0, 0xffffffff }, { 0xffffb4c0, 0x0 }, { 0x54a800, 0xfffffee0 },
/*39*/ { 0x5cfd, 0x0 }, { 0x3bf6, 0x0 }, { 0x15c7aa1e, 0x0 },
/*40*/ { 0x5f49, 0x0 }, { 0x5e14, 0x0 }, { 0x23043fb4, 0x0 },
/*41*/ { 0xffffd1c0, 0xfffffffb }, { 0xffff993c, 0x0 }, { 0x1290e900, 0x16cd0 },
/*42*/ { 0x6032, 0x7eb7 }, { 0x3ef6, 0x0 }, { 0x17a88c0c, 0x1f2a15da },
/*43*/ { 0x409d, 0x1 }, { 0xffff8c26, 0x0 }, { 0xe2c2734e, 0xffffccc2 },
/*44*/ { 0x1, 0x0 }, { 0x1, 0x0 }, { 0x1, 0x0 },
/*45*/ { 0x4a80, 0x692c }, { 0x3cd5, 0x0 }, { 0x11b3fc80, 0x18fdd19c },
/*46*/ { 0x5db2, 0x80 }, { 0x5753, 0x0 }, { 0x1ff5deb6, 0x2ba980 },
/*47*/ { 0xffffc32a, 0xffffa398 }, { 0x47e, 0x0 }, { 0xfeeeb6ac, 0xfe60e94d },
/*48*/ { 0x368e, 0x1c }, { 0x4657, 0x0 }, { 0xefd5e42, 0x7b184 },
/*49*/ { 0x2fff, 0x61 }, { 0x22cd, 0x0 }, { 0x6864d33, 0xd2fad },
/*50*/ { 0x5e9d, 0x0 }, { 0x6b72, 0x0 }, { 0x27b5c0ea, 0x0 },
/*51*/ { 0x0, 0x0 }, { 0x7, 0x0 }, { 0x0, 0x0 },
/*52*/ { 0xffff9418, 0xffffe728 }, { 0x6bcb, 0x0 }, { 0xd2907708, 0xf58a7082 },
/*53*/ { 0xffffa0e2, 0xfffff1ed }, { 0xffffd4f4, 0x0 }, { 0xffe7f68, 0x25d4fba },
/*54*/ { 0xffff952c, 0xffffffff }, { 0x2059, 0x0 }, { 0xf2805c4c, 0xffffffff },
/*55*/ { 0x7cf, 0x35 }, { 0xecc, 0x0 }, { 0x738af4, 0x3103c },
/*56*/ { 0xfffff170, 0xfffffe2c }, { 0x458f, 0x0 }, { 0xfc0b0d90, 0xff811c22 },
/*57*/ { 0x19d9, 0x0 }, { 0x1dc0, 0x0 }, { 0x300f7c0, 0x0 },
/*58*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*59*/ { 0x2b00, 0x0 }, { 0x7fbe, 0x0 }, { 0x1574ea00, 0x0 },
/*60*/ { 0x15, 0x0 }, { 0x2, 0x0 }, { 0x2a, 0x0 },
/*61*/ { 0x6270, 0x0 }, { 0x4d54, 0x0 }, { 0x1dbbfcc0, 0x0 },
/*62*/ { 0x4c85, 0x3bb1 }, { 0x4ff8, 0x0 }, { 0x17e72bd8, 0x12a57278 },
/*63*/ { 0x3004, 0x0 }, { 0x73d9, 0x0 }, { 0x15ba7f64, 0x0 },
/*64*/ { 0xffffb299, 0xffffffd0 }, { 0x3f4a, 0x0 }, { 0xecdd473a, 0xfff46169 },
/*65*/ { 0x4e57, 0xd0 }, { 0x1316, 0x0 }, { 0x5d7307a, 0xf81e0 },
/*66*/ { 0xffff8b53, 0xffffd0ee }, { 0x5579, 0x0 }, { 0xd90b693b, 0xf0491bf6 },
/*67*/ { 0x48db, 0x12 }, { 0xffff90c4, 0x0 }, { 0xe057f7ac, 0xfff876a2 },
/*68*/ { 0xffffec2d, 0xffffffff }, { 0x520b, 0x0 }, { 0xf9a58fef, 0xffffffff },
/*69*/ { 0x3960, 0x0 }, { 0x4027, 0x0 }, { 0xe60bda0, 0x0 },
/*70*/ { 0xffffa18a, 0xfffff6a6 }, { 0x6fc9, 0x0 }, { 0xd6c0ab5a, 0xfbeb121e },
/*71*/ { 0xd4, 0x0 }, { 0xfffffedb, 0x0 }, { 0xffff0d5c, 0xd3 },
/*72*/ { 0x940, 0x0 }, { 0xd6a, 0x0 }, { 0x7c1480, 0x0 },
/*73*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*74*/ { 0xf97, 0x0 }, { 0x815, 0x0 }, { 0x7dff63, 0x0 },
/*75*/ { 0x1, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*76*/ { 0x5fa8, 0x0 }, { 0x46c2, 0x0 }, { 0x1a706d50, 0x0 },
/*77*/ { 0x50bf, 0x0 }, { 0x5f23, 0x0 }, { 0x1e01eb1d, 0x0 },
/*78*/ { 0xfffffc70, 0xffffb1aa }, { 0xffffef27, 0x0 }, { 0x3c0510, 0x527b27d },
/*79*/ { 0x4c66, 0x0 }, { 0xffffefd0, 0x0 }, { 0xfb2b4ce0, 0x4c65 },
/*80*/ { 0x1bd9, 0x4efe }, { 0x2ba5, 0x0 }, { 0x4bf65dd, 0xd7793b6 },
/*81*/ { 0x549b, 0x2f0c }, { 0x4e38, 0x0 }, { 0x19d9bbe8, 0xe5ff2a0 },
/*82*/ { 0x1289, 0x146 }, { 0x117a, 0x0 }, { 0x143ee4a, 0x16415c },
/*83*/ { 0x36c2, 0x0 }, { 0x1cdf, 0x0 }, { 0x62ceafe, 0x0 },
/*84*/ { 0x676d, 0xe29 }, { 0x7296, 0x0 }, { 0x2e4b23de, 0x6568e06 },
/*85*/ { 0x4ebf, 0x5f34 }, { 0x6e89, 0x0 }, { 0x22003637, 0x291b4ad4 },
/*86*/ { 0x56d, 0x0 }, { 0x328, 0x0 }, { 0x112008, 0x0 },
/*87*/ { 0x2120, 0x0 }, { 0x1003, 0x0 }, { 0x2126360, 0x0 },
/*88*/ { 0x7, 0x0 }, { 0x5, 0x0 }, { 0x23, 0x0 },
/*89*/ { 0x6b28, 0x1 }, { 0xffffcd19, 0x0 }, { 0xeab17ee8, 0x3840 },
/*90*/ { 0xffffbcba, 0xffffff71 }, { 0xffffb50d, 0x0 }, { 0x13b21772, 0x294f84 },
/*91*/ { 0x78fe, 0x578d }, { 0x7871, 0x0 }, { 0x38ec781e, 0x2930bd3d },
/*92*/ { 0x49d0, 0x64a0 }, { 0x8c, 0x0 }, { 0x285dc0, 0x370780 },
/*93*/ { 0x5478, 0xa87 }, { 0x54be, 0x0 }, { 0x1bf61110, 0x37c1c32 },
/*94*/ { 0x3, 0x0 }, { 0xfffffffd, 0x0 }, { 0xfffffff7, 0x2 },
/*95*/ { 0xffff90d0, 0xfffffc05 }, { 0xffffb959, 0x0 }, { 0x1eafa850, 0x11884e6 },
/*96*/ { 0x2332, 0x0 }, { 0x2568, 0x0 }, { 0x5248650, 0x0 },
/*97*/ { 0x58e6, 0x2f0b }, { 0x42be, 0x0 }, { 0x172d46b4, 0xc43c02a },
/*98*/ { 0x389, 0x0 }, { 0xfffffe03, 0x0 }, { 0xfff8f89b, 0x388 },
/*99*/ { 0x6f68, 0x634f }, { 0x6014, 0x0 }, { 0x29cfb420, 0x2545622c },
/*100*/ { 0xfffff82d, 0xffffffff }, { 0xffffe7c6, 0x0 }, { 0xbd8dce, 0xfffff82d },
/*101*/ { 0x4f66, 0x0 }, { 0x63cb, 0x0 }, { 0x1ef367e2, 0x0 },
/*102*/ { 0xfffffba2, 0xffffffff }, { 0x34c, 0x0 }, { 0xfff19a18, 0xffffffff },
/*103*/ { 0x3605, 0x48e6 }, { 0x44aa, 0x0 }, { 0xe7d3352, 0x138d80bc },
/*104*/ { 0x2cd5, 0x32cf }, { 0xfffff701, 0x0 }, { 0xfe6cafd5, 0xfe3718a3 },
/*105*/ { 0xfffff6ec, 0xffffffff }, { 0x1a27, 0x0 }, { 0xff1295f4, 0xffffffff },
/*106*/ { 0x387c, 0x0 }, { 0xffffb433, 0x0 }, { 0xef4670b4, 0x387b },
/*107*/ { 0xffff8fe0, 0xfffffff8 }, { 0x72a6, 0x0 }, { 0xcdc90b40, 0xfffcdd75 },
/*108*/ { 0x504c, 0x3895 }, { 0x214e, 0x0 }, { 0xa724328, 0x75c7266 },
/*109*/ { 0x5ae7, 0x7299 }, { 0x32de, 0x0 }, { 0x120ff252, 0x16c542ae },
/*110*/ { 0xad, 0x0 }, { 0x67, 0x0 }, { 0x459b, 0x0 },
/*111*/ { 0xffffee2b, 0xffffffff }, { 0x749f, 0x0 }, { 0xf7e068b5, 0xffffffff },
/*112*/ { 0xe00, 0x2 }, { 0x53d1, 0x0 }, { 0x4956e00, 0xa7a2 },
/*113*/ { 0xb93, 0x5804 }, { 0x2d73, 0x0 }, { 0x20e0a09, 0xfa03dcc },
/*114*/ { 0x243, 0x0 }, { 0xca, 0x0 }, { 0x1c8de, 0x0 },
/*115*/ { 0x4ecf, 0x0 }, { 0x45ce, 0x0 }, { 0x157d3592, 0x0 },
/*116*/ { 0x3b65, 0x3e }, { 0x5707, 0x0 }, { 0x1430f2c3, 0x1513b2 },
/*117*/ { 0x31be, 0x1 }, { 0xfffff837, 0x0 }, { 0xfe7cbfd2, 0x29f4 },
/*118*/ { 0x1b32, 0x6469 }, { 0x384d, 0x0 }, { 0x5fb1e0a, 0x16152b95 },
/*119*/ { 0x6117, 0x0 }, { 0xffff8763, 0x0 }, { 0xd241ace5, 0x6116 },
/*120*/ { 0xfffff928, 0xffffffff }, { 0x738, 0x0 }, { 0xffce98c0, 0xffffffff },
/*121*/ { 0x4e68, 0x0 }, { 0xffffc5ac, 0x0 }, { 0xee22b5e0, 0x4e67 },
/*122*/ { 0xffffcc8f, 0xffffffff }, { 0x700d, 0x0 }, { 0xe97bf343, 0xffffffff },
/*123*/ { 0x1d, 0x0 }, { 0x32, 0x0 }, { 0x5aa, 0x0 },
/*124*/ { 0x561c, 0x6874 }, { 0x2bb8, 0x0 }, { 0xeb49820, 0x11d68f60 },
/*125*/ { 0x2f95, 0x0 }, { 0xffffaf80, 0x0 }, { 0xf109a580, 0x2f94 },
/*126*/ { 0x448d, 0x176d }, { 0x1943, 0x0 }, { 0x6c3b5e7, 0x24fc687 },
/*127*/ { 0x7a08, 0x11 }, { 0x17bd, 0x0 }, { 0xb50cfe8, 0x1938d },
/*128*/ { 0xffffdfeb, 0xffffde14 }, { 0x5b60, 0x0 }, { 0xf48c8120, 0xf3e4bedf },
/*129*/ { 0xffff98c4, 0xfffff591 }, { 0x4962, 0x0 }, { 0xe2685f08, 0xfd02a3e3 },
/*130*/ { 0xffffe771, 0xfffffff5 }, { 0x52e5, 0x0 }, { 0xf80c3a15, 0xfffcc30d },
/*131*/ { 0x93b, 0x164a }, { 0xffffb8c0, 0x0 }, { 0xfd6e5440, 0xf9cbf0ba },
/*132*/ { 0x1dc3, 0x63c6 }, { 0xffff83b6, 0x0 }, { 0xf18cf1a2, 0xcf8f5e86 },
/*133*/ { 0x6275, 0x2ee }, { 0x2c9e, 0x0 }, { 0x1128e036, 0x82b6e4 },
/*134*/ { 0x3510, 0x0 }, { 0x5981, 0x0 }, { 0x128d4d10, 0x0 },
/*135*/ { 0x28, 0x0 }, { 0x39e, 0x0 }, { 0x90b0, 0x0 },
/*136*/ { 0x81, 0x0 }, { 0xffffff33, 0x0 }, { 0xffff98b3, 0x80 },
/*137*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*138*/ { 0x2, 0x0 }, { 0x7, 0x0 }, { 0xe, 0x0 },
/*139*/ { 0x6959, 0x2d50 }, { 0x5427, 0x0 }, { 0x22a1408f, 0xee52730 },
/*140*/ { 0xb7f, 0x0 }, { 0x13b9, 0x0 }, { 0xe2bbc7, 0x0 },
/*141*/ { 0xffffd3b2, 0xffffffff }, { 0x6de, 0x0 }, { 0xfecfc05c, 0xffffffff },
/*142*/ { 0x3742, 0x5198 }, { 0xffffac4a, 0x0 }, { 0xedee5114, 0xe551ed31 },
/*143*/ { 0x69bb, 0x2ec }, { 0x7de2, 0x0 }, { 0x33fda616, 0x16fd058 },
/*144*/ { 0xffffd983, 0xffffffff }, { 0x4dd3, 0x0 }, { 0xf44cadf9, 0xffffffff },
/*145*/ { 0x60be, 0x0 }, { 0x7fd6, 0x0 }, { 0x304f20d4, 0x0 },
/*146*/ { 0x4f83, 0x0 }, { 0x4898, 0x0 }, { 0x168c0dc8, 0x0 },
/*147*/ { 0x32e, 0x0 }, { 0xfffffe24, 0x0 }, { 0xfffa1678, 0x32d },
/*148*/ { 0xfca, 0x0 }, { 0x3e94, 0x0 }, { 0x3dc0cc8, 0x0 },
/*149*/ { 0x7474, 0x5092 }, { 0xffffc15c, 0x0 }, { 0xe3814db0, 0xec497aeb },
/*150*/ { 0xffff87a2, 0xfffffe2a }, { 0x5d80, 0x0 }, { 0xd409ab00, 0xff54b47f },
/*151*/ { 0x54b, 0x0 }, { 0x45b1, 0x0 }, { 0x170dfdb, 0x0 },
/*152*/ { 0x7f7d, 0x0 }, { 0x161e, 0x0 }, { 0xb03aea6, 0x0 },
/*153*/ { 0xffffd78f, 0xffffff72 }, { 0x1c5e, 0x0 }, { 0xfb84ca82, 0xfff06039 },
/*154*/ { 0x3faf, 0x154e }, { 0xffffff6c, 0x0 }, { 0xffdb2ed4, 0xfff3ee96 },
/*155*/ { 0xffffef8b, 0xffffffe2 }, { 0x5258, 0x0 }, { 0xfab4ddc8, 0xfff6ac07 },
/*156*/ { 0x5df2, 0x0 }, { 0xffffd181, 0x0 }, { 0xeeefe8f2, 0x5df1 },
/*157*/ { 0x691d, 0x73cb }, { 0x6174, 0x0 }, { 0x28039e24, 0x2c1462fc },
/*158*/ { 0x77d2, 0x555 }, { 0xef7, 0x0 }, { 0x701179e, 0x4fcb03 },
/*159*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*160*/ { 0x6788, 0x35 }, { 0x1a2a, 0x0 }, { 0xa94cc50, 0x56ab2 },
/*161*/ { 0x1732, 0x0 }, { 0xffffe7a6, 0x0 }, { 0xfdcb286c, 0x1731 },
/*162*/ { 0xf77, 0x0 }, { 0x6169, 0x0 }, { 0x5e26ecf, 0x0 },
/*163*/ { 0xffffc694, 0xffffffff }, { 0x3f57, 0x0 }, { 0xf1cae84c, 0xffffffff },
/*164*/ { 0xffffb866, 0xffffffff }, { 0x6db2, 0x0 }, { 0xe151a4ec, 0xffffffff },
/*165*/ { 0x50e6, 0x5 }, { 0x7477, 0x0 }, { 0x24cdd2ea, 0x24653 },
/*166*/ { 0x46c3, 0x0 }, { 0xffffa5df, 0x0 }, { 0xe71652dd, 0x46c2 },
/*167*/ { 0x4, 0x0 }, { 0x8, 0x0 }, { 0x20, 0x0 },
/*168*/ { 0xfffff945, 0xffffc251 }, { 0xffff9f36, 0x0 }, { 0x28b6f8e, 0x1751e491 },
/*169*/ { 0x75d, 0x0 }, { 0x5953, 0x0 }, { 0x291b827, 0x0 },
/*170*/ { 0xffff8258, 0xffffffff }, { 0x6fea, 0x0 }, { 0xc9114c70, 0xffffffff },
/*171*/ { 0xffffedab, 0xffffffff }, { 0x2fd9, 0x0 }, { 0xfc92daf3, 0xffffffff },
/*172*/ { 0x6837, 0x5f8 }, { 0xffffdd86, 0x0 }, { 0xf1f707ca, 0xff32a006 },
/*173*/ { 0x6c4e, 0x1d5c }, { 0xffffb204, 0x0 }, { 0xdf01ed38, 0xf70ed9bd },
/*174*/ { 0x1785, 0x0 }, { 0x327d, 0x0 }, { 0x4a375f1, 0x0 },
/*175*/ { 0x74b1, 0xe }, { 0x7c12, 0x0 }, { 0x388df072, 0x6c8fc },
/*176*/ { 0x12c6, 0xb8b }, { 0x7ca3, 0x0 }, { 0x923dc12, 0x59ead81 },
/*177*/ { 0x3f4, 0x0 }, { 0xffff9747, 0x0 }, { 0xfe6204ac, 0x3f3 },
/*178*/ { 0xffffcffe, 0xffffe3fb }, { 0x41e, 0x0 }, { 0xff3a57c4, 0xff8ca787 },
/*179*/ { 0x0, 0x0 }, { 0x2, 0x0 }, { 0x0, 0x0 },
/*180*/ { 0x92, 0x0 }, { 0xb5, 0x0 }, { 0x673a, 0x0 },
/*181*/ { 0x2737, 0x0 }, { 0x3ef2, 0x0 }, { 0x9a463fe, 0x0 },
/*182*/ { 0x126, 0x0 }, { 0xffffff86, 0x0 }, { 0xffff73e4, 0x125 },
/*183*/ { 0xf55, 0x0 }, { 0x7857, 0x0 }, { 0x7350de3, 0x0 },
/*184*/ { 0x6c, 0x0 }, { 0xffffff50, 0x0 }, { 0xffffb5c0, 0x6b },
/*185*/ { 0x21c, 0x0 }, { 0xffffdaa1, 0x0 }, { 0xffb12b9c, 0x21b },
/*186*/ { 0xffff8546, 0xffffb822 }, { 0x68c0, 0x0 }, { 0xcdc86480, 0xe298523f },
/*187*/ { 0x421d, 0x0 }, { 0xffffd544, 0x0 }, { 0xf4f6b0b4, 0x421c },
/*188*/ { 0x624a, 0x3b2b }, { 0x5759, 0x0 }, { 0x218951ba, 0x14302ef3 },
/*189*/ { 0x26a, 0x0 }, { 0x71, 0x0 }, { 0x110ca, 0x0 },
/*190*/ { 0x3, 0x0 }, { 0xfffffff9, 0x0 }, { 0xffffffeb, 0x2 },
/*191*/ { 0xfffffee6, 0xffffffff }, { 0x122, 0x0 }, { 0xfffec08c, 0xffffffff },
/*192*/ { 0x3105, 0x773c }, { 0x6ebe, 0x0 }, { 0x153487b6, 0x33944688 },
/*193*/ { 0xffffd562, 0xffffffff }, { 0x4fe, 0x0 }, { 0xff2b3f3c, 0xffffffff },
/*194*/ { 0xa, 0x0 }, { 0xf, 0x0 }, { 0x96, 0x0 },
/*195*/ { 0x2714, 0x0 }, { 0xffffd90e, 0x0 }, { 0xfa0e1718, 0x2713 },
/*196*/ { 0xffffb4af, 0xffffe897 }, { 0x6fec, 0x0 }, { 0xdf127254, 0xf5c4541f },
/*197*/ { 0xffffa2ee, 0xfffff96b }, { 0x3930, 0x0 }, { 0xeb358aa0, 0xfe87d03f },
/*198*/ { 0x3af, 0x3 }, { 0x20e3, 0x0 }, { 0x79242d, 0x62a9 },
/*199*/ { 0x1da1, 0x0 }, { 0xfffff5cf, 0x0 }, { 0xfed20a2f, 0x1da0 },
/*200*/ { 0x1fd, 0x0 }, { 0xef, 0x0 }, { 0x1db33, 0x0 },
/*201*/ { 0xfffffff7, 0xffffffff }, { 0xfffffff1, 0x0 }, { 0x87, 0xfffffff7 },
/*202*/ { 0x6f5e, 0x4be2 }, { 0xffff8742, 0x0 }, { 0xcb79483c, 0xdc362da1 },
/*203*/ { 0xffffffd1, 0xffffffff }, { 0x54, 0x0 }, { 0xfffff094, 0xffffffff },
/*204*/ { 0xffffee94, 0xffffffff }, { 0x660a, 0x0 }, { 0xf90e49c8, 0xffffffff },
/*205*/ { 0x1d, 0x0 }, { 0xe, 0x0 }, { 0x196, 0x0 },
/*206*/ { 0xfffff64f, 0xfffffd0d }, { 0xffffcb8c, 0x0 }, { 0x1fc5834, 0x9a73f7 },
/*207*/ { 0x174f, 0x0 }, { 0x4347, 0x0 }, { 0x62023e9, 0x0 },
/*208*/ { 0x1454, 0x2742 }, { 0x1739, 0x0 }, { 0x1d812b4, 0x38fabb2 },
/*209*/ { 0xffffb6f4, 0xffffff99 }, { 0xffff908c, 0x0 }, { 0x1fcd4d70, 0x2c1f2c },
/*210*/ { 0xd77, 0x0 }, { 0xffff8d6d, 0x0 }, { 0xf9f946ab, 0xd76 },
/*211*/ { 0x6944, 0x6fa7 }, { 0xffffc648, 0x0 }, { 0xe8443320, 0xe6d3fa3b },
/*212*/ { 0x7db6, 0x7987 }, { 0x10e4, 0x0 }, { 0x84b5618, 0x804ac3c },
/*213*/ { 0x3e61, 0x4cdd }, { 0xffffa774, 0x0 }, { 0xea6c8af4, 0xe56a3d84 },
/*214*/ { 0xffff823c, 0xffffff98 }, { 0x72f2, 0x0 }, { 0xc787d4b8, 0xffd1c0a1 },
/*215*/ { 0x44cc, 0x0 }, { 0xffffea57, 0x0 }, { 0xfa2dd954, 0x44cb },
/*216*/ { 0x761e, 0x1c11 }, { 0x57e5, 0x0 }, { 0x288ddad6, 0x9a2e235 },
/*217*/ { 0x83f, 0x0 }, { 0x5ae, 0x0 }, { 0x2ed5d2, 0x0 },
/*218*/ { 0x6b49, 0x2a9 }, { 0xffffb736, 0x0 }, { 0xe17ed066, 0xff3ec9ee },
/*219*/ { 0xe, 0x0 }, { 0x15, 0x0 }, { 0x126, 0x0 },
/*220*/ { 0x381c, 0x1e }, { 0x8bd, 0x0 }, { 0x1ea4cac, 0x10626 },
/*221*/ { 0xd3, 0x0 }, { 0x4e, 0x0 }, { 0x404a, 0x0 },
/*222*/ { 0x1ef6, 0x0 }, { 0x1613, 0x0 }, { 0x2ab7042, 0x0 },
/*223*/ { 0x2684, 0x1c2d }, { 0xffffde5e, 0x0 }, { 0xfaf09c78, 0xfc4c8509 },
/*224*/ { 0x4802, 0x0 }, { 0x3a13, 0x0 }, { 0x1055cc26, 0x0 },
/*225*/ { 0x759, 0xba }, { 0x48a6, 0x0 }, { 0x215cbb6, 0x34c89c },
/*226*/ { 0x65cf, 0xa65 }, { 0x4c21, 0x0 }, { 0x1e4693af, 0x3175305 },
/*227*/ { 0x7d4b, 0x1 }, { 0x20a8, 0x0 }, { 0xffb9938, 0x20a8 },
/*228*/ { 0x22e0, 0x65c0 }, { 0x1a6e, 0x0 }, { 0x399bc40, 0xa813880 },
/*229*/ { 0xffffd2b1, 0xffffb29d }, { 0xffffe360, 0x0 }, { 0x510f560, 0x8a6e7f1 },
/*230*/ { 0xffff85f4, 0xfffffffe }, { 0xffffd281, 0x0 }, { 0x15b0a7f4, 0xffffb373 },
/*231*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*232*/ { 0xffffff43, 0xfffffff6 }, { 0x2533, 0x0 }, { 0xffe48959, 0xfffeb134 },
/*233*/ { 0xffffffff, 0xffffffff }, { 0x6, 0x0 }, { 0xfffffffa, 0xffffffff },
/*234*/ { 0x4574, 0x1337 }, { 0xd0c, 0x0 }, { 0x38a2570, 0xfab194 },
/*235*/ { 0x57fd, 0x3 }, { 0xffffe7cf, 0x0 }, { 0xf7af7093, 0xf69 },
/*236*/ { 0xfffff9e8, 0xffffffff }, { 0xae1, 0x0 }, { 0xffbdb4e8, 0xffffffff },
/*237*/ { 0xffffb68b, 0xffff84cb }, { 0x34ed, 0x0 }, { 0xf0d03aaf, 0xe68760db },
/*238*/ { 0x78fb, 0x6963 }, { 0x654, 0x0 }, { 0x2fd945c, 0x29ae67c },
/*239*/ { 0x3a2c, 0x0 }, { 0x2b97, 0x0 }, { 0x9e7b3f4, 0x0 },
/*240*/ { 0xffffff61, 0xffff9886 }, { 0xffffd774, 0x0 }, { 0x192ef4, 0x10637d8d },
/*241*/ { 0x7e0, 0x0 }, { 0xffffe0a1, 0x0 }, { 0xff08f3e0, 0x7df },
/*242*/ { 0x2, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*243*/ { 0xffffbed5, 0xffffffff }, { 0xab5, 0x0 }, { 0xfd463e99, 0xffffffff },
/*244*/ { 0xfffff4d2, 0xffffffff }, { 0x2a98, 0x0 }, { 0xfe23d0b0, 0xffffffff },
/*245*/ { 0xffffedb8, 0xfffff157 }, { 0xffff80b8, 0x0 }, { 0x916dc40, 0x74964f8 },
/*246*/ { 0x426e, 0x0 }, { 0x62a1, 0x0 }, { 0x1997e32e, 0x0 },
/*247*/ { 0x2f49, 0x7c0e }, { 0x26bc, 0x0 }, { 0x7278f9c, 0x12c52e48 },
/*248*/ { 0x350b, 0x2 }, { 0x36b7, 0x0 }, { 0xb563cdd, 0x6d6e },
/*249*/ { 0xfffff44d, 0xffffa1ee }, { 0xffffae5d, 0x0 }, { 0x3bb15f9, 0x1dff3a20 },
/*250*/ { 0xfffff3eb, 0xffffff32 }, { 0x74e9, 0x0 }, { 0xfa7b7ce3, 0xffa2616a },
/*251*/ { 0x13bf, 0x27b8 }, { 0x1a5c, 0x0 }, { 0x2087ea4, 0x416f620 },
/*252*/ { 0x860, 0x2aea }, { 0xffffc6db, 0x0 }, { 0xfe216a20, 0xf66bba8d },
/*253*/ { 0xffffc251, 0xffffe90d }, { 0x77e5, 0x0 }, { 0xe31c7975, 0xf540fb85 },
/*254*/ { 0xffff96bb, 0xffffffa8 }, { 0xec, 0x0 }, { 0xff9ef464, 0xffffafcb },
/*255*/ { 0x2, 0x0 }, { 0xfffffffe, 0x0 }, { 0xfffffffc, 0x1 },
/*256*/ { 0xbf9, 0x3ee1 }, { 0x3122, 0x0 }, { 0x24c4012, 0xc116ae2 },
/*257*/ { 0x4, 0x0 }, { 0x2, 0x0 }, { 0x8, 0x0 },
/*258*/ { 0xe, 0x0 }, { 0x6, 0x0 }, { 0x54, 0x0 },
/*259*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*260*/ { 0x43f, 0x0 }, { 0xb1, 0x0 }, { 0x2ef8f, 0x0 },
/*261*/ { 0x4bf7, 0x0 }, { 0x649f, 0x0 }, { 0x1ddbaa69, 0x0 },
/*262*/ { 0x6c12, 0x16 }, { 0xffff8c52, 0x0 }, { 0xcf2a75c4, 0xfff67b1d },
/*263*/ { 0x2e01, 0x7245 }, { 0x579f, 0x0 }, { 0xfbee99f, 0x271c6bdb },
/*264*/ { 0xffffc88b, 0xffffffff }, { 0x4390, 0x0 }, { 0xf15d2f30, 0xffffffff },
/*265*/ { 0xfffff879, 0xffffffff }, { 0xfffffc51, 0x0 }, { 0x1bba49, 0xfffff879 },
/*266*/ { 0x74a3, 0x2e }, { 0x1b0a, 0x0 }, { 0xc51bf5e, 0x4dbcc },
/*267*/ { 0xffff8f28, 0xffffffff }, { 0x7008, 0x0 }, { 0xce9df940, 0xffffffff },
/*268*/ { 0x1932, 0x0 }, { 0x5177, 0x0 }, { 0x804883e, 0x0 },
/*269*/ { 0x14d, 0x0 }, { 0x72, 0x0 }, { 0x944a, 0x0 },
/*270*/ { 0x49d, 0x5f21 }, { 0x48d3, 0x0 }, { 0x14ff567, 0x1b0fb033 },
/*271*/ { 0xfffff61f, 0xffffe3fb }, { 0x111d, 0x0 }, { 0xff56f083, 0xfe208f8b },
/*272*/ { 0xffffbee1, 0xfffffff5 }, { 0xfffff06b, 0x0 }, { 0x3f6b80b, 0x5ab3 },
/*273*/ { 0x3c47, 0x5a7d }, { 0xffff982e, 0x0 }, { 0xe78dfcc2, 0xdb4db6bc },
/*274*/ { 0xffff95dd, 0xfffff761 }, { 0x792c, 0x0 }, { 0xcdc336fc, 0xfbebd6d7 },
/*275*/ { 0xffffc63c, 0xffffffff }, { 0x7132, 0x0 }, { 0xe67533b8, 0xffffffff },
/*276*/ { 0xffffbf0e, 0xfffffff0 }, { 0x6548, 0x0 }, { 0xe64e41f0, 0xfffa10c7 },
/*277*/ { 0x5f46, 0x0 }, { 0xffffb501, 0x0 }, { 0xe416dd46, 0x5f45 },
/*278*/ { 0x1f, 0x0 }, { 0xffffffe2, 0x0 }, { 0xfffffc5e, 0x1e },
/*279*/ { 0xfffffffd, 0xffffffff }, { 0xfffffffd, 0x0 }, { 0x9, 0xfffffffd },
/*280*/ { 0xffff9256, 0xffffba5c }, { 0x281c, 0x0 }, { 0xeed17168, 0xf516ea2b },
/*281*/ { 0xfffffeaf, 0xffffffff }, { 0xfffffe6a, 0x0 }, { 0x21676, 0xfffffeaf },
/*282*/ { 0xd5, 0x0 }, { 0xffffffaa, 0x0 }, { 0xffffb872, 0xd4 },
/*283*/ { 0x33e9, 0x0 }, { 0x40c8, 0x0 }, { 0xd22ce08, 0x0 },
/*284*/ { 0x500d, 0x0 }, { 0x7307, 0x0 }, { 0x23f8075b, 0x0 },
/*285*/ { 0x5658, 0xa01 }, { 0xffff89f3, 0x0 }, { 0xd82f0d88, 0xfb635e4a },
/*286*/ { 0xffffecf8, 0xfffffeea }, { 0xffffa7bf, 0x0 }, { 0x68f9508, 0x5f6b4d },
/*287*/ { 0x3a14, 0x0 }, { 0xfffff34d, 0x0 }, { 0xfd1e7404, 0x3a13 },
/*288*/ { 0x7060, 0x0 }, { 0x5ce3, 0x0 }, { 0x28c62520, 0x0 },
/*289*/ { 0x681d, 0x0 }, { 0xffffd19e, 0x0 }, { 0xed22eee6, 0x681c },
/*290*/ { 0x6450, 0x0 }, { 0xfffff019, 0x0 }, { 0xf9c4cbd0, 0x644f },
/*291*/ { 0xffffdc3c, 0xfffffffc }, { 0x28c8, 0x0 }, { 0xfa4d6ee0, 0xffff85a7 },
/*292*/ { 0xfffffe9b, 0xffffffff }, { 0x22d, 0x0 }, { 0xfffcf73f, 0xffffffff },
/*293*/ { 0xffffd8a0, 0xffffffff }, { 0xffff84fb, 0x0 }, { 0x12ebe4e0, 0xffffd8a0 },
/*294*/ { 0x1a, 0x0 }, { 0xfffffff9, 0x0 }, { 0xffffff4a, 0x19 },
/*295*/ { 0x2c3, 0x368 }, { 0x5c24, 0x0 }, { 0xfe776c, 0x139daa0 },
/*296*/ { 0xb, 0x0 }, { 0xfffffff4, 0x0 }, { 0xffffff7c, 0xa },
/*297*/ { 0x494a, 0x0 }, { 0xffffb9fe, 0x0 }, { 0xebf5316c, 0x4949 },
/*298*/ { 0x65a2, 0x20 }, { 0x44f2, 0x0 }, { 0x1b5f1b24, 0x89e40 },
/*299*/ { 0x31d7, 0x1 }, { 0x5870, 0x0 }, { 0x1137b610, 0x5870 },
/*300*/ { 0x71b1, 0x0 }, { 0xe44, 0x0 }, { 0x655e104, 0x0 },
/*301*/ { 0x7d1d, 0x5de1 }, { 0xffffb18d, 0x0 }, { 0xd9a8f5f9, 0xe33bc309 },
/*302*/ { 0x7fce, 0x0 }, { 0xffffaf54, 0x0 }, { 0xd7b9c198, 0x7fcd },
/*303*/ { 0x7706, 0x0 }, { 0x53ef, 0x0 }, { 0x2706109a, 0x0 },
/*304*/ { 0x34b, 0x0 }, { 0xf4c, 0x0 }, { 0x325f44, 0x0 },
/*305*/ { 0x4619, 0x17 }, { 0x5c25, 0x0 }, { 0x193b1d9d, 0x84753 },
/*306*/ { 0x20cb, 0x0 }, { 0xffffe441, 0x0 }, { 0xfc721f8b, 0x20ca },
/*307*/ { 0x28, 0x0 }, { 0x46, 0x0 }, { 0xaf0, 0x0 },
/*308*/ { 0x2af9, 0x1 }, { 0xa6d, 0x0 }, { 0x1c00605, 0xa6d },
/*309*/ { 0x31, 0x0 }, { 0xa, 0x0 }, { 0x1ea, 0x0 },
/*310*/ { 0xffffe334, 0xffffc603 }, { 0x7081, 0x0 }, { 0xf3583d34, 0xe6848803 },
/*311*/ { 0x1db4, 0x34b2 }, { 0x5c8c, 0x0 }, { 0xabcee70, 0x130cc958 },
/*312*/ { 0x7275, 0x0 }, { 0x440d, 0x0 }, { 0x1e6ce3f1, 0x0 },
/*313*/ { 0x1ef, 0x12 }, { 0x71df, 0x0 }, { 0xdc2e31, 0x801ae },
/*314*/ { 0xd41, 0x3 }, { 0x648, 0x0 }, { 0x534048, 0x12d8 },
/*315*/ { 0x7fc3, 0xeee }, { 0x5712, 0x0 }, { 0x2b7440b6, 0x513eebc },
/*316*/ { 0x601c, 0x0 }, { 0x54dc, 0x0 }, { 0x1fdbc810, 0x0 },
/*317*/ { 0x7425, 0x91a }, { 0x499e, 0x0 }, { 0x21663bd6, 0x29e080c },
/*318*/ { 0x4975, 0x5 }, { 0x6aca, 0x0 }, { 0x1ea46852, 0x215f2 },
/*319*/ { 0x3969, 0x0 }, { 0x774, 0x0 }, { 0x1abe294, 0x0 },
/*320*/ { 0x7cb0, 0xf9a }, { 0x1a4e, 0x0 }, { 0xccfdda0, 0x19a64ec },
/*321*/ { 0x6bd6, 0x7950 }, { 0x3727, 0x0 }, { 0x173b679a, 0x1a22ab30 },
/*322*/ { 0x606c, 0x6e0 }, { 0xffffaf45, 0x0 }, { 0xe197d11c, 0xfdd55acb },
/*323*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*324*/ { 0xffffffb4, 0xffffffff }, { 0xfffffda7, 0x0 }, { 0xb26c, 0xffffffb4 },
/*325*/ { 0x11e4, 0x0 }, { 0x6daa, 0x0 }, { 0x7a9f568, 0x0 },
/*326*/ { 0x4ffc, 0x0 }, { 0x3fa2, 0x0 }, { 0x13e1a178, 0x0 },
/*327*/ { 0xe07, 0x0 }, { 0xca7, 0x0 }, { 0xb17a91, 0x0 },
/*328*/ { 0x42a7, 0xbed }, { 0x5e70, 0x0 }, { 0x18967b10, 0x4663db0 },
/*329*/ { 0x17fb, 0x0 }, { 0x5c57, 0x0 }, { 0x8a65a4d, 0x0 },
/*330*/ { 0x7529, 0x0 }, { 0x60fc, 0x0 }, { 0x2c62b45c, 0x0 },
/*331*/ { 0x2312, 0x5f4f }, { 0x6102, 0x0 }, { 0xd4a1824, 0x241dad9e },
/*332*/ { 0x6, 0x0 }, { 0x7, 0x0 }, { 0x2a, 0x0 },
/*333*/ { 0xffff9fc3, 0xffffe1ec }, { 0x7bca, 0x0 }, { 0xd176c0de, 0xf1752401 },
/*334*/ { 0x71c6, 0x0 }, { 0x6694, 0x0 }, { 0x2d96aa78, 0x0 },
/*335*/ { 0x3632, 0x51 }, { 0xffffa7da, 0x0 }, { 0xed56c494, 0xffe4522b },
/*336*/ { 0x4, 0x0 }, { 0x1, 0x0 }, { 0x4, 0x0 },
/*337*/ { 0x2e, 0x0 }, { 0x31, 0x0 }, { 0x8ce, 0x0 },
/*338*/ { 0xffffbcb6, 0xfffffff8 }, { 0xfffff9de, 0x0 }, { 0x19cabd4, 0xffffe7a4 },
/*339*/ { 0x6f, 0x0 }, { 0xa, 0x0 }, { 0x456, 0x0 },
/*340*/ { 0x293c, 0x727 }, { 0x777f, 0x0 }, { 0x133f58c4, 0x356ad59 },
/*341*/ { 0x49e3, 0x0 }, { 0x64bf, 0x0 }, { 0x1d13cc5d, 0x0 },
/*342*/ { 0x3, 0x0 }, { 0x2, 0x0 }, { 0x6, 0x0 },
/*343*/ { 0x8d1, 0xe01 }, { 0x2777, 0x0 }, { 0x15bf027, 0x228a977 },
/*344*/ { 0x29e2, 0x0 }, { 0x7682, 0x0 }, { 0x136370c4, 0x0 },
/*345*/ { 0x4a67, 0x5ada }, { 0x62d6, 0x0 }, { 0x1cb9a01a, 0x2313663c },
/*346*/ { 0x2712, 0x0 }, { 0xffffe809, 0x0 }, { 0xfc57afa2, 0x2711 },
/*347*/ { 0x4166, 0x3049 }, { 0x4ed2, 0x0 }, { 0x1422b9ac, 0xeddd9e2 },
/*348*/ { 0x5d85, 0x7a7d }, { 0x111c, 0x0 }, { 0x6400f8c, 0x82fb2ac },
/*349*/ { 0x646e, 0x0 }, { 0x6b70, 0x0 }, { 0x2a25ea20, 0x0 },
/*350*/ { 0x6dc6, 0x7fbf }, { 0x7b40, 0x0 }, { 0x34d99380, 0x3d80b4c0 },
/*351*/ { 0xfffffffe, 0xffffffff }, { 0x6, 0x0 }, { 0xfffffff4, 0xffffffff },
/*352*/ { 0x4c60, 0x1b }, { 0x1a5b, 0x0 }, { 0x7dce620, 0x2c799 },
/*353*/ { 0x2, 0x0 }, { 0x3, 0x0 }, { 0x6, 0x0 },
/*354*/ { 0x38ba, 0x32f3 }, { 0x267a, 0x0 }, { 0x886a4a4, 0x7a859ce },
/*355*/ { 0x5597, 0x0 }, { 0xffffc38b, 0x0 }, { 0xebc97dfd, 0x5596 },
/*356*/ { 0x4aea, 0x4 }, { 0x68ae, 0x0 }, { 0x1ea1fb0c, 0x1a2b8 },
/*357*/ { 0x1, 0x0 }, { 0xfffffffa, 0x0 }, { 0xfffffffa, 0x0 },
/*358*/ { 0x4a4e, 0x4d3a }, { 0x70d8, 0x0 }, { 0x20c0d1d0, 0x220a88f0 },
/*359*/ { 0x0, 0x0 }, { 0x1, 0x0 }, { 0x0, 0x0 },
/*360*/ { 0x6413, 0x0 }, { 0x32e4, 0x0 }, { 0x13e4d6ec, 0x0 },
/*361*/ { 0xffffffd0, 0xffffffff }, { 0x7, 0x0 }, { 0xfffffeb0, 0xffffffff },
/*362*/ { 0x73f1, 0x6354 }, { 0xffff86a1, 0x0 }, { 0xc9081091, 0xd0e8e3c4 },
/*363*/ { 0xa3, 0x0 }, { 0x55, 0x0 }, { 0x361f, 0x0 },
/*364*/ { 0x32c1, 0xf32 }, { 0x2062, 0x0 }, { 0x66b8de2, 0x1ec1124 },
/*365*/ { 0x5205, 0x5723 }, { 0xffffbeb3, 0x0 }, { 0xeb140f7f, 0xe9c6397d },
/*366*/ { 0x15be, 0x0 }, { 0x4745, 0x0 }, { 0x60d8e36, 0x0 },
/*367*/ { 0xffff8003, 0xffffffff }, { 0x5d9, 0x0 }, { 0xfd13918b, 0xffffffff },
/*368*/ { 0x468a, 0x2 }, { 0x68a3, 0x0 }, { 0x1cd4f9de, 0xd146 },
/*369*/ { 0x6d5f, 0x0 }, { 0x29cc, 0x0 }, { 0x11db5eb4, 0x0 },
/*370*/ { 0xfffff0aa, 0xffffffff }, { 0x1f8b, 0x0 }, { 0xfe1c424e, 0xffffffff },
/*371*/ { 0xeb0, 0x0 }, { 0x7796, 0x0 }, { 0x6dc6b20, 0x0 },
/*372*/ { 0x6fb4, 0x0 }, { 0x1df6, 0x0 }, { 0xd12baf8, 0x0 },
/*373*/ { 0x5433, 0x0 }, { 0x1678, 0x0 }, { 0x763d9e8, 0x0 },
/*374*/ { 0x1ff, 0x0 }, { 0x1da, 0x0 }, { 0x3b226, 0x0 },
/*375*/ { 0xfffffeac, 0xffffffff }, { 0x85, 0x0 }, { 0xffff4f5c, 0xffffffff },
/*376*/ { 0xe6a, 0x42cf }, { 0x7f73, 0x0 }, { 0x72d0f9e, 0x2142b3fd },
/*377*/ { 0x3b90, 0x5d }, { 0x78d3, 0x0 }, { 0x1c1c97b0, 0x2be4a7 },
/*378*/ { 0xffff9c02, 0xffffff64 }, { 0x4e9b, 0x0 }, { 0xe14c1136, 0xffd06826 },
/*379*/ { 0x6ea, 0x0 }, { 0xffffe261, 0x0 }, { 0xff3332aa, 0x6e9 },
/*380*/ { 0x4140, 0x81 }, { 0xffff91c1, 0x0 }, { 0xe3e67140, 0xffc8b380 },
/*381*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*382*/ { 0xffffeacd, 0xffffc125 }, { 0x405a, 0x0 }, { 0xfaabcc12, 0xf033675b },
/*383*/ { 0x1426, 0x1fa }, { 0x45e1, 0x0 }, { 0x57ff366, 0x8a1eba },
/*384*/ { 0xeea, 0x0 }, { 0x6201, 0x0 }, { 0x5b5a2ea, 0x0 },
/*385*/ { 0x672c, 0x7572 }, { 0x6333, 0x0 }, { 0x27fa91c4, 0x2d827bb6 },
/*386*/ { 0x44f3, 0x7522 }, { 0x525d, 0x0 }, { 0x162ee247, 0x25af715a },
/*387*/ { 0x48fe, 0x0 }, { 0x639e, 0x0 }, { 0x1c6746c4, 0x0 },
/*388*/ { 0xffff98c8, 0xffffe771 }, { 0xffff875b, 0x0 }, { 0x30a4c718, 0xb91fc4e },
/*389*/ { 0x1199, 0x0 }, { 0xffffecef, 0x0 }, { 0xfeb079d7, 0x1198 },
/*390*/ { 0x512a, 0x13b5 }, { 0x327f, 0x0 }, { 0x100277d6, 0x3e320cb },
/*391*/ { 0xffff958d, 0xffffffff }, { 0x5209, 0x0 }, { 0xdde36bf5, 0xffffffff },
/*392*/ { 0xffffe8aa, 0xffffffe1 }, { 0x7d50, 0x0 }, { 0xf493b720, 0xfff1509f },
/*393*/ { 0x4382, 0x1 }, { 0x1268, 0x0 }, { 0x4da90d0, 0x1268 },
/*394*/ { 0x26b1, 0x1386 }, { 0x4c53, 0x0 }, { 0xb891763, 0x5d21c72 },
/*395*/ { 0x4a9f, 0x0 }, { 0x6502, 0x0 }, { 0x1d71503e, 0x0 },
/*396*/ { 0xd42, 0xa55 }, { 0x2a3, 0x0 }, { 0x22f506, 0x1b3e1f },
/*397*/ { 0x35cd, 0x7d48 }, { 0xfffff22a, 0x0 }, { 0xfd179da2, 0xf93ad39c },
/*398*/ { 0x5aed, 0xb03 }, { 0x2376, 0x0 }, { 0xc98503e, 0x1867c62 },
/*399*/ { 0x5100, 0x0 }, { 0x4921, 0x0 }, { 0x17237100, 0x0 },
/*400*/ { 0xfffffff3, 0xffffffff }, { 0x34, 0x0 }, { 0xfffffd5c, 0xffffffff },
/*401*/ { 0x3e82, 0x0 }, { 0x5dd0, 0x0 }, { 0x16e803a0, 0x0 },
/*402*/ { 0xffffc957, 0xfffffffc }, { 0x335, 0x0 }, { 0xff50b403, 0xfffff660 },
/*403*/ { 0x4504, 0x6043 }, { 0x5a01, 0x0 }, { 0x1843ad04, 0x21d7ee43 },
/*404*/ { 0xfffffff9, 0xffffffff }, { 0x1, 0x0 }, { 0xfffffff9, 0xffffffff },
/*405*/ { 0x30f8, 0x4cf }, { 0x348c, 0x0 }, { 0xa0d27a0, 0xfcad34 },
/*406*/ { 0x2e35, 0x0 }, { 0xffffc0a0, 0x0 }, { 0xf48fa120, 0x2e34 },
/*407*/ { 0x46d5, 0x12 }, { 0x1ace, 0x0 }, { 0x76aa166, 0x1e27c },
/*408*/ { 0x2e85, 0x0 }, { 0xffff8d28, 0x0 }, { 0xeb2185c8, 0x2e84 },
/*409*/ { 0x1, 0x0 }, { 0xf, 0x0 }, { 0xf, 0x0 },
/*410*/ { 0x0, 0x0 }, { 0x2d, 0x0 }, { 0x0, 0x0 },
/*411*/ { 0x6266, 0x6c56 }, { 0x7d12, 0x0 }, { 0x3012b92c, 0x34ed9c0c },
/*412*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*413*/ { 0x65d4, 0x0 }, { 0x3138, 0x0 }, { 0x1393da60, 0x0 },
/*414*/ { 0xf2, 0x0 }, { 0xffffff30, 0x0 }, { 0xffff3b60, 0xf1 },
/*415*/ { 0x68be, 0x0 }, { 0x61bc, 0x0 }, { 0x27fce988, 0x0 },
/*416*/ { 0x7c4, 0x0 }, { 0x4a3a, 0x0 }, { 0x2406a68, 0x0 },
/*417*/ { 0x367a, 0x0 }, { 0x452c, 0x0 }, { 0xeb83ef8, 0x0 },
/*418*/ { 0x50ce, 0x0 }, { 0xffffb666, 0x0 }, { 0xe8c4a614, 0x50cd },
/*419*/ { 0x7b84, 0x5691 }, { 0x71, 0x0 }, { 0x368544, 0x263601 },
/*420*/ { 0xffffe8d2, 0xffffee10 }, { 0x61b4, 0x0 }, { 0xf72745a8, 0xf927d4f3 },
/*421*/ { 0x3f7b, 0x2eb7 }, { 0x1583, 0x0 }, { 0x55592f1, 0x3eceaa5 },
/*422*/ { 0x2ac7, 0x44b0 }, { 0x3c51, 0x0 }, { 0xa142cf7, 0x102efbb0 },
/*423*/ { 0xffffffb4, 0xffffffff }, { 0x18, 0x0 }, { 0xfffff8e0, 0xffffffff },
/*424*/ { 0x14e7, 0x0 }, { 0xffffe455, 0x0 }, { 0xfdbdacb3, 0x14e6 },
/*425*/ { 0x2a09, 0x0 }, { 0xffffbd2d, 0x0 }, { 0xf5070895, 0x2a08 },
/*426*/ { 0x4621, 0x93 }, { 0x4c10, 0x0 }, { 0x14d62e10, 0x2bad30 },
/*427*/ { 0x2521, 0x0 }, { 0x53a1, 0x0 }, { 0xc210cc1, 0x0 },
/*428*/ { 0x1108, 0x0 }, { 0x74fb, 0x0 }, { 0x7c852d8, 0x0 },
/*429*/ { 0x52ed, 0xbb }, { 0xffff8bc4, 0x0 }, { 0xda592c74, 0xffab6b18 },
/*430*/ { 0x648b, 0x1d2e }, { 0x1fe0, 0x0 }, { 0xc84cea0, 0x3a21a40 },
/*431*/ { 0x69d3, 0x81 }, { 0x1215, 0x0 }, { 0x779844f, 0x91c95 },
/*432*/ { 0xfffffff3, 0xffffffff }, { 0x2, 0x0 }, { 0xffffffe6, 0xffffffff },
/*433*/ { 0x6c70, 0x39 }, { 0xffffaced, 0x0 }, { 0xdccfa3b0, 0xffeded34 },
/*434*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*435*/ { 0x4d82, 0x0 }, { 0x78e3, 0x0 }, { 0x2499aa46, 0x0 },
/*436*/ { 0xfffffffb, 0xffffffff }, { 0x2, 0x0 }, { 0xfffffff6, 0xffffffff },
/*437*/ { 0xffffaf74, 0xffffffff }, { 0x4ad2, 0x0 }, { 0xe8757528, 0xffffffff },
/*438*/ { 0xffff8838, 0xffffffff }, { 0x526c, 0x0 }, { 0xd96f67a0, 0xffffffff },
/*439*/ { 0x18eb, 0x6384 }, { 0x169, 0x0 }, { 0x232363, 0x8c5524 },
/*440*/ { 0x2caa, 0x50 }, { 0x38a8, 0x0 }, { 0x9e27f90, 0x11b480 },
/*441*/ { 0x4f54, 0x5d50 }, { 0x1940, 0x0 }, { 0x7d30900, 0x9342400 },
/*442*/ { 0x360d, 0x10fa }, { 0x3fa4, 0x0 }, { 0xd6fd354, 0x4386628 },
/*443*/ { 0x69f3, 0xef8 }, { 0x6ac2, 0x0 }, { 0x2c2ee826, 0x63e07f0 },
/*444*/ { 0x438b, 0x0 }, { 0x90d, 0x0 }, { 0x263510f, 0x0 },
/*445*/ { 0x5a1, 0x63b }, { 0x7add, 0x0 }, { 0x2b395fd, 0x2fd7eef },
/*446*/ { 0x463d, 0x3695 }, { 0x75b, 0x0 }, { 0x204a2af, 0x19179f7 },
/*447*/ { 0x6ef2, 0x1509 }, { 0x3ccf, 0x0 }, { 0x1a5a6dae, 0x4ff1e47 },
/*448*/ { 0xe67, 0x74a }, { 0x7ffc, 0x0 }, { 0x7334664, 0x3a4e2d8 },
/*449*/ { 0xfffffff9, 0xffffffff }, { 0x1, 0x0 }, { 0xfffffff9, 0xffffffff },
/*450*/ { 0xffffe3fd, 0xfffffffa }, { 0xffffca95, 0x0 }, { 0x5d85441, 0xef14 },
/*451*/ { 0x3441, 0x64be }, { 0x1189, 0x0 }, { 0x39447c9, 0x6e687ae },
/*452*/ { 0x20c4, 0x7430 }, { 0x4753, 0x0 }, { 0x920fb8c, 0x205efb90 },
/*453*/ { 0xffff9229, 0xffffffee }, { 0x5394, 0x0 }, { 0xdc23cab4, 0xfffa732b },
/*454*/ { 0x515e, 0x0 }, { 0xffffc5fa, 0x0 }, { 0xed8ecbcc, 0x515d },
/*455*/ { 0x3006, 0x0 }, { 0x1085, 0x0 }, { 0x319531e, 0x0 },
/*456*/ { 0x293f, 0x0 }, { 0x3fee, 0x0 }, { 0xa4cd992, 0x0 },
/*457*/ { 0x8de, 0x683d }, { 0x8a0, 0x0 }, { 0x4c7ac0, 0x3830e20 },
/*458*/ { 0x7efa, 0x0 }, { 0x1ecf, 0x0 }, { 0xf47f826, 0x0 },
/*459*/ { 0xf, 0x0 }, { 0x9, 0x0 }, { 0x87, 0x0 },
/*460*/ { 0x90d, 0x0 }, { 0x2fe2, 0x0 }, { 0x1b1607a, 0x0 },
/*461*/ { 0x54bd, 0x0 }, { 0x2b56, 0x0 }, { 0xe58367e, 0x0 },
/*462*/ { 0x9d0, 0x0 }, { 0xffffaac7, 0x0 }, { 0xfcbbc0b0, 0x9cf },
/*463*/ { 0x30d, 0x0 }, { 0xce, 0x0 }, { 0x27476, 0x0 },
/*464*/ { 0xffffe94f, 0xffffea03 }, { 0x1ff6, 0x0 }, { 0xfd2ac2ea, 0xfd415bd7 },
/*465*/ { 0x6b01, 0x0 }, { 0x30ef, 0x0 }, { 0x147415ef, 0x0 },
/*466*/ { 0x2201, 0x338a }, { 0xffffe5db, 0x0 }, { 0xfc86fbdb, 0xfabcab0e },
/*467*/ { 0x7143, 0x3 }, { 0xffff8b2b, 0x0 }, { 0xcc4f6741, 0xffff12c3 },
/*468*/ { 0x6800, 0x5508 }, { 0x467, 0x0 }, { 0x1c9d800, 0x1765638 },
/*469*/ { 0x746, 0x0 }, { 0x924, 0x0 }, { 0x427bd8, 0x0 },
/*470*/ { 0xffff9110, 0xffffffff }, { 0x2ab7, 0x0 }, { 0xed7d5270, 0xffffffff },
/*471*/ { 0x532f, 0x0 }, { 0xb6f, 0x0 }, { 0x3b71661, 0x0 },
/*472*/ { 0xffffc0ad, 0xfffffdfc }, { 0xcdd, 0x0 }, { 0xfcd17159, 0xffe61f68 },
/*473*/ { 0xfffff860, 0xffffffff }, { 0x5f, 0x0 }, { 0xfffd2ba0, 0xffffffff },
/*474*/ { 0xffffdb61, 0xffffffe3 }, { 0x4678, 0x0 }, { 0xf5eb5b78, 0xfff84adf },
/*475*/ { 0x0, 0x0 }, { 0x0, 0x0 }, { 0x0, 0x0 },
/*476*/ { 0xffff87f5, 0xffff9e23 }, { 0xffffc858, 0x0 }, { 0x1a192438, 0x15460455 },
/*477*/ { 0x154a, 0xeca }, { 0xffffa1dd, 0x0 }, { 0xf82beae2, 0xfa8fe3ab },
/*478*/ { 0xfffff9b5, 0xffffffff }, { 0x2b2, 0x0 }, { 0xffef09da, 0xffffffff },
/*479*/ { 0x4d59, 0x5a }, { 0xd34, 0x0 }, { 0x3fd3b14, 0x4a448 },
/*480*/ { 0xfffff1b5, 0xffffffff }, { 0x440, 0x0 }, { 0xffc34140, 0xffffffff },
/*481*/ { 0x193, 0x0 }, { 0x1b9, 0x0 }, { 0x2b63b, 0x0 },
/*482*/ { 0x5a4b, 0xd4a }, { 0x7308, 0x0 }, { 0x28928358, 0x5f8a850 },
/*483*/ { 0x64c, 0x0 }, { 0x17c, 0x0 }, { 0x958d0, 0x0 },
/*484*/ { 0x1df1, 0x0 }, { 0xffff9f04, 0x0 }, { 0xf4a826c4, 0x1df0 },
/*485*/ { 0x2305, 0x39 }, { 0x4f1d, 0x0 }, { 0xad28291, 0x119d75 },
/*486*/ { 0xffff8cda, 0xffffffff }, { 0xffffb4ab, 0x0 }, { 0x21e25d9e, 0xffff8cda },
/*487*/ { 0x5dba, 0x2ad8 }, { 0xffffb897, 0x0 }, { 0xe5daf8b6, 0xf40ce321 },
/*488*/ { 0x74d6, 0x3f80 }, { 0x3012, 0x0 }, { 0x15f0570c, 0xbec7700 },
/*489*/ { 0x7ed7, 0x0 }, { 0x2628, 0x0 }, { 0x12e7bb98, 0x0 },
/*490*/ { 0x71f3, 0xf9b }, { 0x1ec7, 0x0 }, { 0xdb30de5, 0x1e04b7d },
/*491*/ { 0x6011, 0x0 }, { 0x2812, 0x0 }, { 0xf096932, 0x0 },
/*492*/ { 0xffffebb9, 0xfffff8ed }, { 0xffff8031, 0x0 }, { 0xa1f9e69, 0x3879147 },
/*493*/ { 0xffffb56b, 0xffffffff }, { 0xdfe, 0x0 }, { 0xfbec6f2a, 0xffffffff },
/*494*/ { 0x1f5, 0x0 }, { 0x3c, 0x0 }, { 0x756c, 0x0 },
/*495*/ { 0xffffb6b9, 0xfffffebd }, { 0x963, 0x0 }, { 0xfd502a8b, 0xfff43179 },
/*496*/ { 0x3dc3, 0x9c }, { 0x5218, 0x0 }, { 0x13ce4048, 0x3206a0 },
/*497*/ { 0x520e, 0x0 }, { 0x2ba, 0x0 }, { 0xdfba2c, 0x0 },
/*498*/ { 0x6d77, 0x99 }, { 0x47dc, 0x0 }, { 0x1eba1344, 0x2af27c },
/*499*/ { 0x7d5e, 0x1e }, { 0xffffcd91, 0x0 }, { 0xe74d483e, 0xfffa945b }
};
#define NTESTS ((UINT) (sizeof abc / (sizeof abc[0] * 3)))


int CompilerBuiltin(void);
int NoCompilerBuiltin(void);

#define Test(_name_) \
int _name_(void)    \
{    \
    int i;    \
    MY_INT64 *p;    \
    UINT64 a, b, c, d;    \
    int nPass, nFail;    \
    TIME Tstart, Tend;    \
    \
    Tstart = CurrentTime();    \
    \
    nPass = nFail = 0;    \
    p = abc;    \
    for (i = 0; i < NTESTS; ++i) {    \
    \
        Int64FromHighAndLow(a, p->HighPart, p->LowPart);    \
        p++;    \
        Int64FromHighAndLow(b, 0, p->LowPart);    \
        p++;    \
        c = Uint64TimesUint64(a, b);    \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
    \
        if (!Int64Equal(c,d)) {    \
    \
            _tprintf(_TEXT("a = { 0x%x, 0x%x }, "), (a));    \
            _tprintf(_TEXT("b = { 0x%x, 0x%x }, "), (b));    \
            _tprintf(_TEXT("a*b = { 0x%x, 0x%x }\n\r"), (c));    \
            _tprintf(_TEXT("  ==> a*b should be { 0x%x, 0x%x }!!!\n\r"), (d));  \
            _tprintf(_TEXT("64-bit unsigned multiplication test FAILED "));   \
            _tprintf(_TEXT("in iteration %d.\n\r"), i);   \
            nFail++;    \
        } else    \
            nPass++;    \
    }    \
    Tend = CurrentTime();    \
    \
    _tprintf(_TEXT("64-bit unsigned multiplication test "));    \
    if (nFail == 0) {    \
        _tprintf(_TEXT("PASSED.\n\r"));    \
    \
    } else {    \
        _tprintf(_TEXT("FAILED (%d fail %d pass).\n\r"),    \
                 nFail, nPass);    \
    }    \
    \
    i = TimeDifference(Tend,Tstart);    \
    _tprintf(_TEXT("Took %d microseconds for %d tests (%d/test)\n\r"),    \
             i / 10,    \
             NTESTS,    \
             i / (NTESTS*10));    \
    return nFail;    \
}
/* In any event, test the os-supported routines.
 * If the compiler supports it, repeat for the builtin routines.
 */
int _tmain()
{
    int nFail;

    _tprintf(_TEXT("\n\rTesting os-supported 64bit unsigned multiplication.\n\r"));
    nFail = NoCompilerBuiltin();

#if !defined(__NO_BUILTIN_INT64)
    _tprintf(_TEXT("\n\rTesting compiler-supported 64bit unsigned multiplication.\n\r"));
    nFail += CompilerBuiltin();
#endif

    if (nFail)
        _tprintf(_TEXT("Test FAILED, %d errors.\n\r"), nFail);

    exit ((nFail == 0) ? EXIT_SUCCESS : EXIT_FAILURE);
    return 0;/*amusme*/
}

#include "tst64again.c"

