/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * C test program -- 64-bit logical functions or/and/xor
 */

#if defined(MMLITE)
#include <mmlite.h>
#define XXXX 1

#else
#include <windows.h>
#define i386 /* uhu? */
#define EXTERN_C extern
#include "int64.h"
typedef INT64 TIME;
TIME CurrentTime(void)
{
    TIME t;
    Int64FromHighAndLow(t,0,GetCurrentTime());
#define XXXX 10000
    return t;
}
#endif

/* Was useful for testing under Win32 */
UINT32 TimeDifference(TIME Stop, TIME Start)
{
    UINT32 r;
    Stop = TimeSubtract(Stop,Start);
    r = ((UINT32) Int64ToInt32(Stop) ) * XXXX;
    return r;
}

#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* grumble.. */
typedef struct
    {
    UINT32 LowPart;
    UINT32 HighPart;
    }   MY_UINT64;


/* NOTE:
 * - The signed and unsigned versions are the same, except for type signatures.
 * - For each input pair record all three results in the table below.
 * - 5 entries: a, b, a|b, a&b, a^b
 */
#define m 0x80000000
#define M 0x7fffffff
#define A 0xaaaaaaaa
#define E 0xeeeeeeee
#define F 0x44444444
MY_UINT64 abcde[] = {
/*0*/
 { 0, 0 }, { 0, 0 },      { 0, 0 }, { 0, 0 }, { 0, 0 },
 { ~0, ~0 }, { ~0, ~0 },  { ~0, ~0 }, { ~0, ~0 }, { 0, 0 },
 { ~0, ~0 }, { 0, 0 },    { ~0, ~0 }, { 0, 0 }, { ~0, ~0 },
 { 0, 0 }, { ~0, ~0 },    { ~0, ~0 }, { 0, 0 }, { ~0, ~0 },
 { 0, ~0 }, { ~0, 0 },    { ~0, ~0 }, { 0, 0 }, { ~0, ~0 },
 { ~0, 0 }, { 0, ~0 },    { ~0, ~0 }, { 0, 0 }, { ~0, ~0 },
/*6*/
 { m, 0 }, { 0, 0 },      { m, 0 }, { 0, 0 }, { m, 0 },
 { 0, m }, { 0, 0 },      { 0, m }, { 0, 0 }, { 0, m },
 { 0, 0 }, { m, 0 },      { m, 0 }, { 0, 0 }, { m, 0 },
 { 0, 0 }, { 0, m },      { 0, m }, { 0, 0 }, { 0, m },
 { m, 0 }, { m, 0 },      { m, 0 }, { m, 0 }, { 0, 0 },
 { 0, m }, { 0, m },      { 0, m }, { 0, m }, { 0, 0 },
 { m, 0 }, { 0, m },      { m, m }, { 0, 0 }, { m, m },
 { 0, m }, { m, 0 },      { m, m }, { 0, 0 }, { m, m },
 { m, m }, { m, m },      { m, m }, { m, m }, { 0, 0 },
/*15*/
 { M, 0 }, { 0, 0 },      { M, 0 }, { 0, 0 }, { M, 0 },
 { 0, M }, { 0, 0 },      { 0, M }, { 0, 0 }, { 0, M },
 { 0, 0 }, { M, 0 },      { M, 0 }, { 0, 0 }, { M, 0 },
 { 0, 0 }, { 0, M },      { 0, M }, { 0, 0 }, { 0, M },
 { M, 0 }, { M, 0 },      { M, 0 }, { M, 0 }, { 0, 0 },
 { 0, M }, { 0, M },      { 0, M }, { 0, M }, { 0, 0 },
 { M, 0 }, { 0, M },      { M, M }, { 0, 0 }, { M, M },
 { 0, M }, { M, 0 },      { M, M }, { 0, 0 }, { M, M },
 { M, M }, { M, M },      { M, M }, { M, M }, { 0, 0 },
/*24*/
 { M, m }, { m, m },      { ~0, m }, { 0, m }, { ~0, 0 },
 { m, M }, { m, m },      { m, ~0 }, { m, 0 }, { 0, ~0 },
 { m, m }, { M, m },      { ~0, m }, { 0, m }, { ~0, 0 },
 { m, m }, { m, M },      { m, ~0 }, { m, 0 }, { 0, ~0 },
 { M, m }, { M, m },      { M, m }, { M, m }, { 0, 0 },
 { m, M }, { m, M },      { m, M }, { m, M }, { 0, 0 },
 { M, m }, { m, M },      { ~0, ~0 }, { 0, 0 }, { ~0, ~0 },
 { m, M }, { M, m },      { ~0, ~0 }, { 0, 0 }, { ~0, ~0 },
/*32*/
 { 1, 0 }, { 0, 0 },      { 1, 0 }, { 0, 0 }, { 1, 0 },
 { 0, 1 }, { 0, 0 },      { 0, 1 }, { 0, 0 }, { 0, 1 },
 { 0, 0 }, { 1, 0 },      { 1, 0 }, { 0, 0 }, { 1, 0 },
 { 0, 0 }, { 0, 1 },      { 0, 1 }, { 0, 0 }, { 0, 1 },
 { 1, 0 }, { 1, 0 },      { 1, 0 }, { 1, 0 }, { 0, 0 },
 { 0, 1 }, { 0, 1 },      { 0, 1 }, { 0, 1 }, { 0, 0 },
 { 1, 0 }, { 0, 1 },      { 1, 1 }, { 0, 0 }, { 1, 1 },
 { 0, 1 }, { 1, 0 },      { 1, 1 }, { 0, 0 }, { 1, 1 },
 { 1, 1 }, { 1, 1 },      { 1, 1 }, { 1, 1 }, { 0, 0 },
/*41*/
 { A, E }, { E, E },      { E, E }, { A, E }, { F, 0 },
 { E, A }, { E, E },      { E, E }, { E, A }, { 0, F },
 { E, E }, { A, E },      { E, E }, { A, E }, { F, 0 },
 { E, E }, { E, A },      { E, E }, { E, A }, { 0, F },
 { A, E }, { A, E },      { A, E }, { A, E }, { 0, 0 },
 { E, A }, { E, A },      { E, A }, { E, A }, { 0, 0 },
 { A, E }, { E, A },      { E, E }, { A, A }, { F, F },
 { E, A }, { A, E },      { E, E }, { A, A }, { F, F },
/*49*/
 {0x5fb3dfbd,0x0}, {0x1b4554ff,0x0}, {0x5ff7dfff,0x0},
   {0x1b0154bd,0x0},{0x44f68b42,0x0},
 {0x3fa9,0x0}, {0x62e7d8e7,0x0}, {0x62e7ffef,0x0},
   {0x18a1,0x0},{0x62e7e74e,0x0},
 {0x4ff7,0x0}, {0x4ef7,0x0}, {0x4ff7,0x0},
   {0x4ef7,0x0},{0x100,0x0},
 {0xdcfff35b,0x0}, {0x7f7b,0x0}, {0xdcffff7b,0x0},
   {0x735b,0x0},{0xdcff8c20,0x0},
 {0x9650f7ff,0x0}, {0x17ff,0x0}, {0x9650f7ff,0x0},
   {0x17ff,0x0},{0x9650e000,0x0},
 {0xb1ab3b57,0x0}, {0x7876f2fb,0x0}, {0xf9fffbff,0x0},
   {0x30223253,0x0},{0xc9ddc9ac,0x0},
 {0xc925fb67,0x0}, {0xc9d667fc,0x0}, {0xc9f7ffff,0x0},
   {0xc9046364,0x0},{0xf39c9b,0x0},
 {0xea91bafd,0x0}, {0x6eff,0x0}, {0xea91feff,0x0},
   {0x2afd,0x0},{0xea91d402,0x0},
 {0xd39cf3ef,0x0}, {0xf3fd7f3e,0x0}, {0xf3fdffff,0x0},
   {0xd39c732e,0x0},{0x20618cd1,0x0},
 {0xdf3c5de3,0x0}, {0x194b5fef,0x0}, {0xdf7f5fef,0x0},
   {0x19085de3,0x0},{0xc677020c,0x0},
 {0xddccb97d,0x0}, {0x3baee9bf,0x0}, {0xffeef9ff,0x0},
   {0x198ca93d,0x0},{0xe66250c2,0x0},
 {0x1efd,0x0}, {0x86ba5de5,0x0}, {0x86ba5ffd,0x0},
   {0x1ce5,0x0},{0x86ba4318,0x0},
 {0xd7b3735e,0x0}, {0x367d,0x0}, {0xd7b3777f,0x0},
   {0x325c,0x0},{0xd7b34523,0x0},
 {0xbc6bb7ee,0x0}, {0x6b7e,0x0}, {0xbc6bfffe,0x0},
   {0x236e,0x0},{0xbc6bdc90,0x0},
 {0xbbb5bff7,0x0}, {0x7ff7,0x0}, {0xbbb5fff7,0x0},
   {0x3ff7,0x0},{0xbbb5c000,0x0},
 {0xbd2ff7e7,0x0}, {0x7f7f8f6b,0x0}, {0xff7fffef,0x0},
   {0x3d2f8763,0x0},{0xc250788c,0x0},
 {0x9c637f6f,0x0}, {0x8ad8bfff,0x0}, {0x9efbffff,0x0},
   {0x88403f6f,0x0},{0x16bbc090,0x0},
 {0xff8d5b3b,0x0}, {0xca9e73ff,0x0}, {0xff9f7bff,0x0},
   {0xca8c533b,0x0},{0x351328c4,0x0},
 {0x7fffa6ef,0x0}, {0x89253fff,0x0}, {0xffffbfff,0x0},
   {0x92526ef,0x0},{0xf6da9910,0x0},
 {0x6739,0x0}, {0x6f3b,0x0}, {0x6f3b,0x0},
   {0x6739,0x0},{0x802,0x0},
 {0x7f35ef7f,0x0}, {0xefff0ff5,0x0}, {0xffffefff,0x0},
   {0x6f350f75,0x0},{0x90cae08a,0x0},
 {0x6f04f575,0x0}, {0xa37e673d,0x0}, {0xef7ef77d,0x0},
   {0x23046535,0x0},{0xcc7a9248,0x0},
 {0x56ffea,0x0}, {0x62826eff,0x0}, {0x62d6ffff,0x0},
   {0x26eea,0x0},{0x62d49115,0x0},
 {0xbb635fee,0x0}, {0xb2b04dfe,0x0}, {0xbbf35ffe,0x0},
   {0xb2204dee,0x0},{0x9d31210,0x0},
 {0xbb8b97f3,0x0}, {0xdb1f58fc,0x0}, {0xfb9fdfff,0x0},
   {0x9b0b10f0,0x0},{0x6094cf0f,0x0},
 {0xa65b7db1,0x0}, {0xf922f63f,0x0}, {0xff7bffbf,0x0},
   {0xa0027431,0x0},{0x5f798b8e,0x0},
 {0x5d7f,0x0}, {0x1bfa557f,0x0}, {0x1bfa5d7f,0x0},
   {0x557f,0x0},{0x1bfa0800,0x0},
 {0xfc059ffe,0x0}, {0x2f22ffb7,0x0}, {0xff27ffff,0x0},
   {0x2c009fb6,0x0},{0xd3276049,0x0},
 {0xbfdf7ffd,0x0}, {0xf37bbbf5,0x0}, {0xfffffffd,0x0},
   {0xb35b3bf5,0x0},{0x4ca4c408,0x0},
 {0x7dbf,0x0}, {0x7f7d,0x0}, {0x7fff,0x0},
   {0x7d3d,0x0},{0x2c2,0x0},
 {0x7df7,0x0}, {0x7773,0x0}, {0x7ff7,0x0},
   {0x7573,0x0},{0xa84,0x0},
 {0x71ff,0x0}, {0xbb2ce77d,0x0}, {0xbb2cf7ff,0x0},
   {0x617d,0x0},{0xbb2c9682,0x0},
 {0xffffff9f,0x0}, {0xffedffee,0x0}, {0xffffffff,0x0},
   {0xffedff8e,0x0},{0x120071,0x0},
 {0xfb4fad66,0x0}, {0x1e254fe6,0x0}, {0xff6fefe6,0x0},
   {0x1a050d66,0x0},{0xe56ae280,0x0},
 {0xbae17ff5,0x0}, {0x885bfb2e,0x0}, {0xbafbffff,0x0},
   {0x88417b24,0x0},{0x32ba84db,0x0},
 {0xcda6bf3f,0x0}, {0x63025fbf,0x0}, {0xefa6ffbf,0x0},
   {0x41021f3f,0x0},{0xaea4e080,0x0},
 {0x1f835eff,0x0}, {0x44cf39bd,0x0}, {0x5fcf7fff,0x0},
   {0x48318bd,0x0},{0x5b4c6742,0x0},
 {0x935e77ff,0x0}, {0xc05236fe,0x0}, {0xd35e77ff,0x0},
   {0x805236fe,0x0},{0x530c4101,0x0},
 {0xbf3b7173,0x0}, {0xba0638ff,0x0}, {0xbf3f79ff,0x0},
   {0xba023073,0x0},{0x53d498c,0x0},
 {0xbb6fabed,0x0}, {0xf6f77e3e,0x0}, {0xffffffff,0x0},
   {0xb2672a2c,0x0},{0x4d98d5d3,0x0},
 {0x99e73f32,0x0}, {0x7b77d7b7,0x0}, {0xfbf7ffb7,0x0},
   {0x19671732,0x0},{0xe290e885,0x0},
 {0xb7ffcfef,0x0}, {0x1c993ef3,0x0}, {0xbfffffff,0x0},
   {0x14990ee3,0x0},{0xab66f11c,0x0},
 {0x5e3d,0x0}, {0x675ebff,0x0}, {0x675ffff,0x0},
   {0x4a3d,0x0},{0x675b5c2,0x0},
 {0x67aa3d6e,0x0}, {0x7b67,0x0}, {0x67aa7f6f,0x0},
   {0x3966,0x0},{0x67aa4609,0x0},
 {0xea977bef,0x0}, {0x657f,0x0}, {0xea977fff,0x0},
   {0x616f,0x0},{0xea971e90,0x0},
 {0x7fd64879,0x0}, {0x6176ffd,0x0}, {0x7fd76ffd,0x0},
   {0x6164879,0x0},{0x79c12784,0x0},
 {0x7def,0x0}, {0xdfcbff77,0x0}, {0xdfcbffff,0x0},
   {0x7d67,0x0},{0xdfcb8298,0x0},
 {0xa9e327ff,0x0}, {0x7cbf,0x0}, {0xa9e37fff,0x0},
   {0x24bf,0x0},{0xa9e35b40,0x0},
 {0xf75cfeff,0x0}, {0xfff5d7ff,0x0}, {0xfffdffff,0x0},
   {0xf754d6ff,0x0},{0x8a92900,0x0},
 {0x53867ef7,0x0}, {0xfbf09dfb,0x0}, {0xfbf6ffff,0x0},
   {0x53801cf3,0x0},{0xa876e30c,0x0},
 {0x96ceffe,0x0}, {0x7bff,0x0}, {0x96cffff,0x0},
   {0x6bfe,0x0},{0x96c9401,0x0},
 {0x3e957b76,0x0}, {0x76bc,0x0}, {0x3e957ffe,0x0},
   {0x7234,0x0},{0x3e950dca,0x0},
 {0xfbf2ce0e,0x0}, {0x2dc7d7f,0x0}, {0xfbfeff7f,0x0},
   {0x2d04c0e,0x0},{0xf92eb371,0x0},
 {0xbf8effff,0x0}, {0x3e7f,0x0}, {0xbf8effff,0x0},
   {0x3e7f,0x0},{0xbf8ec180,0x0},
 {0x60fefffc,0x0}, {0xd5d2ff6d,0x0}, {0xf5fefffd,0x0},
   {0x40d2ff6c,0x0},{0xb52c0091,0x0},
 {0x6f697dfa,0x0}, {0x7efe,0x0}, {0x6f697ffe,0x0},
   {0x7cfa,0x0},{0x6f690304,0x0},
 {0x1a4eaf6b,0x0}, {0xd4e37f3d,0x0}, {0xdeefff7f,0x0},
   {0x10422f29,0x0},{0xceadd056,0x0},
 {0xd77f8ee9,0x0}, {0xf3bfe6ef,0x0}, {0xf7ffeeef,0x0},
   {0xd33f86e9,0x0},{0x24c06806,0x0},
 {0x775e3ff9,0x0}, {0x7fee,0x0}, {0x775e7fff,0x0},
   {0x3fe8,0x0},{0x775e4017,0x0},
 {0xe3b4fbdd,0x0}, {0x5e85f5ef,0x0}, {0xffb5ffff,0x0},
   {0x4284f1cd,0x0},{0xbd310e32,0x0},
 {0xab40b77f,0x0}, {0x5ffbb3bb,0x0}, {0xfffbb7ff,0x0},
   {0xb40b33b,0x0},{0xf4bb04c4,0x0},
 {0x1ff1,0x0}, {0xf95cfbff,0x0}, {0xf95cffff,0x0},
   {0x1bf1,0x0},{0xf95ce40e,0x0},
 {0xd0af797d,0x0}, {0xa72445bf,0x0}, {0xf7af7dff,0x0},
   {0x8024413d,0x0},{0x778b3cc2,0x0},
 {0xdf37f663,0x0}, {0x37fe,0x0}, {0xdf37f7ff,0x0},
   {0x3662,0x0},{0xdf37c19d,0x0},
 {0xcbccbbf3,0x0}, {0x7caf,0x0}, {0xcbccffff,0x0},
   {0x38a3,0x0},{0xcbccc75c,0x0},
 {0xaf225ffd,0x0}, {0xe4b3f9ff,0x0}, {0xefb3ffff,0x0},
   {0xa42259fd,0x0},{0x4b91a602,0x0},
 {0x21d07eee,0x0}, {0x7ff5bf77,0x0}, {0x7ff5ffff,0x0},
   {0x21d03e66,0x0},{0x5e25c199,0x0},
 {0x9d22df79,0x0}, {0x164c7ff5,0x0}, {0x9f6efffd,0x0},
   {0x14005f71,0x0},{0x8b6ea08c,0x0},
 {0x4ffe,0x0}, {0x79fd,0x0}, {0x7fff,0x0},
   {0x49fc,0x0},{0x3603,0x0},
 {0x98dffdbd,0x0}, {0x55b3,0x0}, {0x98dffdbf,0x0},
   {0x55b1,0x0},{0x98dfa80e,0x0},
 {0xe358bfbf,0x0}, {0x3f2e,0x0}, {0xe358bfbf,0x0},
   {0x3f2e,0x0},{0xe3588091,0x0},
 {0x840f7fbf,0x0}, {0x76571fff,0x0}, {0xf65f7fff,0x0},
   {0x4071fbf,0x0},{0xf2586040,0x0},
 {0xb5d7677f,0x0}, {0x31097673,0x0}, {0xb5df777f,0x0},
   {0x31016673,0x0},{0x84de110c,0x0},
 {0xf7eb1c5,0x0}, {0x50ad6f7e,0x0}, {0x5fffffff,0x0},
   {0x2c2144,0x0},{0x5fd3debb,0x0},
 {0xc7b33bfe,0x0}, {0x3ee3,0x0}, {0xc7b33fff,0x0},
   {0x3ae2,0x0},{0xc7b3051d,0x0},
 {0xa77b4e73,0x0}, {0x7dfb,0x0}, {0xa77b7ffb,0x0},
   {0x4c73,0x0},{0xa77b3388,0x0},
 {0x5bb6,0x0}, {0x7ffdf7fd,0x0}, {0x7ffdffff,0x0},
   {0x53b4,0x0},{0x7ffdac4b,0x0},
 {0xf7fff7e6,0x0}, {0x53bf,0x0}, {0xf7fff7ff,0x0},
   {0x53a6,0x0},{0xf7ffa459,0x0},
 {0xc31f67a1,0x0}, {0xfa067df3,0x0}, {0xfb1f7ff3,0x0},
   {0xc20665a1,0x0},{0x39191a52,0x0},
 {0x5bb5,0x0}, {0x5f3ffc5b,0x0}, {0x5f3fffff,0x0},
   {0x5811,0x0},{0x5f3fa7ee,0x0},
 {0x5d7cfedb,0x0}, {0x6157cbfe,0x0}, {0x7d7fffff,0x0},
   {0x4154cada,0x0},{0x3c2b3525,0x0},
 {0xadc67e7d,0x0}, {0x38fd,0x0}, {0xadc67efd,0x0},
   {0x387d,0x0},{0xadc64680,0x0},
 {0xf2a27737,0x0}, {0xdfecd9ff,0x0}, {0xffeeffff,0x0},
   {0xd2a05137,0x0},{0x2d4eaec8,0x0},
 {0xbf246b2b,0x0}, {0x24abefff,0x0}, {0xbfafefff,0x0},
   {0x24206b2b,0x0},{0x9b8f84d4,0x0},
 {0x793e1ef1,0x0}, {0xd09fffb7,0x0}, {0xf9bffff7,0x0},
   {0x501e1eb1,0x0},{0xa9a1e146,0x0},
 {0x76f9,0x0}, {0x251bbeff,0x0}, {0x251bfeff,0x0},
   {0x36f9,0x0},{0x251bc806,0x0},
 {0x29c4dbef,0x0}, {0x79cc3f70,0x0}, {0x79ccffff,0x0},
   {0x29c41b60,0x0},{0x5008e49f,0x0},
 {0x3f77,0x0}, {0xd96fbff8,0x0}, {0xd96fbfff,0x0},
   {0x3f70,0x0},{0xd96f808f,0x0},
 {0x3fbd,0x0}, {0x1d3d3fbf,0x0}, {0x1d3d3fbf,0x0},
   {0x3fbd,0x0},{0x1d3d0002,0x0},
 {0xfebfdfb9,0x0}, {0xef9789ff,0x0}, {0xffbfdfff,0x0},
   {0xee9789b9,0x0},{0x11285646,0x0},
 {0xc5967f3f,0x0}, {0x939fd7bf,0x0}, {0xd79fffbf,0x0},
   {0x8196573f,0x0},{0x5609a880,0x0},
 {0x7ea2d3bf,0x0}, {0x3b3de4f7,0x0}, {0x7fbff7ff,0x0},
   {0x3a20c0b7,0x0},{0x459f3748,0x0},
 {0x73ff,0x0}, {0x73fe,0x0}, {0x73ff,0x0},
   {0x73fe,0x0},{0x1,0x0},
 {0xa7aed8bf,0x0}, {0xd24efbff,0x0}, {0xf7eefbff,0x0},
   {0x820ed8bf,0x0},{0x75e02340,0x0},
 {0x2ef6ecf7,0x0}, {0x4f68ef7c,0x0}, {0x6ffeefff,0x0},
   {0xe60ec74,0x0},{0x619e038b,0x0},
 {0xd0b7e6d,0x0}, {0x8ffaf3ff,0x0}, {0x8ffbffff,0x0},
   {0xd0a726d,0x0},{0x82f18d92,0x0},
 {0xf94de57f,0x0}, {0xdf7ffdff,0x0}, {0xff7ffdff,0x0},
   {0xd94de57f,0x0},{0x26321880,0x0},
 {0xb4dfdbf7,0x0}, {0xf42575fa,0x0}, {0xf4ffffff,0x0},
   {0xb40551f2,0x0},{0x40faae0d,0x0},
 {0x20fbf5ed,0x0}, {0x4a962ffe,0x0}, {0x6affffff,0x0},
   {0x9225ec,0x0},{0x6a6dda13,0x0},
 {0xfb7c37fd,0x0}, {0xe577c467,0x0}, {0xff7ff7ff,0x0},
   {0xe1740465,0x0},{0x1e0bf39a,0x0},
 {0xfb1c6bf3,0x0}, {0xad4676be,0x0}, {0xff5e7fff,0x0},
   {0xa90462b2,0x0},{0x565a1d4d,0x0},
 {0x8991ffff,0x0}, {0x77f9,0x0}, {0x8991ffff,0x0},
   {0x77f9,0x0},{0x89918806,0x0},
 {0x7e37,0x0}, {0x2fbe7fbb,0x0}, {0x2fbe7fbf,0x0},
   {0x7e33,0x0},{0x2fbe018c,0x0},
 {0x3029efff,0x0}, {0xfa51fbbe,0x0}, {0xfa79ffff,0x0},
   {0x3001ebbe,0x0},{0xca781441,0x0},
 {0x67ff,0x0}, {0xe7fefdfb,0x0}, {0xe7feffff,0x0},
   {0x65fb,0x0},{0xe7fe9a04,0x0},
 {0x80261ffb,0x0}, {0xc61fffef,0x0}, {0xc63fffff,0x0},
   {0x80061feb,0x0},{0x4639e014,0x0},
 {0x4bb3,0x0}, {0xe9177d79,0x0}, {0xe9177ffb,0x0},
   {0x4931,0x0},{0xe91736ca,0x0},
 {0x3e96f7ff,0x0}, {0xeffdf7ee,0x0}, {0xfffff7ff,0x0},
   {0x2e94f7ee,0x0},{0xd16b0011,0x0},
 {0x513f7ff,0x0}, {0x5511df76,0x0}, {0x5513ffff,0x0},
   {0x511d776,0x0},{0x50022889,0x0},
 {0x6fff,0x0}, {0x3d317cfe,0x0}, {0x3d317fff,0x0},
   {0x6cfe,0x0},{0x3d311301,0x0},
 {0x1700f5bb,0x0}, {0xcec6d8ad,0x0}, {0xdfc6fdbf,0x0},
   {0x600d0a9,0x0},{0xd9c62d16,0x0},
 {0x7bff3ead,0x0}, {0xe52b79fe,0x0}, {0xffff7fff,0x0},
   {0x612b38ac,0x0},{0x9ed44753,0x0},
 {0xfbfdacf3,0x0}, {0x3f3e,0x0}, {0xfbfdbfff,0x0},
   {0x2c32,0x0},{0xfbfd93cd,0x0},
 {0x2c7e,0x0}, {0xdf8db4ae,0x0}, {0xdf8dbcfe,0x0},
   {0x242e,0x0},{0xdf8d98d0,0x0},
 {0x3853fbff,0x0}, {0x2eef,0x0}, {0x3853ffff,0x0},
   {0x2aef,0x0},{0x3853d510,0x0},
 {0xfdff7ffb,0x0}, {0xb57d3f6c,0x0}, {0xfdff7fff,0x0},
   {0xb57d3f68,0x0},{0x48824097,0x0},
 {0xa5cc3aed,0x0}, {0x26f7,0x0}, {0xa5cc3eff,0x0},
   {0x22e5,0x0},{0xa5cc1c1a,0x0},
 {0x6a956ff,0x0}, {0x77ef,0x0}, {0x6a977ff,0x0},
   {0x56ef,0x0},{0x6a92110,0x0},
 {0x5198686f,0x0}, {0x7ab9,0x0}, {0x51987aff,0x0},
   {0x6829,0x0},{0x519812d6,0x0},
 {0x7bfd,0x0}, {0xdb7227fa,0x0}, {0xdb727fff,0x0},
   {0x23f8,0x0},{0xdb725c07,0x0},
 {0x65b3,0x0}, {0xaffbf94f,0x0}, {0xaffbfdff,0x0},
   {0x6103,0x0},{0xaffb9cfc,0x0},
 {0xc8fd1bfd,0x0}, {0x9fb7fbd9,0x0}, {0xdffffbfd,0x0},
   {0x88b51bd9,0x0},{0x574ae024,0x0},
 {0x3aff,0x0}, {0xefbfefdc,0x0}, {0xefbfffff,0x0},
   {0x2adc,0x0},{0xefbfd523,0x0},
 {0x5ffc,0x0}, {0x6fbb,0x0}, {0x7fff,0x0},
   {0x4fb8,0x0},{0x3047,0x0},
 {0x7f6d,0x0}, {0x7bff,0x0}, {0x7fff,0x0},
   {0x7b6d,0x0},{0x492,0x0},
 {0x7fee,0x0}, {0x8e163bef,0x0}, {0x8e167fef,0x0},
   {0x3bee,0x0},{0x8e164401,0x0},
 {0x931e63,0x0}, {0x7a7d,0x0}, {0x937e7f,0x0},
   {0x1a61,0x0},{0x93641e,0x0},
 {0x4958feff,0x0}, {0xf7efff7e,0x0}, {0xffffffff,0x0},
   {0x4148fe7e,0x0},{0xbeb70181,0x0},
 {0x204af7bf,0x0}, {0xeb57f55d,0x0}, {0xeb5ff7ff,0x0},
   {0x2042f51d,0x0},{0xcb1d02e2,0x0},
 {0xeaef7fd7,0x0}, {0xbd7cffd9,0x0}, {0xffffffdf,0x0},
   {0xa86c7fd1,0x0},{0x5793800e,0x0},
 {0x301fbfaf,0x0}, {0x3477,0x0}, {0x301fbfff,0x0},
   {0x3427,0x0},{0x301f8bd8,0x0},
 {0x8d727caf,0x0}, {0xbdffbfd,0x0}, {0x8fffffff,0x0},
   {0x95278ad,0x0},{0x86ad8752,0x0},
 {0x5fbf,0x0}, {0x57bd,0x0}, {0x5fbf,0x0},
   {0x57bd,0x0},{0x802,0x0},
 {0xcc39dc37,0x0}, {0x5e5fffed,0x0}, {0xde7fffff,0x0},
   {0x4c19dc25,0x0},{0x926623da,0x0},
 {0x9a4df6fb,0x0}, {0x4c44f7f3,0x0}, {0xde4df7fb,0x0},
   {0x844f6f3,0x0},{0xd6090108,0x0},
 {0x71827069,0x0}, {0xf1e6fbac,0x0}, {0xf1e6fbed,0x0},
   {0x71827028,0x0},{0x80648bc5,0x0},
 {0x5737,0x0}, {0xfff67eff,0x0}, {0xfff67fff,0x0},
   {0x5637,0x0},{0xfff629c8,0x0},
 {0x7a7ffff3,0x0}, {0x797f,0x0}, {0x7a7fffff,0x0},
   {0x7973,0x0},{0x7a7f868c,0x0},
 {0x75f8e971,0x0}, {0x6c59fb63,0x0}, {0x7df9fb73,0x0},
   {0x6458e961,0x0},{0x19a11212,0x0},
 {0x924debad,0x0}, {0xffc117fd,0x0}, {0xffcdfffd,0x0},
   {0x924103ad,0x0},{0x6d8cfc50,0x0},
 {0x81e7e967,0x0}, {0x7f5a73fe,0x0}, {0xfffffbff,0x0},
   {0x1426166,0x0},{0xfebd9a99,0x0},
 {0x7eeb,0x0}, {0x7fbc,0x0}, {0x7fff,0x0},
   {0x7ea8,0x0},{0x157,0x0},
 {0x9ff8f27e,0x0}, {0xdab5beff,0x0}, {0xdffdfeff,0x0},
   {0x9ab0b27e,0x0},{0x454d4c81,0x0},
 {0x1a48dbfb,0x0}, {0x6ef2,0x0}, {0x1a48fffb,0x0},
   {0x4af2,0x0},{0x1a48b509,0x0},
 {0x57c0967f,0x0}, {0x9436ff2b,0x0}, {0xd7f6ff7f,0x0},
   {0x1400962b,0x0},{0xc3f66954,0x0},
 {0xf37edfb3,0x0}, {0xdcfff7bf,0x0}, {0xffffffbf,0x0},
   {0xd07ed7b3,0x0},{0x2f81280c,0x0},
 {0x53f9,0x0}, {0x746f,0x0}, {0x77ff,0x0},
   {0x5069,0x0},{0x2796,0x0},
 {0xad88fb7f,0x0}, {0x8276e7d,0x0}, {0xadafff7f,0x0},
   {0x8006a7d,0x0},{0xa5af9502,0x0},
 {0x550b7be7,0x0}, {0x5be,0x0}, {0x550b7fff,0x0},
   {0x1a6,0x0},{0x550b7e59,0x0},
 {0x7fb5edfe,0x0}, {0x7efc,0x0}, {0x7fb5fffe,0x0},
   {0x6cfc,0x0},{0x7fb59302,0x0},
 {0x2dc57dff,0x0}, {0x8b4a9ff,0x0}, {0x2df5fdff,0x0},
   {0x88429ff,0x0},{0x2571d400,0x0},
 {0xc540b7ff,0x0}, {0x5e3e,0x0}, {0xc540ffff,0x0},
   {0x163e,0x0},{0xc540e9c1,0x0},
 {0x71e7cfaf,0x0}, {0x372a3fe,0x0}, {0x73f7efff,0x0},
   {0x16283ae,0x0},{0x72956c51,0x0},
 {0x28567e39,0x0}, {0xf8032fff,0x0}, {0xf8577fff,0x0},
   {0x28022e39,0x0},{0xd05551c6,0x0},
 {0x47a1efec,0x0}, {0xde8bffbd,0x0}, {0xdfabfffd,0x0},
   {0x4681efac,0x0},{0x992a1051,0x0},
 {0x7af987fb,0x0}, {0x1e177bbf,0x0}, {0x7effffff,0x0},
   {0x1a1103bb,0x0},{0x64eefc44,0x0},
 {0x5ffc,0x0}, {0x2efd,0x0}, {0x7ffd,0x0},
   {0xefc,0x0},{0x7101,0x0},
 {0x68146fb5,0x0}, {0xa8467ebb,0x0}, {0xe8567fbf,0x0},
   {0x28046eb1,0x0},{0xc052110e,0x0},
 {0xb6d93fef,0x0}, {0xd2fffab1,0x0}, {0xf6ffffff,0x0},
   {0x92d93aa1,0x0},{0x6426c55e,0x0},
 {0x6f5dfdfd,0x0}, {0x5e7e,0x0}, {0x6f5dffff,0x0},
   {0x5c7c,0x0},{0x6f5da383,0x0},
 {0xb7fda47d,0x0}, {0x41f87dff,0x0}, {0xf7fdfdff,0x0},
   {0x1f8247d,0x0},{0xf605d982,0x0},
 {0x7f3f,0x0}, {0x510edff,0x0}, {0x510ffff,0x0},
   {0x6d3f,0x0},{0x51092c0,0x0},
 {0x8a4b7eff,0x0}, {0x7fb7,0x0}, {0x8a4b7fff,0x0},
   {0x7eb7,0x0},{0x8a4b0148,0x0},
 {0xcefaefff,0x0}, {0xbebb5fff,0x0}, {0xfefbffff,0x0},
   {0x8eba4fff,0x0},{0x7041b000,0x0},
 {0xfeff7ee5,0x0}, {0xfe9f2fff,0x0}, {0xfeff7fff,0x0},
   {0xfe9f2ee5,0x0},{0x60511a,0x0},
 {0x9fc177ff,0x0}, {0x4bbd,0x0}, {0x9fc17fff,0x0},
   {0x43bd,0x0},{0x9fc13c42,0x0},
 {0xfc2fb9f7,0x0}, {0x99757ff4,0x0}, {0xfd7ffff7,0x0},
   {0x982539f4,0x0},{0x655ac603,0x0},
 {0x6ebefd2d,0x0}, {0x3d5feaeb,0x0}, {0x7fffffef,0x0},
   {0x2c1ee829,0x0},{0x53e117c6,0x0},
 {0x5fff,0x0}, {0x9fe2f38,0x0}, {0x9fe7fff,0x0},
   {0xf38,0x0},{0x9fe70c7,0x0},
 {0xd33f7fbf,0x0}, {0xf73,0x0}, {0xd33f7fff,0x0},
   {0xf33,0x0},{0xd33f70cc,0x0},
 {0x76ed,0x0}, {0x3a40fdef,0x0}, {0x3a40ffef,0x0},
   {0x74ed,0x0},{0x3a408b02,0x0},
 {0xefce7c98,0x0}, {0x77f9,0x0}, {0xefce7ff9,0x0},
   {0x7498,0x0},{0xefce0b61,0x0},
 {0x5eff7f7d,0x0}, {0xb90bf533,0x0}, {0xffffff7f,0x0},
   {0x180b7531,0x0},{0xe7f48a4e,0x0},
 {0xadffeba4,0x0}, {0x1f7f,0x0}, {0xadffffff,0x0},
   {0xb24,0x0},{0xadfff4db,0x0},
 {0x7fff,0x0}, {0xe6deffe,0x0}, {0xe6dffff,0x0},
   {0x6ffe,0x0},{0xe6d9001,0x0},
 {0x7eff,0x0}, {0x1e7887ed,0x0}, {0x1e78ffff,0x0},
   {0x6ed,0x0},{0x1e78f912,0x0},
 {0x5bff,0x0}, {0x90cb6ffe,0x0}, {0x90cb7fff,0x0},
   {0x4bfe,0x0},{0x90cb3401,0x0},
 {0xfc713ffb,0x0}, {0x1ff7,0x0}, {0xfc713fff,0x0},
   {0x1ff3,0x0},{0xfc71200c,0x0},
 {0xdf5bd57f,0x0}, {0xc3eb3f7f,0x0}, {0xdffbff7f,0x0},
   {0xc34b157f,0x0},{0x1cb0ea00,0x0},
 {0xb7fffbfd,0x0}, {0x9d2bf5f6,0x0}, {0xbfffffff,0x0},
   {0x952bf1f4,0x0},{0x2ad40e0b,0x0},
 {0x6dff,0x0}, {0x5a6b,0x0}, {0x7fff,0x0},
   {0x486b,0x0},{0x3794,0x0},
 {0x2aacdffc,0x0}, {0x59628cff,0x0}, {0x7beedfff,0x0},
   {0x8208cfc,0x0},{0x73ce5303,0x0},
 {0xe3157bbe,0x0}, {0x7cee,0x0}, {0xe3157ffe,0x0},
   {0x78ae,0x0},{0xe3150750,0x0},
 {0xb4006fab,0x0}, {0xe6c9f1be,0x0}, {0xf6c9ffbf,0x0},
   {0xa40061aa,0x0},{0x52c99e15,0x0},
 {0x7eff,0x0}, {0x6de7,0x0}, {0x7fff,0x0},
   {0x6ce7,0x0},{0x1318,0x0},
 {0x7fff,0x0}, {0x3efc,0x0}, {0x7fff,0x0},
   {0x3efc,0x0},{0x4103,0x0},
 {0x16c8efff,0x0}, {0x29fd,0x0}, {0x16c8efff,0x0},
   {0x29fd,0x0},{0x16c8c602,0x0},
 {0x25539fe5,0x0}, {0xfd6be57e,0x0}, {0xfd7bffff,0x0},
   {0x25438564,0x0},{0xd8387a9b,0x0},
 {0x113dfc7e,0x0}, {0xfcbdcbdf,0x0}, {0xfdbdffff,0x0},
   {0x103dc85e,0x0},{0xed8037a1,0x0},
 {0x7feb,0x0}, {0xe85f3afe,0x0}, {0xe85f7fff,0x0},
   {0x3aea,0x0},{0xe85f4515,0x0},
 {0xbbe33bef,0x0}, {0x811f4ffc,0x0}, {0xbbff7fff,0x0},
   {0x81030bec,0x0},{0x3afc7413,0x0},
 {0xbd7fdd77,0x0}, {0xb6a89fff,0x0}, {0xbfffdfff,0x0},
   {0xb4289d77,0x0},{0xbd74288,0x0},
 {0x2b2fddf7,0x0}, {0x7f79,0x0}, {0x2b2fffff,0x0},
   {0x5d71,0x0},{0x2b2fa28e,0x0},
 {0x25ff,0x0}, {0xfffefeff,0x0}, {0xfffeffff,0x0},
   {0x24ff,0x0},{0xfffedb00,0x0},
 {0x4f7dd7f0,0x0}, {0xdf827f3f,0x0}, {0xdfffffff,0x0},
   {0x4f005730,0x0},{0x90ffa8cf,0x0},
 {0x9a40d5be,0x0}, {0x5db1,0x0}, {0x9a40ddbf,0x0},
   {0x55b0,0x0},{0x9a40880f,0x0},
 {0xdfdcfd9b,0x0}, {0x63ff,0x0}, {0xdfdcffff,0x0},
   {0x619b,0x0},{0xdfdc9e64,0x0},
 {0x7e7f,0x0}, {0x5fb7,0x0}, {0x7fff,0x0},
   {0x5e37,0x0},{0x21c8,0x0},
 {0x5cce1fee,0x0}, {0x7aab,0x0}, {0x5cce7fef,0x0},
   {0x1aaa,0x0},{0x5cce6545,0x0},
 {0xfff3fe9d,0x0}, {0xd9b66fef,0x0}, {0xfff7ffff,0x0},
   {0xd9b26e8d,0x0},{0x26459172,0x0},
 {0xb9bfcefb,0x0}, {0x6be3f8,0x0}, {0xb9ffeffb,0x0},
   {0x2bc2f8,0x0},{0xb9d42d03,0x0},
 {0xd535edef,0x0}, {0xd7e97bf7,0x0}, {0xd7fdffff,0x0},
   {0xd52169e7,0x0},{0x2dc9618,0x0},
 {0x8ffd3ef7,0x0}, {0x7baf,0x0}, {0x8ffd7fff,0x0},
   {0x3aa7,0x0},{0x8ffd4558,0x0},
 {0x5dcfb3fe,0x0}, {0x16ce8ff8,0x0}, {0x5fcfbffe,0x0},
   {0x14ce83f8,0x0},{0x4b013c06,0x0},
 {0x9f1c7bfa,0x0}, {0xf7e85397,0x0}, {0xfffc7bff,0x0},
   {0x97085392,0x0},{0x68f4286d,0x0},
 {0x3925faff,0x0}, {0x66ff79be,0x0}, {0x7ffffbff,0x0},
   {0x202578be,0x0},{0x5fda8341,0x0},
 {0x60abbfbd,0x0}, {0xacfd4ff6,0x0}, {0xecffffff,0x0},
   {0x20a90fb4,0x0},{0xcc56f04b,0x0},
 {0xff7e7f37,0x0}, {0x72d756ff,0x0}, {0xffff7fff,0x0},
   {0x72565637,0x0},{0x8da929c8,0x0},
 {0xb0bedd3b,0x0}, {0x2cc43fff,0x0}, {0xbcfeffff,0x0},
   {0x20841d3b,0x0},{0x9c7ae2c4,0x0},
 {0xe8f9fefd,0x0}, {0x3dff,0x0}, {0xe8f9ffff,0x0},
   {0x3cfd,0x0},{0xe8f9c302,0x0},
 {0xff7b3d1e,0x0}, {0xd3efddd6,0x0}, {0xfffffdde,0x0},
   {0xd36b1d16,0x0},{0x2c94e0c8,0x0},
 {0x6ffb,0x0}, {0x77fc,0x0}, {0x7fff,0x0},
   {0x67f8,0x0},{0x1807,0x0},
 {0xab94febe,0x0}, {0x23683da9,0x0}, {0xabfcffbf,0x0},
   {0x23003ca8,0x0},{0x88fcc317,0x0},
 {0xa504deff,0x0}, {0x3d3c,0x0}, {0xa504ffff,0x0},
   {0x1c3c,0x0},{0xa504e3c3,0x0},
 {0xaf52777f,0x0}, {0x7ff6,0x0}, {0xaf527fff,0x0},
   {0x7776,0x0},{0xaf520889,0x0},
 {0xd8e2cfff,0x0}, {0x3bf3,0x0}, {0xd8e2ffff,0x0},
   {0xbf3,0x0},{0xd8e2f40c,0x0},
 {0x8281fae7,0x0}, {0xb6ff6f7f,0x0}, {0xb6ffffff,0x0},
   {0x82816a67,0x0},{0x347e9598,0x0},
 {0x1fbf,0x0}, {0xfdebdfbe,0x0}, {0xfdebdfbf,0x0},
   {0x1fbe,0x0},{0xfdebc001,0x0},
 {0xffcef77b,0x0}, {0x2ff7,0x0}, {0xffceffff,0x0},
   {0x2773,0x0},{0xffced88c,0x0},
 {0xfafba9ff,0x0}, {0xd40f7be,0x0}, {0xfffbffff,0x0},
   {0x840a1be,0x0},{0xf7bb5e41,0x0},
 {0xb346f7ff,0x0}, {0x5a9f7f7f,0x0}, {0xfbdfffff,0x0},
   {0x1206777f,0x0},{0xe9d98880,0x0},
 {0x6e9cff6f,0x0}, {0x1a5cfeff,0x0}, {0x7edcffff,0x0},
   {0xa1cfe6f,0x0},{0x74c00190,0x0},
 {0x58cb0bed,0x0}, {0x699fd7fe,0x0}, {0x79dfdfff,0x0},
   {0x488b03ec,0x0},{0x3154dc13,0x0},
 {0x2ffe,0x0}, {0x29e9ecff,0x0}, {0x29e9efff,0x0},
   {0x2cfe,0x0},{0x29e9c301,0x0},
 {0xefbfbecf,0x0}, {0xd0f0ffff,0x0}, {0xffffffff,0x0},
   {0xc0b0becf,0x0},{0x3f4f4130,0x0},
 {0x37f5,0x0}, {0xf7cdddbf,0x0}, {0xf7cdffff,0x0},
   {0x15b5,0x0},{0xf7cdea4a,0x0},
 {0x7b3f,0x0}, {0x3bef,0x0}, {0x7bff,0x0},
   {0x3b2f,0x0},{0x40d0,0x0},
 {0x2a0e6bb7,0x0}, {0x7ffe,0x0}, {0x2a0e7fff,0x0},
   {0x6bb6,0x0},{0x2a0e1449,0x0},
 {0xfd9fa7fe,0x0}, {0x987fdfbb,0x0}, {0xfdffffff,0x0},
   {0x981f87ba,0x0},{0x65e07845,0x0},
 {0xa42fefee,0x0}, {0x898905fb,0x0}, {0xadafefff,0x0},
   {0x800905ea,0x0},{0x2da6ea15,0x0},
 {0x7fcbffeb,0x0}, {0xb1757bf1,0x0}, {0xfffffffb,0x0},
   {0x31417be1,0x0},{0xcebe841a,0x0},
 {0x8c276fff,0x0}, {0xd4e346f7,0x0}, {0xdce76fff,0x0},
   {0x842346f7,0x0},{0x58c42908,0x0},
 {0xa11abeff,0x0}, {0x75b7,0x0}, {0xa11affff,0x0},
   {0x34b7,0x0},{0xa11acb48,0x0},
 {0x3bbb,0x0}, {0x5192ffff,0x0}, {0x5192ffff,0x0},
   {0x3bbb,0x0},{0x5192c444,0x0},
 {0xffbb4bdf,0x0}, {0xb6d,0x0}, {0xffbb4bff,0x0},
   {0xb4d,0x0},{0xffbb40b2,0x0},
 {0x1a4f24a7,0x0}, {0x6ae9,0x0}, {0x1a4f6eef,0x0},
   {0x20a1,0x0},{0x1a4f4e4e,0x0},
 {0xfc5df65d,0x0}, {0xd7f7d7be,0x0}, {0xfffff7ff,0x0},
   {0xd455d61c,0x0},{0x2baa21e3,0x0},
 {0x496496f,0x0}, {0xd27cdffe,0x0}, {0xd6fedfff,0x0},
   {0x14496e,0x0},{0xd6ea9691,0x0},
 {0xebbfdfcf,0x0}, {0x4b3d1bff,0x0}, {0xebbfdfff,0x0},
   {0x4b3d1bcf,0x0},{0xa082c430,0x0},
 {0xdf024ffb,0x0}, {0xfdfdf5fa,0x0}, {0xfffffffb,0x0},
   {0xdd0045fa,0x0},{0x22ffba01,0x0},
 {0x96ee97de,0x0}, {0x77fa,0x0}, {0x96eef7fe,0x0},
   {0x17da,0x0},{0x96eee024,0x0},
 {0x8ae8fbf7,0x0}, {0x6012fffe,0x0}, {0xeafaffff,0x0},
   {0xfbf6,0x0},{0xeafa0409,0x0},
 {0xfffdeefc,0x0}, {0x7cfe,0x0}, {0xfffdfefe,0x0},
   {0x6cfc,0x0},{0xfffd9202,0x0},
 {0x7bfb,0x0}, {0x43bd,0x0}, {0x7bff,0x0},
   {0x43b9,0x0},{0x3846,0x0},
 {0x5bf7,0x0}, {0x8147d3ff,0x0}, {0x8147dbff,0x0},
   {0x53f7,0x0},{0x81478808,0x0},
 {0x4eef,0x0}, {0xc12f99ef,0x0}, {0xc12fdfef,0x0},
   {0x8ef,0x0},{0xc12fd700,0x0},
 {0xf9cef36e,0x0}, {0x76fe,0x0}, {0xf9cef7fe,0x0},
   {0x726e,0x0},{0xf9ce8590,0x0},
 {0x3f7ffa89,0x0}, {0xc2e5f7ff,0x0}, {0xffffffff,0x0},
   {0x265f289,0x0},{0xfd9a0d76,0x0},
 {0x75ccb9eb,0x0}, {0x5f6faf7,0x0}, {0x75fefbff,0x0},
   {0x5c4b8e3,0x0},{0x703a431c,0x0},
 {0x677f,0x0}, {0x3fef,0x0}, {0x7fff,0x0},
   {0x276f,0x0},{0x5890,0x0},
 {0xd536fdff,0x0}, {0xfcf6aecb,0x0}, {0xfdf6ffff,0x0},
   {0xd436accb,0x0},{0x29c05334,0x0},
 {0x9dd5d776,0x0}, {0x7f7b,0x0}, {0x9dd5ff7f,0x0},
   {0x5772,0x0},{0x9dd5a80d,0x0},
 {0x677dbba7,0x0}, {0xc314f7ff,0x0}, {0xe77dffff,0x0},
   {0x4314b3a7,0x0},{0xa4694c58,0x0},
 {0x79b2fbff,0x0}, {0x9171bdfd,0x0}, {0xf9f3ffff,0x0},
   {0x1130b9fd,0x0},{0xe8c34602,0x0},
 {0xefeffd77,0x0}, {0xf7f07ff8,0x0}, {0xffffffff,0x0},
   {0xe7e07d70,0x0},{0x181f828f,0x0},
 {0x8bcb6cfb,0x0}, {0x7fff,0x0}, {0x8bcb7fff,0x0},
   {0x6cfb,0x0},{0x8bcb1304,0x0},
 {0xf9087bff,0x0}, {0xd7a2f4ed,0x0}, {0xffaaffff,0x0},
   {0xd10070ed,0x0},{0x2eaa8f12,0x0},
 {0x4d7d,0x0}, {0xfbabefff,0x0}, {0xfbabefff,0x0},
   {0x4d7d,0x0},{0xfbaba282,0x0},
 {0x77f3,0x0}, {0x5dfa,0x0}, {0x7ffb,0x0},
   {0x55f2,0x0},{0x2a09,0x0},
 {0xc6e3fff7,0x0}, {0x756f,0x0}, {0xc6e3ffff,0x0},
   {0x7567,0x0},{0xc6e38a98,0x0},
 {0xfef3eee6,0x0}, {0xe537f7ff,0x0}, {0xfff7ffff,0x0},
   {0xe433e6e6,0x0},{0x1bc41919,0x0},
 {0x57fc,0x0}, {0xff82ffef,0x0}, {0xff82ffff,0x0},
   {0x57ec,0x0},{0xff82a813,0x0},
 {0x375cbf2f,0x0}, {0x676b,0x0}, {0x375cff6f,0x0},
   {0x272b,0x0},{0x375cd844,0x0},
 {0xf5de5bfc,0x0}, {0xf56aafb7,0x0}, {0xf5feffff,0x0},
   {0xf54a0bb4,0x0},{0xb4f44b,0x0},
 {0x7507776d,0x0}, {0x7aaf,0x0}, {0x75077fef,0x0},
   {0x722d,0x0},{0x75070dc2,0x0},
 {0x1c95fbf0,0x0}, {0x3156deea,0x0}, {0x3dd7fffa,0x0},
   {0x1014dae0,0x0},{0x2dc3251a,0x0},
 {0xddfff7fe,0x0}, {0x7f7a,0x0}, {0xddfffffe,0x0},
   {0x777a,0x0},{0xddff8884,0x0},
 {0x9917ef7,0x0}, {0x773d,0x0}, {0x9917fff,0x0},
   {0x7635,0x0},{0x99109ca,0x0},
 {0x7283fe2f,0x0}, {0x24159fbf,0x0}, {0x7697ffbf,0x0},
   {0x20019e2f,0x0},{0x56966190,0x0},
 {0x17f7,0x0}, {0x76ff,0x0}, {0x77ff,0x0},
   {0x16f7,0x0},{0x6108,0x0},
 {0x7ffb,0x0}, {0x21af5fef,0x0}, {0x21af7fff,0x0},
   {0x5feb,0x0},{0x21af2014,0x0},
 {0xdee6bf97,0x0}, {0x95d4746f,0x0}, {0xdff6ffff,0x0},
   {0x94c43407,0x0},{0x4b32cbf8,0x0},
 {0x17fb,0x0}, {0x1592ffff,0x0}, {0x1592ffff,0x0},
   {0x17fb,0x0},{0x1592e804,0x0},
 {0xdfdadbdf,0x0}, {0xaf3794e5,0x0}, {0xffffdfff,0x0},
   {0x8f1290c5,0x0},{0x70ed4f3a,0x0},
 {0x7e7e,0x0}, {0x6ee7,0x0}, {0x7eff,0x0},
   {0x6e66,0x0},{0x1099,0x0},
 {0xe80ecef3,0x0}, {0x1b5f7fe7,0x0}, {0xfb5ffff7,0x0},
   {0x80e4ee3,0x0},{0xf351b114,0x0},
 {0xac64feef,0x0}, {0xde6f3ffc,0x0}, {0xfe6fffff,0x0},
   {0x8c643eec,0x0},{0x720bc113,0x0},
 {0xe3aa6d7f,0x0}, {0x3addbe7f,0x0}, {0xfbffff7f,0x0},
   {0x22882c7f,0x0},{0xd977d300,0x0},
 {0xef6bfb75,0x0}, {0x55d9d76f,0x0}, {0xfffbff7f,0x0},
   {0x4549d365,0x0},{0xbab22c1a,0x0},
 {0xd4f7f7b2,0x0}, {0x490e6bee,0x0}, {0xddfffffe,0x0},
   {0x400663a2,0x0},{0x9df99c5c,0x0},
 {0x8611fef9,0x0}, {0x8dc1ddff,0x0}, {0x8fd1ffff,0x0},
   {0x8401dcf9,0x0},{0xbd02306,0x0},
 {0x3ffd,0x0}, {0x7ff456db,0x0}, {0x7ff47fff,0x0},
   {0x16d9,0x0},{0x7ff46926,0x0},
 {0x53dcd1e7,0x0}, {0xbfff0f6f,0x0}, {0xffffdfef,0x0},
   {0x13dc0167,0x0},{0xec23de88,0x0},
 {0x7fbf,0x0}, {0xb03efabb,0x0}, {0xb03effbf,0x0},
   {0x7abb,0x0},{0xb03e8504,0x0},
 {0x970aefe5,0x0}, {0xfa9befe,0x0}, {0x9fabffff,0x0},
   {0x708aee4,0x0},{0x98a3511b,0x0},
 {0x3fbb,0x0}, {0xbf9effb7,0x0}, {0xbf9effbf,0x0},
   {0x3fb3,0x0},{0xbf9ec00c,0x0},
 {0xa17cdff,0x0}, {0xbf6dfeeb,0x0}, {0xbf7fffff,0x0},
   {0xa05cceb,0x0},{0xb57a3314,0x0},
 {0x89153bf7,0x0}, {0xfe7bdbde,0x0}, {0xff7ffbff,0x0},
   {0x88111bd6,0x0},{0x776ee029,0x0},
 {0xa3bbcfbb,0x0}, {0xfff6ccde,0x0}, {0xffffcfff,0x0},
   {0xa3b2cc9a,0x0},{0x5c4d0365,0x0},
 {0x7777f7fe,0x0}, {0xcbecfe7f,0x0}, {0xffffffff,0x0},
   {0x4364f67e,0x0},{0xbc9b0981,0x0},
 {0x3ebb,0x0}, {0xc1cbfffa,0x0}, {0xc1cbfffb,0x0},
   {0x3eba,0x0},{0xc1cbc141,0x0},
 {0x73ba,0x0}, {0x37d37f1e,0x0}, {0x37d37fbe,0x0},
   {0x731a,0x0},{0x37d30ca4,0x0},
 {0x2139abfb,0x0}, {0xd12817ef,0x0}, {0xf139bfff,0x0},
   {0x12803eb,0x0},{0xf011bc14,0x0},
 {0x257e35fb,0x0}, {0x386e4f6f,0x0}, {0x3d7e7fff,0x0},
   {0x206e056b,0x0},{0x1d107a94,0x0},
 {0x4086ffff,0x0}, {0xaff7c7ff,0x0}, {0xeff7ffff,0x0},
   {0x86c7ff,0x0},{0xef713800,0x0},
 {0xd3fafbef,0x0}, {0x6dfd,0x0}, {0xd3faffff,0x0},
   {0x69ed,0x0},{0xd3fa9612,0x0},
 {0xa4e6ef3f,0x0}, {0xfa549f36,0x0}, {0xfef6ff3f,0x0},
   {0xa0448f36,0x0},{0x5eb27009,0x0},
 {0xca2b5d7a,0x0}, {0xcb2e5ff9,0x0}, {0xcb2f5ffb,0x0},
   {0xca2a5d78,0x0},{0x1050283,0x0},
 {0xdbfa7ebf,0x0}, {0x737c,0x0}, {0xdbfa7fff,0x0},
   {0x723c,0x0},{0xdbfa0dc3,0x0},
 {0x7e68,0x0}, {0xe237fff1,0x0}, {0xe237fff9,0x0},
   {0x7e60,0x0},{0xe2378199,0x0},
 {0x21a56ff7,0x0}, {0xfb9bf7f5,0x0}, {0xfbbffff7,0x0},
   {0x218167f5,0x0},{0xda3e9802,0x0},
 {0xedf77fef,0x0}, {0x4066be7a,0x0}, {0xedf7ffff,0x0},
   {0x40663e6a,0x0},{0xad91c195,0x0},
 {0x7ffd,0x0}, {0xe690dfff,0x0}, {0xe690ffff,0x0},
   {0x5ffd,0x0},{0xe690a002,0x0},
 {0xffd6faca,0x0}, {0xc2ddcfeb,0x0}, {0xffdfffeb,0x0},
   {0xc2d4caca,0x0},{0x3d0b3521,0x0},
 {0xae07dd37,0x0}, {0x3bbd,0x0}, {0xae07ffbf,0x0},
   {0x1935,0x0},{0xae07e68a,0x0},
 {0xa3fffdff,0x0}, {0x1f37,0x0}, {0xa3ffffff,0x0},
   {0x1d37,0x0},{0xa3ffe2c8,0x0},
 {0x3f1e6ffb,0x0}, {0x3ffb,0x0}, {0x3f1e7ffb,0x0},
   {0x2ffb,0x0},{0x3f1e5000,0x0},
 {0xae5bfcf5,0x0}, {0x776f,0x0}, {0xae5bffff,0x0},
   {0x7465,0x0},{0xae5b8b9a,0x0},
 {0x8bfbe7ff,0x0}, {0x5546eeb6,0x0}, {0xdfffefff,0x0},
   {0x142e6b6,0x0},{0xdebd0949,0x0},
 {0x5114ff74,0x0}, {0x4eff,0x0}, {0x5114ffff,0x0},
   {0x4e74,0x0},{0x5114b18b,0x0},
 {0xf77f7fee,0x0}, {0x67ff,0x0}, {0xf77f7fff,0x0},
   {0x67ee,0x0},{0xf77f1811,0x0},
 {0x76ff,0x0}, {0x47eb,0x0}, {0x77ff,0x0},
   {0x46eb,0x0},{0x3114,0x0},
 {0x7be4,0x0}, {0xe6ff6f76,0x0}, {0xe6ff7ff6,0x0},
   {0x6b64,0x0},{0xe6ff1492,0x0},
 {0xa6997dff,0x0}, {0x1977f9ef,0x0}, {0xbffffdff,0x0},
   {0x1179ef,0x0},{0xbfee8410,0x0},
 {0x7bf37eb9,0x0}, {0xa5ed77f7,0x0}, {0xffff7fff,0x0},
   {0x21e176b1,0x0},{0xde1e094e,0x0},
 {0x73e97bec,0x0}, {0x7f71fdd3,0x0}, {0x7ff9ffff,0x0},
   {0x736179c0,0x0},{0xc98863f,0x0},
 {0xb8fd573b,0x0}, {0xea76fe75,0x0}, {0xfaffff7f,0x0},
   {0xa8745631,0x0},{0x528ba94e,0x0},
 {0xc7e4d6f7,0x0}, {0x3ee7,0x0}, {0xc7e4fef7,0x0},
   {0x16e7,0x0},{0xc7e4e810,0x0},
 {0x6d69,0x0}, {0xee3c0cfe,0x0}, {0xee3c6dff,0x0},
   {0xc68,0x0},{0xee3c6197,0x0},
 {0xe7ef6ffd,0x0}, {0x863afff9,0x0}, {0xe7fffffd,0x0},
   {0x862a6ff9,0x0},{0x61d59004,0x0},
 {0x43095a7c,0x0}, {0x7cb3f6b6,0x0}, {0x7fbbfefe,0x0},
   {0x40015234,0x0},{0x3fbaacca,0x0},
 {0xd9fc7dbe,0x0}, {0x70bbff2b,0x0}, {0xf9ffffbf,0x0},
   {0x50b87d2a,0x0},{0xa9478295,0x0},
 {0xd43c3bff,0x0}, {0x77877ff7,0x0}, {0xf7bf7fff,0x0},
   {0x54043bf7,0x0},{0xa3bb4408,0x0},
 {0x6dff,0x0}, {0x2cfe,0x0}, {0x6dff,0x0},
   {0x2cfe,0x0},{0x4101,0x0},
 {0x3ea5fbfe,0x0}, {0x3f76ff70,0x0}, {0x3ff7fffe,0x0},
   {0x3e24fb70,0x0},{0x1d3048e,0x0},
 {0x67cde6f,0x0}, {0xcae6bb27,0x0}, {0xcefeff6f,0x0},
   {0x2649a27,0x0},{0xcc9a6548,0x0},
 {0xfefbbb47,0x0}, {0x67c877b7,0x0}, {0xfffbfff7,0x0},
   {0x66c83307,0x0},{0x9933ccf0,0x0},
 {0x5fff,0x0}, {0x5afd,0x0}, {0x5fff,0x0},
   {0x5afd,0x0},{0x502,0x0},
 {0xb0057efa,0x0}, {0x7fbf,0x0}, {0xb0057fff,0x0},
   {0x7eba,0x0},{0xb0050145,0x0},
 {0xd049febb,0x0}, {0xbfba7f7f,0x0}, {0xfffbffff,0x0},
   {0x90087e3b,0x0},{0x6ff381c4,0x0},
 {0xf7effee4,0x0}, {0xcdd07eed,0x0}, {0xfffffeed,0x0},
   {0xc5c07ee4,0x0},{0x3a3f8009,0x0},
 {0x7bfbfe9e,0x0}, {0xf1fdb3de,0x0}, {0xfbffffde,0x0},
   {0x71f9b29e,0x0},{0x8a064d40,0x0},
 {0x7fff,0x0}, {0x7ffc,0x0}, {0x7fff,0x0},
   {0x7ffc,0x0},{0x3,0x0},
 {0x77aeffff,0x0}, {0xffffef1e,0x0}, {0xffffffff,0x0},
   {0x77aeef1e,0x0},{0x885110e1,0x0},
 {0xc0566f3a,0x0}, {0xdbeffd7e,0x0}, {0xdbffff7e,0x0},
   {0xc0466d3a,0x0},{0x1bb99244,0x0},
 {0x2ea5e5fd,0x0}, {0x28ba,0x0}, {0x2ea5edff,0x0},
   {0x20b8,0x0},{0x2ea5cd47,0x0},
 {0x5fbf,0x0}, {0x81d9f7ef,0x0}, {0x81d9ffff,0x0},
   {0x57af,0x0},{0x81d9a850,0x0},
 {0xe3e9ffef,0x0}, {0x7d9a4bf9,0x0}, {0xfffbffff,0x0},
   {0x61884be9,0x0},{0x9e73b416,0x0},
 {0xb9ffdfbe,0x0}, {0x9e4c1ffd,0x0}, {0xbfffdfff,0x0},
   {0x984c1fbc,0x0},{0x27b3c043,0x0},
 {0x906f74bf,0x0}, {0x77bd,0x0}, {0x906f77bf,0x0},
   {0x74bd,0x0},{0x906f0302,0x0},
 {0x1a98d5f3,0x0}, {0x6ffb,0x0}, {0x1a98fffb,0x0},
   {0x45f3,0x0},{0x1a98ba08,0x0},
 {0x7cdffbf7,0x0}, {0xe3b38d69,0x0}, {0xffffffff,0x0},
   {0x60938961,0x0},{0x9f6c769e,0x0},
 {0xfc6e35b3,0x0}, {0x367e,0x0}, {0xfc6e37ff,0x0},
   {0x3432,0x0},{0xfc6e03cd,0x0},
 {0xfbc3dbe9,0x0}, {0xd3fe9ff7,0x0}, {0xfbffdfff,0x0},
   {0xd3c29be1,0x0},{0x283d441e,0x0},
 {0x3eff,0x0}, {0x7abd,0x0}, {0x7eff,0x0},
   {0x3abd,0x0},{0x4442,0x0},
 {0xf9f69ffd,0x0}, {0xe56af4bb,0x0}, {0xfdfeffff,0x0},
   {0xe16294b9,0x0},{0x1c9c6b46,0x0},
 {0xc9d8c7fc,0x0}, {0xb4306337,0x0}, {0xfdf8e7ff,0x0},
   {0x80104334,0x0},{0x7de8a4cb,0x0},
 {0xdfe57dbb,0x0}, {0x362cd2fb,0x0}, {0xffedfffb,0x0},
   {0x162450bb,0x0},{0xe9c9af40,0x0},
 {0x9f1cff77,0x0}, {0x77fc,0x0}, {0x9f1cffff,0x0},
   {0x7774,0x0},{0x9f1c888b,0x0},
 {0x5f3f79cd,0x0}, {0xb524f6fd,0x0}, {0xff3ffffd,0x0},
   {0x152470cd,0x0},{0xea1b8f30,0x0},
 {0x107667f7,0x0}, {0xdffbdfdd,0x0}, {0xdfffffff,0x0},
   {0x107247d5,0x0},{0xcf8db82a,0x0},
 {0xdc3177eb,0x0}, {0x75037ffd,0x0}, {0xfd337fff,0x0},
   {0x540177e9,0x0},{0xa9320816,0x0},
 {0xeddbffbd,0x0}, {0x7ff5d7fe,0x0}, {0xffffffff,0x0},
   {0x6dd1d7bc,0x0},{0x922e2843,0x0},
 {0xaaa37eff,0x0}, {0xf7d8fffd,0x0}, {0xfffbffff,0x0},
   {0xa2807efd,0x0},{0x5d7b8102,0x0},
 {0xbaa21fbf,0x0}, {0x5c77,0x0}, {0xbaa25fff,0x0},
   {0x1c37,0x0},{0xbaa243c8,0x0},
 {0x250f75ff,0x0}, {0x5e453de7,0x0}, {0x7f4f7dff,0x0},
   {0x40535e7,0x0},{0x7b4a4818,0x0},
 {0xe63fca77,0x0}, {0xe7bea5f5,0x0}, {0xe7bfeff7,0x0},
   {0xe63e8075,0x0},{0x1816f82,0x0},
 {0xab6b7daa,0x0}, {0x88c1d7ee,0x0}, {0xabebffee,0x0},
   {0x884155aa,0x0},{0x23aaaa44,0x0},
 {0x669a736e,0x0}, {0xfdff9dfe,0x0}, {0xfffffffe,0x0},
   {0x649a116e,0x0},{0x9b65ee90,0x0},
 {0xf61bdff7,0x0}, {0x51781bba,0x0}, {0xf77bdfff,0x0},
   {0x50181bb2,0x0},{0xa763c44d,0x0},
 {0x35397a76,0x0}, {0x335073f1,0x0}, {0x37797bf7,0x0},
   {0x31107270,0x0},{0x6690987,0x0},
 {0xa5feefff,0x0}, {0xc6db5f7f,0x0}, {0xe7ffffff,0x0},
   {0x84da4f7f,0x0},{0x6325b080,0x0},
 {0x175abe3,0x0}, {0x7fbe9fbf,0x0}, {0x7fffbfff,0x0},
   {0x1348ba3,0x0},{0x7ecb345c,0x0},
 {0xafd177fe,0x0}, {0xbbec8d3f,0x0}, {0xbffdffff,0x0},
   {0xabc0053e,0x0},{0x143dfac1,0x0},
 {0xe3f571fd,0x0}, {0xda7f7ebc,0x0}, {0xfbff7ffd,0x0},
   {0xc27570bc,0x0},{0x398a0f41,0x0},
 {0x8a1c7fbd,0x0}, {0x77f0,0x0}, {0x8a1c7ffd,0x0},
   {0x77b0,0x0},{0x8a1c084d,0x0},
 {0xf7434dfe,0x0}, {0x53ff,0x0}, {0xf7435fff,0x0},
   {0x41fe,0x0},{0xf7431e01,0x0},
 {0x9e7fea26,0x0}, {0xe8cffdfb,0x0}, {0xfeffffff,0x0},
   {0x884fe822,0x0},{0x76b017dd,0x0},
 {0xe4af68ff,0x0}, {0x77f3,0x0}, {0xe4af7fff,0x0},
   {0x60f3,0x0},{0xe4af1f0c,0x0},
 {0x6bf9,0x0}, {0xa9046dfd,0x0}, {0xa9046ffd,0x0},
   {0x69f9,0x0},{0xa9040604,0x0},
 {0x7c7d,0x0}, {0x4c5bdabe,0x0}, {0x4c5bfeff,0x0},
   {0x583c,0x0},{0x4c5ba6c3,0x0},
 {0xf2769dfd,0x0}, {0x56df73fe,0x0}, {0xf6ffffff,0x0},
   {0x525611fc,0x0},{0xa4a9ee03,0x0},
 {0x3ecfedbf,0x0}, {0xeffbf3cc,0x0}, {0xffffffff,0x0},
   {0x2ecbe18c,0x0},{0xd1341e73,0x0},
 {0x3c85d7e4,0x0}, {0x3628fff6,0x0}, {0x3eadfff6,0x0},
   {0x3400d7e4,0x0},{0xaad2812,0x0},
 {0x1eff,0x0}, {0x13dd7fee,0x0}, {0x13dd7fff,0x0},
   {0x1eee,0x0},{0x13dd6111,0x0},
 {0x6bfe,0x0}, {0x1bffff7f,0x0}, {0x1bffffff,0x0},
   {0x6b7e,0x0},{0x1bff9481,0x0},
 {0x190efdf9,0x0}, {0xf0ae75ea,0x0}, {0xf9aefdfb,0x0},
   {0x100e75e8,0x0},{0xe9a08813,0x0},
 {0x7df7bbfe,0x0}, {0x7ffc,0x0}, {0x7df7fffe,0x0},
   {0x3bfc,0x0},{0x7df7c402,0x0},
 {0x8ea257ff,0x0}, {0x12e6,0x0}, {0x8ea257ff,0x0},
   {0x12e6,0x0},{0x8ea24519,0x0},
 {0xf5cefb7c,0x0}, {0x3f7f,0x0}, {0xf5ceff7f,0x0},
   {0x3b7c,0x0},{0xf5cec403,0x0},
 {0x36ff3ffe,0x0}, {0xd2fd577b,0x0}, {0xf6ff7fff,0x0},
   {0x12fd177a,0x0},{0xe4026885,0x0},
 {0xf55877ba,0x0}, {0x665effb,0x0}, {0xf77dfffb,0x0},
   {0x44067ba,0x0},{0xf33d9841,0x0},
 {0xffbbdbce,0x0}, {0x441d7f6f,0x0}, {0xffbfffef,0x0},
   {0x44195b4e,0x0},{0xbba6a4a1,0x0},
 {0x8afff553,0x0}, {0x930f586e,0x0}, {0x9bfffd7f,0x0},
   {0x820f5042,0x0},{0x19f0ad3d,0x0},
 {0x7f3f327d,0x0}, {0xd1c5fbbf,0x0}, {0xfffffbff,0x0},
   {0x5105323d,0x0},{0xaefac9c2,0x0},
 {0x7ae3fbb7,0x0}, {0x46b8,0x0}, {0x7ae3ffbf,0x0},
   {0x42b0,0x0},{0x7ae3bd0f,0x0},
 {0xf5a7e77b,0x0}, {0x9647d53f,0x0}, {0xf7e7f77f,0x0},
   {0x9407c53b,0x0},{0x63e03244,0x0},
 {0x7f8dbfbf,0x0}, {0xa54aff27,0x0}, {0xffcfffbf,0x0},
   {0x2508bf27,0x0},{0xdac74098,0x0},
 {0xfbaefabe,0x0}, {0x1ff6,0x0}, {0xfbaefffe,0x0},
   {0x1ab6,0x0},{0xfbaee548,0x0},
 {0xffa1ddff,0x0}, {0x33fdfef9,0x0}, {0xfffdffff,0x0},
   {0x33a1dcf9,0x0},{0xcc5c2306,0x0},
 {0x8a197ffd,0x0}, {0x9aefddff,0x0}, {0x9affffff,0x0},
   {0x8a095dfd,0x0},{0x10f6a202,0x0},
 {0x1d7f,0x0}, {0x3ff4,0x0}, {0x3fff,0x0},
   {0x1d74,0x0},{0x228b,0x0},
 {0xa3a7ffef,0x0}, {0xf7dff22f,0x0}, {0xf7ffffef,0x0},
   {0xa387f22f,0x0},{0x54780dc0,0x0},
 {0x4dff,0x0}, {0x4899effd,0x0}, {0x4899efff,0x0},
   {0x4dfd,0x0},{0x4899a202,0x0},
 {0xff93faeb,0x0}, {0x7635,0x0}, {0xff93feff,0x0},
   {0x7221,0x0},{0xff938cde,0x0},
 {0x5a967f7f,0x0}, {0xefb76c7f,0x0}, {0xffb77f7f,0x0},
   {0x4a966c7f,0x0},{0xb5211300,0x0},
 {0x40f0,0x0}, {0xd5ffefff,0x0}, {0xd5ffefff,0x0},
   {0x40f0,0x0},{0xd5ffaf0f,0x0},
 {0x6435bfbe,0x0}, {0xad1f73bb,0x0}, {0xed3fffbf,0x0},
   {0x241533ba,0x0},{0xc92acc05,0x0},
 {0x5dfb,0x0}, {0x9a7e7fff,0x0}, {0x9a7e7fff,0x0},
   {0x5dfb,0x0},{0x9a7e2204,0x0},
 {0x9b766f,0x0}, {0x9ca877ff,0x0}, {0x9cbb77ff,0x0},
   {0x88766f,0x0},{0x9c330190,0x0},
 {0x6707f3ad,0x0}, {0xb90e7efd,0x0}, {0xff0ffffd,0x0},
   {0x210672ad,0x0},{0xde098d50,0x0},
 {0x30d36db3,0x0}, {0x7d37b5b9,0x0}, {0x7df7fdbb,0x0},
   {0x301325b1,0x0},{0x4de4d80a,0x0},
 {0x562e1f3e,0x0}, {0x3efe,0x0}, {0x562e3ffe,0x0},
   {0x1e3e,0x0},{0x562e21c0,0x0},
 {0x7f77,0x0}, {0xf9a59e3d,0x0}, {0xf9a5ff7f,0x0},
   {0x1e35,0x0},{0xf9a5e14a,0x0},
 {0x39c97d3b,0x0}, {0x1605ffff,0x0}, {0x3fcdffff,0x0},
   {0x10017d3b,0x0},{0x2fcc82c4,0x0},
 {0x5bfe,0x0}, {0xc217ebaf,0x0}, {0xc217fbff,0x0},
   {0x4bae,0x0},{0xc217b051,0x0},
 {0xdf4efb57,0x0}, {0x88833dbf,0x0}, {0xdfcfffff,0x0},
   {0x88023917,0x0},{0x57cdc6e8,0x0},
 {0xee7dd66e,0x0}, {0xd6944fff,0x0}, {0xfefddfff,0x0},
   {0xc614466e,0x0},{0x38e99991,0x0},
 {0x5dfbfd7f,0x0}, {0xc5ff2f7f,0x0}, {0xddffff7f,0x0},
   {0x45fb2d7f,0x0},{0x9804d200,0x0},
 {0x825fefea,0x0}, {0x6dfe,0x0}, {0x825feffe,0x0},
   {0x6dea,0x0},{0x825f8214,0x0},
 {0x48717baf,0x0}, {0xe843ffa3,0x0}, {0xe873ffaf,0x0},
   {0x48417ba3,0x0},{0xa032840c,0x0},
 {0xe59df3b7,0x0}, {0xc754feff,0x0}, {0xe7ddffff,0x0},
   {0xc514f2b7,0x0},{0x22c90d48,0x0},
 {0xffff9d4e,0x0}, {0x7fff,0x0}, {0xffffffff,0x0},
   {0x1d4e,0x0},{0xffffe2b1,0x0},
 {0x65fdbe6f,0x0}, {0x77ff6b66,0x0}, {0x77ffff6f,0x0},
   {0x65fd2a66,0x0},{0x1202d509,0x0},
 {0x86a9f7bb,0x0}, {0xf59f71b6,0x0}, {0xf7bff7bf,0x0},
   {0x848971b2,0x0},{0x7336860d,0x0},
 {0x8a7d7bfe,0x0}, {0xf7af87bf,0x0}, {0xffffffff,0x0},
   {0x822d03be,0x0},{0x7dd2fc41,0x0},
 {0x2ff7,0x0}, {0xb177677e,0x0}, {0xb1776fff,0x0},
   {0x2776,0x0},{0xb1774889,0x0},
 {0x59fd,0x0}, {0x7f7b,0x0}, {0x7fff,0x0},
   {0x5979,0x0},{0x2686,0x0},
 {0x65fb,0x0}, {0xc5dff3db,0x0}, {0xc5dff7fb,0x0},
   {0x61db,0x0},{0xc5df9620,0x0},
 {0xfaeeefbb,0x0}, {0x7ff9,0x0}, {0xfaeefffb,0x0},
   {0x6fb9,0x0},{0xfaee9042,0x0},
 {0xf7ffd1d2,0x0}, {0xfbff568d,0x0}, {0xffffd7df,0x0},
   {0xf3ff5080,0x0},{0xc00875f,0x0},
 {0x7fed3ffd,0x0}, {0xe94ac43e,0x0}, {0xffefffff,0x0},
   {0x6948043c,0x0},{0x96a7fbc3,0x0},
 {0x7eb6eff,0x0}, {0xd521bffc,0x0}, {0xd7ebffff,0x0},
   {0x5212efc,0x0},{0xd2cad103,0x0},
 {0xd30dfff9,0x0}, {0xd3743ed,0x0}, {0xdf3ffffd,0x0},
   {0x10543e9,0x0},{0xde3abc14,0x0},
 {0x66f3,0x0}, {0x3b7e,0x0}, {0x7fff,0x0},
   {0x2272,0x0},{0x5d8d,0x0},
 {0xe7cc39bf,0x0}, {0x2f5b7fbe,0x0}, {0xefdf7fbf,0x0},
   {0x274839be,0x0},{0xc8974601,0x0},
 {0xadb4fd7d,0x0}, {0x646f,0x0}, {0xadb4fd7f,0x0},
   {0x646d,0x0},{0xadb49912,0x0},
 {0xe9ddeef7,0x0}, {0xe9f1d9fb,0x0}, {0xe9fdffff,0x0},
   {0xe9d1c8f3,0x0},{0x2c370c,0x0},
 {0x54027eae,0x0}, {0x555177f7,0x0}, {0x55537fff,0x0},
   {0x540076a6,0x0},{0x1530959,0x0},
 {0xbc3c53be,0x0}, {0xf1acabfb,0x0}, {0xfdbcfbff,0x0},
   {0xb02c03ba,0x0},{0x4d90f845,0x0},
 {0xe3eff7df,0x0}, {0xa0d09b3f,0x0}, {0xe3ffffff,0x0},
   {0xa0c0931f,0x0},{0x433f6ce0,0x0},
 {0x2628bf7a,0x0}, {0xc3f47b7b,0x0}, {0xe7fcff7b,0x0},
   {0x2203b7a,0x0},{0xe5dcc401,0x0},
 {0x9b77d775,0x0}, {0x3ff7,0x0}, {0x9b77fff7,0x0},
   {0x1775,0x0},{0x9b77e882,0x0},
 {0x7bf7,0x0}, {0x1879f66f,0x0}, {0x1879ffff,0x0},
   {0x7267,0x0},{0x18798d98,0x0},
 {0x8c45fff7,0x0}, {0x57d80fba,0x0}, {0xdfddffff,0x0},
   {0x4400fb2,0x0},{0xdb9df04d,0x0},
 {0x7af005fe,0x0}, {0x127dfffe,0x0}, {0x7afdfffe,0x0},
   {0x127005fe,0x0},{0x688dfa00,0x0},
 {0xadea76f6,0x0}, {0x58825def,0x0}, {0xfdea7fff,0x0},
   {0x88254e6,0x0},{0xf5682b19,0x0},
 {0x229bbfff,0x0}, {0xbe7efbf5,0x0}, {0xbeffffff,0x0},
   {0x221abbf5,0x0},{0x9ce5440a,0x0},
 {0xff5bbf33,0x0}, {0xf7ea7efd,0x0}, {0xfffbffff,0x0},
   {0xf74a3e31,0x0},{0x8b1c1ce,0x0},
 {0xfc2af5b5,0x0}, {0x69b7,0x0}, {0xfc2afdb7,0x0},
   {0x61b5,0x0},{0xfc2a9c02,0x0},
 {0xde3f9e9b,0x0}, {0x51e3,0x0}, {0xde3fdffb,0x0},
   {0x1083,0x0},{0xde3fcf78,0x0},
 {0x52a5fee5,0x0}, {0x36fb,0x0}, {0x52a5feff,0x0},
   {0x36e1,0x0},{0x52a5c81e,0x0},
 {0x105a4efb,0x0}, {0x648fae75,0x0}, {0x74dfeeff,0x0},
   {0xa0e71,0x0},{0x74d5e08e,0x0},
 {0x50b1e577,0x0}, {0x6c9c793b,0x0}, {0x7cbdfd7f,0x0},
   {0x40906133,0x0},{0x3c2d9c4c,0x0},
 {0xfacfddfc,0x0}, {0xa8293f3e,0x0}, {0xfaeffffe,0x0},
   {0xa8091d3c,0x0},{0x52e6e2c2,0x0},
 {0x8ab4737f,0x0}, {0x1e5cff7f,0x0}, {0x9efcff7f,0x0},
   {0xa14737f,0x0},{0x94e88c00,0x0},
 {0xf2dc7f7f,0x0}, {0x7db5,0x0}, {0xf2dc7fff,0x0},
   {0x7d35,0x0},{0xf2dc02ca,0x0},
 {0xe63b7bf7,0x0}, {0xa86adfb7,0x0}, {0xee7bfff7,0x0},
   {0xa02a5bb7,0x0},{0x4e51a440,0x0},
 {0x7fff,0x0}, {0x2bb5cdff,0x0}, {0x2bb5ffff,0x0},
   {0x4dff,0x0},{0x2bb5b200,0x0},
 {0xbfdfbe6e,0x0}, {0x7eaf,0x0}, {0xbfdffeef,0x0},
   {0x3e2e,0x0},{0xbfdfc0c1,0x0}

};
#undef m
#undef M
#undef A
#undef E
#undef F
#define NTESTS ((UINT) (sizeof abcde / (sizeof abcde[0] * 5)))

int CompilerBuiltin(void);
int NoCompilerBuiltin(void);

void error(_TCHAR *Op,
           MY_UINT64 *a,
           MY_UINT64 *b,
           MY_UINT64 *c,
           MY_UINT64 *d,
           int i)
{
    _tprintf(_TEXT("a = { 0x%x, 0x%x }, "), *a);
    _tprintf(_TEXT("b = %d, "), *b);
    _tprintf(_TEXT("a %s b = { 0x%x, 0x%x }\n\r"), Op, *c);
    _tprintf(_TEXT("  ==> a %s b should be { 0x%x, 0x%x }!!!\n\r"), Op, *d);
    _tprintf(_TEXT("64-bit logical operators test FAILED "));
    _tprintf(_TEXT("in iteration %d.\n\r"), i); 
}

#define MYERROR(o,a,b,c,d,i) error(o,(MY_UINT64*)&a,(MY_UINT64*)&b,(MY_UINT64*)&c,(MY_UINT64*)&d,i)

#define Test(_name_) \
int _name_(void)    \
{    \
    int i;    \
    MY_UINT64 *p;    \
    UINT64 a, b, c, d;    \
    INT64 ic;    \
    int nPass, nFail;    \
    TIME Tstart, Tend;    \
    \
    Tstart = CurrentTime();    \
    \
    nPass = nFail = 0;    \
    p = abcde;    \
    for (i = 0; i < NTESTS; i++) {    \
    \
        Int64FromHighAndLow(a, p->HighPart, p->LowPart);    \
        p++;    \
        Int64FromHighAndLow(b, p->HighPart, p->LowPart);    \
        p++;    \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64Or(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("|"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        ic = Int64Or(Uint64ToInt64(a),Uint64ToInt64(b));    \
        if (!Int64Equal(ic,Uint64ToInt64(d))) {    \
            MYERROR(_TEXT("(|)"),a,b,ic,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64And(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("&"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        ic = Int64And(Uint64ToInt64(a),Uint64ToInt64(b));    \
        if (!Int64Equal(ic,Uint64ToInt64(d))) {    \
            MYERROR(_TEXT("(&)"),a,b,ic,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
        Int64FromHighAndLow(d, p->HighPart, p->LowPart);    \
        p++;    \
        c = Uint64Xor(a,b);    \
        if (!Int64Equal(c,d)) {    \
            MYERROR(_TEXT("^"),a,b,c,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        ic = Int64Xor(Uint64ToInt64(a),Uint64ToInt64(b));    \
        if (!Int64Equal(ic,Uint64ToInt64(d))) {    \
            MYERROR(_TEXT("(^)"),a,b,ic,d,i);    \
            nFail++;    \
        } else {    \
            nPass++;    \
        }    \
        \
    }    \
    Tend = CurrentTime();    \
    \
    _tprintf(_TEXT("64-bit logical operators test "));    \
    if (nFail == 0) {    \
        _tprintf(_TEXT("PASSED.\n\r"));    \
    \
    } else {    \
        _tprintf(_TEXT("FAILED (%d fail %d pass).\n\r"),    \
                 nFail, nPass);    \
    }    \
    \
    i = TimeDifference(Tend,Tstart);    \
    _tprintf(_TEXT("Took %d microseconds for %d tests (%d/test)\n\r"),    \
             i / 10,    \
             6*NTESTS,    \
             i / (6*NTESTS*10));    \
    return nFail;    \
}


/* In any event, test the os-supported routines.
 * If the compiler supports it, repeat for the builtin routines.
 */
int _tmain()
{
    int nFail = 0;

    _tprintf(_TEXT("\n\rTesting os-supported 64bit logical operators.\n\r"));
    nFail = NoCompilerBuiltin();

#if !defined(__NO_BUILTIN_INT64)
    _tprintf(_TEXT("\n\rTesting compiler-supported 64bit logical operators.\n\r"));
    nFail += CompilerBuiltin();
#endif

    if (nFail)
        _tprintf(_TEXT("Test FAILED, %d errors.\n\r"), nFail);

    exit ((nFail == 0) ? EXIT_SUCCESS : EXIT_FAILURE);
    return 0;/*amusme*/
}

#include "tst64again.c"

