/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <mmlite.h>
#include "../utilities/utility.h"    

int _tmain(int argc, _TCHAR **argv)
{
  int i, nThds;
  PIPROCESS pPrc = CurrentProcess();
  TIME ts, te;
  SCODE sc;

  nThds = 30;
  if (argc > 1)
    nThds = _ttoi(argv[1]);

  ts = CurrentTime();
  for (i = 0; i < nThds; i++) {
    sc = pPrc->v->CreateThread(pPrc, 0,
                               (THREAD_FUNCTION)ThreadExit,
                               (THREAD_ARGUMENT)NULL,
                               0, NULL, NULL);
    if (FAILED(sc)) {
        _tprintf(_TEXT("FAILED to create thread #%d (sc = x%x)\n\r"), i, sc);
        return SetAndReturn(EXIT_FAILURE);
    }
  }
  te = CurrentTime();

  te = Int64Subtract(te,ts);
  _tprintf(_TEXT("Creating %d threads took %lld * 100 nanoseconds\n\r"),
         nThds, te);
  _tprintf(_TEXT("Test PASSED (I guess..).\n\r"));

  return SetAndReturn(EXIT_SUCCESS);
}
