/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <stdio.h>
#include <mmlite.h>
#include <stdlib.h>
#include <tchar.h>

/* Trivial test for scanf()
 */
UINT32 buffer[1024/4];

int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc;
    INT RetVal = EXIT_FAILURE;
    UINT n, i;
    
    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
        _tprintf(_TEXT("No command line args (%x), test FAILED\r\n"), sc);
        exit(RetVal);
    }

    if (argc < 2) {
        _tprintf(_TEXT("Usage: %s <format string>\r\n"), 
                 argv[0]);
        goto Done;
    }

    _tprintf(_TEXT("Type something to satisfy a '%s'\r\n"), argv[1]);
    n = _tscanf(argv[1],
                buffer+0,buffer+1,buffer+2,buffer+3,
                buffer+4,buffer+5,buffer+6,buffer+7,
                buffer+8,buffer+9,buffer+10,buffer+11,
                buffer+12,buffer+13,buffer+14,buffer+15);

    _tprintf(_TEXT("scanf(%s,buffer,...) returned %d, buffer is:\r\n"),
             argv[1], n);
    for (i = 0; i < n; i++)
        _tprintf(_TEXT("x%x "), buffer[i]);
    _tprintf(_TEXT("\r\n"));

    RetVal = EXIT_SUCCESS;
Done:
    (void) FreeCmdLine(&argc,&argv);
    exit(RetVal);
    return 0;
}
