/* 
* Copyright (c) Microsoft Corporation All rights reserved
*/

#include <mmlite.h>
typedef struct wait_care_pkg
{
    CONDITION   *   pcv;    //condition var
    MUTEX       *   pmtx_console; //mutex to 'protect' console from interlaced writes
    UINT            nStart;   //number of threads to start, at start ..
    UINT            nFinish;  //all threads are done when decremented to zero
    TIME            tm;         //how long to wait ... 
    TIME_CONSTRAINT * pCons;
    BOOL            bEndPrevious;   //does constrained wait end previous wait?
    BOOL            bRecordTimeTaken;   //does constrained wait record time consumed?
}wait_care_pkg; 

void WaitThreadProc(THREAD_ARGUMENT pV);
void CBUsage(const _TCHAR * s); 
void CBStatus(const wait_care_pkg * p, BOOL bBroadcast, UINT32 nStackSize);
void CheckLock(MUTEX * pMTX, BOOL bLocked, const _TCHAR *sFile, unsigned nLine);
void SafePrint(const _TCHAR * sMsg, MUTEX * pMTX);
void ReportConstrainedResults(const wait_care_pkg * p, const TIME * pTM);

#define DEFAULT_THREAD_NUMBER                               (10)
#define DEFAULT_ESTIMATE                                    TIME_RELATIVE(TIME_MILLIS(100))
#define DEFAULT_DEADLINE                                    TIME_RELATIVE(TIME_MILLIS(200))

#define DEFAULT_STACK_SIZE                                  ((UINT32)(-1))
