/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* A possibly not-very-significant test of C++ support
 */
#include <mmlite.h>
#include <stdio.h>

extern "C"
{
void* Create(int nN);
void Destroy(void *pvB);
};

class A
{
    int m_nA;
public:
    A();
    ~A();
};

class B
{
    int m_nN;
    A* m_pA;
public:
    B(int nN);
    ~B();
};

A::A()
{
    m_nA=0;
}

A::~A()
{
}

B::B(int nN)
{
    m_nN=nN;
    m_pA=new A[m_nN];
}

B::~B()
{
    delete[] m_pA;
};

extern "C" void* Create(int nN)
{
    return(void*)new B(nN);    
}

extern "C" void Destroy(void *pvB)
{
    delete(B*)pvB;
}

int _tmain(int argc, _TCHAR **argv)
{
    void *x = Create(33);
    printf("create gives x%x\n", (UINT) x);
    Destroy(x);
    printf("destroyed ok\n");
    return 0;
}
