/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* Trivial test for file I/O routines
 */

#include <mmlite.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <tchar.h>

#define BUFFER_SIZE 512
char Buffer[BUFFER_SIZE];

int _tmain(int argc, _TCHAR **argv)
{
    FILE *f;
    size_t n;
    INT RetVal = EXIT_FAILURE;

    ParseCmdLine(&argc,&argv);

    if (argc < 2) {
        fprintf(stderr,_TEXT("Usage: %s <filename to type>\n"),
                argv[0]);
        goto Done;
    }

    /* fopen */
    f = fopen(argv[1], _TEXT("rb"));
    if (f == NULL) {
        fprintf(stderr, _TEXT("%s wont open\n"), argv[1]);
        goto Done;
    }

    while (!feof(f)) {
        
        n = fread(Buffer,1,BUFFER_SIZE,f);
#if 1
        fwrite(Buffer,n,1,stdout);
#else
        /* almost exactly the same thing */
        write(1,Buffer,n);
#endif
    }

    fclose(f);

    RetVal = EXIT_SUCCESS;
 Done:
    FreeCmdLine(&argc,&argv);

    exit(RetVal);
}
