/* Copyright (c) Microsoft Corporation. All rights reserved. */

#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* Check parsing of command line arguments
 */
int _tmain(INT argc, _TCHAR **argv)
{
    SCODE sc;
    ADDRESS p;

    sc = ParseCmdLine(&argc, &argv);
    if (FAILED(sc)) {
    Nope:
        _tprintf(_TEXT("No command line args (%x), test FAILED\n\r"), sc);
        exit(EXIT_FAILURE);
    }

    if (argc < 2) {
        goto Nope;
    }

    p = _tcstoul(argv[1],NULL,16);
    _tprintf(_TEXT("Freeing memory block @x%x\r\n"),  p);
    free((void *)p);

    (void) FreeCmdLine(&argc,&argv);

    exit(EXIT_SUCCESS);
    return 0;
}
