/* Copyright (c) Microsoft Corporation. All rights reserved. */
#include <mmlite.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

/* Say how long we have been up
 */

_TCHAR *Plural(UINT32 Value)
{
    return (Value > 1) ? _T("s") : _T("");
}

int _tmain(INT argc, _TCHAR **argv)
{
    TIME Now = CurrentTime(), t, t1;
    UINT32 Seconds, Minutes, Hours, Days, Weeks;
    
    Now = Int64DividedByInt32(Now,TIME_SECONDS(1));

    /* Seconds
     */
    t1 = Int64DividedByInt32(Now,60);
    t = Int64TimesInt32(t1,60);
    t = TimeSubtract(Now,t);
    Seconds = Int64ToInt32(t);
    Now = t1;

    /* Minutes
     */
    t1 = Int64DividedByInt32(Now,60);
    t = Int64TimesInt32(t1,60);
    t = TimeSubtract(Now,t);
    Minutes = Int64ToInt32(t);
    Now = t1;

    /* Hours
     */
    t1 = Int64DividedByInt32(Now,24);
    t = Int64TimesInt32(t1,24);
    t = TimeSubtract(Now,t);
    Hours = Int64ToInt32(t);
    Now = t1;

    /* Days
     */
    t1 = Int64DividedByInt32(Now,7);
    t = Int64TimesInt32(t1,7);
    t = TimeSubtract(Now,t);
    Days = Int64ToInt32(t);
    Now = t1;

    /* Weeks
     */
    Weeks = Int64ToInt32(Now);

    /* Say what
     */
    _tprintf(_TEXT("Uptime:"));
    if (Weeks)
        _tprintf(_TEXT(" %u week%s"), Weeks, Plural(Weeks));
    if (Days)
        _tprintf(_TEXT(" %u day%s"), Days, Plural(Days));
    if (Hours)
        _tprintf(_TEXT(" %u hour%s"), Hours, Plural(Hours));
    if (Minutes)
        _tprintf(_TEXT(" %u minute%s"), Minutes, Plural(Minutes));
    if (Seconds)
        _tprintf(_TEXT(" %u second%s"), Seconds, Plural(Seconds));
    _tprintf(_TEXT("\n"));

    exit(EXIT_SUCCESS);
    return 0;
}
