/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* --------------------------------------------------------------------------
 *
 * Module:
 *
 *    vendors.h
 *
 * Purpose:
 *
 *    Utility to print the details of (a) USB device tree, vendor id list
 *
 * Author:
 *    A. Forin (sandrof)
 *
 * --------------------------------------------------------------------------
 */

typedef struct {
    UINT16 VendorId;
    _TCHAR *VendorName;
} VENDOR_ENTRY, *PVENDOR_ENTRY;

VENDOR_ENTRY VendorIdTable[] = {
    {1003, _T("Atmel Corporation")},
    {1006, _T("Mitsumi")},
    {1008, _T("Hewlett Packard")},
    {1012, _T("Diebold, Inc.")},
    {1020, _T("Elitegroup Computer Systems")},
    {1024, _T("National Semiconductor")},
    {1026, _T("ALi Corporation")},
    {1027, _T("Future Technology Devices International Limited")},
    {1033, _T("NEC Corporation")},
    {1034, _T("Kodak Co.")},
    {1037, _T("VIA Technologies, Inc.")},
    {1038, _T("MCCI")},
    {1041, _T("BUFFALO INC.")},
    {1046, _T("Winbond Electronics Corp.")},
    {1050, _T("Phoenix Technologies Ltd.")},
    {1054, _T("Creative Labs")},
    {1057, _T("Nokia Corporation")},
    {1059, _T("CATC")},
    {1060, _T("Standard Microsystems Corp.")},
    {1061, _T("Freescale Semiconductor Hong Kong Limited")},
    {1065, _T("Cirrus Logic Inc.")},
    {1068, _T("Innovative Semiconductors, Inc.")},
    {1071, _T("Molex Inc.")},
    {1074, _T("Unisys Corp.")},
    {1080, _T("Advanced Micro Devices")},
    {1085, _T("Lexmark International Inc.")},
    {1086, _T("LG Electronics USA Inc.")},
    {1088, _T("EIZO NANAO CORPORATION")},
    {1094, _T("NMB Technologies Corporation")},
    {1105, _T("Texas Instruments")},
    {1111, _T("Silicon Integrated Systems Corp.")},
    {1112, _T("KYE Systems Corp. (Mouse Systems)")},
    {1115, _T("Renesas Technology Corp.")},
    {1118, _T("Microsoft Corporation")},
    {1121, _T("Primax Electronics")},
    {1123, _T("MGE UPS Systems")},
    {1128, _T("Wieson Technologies Co., Ltd.")},
    {1130, _T("CHERRY GmbH")},
    {1131, _T("American Megatrends")},
    {1133, _T("Logitech Inc.")},
    {1134, _T("Behavior Tech. Computer Corporation")},
    {1137, _T("Philips")},
    {1140, _T("Sanyo Electric Co. Ltd.")},
    {1143, _T("Seagate Technology")},
    {1150, _T("Agere Systems Inc.")},
    {1154, _T("Kyocera Corporation")},
    {1155, _T("STMicroelectronics")},
    {1161, _T("Foxconn / Hon Hai")},
    {1165, _T("ITE Tech. Inc.")},
    {1177, _T("Yamaha Corporation")},
    {1188, _T("Hitachi, Ltd.")},
    {1189, _T("Benq Corporation")},
    {1191, _T("Visioneer")},
    {1193, _T("Canon Inc. (Kosugi Office)")},
    {1200, _T("Nikon Corporation")},
    {1203, _T("IBM Corporation")},
    {1204, _T("Cypress Semiconductor")},
    {1205, _T("ROHM LSI Systems USA, LLC")},
    {1207, _T("Compal Electronics, Inc.")},
    {1208, _T("Seiko Epson Corp.")},
    {1211, _T("I-O Data Device, Inc.")},
    {1215, _T("TDK Corporation")},
    {1221, _T("Fujitsu Ltd.")},
    {1226, _T("Lite-On Technology Corp.")},
    {1227, _T("Fuji Photo Film Co., Ltd.")},
    {1228, _T("Philips Semiconductors")},
    {1231, _T("Myson Century, Inc.")},
    {1236, _T("LSI Logic Inc.")},
    {1238, _T("Mentor Graphics")},
    {1242, _T("Panasonic (Matsushita)")},
    {1244, _T("Huan Hsin Holdings Ltd.")},
    {1245, _T("Sharp Corporation")},
    {1247, _T("Interlink Electronics")},
    {1251, _T("Zilog")},
    {1254, _T("SCM Microsystems")},
    {1255, _T("Elo TouchSystems")},
    {1256, _T("Samsung Electronics Co., Ltd.")},
    {1259, _T("Northstar Systems, Inc.")},
    {1260, _T("Tokyo Electron Device Limited")},
    {1265, _T("Victor Company of Japan, Limited")},
    {1266, _T("Chicony Electronics Co., Ltd.")},
    {1267, _T("Elan Microelectronics Corportation")},
    {1271, _T("Newnex Technology Corp.")},
    {1273, _T("Brother Industries, Ltd.")},
    {1276, _T("SUNPLUS TECHNOLOGY CO., LTD.")},
    {1278, _T("PFU Limited")},
    {1281, _T("Fujikura/DDK")},
    {1287, _T("Hosiden Corporation")},
    {1293, _T("Belkin Components")},
    {1300, _T("FCI Electronics")},
    {1302, _T("Longwell Electronics/Longwell Company")},
    {1305, _T("Star Micronics Co., LTD")},
    {1308, _T("Shuttle Inc.")},
    {1309, _T("American Power Conversion")},
    {1310, _T("Scientific Atlanta, Inc.")},
    {1312, _T("Taiwan Semiconductor Manufacturing Co.")},
    {1314, _T("ACON, Advanced-Connectek, Inc.")},
    {1317, _T("PLX Technology, Inc.")},
    {1324, _T("Canon Development Americas")},
    {1329, _T("Wacom Technology Corp.")},
    {1335, _T("Inventec Corporation")},
    {1337, _T("Shyh Shiun Terminals Co. LTD")},
    {1338, _T("Preh Werke Gmbh & Co. KG")},
    {1343, _T("Synopsys, Inc.")},
    {1347, _T("ViewSonic Corporation")},
    {1356, _T("Sony Corporation")},
    {1360, _T("Fuji Xerox Co., Ltd.")},
    {1363, _T("STMicroelectronics Imaging Division")},
    {1366, _T("Asahi Kasei Microsystems Co., Ltd.")},
    {1367, _T("ATEN International Co. Ltd.")},
    {1379, _T("Immersion Corporation")},
    {1380, _T("Kodak Digital Product Center, Japan Ltd.")},
    {1383, _T("Xyratex")},
    {1386, _T("WACOM Co., Ltd.")},
    {1390, _T("Elecom Co., Ltd.")},
    {1394, _T("Conexant Systems, Inc.")},
    {1395, _T("Zoran Corporation")},
    {1398, _T("BAFO/Quality Computer Accessories")},
    {1403, _T("Y-E Data, Inc.")},
    {1404, _T("AVM GmbH")},
    {1410, _T("Roland Corporation")},
    {1411, _T("Padix Co., Ltd.")},
    {1412, _T("RATOC System Inc.")},
    {1419, _T("Infineon Technologies")},
    {1421, _T("Micrel Semiconductor")},
    {1423, _T("Alcor Micro, Corp.")},
    {1424, _T("OMRON Corporation")},
    {1435, _T("Iomega Corporation")},
    {1439, _T("LaCie")},
    {1442, _T("Fuji Film Microdevices Co. Ltd.")},
    {1443, _T("TransDimension-NH LLC")},
    {1444, _T("Ortek Technology, Inc.")},
    {1447, _T("Bose Corporation")},
    {1452, _T("Apple Computer")},
    {1453, _T("Y.C. Cable U.S.A., Inc")},
    {14627, _T("National Instruments")},
    {1466, _T("DigitalPersona, Inc.")},
    {1469, _T("RAFI GmbH & Co. KG")},
    {1470, _T("Tyco Electronics")},
    {1473, _T("Kawasaki Microelectronics, Inc.")},
    {1478, _T("Qualcomm, Inc")},
    {1480, _T("Foxlink/Cheng Uei Precision Industry Co., Ltd")},
    {1482, _T("Ricoh Company Ltd.")},
    {1486, _T("sci-worx GmbH")},
    {1497, _T("Axiohm Transaction Solutions")},
    {1498, _T("Microtek International Inc.")},
    {1500, _T("Lexar Media, Inc.")},
    {1504, _T("Symbol Technologies")},
    {1505, _T("Syntek Semiconductor Co., Ltd.")},
    {1507, _T("Genesys Logic, Inc.")},
    {1509, _T("Fuji Electric FA Components & Systems Co.,Ltd.")},
    {1513, _T("Kawasaki LSI")},
    {1520, _T("Canopus Co., Ltd.")},
    {1525, _T("Unixtar Technology Inc.")},
    {1535, _T("LeCroy Corporation")},
    {1539, _T("Novatek Microelectronics Corp.")},
    {1545, _T("SMK Manufacturing Inc.")},
    {1551, _T("Joinsoon Electronics Mfg. Co., Ltd.")},
    {1553, _T("Totoku Electric Co., LTD.")},
    {1555, _T("TransAct Technologies Incorporated")},
    {1556, _T("Bio-Rad Laboratories")},
    {1561, _T("Seiko Instruments Inc.")},
    {1572, _T("Avocent Corporation")},
    {1582, _T("Mainsuper Enterprises Co., Ltd.")},
    {1588, _T("Micron Technology, Inc.")},
    {1611, _T("Analog Devices, Inc. Development Tools")},
    {1612, _T("Ji-Haw Industrial Co., Ltd")},
    {1615, _T("WIBU-Systems AG")},
    {1622, _T("Glory Mark Electronic Ltd.")},
    {1623, _T("Tekcon Electronics Corp.")},
    {1631, _T("Good Way Technology Co., Ltd. & GWC technology Inc")},
    {1632, _T("TSAY-E (BVI) International Inc.")},
    {1633, _T("Hamamatsu Photonics K.K.")},
    {1642, _T("Total Technologies, Ltd.")},
    {1647, _T("SigmaTel, Inc.")},
    {1650, _T("Labtec Inc.")},
    {1656, _T("ACARD Technology Corp.")},
    {1659, _T("Prolific Technology, Inc.")},
    {1662, _T("Intermec Printer AB")},
    {16700, _T("Dell Computer Corp.")},
    {1670, _T("KONICA MINOLTA TECHNOLOGY CENTER, INC.")},
    {1680, _T("Golden Bridge Electech Inc.")},
    {1683, _T("Hagiwara Sys-Com Co., Ltd.")},
    {1689, _T("Tektronix, Inc.")},
    {1690, _T("Askey Computer Corporation")},
    {1699, _T("Saitek PLC")},
    {1709, _T("Greatland Electronics Taiwan Ltd.")},
    {1710, _T("Professional Multimedia Testing Centre")},
    {1720, _T("Pixela Corporation")},
    {1721, _T("Thomson Telecom")},
    {1722, _T("Smooth Cord & Connector Co., Ltd.")},
    {1724, _T("Oki Data Corporation")},
    {1727, _T("Leoco Corporation")},
    {1732, _T("Bizlink International Corporation")},
    {1736, _T("SIIG, Inc.")},
    {1739, _T("Synaptics Inc.")},
    {1741, _T("Keyspan")},
    {1747, _T("Mitsubishi Electric Corporation")},
    {1756, _T("Foxlink Image Technology Co., Ltd.")},
    {1758, _T("Heisei Electronics Co. Ltd.")},
    {1766, _T("Tiger Jet Network, Inc.")},
    {1778, _T("Emine Technology Company")},
    {1795, _T("Bvtech Industry Inc.")},
    {1802, _T("Oki Electric Industry Co., Ltd")},
    {1806, _T("Excel Cell Electronic Co., Ltd.")},
    {1808, _T("Connect Tech Inc.")},
    {1816, _T("Imation Corp.")},
    {1821, _T("Eicon Networks Corporation")},
    {1846, _T("Lorom Industrial Co., Ltd.")},
    {1848, _T("Mad Catz, Inc.")},
    {1862, _T("ONKYO Corporation")},
    {1892, _T("Cyber Power Systems, Inc.")},
    {1893, _T("X-Rite Incorporated")},
    {1894, _T("Jess-Link Products Co., Ltd. (JPC)")},
    {1899, _T("OMNIKEY AG")},
    {1901, _T("Denso Corporation")},
    {1911, _T("Comda Enterprise Corporation")},
    {1913, _T("Fairchild Semiconductor")},
    {1921, _T("SanDisk Corporation")},
    {1929, _T("Logitec Corporation")},
    {1936, _T("Pro-Image Manufacturing Co., Ltd")},
    {1937, _T("Copartner Wire and Cable Mfg. Corp.")},
    {1939, _T("Wha Yu Industrial Co., Ltd.")},
    {1954, _T("National Technical Systems")},
    {1955, _T("ONNTO Corp.")},
    {1963, _T("Freecom Technologies")},
    {1970, _T("Motorola BCS")},
    {1971, _T("Plustek, Inc.")},
    {1972, _T("OLYMPUS CORPORATION")},
    {1973, _T("Mega World International Ltd.")},
    {1975, _T("TIME Interconnect Ltd.")},
    {1976, _T("AboCom Systems, Inc.")},
    {1988, _T("Datafab Systems Inc.")},
    {1994, _T("AVerMedia Technologies, Inc.")},
    {1996, _T("Carry Computer Eng., Co., Ltd.")},
    {2003, _T("Cyberdata Corp.")},
    {2010, _T("Arasan Chip Systems Inc.")},
    {2038, _T("Circuit Assembly Corp")},
    {2039, _T("Century Corporation")},
    {2041, _T("Dotop Technology, Inc.")},
    {2049, _T("Mag-Tek")},
    {2058, _T("Evermuch Technology Co., Ltd.")},
    {2088, _T("Sato Corporation")},
    {2098, _T("Kouwell Electronics Corp.")},
    {2101, _T("Action Star Enterprise Co., Ltd.")},
    {2105, _T("Samsung Techwin")},
    {2112, _T("Argosy Research Inc.")},
    {2116, _T("Welland Industrial Co., Ltd.")},
    {2118, _T("NETGEAR, Inc.")},
    {2129, _T("Macronix International Co., Ltd.")},
    {2159, _T("MEC IMEX INC/HPT")},
    {2164, _T("A-Tec Subsystem, Inc.")},
    {2174, _T("Fujitsu Computer Products of America")},
    {2183, _T("Hannstar Electronics Corp.")},
    {21930, _T("OnSpec Electronic Inc.")},
    {2205, _T("Icron Technologies Corporation")},
    {2206, _T("NST Co., Ltd.")},
    {2222, _T("Macally (Mace Group, Inc.)")},
    {2235, _T("Texas Instruments Japan")},
    {2248, _T("2Wire, Inc")},
    {2250, _T("AIPTEK International Inc.")},
    {2269, _T("Billionton Systems, Inc.")},
    {2276, _T("Pioneer Corporation")},
    {2278, _T("GEMPLUS")},
    {2284, _T("M-Systems Flash Disk Pioneers")},
    {2288, _T("Corex Technologies")},
    {2297, _T("Wipro Technologies")},
    {2299, _T("Socket Communications")},
    {2303, _T("AuthenTec, Inc.")},
    {2310, _T("FARADAY Technology Corp.")},
    {2313, _T("Audio-Technica Corp.")},
    {2316, _T("Silicon Motion, Inc. - Taiwan")},
    {2319, _T("Fujitsu Devices Inc.")},
    {2321, _T("Philips Speech Processing")},
    {2334, _T("Garmin International")},
    {2338, _T("Dymo Corporation")},
    {2340, _T("Xerox Corporation")},
    {2344, _T("Oxford Semiconductor Ltd.")},
    {2346, _T("Toshiba Information & Industrial Sys. And Services")},
    {2352, _T("Toshiba Corporation")},
    {2354, _T("Crescentec Corporation")},
    {2362, _T("Pixart Imaging, Inc.")},
    {2363, _T("Plextor Corp.")},
    {2366, _T("J.S.T. Mfg. Co., Ltd.")},
    {2385, _T("Kingston Technology Company")},
    {2389, _T("NVIDIA")},
    {2391, _T("Agilent Technologies, Inc.")},
    {2397, _T("Polycom, Inc.")},
    {2419, _T("Axalto")},
    {2428, _T("Marunix Co., Ltd.")},
    {2431, _T("Barun Electronics Co. Ltd.")},
    {2436, _T("Apricorn")},
    {2468, _T("Contech Research, Inc.")},
    {2472, _T("Lin Shiung Enterprise Co., Ltd.")},
    {2478, _T("Tripp Lite")},
    {2497, _T("Arris Interactive LLC")},
    {2508, _T("Workbit Corporation")},
    {2511, _T("Electronics Testing Center, Taiwan")},
    {2513, _T("NeoMagic Inc.")},
    {2522, _T("A-FOUR TECH CO., LTD.")},
    {2525, _T("Fellowes Inc.")},
    {2533, _T("Jo-Dan International, Inc.")},
    {2536, _T("AKAI  professional M.I. Corp.")},
    {2552, _T("SoftConnex Technologies, Inc.")},
    {2554, _T("Mtek Vision")},
    {25600, _T("Springer Design, Inc.")},
    {2578, _T("Cambridge Silicon Radio Ltd.")},
    {2580, _T("Spacelabs Medical Inc.")},
    {2582, _T("Trek Technology (S) Pte Ltd")},
    {2583, _T("PENTAX Corporation")},
    {2593, _T("Medtronic Physio Control Corp.")},
    {2631, _T("Hirose Electric")},
    {2632, _T("I/O Interconnect")},
    {2636, _T("COMPUTEX Co., Ltd.")},
    {2640, _T("Mimaki Engineering Co., Ltd.")},
    {2643, _T("Portable Peripheral Co., Ltd.")},
    {2652, _T("Broadcom Corp.")},
    {2662, _T("ClearCube Technology")},
    {2664, _T("COMAIDE Corporation")},
    {2667, _T("Green House Co., Ltd.")},
    {2672, _T("International Game Technology")},
    {2685, _T("NSTL, Inc.")},
    {2689, _T("CHESEN ELECTRONICS CORP.")},
    {2690, _T("SYSCAN")},
    {2702, _T("Japan Aviation Electronics Industry Ltd. (JAE)")},
    {2704, _T("Candy Technology Co., Ltd.")},
    {2705, _T("Globlink Technology Inc.")},
    {27253, _T("Shanghai Jujo Electronics Co., Ltd.")},
    {2727, _T("Wincor Nixdorf GmbH &Co KG")},
    {2728, _T("TriGem Computer, Inc.")},
    {2755, _T("SANYO Semiconductor Company Micro")},
    {2756, _T("LECO CORPORATION")},
    {2760, _T("Vimicro Corporation")},
    {2788, _T("Taito Corporation")},
    {2796, _T("Neodio Technologies Corporation")},
    {2816, _T("INGENICO")},
    {2821, _T("ASUSTek Computer Inc.")},
    {2828, _T("Todos Data System AB")},
    {2846, _T("Electronic Warfare Assoc., Inc. (EWA)")},
    {2848, _T("TransDimension Inc.")},
    {2849, _T("Yokogawa Electric Corporation")},
    {2851, _T("Pan-Asia Electronics Co., Ltd.")},
    {2855, _T("Ritek Corporation")},
    {2871, _T("Hitachi ULSI Systems Co., Ltd.")},
    {2873, _T("Omnidirectional Control Technology Inc.")},
    {2876, _T("Olivetti Tecnost")},
    {2888, _T("TechnoTrend AG")},
    {2900, _T("Sinbon Electronics Co., Ltd.")},
    {2913, _T("NEC Viewtechnology, Ltd.")},
    {2922, _T("Maxim Integrated Products")},
    {2928, _T("PortalPlayer, Inc")},
    {2933, _T("Roland DG Corporation")},
    {2949, _T("Elkat Electronics (M) SDN. BHD.")},
    {2965, _T("ASIX Electronics Corp.")},
    {2992, _T("Concord Camera Corp.")},
    {2996, _T("High Tech Computer, Corp. (HTC)")},
    {2997, _T("Murata Manufacturing Co., Ltd.")},
    {3015, _T("X10 Wireless Technology, Inc.")},
    {3035, _T("Ericsson Mobile Platforms")},
    {3042, _T("Kanda Tsushin Kogyo Co., LTD")},
    {3044, _T("Elka International Ltd.")},
    {3054, _T("LTK Industries Ltd.")},
    {3062, _T("Addonics Technologies, Inc.")},
    {3064, _T("Fujitsu Siemens Computers")},
    {3108, _T("Taiyo Yuden")},
    {3132, _T("Radius Co., Ltd.")},
    {3140, _T("Motorola iDEN")},
    {3141, _T("Sonix Technology Co., Ltd.")},
    {3156, _T("GLORY LTD.")},
    {3157, _T("Spectrum Digital Inc.")},
    {3158, _T("Billion Bright Limited")},
    {3159, _T("Imaginative Design Operation Co. Ltd.")},
    {3161, _T("Dong Guan Shinko Wire Co., Ltd.")},
    {3170, _T("Chant Sincere Co., Ltd")},
    {3172, _T("Signality System Engineering Co., Ltd.")},
    {3173, _T("Eminence Enterprise Co., Ltd.")},
    {3194, _T("Wing-Span Enterprise Co., Ltd.")},
    {3208, _T("Kyocera Wireless Inc.")},
    {3245, _T("Motorola CGISS")},
    {3247, _T("Buslink")},
    {3255, _T("Singatron Enterprise Co. Ltd.")},
    {3259, _T("Shanghai Darong Electronics Co., Ltd.")},
    {3268, _T("emsys GmbH")},
    {3274, _T("AMPHENOL")},
    {3276, _T("DOMEX TECHNOLOGY CORPORATION")},
    {3289, _T("Hitachi Shin Din Cable Limited")},
    {32902, _T("Intel Corporation")},
    {3314, _T("ENE Technology Inc.")},
    {3315, _T("Atheros Communications, Inc.")},
    {3318, _T("Compucable Corporation")},
    {3340, _T("Astron Electronics Co., Ltd.")},
    {3343, _T("Feng Shin Cable Co. Ltd.")},
    {3350, _T("Hi-Touch Imaging Technologies Co., Ltd.")},
    {3351, _T("NALTEC, Inc.")},
    {3353, _T("Hank Connection Industrial Co., Ltd.")},
    {3381, _T("Dah Kun Co., Ltd.")},
    {3393, _T("Ta Yun Terminals Industrial Co., Ltd.")},
    {3394, _T("FULL DER CO., LTD.")},
    {3401, _T("Maxtor")},
    {3402, _T("NF Corporation")},
    {3403, _T("Grape Systems Inc.")},
    {3405, _T("Coherent Inc.")},
    {3409, _T("Volex (Asia) Pte Ltd")},
    {3413, _T("ASKA Technologies Inc.")},
    {3414, _T("AVLAB Technology, Inc.")},
    {3425, _T("MEILU ELECTRONICS (SHENZHEN) CO., LTD.")},
    {3426, _T("Darfon Electronics Corp.")},
    {3434, _T("eMegaTech International Corp.")},
    {3440, _T("Try Computer Co. LTD")},
    {3450, _T("MARX CryptoTech LP")},
    {3452, _T("Taiwan Line Tek Electronic Co., Ltd.")},
    {3453, _T("Add-On Technology Co., Ltd.")},
    {3466, _T("KING JIM CO., LTD.")},
    {3468, _T("C-MEDIA ELECTRONICS INC.")},
    {3469, _T("Promotion & Display Technology Ltd.")},
    {3470, _T("Global Sun Technology Inc.")},
    {3471, _T("Pitney Bowes")},
    {3472, _T("Sure-Fire Electrical Corporation")},
    {3484, _T("Chee Chen Hi-Technology Co., Ltd.")},
    {3489, _T("Suzhou Peter's Precise Industrial Co., Ltd.")},
    {3495, _T("IOGEAR, Inc.")},
    {3504, _T("Micro Star International")},
    {3519, _T("Jess-Link International")},
    {3520, _T("Great Notions")},
    {3524, _T("Macpower & Tytyech Technology Co., LTD.")},
    {3525, _T("SDK Co, Ltd.")},
    {3537, _T("Contek Electronics Co., Ltd.")},
    {3538, _T("Power Quotient International Co., Ltd.")},
    {3540, _T("Custom Engineering SPA")},
    {3546, _T("Integrated Circuit Solution Inc.")},
    {3549, _T("Datelink Technology Co., Ltd.")},
    {3552, _T("BD Consumer Healthcare")},
    {3562, _T("UTECH Electronic (D.G.) Co., Ltd.")},
    {3567, _T("Full Rise Electronic Co., Ltd.")},
    {3574, _T("Sitecom Europe B.V.")},
    {3575, _T("Mobile Action Technology Inc.")},
    {3577, _T("Nice Fountain Industrial Co., Ltd.")},
    {3604, _T("Hunter Engineering Co.")},
    {3607, _T("Walex Electronic Ltd.")},
    {3618, _T("Symbian Ltd.")},
    {3619, _T("Liou Yuane Enterprise Co., Ltd.")},
    {3621, _T("VinChip Systems Inc.")},
    {3636, _T("Micro Computer Control Corp.")},
    {3640, _T("Stratitec, Inc.")},
    {3641, _T("Smart Modular Technologies, Inc.")},
    {3642, _T("Neostar Technology Co., Ltd.")},
    {3650, _T("Puretek Industrial Co., Ltd.")},
    {3652, _T("Sun-Riseful Technology Co., Ltd.")},
    {3669, _T("Speed Dragon Multimedia Ltd.")},
    {3670, _T("Cenix Digicom Co., Ltd.")},
    {3674, _T("ACTIVE CO., LTD.")},
    {3675, _T("Union Power Information Industrial Co., Ltd.")},
    {3676, _T("Bitland Information Technology Co., Ltd.")},
    {3687, _T("Fossil")},
    {3690, _T("Megawin Technology Co., Ltd.")},
    {3698, _T("Hsi-Chin Electronics Co., Ltd.")},
    {3714, _T("Ching Tai Electric Wire & Cable Co., Ltd.")},
    {3723, _T("KAO SHIN PRECISION INDUSTRY CO., LTD.")},
    {3724, _T("Well Force Electronic Co., Ltd")},
    {3730, _T("C'S GLORY ENTERPRISE CO., LTD.")},
    {3736, _T("Advanced Analogic Technologies, Inc.")},
    {3739, _T("ADTEC CORPORATION")},
    {3744, _T("Ours Technology Inc.")},
    {3751, _T("MSL Enterprises Corp.")},
    {3761, _T("WIS Technologies, Inc.")},
    {3775, _T("Omega Technology of Taiwan Inc.")},
    {3778, _T("Sweetray Industrial Ltd.")},
    {3779, _T("AXELL CO., LTD.")},
    {3782, _T("InnoVISION Multimedia Limited")},
    {3802, _T("NORITAKE ITRON CORPORATION")},
    {3826, _T("I/OMAGIC CORPORATION")},
    {3827, _T("Lynn Products, Inc.")},
    {3829, _T("PointChips")},
    {3837, _T("Oasis Semiconductor")},
    {3838, _T("WEM TECHNOLOGY INC.")},
    {3846, _T("Visual Frontier Precision Corp.")},
    {3848, _T("CSL Wire & Plug (Shen Zhen) Company")},
    {38672, _T("Moschip Semiconductor Technology")},
    {3868, _T("Funai Electric Co., Ltd.")},
    {3874, _T("SENIOR INDUSTRIES, INC.")},
    {3876, _T("FLEX-P INDUSTRIES SDN.BHD.")},
    {3886, _T("Geniality Maple Technology Co., Ltd.")},
    {3890, _T("YFC-BonEagle Electric Co., Ltd.")},
    {3896, _T("Nien-Yi Industrial Corp.")},
    {3906, _T("Nital Consulting Services, Inc.")},
    {3916, _T("WORLDWIDE CABLE OPTO CORP.")},
    {3922, _T("WING KEI ELECTRICAL CO., LTD.")},
    {3923, _T("Taiyo Cable (Dongguan) Co. Ltd.")},
    {3924, _T("Kawai Musical Instruments Mfg. Co., Ltd.")},
    {3935, _T("Key Technology Corporation")},
    {3936, _T("NTK (HK) LTD.")},
    {3938, _T("Acrox Technologies Co., Ltd.")},
    {3944, _T("TEPCO UQUEST, LTD.")},
    {3945, _T("DIONEX CORPORATION")},
    {3966, _T("Fluke")},
    {3976, _T("VTech Holdings Ltd.")},
    {3979, _T("Yazaki Corporation")},
    {3981, _T("Uniwill Computer Corp.")},
    {3991, _T("CviLux Corporation")},
    {3992, _T("CYBERBANK CORP.")},
    {4005, _T("SOTEC CO., LTD.")},
    {4016, _T("Haurtian Wire & Cable Co., Ltd.")},
    {4018, _T("Conteck Co., Ltd.")},
    {4024, _T("Wistron Corporation")},
    {4026, _T("SAN SHING ELECTRONICS CO., LTD..")},
    {4033, _T("MITAC INTERNATIONAL CORP.")},
    {4038, _T("Dataplus Supplies, Inc.")},
    {4046, _T("Sony Ericsson Mobile Communications AB")},
    {4069, _T("GREENCONN (U.S.A.) INC.")},
    {4077, _T("ACCESS CO., LTD.")},
    {4087, _T("CHI SHING COMPUTER ACCESSORIES CO., LTD.")},
    {4096, _T("Speed Tech Corp.")},
    {4097, _T("Ritronics Components (S) Pte. Ltd.")},
    {4105, _T("EMUZED, INC.")},
    {4106, _T("AV Chaseway Ltd.")},
    {4112, _T("FUKUDA DENSHI CO., LTD.")},
    {4114, _T("SDKM Fibres, Wires & Cables Berhad")},
    {4130, _T("Shinko Shoji Co., Ltd.")},
    {4134, _T("Newly Corporation")},
    {4139, _T("Infotronic America, Inc.")},
    {4140, _T("Etoms Electronics Corp.")},
    {4147, _T("Nucam Corporation")},
    {4184, _T("Western Digital Technologies, Inc.")},
    {4185, _T("Giesecke & Devrient GmbH")},
    {4188, _T("Hong Ji Electric Wire & Cable (Dongguan) Co., Ltd.")},
    {4190, _T("Valence Semiconductor Design Limited")},
    {4191, _T("Chin Shong Enterprise Co., Ltd.")},
    {4206, _T("ConectL")},
    {4227, _T("CANON ELECTRONICS INC.")},
    {4228, _T("PANTECH CO., LTD.")},
    {4235, _T("Grand-tek Technology Co., Ltd.")},
    {4236, _T("Robert Bosch GmbH")},
    {4255, _T("eSOL Co., Ltd.")},
    {4267, _T("USI Co., Ltd.")},
    {4270, _T("Princeton Technology Corp.")},
    {4292, _T("Silicon Laboratories, Inc.")},
    {4293, _T("Sanei Electric Inc.")},
    {4301, _T("Kycon Inc.")},
    {4310, _T("Actions Semiconductor Co., Ltd.")},
    {4349, _T("Animation Technologies Inc.")},
    {4398, _T("Master Hill Electric Wire and Cable Co., Ltd.")},
    {4400, _T("Tenx Technology, Inc.")},
    {4412, _T("Arin Tech Co., Ltd.")},
    {4413, _T("Mapower Electronics Co. Ltd.")},
    {4415, _T("Testech, inc.")},
    {4417, _T("V ONE MULTIMEDIA PTE LTD")},
    {4423, _T("Ever Great Electric Wire and Cable Co., Ltd.")},
    {4429, _T("Alpha Imaging Technology Corp.")},
    {4450, _T("Secugen Corporation")},
    {4451, _T("DeLorme Publishing Inc.")},
    {4452, _T("YUAN High-Tech Development Co., Ltd.")},
    {4456, _T("BizConn International Corp.")},
    {4462, _T("Gigastorage Corp.")},
    {4463, _T("Silicon 10 Technology Corp.")},
    {4469, _T("Shengyih Steel Mold Co., Ltd.")},
    {4482, _T("Venture Corporation Limited")},
    {4489, _T("Trisat Industrial Co., Ltd.")},
    {4495, _T("You Yang Technology Co., Ltd.")},
    {4506, _T("ZHAN QI Technology Co., Ltd.")},
    {4522, _T("GlobalMedia Group, LLC")},
    {4528, _T("ATECH FLASH TECHNOLOGY")},
    {4571, _T("Topfield Co., Ltd.")},
    {4582, _T("K.I. Technology Co. Ltd.")},
    {4585, _T("Wincan Technology Co., Ltd.")},
    {4622, _T("HUDSON SOFT CO., LTD.")},
    {4643, _T("SKYCABLE ENTERPRISE. CO., LTD.")},
    {4649, _T("EPO Science & Technology Inc.")},
    {4655, _T("Takasic")},
    {4656, _T("Chipidea-Microelectronica, S.A.")},
    {4657, _T("CHI MEI COMMUNICATION SYSTEMS, INC.")},
    {4668, _T("K-Won C & C Co., Ltd.")},
    {4682, _T("AirVast Technology Inc.")},
    {4683, _T("NYKO Technologies, Inc.")},
    {4706, _T("MICRO VISION CO., LTD.")},
    {4717, _T("Bel Stewart")},
    {4719, _T("TwinMOS Technologies Inc.")},
    {4742, _T("MARVELL SEMICONDUCTOR, INC.")},
    {4763, _T("CyberTAN Technology Inc.")},
    {4764, _T("Min Aik Technology Co., Ltd.")},
    {4772, _T("Guangdong Matsunichi Communications Technology Co., Ltd")},
    {4779, _T("Honey Bee Electronic International Ltd.")},
    {4781, _T("Asahi Seiko Co., Ltd.")},
    {4787, _T("Megaforce Company Ltd.")},
    {4792, _T("Zhejiang Xinya Electronic Technology Co., Ltd.")},
    {4794, _T("Sony Computer Entertainment America")},
    {4855, _T("Memorex Products, Inc.")},
    {4871, _T("USBest Technology Inc.")},
    {4907, _T("Konica Minolta Holdings, Inc.")},
    {4908, _T("Le Prestique International (H.K.) Ltd.")},
    {4930, _T("Sutter Instrument Company")},
    {4933, _T("Sino Lite Technology Corp.")},
    {4936, _T("Katsuragawa Electric Co., Ltd.")},
    {4972, _T("Datastor Technology Co., Ltd.")},
    {4976, _T("Swissbit AG")},
    {4982, _T("Vimtron Electronics Co., Ltd.")},
    {4988, _T("Yaskawa Electric Corporation")},
    {5014, _T("Silicon Storage Technology, Inc.")},
    {5032, _T("Grandtec Electronic Corp")},
    {5040, _T("PerkinElmer Optoelectronics")},
    {5041, _T("Cisco-Linksys, LLC")},
    {5042, _T("ALESIS")},
    {5043, _T("Nippon Dics Co., Ltd.")},
    {5048, _T("PDM Electronic Co., Ltd.")},
    {5054, _T("Ricoh Printing Systems, Ltd.")},
    {5055, _T("Accusys, Inc.")},
    {5056, _T("Stream Labs")},
    {5057, _T("Vivitar Corporation")},
    {5065, _T("LinearX Systems Inc.")},
    {5066, _T("Suzhou Jye Tai Precision Industrial Co., Ltd.")},
    {5067, _T("JTEK Technology Corporation")},
    {5068, _T("Cellvic Corporation")},
    {5071, _T("Wisair Ltd.")},
    {5073, _T("A-MAX Technology Co., Ltd.")},
    {5074, _T("Intelligraphics, Inc.")},
    {5075, _T("TwinHan Technology Co., Ltd.")},
    {5084, _T("ALEREON, INC.")},
    {5085, _T("i.Tech Dynamic Limited")},
    {5086, _T("LANKOM ELECTRONICS CO., LTD.")},
    {5087, _T("Good Fancy Enterprise Co., Ltd.")},
    {5088, _T("Taiwan Silicon Electronics Corp.")},
    {5089, _T("Kaibo Wire & Cable (Shenzhen) Co., Ltd.")},
    {5094, _T("TechnoScope Co., Ltd.")},
    {5098, _T("I/F - COM A/S")},
    {5108, _T("Verisity Design Inc.")},
    {5110, _T("Aspen Touch Solutions, Inc.")},
    {5111, _T("Corevalley Co., Ltd.")},
    {5112, _T("EZPnP Technologies Corp.")},
    {5118, _T("Phison Electronics Corp.")},
    {5119, _T("VIEWCON ELECTRONIC LTD.")},
    {5120, _T("Axxion Group Corp.")},
    {5121, _T("Fulhua Microelectronics Corp.")},
    {5122, _T("Bowe Bell & Howell")},
    {5123, _T("Sitronix Technology Corp.")},
    {5134, _T("Telechips, Inc.")},
    {5141, _T("Sony Computer Entertainment Europe")},
    {5145, _T("ABILITY ENTERPRISE CO., LTD.")},
    {5146, _T("Realm Systems Inc.")},
    {5147, _T("METRAWARE")},
    {5148, _T("Leviton Manufacturing")},
    {5153, _T("Sensor Technologies America, Inc.")},
    {5161, _T("Vega Technologies Industrial (Austria) Co.")},
    {5168, _T("RedOctane")},
    {5172, _T("Comart System Co., Ltd.")},
    {5173, _T("Wistron NeWeb Corp.")},
    {5174, _T("Denali Software, Inc.")},
    {5176, _T("My3ia (Beijing) Technology Ltd.")},
    {5177, _T("Wind River Systems Inc.")},
    {5178, _T("CP Technologies")},
    {5186, _T("Canadian Bank Note Company, Limited")},
    {5189, _T("JUSTER CO., LTD.")},
    {5205, _T("Georgia Technology Corp.")},
    {5206, _T("Extending Wire & Cable Co., Ltd.")},
    {5209, _T("Shanghai Simax Micro-electronics Co., Ltd.")},
    {5211, _T("Lead-Type Precision Electronics Co., Ltd.")},
    {5214, _T("Forschungszentrum Karlsruhe GmbH")},
    {5216, _T("TATUNG Company")},
    {5217, _T("Staccato Communications")},
    {5218, _T("Bright Computech Co., Ltd.")},
    {5219, _T("BBWM Corp.")},
    {5220, _T("Asiamajor Inc.")},
    {5229, _T("Progeny Inc.")},
    {5230, _T("ClearOne Communications")},
    {5231, _T("Unity Electrical Ind. Ltd.")},
    {5232, _T("STARRIVER TECHNOLOGY CO., LTD.")},
    {5234, _T("Hangzhou Huawei-3Com Tech. Co., Ltd.")},
    {5235, _T("Dingo Incorporated")},
    {5247, _T("Hama GmbH & Co., KG")},
    {5252, _T("Triad Semiconductor, Inc.")},
    {5253, _T("OrangeWare Corp.")},
    {5255, _T("DSP Group, Ltd.")},
    {5256, _T("Orion Technology Corp.")},
    {5261, _T("DESMA Co., Ltd.")},
    {5262, _T("EVATRONIX SA")},
    {5263, _T("Ralink Technology, Corp.")},
    {5271, _T("Panstrong Company Ltd.")},
    {5272, _T("ULi Electronics Inc.")},
    {5273, _T("G-STAR Communications, Ltd.")},
    {5274, _T("Imagination Technologies")},
    {5278, _T("Amkor Technology")},
    {5279, _T("Wits Technologies Pte. Ltd.")},
    {5285, _T("I-ROCKS TECHNOLOGY CO., LTD.")},
    {5293, _T("CTK Corporation")},
    {5294, _T("Printronix Inc.")},
    {5295, _T("ATP Electronics Inc.")},
    {5296, _T("Startech.com Ltd.")},
    {5300, _T("Inventec Appliances Corp.")},
    {5305, _T("BP Microsystems")},
    {5306, _T("FLOVEL CO., LTD.")},
    {5307, _T("Assembly Tech. Co., Ltd.")},
    {5312, _T("Rockwell Automation, Inc.")},
    {5313, _T("SOHYA TECHNOLOGY CO., LTD.")},
    {5314, _T("Gemlight Computer Ltd.")},
    {5315, _T("Smart Link Ltd.")},
    {5324, _T("WIN TONG ELECTRONICS CO., LTD.")},
    {5325, _T("MOAI ELECTRONICS CORPORATION")},
    {5336, _T("Jamer Enterprises Company Limited")},
    {5337, _T("Advanced Flash Memory Card Technology Ltd.")},
    {5338, _T("Horng Technical Enterprise Co., Ltd.")},
    {5341, _T("Raritan Computer, Inc.")},
    {5342, _T("Jetway Information Co., Ltd.")},
    {5349, _T("SAIN Information & Communications Co., Ltd.")},
    {5357, _T("Shure Inc.")},
    {5358, _T("INFORAD Ltd.")},
    {5359, _T("AVICLink Corporation")},
    {5365, _T("SourceQuest, Inc.")},
    {5366, _T("Symbium Corporation")},
    {5368, _T("Chenrol Electric Wire & Cable Co., Ltd.")},
    {5369, _T("Full Conductor Electric Appliance Manufacturer")},
    {5376, _T("Ellisys")},
    {5377, _T("Pine-Tum Enterprise Co., Ltd.")},
    {5379, _T("Stretch Inc.")},
    {5393, _T("BridgeCo, AG")},
    {5394, _T("Software Technologies Group, Inc.")},
    {5395, _T("Hypercom")},
    {5396, _T("ACTEL CORPORATION")},
    {5397, _T("Hexon Media Pte Ltd")},
    {5398, _T("Skymedi Corporation")},
    {5401, _T("Comneon GmbH Co., Ohg.")},
    {5403, _T("HOSTNET CO.")},
    {5404, _T("VeriSilicon, Inc.")},
    {5408, _T("Bitwire Corp.")},
    {5421, _T("JMicron Technology Corp.")},
    {5422, _T("HLDS (Hitachi-LG Data Storage, Inc.)")},
    {5429, _T("Practical Engineering Incorporated")},
    {5430, _T("NEONODE AB")},
    {5437, _T("Adam-Technologies")},
    {5438, _T("abKey ptd ltd.")},
    {5439, _T("UNIBRAIN S.A.")},
    {5440, _T("Phihong Technology Co., Ltd.")},
    {5442, _T("Gemini Industries, Inc.")},
    {5443, _T("Buxco Research Systems")},
    {5451, _T("PNY Technologies Inc.")},
    {5453, _T("CONNECTCOUNTY SDN BHD")},
    {5454, _T("D & M Holdings, Inc.")},
    {5460, _T("Prolink Microsystems Corporation")},
    {5463, _T("OQO")},
    {5476, _T("Gizmondo Europe Ltd.")},
    {5477, _T("Advance Modules")},
    {5478, _T("WIN ACCORD LTD.")},
    {5479, _T("MUTOH Industries Ltd.")},
    {5486, _T("MVox Electronics")},
    {5487, _T("Certance L.L.C.")},
    {5488, _T("ALLTOP TECHNOLOGY CO., LTD.")},
    {5495, _T("MIYUKI ELEX CO., LTD.")},
    {5496, _T("Beijing Huaqi Information Digital Technology Co., Ltd.")},
    {5497, _T("Reputed Industrial Company Limited")},
    {5498, _T("Lowrance Electronics, Inc.")},
    {5499, _T("Ketron SRL")},
    {5501, _T("Tokyo Sokuteikizai Co., Ltd.")},
    {5502, _T("U-MEDIA Communications, Inc.")},
    {5509, _T("IKeyInfinity Inc.")},
    {5510, _T("Shenzhen Shi Viton Technology City Co., Ltd.")},
    {5511, _T("SMA Regelsysteme GmbH")},
    {5512, _T("Fine Instruments Corporation")},
    {5517, _T("Oakley Inc.")},
    {5519, _T("Tai Yip Electrical Co., Ltd.")},
    {5520, _T("Onsu Data Telecommunication Technology (Shenzhen) Fty.")},
    {5544, _T("Teams Power Limited")},
    {5545, _T("Gemtek Technology Co.,Ltd.")},
    {5546, _T("Gearway Electronics (Dong Guan) Co., Ltd.")},
    {5547, _T("Virgin Electronics, LLC")},
    {5556, _T("Orient Power Multimedia Ltd.")},
    {5557, _T("ANUBIS ELECTRONIC GmbH")},
    {5575, _T("IRI-Ubiteq, Inc.")},
    {5576, _T("KTF Technologies")},
    {5577, _T("D-Box Technologies")},
    {5578, _T("TEXTECH INTERNATIONAL LTD.")},
    {5589, _T("Coulomb Electronics Ltd.")},
    {5590, _T("Fitness Expert")},
    {5595, _T("Philip Harris Education")},
    {5596, _T("Hynix Semiconductor Inc.")},
    {5600, _T("Seong Ji Industrial Co., Ltd.")},
    {5601, _T("RSA Security Inc.")},
    {5602, _T("Bionopoly LLC")},
    {5609, _T("Pacific Digital Corp.")},
    {5610, _T("C-guys Inc.")},
    {5611, _T("VIA Telecom")},
    {5612, _T("Belcarra Technologies Corp.")},
    {5613, _T("UCA Technology Inc.")},
    {5622, _T("ASICS World Services Ltd.")},
    {5623, _T("HANTEL CO., LTD.")},
    {5624, _T("Vianet, Inc.")},
    {5628, _T("Humen Xintai Electrical Wires Factory")},
    {5633, _T("Avenues in Leather")},
    {5635, _T("ERGODEX Corp.")},
    {5640, _T("Inside Out Networks")},
    {5641, _T("K-byte (ACI Group)")},
    {5645, _T("Samtec")},
    {5650, _T("Soft DB Inc.")},
    {5651, _T("Airconnect Solutions (Asia) Ltd.")},
    {5655, _T("Navman")},
    {5656, _T("Redpine Signals, Inc.")},
    {5657, _T("L & K Precision Technology Co., Ltd.")},
    {5658, _T("Celeraise Investments Ltd.")},
    {5665, _T("Orion Microelectronics Corp.")},
    {5670, _T("Advance Data Technology Corporation")},
    {5671, _T("IPextreme, Inc.")},
    {5672, _T("Stonestreet One, Inc.")},
    {5673, _T("Erae Electronics")},
    {5674, _T("Airgo Networks Inc.")},
    {5679, _T("WiQuest Communications, Inc.")},
    {5680, _T("QformX")},
    {5681, _T("Focus Enhancements")},
    {5782, _T("Hitachi Advanced Digital, Inc.")},
    {5783, _T("VTEC TEST, INC.")},
    {60186, _T("Empia Technology , Inc.")},
    {6568, _T("Biforst Technology Inc.")},
    {7867, _T("NuCORE Technology, Inc.")},
    {8256, _T("Hauppauge Computer Works, Inc.")},
    {8888, _T("Motorola PCS")},
    {8964, _T("Pinnacle Systems, Inc.")},
    {9224, _T("Catalyst Enterprises, Inc.")},
    {9797, _T("Lead Data Inc.")},
    {9808, _T("Electronics For Imaging, Inc.")}
};
#define nVendorIdTable (sizeof VendorIdTable / sizeof VendorIdTable[0])
