/* 
* Copyright (c) Microsoft Corporation All rights reserved
*/
#ifndef _UTILITY_H_
#define _UTILITY_H_
 
//#include <tchar.h>

#define NAME_SPACE_BOGUS_FLAG  (~(NAME_SPACE_READ | NAME_SPACE_WRITE | NAME_SPACE_SHARE_READ | NAME_SPACE_SHARE_WRITE | NAME_SPACE_CREATE | NAME_SPACE_FAILIFEXIST | NAME_SPACE_EXTENSION | NAME_SPACE_NOFOLLOW | NAME_SPACE_PREFIX | NAME_SPACE_APPEND ))


//defines for ops table. See utility.c also. 
//Add new values to the end, e.g. #define MY_NEW_OP 12
#define BIND        0 
#define READ        1 
#define WRITE       2 
#define GETSIZE     3
#define SETSIZE     4
#define UNREGISTER  5
#define LOADIMAGE   6
#define CREATETHREAD    7
#define SETEXITCODE     8
#define REGISTER        9
#define QUERYINTERFACE  10
#define VALIDATE        11
#define STATUS          12
#define FINDNEXT        13
#define GETFUNCTIONADDRESS  14
#define EXTRACT         15
#define ALLOCATE        16

#define min(a, b)((a < b) ? a : b)
#define XOR(a, b)((a)?(!b):(b))
typedef struct 
{
    UINT flag; 
    _TCHAR * sDesc; 
}flags_desc_map;

UINT FetchFlagsFromCommandLine(UINT argc, _TCHAR ** argv, UINT64 *pSize);
void Outcome(BYTE op, SCODE sc, const _TCHAR * sFile, UINT flags, UINT64 nBytes);
const _TCHAR * ErrorDescription(SCODE sc);
void GetFlagsDescription(_TCHAR * sFlags, UINT nLen, UINT flags, BYTE op);
const _TCHAR * GetArgFromCommandLine(UINT argc, _TCHAR ** argv, const _TCHAR *);
const flags_desc_map * GetDescMap(BYTE op);
void CreateThreadOutcome(BYTE op, SCODE sc, THREAD_FUNCTION pStart, IThread * pThread, const _TCHAR * sArgs, ADDR_SIZE stacksize);
void SetExitCodeOutcome(BYTE op, SCODE sc);
const _TCHAR * ProcessorKind(UINT32 nProc);
const _TCHAR * ProcessorFlavor(UINT32 nFlavor);
void OptionalBreak(int argc, _TCHAR ** argv);
void TellAboutOptionalBreak();
void NSOutcome(BYTE op, SCODE sc, const _TCHAR * sPref, const _TCHAR * sPrev, const _TCHAR * sOutput, UINT nBuflen, UINT nStrLenOut);
void GFAOutcome(BYTE op, SCODE sc, const _TCHAR * sFuncName, INT nOrdinal, ADDRESS addr);
int SetAndReturn(int nRet);
#endif
