/* Copyright (c) Microsoft Corporation. All rights reserved. */
//////////////////////////////////////////////////////////////////////////////
//
//  File:       debugsyn.h
//  Module:     debugsyn.dll
//  Author:     Galen Hunt
//
//  Debugging Synthesis - Symbol debugging creation library.
//

#pragma once
#ifndef _DEBUGSYN_H_
#define _DEBUGSYN_H_

#ifndef _DEBUGSYN_
#pragma comment(lib, "debugsyn")
#endif

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

///////////////////////////////////////// Symbolic Debug Information Creation.
//
enum {
    DEBUG_SYN_HEADERSIZE    = 512,
};

typedef VOID * PDEBUGSYN;

PDEBUGSYN WINAPI DebugSynCreate();

PDEBUGSYN WINAPI DebugSynCreatePseudoFile(PCHAR pszBinPath,
                                          PVOID pvBase);

BOOL WINAPI DebugSynAddSymbol(PDEBUGSYN pSynth,
                              PVOID pvSymbol,
                              PCSTR pszSymbol);

BOOL WINAPI DebugSynAddSource(PDEBUGSYN pSynth,
                              PVOID pvSource,
                              DWORD cbSource,
                              PCSTR pszFile,
                              DWORD nLine);

BOOL WINAPI DebugSynAddOpcode(PDEBUGSYN pSynth,
                              PVOID pvCode,
                              DWORD cbCode);

BOOL WINAPI DebugSynWriteToFile(PDEBUGSYN pSynth,
                                HANDLE hFile,
                                WORD Machine,
                                WORD Characteristics,
                                DWORD TimeDateStamp,
                                DWORD CheckSum,
                                DWORD ImageBase,
                                DWORD SizeOfImage,
                                DWORD SectionAlignment,
                                PIMAGE_SECTION_HEADER pSections,
                                DWORD nSections);

DWORD WINAPI DebugSynAppendToFile(PDEBUGSYN pBinary,
                                     HANDLE hFile,
                                     DWORD ImageBase,
                                     PIMAGE_SECTION_HEADER pSections,
                                     DWORD nSections,
                                     PIMAGE_DEBUG_DIRECTORY pDir);

BOOL WINAPI DebugSynFlushPseudoFile(PDEBUGSYN pSynth);

BOOL WINAPI DebugSynClose(PDEBUGSYN pSynth);

DWORD WINAPI DebugSynNotifyFlush(VOID);
VOID WINAPI DebugSynNotifyLoad(PBYTE pbData, PCSTR pszDllPath);
VOID WINAPI DebugSynNotifyUnload(PBYTE pbData);

//
//////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
}
#endif // __cplusplus
#endif // _DEBUGSYN_H_
//
////////////////////////////////////////////////////////////////  End of File.
