/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * Definitions for Secure Extension images (for eMIPS).
 */

#include <stdio.h>
#include <stdlib.h>
typedef signed __int32 INT32;
typedef signed __int16 INT16;
typedef signed __int8  INT8;
typedef unsigned __int32 UINT32;
typedef unsigned __int16 UINT16;
typedef unsigned __int8  UINT8;
typedef int BOOL;
#define FALSE 0
#define TRUE 1

/* This runs on a PC so */
#ifndef BYTE_ORDER
#define LITTLE_ENDIAN 04030201
#define BIG_ENDIAN 01020304
#define BYTE_ORDER LITTLE_ENDIAN
#endif

/* Types that are defined in the ELF specification */
typedef UINT32 Elf32_Addr, Elf32_Off, Elf32_Word;
typedef INT32 Elf32_Sword;
typedef UINT16 Elf32_Half;

typedef char *NAME;

/* Definitions for our security header
 */
typedef struct _SE_HEADER {
    UINT32 SwImageOffset;
    UINT32 SwImageSize;
    UINT32 SwProperties; /* nothing yet */
    UINT32 HwImageOffset;
    UINT32 HwImageSize;
    UINT32 HwProperties;
#define SE_HW_PRIVILEGED        0x00000001
#define SE_HW_PERIPHERAL        0x00000002
#define SE_HW_PRIORITY_MASK     0x0000000c
#define SE_HW_PRIORITY_1        0x00000004
#define SE_HW_PRIORITY_2        0x00000008
#define SE_HW_HIGH_PRIORITY     0x0000000c
    UINT32 DigestOffset;
    UINT32 DigestSize;
    UINT32 DigestProperties; /* nothing yet */
    UINT32 MySize;
    UINT32 MagicNumber;
#define SE_MAGIC_BE  0x53453031  /* "SE01" */
#define SE_MAGIC_LE  0x31304553
} SE_HEADER, *PSE_HEADER;

#define SECTION_ROUNDUP 32

