/* Copyright (c) Microsoft Corporation. All rights reserved. */
/*
 * for Win32
 */
#include <stdio.h>

typedef FILE * FILE_HANDLE;
#define INVALID_FILE_HANDLE ((FILE*)NULL)

FILE_HANDLE _Open( CTSTR FileName, UINT Mode)
{
    FILE *f;

    if (Mode != 1)
        return INVALID_FILE_HANDLE;
    f = fopen(FileName,"rb");
    return f;
}

INT _Close( FILE_HANDLE File)
{
    return fclose(File);
}

INT _Read( FILE_HANDLE File, BYTE *Buffer, UINT nBytes)
{
    size_t n;
    n = fread(Buffer,1,nBytes,File);
    return (INT)n;
}

UINT _Seek( FILE_HANDLE File, UINT Position)
{
    return (UINT)fseek(File,Position,SEEK_SET);
}

INT _Stat( FILE_HANDLE File)
{
    long curpos = ftell(File);
    INT size;

    fseek(File,0,SEEK_END);
    size = ftell(File);
    fseek(File,curpos,SEEK_SET);
    return size;
}
