/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* The RTL descriptor remember the function's name and its ordinal.
 * In case we later want to compact the string table, we also note
 * the function's symbol name (if not referenced it stays -1).
 */
typedef struct _RTL_ENTRY {
    char *RtlName;
    int Ordinal;
    char *RefAsSymbol;
} RTL_ENTRY, *PRTL_ENTRY;

/* Qsort wants arrays, not lists. So here it goes with its length
 */
typedef struct _RTL {
    char *DllName;
    char *Uuid;
    PRTL_ENTRY pEntries;
    unsigned int nEntries;
    int Index; /* used by linker */
    int Referenced;
} RTL, *PRTL;

/* Constructor */
extern PRTL ParseDllDeffile(char *Filename);

/* Destructor */
extern void DestroyRtl(PRTL pRtl);

/* for qsort()ing */
extern int CompareRtlByName(const void *node1, const void *node2);
extern int CompareRtlByOrdinal(const void *node1, const void *node2);
extern int CompareRtlByRef(const void *node1, const void *node2);

/* Searching */
extern PRTL_ENTRY IsaRtl( PRTL pRtl, char *Name);

/* utils & debug */
extern void PrintEntries( char *msg, PRTL_ENTRY pEntries, int NumEntries);
extern void quit(int status,char *Format, ...);

