/* Copyright (c) Microsoft Corporation. All rights reserved. */
/* This program takes the filenames on the command line and prints out the
 * short 8.3 version of it.
 */
#include <windows.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
    int i;
    WIN32_FIND_DATA FindFileData;
    HANDLE hFind;

    for (i = 1; i < argc; i++) {
        hFind = FindFirstFile(argv[i], &FindFileData);

        if (hFind == INVALID_HANDLE_VALUE) {
            printf ("shortnam: %s not found err=%d\n",
                    argv[i], GetLastError());
            exit(1);
        } else {
            char *pSeparator = strrchr(argv[i],'\\');

            if (pSeparator == NULL)
                pSeparator = strrchr(argv[i],'/');

            if (pSeparator) {
                pSeparator[1] = 0;
                printf("%s",argv[i]);
            }

            if (FindFileData.cAlternateFileName[0] != '\0')
                printf ("%s ", FindFileData.cAlternateFileName);
            else
                printf ("%s ", FindFileData.cFileName);
            FindClose(hFind);
        }

    }
    exit(0);
}
